#ifndef _UTS_CORE__CORE_H
#define _UTS_CORE__CORE_H

#include <cvidef.h>
#include "systems\\common\\include\\plugindef.h"
#include "systems\\common\\include\\systemdef.h"



void closeUserSystem(void);
int  openUserSystem(char *syspath, char *sysname);

int  openPlugList4System(char *sysname);
void closePlugList4System(void);
int  insertModuleList2Bar(int pnl, int pbar, int plugMenuItem, 
 void CVICALLBACK ModuleFunction ( int menuBarHandle,
         int menuItemID, void *callbackData, int panelHandle ));

int   connect2System(void);
int   disconnectSystem(void);
char *core_getSysDescr(void);

systemManager *systemCore(void);
pluginManager *moduleCore(void);

int  deselectPlugin(void);
int  selectPlugin(/*char *path*/int index);

int   core_getPlugNum(void);
char *core_getPlugName(int n);
char *core_getPlugPath(int n);
char *core_getPlugFileName(int n);
char *core_getPlugDescr(int n);

typedef struct sIntList {
	int data;
	struct sIntList *next;
} IntList;
typedef struct {
	int number;
	IntList *list;
} IntListAndLength;


char *core_getModuleName(char *moduleDescr);
int   core_getPluginNum4Module(char *moduleName);
char *core_getPluginPath4Module(int num, char *moduleName);
char *core_getPluginDescr4Module(int num, char *moduleName);
IntListAndLength core_getPluginList4Module(char *moduleName);
void freeIntList(IntList *list);


char *pluginCurrentPath(void);
char *pluginCurrentDescr(void); // !!! tmp

void * core_getSysTContext(char *moduleDescr);
int fillTContext(TCONTEXT *tc, tCbfPtr f, char *currentModule_Descr, void *te01);

void core_fillLocalTFUseFlags(void);
void core_updateLocalTFUseFlags(int n, int use[256]);
int  core_isUseTF(int fnum);

#pragma pack(1)
typedef struct {
   int port;
   int use;
 } COREINISETHW;
 
 typedef struct {
   char sign[15+1];
   int  loop;
   int  breakOnError;
   int  launchAll;
   COREINISETHW te01;
   COREINISETHW keithley;
   COREINISETHW burn;
   int  crc;
 } COREINISET;
#pragma pack()

void coreReadIni(COREINISET *set);
void coreWriteIni(COREINISET *set);

#endif
