#ifndef _TE01API_
#define _TE01API_
#include <windows.h>
//       EEPROM 
#define EEPROM_CRC_S   1
#define EEPROM_CRC_I   2
#define EEPROM_CRC_F   4
//   
#define CMD_ERROR            0x0001
#define RAM_ERROR            0x0002
#define UMODULE_ERROR        0x0004
#define IMODULE_ERROR        0x0008
#define AMODULE_ERROR        0x0010
#define AMODULE_CHANGED      0x2000
#define IMODULE_OVERLOAD     0x4000
#define MMODULE_RESET        0x8000
//   
//   
#define FORCE_UPDATE_RAM      0x0400
#define FORCE_UPDATE_FDAC     0x0800
#define FORCE_UPDATE_SDAC     0x1000
#define FORCE_UPDATE_UMODULE  0x2000
#define FORCE_UPDATE_IMODULE  0x4000
#define FORCE_UPDATE_AMODULE  0x8000
//    
// ram     
#define RAM_START             0x000000l
#define RAM_END                   0x007FFFl
#define RAM_SIZE              0x008000l
// eeprom     
#define EEPROM_D_START        0x100000l
#define EEPROM_D_END          0x11FBFFl
#define EEPROM_D_SIZE         0x01FC00l
// eeprom   
#define EEPROM_C_START        0x11FC00l
#define EEPROM_C_END          0x11FFFFl
#define EEPROM_C_SIZE         0x000400l
// eeprom  
#define EEPROM_M_START        0x200000l
#define EEPROM_M_END          0x200037l
#define EEPROM_M_SIZE         0x000040l
// eeprom 
#define EEPROM_U_START        0x300000l
#define EEPROM_U_END          0x300037l
#define EEPROM_U_SIZE         0x000040l
// eeprom 
#define EEPROM_I_START        0x400000l
#define EEPROM_I_END          0x400037l
#define EEPROM_I_SIZE         0x000040l
// eeprom  
#define EEPROM_A_START        0x500000l
#define EEPROM_A_END          0x5000FFl
#define EEPROM_A_SIZE         0x000100l
//  (  )
#define REGISTERS_START       0x600000l
#define REGISTERS_END         0x5000FFl
#define REGISTERS_SIZE        0x000100l
//
#define UADC_DATA_CORRECTION  1
#define IADC_DATA_CORRECTION  2
#define SDAC_DATA_CORRECTION  4
#define FDAC_DATA_CORRECTION  8
//
#define FORMAT_CODE           0
#define FORMAT_VALUE          1


//     OBJECTS
#define NOBJECTS 9
//   
//    = ADC_FILTER_CONST/uadc_filter
//    = ADC_FILTER_CONST/iadc_filter
#define ADC_FILTER_CONST (2457600.0/128.0)
//->
#if 1
//->
#ifdef DLL_FLAG
#ifdef __cplusplus
#define TE01CALL(type) type __declspec(dllexport) __stdcall
#define TE01DECL(type) type __declspec(dllexport)
#else
#define TE01CALL(type) type __export __stdcall
#define TE01DECL(type) type __export
#endif
//
#else
#ifdef __cplusplus
#define TE01CALL(type) extern "C" type __declspec(dllimport) __stdcall
#define TE01DECL(type) extern "C" type __declspec(dllimport)
#else
#define TE01CALL(type) extern type __import __stdcall
#define TE01DECL(type) extern type __import
#endif
#endif
//->
#else
//->
#define TE01CALL(type) type __stdcall
#define TE01DECL(type) extern type
////
#endif
//**** 
#pragma pack(1)                    //
typedef struct{                    //
        //****  .
        //****  :        .
        BYTE   Port;               //  COM    RS232  RS485
        HANDLE Handle;             //    
        DWORD  ReqTotal;           //      
        DWORD  ReqBad;             //       
        //                         //
    DWORD  ReqBadU;                //
    DWORD  ReqBadI;                //
    DWORD  ReqBadE;                //
        //****   //
        //****  :      
        //**** TE01SetConfig()      .
    WORD   state;                  //  
        //**** RAM                 //
        WORD   ram_size;           //02//*<15..0>   
        WORD   ram_step;           //04//*<14..0>    
        BYTE   ram_freq;           //06//*<2..0>     (0..4)
                                   //  0 -  20 
                                   //  1 -   2 
                                   //  2 - 200 
                                   //  3 -  20 
                                   //  4 -   2 
        //**** F DAC               //
        BYTE   fdac_range;         //07//*<3..0>    
                                   //  0 - +/- 10000 
                                   //  1 - +/-  5000 
                                   //  2 - +/-  2000 
                                   //  3 - +/-  1000 
                                   //  4 - +/-   500 
                                   //  5 - +/-   250 
                                   //  6 - +/-   200 
                                   //  7 - +/-   100 
                                   //  8 -                 0 
        BYTE   fdac_filter;        //08//*<1..0>     
                                   //  0 -   
                                   //  1 -   20 
                                   //  2 -    5 
                                   //  3 -  400  
        WORD   fdac_min;           //09//*<15..0>   
        WORD   fdac_max;           //11//*<15..0>   
        //**** S DAC               //
        BYTE   sdac_range;         //13//*<1..0>    
                                   //  0 - +/- 10000 
                                   //  1 - +/-  4096 
                                   //  2 - +/-   250 
                                   //  3 -             0 
        WORD   sdac_value;         //14//*<13..0>    
        //**** U ADC               //
        BYTE   uadc_range;         //16//*<2..0>   
                                   // 0 - +/- 12200.00  (12200.00  ) 
                                   // 1 - +/-  6100.00  ( 6100.00  ) 
                                   // 2 - +/-   250.00  (  625.00  ) 
                                   // 3 - +/-    62.50  (  156.25  ) 
                                   // 4 - +/-    15.6250(   39.0625) 
        WORD   uadc_filter;        //17//*<11..0>      [19..4000]
        BYTE   uadc_switch;        //19//*<3..0>    
                                   //  0 -  +U & -U   -01 (1:1)
                                   //  1 -  +U & -U   -01 (1:10)
                                   //  2 -   
                                   //  3 -  +Us  
                                   //  4 -  -Us  
                                   //  5 -  I- ( 392 Ohm)
                                   //  6 -  I- (   2 Ohm)
                                   //  7 -  I- (49.8 Ohm)
                                   //  8 -  I- (   0 Ohm)
                                   //  9 -  
                                   // 10 -       ( 1..5)
                                   // 11 -   ( 1)
                                   // 12 -  (BUF=0)
                                   // 13 -  (BUF=1)
        //**** I ADC               //
        BYTE   iadc_range;         //20//*<2..0>  / 
                                   //  0 - +/- 0.312 mA
                                   //  1 - +/- 0.625 mA
                                   //  2 - +/- 1.25  mA
                                   //  3 - +/- 2.5   mA
                                   //  4 - +/- 5     mA
                                   //  5 - +/- 10    mA
                                   //  6 - +/- 20    mA
                                   //  7 - +/- 500   mA
        WORD   iadc_filter;        //21//*<11..0>      [19..4000]
        BYTE   iadc_switch;        //23//*<1..0>    
                                   //  0 -   
                                   //  1 -  
                                   //  2 -  I+ & I-   -01
                                   //  3 -   
        //****   
        BYTE   mid;                        //24//  (RO)
        BYTE   bid;                        //25//  (RO)
        //****       //
        BYTE   aregs[15];                  //  (RW)
        //****     //
        DWORD  ucounter;                   //
        DWORD  uvalue;                     //
        DWORD  icounter;                   //
        DWORD  ivalue;                     //
        //****   
        WORD   cflags;                     //
        //****    //
        //                                 //
        double Kd;                         // .   
        double Ku[5];                      //  .  ,  
        double Bu[5];                      // .    ,  
        //                                 //
        double Ki[8];                      //  .  ,  
        double Bi[8];                      // .    ,  
        //                                 //
        double Ks1[4];                     //  .   U+  ,  
        double Bs1[4];                     // .     U+  ,  
        //                                 //
        double Ks2[4];                     //  .   U-  ,  
        double Bs2[4];                     // .     U-  ,  
        //                                 //
        double Kf1[9];                     //  .     ,  
        double Bf1[9];                     // .       ,  
        //                                 //
        double Kf2[9];                     //  .       ,  
        double Bf2[9];                     // .         ,  
        //****  EEPROM 
        //****  :       
        //**** TE01WriteEnableEEPROM()  TE01WriteEEPROM()   
        //****  .          //
        struct {                           //
                //***  .   //
                BYTE  sn[6];               //   
                BYTE  name[10];            //  
                BYTE  revision;            //    
                BYTE  cpu_type[10];        //   CPU/DSP
                DWORD qfrequency;          //     
                BYTE  crc_0;               //  
                BYTE  free[95];            // 
                BYTE  crc_f;               //  
        } mmodule_eeprom;                  //
        //                                 //
        struct {                           //
                BYTE  sn[6];               //   
                BYTE  name[10];            //  
                BYTE  revision;            //    
                BYTE  cpu_type[10];        //   CPU/DSP
                DWORD qfrequency;          //     
                BYTE  crc_0;               //  
                double uref;               //     ()
                BYTE  crc_1;               //
                BYTE  free[86];            //
                BYTE  crc_f;               //  
        } umodule_eeprom;                  //
        //                                 //
        struct {                           //
                BYTE  sn[6];               //   
                BYTE  name[10];            //  
                BYTE  revision;            //    
                BYTE  cpu_type[10];        //   CPU/DSP
                DWORD qfrequency;          //     
                BYTE  crc_0;               //  
                BYTE  free[95];            //
                BYTE  crc_f;               //
        } imodule_eeprom;                  //
        //                                 //
        struct {                           //
                BYTE  sn[6];               //   
                BYTE  name[10];            //  
                BYTE  revision;            //    
                BYTE  cpu_type[10];        //   CPU/DSP
                DWORD qfrequency;          //     
                BYTE  crc_0;               //  
                BYTE  mid;                 // MID
                BYTE  crc_1;               //  
                BYTE  comment[477];        // 
                BYTE  crc_f;               //  
        } amodule_eeprom;                  //
} TE01, *PTE01;                            //
#pragma pack()                             //
//
typedef struct {
        BYTE bid;
        BYTE mid;
        BYTE object;
        double u_min;
        double u_max;
        char *str;
}OBJECT;




// ************************************************************
//                
// ************************************************************
TE01CALL(int) TE01Init(PTE01);
// ************************************************************
//                         
// ************************************************************
TE01CALL(int) TE01Open(PTE01, BYTE);
// ************************************************************
//                 
// ************************************************************
TE01CALL(int) TE01Close(PTE01);
// ************************************************************
//
// ************************************************************
TE01CALL(int) TE01Test(PTE01, BYTE*);
// ************************************************************
//                     
// ************************************************************
TE01CALL(int) TE01GetConfiguration(PTE01);
// ************************************************************
//                        
// flags   //00//    
// ************************************************************
TE01CALL(int) TE01SetConfiguration(PTE01, WORD);
// ************************************************************
//
// ************************************************************
TE01CALL(int) TE01GetData(PTE01, DWORD*);
// *************************************************************
//  (128 )     
// *************************************************************
TE01CALL(int) TE01ReadMemoryBlock(PTE01, DWORD, WORD*);
// *************************************************************
//  (128 )     
// *************************************************************
TE01CALL(int) TE01WriteMemoryBlock(PTE01, DWORD, WORD*);
// *************************************************************
//             eeprom
// *************************************************************
TE01CALL(int) TE01SystemAreaWriteEnable(PTE01);
// *************************************************************
//
// *************************************************************
TE01CALL(int) TE01CopyMemory(PTE01, DWORD, DWORD, WORD);






// ************************************************************
// ************************************************************
//                      1
// ************************************************************
// ************************************************************

// ************************************************************
//                         
// ************************************************************
TE01CALL(int) TE01ReadMemoryRandom(PTE01, DWORD, DWORD, WORD*, int (*)(char*));
// ************************************************************
//                         
// ************************************************************
TE01CALL(int) TE01WriteMemoryRandom(PTE01, DWORD, DWORD, WORD*, int (*)(char*));
// *************************************************************
//                       -> ram copy
// *************************************************************
TE01CALL(int) TE01LoadRAMFromEEPROM(PTE01, DWORD, DWORD, WORD);
// *************************************************************
//                      ram -> eeprom copy
// *************************************************************
TE01CALL(int) TE01SaveRAMToEEPROM(PTE01, DWORD, DWORD, WORD);
// *************************************************************
//                        eeprom  
// *************************************************************
TE01CALL(int) TE01ReadMModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom  
// *************************************************************
TE01CALL(int) TE01WriteMModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom 
// *************************************************************
TE01CALL(int) TE01ReadUModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom 
// *************************************************************
TE01CALL(int) TE01WriteUModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom 
// *************************************************************
TE01CALL(int) TE01ReadIModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom 
// *************************************************************
TE01CALL(int) TE01WriteIModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom  
// *************************************************************
TE01CALL(int) TE01ReadAModuleEEPROM(PTE01);
// *************************************************************
//                        eeprom  
// *************************************************************
TE01CALL(int) TE01WriteAModuleEEPROM(PTE01);
// *************************************************************
//                 eeprom
// *************************************************************
TE01CALL(int) TE01ReadCoeffFromEEPROM(PTE01);
// *************************************************************
//                 eeprom
// *************************************************************
TE01CALL(int) TE01WriteCoeffToEEPROM(PTE01);
// *************************************************************
//                       
// *************************************************************
TE01CALL(int) TE01UIMeasurement(PTE01, double*, double*, int, int, double, double, int (*)(char*));
// *************************************************************
//                          
// *************************************************************
TE01CALL(int) TE01UMeasurement(PTE01, double*, int, double, int (*)(char*));
// *************************************************************
//                          
// *************************************************************
TE01CALL(int) TE01IMeasurement(PTE01, double*, int, double, int (*)(char*));
// ************************************************************
//                  ->   
// ************************************************************
TE01CALL(double) TE01UModuleValue(PTE01, double, int);
TE01CALL(double) TE01GetUModuleValue(PTE01, int);
// ************************************************************
//                   ->   
// ************************************************************
TE01CALL(double) TE01IModuleValue(PTE01, double, int);
TE01CALL(double) TE01GetIModuleValue(PTE01, int);
// ************************************************************
//                   
// ************************************************************
TE01CALL(int) TE01SetFDACConfiguration(PTE01, int, int, int, int, int, double, double, int);
// ************************************************************
//                
// ************************************************************
TE01CALL(int) TE01GetFDACConfiguration(PTE01, int*,int*,int*,int*,int*,double*,double*, int);
// ************************************************************
//                
// ************************************************************
TE01CALL(int) TE01SetSDACConfiguration(PTE01, int, double, int);
// ************************************************************
//                
// ************************************************************
TE01CALL(int) TE01GetSDACConfiguration(PTE01, int*,double*,int);
// ************************************************************
//                
// ************************************************************
TE01CALL(int) TE01SetUADCConfiguration(PTE01, int, int, int);
// ************************************************************
//                 
// ************************************************************
TE01CALL(int) TE01GetUADCConfiguration(PTE01, int*,int*,int*);
// ************************************************************
//                
// ************************************************************
TE01CALL(int) TE01SetIADCConfiguration(PTE01, int, int, int);
// ************************************************************
//                 
// ************************************************************
TE01CALL(int) TE01GetIADCConfiguration(PTE01, int*,int*,int*);
// ************************************************************
//               
//            
// ************************************************************
TE01CALL(int) TE01SetAModuleConfiguration(PTE01, BYTE*);
// ************************************************************
//             
//                    
// ************************************************************
TE01CALL(int) TE01GetAModuleConfiguration(PTE01, BYTE*);




// ************************************************************
//                  
// ************************************************************
//TE01CALL(double) TE01GetFDACFrequency(PTE01);
// ************************************************************
//       :  ->    
// ************************************************************
//TE01CALL(int) TE01GetFDACValue(PTE01, double*, double*, int);
// ************************************************************
//       :  ->    
// ************************************************************
//TE01CALL(int) TE01SetFDACValue(PTE01, double, double, int);
// ************************************************************
//           ->    
// ************************************************************
//TE01CALL(double) TE01GetSDACValue(PTE01, int);
// ************************************************************
//           ->    
// ************************************************************
//TE01CALL(int) TE01SetSDACValue(PTE01, double, int);


// *************************************************************
//                   
// *************************************************************
TE01CALL(int) TE01GetMModuleSerialNumber(PTE01, char*);
TE01CALL(int) TE01SetMModuleSerialNumber(PTE01, char*);
// *************************************************************
//                      
// *************************************************************
TE01CALL(int) TE01GetUModuleSerialNumber(PTE01, char*);
TE01CALL(int) TE01SetUModuleSerialNumber(PTE01, char*);
// *************************************************************
//                      
// *************************************************************
TE01CALL(int) TE01GetIModuleSerialNumber(PTE01, char*);
TE01CALL(int) TE01SetIModuleSerialNumber(PTE01, char*);
// *************************************************************
//                       
// *************************************************************
TE01CALL(int) TE01GetAModuleSerialNumber(PTE01, char*);
TE01CALL(int) TE01SetAModuleSerialNumber(PTE01, char*);
// ************************************************************
//           
//       
// ************************************************************
TE01CALL(char*) TE01GetAPIMessage(void);






// *************************************************************
// *************************************************************
//                      2
// *************************************************************
// *************************************************************

// *************************************************************
//                          
// flag==1 <-   
// *************************************************************
TE01CALL(int) TE01TestMemory(PTE01, DWORD, DWORD, int, int (*)(char*));
// *************************************************************
//                         
// range 0..4 (12..0.039)
// mode  0 -                                                                              (range=0..4)
//               1 -                                                                                       (range=0..4)
//               2 -                                                                  (range=0..4)
//               3 -       (range=0..1)
//               4 -                         (range=1)
// *************************************************************
TE01CALL(int) TE01CalibrateUADCModule(PTE01, int, int, double, int (*)(char*));
// *************************************************************
//                       
// range 0..2
// mode  0 -    +Us
//       1 -    -Us
// *************************************************************
TE01CALL(int) TE01CalibrateSDACModule(PTE01, int, int, WORD, double*, int (*)(char*));
// *************************************************************
//                      
// range : 0..7
// *************************************************************
TE01CALL(int) TE01CalibrateFDACModule(PTE01, int, int, int, double*, int (*)(char*));
// *************************************************************
//                       I-
// range : 0..7
// *************************************************************
TE01CALL(int) TE01CalibrateIADCModule(PTE01, int, int (*)(char*));
//
TE01DECL(const double)  RAM_FREQ[5];
TE01DECL(const double) FDAC_RANGE[9];
TE01DECL(const double) FDAC_FILTER[4];
TE01DECL(const double) SDAC_RANGE[4];
TE01DECL(const double) UADC_RANGE[5];
TE01DECL(const double) UADC_RANGE_FULL[5];
TE01DECL(const double) IADC_RANGE[8];
TE01DECL(const double) IADC_RANGE_FULL[8];
TE01DECL(const double) IADC_SHUNT[8];
TE01DECL(const OBJECT) OBJECTS[NOBJECTS];
#endif
