#include <userint.h>
#include "te01uir.h"
#include "te01api.h"
#include <ansi_c.h>
//
extern int pnl1, pnl6, pnl7;
extern int RunFlag, StopFlag;
extern char stt[300];
extern TE01 *module;
//
int calibr_group[4]={P6_TOGGLEBUTTON1, P6_TOGGLEBUTTON2, P6_TOGGLEBUTTON3, P6_TOGGLEBUTTON4};
int Ku [6]={P6_KU1, P6_KU2, P6_KU3, P6_KU4, P6_KU5, P6_KD};
int Bu [5]={P6_BU1, P6_BU2, P6_BU3, P6_BU4, P6_BU5};
int CBu[6]={P6_CHECKBOX1, P6_CHECKBOX2, P6_CHECKBOX3, P6_CHECKBOX4, P6_CHECKBOX5, P6_CHECKBOX6}; 
int Ki [8]={P6_KI1, P6_KI2, P6_KI3, P6_KI4, P6_KI5, P6_KI6, P6_KI7, P6_KI8};
int Bi [8]={P6_BI1, P6_BI2, P6_BI3, P6_BI4, P6_BI5, P6_BI6, P6_BI7, P6_BI8};
int CBi[8]={P6_CHECKBOX31, P6_CHECKBOX32, P6_CHECKBOX33, P6_CHECKBOX34, 
            P6_CHECKBOX35, P6_CHECKBOX36, P6_CHECKBOX37, P6_CHECKBOX38}; 
int Ks [3]={P6_KS1, P6_KS2, P6_KS3};
int Bs [3]={P6_BS1, P6_BS2, P6_BS3};
int CBs[3]={P6_CHECKBOX11, P6_CHECKBOX12, P6_CHECKBOX13}; 
int Kf [8]={P6_KF1, P6_KF2, P6_KF3, P6_KF4, P6_KF5, P6_KF6, P6_KF7, P6_KF8};
int Bf [8]={P6_BF1, P6_BF2, P6_BF3, P6_BF4, P6_BF5, P6_BF6, P6_BF7, P6_BF8};
int CBf[8]={P6_CHECKBOX21, P6_CHECKBOX22, P6_CHECKBOX23, P6_CHECKBOX24, 
            P6_CHECKBOX25, P6_CHECKBOX26, P6_CHECKBOX27, P6_CHECKBOX28}; 
//
void InfoMessage(char*, int);
int get_group_select(int, int *, int);
int set_group_select_controlid(int, int, int*, int); 
int CVICALLBACK get_config(int, int, int, void *, int, int);
//************************************************************* 
//
//************************************************************* 
void InitP6(void)
{
 int i, j;
	SetCtrlVal(pnl6, P6_KU, module->Ku[1]);
	SetCtrlVal(pnl6, P6_BU, module->Bu[1]);
	for(i=0; i<5; i++) {
		SetCtrlVal(pnl6, Ku[i], module->Ku[i]);
		SetCtrlVal(pnl6, Bu[i], module->Bu[i]);
	}
	SetCtrlVal(pnl6, Ku[5], module->Kd);
	for(i=0; i<8; i++) {
		SetCtrlVal(pnl6, Ki[i], module->Ki[i]);
		SetCtrlVal(pnl6, Bi[i], module->Bi[i]);
	}
	GetCtrlVal(pnl6, P6_SDAC_METHOD, &j);
	for(i=0; i<3; i++) {
		SetCtrlVal(pnl6, Ks[i], j ? module->Ks2[i] : module->Ks1[i]);
		SetCtrlVal(pnl6, Bs[i], j ? module->Bs2[i] : module->Bs1[i]);
	}
	GetCtrlVal(pnl6, P6_FDAC_METHOD, &j);
	for(i=0; i<8; i++) {
		SetCtrlVal(pnl6, Kf[i], j ? module->Kf2[i] : module->Kf1[i]);
		SetCtrlVal(pnl6, Bf[i], j ? module->Bf2[i] : module->Bf1[i]);
	}
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK k_b_changed(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{															 //
 double d;													 //
 int i, j;													 //
	switch (event) {										 //
		case EVENT_VAL_CHANGED:								 //
			GetCtrlVal(pnl6, control, &d);					 //
			for(i=0; i<5; i++) 								 //
				if(control==Ku[i]) module->Ku[i]=d;			 //
				else if(control==Bu[i]) module->Bu[i]=d;		 //
			if(control==Ku[5]) module->Kd=d;					 // .   
			for(i=0; i<8; i++) 
				if(control==Ki[i]) module->Ki[i]=d;
				else if(control==Bi[i]) module->Bi[i]=d;
			GetCtrlVal(pnl6, P6_SDAC_METHOD, &j);
			for(i=0; i<3; i++) 
				if(control==Ks[i]) 
					if(j) module->Ks2[i]=d; else module->Ks1[i]=d; 
				else if(control==Bs[i]) 
					if(j) module->Bs2[i]=d; else module->Bs1[i]=d;
			GetCtrlVal(pnl6, P6_SDAC_METHOD, &j);
			for(i=0; i<8; i++)	
				if(control==Kf[i]) 
					if(j) module->Kf2[i]=d; else module->Kf1[i]=d;
				else if(control==Bf[i]) 
					if(j) module->Bf2[i]=d; else module->Bf1[i]=d;
			if(control==P6_KU) 
				for(i=0; i<5; i++) SetCtrlVal(pnl6, Ku[i], module->Ku[i]=d);
			else if(control==P6_BU)
				for(i=0; i<5; i++) SetCtrlVal(pnl6, Bu[i], module->Bu[i]=d);
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK method_u(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(pnl6, P6_METHOD_U, &i);
			SetCtrlAttribute(pnl6, P6_VOLTAGE, ATTR_LABEL_TEXT, i ? "  , " : " , ");
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK voltage(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_VAL_CHANGED :
			module->Ku[1]=1;
			module->Bu[1]=0;
			InitP6();
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK write(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			module->umodule_eeprom.uref=UADC_RANGE_FULL[1]*((module->Ku[1]*0xFFFFFF+module->Bu[1])*2/0xFFFFFF-1);
			if(TE01WriteUModuleEEPROM(module)) InfoMessage("\033fgff0000>>   EEPROM U-.", 0);
			else {
				SetCtrlVal(pnl6, P6_METHOD_U, 0);
				SetCtrlAttribute(pnl6, P6_VOLTAGE, ATTR_LABEL_TEXT, " , ");
				SetCtrlVal(pnl6, P6_VOLTAGE, module->umodule_eeprom.uref);
				InfoMessage("\033fg0000ff>>  EEPROM U-  ", 0);
			}	
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK read(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			if(TE01ReadUModuleEEPROM(module)) InfoMessage("\033fgff0000>>   EEPROM U-", 0);
			else {
				InfoMessage("\033fg0000ff>>  EEPROM U-  ", 0);
				SetCtrlVal(pnl6, P6_METHOD_U, 0);
				SetCtrlAttribute(pnl6, P6_VOLTAGE, ATTR_LABEL_TEXT, " , ");
				SetCtrlVal(pnl6, P6_VOLTAGE, module->umodule_eeprom.uref);
				module->Ku[1]=1;
				module->Bu[1]=0;
				InitP6();
			}	
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int info_calibr(char *str)
{
 if(str[0]=='!') {
	MessagePopup ("!!!", str+1);
 } else {
 	sprintf(stt, "\033fg0000ff>> %s", str);
 	InfoMessage(stt, 1);
 }	
 return StopFlag;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK umodule_calibr(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{															 //
	switch (event) {										 //
		case EVENT_COMMIT:									 //
			if(RunFlag) StopFlag=1;							 //
			else {											 //
				void *buf=NULL;								 //
				int i, j, k, m;							     //
				RunFlag=1; StopFlag=0;						 //
			    SetCtrlAttribute(pnl6, P6_UMODULE_CALIBR, ATTR_LABEL_TEXT , "");
				//
				switch(get_group_select(pnl6, calibr_group, 4)) {
					case 0 : 
						MessagePopup ("!!!", "  ,  \n      .");
						//   		 //
						GetCtrlVal(pnl6, P6_CHECKBOX1, &j);	 //	 				 
						if(j && !StopFlag) {				 //					 
							double val;						 //
							InfoMessage("\033fg0000ff>>   ", 0);
							GetCtrlVal(pnl6, P6_METHOD_U, &i);							  
							GetCtrlVal(pnl6, P6_VOLTAGE, &val);
							if(TE01CalibrateUADCModule(module, 1, i+3, val, info_calibr)) StopFlag=1;
							InitP6(); 
							get_config(panel, control, EVENT_COMMIT, NULL, 0, 0);
						}	   					   
						//    1..5
						//GetCtrlVal(pnl6, P6_CHECKBOX7, &k);			
						k=0;
						for(i=0; i<5; i++) {
							GetCtrlVal(pnl6, CBu[i+1], &j);
							if(!StopFlag && j) {
								InfoMessage("\033fg0000ff>>  ", 0);							
								if((!i && TE01CalibrateUADCModule(module, 0, 3, 0, info_calibr)) ||
								  ((i || k) && TE01CalibrateUADCModule(module, i, k ? 2 : 0, 0, info_calibr))) StopFlag=1;
								get_config(panel, control, EVENT_COMMIT, NULL, 0, 0);
							}									        
							SetCtrlVal(pnl6, Ku[i], module->Ku[i]);
							SetCtrlVal(pnl6, Bu[i], module->Bu[i]);
							if(i==1) SetCtrlVal(pnl6, P6_BU, module->Bu[1]);
						}
						//  .   
						GetCtrlVal(pnl6, P6_CHECKBOX8, &j);			    
						if(j && !StopFlag) {			
							if(TE01CalibrateUADCModule(module, 1, 5, 0, info_calibr)) StopFlag=1;
							SetCtrlVal(pnl6, Ku[5], module->Kd);
							get_config(panel, control, EVENT_COMMIT, NULL, 0, 0);
						}
					break;
					case 1 : //  
						for(i=0; i<8; i++) {
							GetCtrlVal(pnl6, CBi[i], &j);
							if(!StopFlag && j) {
								InfoMessage("\033fg0000ff>>  ", 0);
								if(TE01CalibrateIADCModule(module, i, info_calibr)) {
									sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
									InfoMessage(stt, 0);
									StopFlag=1;
								}
								get_config(panel, control, EVENT_COMMIT, NULL, 0, 0);
							}	
							SetCtrlVal(pnl6, Ki[i], module->Ki[i]);
							SetCtrlVal(pnl6, Bi[i], module->Bi[i]);
						}
					break;
					case 2 : //   
						GetCtrlVal(pnl6, P6_SDAC_NPOINT, &k);
						GetCtrlVal(pnl6, P6_SDAC_GRAPH, &j);
						GetCtrlVal(pnl6, P6_SDAC_METHOD, &m);
						if(j && (buf=malloc(k*sizeof(double)))==NULL) {
							InfoMessage("\033fgff0000>>  .", 1);						
							StopFlag=1;
						}
						for(i=0; i<3; i++) {
							GetCtrlVal(pnl6, CBs[i], &j);
							if(!StopFlag && j) {
								InfoMessage("\033fg0000ff>>   ", 0);
								if(TE01CalibrateSDACModule(module, i, m, k, buf, info_calibr)) {
									sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
									InfoMessage(stt, 0);
									StopFlag=1;
								} else if(buf!=NULL && (pnl7>0 || (pnl7=LoadPanel(0, "te01\\te01uir.uir", P7))>0)) {
									const int color[3]={0xFF0000, 0x000000, 0x0000FF};
									DisplayPanel(pnl7);	
									SetPanelAttribute(pnl7, ATTR_TITLE, "   , ");
									PlotWaveform (pnl7, P7_GRAPH, buf, k, VAL_DOUBLE, 2*SDAC_RANGE[module->sdac_range]/0xFFFF, 0.0, 0.0, 1.0, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, color[module->sdac_range]);
								}
								module->cflags|=SDAC_DATA_CORRECTION;
								get_config(panel, control, EVENT_COMMIT, NULL, 0, 0);
							}	
							SetCtrlVal(pnl6, Ks[i], m ? module->Ks2[i] : module->Ks1[i]);
							SetCtrlVal(pnl6, Bs[i], m ? module->Bs2[i] : module->Bs1[i]);
						}
					break;
					case 3 :
						//   
						GetCtrlVal(pnl6, P6_FDAC_NPOINT, &k);
						GetCtrlVal(pnl6, P6_FDAC_GRAPH, &j);
						GetCtrlVal(pnl6, P6_FDAC_METHOD, &m);
						if(j && (buf=malloc(k*sizeof(double)))==NULL) {
							InfoMessage("\033fgff0000>>  .", 1);						
							StopFlag=1;
						}
						for(i=0; i<8; i++) {
							GetCtrlVal(pnl6, CBf[i], &j);
							if(!StopFlag && j) {
								InfoMessage("\033fg0000ff>>   ", 0);
								if(TE01CalibrateFDACModule(module, i, m, k, buf, info_calibr)) {
									sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
									InfoMessage(stt, 0);
									StopFlag=1;
								} else if(buf!=NULL && (pnl7>0 || (pnl7=LoadPanel(0, "te01\\te01uir.uir", P7))>0)) {
									const int color[8]={0xFF0000, 0x000000, 0x0000FF};
									DisplayPanel(pnl7);	
									SetPanelAttribute(pnl7, ATTR_TITLE, "   , ");
									PlotWaveform (pnl7, P7_GRAPH, buf, k, VAL_DOUBLE, 2*FDAC_RANGE[module->fdac_range]/0xFFFF, 0.0, 0.0, 1.0, VAL_THIN_LINE, VAL_EMPTY_SQUARE, VAL_SOLID, 1, color[module->fdac_range]);
								}
								get_config(panel, control, EVENT_COMMIT, NULL, 0, 0);
							}	
							SetCtrlVal(pnl6, Kf[i], m ? module->Kf2[i] : module->Kf1[i]);
							SetCtrlVal(pnl6, Bf[i], m ? module->Bf2[i] : module->Bf1[i]);
						}
					break;
				}
				free(buf);
				RunFlag=0;
			    SetCtrlAttribute(pnl6, P6_UMODULE_CALIBR, ATTR_LABEL_TEXT , "");
				//
			}
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int PNL_UMODULE[26][3]={
{P6_DECORATION, 23, 2},  {P6_DECORATION_2, 80, 2},
{P6_METHOD_U, 53, 20}, {P6_VOLTAGE, 53, 131}, 
{P6_WRITE, 29, 260}, {P6_READ, 29, 360}, 
{P6_CHECKBOX1,  26, 7}, {P6_KU,   53, 251}, {P6_BU,   53, 368},
{P6_CHECKBOX2,  88, 7}, {P6_KU1,  85, 258}, {P6_BU1,  85, 367},
{P6_CHECKBOX3, 104, 7}, {P6_KU2, 102, 258}, {P6_BU2, 102, 367}, 
{P6_CHECKBOX4, 120, 7}, {P6_KU3, 119, 258}, {P6_BU3, 119, 367},
{P6_CHECKBOX5, 136, 7}, {P6_KU4, 136, 258}, {P6_BU4, 136, 367},
{P6_CHECKBOX6, 152, 7}, {P6_KU5, 153, 258}, {P6_BU5, 153, 367},
{P6_CHECKBOX8, 168, 7}, {P6_KD , 170, 258}};
//										    
int PNL_IMODULE[25][3]={
{P6_DECORATION_5, 23,   2}, 
{P6_CHECKBOX31,  30, 7}, {P6_KI1,  27, 258}, {P6_BI1,  27, 367},
{P6_CHECKBOX32,  46, 7}, {P6_KI2,  43, 258}, {P6_BI2,  43, 367},
{P6_CHECKBOX33,  62, 7}, {P6_KI3,  59, 258}, {P6_BI3,  59, 367},
{P6_CHECKBOX34,  78, 7}, {P6_KI4,  75, 258}, {P6_BI4,  75, 367},
{P6_CHECKBOX35,  94, 7}, {P6_KI5,  91, 258}, {P6_BI5,  91, 367},
{P6_CHECKBOX36, 110, 7}, {P6_KI6, 107, 258}, {P6_BI6, 107, 367},							 
{P6_CHECKBOX37, 126, 7}, {P6_KI7, 123, 258}, {P6_BI7, 123, 367},
{P6_CHECKBOX38, 142, 7}, {P6_KI8, 139, 258}, {P6_BI8, 139, 367}};
//
int PNL_SDAC[13][3]={
{P6_DECORATION_3, 23,   2}, {P6_SDAC_METHOD  , 27,  87},
{P6_SDAC_NPOINT , 104, 388}, {P6_SDAC_GRAPH, 128, 430},
{P6_CHECKBOX11,  50, 7}, {P6_KS1,  44, 258}, {P6_BS1,  44, 367},
{P6_CHECKBOX12,  66, 7}, {P6_KS2,  61, 258}, {P6_BS2,  61, 367},
{P6_CHECKBOX13,  82, 7}, {P6_KS3,  78, 258}, {P6_BS3,  78, 367}};
//
int PNL_FDAC[28][3]={
{P6_DECORATION_4, 23,   2}, {P6_FDAC_METHOD, 27,   50}, 
{P6_FDAC_NPOINT, 185, 388}, {P6_FDAC_GRAPH , 209, 430}, 
{P6_CHECKBOX21,  50, 7}, {P6_KF1,  47, 258}, {P6_BF1,  47, 367},
{P6_CHECKBOX22,  66, 7}, {P6_KF2,  63, 258}, {P6_BF2,  63, 367},
{P6_CHECKBOX23,  82, 7}, {P6_KF3,  79, 258}, {P6_BF3,  79, 367},
{P6_CHECKBOX24,  98, 7}, {P6_KF4,  95, 258}, {P6_BF4,  95, 367},
{P6_CHECKBOX25, 114, 7}, {P6_KF5, 111, 258}, {P6_BF5, 111, 367},
{P6_CHECKBOX26, 130, 7}, {P6_KF6, 127, 258}, {P6_BF6, 127, 367},
{P6_CHECKBOX27, 146, 7}, {P6_KF7, 143, 258}, {P6_BF7, 143, 367},
{P6_CHECKBOX28, 162, 7}, {P6_KF8, 159, 258}, {P6_BF8, 159, 367}};
int CVICALLBACK calibr_switch(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i, y, index;
	switch (event) {
		case EVENT_COMMIT:
			index=set_group_select_controlid(pnl6, control, calibr_group, 4);
			y=(index==0 ? 0 : 300);
			for(i=0; i<26; i++) {
				SetCtrlAttribute(pnl6, PNL_UMODULE[i][0], ATTR_TOP, PNL_UMODULE[i][1]+y);
				SetCtrlAttribute(pnl6, PNL_UMODULE[i][0], ATTR_LEFT, PNL_UMODULE[i][2]);
			}	
			y=(index==1 ? 0 : 300);
			for(i=0; i<25; i++) {
				SetCtrlAttribute(pnl6, PNL_IMODULE[i][0], ATTR_TOP, PNL_IMODULE[i][1]+y);
				SetCtrlAttribute(pnl6, PNL_IMODULE[i][0], ATTR_LEFT, PNL_IMODULE[i][2]);
			}	
			y=(index==2 ? 0 : 300);
			for(i=0; i<13; i++) {
				SetCtrlAttribute(pnl6, PNL_SDAC[i][0], ATTR_TOP, PNL_SDAC[i][1]+y);
				SetCtrlAttribute(pnl6, PNL_SDAC[i][0], ATTR_LEFT, PNL_SDAC[i][2]);
			}	
			y=(index==3 ? 0 : 300);
			for(i=0; i<28; i++) {
				SetCtrlAttribute(pnl6, PNL_FDAC[i][0], ATTR_TOP, PNL_FDAC[i][1]+y);
				SetCtrlAttribute(pnl6, PNL_FDAC[i][0], ATTR_LEFT, PNL_FDAC[i][2]);
			}	
		break;
	}
 return 0;
}
//
int CVICALLBACK reinit(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			InitP6();						
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK write_all (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			if(TE01WriteCoeffToEEPROM(module)) InfoMessage("\033fgff0000>>     EEPROM.", 0);
								           else InfoMessage("\033fg0000ff>>    EEPROM  ", 0);
		break;
	}
 return 0;
}
//************************************************************* 
//
//************************************************************* 
int CVICALLBACK read_all (int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT:
			if(TE01ReadCoeffFromEEPROM(module)) InfoMessage("\033fgff0000>>     EEPROM", 0);
			else {
				InfoMessage("\033fg0000ff>>     EEPROM  ", 0);
				InitP6();
			}	
		break;
	}
 return 0;
}
