#include <userint.h>
#include "te01uir.h"
#include "te01api.h"
#include <ansi_c.h>
//#include <ansi_c.h>
//
extern char stt[300];
extern int pnl5, RunFlag, StopFlag;
extern TE01 *module;
void InfoMessage(char*, int);


const int PANEL5[15]={
P5_MSN, P5_MREV, P5_MEEWRITE,
P5_USN, P5_UREV, P5_UEEWRITE,
P5_ISN, P5_IREV, P5_IEEWRITE, 
P5_ASN, P5_AREV, P5_AEEWRITE, P5_TEXTMSG, P5_BID_MID, P5_TEXTBOX};
//************************************************************* 
// 
//************************************************************* 
void InitP5(void)
{
 int i;
 TE01GetMModuleSerialNumber(module, stt);
 SetCtrlVal(pnl5, P5_MSN, stt);
 SetCtrlVal(pnl5, P5_MREV, module->mmodule_eeprom.revision); 
 TE01GetUModuleSerialNumber(module, stt);
 SetCtrlVal(pnl5, P5_USN, stt);
 SetCtrlVal(pnl5, P5_UREV, module->umodule_eeprom.revision);
 TE01GetIModuleSerialNumber(module, stt);
 SetCtrlVal(pnl5, P5_ISN, stt);
 SetCtrlVal(pnl5, P5_IREV, module->imodule_eeprom.revision);
 					  
 for(i=9; i<15; i++) SetCtrlAttribute(pnl5, PANEL5[i], ATTR_ZPLANE_POSITION, module->bid ? 0 : 100);
// if(module->bid) {
	 TE01GetAModuleSerialNumber(module, stt); 
	 SetCtrlVal(pnl5, P5_ASN, stt); 
	 SetCtrlVal(pnl5, P5_AREV, module->amodule_eeprom.revision);
	 sprintf(stt, "BID=%i,   MID=", module->bid);
	 SetCtrlAttribute(pnl5, P5_BID_MID, ATTR_LABEL_TEXT, stt);
	 SetCtrlVal(pnl5, P5_BID_MID, module->amodule_eeprom.mid);
	 sprintf(stt, "%.221s", module->amodule_eeprom.comment);
	 ResetTextBox(pnl5, P5_TEXTBOX, stt); 
// }
}
//************************************************************* 
// 
//************************************************************* 
int info_test(char *str)
{
 sprintf(stt, "\033fg0000ff>> %s", str);
 InfoMessage(stt, 1);
 return StopFlag;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK test_start(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i;
 WORD buf[256];
	switch (event) {
		case EVENT_COMMIT:
			if(!RunFlag) { 
				RunFlag=1; StopFlag=0;
				//
				GetCtrlVal(panel, P5_TEST1, &i);
				if(!StopFlag && i) { 
					InfoMessage("\033fg0000ff>>  :", 0);			 
					InfoMessage("\033fg0000ff>>", 0);			 
					if(TE01Test(module, (BYTE*)buf)) InfoMessage("\033fgff0000>>    ", 1);	
					else {
						sprintf(stt, "\033fg0000ff>> %.128s", (BYTE*)buf);
						InfoMessage(stt, 1);	
					}
				}	
				//
				GetCtrlVal(panel, P5_TEST2, &i);
				if(!StopFlag && i) {
					InfoMessage("\033fg0000ff>>   :", 0);			 
					InfoMessage("\033fg0000ff>>", 0);			 
		 			if(TE01TestMemory(module, RAM_START, RAM_SIZE, 0, info_test)) {
		 				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
		 				InfoMessage(stt, 1);
		 			}
				}
				//
				GetCtrlVal(panel, P5_TEST3, &i);
				if(!StopFlag && i) {
					InfoMessage("\033fg0000ff>>   :", 0);			 
					InfoMessage("", 0);			 
		 			if(TE01TestMemory(module, EEPROM_D_START, EEPROM_D_SIZE+EEPROM_C_SIZE, 0, info_test)) {
		 				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
		 				InfoMessage(stt, 1);
		 			}
				}
				//
				GetCtrlVal(panel, P5_TEST4, &i);
				if(!StopFlag && i) {
					InfoMessage("\033fg0000ff>>  U- :", 0);			 
					InfoMessage("", 0);			 
		 			if(TE01TestMemory(module, EEPROM_U_START, EEPROM_U_SIZE, 0, info_test)) {
		 				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
		 				InfoMessage(stt, 1);
		 			}
				}
				//
				GetCtrlVal(panel, P5_TEST5, &i);
				if(!StopFlag && i) {
					InfoMessage("\033fg0000ff>>  I- :", 0);			 
					InfoMessage("", 0);			 
		 			if(TE01TestMemory(module, EEPROM_I_START, EEPROM_I_SIZE, 0, info_test)) {
		 				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
		 				InfoMessage(stt, 1);
		 			}
				}
				//
				GetCtrlVal(panel, P5_TEST6, &i);
				if(!StopFlag && i) {
					InfoMessage("\033fg0000ff>>    :", 0);			 
					InfoMessage("", 0);			 
		 			if(TE01TestMemory(module, EEPROM_A_START, EEPROM_A_SIZE, 0, info_test)) { 
		 				sprintf(stt, "\033fgff0000>> %s", TE01GetAPIMessage());
		 				InfoMessage(stt, 1);
		 			}
				}
				//
				RunFlag=0;
			} else StopFlag=1;
		break;
	}
 return 0;
}


typedef struct{BYTE  sn[6];	BYTE  name[10];	BYTE  rev; BYTE  cpu[10];	DWORD qfreq; BYTE  crc;} HEADER;
const HEADER mm={"", "TE01M", 0,  "CR16MCS9", 14745600, 0}; 
const HEADER um={"", "TE01U", 0,  "AT90S2313", 2457600, 0}; 
const HEADER im={"", "TE01I", 0,  "AT90S2313", 2457600, 0}; 
const HEADER am={"", "TE01A", 0,  "NONE",            0, 0}; 
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK meewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT :												   
			memcpy((void*)(unsigned long)module->mmodule_eeprom.sn, (void*)(unsigned long)mm.sn, sizeof(HEADER));
			GetCtrlVal(panel, P5_MSN, stt);
			TE01SetMModuleSerialNumber(module, stt);	
			GetCtrlVal(pnl5, P5_MREV, &module->mmodule_eeprom.revision); 
	 	    if(TE01SystemAreaWriteEnable(module) || TE01WriteMModuleEEPROM(module)) InfoMessage("\033fgff0000>>   EEPROM  ", 0);   
		    else InfoMessage("\033fg0000ff>> EEPROM   ", 0);   
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK ueewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT :
			memcpy((void*)(unsigned long)module->umodule_eeprom.sn, (void*)(unsigned long)um.sn, sizeof(HEADER));
			GetCtrlVal(panel, P5_USN, stt);
			TE01SetUModuleSerialNumber(module, stt);	 
			GetCtrlVal(pnl5, P5_UREV, &module->umodule_eeprom.revision); 
	 	    if(TE01SystemAreaWriteEnable(module) || TE01WriteUModuleEEPROM(module)) InfoMessage("\033fgff0000>>   EEPROM ", 0);   
		    else InfoMessage("\033fg0000ff>> EEPROM  ", 0);   
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK ieewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch (event) {
		case EVENT_COMMIT :
			memcpy((void*)(unsigned long)module->imodule_eeprom.sn, (void*)(unsigned long)im.sn, sizeof(HEADER));
			GetCtrlVal(panel, P5_ISN, stt);
			TE01SetIModuleSerialNumber(module, stt);	
			GetCtrlVal(pnl5, P5_IREV, &module->imodule_eeprom.revision); 
	 	    if(TE01SystemAreaWriteEnable(module) || TE01WriteIModuleEEPROM(module)) InfoMessage("\033fgff0000>>   EEPROM ", 0);   
		    else InfoMessage("\033fg0000ff>> EEPROM  ", 0);   
		break;
	}
 return 0;
}
//************************************************************* 
// 
//************************************************************* 
int CVICALLBACK aeewrite(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i, n;
	switch (event) {
		case EVENT_COMMIT :
 MessagePopup("TE01 WARNING", "Not supported here, see plugins");
                break;  // @ BKL
			memcpy((void*)(unsigned long)module->amodule_eeprom.sn, (void*)(unsigned long)am.sn, sizeof(HEADER)); 
			GetCtrlVal(panel, P5_ASN, stt);
// @BKL			TE01SetAModuleSerialNumber(module, stt);	
			GetCtrlVal(pnl5, P5_IREV, &module->amodule_eeprom.revision); 
			GetCtrlVal(pnl5, P5_BID_MID, &module->amodule_eeprom.mid); 
		    GetNumTextBoxLines(pnl5, P5_TEXTBOX, &n);
		    memset(module->amodule_eeprom.comment, 0, sizeof(module->amodule_eeprom.comment));
		    for(i=0; i<n; i++) {
			    char tmp[1000];
			    GetTextBoxLine(pnl5, P5_TEXTBOX, i, tmp);
		   	    strncat(module->amodule_eeprom.comment, tmp, 220-strlen(module->amodule_eeprom.comment));
		   	    strncat(module->amodule_eeprom.comment, "\n", 220-strlen(module->amodule_eeprom.comment));
		    }
		    //		  
//		    if(TE01SystemAreaWriteEnable(module) || TE01WriteAModuleEEPROM(module)) InfoMessage("\033fgff0000>>   EEPROM  ", 0);   
//		    else {
//		   	   InfoMessage("\033fg0000ff>> EEPROM   ", 0);   
//		       ResetTextBox (pnl5, P5_TEXTBOX, module->amodule_eeprom.comment);
// @BKL		    }
		break;
	}
 return 0;
}

