#include "common\\include\\commondef.h"
#include "uirprocessor.h"
#include "core.h"
#include <ansi_c.h>
#include <utility.h>
#include <userint.h>
extern int selectUserSystem(char *sysname);

extern int loadAvailableServices(char *filelist);
extern int unloadAvailableServices(void);

void main(int argc, char *argv[]) {
  char   sysname[FNAMELEN + 1], syspath[FNAMELEN+1];
  int    res;
  int    wasOtherInstance;
  static int AllB, AllBt, AllB2, AllBt2;  
  int     n;
  uirData u;
  char tmp[512];
  
  
  if(CheckForDuplicateAppInstance (ACTIVATE_OTHER_INSTANCE, &wasOtherInstance) < -1) {
        MessagePopup(MSG_ERROR, "Unable to allocate system resources.");
        return;
  };
  if(wasOtherInstance) {
     // return;
  };
  CVIDynamicMemoryInfo ("enter", &AllB, &AllBt, DYNAMIC_MEMORY_SHOW_ALLOCATED_MEMORY_SUMMARY);
  
  GetProjectDir (syspath);
  SetDir (syspath); 

  if(argc > 1) strcpy(syspath, argv[1]);
  else {
     if((res= selectUserSystem(syspath))) {
         if(res == -1) goto __return;
         if(res) {
            MessagePopup(MSG_ERROR, "No any available system");
            goto __return;
         };
     };
  };

  if(openUserSystem(syspath, sysname)) {
    MessagePopup(MSG_ERROR, "UTS has failed to open the specified system");
    goto __return;
  };
  
  if(openPlugList4System(sysname)) {
    MessagePopup(MSG_ERROR, "UTS did not find any module plugin for the specified system");
    closeUserSystem();    
    goto __return;  
  };
  
  loadAvailableServices("service.s");  // !!! tmp -> fname +  _here_  ??? 

  strcpy(tmp, sysname);
  if(wasOtherInstance) {
     sprintf(tmp, "%s *", sysname);          
  };
  openUir(tmp, &u);
  showUir();
  
  RunUserInterface();
  
  unloadAvailableServices();
  
  closeUir();

  closePlugList4System();
  closeUserSystem();

__return:  
  CVIDynamicMemoryInfo ("enter", &AllB2, &AllBt2, DYNAMIC_MEMORY_SHOW_ALLOCATED_MEMORY_SUMMARY);  
  if(AllB!=AllB2 || AllBt !=AllBt2) {
     MessagePopup(MSG_ERROR, "Please, inform me that the program has incorrect work with memory");
  };

};
