#include <ansi_c.h>
#include "systems\\common\\include\\systemdef.h"
#include "common\\include\\commondef.h"
#include "selectoruir.h"

#define CUIR_FNAME     "selectoruir.uir"
#define CSTARTUP_FNAME "startup.s"

static void releaseSelector(int p, FILE *f) {
  if(p > 0) DiscardPanel(p); 
  if(f!= NULL) fclose(f);
};

int selectUserSystem(char *sysname) {
  int p= LoadPanel(0, CUIR_FNAME, SP);
  int xc, xp, n= 0, i;
  FILE *f= fopen(CSTARTUP_FNAME, "r");
  char  buf[FNAMELEN+1], tmp[FNAMELEN+1];
  systemManager smng;
  
  if(f == NULL) goto __bad_ret;
  
  while(fgets(buf, FNAMELEN, f)!= NULL) {
     if((i= strlen(buf)) >= 1) buf[i-1]= 0x0;  // \r   // !!! tmp
     else
       continue;
     if(!openUTFSystemDLL(&smng, buf)) {	   // \033p100
        sprintf(tmp, "\033fg0000CC %s\033fg000000 : %s, v. <%s>", smng.system()->info.name, smng.system()->info.descr, smng.system()->info.version);
		InsertListItem (p, SP_list, -1, tmp, buf);
        closeUTFSystemDLL(&smng);
        strcpy(sysname, buf);
        n++;
     }
  };
  
  if(!n) goto __bad_ret;
  if(n == 1) goto __good_ret;

  InstallPopup(p);

  while(1) {
	  if(!GetUserEvent(0, &xp, &xc)) continue;
	  if(xp!= p) continue;
	  if(xc == SP_cancel) goto __cancel;
	  if(xc == SP_ok) {
	     GetCtrlVal(p, SP_list, sysname);
         goto __good_ret; 
	  };
  };

__cancel:
  releaseSelector(p, f);
  return -1;
  
__good_ret:
  releaseSelector(p, f);
  return 0;
  
__bad_ret:
  releaseSelector(p, f);
  return 1;
};


