#include "common\\include\\commondef.h"
#include "services\\common\\include\\servicedef.h"
#include "systems\\common\\include\\plugindef.h"
#include "serviceuir.h"
#include <userint.h>
#include <ansi_c.h>
#include "core.h"

//void closeUTServiceDLL(serviceManager *p);
//int  openUTServiceDLL(serviceManager *p, char *srcpath);

extern void EnaDisBarMenuVsStart(int );
static int Pnl, NavPnl= -1;
#define P(x) BRIDGE_##x
#define N(x) NAV_##x

static int ServiceNum= 0;
#define MAXSERVICENUM 128  // ??? !!! tmp

pluginADC *listADC= NULL;

serviceManager serviceMng[MAXSERVICENUM];

int loadAvailableServices(char *filelist) {
  FILE *f= fopen(filelist, "r");
  char  buf[FNAMELEN+1];
  int   i;

  if(f == NULL) return 0;
  
  while(fgets(buf, FNAMELEN, f)!= NULL) {
     if((i= strlen(buf)) >= 1) if(buf[i-1] == 0xD || buf[i-1] == 0xA) buf[i-1]= 0x0;  // \r   // !!! tmp
     else
       continue;
     if(!openUTServiceDLL(&serviceMng[ServiceNum], buf)) {	   
        ServiceNum++;
     }
  };
 return 0;
};

int unloadAvailableServices(void) {
 int j;
 // if(!ServiceNum) return 0;
 if(NavPnl!= -1) {
    slf_closenav (-1, -1, EVENT_COMMIT, NULL, 0, 0);
 };
 
 for(j= 0; j<ServiceNum; j++) 
     closeUTServiceDLL(&serviceMng[j]); 

 return 0;
};
/*
int servprocGetNum(void) {
 return ServiceNum;
};

char *servprocGetName(int num) {
 if(num > ServiceNum - 1) return NULL;
 return serviceMng[num].service()->name;
};
*/

int  insertServiceList2Bar(int pnl, int bar, int menuItem, 
  void CVICALLBACK sFunction ( int menuBarHandle,
         int menuItemID, void *callbackData, int panelHandle )) {
         
 int  did= -1;
 char tmp[2*FNAMELEN + 16];
 int  firstId; 
 int  j; 
 
 GetMenuBarAttribute (bar, menuItem, ATTR_FIRST_ITEM_ID, &firstId);
 
 did= InsertSeparator(bar, menuItem, firstId); 
 if(did<= 0) return 1;
 
 for(j= 0; j< ServiceNum; j++) {
     sprintf(tmp, "%s", serviceMng[j].service()->name);
	 NewMenuItem (bar, menuItem, tmp, did, 0, sFunction, NULL); 
 }; 
 return 0; 
};

void servprocShowDescription(char *sname) {
 int j;
 
 for(j= 0; j< ServiceNum; j++) {  
     if(!stricmp(sname, serviceMng[j].service()->name)) {
        MessagePopup(MSG_PROMPT, serviceMng[j].service()->descr);
        return;
     };
 };
 
};

static serviceDefine *serviceCore(char *sname) {
 int j;
 
 for(j= 0; j< ServiceNum; j++) {  
     if(!stricmp(sname, serviceMng[j].service()->name)) {
        return serviceMng[j].service();
     };
 };
 
 return NULL;
};

// *****************************************************************
static  serviceDefine *theSD;
static  pluginDefine  *thePD;
static char servicename[FNAMELEN + 1];
static char moduleDescr[FNAMELEN + 1];


extern void *getTE01Handle(void);

static int parentPanel;

// -----------------------------------------------------------------
void ServiceLauncher(int parentpnl, char *sname, pluginDefine *pd, char *modDescr) {
 int ch, nchan;
 pluginADC pADC; // , *listADC;
 pluginDAC pDAC;
 pluginDIO pDIO;
 int j;
 char tmp[1024];  // ??? tmp
 TCONTEXT tc;

 parentPanel= parentpnl;
 fillTContext(&tc, NULL, modDescr, getTE01Handle());
 
 strcpy(servicename, sname);
 strcpy(moduleDescr, modDescr);
 theSD= serviceCore(servicename);
 thePD= pd;
 
 if(theSD == NULL) {
    MessagePopup(MSG_WARNING, "The specified service name is not valid");
    return; 
 };
 
 if(pd->adc_descr == NULL &&
    pd->dac_descr == NULL &&
    pd->dio_descr == NULL) {
    MessagePopup(MSG_WARNING, "The plugin has no any h/w descriptor function");
    return;
 };
 
 if(pd->start == NULL ||
    pd->stop == NULL) {
    MessagePopup(MSG_WARNING, "The plugin has no start or stop function");
    return;
 }; 
 
 Pnl= LoadPanel(0, "serviceuir.uir", BRIDGE);
 SetCtrlVal(Pnl, P(text), theSD->descr);
 
 // !!! tmp !!! 
 if(pd->adc_descr != NULL) {
    memset(&pADC, 0x0, sizeof(pluginADC));
    pd->adc_descr(&tc, &pADC, 0);
    nchan= pADC.nchan;
    
    listADC= (pluginADC *)malloc(sizeof(pluginADC)*nchan);  // !!! tnp --> check for the error
    memset(listADC, 0x0, sizeof(pluginADC)*nchan);
    
    for(j= 0; j< nchan; j++) {  // !!! TMP --->   nchan != 0
        memset(&pADC, 0x0, sizeof(pluginADC));
        pd->adc_descr(&tc, &pADC, j);    
        
        memcpy(&listADC[j], &pADC, sizeof(pluginADC));
        
        // !!! tmp ---> check for compatibility
        //sprintf(tmp, "Ch%d: %.3lf...%3.lf %s : %.3e Hz", pADC.channel, pADC.minU, pADC.maxU, pADC.unit, pADC.fs);
		InsertListItem (Pnl, P(list), -1, pADC.comment, pADC.unit);  // !!! tmp ????   NULL
    };
    
    //sd->open((void *)listADC);
 };
 
 
 InstallPopup(Pnl);
 
 slf_ok (Pnl, BRIDGE_ok, EVENT_COMMIT, NULL, 0, 0);
 
 slf_start (NavPnl, NAV_start, EVENT_COMMIT, NULL, 0, 0);
};

// *******************************************************************************

int CVICALLBACK slf_cancel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
			free(listADC);   // !!! tmp -->    ADC !!!!!!!!!!!!!!!!!!!!!!!!!!! 
			listADC= NULL;    // !!! tmp -->    ADC !!!!!!!!!!!!!!!!!!!!!!!!!!! 
			
			DiscardPanel(Pnl);
			break;
	}
	return 0;
}

// ---------------------------------------------------------------------------------
//#define CHANSTRLEN (COMMENTLEN+1)
// ---------------------------------------------------------------------------------
/*
static int allocateServiceStruc(int n, char ***X) {
 int j;
 
 if((*X= (char **)malloc(sizeof(char *) * n)) == NULL) return 1;
 for(j= 0; j< n; j++) (*X)[j]= NULL;
 
 for(j= 0; j< n; j++) {
   if(((*X)[j]= (char *)malloc(sizeof(char) * CHANSTRLEN + 1)) == NULL) return 1;
   memset((*X)[j], 0x0, CHANSTRLEN + 1);
 };
 return 0;
};

static void freeServiceStruc(int n, char ***X) {
  int j;
  
  if(*X != NULL) {
    for(j= 0; j< n; j++) {
      if((*X)[j] != NULL) free((*X)[j]);
      (*X)[j]= NULL;
    };
    free(*X);
  };
};
*/

static int closeServicePanelCBF(char *name) {
  int j, n;
  char tmp[512];
  
  if(NavPnl == -1) return 0;
  GetNumListItems (NavPnl, N(list), &n);
  for(j= 0; j<n; ) {
	  GetLabelFromIndex (NavPnl, N(list), j, tmp);
      if(!stricmp(tmp, name)) {
		  DeleteListItem (NavPnl, N(list), j, 1);
		  GetNumListItems (NavPnl, N(list), &n);
		  j= 0;
      }
      else
        j++;
  };
  GetNumListItems (NavPnl, N(list), &n);
  if(n) return 0;
  
  //DiscardPanel(NavPnl);
  //NavPnl= -1;
  slf_closenav (-1, -1, EVENT_COMMIT, NULL, 0, 0);

  return 0;
};

int CVICALLBACK slf_ok (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int   n, k;
//char **X= NULL, **Unit= NULL;
serviceStrucOpen S;
int   j;
char tmp[512], name[512];

	switch (event) {
		case EVENT_COMMIT:
		    EnaDisBarMenuVsStart(0);
		
			GetNumListItems (Pnl, P(list), &n);
			memset(&S, 0x0, sizeof(serviceStrucOpen));
			strcpy(S.spath, "");  // !!! tmp
			S.nAdc= n;	    // !!! tmp -->    ADC !!!!!!!!!!!!!!!!!!!!!!!!!!!      
			S.adc= listADC;  // !!! tmp -->    ADC !!!!!!!!!!!!!!!!!!!!!!!!!!! 
			S.closeCBF= closeServicePanelCBF;
			theSD->open(&S);

			free(listADC);   // !!! tmp -->    ADC !!!!!!!!!!!!!!!!!!!!!!!!!!! 
			listADC= NULL;    // !!! tmp -->    ADC !!!!!!!!!!!!!!!!!!!!!!!!!!! 
			DiscardPanel(Pnl);
			
		    k= theSD->num();
		    
		    if(NavPnl == -1) {
		       NavPnl= LoadPanel(parentPanel, "serviceuir.uir", NAV);
		       DisplayPanel(NavPnl);
		    };
		    
		    GetNumListItems (NavPnl, N(list), &n);
		    for(j= 0; j< n; ) {
		        GetValueFromIndex(NavPnl, N(list), j, tmp);
		        if(!stricmp(tmp, servicename)) {
		           DeleteListItem(NavPnl, N(list), j, 1);
		           GetNumListItems (NavPnl, N(list), &n);
		           j= 0;
		        }
		        else 
		         j++;
		    };
		    
		    for(j= 0; j< k; j++) {
	          theSD->getname(j, name);
			  InsertListItem (NavPnl, N(list), -1, name, servicename);
		    };
			break;
	}
	return 0;
}

// ********************************************************************************************
int CVICALLBACK slf_nav (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int ind;
char sname[512], name[512];
serviceDefine *sd;
	switch (event) {
		case EVENT_VAL_CHANGED: 
		case EVENT_LEFT_DOUBLE_CLICK:
			GetCtrlIndex (NavPnl, N(list), &ind);
			GetLabelFromIndex (NavPnl, N(list), ind, name);
			GetValueFromIndex (NavPnl, N(list), ind, sname);
			sd= serviceCore(sname);
			if(sd->bring2front == NULL) break;
			sd->bring2front(name);
			break;
	}
	return 0;
}

int CVICALLBACK slf_closenav (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int n, j;
char sname[512];
serviceDefine *sd;
int a;
	switch (event) {
		case EVENT_COMMIT:
		
		    GetCtrlAttribute(NavPnl, N(stop), ATTR_DIMMED, &a);
		    if(!a) 
		       slf_stop (-1, -1, EVENT_COMMIT, NULL, 0, 0);

            GetNumListItems (NavPnl, N(list), &n);		
            for(j= 0; j< n; j++) {  // !!! tmp --      
			   GetValueFromIndex (NavPnl, N(list), j, sname);
			   sd= serviceCore(sname);
			   sd->close();
            };
		    DiscardPanel(NavPnl);
			NavPnl= -1;
			
			EnaDisBarMenuVsStart(1);
			break;
	}
	return 0;
}

// *********************************************************************************************************
// *********************************************************************************************************
static int dataUpdateCBF(int nchan, serviceStrucData *X, char *info) {
 int n, j, i;
 char sname[512], tmp[512];
 serviceDefine *sd;
 int  *mark, markID= 1;
 
 GetNumListItems (NavPnl, N(list), &n);		
 if(!n) return 0;
 
 mark= (int *)malloc(sizeof(int) * n);  // !!! tmp --->   NULL
 memset(mark, 0, sizeof(int) * n);

 //      ,  ,     ,
 //      
 //
 for(j= 0; j< n; j++) { 
     GetValueFromIndex (NavPnl, N(list), j, sname);
     if(mark[j]) continue;   //   
     mark[j]= markID;
     for(i= j+1; i< n; i++) {
         GetValueFromIndex (NavPnl, N(list), i, tmp);
         if(!stricmp(sname, tmp)) mark[i]= markID;  //   
     };
     markID++;
 };
 
 for(j= 0; j< n; j++) { 
     if(!mark[j]) continue;  //   
     GetValueFromIndex (NavPnl, N(list), j, sname);
     sd= serviceCore(sname);
     sd->update(nchan, X, info);
     //      
     for(i= j+1; i< n; i++) {  
         if(mark[i] == mark[j]) 
             mark[i]= 0;
     };
     mark[j]= 0;
 };
 
 free(mark);
 return 0;
}

// *********************************************************************************************************
// *********************************************************************************************************
extern int  activateWaitPnl(int p);
extern void deactivateWaitPnl(int p);

//-----------------------------------------------------------------------------
// callback       
//       
//-----------------------------------------------------------------------------
static int serviceCBFunction(unsigned int id, char *msg) 
{
 ProcessSystemEvents();
 //
 if((id&MIDCER__MASK)==MIDCER_STOP_ERROR && msg!=NULL) {
	char str[1024];
    sprintf(str, "%s (%s)", MSG_ERROR, moduleDescr);
  	MessagePopup(str, msg);
 }	
 //
 return 0;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
int CVICALLBACK slf_start (int panel, int control, int event, void *callbackData, int eventData1, int eventData2) 
{
 TCONTEXT tc;
 plugStartStruc X;
 int q, p;
	switch (event) {
		case EVENT_COMMIT:
		    GetCtrlAttribute(panel, control, ATTR_DIMMED, &q);
		    if(q) break;
		    
		    GetCtrlVal(NavPnl, N(data), &q);
		    fillTContext(&tc, serviceCBFunction, moduleDescr, getTE01Handle());
		    memset(&X, 0x0, sizeof(plugStartStruc));
		    X.coreCBF= dataUpdateCBF;
		    X.dataMode= q;
		    p= activateWaitPnl(NavPnl);
		    if(!thePD->start(&tc, (void *)&X)) {
		    	SetCtrlAttribute(NavPnl, N(start), ATTR_DIMMED, 1);
		   	    SetCtrlAttribute(NavPnl, N(data), ATTR_DIMMED, 1);
		        SetCtrlAttribute(NavPnl, N(stop), ATTR_DIMMED, 0);		    
		    }
			// MessagePopup(MSG_ERROR, "Failed start module");
		    deactivateWaitPnl(p);
			break;
	}
 return 0;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
int CVICALLBACK slf_stop (int panel, int control, int event, void *callbackData, int eventData1, int eventData2) 
{
 TCONTEXT tc;	
 int p;
	switch (event) {
		case EVENT_COMMIT:
		    p= activateWaitPnl(NavPnl);
		    SetCtrlAttribute(NavPnl, N(start), ATTR_DIMMED, 0);
		    SetCtrlAttribute(NavPnl, N(data), ATTR_DIMMED, 0);
		    SetCtrlAttribute(NavPnl, N(stop), ATTR_DIMMED, 1);		
		    fillTContext(&tc, serviceCBFunction, moduleDescr, getTE01Handle());
		    if(!thePD->stop(&tc, NULL)) {
		    }   
		    //MessagePopup(MSG_WARNING, "Failed stop module");
		    deactivateWaitPnl(p); 
			break;
	}
	return 0;
}
