#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\services\\common\\include\\servicedef.h"
#include <analysis.h>
#include <utility.h>
#include <ansi_c.h>
#include <userint.h>
#include "srvuir.h"
#include "uts\\services\\common\\include\\utsmath.h"

#define NPOINTMAX  1024
#define P(x)       PANEL_##x
#define SNAME      "Digital IO"

#define FFTSIZEMAX 16384
// ------------------------------------------------------------------------------------------------
static int         Pnl= -1;
// ------------------------------------------------------------------------------------------------
#define FUNCID_NO        0
#define FUNCID_MEAN      1   //  
#define FUNCID_STDDEV    2   // 
#define FUNCID_RMS       3   // 
#define FUNCID_WIDTH     4   //  - 
#define FUNCID_MIN       5   // min  
#define FUNCID_MAX       6   // max  
#define FUNCID_INSTVAL   7   //     
#define FUNCID_DC        8
#define FUNCID_DCUTS     9
#define FUNCID_RMSUTS    10
#define FUNCID_MIDDLE    11
#define FUNCID_AMPL      12
#define FUNCID_RMSAMPL   13
#define FUNCID_RMSFORMFACT 14
#define FUNCID_PERIOD      15
#define FUNCID_FREQ        16

#define FUNCID_DUMMY
// ------------------------------------------------------------------------------------------------
typedef struct { 
  char *name;
  int   fid;
} listFunc;
// ------------------------------------------------------------------------------------------------
static listFunc functionList[]= {
 {"Dummy",       FUNCID_DUMMY    },
/* {"StdDev",      FUNCID_STDDEV  },
 {"Inst.Val.",   FUNCID_INSTVAL }, 
 
 {"\033m-",      FUNCID_NO},
 
 {"AC (Rms)",    FUNCID_RMS     },
 {"Rms Ampl",    FUNCID_RMSAMPL     }, 
 {"DC",          FUNCID_DC      }, 

 {"\033m-",      FUNCID_NO},
 
 {"Min",         FUNCID_MIN     },
 {"Max",         FUNCID_MAX     }, 
 {"Pik-Pik",     FUNCID_WIDTH   },
 {"Middle",      FUNCID_MIDDLE   },
 {"Amplitude",   FUNCID_AMPL   },
 
 {"\033m-",      FUNCID_NO},

 {"Frequency, Hz",        FUNCID_FREQ   },
 {"Period, ms",           FUNCID_PERIOD   },    
 {"Form Factor, a.u.",    FUNCID_RMSFORMFACT   }, // ,  -  

// {"Rms:UTS",       FUNCID_RMSUTS     },
// {"DC:UTS",        FUNCID_DCUTS      },  */
 {NULL, 0}	  
};
// ------------------------------------------------------------------------------------------------
static void fillList(void) 
{
  /*listFunc *p= &functionList[0];
  while(p->name!=NULL) {
    InsertListItem(Pnl, P(list), -1, p->name, p->fid);
    p++;
  };
  SetCtrlIndex(Pnl, P(list), 0);   */
};
// ------------------------------------------------------------------------------------------------
typedef struct {
  int n;   //   ,  
  
  int  value;
  //int  unit;
  int  descr;
  //int  gr_value[4];
  //int  code;
  //int  point;
} uirControl;

int GrValueControl[4];
// ------------------------------------------------------------------------------------------------
static uirControl *theControl;
// ------------------------------------------------------------------------------------------------

static void discardUIR(void);


//   ()

static int createUIR(int n, pluginDIO *p) {
 int j, top, left, h, w, wd, offset, grp_cntr=0, top_top=0, top_ramka, top_gr;
 char tmp[512];
 const int d=70; //    
 int gr_cntr=0;
 
 if((theControl= (uirControl *)malloc(sizeof(uirControl)*n)) == NULL) return 1;
 memset(theControl, 0x0, sizeof(uirControl)*n);
 for(j= 0; j< n; j++) theControl[j].n= n;
 
 //SetCtrlAttribute(Pnl, P(value) , ATTR_MAX_VALUE, 1);  
 GetCtrlBoundingRect (Pnl, P(value), &top, 0, &h, &w);
 GetCtrlBoundingRect (Pnl, P(descr), 0, 0, 0, &wd);   
 
 offset=0;
 top_top=top; //     
 
 for(j= 0; j< n; j++) 
  {
	 if(!(j%8))
	 {
	  offset=grp_cntr*(w+wd+d); //       
	 
	  top=top_top;
	  GetCtrlBoundingRect (Pnl, P(ramka), &top_ramka, &left, 0, 0);   
	  DuplicateCtrl (Pnl, P(ramka), Pnl, 0, top_ramka, left+offset);
	  
	 GetCtrlBoundingRect (Pnl, P(gr_value), &top_gr, &left, 0, 0);
	 GrValueControl[grp_cntr]=DuplicateCtrl (Pnl, P(gr_value), Pnl, "Hex:", top_gr, left+offset);
	   
	  grp_cntr++; 
	  
	 } 
	  
  
     GetCtrlBoundingRect (Pnl, P(value), 0, &left, 0, 0);
	 theControl[j].value= DuplicateCtrl (Pnl, P(value), Pnl, 0, top, left+offset);
	 
	 GetCtrlBoundingRect (Pnl, P(descr), 0, &left, 0, 0);
	 theControl[j].descr= DuplicateCtrl (Pnl, P(descr), Pnl, "", top, left+offset);
	 
	 top+= (h+5);
	 
	 
	  
 };
 
  SetCtrlAttribute(Pnl, P(gr_value) , ATTR_VISIBLE, 0);   
 
 for(j= 0; j< n; j++) 
    {
    if(theControl[j].value <= 0 ||theControl[j].descr <= 0) {
         discardUIR();
         return 1;
    };
    
   
    SetCtrlAttribute(Pnl, theControl[j].value , ATTR_VISIBLE, 1);
    if(p[j].type==2)
      {
        SetCtrlAttribute(Pnl, theControl[j].value , ATTR_CTRL_MODE, VAL_NORMAL);
        //SetCtrlAttribute(Pnl, theControl[j].value , ATTR_MAX_VALUE, 1); 
      } 
    else
      SetCtrlAttribute(Pnl, theControl[j].value , ATTR_CTRL_MODE, VAL_INDICATOR);
      
     
    SetCtrlAttribute(Pnl, theControl[j].descr , ATTR_VISIBLE, 1);
    SetCtrlVal(Pnl, theControl[j].descr, p[j].comment);
    sprintf(tmp, "%02d", j+1);
	SetCtrlAttribute (Pnl, theControl[j].value, ATTR_LABEL_TEXT, tmp);

 };
 return 0;
};
// ------------------------------------------------------------------------------------------------
static void discardUIR(void) {
  int j, n;
  
  n= theControl[0].n;
  for(j= 0; j< n; j++) {
      if(theControl[j].value > 0) DiscardCtrl(Pnl, theControl[j].value);
      
      //if(theControl[j].gr_value > 0) DiscardCtrl(Pnl, theControl[j].value);
      //if(theControl[j].unit > 0) DiscardCtrl(Pnl, theControl[j].unit);
      if(theControl[j].descr > 0) DiscardCtrl(Pnl, theControl[j].descr);
      //if(theControl[j].code > 0) DiscardCtrl(Pnl, theControl[j].code);
      //if(theControl[j].point > 0) DiscardCtrl(Pnl, theControl[j].point);
  };
  free(theControl);
};

// *************************************************************************************************
int numUTService(void) { return 1; };

// *************************************************************************************************
int nameUTService(int num, char *name) { strcpy(name, SNAME); return 0; };
// *************************************************************************************************
int bring2frontUTService(char *name) { SetActivePanel(Pnl); return 0; };
// *************************************************************************************************
static int (*closeCBF)(char *name)= NULL;
// -------------------------------------------------------------------------------------------------
int  openUTService(serviceStrucOpen *X) {
 int j, ind, q;
 char tmp[512];
 int t, l;
 
 if(Pnl > 0) {
    MessagePopup("DIO service: WARNING", "Supposed only one instance of the service");
    return 0; // 
 };

 closeCBF= X->closeCBF;
 Pnl= LoadPanelEx (0, "services\\DIO\\srvuir.uir", PANEL, __CVIUserHInst);  // !!! path - tmp !!!
 fillList();
 if(createUIR(X->nDIO, X->dio)) {
    DiscardPanel(Pnl);
    Pnl= -1;
    
    MessagePopup("DIO service: ERROR", "Failed allocate memory for channels");
    return 1;
 };
/* 
 SetCtrlAttribute (Pnl, P(n), ATTR_MAX_VALUE, FFTSIZEMAX);  */
 DisplayPanel(Pnl);
 return 0;
};
// *************************************************************************************************
int  reopenUTService(serviceStrucOpen *X) { return 0; };
// *************************************************************************************************
void closeUTService(void) {   // !!! ??? tmp  P(list) 
  if(Pnl > 0) {
     discardUIR();
     DiscardPanel(Pnl); 
  };
  Pnl= -1; 
};
// *************************************************************************************************
// 
// !!! tmp --> ,   ,      
//      !!!!!!!!!!!!!!! tmp !!!!!!!!!!
// 
static double YOut[FFTSIZEMAX/2], darrtmp[FFTSIZEMAX];
// -------------------------------------------------------------------
int  updateUTService(int nchan, serviceStrucData X[], char *info) 
{
 int ch, led, flag= 0, q, jj;
 serviceStrucData *y;
 uirControl *c;
 int   fid;
 double value, d, max, min, ac, dc;
 int gr_value=0;
 int imax, imin, np;
 WindowConst wc;
 double df;
 int CtrlAttr;
 int input_val;
 int gr_cntr=0;
 int sec_mark_cntr=0;
 
 
 // if(info!=NULL) InsertTextBoxLine(Pnl, P(info), -1, info);  // !!! tmp
 
 //     DIO, mlv
 /*GetCtrlVal(Pnl, P(list), &fid);  */
 
 
 q= 0;
 
/* if(X[0].fs)
 {
   
   GetCtrlVal (Pnl, PANEL_sec_mark, &sec_mark_cntr);
   sec_mark_cntr++; */ 
   SetCtrlVal (Pnl, PANEL_sec_mark, (unsigned int) X[0].fs);
   
   //}

 for(ch= 0; ch< nchan; ch++)
  {
     y= &X[ch];
     c= &theControl[ch];
     
     
     if(y->iarray != NULL /*&& np*/)
     {
        
        //if(np > 1) Mean(y->iarray, np, &value);   // ??? tmp
 /*else*/ 
         GetCtrlAttribute(Pnl, c->value, ATTR_CTRL_MODE, &CtrlAttr);
         if(CtrlAttr!=VAL_INDICATOR)			  //   ,     .,    
           {
           
            
            GetCtrlVal(Pnl, c->value, &input_val);
            y->iarray[0]= (double) input_val;
            
            gr_value|=((int) input_val)<<ch; 
            
        if((!((ch+1)%8)&&(ch!=0)))
        {
            SetCtrlVal(Pnl, GrValueControl[gr_cntr], (BYTE) (gr_value>>(ch-7)));
            //gr_value=0;
            gr_cntr++;
            
            if(gr_cntr==4)
             gr_cntr=0;
        }   
        
            
           }
         else
         
         {
         value= y->iarray[0];
       
         
         SetCtrlVal(Pnl, c->value, (int) value);
       
        
        //flag= 1;
        
        SetCtrlAttribute(Pnl, c->value, ATTR_DIMMED, 0);
        
        //gr_value<<=1;
        gr_value|=((int) value)<<ch;
        
        
        if((!((ch+1)%8)&&(ch!=0)))
        {
            SetCtrlVal(Pnl, GrValueControl[gr_cntr], (BYTE) (gr_value>>(ch-7)));
            //gr_value=0;
            gr_cntr++;
            
            if(gr_cntr==4)
             gr_cntr=0;
        }   
        
       
        
        
        //y->iarray[0]=(double) 2;
         }
      }
      
      flag= 1; 
     }  //  for

 if(flag) 
  {
    GetCtrlVal(Pnl, P(led), &led);		// ??? !!! tmp --> here ?
    SetCtrlVal(Pnl, P(led), !led);
  }
 else {};
 
 return 0;
};

// ************************************************************************************************
// 
// ************************************************************************************************
int CVICALLBACK mf_close (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
		
			Sleep(500);
		    discardUIR();
			DiscardPanel(Pnl);
			Pnl= -1;
			if(closeCBF == NULL) break;
		    closeCBF(SNAME);
			break;
	}
	return 0;
}

#define HLPMSG \
"Displays code/physical value of all channels\n\n\
"

int CVICALLBACK mf_help (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
			MessagePopup("Multimeter HELP", HLPMSG);
			break;
	}
	return 0;
}

int CVICALLBACK mf_list (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:

			break;
	}
	return 0;
}

int CVICALLBACK mf_precision (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) 
{
int v, j;
	switch (event) 
	{
		case EVENT_COMMIT:
		/*	GetCtrlVal(Pnl, P(precision), &v);
			for(j= 0; j< theControl[0].n; j++) 
			  SetCtrlAttribute(Pnl, theControl[j].value, ATTR_PRECISION, v);
			break;  */
			;
	}
	return 0;
}
