#ifndef __UTS_SERVICEDEF__H
#define __UTS_SERVICEDEF__H

#include <windows.h>
#include "uts\\common\\include\\commondef.h"
#include "uts\\systems\\common\\include\\plugindef.h"

#pragma pack(1)

typedef int  (*service_FPtr_closecb)(char *name);

typedef struct {
  char spath[FNAMELEN+1];
  //int  n;
  //char **channel;
  //char **unit;
  
  int nAdc;
  int nDac;  
  int nDIO;
  
  pluginADC *adc;
  pluginDAC *dac;
  pluginDIO *dio;  
  
  service_FPtr_closecb closeCBF;
} serviceStrucOpen;


typedef struct {
  int     point;
  double *iarray;
  double *darray;
  double  fs;
} serviceStrucData;


typedef int (*dataUpdateCBF_FPtr)(int nchan, serviceStrucData *X, char *info);

// --------------------------------------------------------
typedef int  (*service_FPtr_open)(serviceStrucOpen *);
typedef int  (*service_FPtr_update)(int n, serviceStrucData *chdata, char *dbginfo);
typedef void (*service_FPtr_close)(void);
typedef int  (*service_FPtr_num)(void);
typedef int  (*service_FPtr_bring)(char *name);
typedef int  (*service_FPtr_name)(int num, char *name);

typedef struct {
  char *name;
  char *version;
  char *descr;
  int   type;

  service_FPtr_open   open;
  service_FPtr_open   reopen;
  service_FPtr_close  close;
  service_FPtr_update update;
  service_FPtr_num    num;
  service_FPtr_name   getname;
  service_FPtr_bring  bring2front;
} serviceDefine;

typedef serviceDefine * __stdcall (*getUTServiceInfo_Ptr)(void);

typedef struct {
  HINSTANCE   h;
  int         id;
  int         type;
  getUTServiceInfo_Ptr service;
} serviceManager; 

void closeUTServiceDLL(serviceManager *p);
int  openUTServiceDLL(serviceManager *p, char *srcpath);

#define PSERVNAME(x)  x
#define PSERVER(x)    x 
#define PSERVDESCR(x) x
#define PSERVTYPE(x)  x

#define FSERVOPEN(x)    x
#define FSERVREOPEN(x)  x
#define FSERVCLOSE(x)   x
#define FSERVUPDATE(x)  x
#define FSERVNUM(x)     x

#pragma pack()

#endif
