#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\services\\common\\include\\servicedef.h"
#include <analysis.h>
#include <utility.h>
#include <ansi_c.h>
#include <userint.h>
#include "srvuir.h"

#define MAXIDNUM 16

#define HISTSIZEMAX (21+1)

#define P(x) PANEL_##x

static int     ipnl[MAXIDNUM], Pnl= -1;
static double  hmin[MAXIDNUM], hmax[MAXIDNUM], hdev[MAXIDNUM];
static int     isfirst[MAXIDNUM], resetFLAG[MAXIDNUM];

static int findFreeId(void) {
 int j;
 for(j= 0; j< MAXIDNUM; j++) if(ipnl[j] <= 0) return j;
 return -1;
};

int  numUTService(void) {
 int j;
 int q= 0;
 
 for(j= 0; j<MAXIDNUM; j++) if(ipnl[j] > 0) q++;
 
 return q;
};

int nameUTService(int num, char *name) {
 int j, q= 0;
 
 for(j= 0; j<MAXIDNUM; j++) {
     if(ipnl[j] <= 0) continue;
     if(q == num) {
	    GetPanelAttribute (ipnl[j], ATTR_TITLE, name);
	    return 0;
     };
     q++;
 };
 return 1;
};

int bring2frontUTService(char *name) {
 int j;
 char tmp[512];
 for(j= 0; j<MAXIDNUM; j++) {
     if(ipnl[j] <= 0) continue;
	 GetPanelAttribute (ipnl[j], ATTR_TITLE, tmp);
	 if(!stricmp(name, tmp)) {
	    SetActivePanel(ipnl[j]);
	    return 0;
	 };
 };
 return 1;
};

static int (*closeCBF)(char *name)= NULL;

int  openUTService(serviceStrucOpen *X) {
 int j, ind, q;
 char tmp[512];
 int t, l;
 
 closeCBF= X->closeCBF;
 
 if(Pnl == -1) {
    for(j= 0; j< MAXIDNUM; j++) {
       ipnl[j]= -1;
    };
	Pnl = LoadPanelEx (0, "services\\hystogram\\srvuir.uir", PANEL, __CVIUserHInst);  // !!! path - tmp !!!
 };
 
 for(q= 0, j= 0; j<MAXIDNUM; j++) if(ipnl[j] > 0) q++;
 if(q == X->nAdc) {
    MessagePopup("Hystogram service: WARNING", "All channels are visualized already");
    return 0;  // !!! tmp
 };
 
 if((ind= findFreeId()) < 0) return -1;

 sprintf(tmp, "Hystogram (%d)", ind+1);
 if((ipnl[ind] = DuplicatePanel (0, Pnl, tmp, VAL_KEEP_SAME_POSITION, VAL_KEEP_SAME_POSITION)) <= 0) return -1;
 GetPanelAttribute (ipnl[ind], ATTR_TOP, &t);
 GetPanelAttribute (ipnl[ind], ATTR_LEFT, &l);
 SetPanelPos (ipnl[ind], t + ind * 20, l);
 
 

 for(j= 0; j< X->nAdc; j++) {
     sprintf(tmp, "%d", j+1);
     InsertListItem (ipnl[ind], P(list), -1, tmp, X->adc[j].comment); 
 };
 
 q= ind % X->nAdc;
 SetCtrlIndex(ipnl[ind], P(list), q);
 SetCtrlVal(ipnl[ind], P(text), X->adc[q].comment);
 
 
 SetCtrlAttribute (ipnl[ind], P(intervals), ATTR_MIN_VALUE, 2);
 SetCtrlAttribute (ipnl[ind], P(intervals), ATTR_MAX_VALUE, HISTSIZEMAX-1);
 SetCtrlVal(ipnl[ind], P(color), VAL_RED);    

 hmin[ind]= 0.0; 
 hmax[ind]= 0.0;
 hdev[ind]= 0.0;
 isfirst[ind]= 1;
 resetFLAG[ind]= 1;
 
 DisplayPanel(ipnl[ind]);
 return ind;
};

int  reopenUTService(serviceStrucOpen *X) {
 return 0;
};

// NULL at the input : close all !
void closeUTService(void) {
 int j;
 if(Pnl!=-1) DiscardPanel(Pnl);
 Pnl= -1;
 for(j= 0; j<MAXIDNUM; j++) if(ipnl[j] > 0 ) { DiscardPanel(ipnl[j]); ipnl[j]= -1; };

};

static void ShowHystogramm(int n, double *x,  int xPnl, int pnlind);

int  updateUTService(int nchan, serviceStrucData *X, char *info) {
 int i, ind;
 
 for(i= 0; i<MAXIDNUM; i++) {
     if(ipnl[i] <= 0) continue;			   
	 GetCtrlIndex (ipnl[i], P(list), &ind);

     if(X[ind].iarray!= NULL) ShowHystogramm(X[ind].point, X[ind].iarray,  ipnl[i], i);
     
     //if(info!=NULL) InsertTextBoxLine(ipnl[i], P(info), -1, info);  // !!! tmp
     
     // printf("ind_%d i_%d : point= %d (pnl_%d)\n", ind, i, X[ind].point, ipnl[i]);
 };
 return 0;
};

int CVICALLBACK mf_close (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j;
char name[512];

	switch (event) {
		case EVENT_COMMIT:
		    for(j= 0; j<MAXIDNUM; j++) {
		       if(panel != ipnl[j]) continue;
		       break;
		    };
		       
		    ipnl[j]= -1;
		    GetPanelAttribute (panel, ATTR_TITLE, name);
			DiscardPanel(panel);
			if(closeCBF == NULL) break;
		    closeCBF(name);
			break;
	}
	return 0;
}

int CVICALLBACK mf_list (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int i;
char tmp[FNAMELEN+1];
	switch (event) {
		case EVENT_COMMIT:
		//case EVENT_VAL_CHANGED:
            GetCtrlIndex(panel, P(list), &i);
			GetValueFromIndex (panel, P(list), i, tmp);
            SetCtrlVal(panel, P(text), tmp);
            
            mf_reset (panel, P(reset), EVENT_COMMIT, NULL, 0, 0);
       break;

	}
	return 0;
}

// *****************************************************************************************

static void ShowHystogramm(int n, double *y,  int xPnl, int ind) {
 int     intervals;
 int     hist[HISTSIZEMAX];
 double  histNorm[HISTSIZEMAX];
 double  axis[HISTSIZEMAX], modeValue, max, min, mean, dev;
 int     imax, imin;
 int     j, isinfo, color;
 char    tmp[512];
 int     led, use, ause;
 double  xmin, xmax, w;
 
    if( n < 2) return;  // ??? !!! tmp
    if( n > 1024) n= 1024;  // ??? !!! tmp
    
    GetCtrlVal(xPnl, P(led), &led);
    SetCtrlVal(xPnl, P(led), !led);
    
    GetCtrlVal(xPnl, P(intervals), &intervals);
    GetCtrlVal(xPnl, P(isinfo), &isinfo);
    GetCtrlVal(xPnl, P(color), &color);    
    
    StdDev (y, n, &mean, &dev);
    MaxMin1D (y, n, &max, &imax, &min, &imin);
    Mode(y, n, min-1, max+1, intervals, &modeValue);
    Histogram (y, n, min-1, max+1, hist, axis, intervals);    

	SetCtrlVal(xPnl, P(min),  min);
	SetCtrlVal(xPnl, P(max),  max);
	SetCtrlVal(xPnl, P(mean), mean);
	SetCtrlVal(xPnl, P(dev),  dev);
	
	SetCtrlVal(xPnl, P(w),  max - min + 1);
	
	if(resetFLAG[ind]) {   //  , .. thread plugin-   ;-)
	   resetFLAG[ind]= 0;
	   isfirst[ind]= 1;
	};
	
	if(isfirst[ind]) {
	   isfirst[ind]= 0;
	   hmin[ind]= min;
	   hmax[ind]= max;
	   hdev[ind]= dev;
	   SetCtrlAttribute(xPnl, P(use), ATTR_DIMMED, 0);
	   SetCtrlAttribute(xPnl, P(reset), ATTR_DIMMED, 0);
	}
	else {
	  if(min < hmin[ind]) hmin[ind]= min;
	  if(max > hmax[ind]) hmax[ind]= max;
	  if(dev > hdev[ind]) hdev[ind]= dev;
	  
	  SetCtrlVal(xPnl, P(hmin), hmin[ind]);
	  SetCtrlVal(xPnl, P(hmax), hmax[ind]);
	  SetCtrlVal(xPnl, P(hdev), hdev[ind]);
	  
	  SetCtrlVal(xPnl, P(hw),  hmax[ind] - hmin[ind] + 1);
	};
	
	SetCtrlVal(xPnl, P(modeValue),  modeValue);
	
	for(j= 0; j< intervals; j++) histNorm[j]= (double)hist[j] / n;

    use= 0;
    xmin= min;
    xmax= max;
    
    GetCtrlAttribute(xPnl, P(use), ATTR_DIMMED, &ause);
    if(!ause) {
       GetCtrlVal(xPnl, P(use), &use);
       if(use) {
          xmin= hmin[ind];
          xmax= hmax[ind];
       };
    };
    
    if(!use) {
       GetCtrlVal(xPnl, P(w),  &w);
    }
    else {
       GetCtrlVal(xPnl, P(hw),  &w);
    };
    
	SetCtrlAttribute (xPnl, P(intervals), ATTR_TEXT_COLOR, intervals > w ? VAL_RED : VAL_BLACK);
    
	SetAxisRange (xPnl, P(graf), VAL_MANUAL, xmin-1, xmax+1, VAL_LOCK, 0, 1.0);
    DeleteGraphPlot(xPnl,  P(graf), -1, VAL_DELAYED_DRAW);
	PlotXY (xPnl, P(graf), axis, histNorm, intervals, VAL_DOUBLE, VAL_DOUBLE,
			VAL_VERTICAL_BAR, VAL_EMPTY_SQUARE, VAL_SOLID, 1, color);
	
	if(!isinfo) return;
	
	ResetTextBox(xPnl, P(info), "Centers at:\n");
	for(j= 0; j< intervals; j++) {
	    sprintf(tmp, "%02d: %-.3lf (%.3lf)", j + 1, axis[j], histNorm[j]);
		InsertTextBoxLine (xPnl, P(info), -1, tmp);
	};
};

#define HLPMSG \
"Control elements:\n\
   - WIDTH: regulates the bin width of the histogram\n\
   - CHANNEL selector: lets you select another device channel (description is to the right of the control)\n\
   - COLOR: defines histogram plot color\n\n\
Number of points is 2...1024"

int CVICALLBACK mf_help (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
			MessagePopup("Hystogrammer HELP", HLPMSG);
			break;
	}
	return 0;
}

int CVICALLBACK mf_reset (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int ind= -1, j;

	switch (event) {
		case EVENT_COMMIT:
		    for(j= 0; j< MAXIDNUM; j++) {
		        if(panel == ipnl[j]) {
		           ind= j;
		           break;
		        };
		    };
		    
		    if(ind == -1) break;
		    
            // isfirst[ind]= 1;
	        SetCtrlAttribute(panel, P(use), ATTR_DIMMED, 1);
	        SetCtrlAttribute(panel, P(reset), ATTR_DIMMED, 1);            
	        
	        //SetCtrlVal(panel, P(use), 0);
	        
	        resetFLAG[ind]= 1;
			break;
	}
	return 0;
}

