#ifndef __UTS_SYSTEMDEF__H
#define __UTS_SYSTEMDEF__H

#include <windows.h>

#pragma pack(1)

typedef struct moduleDefine moduleDefine;
struct moduleDefine {
  char          name[16];
  char          descr[128];
  int           context;  // slot, ... 
  int           rsv;
  moduleDefine *next;
};

typedef struct {
  char *name;
  char *version;
  char *descr;
} systemDescription;

typedef int (*sys_FPtr)(void);
typedef int (*sys_FPtr)(void);
typedef int (*sys_FPtr)(void);

typedef struct {
  systemDescription  info;
  sys_FPtr           config;
  sys_FPtr           open;
  sys_FPtr           close;  
  moduleDefine      *module;  
} systemDefine;


typedef systemDefine * __stdcall (*getUTFSystemInfo_Ptr)(void);
typedef void         * __stdcall (*getUTFSystemTContext_Ptr)(moduleDefine *mi);

typedef struct {
  HINSTANCE   h;
  int         id;
  int         type;
  getUTFSystemInfo_Ptr     system;  // ret :   systemDefine *
  getUTFSystemTContext_Ptr tcontext;  //     void *
} systemManager; 

#pragma pack()

#define PSYSNAME(x)    x
#define PSYSVERSION(x) x
#define PSYSDESCR(x)   x
#define PSYS_MODULEDEF_PTR(x) x

moduleDefine * systemAddModule(moduleDefine *list, moduleDefine module);
void systemFreeDefine(moduleDefine **p);

int  openUTFSystemDLL(systemManager *p, char *path);
void closeUTFSystemDLL(systemManager *p);

#endif

