#include "uts\\systems\\common\\include\\systemdef.h"
#include <utility.h>
#include <ansi_c.h>
#include "uts\\common\\include\\commondef.h"


static moduleDefine *newModule(moduleDefine module) {
 moduleDefine *newp;
 
 if((newp= (moduleDefine *)malloc(sizeof(moduleDefine))) == NULL) return NULL;
 memcpy(newp, &module, sizeof(moduleDefine));
 newp->next= NULL;
 return newp;
};

moduleDefine *systemAddModule(moduleDefine *list, moduleDefine module) {
 moduleDefine *p, *newp;
 
 if( (newp= newModule(module)) == NULL) return NULL;
 if(list == NULL) return newp;
 
 for(p= list; p->next!= NULL; p= p->next);
 p->next= newp;
 return list;
};

void systemFreeDefine(moduleDefine **list) {
  moduleDefine *next;
  
  for(; (*list)!= NULL; (*list)= next) {
    next= (*list)->next;
    free(*list);
  };
  *list= NULL;
  
};


// ----------------------------------------------------------------------------
void closeUTFSystemDLL(systemManager *p) {
 if(p->id >=0) UnloadExternalModule(p->id); 
 p->id= -2;
};

// ----------------------------------------------------------------------------
//       
//      
// ----------------------------------------------------------------------------
int  openUTFSystemDLL(systemManager *p, char *srcpath) {
 int  s, n;
 char cur_dir[FNAMELEN+1], dir[FNAMELEN+1], path[FNAMELEN+1], *sptr;
 systemDefine *d;
 
// SetDllDirectory(path); <- only WinXP & Win2003
 strcpy(dir, srcpath); 
 if((sptr=strrchr(dir, '\\'))==NULL) goto __bad_ret; 
 *sptr=0;
 GetCurrentDirectory(sizeof(cur_dir), cur_dir);
 SetCurrentDirectory(dir);

 memset(p, 0x0, sizeof(systemManager));
 p->id= -2;

 strcpy(path, srcpath); 
 if((sptr=strrchr(path, '.'))==NULL) goto __bad_ret; 
 *sptr=0;
 strcat(path, ".lib");
 
 //  
 if((p->id=LoadExternalModule(path)) < 0) goto __bad_ret; 
 //    
 p->system=(void *)GetExternalModuleAddr (p->id, "getUTFSystemDefine", &s);
 if(s || (p->system == NULL) ) goto __bad_ret; 
 p->tcontext= (void *)GetExternalModuleAddr (p->id, "getUTFSystemTContext", &s);
 if(s || (p->tcontext == NULL) ) goto __bad_ret; 

//   p->open= (void *)GetExternalModuleAddr (p->id, "openUTFSystem", &s);
//   if(s || (p->open == NULL) ) goto __bad_ret;
//   p->close= (void *)GetExternalModuleAddr (p->id, "closeUTFSystem", &s);
//   if(s || (p->close == NULL) ) goto __bad_ret;
 
 d= p->system();
 if((d->open == NULL) || (d->close == NULL)) goto __bad_ret;


 SetCurrentDirectory(cur_dir);
 return 0;
 
__bad_ret:
 SetCurrentDirectory(cur_dir);
 closeUTFSystemDLL(p);
 return 1;
};

