#include <ansi_c.h>
#include "systems\\common\\include\\systemdef.h"
#include "systems\\common\\include\\systemexport.h"

static systemDefine systemE440;

static systemDefine systemE440Pattern= {
 { PSYSNAME("E-440"), 
   PSYSVERSION("1.0"), 
   PSYSDESCR("Multifunctional E-440 board on USB")
 },

 PSYS_MODULEDEF_PTR(NULL) // will be allocated at-the-place
};

systemDescription * __stdcall getUTFSystemInfo(void) {
  return &(systemE440Pattern.info); 
};

// *********************************************************************
systemDefine * __stdcall openUTFSystem(void) {
  // moduleDefine *list= systemLTR.module;
  moduleDefine module;

  closeUTFSystem(&systemE440);
  memcpy(&systemE440, &systemE440Pattern, sizeof(systemDefine));
  
  memset(&module, 0x0, sizeof(moduleDefine));
  strcpy(module.name,  "E-440");
  strcpy(module.descr, "Module E-440");
  module.context= -1;
  if((systemE440.module= systemAddModule(systemE440.module, module)) == NULL) goto __bad_ret;
  
  return &systemE440;
  
__bad_ret:  
  closeUTFSystem(&systemE440);
  return NULL;
}

void         * __stdcall getUTFSystemTContext(moduleDefine *mi) {
  return NULL;
}

void           __stdcall closeUTFSystem(systemDefine *p) {
  systemFreeDefine(&(p->module));
  memset(p, 0x0, sizeof(systemDefine));
  
}


