#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "te01api.h"
#include "pluginuir.h"
#include "systems\\common\\include\\tfuncdef.h"
#include "localdefs.h"
#include "systems\\common\\include\\plugindef.h"
#include "systems\\ltr\\common\\include\\ltrspecific.h"
#include "services\\common\\include\\servicedef.h"

static int Pnl= -1;
static int TePnl= -1;
#define P(x)  PANEL_##x

void closeUIR(void) {
  if(Pnl!= -1)   { DiscardPanel(Pnl);   Pnl= -1;   };
  if(TePnl!= -1) { DiscardPanel(TePnl); TePnl= -1; };  
};

int utspLoadADSP(TCONTEXT *tc, void *p) {  return 0; };
int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };

#define MAX_VCHANNEL 2
#pragma pack(1)
typedef struct {
  int X;
} IniSet_common;

typedef struct {
  int  onoff;
  int  scale;
  int  channel;
} IniSet_vchan;

typedef struct {
  IniSet_common common;  
  IniSet_vchan  vchan[MAX_VCHANNEL];
} IniSet_XXX;
#pragma pack()

static IniSet_XXX IniSet;

static void fillINI(void) {  //   UIR- 
 int j;
 
 memset(&IniSet, 0x0, sizeof(IniSet_XXX));
 IniSet.common.X= 0;
 
 for(j= 0; j<MAX_VCHANNEL; j++) {
     IniSet.vchan[j].onoff= 0;
     IniSet.vchan[j].scale= 0;
     IniSet.vchan[j].channel= j%MAX_VCHANNEL;
 };
 IniSet.vchan[0].onoff= 1; 
};

#define INIFNAME "inifile.ini"
static char theDIR[FNAMELEN+1];
static void readINI(char *xdir) {
  FILE *f;
  char fname[FNAMELEN+1];
  strcpy(theDIR, xdir);
  fillINI();
  sprintf(fname, "%s\\%s", theDIR, INIFNAME);
  if((f= fopen(fname, "rb")) == NULL) return;
  fread (&IniSet, sizeof(IniSet_XXX), 1, f);
  fclose(f);
};

static void writeINI(void) {
  FILE *f;
  char fname[FNAMELEN+1];  
  sprintf(fname, "%s\\%s", theDIR, INIFNAME);
  if((f= fopen(fname, "wb")) == NULL) return;
  fwrite (&IniSet, sizeof(IniSet_XXX), 1, f);
  fclose(f);
};

// -------------------------------------------------------------------------------------
static void showINI(void) {
 char tmp[512];
 int  j;

 for(j= 0; j< MAX_VCHANNEL; j++) {
     sprintf(tmp, " %d", j+1);
 };
 
};
// -------------------------------------------------------------------------------------
int utspConfigDevice(TCONTEXT *tc, void *p) {
  char ppath[FNAMELEN+1];
  readINI(tc->dllpath);
  sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
  Pnl= LoadPanelEx (0, ppath, PANEL, __CVIUserHInst);  
  showINI();  
  InstallPopup(Pnl);
 return 0;
};

// ------------------------------------------------
static int numOfVChan(void) {
 int n= 0, j;
 for(j= 0; j< MAX_VCHANNEL; j++) if(IniSet.vchan[j].onoff) n++;
 return n;
};

int CVICALLBACK mf_apply (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
		    if(!numOfVChan()) {
		        MessagePopup(MSG_WARNING, "Invalid number of channels: 0");
		        break;
		    };		
		    
		    writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;		    
		break;
	}
	return 0;
}




int configHW(TCONTEXT *tc, void *X) {
 readINI(tc->dllpath);
 return 0;
};


// ***********************************************************************
static HANDLE hThread;
static int (*dataUpdateCBF)(int nchan, serviceStrucData X[], char *info)= NULL;
static UINT32 rd_buf[MAXNPOINTS * MAX_VCHANNEL];
static double rd_buf_double[MAXNPOINTS * MAX_VCHANNEL];
static double ibuf[MAX_VCHANNEL][MAXNPOINTS];
static double dbuf[MAX_VCHANNEL][MAXNPOINTS];
static serviceStrucData serviceDATA[MAX_VCHANNEL];

static int runFlag;
static int tpassed;

static void DataRecorder(void *par) {
 while(runFlag) { 
   Sleep(0);
 };

 ExitThread(0);
};

extern int testPlolog(TCONTEXT *tc);
extern void closeModule(void);

int utspStart(TCONTEXT *tc, void *p) {
  DWORD TmpDWord;
  plugStartStruc *X;
  X= (plugStartStruc *)p;
  if(testPlolog(tc)) return 1;  // !!! ??? tmp
  dataUpdateCBF= X->coreCBF; // (dataUpdateCBF_FPtr)p;
  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);
  ResumeThread(hThread);        // start thread here

 return 0;
};


int utspStop(TCONTEXT *tc, void *p) {
  int j;
  int c;

  runFlag= 0;
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);

  return 0;
};

// *******************************************************************************
static TE01 *theTE01;
static char thePATH[FNAMELEN+1];
// -------------------------------------------------------------
static int showWPanel(int ppnl, char *msg) {
  int p= LoadPanelEx(ppnl, thePATH, WP, __CVIUserHInst);  
  InstallPopup(p);
  return p;
};
// -------------------------------------------------------------
static void hideWPanel(int p) {
 DiscardPanel(p);
};
// -------------------------------------------------------------
int utspConfigTe01Ext(TCONTEXT *tc, void *p) {
  return 0;
};

int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int ch) { 
 return 1;
};

