#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include <ansi_c.h>
#include "ltr\\include\\ltravrapi.h"
#include "ltr\\include\\ltr010api.h"
//--------------------------------------------------------------
//
//--------------------------------------------------------------
int utspDefaultReadMCUFuses(TCONTEXT *tc, void *p)
{ 
 int res=TRES_T_FAIL;
 ltrTContext *tclocal=tc->tcontext;
 burnMcuContext *pbc=p;
 //
 TLTRAVR module;
 LTRAVR_Init(&module);
 res = LTRAVR_Open(&module, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot);
 if (res==LTR_WARNING_MODULE_IN_USE) res = LTR_OK;
 if(res==LTR_OK) {
	if(LTRAVR_ReadFuseBits(&module, (BYTE*)&pbc->fuses)==LTR_OK) res=TRES_T_OK;
	else if(tc->cbf!=NULL) tc->cbf(0, "Can't read fuses!");
	//
	LTRAVR_Close(&module);
 } else if(tc->cbf!=NULL) tc->cbf(0, "Can't open module!");
 return res;
}
//--------------------------------------------------------------
// 
//--------------------------------------------------------------
int utspDefaultWriteMCUFuses(TCONTEXT *tc, void *p)
{ 
 int res=TRES_T_OK;
 ltrTContext *tclocal=tc->tcontext;
 burnMcuContext *pbc=p;
 //
 TLTRAVR module;
 LTRAVR_Init(&module);
 res = LTRAVR_Open(&module, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot);
 if (res==LTR_WARNING_MODULE_IN_USE) res = LTR_OK;
 if(res==LTR_OK) 
 {  
	//   -      
	if(LTRAVR_SetSpeedFlag(&module, (pbc->flags&(1<<0)) ? TRUE : FALSE)==LTR_OK) 
	{   
		if(LTRAVR_WriteFuseBits(&module, (BYTE*)&pbc->fuses)!=LTR_OK) res=TRES_T_FAIL;
	} else res=TRES_INIT_FAIL;
	LTRAVR_Close(&module);
	// first time write fuses?
	
    if(res==TRES_T_OK && (pbc->flags&(1<<0))) 
    {
		TLTR010 control;
 		LTR010_Init(&control);
		if(LTR010_Open(&control, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial)==LTR_OK) 
		{
			if(LTR010_LoadFPGA(&control, TTF_WORK1, 7, 0)!=LTR_OK) res=TRES_T_FAIL;
			LTR010_Close(&control);
		}
    }
 } else res=TRES_INIT_FAIL;	
 return res;
}
//--------------------------------------------------------------
// 
//--------------------------------------------------------------
int utspDefaultWriteMCUFlash(TCONTEXT *tc, void *p)
{ 
 int res=TRES_T_FAIL;
 ltrTContext *tclocal=tc->tcontext;
 burnMcuContext *pbc=p;
 TLTRAVR module;
 FILE *f;
 //
 if((f=fopen(pbc->fname, "rb"))!=NULL) 
 {
	 DWORD i, k, size, pages;
	 WORD buf[ATMEGA8515_FLASH_SIZE]; 
	 memset(buf, 0xff, sizeof(buf));
	 size=fread(buf, sizeof(WORD), ATMEGA8515_FLASH_SIZE, f);
 	 if(size>0) {
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|10, "Read firmware from file -> ok");
 		//
 		LTRAVR_Init(&module);
 	    res = LTRAVR_Open(&module, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot);
 		if (res==LTR_WARNING_MODULE_IN_USE) res = LTR_OK;
 		if(res==LTR_OK) 
 		{
			if(LTRAVR_ChipErase(&module)==LTR_OK) 
			{	   
				if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|20, "Chip erase -> ok");
				if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Write programm memory...");
				//
				pages=(size+ATMEGA8515_PAGE_SIZE-1)/ATMEGA8515_PAGE_SIZE;
				i=k=0;
				while(i<pages && k<3) 
				{
					DWORD offset=i*ATMEGA8515_PAGE_SIZE;
					if(LTRAVR_WriteProgrammMemory(&module, buf+offset, ATMEGA8515_PAGE_SIZE, offset)==LTR_OK) 
					{
						if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|(80*(i+1)/pages+20), NULL);
						i++;
						k=0;
					} else k++;	
				}
				//
				if(i==pages) {
					if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|100, "Write programm memory -> ok");
					res=TRES_T_OK;
				} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't write programm memory!");
			} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't erase selected module!");
			//
			LTRAVR_Close(&module);
 		} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't open selected module!");	
 	 } else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't read file with firmware!");
 	 Sleep(300);
 	 fclose(f);
 } else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't open file with firmware!");	 
 return res;
}
