#include <ansi_c.h>
#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\systems\\common\\include\\pluginexport.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include "tflist.h"
#include "localdefs.h"

extern void closeModule(void);
extern void closeUIR(void);
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
void closeThisPlugin(void) 
{
  closeModule();
  closeUIR();
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
static pluginDefine thePlugin= 
{
 PNAME("LTR010"), 
 PVERSION("1.0"), 
 PDESCR("Standart Factory LTR010 module tester"),

 PIMAGE_MCU("ATMega162"),
 PIMAGE_MCU("ltr010_firmware.bin"),
 PIMAGE_MCU(NULL),
 { 
   !NEED_TE01, PTE01EXT_NAME(""), 
   !NEED_KEITHLEY,
   PTYPE_STD
 },
 {
   PHELP_MANUAL("manual.pdf"),
   PHELP_DEV_HW_DESCR(NULL),
   PHELP_DEV_SCHEME("scheme.pdf"), 
   PHELP_DEV_CABLES("cables.pdf"),
   PHELP_TE01EXT_HW_DESCR(NULL),   
   PHELP_TE01EXT_SCHEME(NULL),
 },
 PFPTR_INIT_MODULE(NULL),    	    	    //extern int utspInitModule(TCONTEXT *tc, void *);       
 PFPTR_READ_DATA(NULL),						//extern int utspReadData(TCONTEXT *tc, void *);         
 PFPTR_WRITE_DATA(NULL),					//extern int utspWriteData(TCONTEXT *tc, void *);        
 PFPTR_WRITE_DATAFILE(NULL),				//extern int utspWriteFile(TCONTEXT *tc, void *);        
 PFPTR_CALIBR(NULL),	 				   	//extern int utspCalibrModule(TCONTEXT *tc);             
 PFPTR_VERIFY(NULL),						//extern int utspVerifyModule(TCONTEXT *tc);             
 PFPTR_SHOWPNL_TESTCFG(NULL),				//extern int utspConfigTest(TCONTEXT *tc, void *);       
 PFPTR_SHOWPNL_VIRTDEVICE(NULL),			//extern int utspVirtualDevice(TCONTEXT *tc, void *);    
 PFPTR_SHOWPNL_DEVCFG(NULL),				//extern int utspConfigDevice(TCONTEXT *tc, void *);     
 PFPTR_SHOWPNL_TE01CFG(NULL),	            //extern int utspConfigTe01Ext(TCONTEXT *tc, void *);    
 PFPTR_GETDESCR_ADC(NULL),	      			//extern int utspGetDescrADC(pluginADC *D, int channel); 
 PFPTR_GETDESCR_DAC(NULL),					//extern int utspGetDescrDAC(pluginDAC *D, int channel); 
 PFPTR_GETDESCR_DIO(NULL),					//extern int utspGetDescrDIO(pluginDIO *D, int channel); 
 PFPTR_GET_DIO(NULL),						//extern int utspGetDIO(TCONTEXT *tc, void *);           
 PFPTR_PUT_DIO(NULL),						//extern int utspPutDIO(TCONTEXT *tc, void *);           
 PFPTR_WRITE_MCU(NULL),			  
 PFPTR_WRITE_MCU(utspWriteMCUFlash),	 	//extern int utspWriteMCU(TCONTEXT *tc, void *);         
 PFPTR_WRITE_MCU(NULL),			  
 PFPTR_WRITE_MCU(NULL),			  
 PFPTR_LOAD_ADSP(NULL),  					//extern int utspLoadADSP(TCONTEXT *tc, void *);         
 PFPTR_MODULE_INFO(utspGetModuleInfo),		//extern int utspGetModuleInfo(TCONTEXT *tc, void *);
 PFPTR_START(utspStart),					//extern int utspStart(TCONTEXT *tc, void *);    
 PFPTR_STOP(utspStop)						//extern int utspStop(TCONTEXT *tc, void *);    
};
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
static TFuncDefine TFuncSet[]= 
{
 {
  PNAME("SerialRing"), 
  PVERSION("0.1"), 
  PDESCR("Test crate controller in serail ring mode. Send random data, receive and compare data. Data size - 16M samples."),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestSerialRing
 },
 
 NULL
};
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
pluginDefine * __stdcall readPluginDefine(void) 
{
 return &thePlugin;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
int __stdcall readTFuncNum(void) 
{
 int n= 0;
 TFuncDefine *p= &TFuncSet[0];
 while(p->name!=NULL) { n++; p++; };
 return n;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
TFuncDefine * __stdcall readTFuncDefine(int num) 
{
 if(num > (readTFuncNum() - 1) ) return NULL;
 return &TFuncSet[num];
}




