#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include "ltr\\include\\ltr010api.h"
#include "ltr\\include\\ltrbootapi.h"
#include "ltr\\include\\ltrapidefine.h"
#include <ansi_c.h>
#include <time.h>
static TLTR010 ltr010;
static int needOpen= 1;
//-----------------------------------------------------------------------------
void closeModule(void) 
{
 if(!needOpen) {
	LTR010_Close(&ltr010);
  	needOpen= 1;
 }	
}
//-----------------------------------------------------------------------------
int testPlolog(TCONTEXT *tc) 
{
 INT res=LTR_OK;
 if(needOpen) 
 {
	ltrTContext *tclocal=tc->tcontext;
	if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL); 
	LTR010_Init(&ltr010);
	res=LTR010_Open(&ltr010, tclocal->serverAddr, tclocal->serverPort,tclocal->crateSerial);
	if(res!=LTR_OK) {
		LTR010_Close(&ltr010);	
	} 
 	if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
 	//
 	needOpen=0;
 }	
 return res==LTR_OK ? 0 : TRES_INIT_FAIL;
}
//-----------------------------------------------------------------------------
int utspInitModule(TCONTEXT *tc, void *p) { return 0; }
int utspReadData  (TCONTEXT *tc, void *p) { return 0; }
int utspWriteData (TCONTEXT *tc, void *p) { return 0; }
int utspWriteFile (TCONTEXT *tc, void *p) { return 0; }
int utspCalibrModule(TCONTEXT *tc) { return 0; }
int utspVerifyModule(TCONTEXT *tc) { return 0; }
int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel) { return 0; }
int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int channel) { return 0; }
int utspGetDIO(TCONTEXT *tc, void *p) { return 0; }
int utspPutDIO(TCONTEXT *tc, void *p) { return 0; }
//-----------------------------------------------------------------------------
//    :  ,   
//-----------------------------------------------------------------------------
int utspGetModuleInfo(TCONTEXT *tc, void *p) 
{
 int res=TRES_INIT_FAIL;
 if(!testPlolog(tc)) 
 {
	TDESCRIPTION_LTR010 descr;
	char info1[16], info2[16];
	INT res=LTRBOOT_CallApplication(&ltr010, LTR010_FIRMWARE_START_ADDRESS);
	if(res==LTR_OK) 
	{
       	res=LTR010_GetDescription(&ltr010, &descr);
       	if(res==LTR_OK) 
       	{
       		//
		} else tc->cbf(TFMSG_LOG, "LTR010_GetDescription() -> error"); 
	} 
	else 
	{
       	res=LTRBOOT_GetDescription(&ltr010, &descr);
       	if(res==LTR_OK) 
       	{
       		//
		} else tc->cbf(TFMSG_LOG, "LTRBOOT_GetDescription() -> error"); 
	}
	//
	if(res==LTR_OK) 
	{
 		if(tc->cbf!=NULL) 
 		{
 			DWORD dw;
 			char cstr[1024];
	 		sprintf(cstr, " : %.16s", descr.Module.DeviceName);
 			tc->cbf(TFMSG_IMODULE, cstr);
 			tc->cbf(TFMSG_SERIAL, descr.Module.SerialNumber);
	 		sprintf(cstr, ": %s", descr.Module.Comment);
 			tc->cbf(TFMSG_IMODULE, cstr);
	 		sprintf(cstr, ": %.16s", descr.Cpu.Name);
 			tc->cbf(TFMSG_IMODULE, cstr);
	 		sprintf(cstr, " : %.1f MHz", descr.Cpu.ClockRate);
 			tc->cbf(TFMSG_IMODULE, cstr);
 			dw=descr.Cpu.FirmwareVersion;
 			sprintf(cstr, " : %d.%d.%d.%d", (int)((dw>>24)&255), (int)((dw>>16)&255), (int)((dw>>8)&255), (int)((dw>>0)&255));
 			tc->cbf(TFMSG_IMODULE, cstr);
	 		sprintf(cstr, ": %s", descr.Cpu.Comment);
 			tc->cbf(TFMSG_IMODULE, cstr);
 		}
 		res=TRES_T_OK;
 	}	
 } 
 return res;
};
//-----------------------------------------------------------------------------
//  avr
//-----------------------------------------------------------------------------
int utspWriteMCUFlash(TCONTEXT *tc, void *p) 
{  
 int TRES1=TRES_T_FAIL, TRES2=TRES_T_FAIL;
 //
 if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_ISTART, "Start write firmware to LTR010 AVR");
 if(LTRBOOT_CallApplication(&ltr010, LTR010_BOOT_LOADER_START_ADDRESS)==LTR_OK) 
 {
	TDESCRIPTION_LTR010 descr;
	if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|10, "Jump to boot loader -> ok");
	//
	if(LTRBOOT_GetDescription(&ltr010, &descr)==LTR_OK) 
	{
		time_t timer;
        struct tm *tblock;
		char cstr[1024];
 		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|20, "Read module descriptor -> ok");
		//
		strncpy(descr.Module.DeviceName, "LTR010", sizeof(descr.Module.DeviceName));
		strncpy(descr.Module.SerialNumber, ((burnMcuContext*)p)->serial, sizeof(descr.Module.SerialNumber));
        timer=time(NULL);
        tblock=localtime(&timer);
		sprintf(cstr, "<Revision>{A}<BurnDate>{%d:%d %d.%d.%d}", tblock->tm_hour, tblock->tm_min, tblock->tm_mday, tblock->tm_mon, tblock->tm_year+1900);
		strncpy(descr.Module.Comment, cstr, sizeof(descr.Module.Comment));
    	strncpy(descr.Cpu.Name, "ATMega162", sizeof(descr.Cpu.Name));
    	descr.Cpu.ClockRate=15000000l;
		if(LTRBOOT_SetDescription(&ltr010, &descr)==LTR_OK) 
		{
			FILE *f;	
			if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|30, "Write module descriptor -> ok");
			//
			f=fopen(((burnMcuContext*)p)->fname, "rb");	
			if(f!=NULL) 
			{
				BYTE buf[LTR010_FIRMWARE_SIZE];
				if(fread(buf, 1, sizeof(buf), f)==sizeof(buf)) 
				{
					if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|40, "Read firmware from file -> ok");
					if(LTRBOOT_PutArray(&ltr010, buf, sizeof(buf), LTR010_FIRMWARE_START_ADDRESS)==LTR_OK) 
					{
						//
						if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|80, "Write module firmware -> ok");						
						TRES1=TRES_T_OK;
						//
					} else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Write module firmware -> error");
				} else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Read firmware from file -> error");
				fclose(f);
			} else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Open firmware file -> error");
		} else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Write module descriptor -> error");
    } else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Read module descriptor -> error");
    //
	if(LTRBOOT_CallApplication(&ltr010, LTR010_FIRMWARE_START_ADDRESS)==LTR_OK) 
	{
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|90, "Jump to application -> ok");
		//
		TRES2=LTR010_LoadFPGA(&ltr010, TTF_WORK3, 7, 0);
		if(TRES2==LTR_OK) 
		{ 
			if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|100, "Load FPGA -> ok");
			TRES2=utspGetModuleInfo(tc, p);
			//
		} else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Load FPGA -> error");	
	} else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Jump to application -> error");
 } else if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Jump to boot loader -> error");
 if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_IEND, "Stop write firmware to LTR010 AVR");
 return (TRES1==TRES_T_FAIL || TRES2==TRES_T_FAIL) ? TRES_T_FAIL : TRES_T_OK; 
}
//-----------------------------------------------------------------------------
//     :   
//  . .     .
//-----------------------------------------------------------------------------
#define NPOINT    (64*1024)
#define NPASS     (16)  
int utspTestSerialRing(TCONTEXT *tc) 
{ 
 char msg[1024];
 int res=LTR_OK, stop_flag=0, TRES1=TRES_T_FAIL, TRES2=TRES_T_FAIL;
 srand(1);
 if(tc->cbf!=NULL) stop_flag=tc->cbf(MIDFD_CORE|MIDFC_ISTART, "Start serial ring test");
 res=LTR010_LoadFPGA(&ltr010, TTF_TEST2, 7, 0);
 if(res==LTR_OK) 
 {
	DWORD i, j;
	TLTR ltr[MODULE_MAX];
	if(tc->cbf!=NULL) stop_flag=tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|10, "Load FPGA -> ok");
	//
	Sleep(5000);
	for(i=0; i<MODULE_MAX; i++) 
	{
		LTR_Init(&ltr[i]);
		memcpy(ltr[i].csn, ltr010.ltr.csn, sizeof(ltr[i].csn));
		ltr[i].saddr=ltr010.ltr.saddr;
		ltr[i].sport=ltr010.ltr.sport;
		ltr[i].cc=(CC_MODULE1+i)|CC_DEBUG_FLAG;
	}	
	
	for(i=0; i<MODULE_MAX; i++)
	{
		if(LTR_Open(&ltr[i])!=LTR_OK) break;
	}
	//
	if(i==MODULE_MAX) 
	{
		DWORD *buf1, *buf2;
		if(tc->cbf!=NULL) stop_flag=tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|15, "Open modules -> ok");
		//
	    buf1=malloc(NPOINT*MODULE_MAX*sizeof(DWORD));
	    buf2=malloc(NPOINT*MODULE_MAX*sizeof(DWORD));
		if(buf1!=NULL && buf2!=NULL) 
		{
			int k, n;
			if(tc->cbf!=NULL) stop_flag=tc->cbf(TFMSG_LOG, "Send/Receive/Compare random data. Please wait...");
			//
			for(n=k=0; n<NPASS && !k && !stop_flag; n++) 
			{
				int res=LTR_OK;
				for(j=0; j<NPOINT; j++) 
				{
					for(i=0; i<MODULE_MAX; i++) 
					{
						buf1[j*MODULE_MAX+i]=(rand()<<16)|(i<<8);
					}
				}
				res =  LTR_Send(&ltr[0], buf1, NPOINT*MODULE_MAX, 3000);
				if(res==(NPOINT*MODULE_MAX)) 
				{
					if(tc->cbf!=NULL) 
					{
						stop_flag=tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|(70*(3*n+1)/3/NPASS+15), NULL);
					}
					
					for(i=0; i<MODULE_MAX && !stop_flag; i++) 
					{
						DWORD sz=LTR_Recv(&ltr[i], buf2+i*NPOINT, NULL, NPOINT, 4000);
						if(sz!=NPOINT) 
						{
							char astr[255];
							sprintf(astr, "Receive -> error [Module:%0.2d Send:%d Recv:%d]", i+1, NPOINT, sz);
							if(tc->cbf!=NULL) stop_flag=tc->cbf(TFMSG_LOG, astr);								
							k++;
						}
					}									  
					//
					if(!k) 
					{
						if(tc->cbf!=NULL) stop_flag=tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|(70*(3*n+2)/3/NPASS+15), NULL);
						//
						for(j=0; j<NPOINT && k<16 && !stop_flag; j++) 
						{
							for(i=0; i<MODULE_MAX && k<16; i++) 
							{
								if(buf2[i*NPOINT+j]!=buf1[j*MODULE_MAX+i]) 
								{
									char astr[255];
									sprintf(astr, "Compare data -> error [Module:%0.2d, Offset:0x%0.8X Write:0x%0.8X Read:0x%0.8X]", i+1, j, buf1[j*MODULE_MAX+i], buf2[i*NPOINT+j]);
									if(tc->cbf!=NULL) stop_flag=tc->cbf(TFMSG_LOG, astr);								
									k++;
								}	
							}
						}
						//	
 						if(!k && tc->cbf!=NULL) stop_flag=tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|(70*(3*n+3)/3/NPASS+15), NULL);
					} 
				} 
				else 
				{
					if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Send random data -> error");
					k++;
				}
			}		
			//
			if(!k) 
			{
				if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Send/Receive/Compare random data -> ok");
				TRES1=TRES_T_OK;
			}	
		} 
		else
		{
			if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Allocate memory for test -> error");
		}
		
		free(buf2);
		free(buf1);
	} else if(tc->cbf!=NULL) stop_flag=tc->cbf(TFMSG_LOG, "Open modules -> error");
	//
	for(i=0; i<MODULE_MAX; i++)
	{
		if (LTR_Close(&ltr[i])!=LTR_OK) break;
	}
	
	if (i==MODULE_MAX)
	{
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|90, "Close modules -> ok");
	}
 } 
 else if(tc->cbf!=NULL) 
 {
    sprintf(msg, "Load FPGA -> error (%s)", LTR010_GetErrorString(res));
 	tc->cbf(TFMSG_LOG, msg);
 }	
 //
 if(LTR010_LoadFPGA(&ltr010, TTF_WORK3, 7, 0)==LTR_OK) 
 {
	if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|100, "Load FPGA -> ok");
	TRES2=TRES_T_OK;
 } 
 else 
 {
 	if(tc->cbf!=NULL) tc->cbf(TFMSG_LOG, "Load FPGA -> error");
 }
 
 if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_IEND, "Stop serial ring test");
 //
 return (TRES1==TRES_T_FAIL || TRES2==TRES_T_FAIL) ? TRES_T_FAIL : TRES_T_OK;
}
