#ifndef LTR11_LOCAL_DEFS_H_
#define LTR11_LOCAL_DEFS_H_

#include "ltr\\include\\ltr11api.h"

/*===============================================================================================*/
#define MAXNPOINTS         100000         // 200000 // 400 kHz @ 0.5 sec
#define MCUTYPE_LTR11 	   "ATMega8515"
#define MCUIMAGENAME_LTR11 "ltr-11.tsk"
#define TE01EXT11NAME      "TE-01A-11"
/*===============================================================================================*/

#pragma pack(1)
typedef struct
{
    int start_source;
    int clock;
    int signal;
    int is400khz;
    int prescaler;
    int divider;
    int calibr;
    int point;
    int procpoint;
    int debugpanel_on;
} IniSet_common;

typedef struct
{
    int onoff;
    int scale;
    int mode;
    int channel;
} IniSet_vchan;

typedef struct
{
    IniSet_common common;  
    IniSet_vchan  vchan[LTR11_MAX_LCHANNEL];
} IniSet_LTR11;
#pragma pack()

void   readINI               (char *xdir, char *mdescr);

#endif


