#include <ansi_c.h>
#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\systems\\common\\include\\pluginexport.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "tflist.h"
#include "localdefs.h"


/*===============================================================================================*/
extern void closeModule(void);
extern void closeUIR(void);
/*===============================================================================================*/

/*===============================================================================================*/
static pluginDefine ltrPlugin =
{
    PNAME("LTR11"), 
    PVERSION("1.0"), 
    PDESCR("Standart Factory LTR11 module tester"),
	PIMAGE_MCU(MCUTYPE_LTR11),
    PIMAGE_MCU(MCUIMAGENAME_LTR11),
    PIMAGE_MCU(NULL),

    {
        NEED_TE01, PTE01EXT_NAME("TE-01 Supplementary LTR11 module"), 
        !NEED_KEITHLEY,
        PTYPE_STD
    },

    {
        PHELP_MANUAL("manual.pdf"),
        PHELP_DEV_HW_DESCR(NULL),
        PHELP_DEV_SCHEME("scheme.pdf"), 
        PHELP_DEV_CABLES("cables.pdf"),
        PHELP_TE01EXT_HW_DESCR(NULL),   
        PHELP_TE01EXT_SCHEME(NULL),
    },

    PFPTR_INIT_MODULE(NULL),                  /* extern int utspInitModule(TCONTEXT *tc, void *); */
    PFPTR_READ_DATA(NULL),					  /* extern int utspReadData(TCONTEXT *tc, void *); */
    PFPTR_WRITE_DATA(NULL),				      /* extern int utspWriteData(TCONTEXT *tc, void *); */
    PFPTR_WRITE_DATAFILE(NULL),			      /* extern int utspWriteFile(TCONTEXT *tc, void *); */
    PFPTR_CALIBR(utspCalibrModule),    	      /* extern int utspCalibrModule(TCONTEXT *tc); */
    PFPTR_VERIFY(utspVerifyModule),		      /* extern int utspVerifyModule(TCONTEXT *tc); */
    PFPTR_SHOWPNL_TESTCFG(utspConfigTest),	  /* extern int utspConfigTest(TCONTEXT *tc, void *); */
    PFPTR_SHOWPNL_VIRTDEVICE(NULL),		      /* extern int utspVirtualDevice(TCONTEXT *tc, void *); */
    PFPTR_SHOWPNL_DEVCFG(utspConfigDevice),   /* extern int utspConfigDevice(TCONTEXT *tc, void *); */
    PFPTR_SHOWPNL_TE01CFG(utspConfigTe01Ext), /* extern int utspConfigTe01Ext(TCONTEXT *tc, void *); */
    PFPTR_GETDESCR_ADC(utspGetDescrADC),	  /* extern int utspGetDescrADC(pluginADC *D, int channel); */
    PFPTR_GETDESCR_DAC(NULL),				  /* extern int utspGetDescrDAC(pluginDAC *D, int channel); */
    PFPTR_GETDESCR_DIO(NULL),				  /* extern int utspGetDescrDIO(pluginDIO *D, int channel); */
    PFPTR_GET_DIO(NULL),					  /* extern int utspGetDIO(TCONTEXT *tc, void *); */
    PFPTR_PUT_DIO(NULL),					  /* extern int utspPutDIO(TCONTEXT *tc, void *); */
    PFPTR_WRITE_MCU(NULL), 	        	      /* flash_read  -> int utspReadMCU(TCONTEXT *tc, void *); */
    PFPTR_WRITE_MCU(utspWriteMCUFlash),	      /* flash_write -> int utspWriteMCU(TCONTEXT *tc, void *); */
    PFPTR_WRITE_MCU(utspDefaultReadMCUFuses), /* fuse_read  -> int utspReadMCU(TCONTEXT *tc, void *); */
    PFPTR_WRITE_MCU(utspDefaultWriteMCUFuses),/* fuse_write -> int utspWriteMCU(TCONTEXT *tc, void *); */
    PFPTR_LOAD_ADSP(NULL),  				  /* extern int utspLoadADSP(TCONTEXT *tc, void *); */
    PFPTR_MODULE_INFO(utspGetModuleInfo),	  /* extern int utspGetModuleInfo(TCONTEXT *tc, void *); */
    PFPTR_START(utspStart),				      /* extern int utspStart(TCONTEXT *tc, void *); */
    PFPTR_STOP(utspStop)					  /* extern int utspStop(TCONTEXT *tc, void *); */
};

static TFuncDefine TFuncSet[] =
{
    {
        PNAME("X-Y"),
        PVERSION("0.1"),
        PDESCR("   X  Y  "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testShortCircuitXY
    },
    {
        PNAME("XY-Ground"),
        PVERSION("0.1"),
        PDESCR("   X  Y  "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testShortCircuitXYGround
    },
    {
        PNAME("GND32-AGND"),
        PVERSION("0.1"),
        PDESCR("   GND32   "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testShortCircuitGND32AGND
    },
    {
        PNAME("Calibrate"), 
        PVERSION("0.1"), 
        PDESCR("    Flash MCU"),
        {TFTYPE_AUTO, !TFPASSPORT, !TFUSE},
        utspCalibrModule
    },
    {
        PNAME("Verify"), 
        PVERSION("0.1"), 
        PDESCR("  "),
        {TFTYPE_AUTO, TFPASSPORT, TFUSE},
        utspVerifyModule
    },
    {
        PNAME("IntNoise"), 
        PVERSION("0.1"), 
        PDESCR("   "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testIntrinsicNoise
    },
    {
        PNAME("InphaseReject"), 
        PVERSION("0.1"), 
        PDESCR("   "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testInphaseRejection
    },
    {
        PNAME("NonLinDistor"), 
        PVERSION("0.1"), 
        PDESCR("  "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testNonlinearDistortion
    },
    {
        PNAME("InterChannel"), 
        PVERSION("0.1"), 
        PDESCR("  "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testInterchannel
    },
    {
        PNAME("TestMode"), 
        PVERSION("0.1"), 
        PDESCR("  "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testLTRR11TestMode
    },
    {
        PNAME("StartADC"), 
        PVERSION("0.1"), 
        PDESCR("   "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testExternalADCStart
    },
    {
        PNAME("StartAcquisition"), 
        PVERSION("0.1"), 
        PDESCR("    "),
        {TFTYPE_AUTO, !TFPASSPORT, TFUSE},
        testExternalAcquisionStart
    },


    NULL
};
/*===============================================================================================*/

/*===============================================================================================*/
/*-----------------------------------------------------------------------------------------------*/
pluginDefine * DLLEXPORT DLLSTDCALL readPluginDefine(void)
{
    return &ltrPlugin;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int DLLEXPORT DLLSTDCALL readTFuncNum(void)
{
    int         n  = 0;
    TFuncDefine *p = &TFuncSet[0];
    
    
    while(p->name != NULL)
    {
        n++;
        p++;
    }
    return n;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
TFuncDefine * DLLEXPORT DLLSTDCALL readTFuncDefine(int num)
{
    if (num > (readTFuncNum() - 1))
        return NULL;
    return &TFuncSet[num];
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
void closeThisPlugin(void)
{
    closeModule();
    closeUIR();
}
/*-----------------------------------------------------------------------------------------------*/
/*===============================================================================================*/
