/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2006. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  DPNL                            1
#define  DPNL_reset                      2       /* callback function: dbgf_reset */
#define  DPNL_hide                       3       /* callback function: dbgf_hide */
#define  DPNL_perr                       4
#define  DPNL_loop                       5
#define  DPNL_np                         6
#define  DPNL_ns                         7
#define  DPNL_point                      8
#define  DPNL_p                          9
#define  DPNL_rx                         10
#define  DPNL_time                       11
#define  DPNL_DECORATION                 12

#define  PANEL                           2
#define  PANEL_cfgdone                   2       /* callback function: mf_apply */
#define  PANEL_clock                     3       /* callback function: cfgf_clock */
#define  PANEL_signal                    4       /* callback function: cfgf_signal */
#define  PANEL_is400khz                  5       /* callback function: cfgf_fs */
#define  PANEL_divider                   6       /* callback function: cfgf_fs */
#define  PANEL_prescaler                 7       /* callback function: cfgf_fs */
#define  PANEL_to                        8
#define  PANEL_time                      9
#define  PANEL_fch                       10
#define  PANEL_f0                        11
#define  PANEL_channel                   12      /* callback function: cfgf_channel */
#define  PANEL_mode                      13      /* callback function: cfgf_mode */
#define  PANEL_scale                     14      /* callback function: cfgf_scale */
#define  PANEL_descr                     15
#define  PANEL_text                      16
#define  PANEL_DECORATION_2              17
#define  PANEL_DECORATION_5              18
#define  PANEL_DECORATION                19
#define  PANEL_list                      20      /* callback function: cfgf_list */
#define  PANEL_DECORATION_3              21
#define  PANEL_ch32                      22      /* callback function: cfgf_ch32 */
#define  PANEL_ch16                      23      /* callback function: cfgf_ch16 */
#define  PANEL_clear                     24      /* callback function: cfgf_clear */
#define  PANEL_DECORATION_4              25
#define  PANEL_TEXTMSG                   26
#define  PANEL_total                     27
#define  PANEL_nvchan                    28
#define  PANEL_TEXTMSG_2                 29
#define  PANEL_calibr                    30      /* callback function: cfgf_calibr */
#define  PANEL_procpoint                 31      /* callback function: cfgf_point */
#define  PANEL_point                     32      /* callback function: cfgf_point */
#define  PANEL_debug_on                  33      /* callback function: cb_debugpnlon */
#define  PANEL_start_src                 34      /* callback function: cfgf_start_src */

#define  TCFG                            3
#define  TCFG_cfgdone                    2       /* callback function: mf_cfgtestdone */

#define  TE01P                           4
#define  TE01P_apply                     2       /* callback function: te01f_apply */
#define  TE01P_cfgdone                   3       /* callback function: te01f_done */
#define  TE01P_comment                   4
#define  TE01P_name                      5
#define  TE01P_serial3                   6
#define  TE01P_mid                       7
#define  TE01P_revision                  8
#define  TE01P_serial1                   9
#define  TE01P_serial2                   10
#define  TE01P_DECORATION_2              11
#define  TE01P_DECORATION                12
#define  TE01P_write                     13      /* callback function: te01f_write */
#define  TE01P_read                      14      /* callback function: te01f_read */
#define  TE01P_setdefault                15      /* callback function: te01f_default */
#define  TE01P_TEXTMSG                   16
#define  TE01P_DECORATION_4              17
#define  TE01P_TEXTMSG_2                 18
#define  TE01P_minus                     19
#define  TE01P_plus                      20
#define  TE01P_sel54                     21
#define  TE01P_sel32                     22
#define  TE01P_sel10                     23      /* callback function: te01f_sel10 */
#define  TE01P_TEXTMSG_3                 24
#define  TE01P_DECORATION_5              25
#define  TE01P_TEXTMSG_4                 26
#define  TE01P_DECORATION_7              27
#define  TE01P_DECORATION_9              28
#define  TE01P_DECORATION_8              29
#define  TE01P_start                     30
#define  TE01P_sync                      31

#define  WP                              5
#define  WP_TEXTMSG                      2


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK cb_debugpnlon(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_calibr(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_ch16(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_ch32(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_channel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_clear(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_clock(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_fs(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_mode(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_point(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_scale(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_signal(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cfgf_start_src(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK dbgf_hide(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK dbgf_reset(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_apply(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK mf_cfgtestdone(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_apply(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_default(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_done(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_read(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_sel10(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_write(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
