#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "pluginuir.h"
#include "localdefs.h"
#include "ltr\\include\\ltr11api.h"
#include "uts\\instruments\\te01\\te01api.h"
#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\common\\include\\plugindef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "uts\\services\\common\\include\\servicedef.h"



/*===============================================================================================*/
#define P(x)  PANEL_##x
/*===============================================================================================*/

/*===============================================================================================*/
/*===============================================================================================*/

/*===============================================================================================*/
static double calcFsPerChannel      (void);
extern void   closeModule           (void);
static int    iniset_Timeout        (void);
static int    LTR11_CREATE_VCHANNEL (int scale, int mode, int channel);
static int    numOfVChan            (void);
static void   showDescr             (void);
extern int    testPlolog            (TCONTEXT *tc);
static void   writeINI              (void);
/*===============================================================================================*/

/*===============================================================================================*/
static int (*dataUpdateCBF)(int nchan, serviceStrucData X[], char *info) = NULL;
static double dbuf[LTR11_MAX_LCHANNEL][MAXNPOINTS];
static int DebugPnl = -1;
extern TLTR11 hltr11;
static HANDLE hThread;
static double ibuf[LTR11_MAX_LCHANNEL][MAXNPOINTS];
IniSet_LTR11 IniSet;
static int Pnl = -1;
static DWORD rd_buf[MAXNPOINTS*LTR11_MAX_LCHANNEL];
static double rd_buf_double[MAXNPOINTS*LTR11_MAX_LCHANNEL];
static int runFlag;
static serviceStrucData serviceDATA[LTR11_MAX_LCHANNEL];
static int TePnl = -1;
static char theDIR[FNAMELEN+1];
static char theMDESCR[FNAMELEN+1];
static char thePATH[FNAMELEN+1];
static TE01 *theTE01;
static double theScalesVal[] = {10.0, 2.5, 0.625, 0.156};
static int tpassed;
static int TPnl = -1;
/*===============================================================================================*/

/*===============================================================================================*/
/*-----------------------------------------------------------------------------------------------*/
#if 0
static void byte2bin01(int xbyte, char *buf)
{
    int j;
    
    
    strcpy(buf, "XXXXXXXX");
    for (j = 0; j < 8; j++)
        buf[7-j] = ((xbyte >> j) & 1) ? '1' : '0';
}
#endif
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static double calcFsPerChannel(void)
{
    int    n = numOfVChan();  /* !!! ??? tmp --> 0 */
    double f;

    if (IniSet.common.is400khz)
    {
        f = 400E3;
    }
    else
    {
        f = (double)LTR11_CLOCK * 1E3 / IniSet.common.prescaler / (IniSet.common.divider + 1);
    }
    
    return f / n;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cb_debugpnlon(int panel, int control, int event, void *callbackData,
    int eventData1, int eventData2)
{
	switch (event)
    {
	case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(debug_on), &IniSet.common.debugpanel_on);
		break;
    }
	return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_calibr(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(calibr), &IniSet.common.calibr);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_ch16(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int  j;
    char tmp[512];
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
        {
            IniSet.vchan[j].onoff   = 0;
            IniSet.vchan[j].scale   = 0;
            IniSet.vchan[j].mode    = 0;
            IniSet.vchan[j].channel = j % 16;
        }
        for(j = 0; j < 16; j++)
            IniSet.vchan[j].onoff = 1; 

        DeleteListItem(Pnl, P(list), 0, -1);
        for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
        {
            sprintf(tmp, " %d", j + 1);
            InsertListItem(Pnl, P(list), -1, tmp, j);
            CheckListItem(Pnl, P(list), j, IniSet.vchan[j].onoff & 1);
        }

        SetCtrlIndex(Pnl, P(list), 0);

        cfgf_list (-1, -1, EVENT_COMMIT, NULL, 0, 0);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_ch32(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int  j;
    char tmp[512];
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
        {
            IniSet.vchan[j].onoff   = 0;
            IniSet.vchan[j].scale   = 0;
            IniSet.vchan[j].mode    = 1;
            IniSet.vchan[j].channel = j % 32;
        }
        for(j = 0; j < 32; j++)
            IniSet.vchan[j].onoff = 1;

        DeleteListItem(Pnl, P(list), 0, -1);
        for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
        {
            sprintf(tmp, " %d", j + 1);
            InsertListItem(Pnl, P(list), -1, tmp, j);
            CheckListItem(Pnl, P(list), j, IniSet.vchan[j].onoff & 1);
        }

        SetCtrlIndex(Pnl, P(list), 0);

        cfgf_list(-1, -1, EVENT_COMMIT, NULL, 0, 0);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_channel(int panel, int control, int event, void *callbackData,
    int eventData1, int eventData2)
{
    int ind;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlIndex(Pnl, P(list), &ind);
        GetCtrlVal(Pnl, P(channel), &IniSet.vchan[ind].channel);

        showDescr();
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_clear(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int  j;
    char tmp[512];
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
        {
            IniSet.vchan[j].onoff   = 0;
            IniSet.vchan[j].scale   = 0;
            IniSet.vchan[j].mode    = 0;
            IniSet.vchan[j].channel = j % 16;
        }
        IniSet.vchan[0].onoff = 1; 

        DeleteListItem(Pnl, P(list), 0, -1);
        for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
        {
            sprintf(tmp, " %d", j + 1);
            InsertListItem(Pnl, P(list), -1, tmp, j);
            CheckListItem(Pnl, P(list), j, IniSet.vchan[j].onoff & 1);
        }

        SetCtrlIndex(Pnl, P(list), 0);

        cfgf_list(-1, -1, EVENT_COMMIT, NULL, 0, 0);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_clock(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int i;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(clock), &i);
        IniSet.common.clock = i;

        SetCtrlAttribute(Pnl, P(is400khz), ATTR_VISIBLE, (i) ? 0 : 1);
        SetCtrlAttribute(Pnl, P(prescaler), ATTR_VISIBLE, (i) ? 0 : 1);
        SetCtrlAttribute(Pnl, P(divider), ATTR_VISIBLE, (i) ? 0 : 1);
        SetCtrlAttribute(Pnl, P(f0), ATTR_VISIBLE, (i) ? 0 : 1);
        SetCtrlAttribute(Pnl, P(fch), ATTR_VISIBLE, (i) ? 0 : 1);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_fs(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    double fx;
    int    n;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(is400khz), &IniSet.common.is400khz);
        SetCtrlAttribute(Pnl, P(prescaler), ATTR_DIMMED, IniSet.common.is400khz);
        SetCtrlAttribute(Pnl, P(divider), ATTR_DIMMED, IniSet.common.is400khz);
        SetCtrlVal(Pnl, P(f0), 400E3);
        SetCtrlVal(Pnl, P(fch), (n = numOfVChan()) ? 400E3 / n : 400E3); /* ??? !!! tmp */

        GetCtrlVal(Pnl, P(prescaler), &IniSet.common.prescaler);
        GetCtrlVal(Pnl, P(divider), &IniSet.common.divider);

        if (IniSet.common.prescaler == 1)
        {
            if (IniSet.common.divider < 37)
            {
                IniSet.common.divider = 37;                              /* ??? !!! tmp */
                SetCtrlVal(Pnl, P(prescaler), IniSet.common.prescaler);
                SetCtrlVal(Pnl, P(divider), IniSet.common.divider);				
            }
        }

        if (IniSet.common.prescaler == 8)
        {
            if (IniSet.common.divider < 4)
            {
                IniSet.common.divider = 4;                               /* ??? !!! tmp */
                SetCtrlVal(Pnl, P(prescaler), IniSet.common.prescaler);
                SetCtrlVal(Pnl, P(divider), IniSet.common.divider);				
            }
        }

        if (IniSet.common.is400khz)
        {
            IniSet.common.prescaler = 1;
            IniSet.common.divider   = 36;

            SetCtrlVal(Pnl, P(prescaler), IniSet.common.prescaler);
            SetCtrlVal(Pnl, P(divider), IniSet.common.divider);			   
        }
        else
        {
            GetCtrlVal(Pnl, P(prescaler), &IniSet.common.prescaler);
            GetCtrlVal(Pnl, P(divider), &IniSet.common.divider);

            fx = (double)LTR11_CLOCK * 1E3 / IniSet.common.prescaler / (IniSet.common.divider + 1);

            SetCtrlVal(Pnl, P(f0), fx);
            SetCtrlVal(Pnl, P(fch), (n = numOfVChan()) ? fx / n : fx);  /* ??? !!! tmp */
        }

        cfgf_point(-1, -1, EVENT_COMMIT, NULL, 0, 0);

        break;
    } /*switch (event)*/
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_list(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int ind;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
    case EVENT_VAL_CHANGED:
        GetCtrlIndex(Pnl, P(list), &ind);
        IsListItemChecked(Pnl, P(list), ind, &IniSet.vchan[ind].onoff);

        SetCtrlAttribute(Pnl, P(scale), ATTR_VISIBLE, IniSet.vchan[ind].onoff);
        SetCtrlAttribute(Pnl, P(mode), ATTR_VISIBLE, IniSet.vchan[ind].onoff);
        SetCtrlAttribute(Pnl, P(channel), ATTR_VISIBLE, IniSet.vchan[ind].onoff);
        SetCtrlAttribute(Pnl, P(descr), ATTR_VISIBLE, IniSet.vchan[ind].onoff);
        SetCtrlAttribute(Pnl, P(text), ATTR_VISIBLE, IniSet.vchan[ind].onoff);

        SetCtrlVal(Pnl, P(scale), IniSet.vchan[ind].scale);
        SetCtrlVal(Pnl, P(mode), IniSet.vchan[ind].mode);

        /*        P(channel) */
        cfgf_mode(-1, -1, EVENT_COMMIT, NULL, 0, 0);
        cfgf_fs(-1, -1, EVENT_COMMIT, NULL, 0, 0);

        showDescr();
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_mode (int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int  ind;
    int  j;
    char tmp[512];
    

    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlIndex(Pnl, P(list), &ind);
        GetCtrlVal(Pnl, P(mode), &IniSet.vchan[ind].mode);

        SetCtrlAttribute(Pnl, P(channel), ATTR_DIMMED, 0);

        if (IniSet.vchan[ind].mode == 0)
        {
            DeleteListItem(Pnl, P(channel), 0, -1);
            for(j = 0; j < 16; j++)
            {
                sprintf(tmp, " %d", j + 1);
                InsertListItem(Pnl, P(channel), -1, tmp, j);
            }
        }
        else if (IniSet.vchan[ind].mode == 2)              /* zero */
        { 
            SetCtrlAttribute(Pnl, P(channel), ATTR_DIMMED, 1);
        }
        else                                               /* 32-chan */
        {
            DeleteListItem(Pnl, P(channel), 0, -1);
            for(j = 0; j < 32; j++)
            {
                sprintf(tmp, " %d", j + 1);
                InsertListItem(Pnl, P(channel), -1, tmp, j);
            }
        }

        SetCtrlVal(Pnl, P(channel), IniSet.vchan[ind].channel);			
        cfgf_channel(-1, -1, EVENT_COMMIT, NULL, 0, 0);    /*     	*/

        showDescr();
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_point(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    double f;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(point), &IniSet.common.point);
        GetCtrlVal(Pnl, P(fch), &f);
        SetCtrlVal(Pnl, P(time), 1000.0 * IniSet.common.point / f);
        SetCtrlVal(Pnl, P(to), (double)iniset_Timeout());

        SetCtrlVal(Pnl, P(total), IniSet.common.point * numOfVChan());

        GetCtrlVal(Pnl, P(procpoint), &IniSet.common.procpoint);
        if (IniSet.common.procpoint > IniSet.common.point)
        {
            IniSet.common.procpoint = IniSet.common.point;
            SetCtrlVal(Pnl, P(procpoint), IniSet.common.procpoint);
        }
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_scale(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int ind;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlIndex(Pnl, P(list), &ind);
        GetCtrlVal(Pnl, P(scale), &IniSet.vchan[ind].scale);

        showDescr();
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_signal(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(signal), &IniSet.common.signal);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK cfgf_start_src(int panel, int control, int event, void *callbackData,
    int eventData1, int eventData2)
{
    int start_source;
    
	switch (event)
    {
	case EVENT_COMMIT:
        GetCtrlVal(Pnl, P(start_src), &start_source);
        IniSet.common.start_source = start_source;
		break;
    }
	return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
void closeUIR(void)
{
    if (Pnl != -1)
    {
        DiscardPanel(Pnl);
        Pnl = -1;
    }
    if (TPnl != -1)
    {
        DiscardPanel(TPnl);
        TPnl = -1;
    }
    if (TePnl != -1)
    {
        DiscardPanel(TePnl);
        TePnl = -1;
    }
    if (DebugPnl !=-1)
    {
        DiscardPanel(DebugPnl);
        DebugPnl = -1;
    }
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int configHW(TCONTEXT *tc, PTLTR11 hltr11)
{
    int AdcMode[] =
    {
        LTR11_ADCMODE_ACQ, LTR11_ADCMODE_TEST_U1P, LTR11_ADCMODE_TEST_U1N,
        LTR11_ADCMODE_TEST_U2P, LTR11_ADCMODE_TEST_U2N
    };
    INT err_code;
    int InpMode[] = {LTR11_INPMODE_INT, LTR11_INPMODE_EXTRISE, LTR11_INPMODE_EXTFALL};
    int j;
    int k;


    readINI(tc->dllpath, tc->mdescr);

    hltr11->InpMode = InpMode[IniSet.common.clock];
    hltr11->LChQnt  = numOfVChan();


    for (k = 0, j = 0; j < LTR11_MAX_LCHANNEL; j++)
    {
        if (!IniSet.vchan[j].onoff)
            continue;
        hltr11->LChTbl[k] = LTR11_CREATE_VCHANNEL(IniSet.vchan[j].scale, IniSet.vchan[j].mode,
            IniSet.vchan[j].channel);
        k++;
    }

    hltr11->StartADCMode      = IniSet.common.start_source;
    hltr11->ADCMode           = AdcMode[IniSet.common.clock];
    hltr11->ADCRate.prescaler = IniSet.common.prescaler;
    hltr11->ADCRate.divider   = IniSet.common.divider;

    err_code = LTR11_SetADC(hltr11);
    if(err_code != LTR_OK)
    {
        if (tc->cbf != NULL)
            tc->cbf(MIDCER_STOP_ERROR, (char*)LTR11_GetErrorString(err_code));
        return 1;
    }
    err_code = LTR11_GetConfig(hltr11);
    if (err_code != LTR_OK && tc->cbf != NULL)
        tc->cbf(MIDCER_STOP_ERROR, (char *)LTR11_GetErrorString(err_code));

    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void DataRecorder(void *par)
{
    int      cnt;
    int      dval;
    int      j;
    int      n =  numOfVChan();
    int      nline;
    int      p;
    int      q;
    int      r;
    int      stop_record = 0;
    double   t;
    TCONTEXT *tc = par;
    char     tmp[512];
    int      tx;
    int      to = iniset_Timeout();
    int      xp;


    while (runFlag)
    { 
        if (!stop_record)
        {   
            cnt = LTR_Recv(&hltr11.Channel, rd_buf, NULL, n * IniSet.common.point, to);

            if (DebugPnl != -1)
            {
                GetCtrlVal(DebugPnl, DPNL_loop, &dval);
                SetCtrlVal(DebugPnl, DPNL_loop, dval + 1);
                t       = ((tx = GetTickCount()) - tpassed);
                tpassed = tx;
                SetCtrlVal(DebugPnl, DPNL_time, t);
            }

            for (j = 0; j < n; j++)
            {
                serviceDATA[j].point  = 0;
                serviceDATA[j].iarray = NULL; 
                serviceDATA[j].darray = NULL; 
                serviceDATA[j].fs     = 0;
            }

            if (cnt <= 0)
            {
                if (cnt < 0)
                {
                    if (tc->cbf != NULL)
                       tc->cbf(MIDCER_STOP_ERROR, (char*)LTR11_GetErrorString(cnt));
                }
                else
                {
                    if (tc->cbf != NULL)
                       tc->cbf(MIDCER_STOP_ERROR, "   ");
                }
        
                if (DebugPnl != -1)
                {
                    GetCtrlVal(DebugPnl, DPNL_ns, &dval);
                    SetCtrlVal(DebugPnl, DPNL_ns, dval + 1);   
                    sprintf(tmp, "%d", cnt);
                    InsertTextBoxLine(DebugPnl, DPNL_rx, -1, tmp);
                    GetNumTextBoxLines(DebugPnl, DPNL_rx, &nline);
                    if (nline > 100)
                        ResetTextBox(DebugPnl, DPNL_rx, tmp);
                }
                goto __skip_processing;
            }
            else
            {
                if (DebugPnl != -1 && cnt != n * IniSet.common.point)
                {
                    GetCtrlVal(DebugPnl, DPNL_point, &dval);
                    SetCtrlVal(DebugPnl, DPNL_point, dval + 1);
                    sprintf(tmp, "%d", cnt);
                    InsertTextBoxLine(DebugPnl, DPNL_rx, -1, tmp);        
                    GetNumTextBoxLines(DebugPnl, DPNL_rx, &nline);
                    if (nline > 100)
                        ResetTextBox(DebugPnl, DPNL_rx, tmp);        
                }
            }

            xp = n * IniSet.common.procpoint;
            r  = LTR11_ProcessData(&hltr11, rd_buf, rd_buf_double, &xp, IniSet.common.calibr, 0);
            q  = xp / n;   

            if (r != LTR_OK)
            {
                if (DebugPnl == -1)
                {
                    if (tc->cbf != NULL)
                        tc->cbf(MIDCER_STOP_ERROR, (char*)LTR11_GetErrorString(r));
                    stop_record = 1;
                }
                else
                {
                    time_t cur_time = time(NULL);
                    
                    strftime(tmp, 10, "%H:%M:%S", localtime(&cur_time));
                    strcat(tmp, (char*)LTR11_GetErrorString(r));
                
                    GetNumTextBoxLines(DebugPnl, DPNL_p, &nline);
                    if(nline > 100)
                        ResetTextBox(DebugPnl, DPNL_p, tmp);
                    InsertTextBoxLine(DebugPnl, DPNL_p, -1, tmp);
                }
            }

            if (DebugPnl != -1 && q == 0)
            {
                sprintf(tmp, "TN= %d, N= %d", xp, q);
                InsertTextBoxLine(DebugPnl, DPNL_p, -1, tmp);        
                GetNumTextBoxLines(DebugPnl, DPNL_p, &nline);
                if(nline > 100)
                    ResetTextBox(DebugPnl, DPNL_p, tmp);
            }

            if (DebugPnl != -1 && r)
            {
                GetCtrlVal(DebugPnl, DPNL_perr, &dval);
                SetCtrlVal(DebugPnl, DPNL_perr, dval + 1);   
            }

            if (q != IniSet.common.procpoint)
            {
                if (DebugPnl != -1)
                {
                    GetCtrlVal(DebugPnl, DPNL_np, &dval);
                    SetCtrlVal(DebugPnl, DPNL_np, dval + 1);
                }
                if (!q)
                    goto __skip_processing;      
            }

            for(j = 0; j < n; j++)
            {
                serviceDATA[j].point  = q;
                serviceDATA[j].iarray = ibuf[j]; 
                serviceDATA[j].darray = dbuf[j];
                serviceDATA[j].fs     = calcFsPerChannel();
                for(p = 0; p < q; p++)
                {
                    ibuf[j][p] = rd_buf_double[j + p*n];
                    dbuf[j][p] = (double)ibuf[j][p] / 8192.0 * theScalesVal[IniSet.vchan[j].scale];
                }
            }

__skip_processing:

            dataUpdateCBF(n, serviceDATA, NULL);
            Sleep(0);
        } /*if (!stop_record)*/
    }     /*while (runFlag)*/


    ExitThread(0);
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK dbgf_hide(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        DiscardPanel(DebugPnl);
        DebugPnl = -1;
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK dbgf_reset(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        SetCtrlVal(DebugPnl, DPNL_point, 0);
        SetCtrlVal(DebugPnl, DPNL_perr, 0);
        SetCtrlVal(DebugPnl, DPNL_ns, 0);
        SetCtrlVal(DebugPnl, DPNL_np, 0);

        SetCtrlVal(DebugPnl, DPNL_loop, 0);

        ResetTextBox(DebugPnl, DPNL_rx, ""); 
        ResetTextBox(DebugPnl, DPNL_p, ""); 
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
#if 0
static void dprintf(descr_ltr11 h)
{
    char buf[512];
    FILE *f = fopen("_ltr11_set_debug.txt", "w");
    int  j;


    if (f == NULL)
        return;

    fprintf(f, "size: %d\n", h.size);
    fprintf(f, "InpMode: %Xh\n", h.InpMode);
    fprintf(f, "VChQnt: %d\n", h.VChQnt);
    for (j = 0; j < h.VChQnt; j++)
    {
        byte2bin01(h.VChTbl[j], buf);
        fprintf(f, " - Ch%02d. %02Xh: %s\n", j, h.VChTbl[j], buf); 
    }
    fprintf(f, "ADCMode: %Xh\n", h.ADCMode);
    fprintf(f, "divider: %d, prescaler: %d, ChRate= %.1lf\n", h.ADCRate.divider,
        h.ADCRate.prescaler, h.ChRate);
    fclose(f);
}
#endif
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void fillINI(void)
{
    /*   UIR-  */

    int j;


    memset(&IniSet, 0x00, sizeof(IniSet_LTR11));

    IniSet.common.start_source = LTR11_STARTADCMODE_INT;
    IniSet.common.clock     = 0;
    IniSet.common.signal    = 0;
    IniSet.common.is400khz  = 1;
    IniSet.common.prescaler = 1;
    IniSet.common.divider   = 36;

    IniSet.common.point     = 100000;
    IniSet.common.procpoint = 1024;
    IniSet.common.calibr    = 0;
    
    IniSet.common.debugpanel_on = 0;

    for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
    {
        IniSet.vchan[j].onoff   = 0;
        IniSet.vchan[j].scale   = 0;
        IniSet.vchan[j].mode    = 0;
        IniSet.vchan[j].channel = j % 16;
    }
    IniSet.vchan[0].onoff = 1;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void hideWPanel(int p)
{
    DiscardPanel(p);
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static int iniset_Timeout(void)
{
    /* !!!   ,  Ini-  !!! TMP !!! */
    
    double f;
    double to;

    if (IniSet.common.is400khz)
    {
        f = 400E3;
    }
    else
    {
        f = (double)LTR11_CLOCK * 1E3 / IniSet.common.prescaler / (IniSet.common.divider + 1);
    }
    f /= numOfVChan();

    to = 2.0 * (double)IniSet.common.point / f;  /* seconds */
    to = to * 1E3 + 0.5;
    if (to < 5000.0)
        to = 5000.0;
        
    return to;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static int LTR11_CREATE_VCHANNEL(int scale, int mode, int channel)
{
    int q = 0;
    int X = 0;
    

    if (mode == 2)               /* zero */
        q = 1;
    if (mode == 1)               /* 32-chan */
    {
        q = 2;                   /* 32-chan, 1-16 chan by def. */
        if (channel / 16)        /* 32- chan, 17-32 chan */
            q = 3;
    }

    X  = (scale & 0x03) << 6;
    X |= ((q & 0x03) << 4);
    X |= ((channel % 16) & 0x0F);

    return X;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void makeAdcVChanDescr(int ind, char X[COMMENTLEN+1])
{
    char *mode[]= {"Diff.", "32-Chan.", "Zero"};
    
    
    sprintf(X, "LC%02d:Ch%02d,D:+/-%.3lfV:%s,Fs=%.1lf kHz", ind + 1, IniSet.vchan[ind].channel + 1,
        theScalesVal[IniSet.vchan[ind].scale], mode[IniSet.vchan[ind].mode],
        calcFsPerChannel() / 1E3);
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK mf_apply(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        if(!numOfVChan())
        {
            MessagePopup(MSG_WARNING, "Invalid number of channels: 0");
            break;
        }

        /* !!! tmp ??? ---> do it physically : + real Fs > 400 kHz must be suppressed */
        writeINI();
        DiscardPanel(Pnl);
        Pnl = -1;		    
        /* MessagePopup(MSG_PROMPT, "Changes were made succesfully, ini-file has been updated"); */
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK mf_cfgtestdone(int panel, int control, int event, void *callbackData,
    int eventData1, int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        DiscardPanel(TPnl);
        TPnl = -1;
        break;
    }
    
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static int numOfVChan(void)
{
    int j;
    int n = 0;
    
    
    for (j = 0; j < LTR11_MAX_LCHANNEL; j++)
    {
        if (IniSet.vchan[j].onoff)
            n++;
    }

    if (Pnl != -1)
        SetCtrlVal(Pnl, P(nvchan), n);  /* !!! ??? tmp ---> here */

    return n;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
void readINI(char *xdir, char *mdescr)
{
    FILE *f;
    char fname[FNAMELEN+1];


    strcpy(theDIR, xdir);
    strcpy(theMDESCR, mdescr);

    fillINI();

    sprintf(fname, "%s\\%s", theDIR, mdescr);
    if((f = fopen(fname, "rb")) == NULL)
        return;

    fread(&IniSet, sizeof(IniSet_LTR11), 1, f);

    fclose(f);
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void showDescr(void)
{
    int  ind;
    int  q;
    char tmp[512];


    GetCtrlIndex(Pnl, P(list), &ind);

    q = 0;
    if (IniSet.vchan[ind].mode == 2)           /* zero */
        q = 1;
    if (IniSet.vchan[ind].mode == 1)
    {
        q = 2;
        if (IniSet.vchan[ind].channel / 16)
            q = 3;
    }

    sprintf(tmp, "%d:%d:%d", IniSet.vchan[ind].scale, q, IniSet.vchan[ind].channel % 16);

    SetCtrlVal(Pnl, P(text), tmp);
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void showINI(void)
{
    int  j;
    char tmp[512];


    SetCtrlVal(Pnl, P(start_src), IniSet.common.start_source);
    SetCtrlVal(Pnl, P(clock), IniSet.common.clock);
    SetCtrlVal(Pnl, P(signal), IniSet.common.signal);
    SetCtrlVal(Pnl, P(is400khz), IniSet.common.is400khz);
    SetCtrlVal(Pnl, P(prescaler), IniSet.common.prescaler);
    SetCtrlVal(Pnl, P(divider), IniSet.common.divider);
    SetCtrlVal(Pnl, P(point), IniSet.common.point);
    SetCtrlVal(Pnl, P(procpoint), IniSet.common.procpoint);
    SetCtrlVal(Pnl, P(calibr), IniSet.common.calibr);
    SetCtrlVal(Pnl, P(debug_on), IniSet.common.debugpanel_on);

    for(j = 0; j < LTR11_MAX_LCHANNEL; j++)
    {
        sprintf(tmp, " %d", j + 1);
        InsertListItem(Pnl, P(list), -1, tmp, j);
        CheckListItem(Pnl, P(list), j, IniSet.vchan[j].onoff & 1);
    }

    SetCtrlIndex(Pnl, P(list), 0);

    cfgf_clock(-1, -1, EVENT_COMMIT, NULL, 0, 0);
    cfgf_signal(-1, -1, EVENT_COMMIT, NULL, 0, 0);
    cfgf_fs(-1, -1, EVENT_COMMIT, NULL, 0, 0);

    cfgf_list(-1, -1, EVENT_COMMIT, NULL, 0, 0);
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static int showWPanel(int ppnl, char *msg)
{
    int p = LoadPanelEx(ppnl, thePATH, WP, __CVIUserHInst);
    
    
    InstallPopup(p);
    return p;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK te01f_apply(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int s1;
    int s2;
    int s3;
    int select;


    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlVal(panel, TE01P_sel10, &s1);
        GetCtrlVal(panel, TE01P_sel32, &s2);
        GetCtrlVal(panel, TE01P_sel54, &s3);
        select = s1 | (s2 << 2) | (s3 << 4);

        memset(theTE01->aregs, 0, 15);
        theTE01->aregs[1] = select;                /* Sel */
        theTE01->aregs[2] = 0;                     /* U */

        GetCtrlVal(panel, TE01P_sync, &s1);
        GetCtrlVal(panel, TE01P_start, &s2);

        theTE01->aregs[3] = s1 | (s2 << 1);

        if (TE01SetConfiguration(theTE01, FORCE_UPDATE_AMODULE))
            MessagePopup(MSG_ERROR, "Failed update the submodule");

        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK te01f_default(int panel, int control, int event, void *callbackData,
    int eventData1, int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        SetCtrlVal(panel, TE01P_serial1, 1);
        SetCtrlVal(panel, TE01P_serial2, "C");
        SetCtrlVal(panel, TE01P_serial3, 1);
        SetCtrlVal(panel, TE01P_name, TE01EXT11NAME);
        SetCtrlVal(panel, TE01P_revision, 1);
        SetCtrlVal(panel, TE01P_mid, 1);
        SetCtrlVal(panel, TE01P_comment, " LTR-11");            
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK te01f_done(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    switch (event)
    {
    case EVENT_COMMIT:
        if (TePnl != -1)
            DiscardPanel(TePnl);
        TePnl = -1;
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK te01f_read(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int  p;
    char q[2] = {0, 0};
    int  sn;


    switch (event)
    {
    case EVENT_COMMIT:
        p = showWPanel(panel, NULL);
        if(TE01ReadAModuleEEPROM(theTE01))
        {
            hideWPanel(p);
            MessagePopup(MSG_ERROR, "Failed read EEPROM");
            break;
        }
        SetCtrlVal(panel, TE01P_serial1, theTE01->amodule_eeprom.sn[4]);
        q[0] = theTE01->amodule_eeprom.sn[3];
        SetCtrlVal(panel, TE01P_serial2, q);
        sn  = theTE01->amodule_eeprom.sn[0];
        sn |= (((int)theTE01->amodule_eeprom.sn[1]) << 8);
        sn |= (((int)theTE01->amodule_eeprom.sn[2]) << 16);
        SetCtrlVal(panel, TE01P_serial3, sn);
        SetCtrlVal(panel, TE01P_name, theTE01->amodule_eeprom.name);
        SetCtrlVal(panel, TE01P_revision, theTE01->amodule_eeprom.revision);
        SetCtrlVal(panel, TE01P_mid, theTE01->amodule_eeprom.mid);
        SetCtrlVal(panel, TE01P_comment, theTE01->amodule_eeprom.comment);
        hideWPanel(p);
        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK te01f_sel10(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int i;
    
    
    switch (event)
    {
    case EVENT_COMMIT:
        GetCtrlIndex(panel, TE01P_sel10, &i);
        SetCtrlIndex(panel, TE01P_plus, i);
        SetCtrlIndex(panel, TE01P_minus, i);

        if (i == 1)
        {
            SetCtrlAttribute(panel, TE01P_plus, ATTR_VISIBLE, 0);
            SetCtrlAttribute(panel, TE01P_minus, ATTR_VISIBLE, 0);
        }
        else
        {
            SetCtrlAttribute(panel, TE01P_plus, ATTR_VISIBLE, 1);
            SetCtrlAttribute(panel, TE01P_minus, ATTR_VISIBLE, 1);
        }

        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int CVICALLBACK te01f_write(int panel, int control, int event, void *callbackData, int eventData1,
    int eventData2)
{
    int  j;
    int  p;
    int  s1;
    char s2[2] = {0,0};
    int  s3;
    BYTE sn[6];


    switch (event)
    {
    case EVENT_COMMIT:
        p= showWPanel(panel, NULL);

        GetCtrlVal(panel, TE01P_serial1, &s1);
        GetCtrlVal(panel, TE01P_serial2, s2);
        GetCtrlVal(panel, TE01P_serial3, &s3);
        sn[0] = s3 & 0xFF;
        sn[1] = (s3 >> 8) & 0xFF;
        sn[2] = (s3 >> 16) & 0xFF;
        sn[3] = s2[0];
        sn[4] = s1 & 0xFF;
        sn[5] = 0;

        for (j = 0; j < 6; j++)
            theTE01->amodule_eeprom.sn[j] = sn[j];

        GetCtrlVal(panel, TE01P_name, theTE01->amodule_eeprom.name);
        GetCtrlVal(panel, TE01P_revision, &s1);
        theTE01->amodule_eeprom.revision = s1;
        GetCtrlVal(panel, TE01P_mid, &s1);
        theTE01->amodule_eeprom.mid = s1;
        GetCtrlVal(panel, TE01P_comment, theTE01->amodule_eeprom.comment);

        if (TE01SystemAreaWriteEnable(theTE01) || TE01WriteAModuleEEPROM(theTE01))
        {
            hideWPanel(p);
            MessagePopup(MSG_ERROR, "Failed update EEPROM");
        }
        else
        {
            hideWPanel(p);
            MessagePopup(MSG_PROMPT, "EEPROM has been updated");
        }

        break;
    }
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspConfigDevice(TCONTEXT *tc, void *p)
{
    char ppath[FNAMELEN+1];


    readINI(tc->dllpath, tc->mdescr);

    sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
    Pnl = LoadPanelEx(0, ppath, PANEL, __CVIUserHInst);  

    SetCtrlAttribute(Pnl, P(point), ATTR_MAX_VALUE, MAXNPOINTS);

    showINI();  
    InstallPopup(Pnl);
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspConfigTe01Ext(TCONTEXT *tc, void *p)
{
    char ppath[FNAMELEN+1];


    if (TePnl != -1)
    {
        SetActivePanel(TePnl);
        return 0;
    }

    theTE01 = (TE01 *)(tc->te01);
    sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
    strcpy(thePATH, ppath);

    TePnl = LoadPanelEx (0, ppath, TE01P, __CVIUserHInst);  
    DisplayPanel(TePnl);

    te01f_read(TePnl, TE01P_read, EVENT_COMMIT, NULL, 0, 0);
    te01f_sel10(TePnl, TE01P_sel10, EVENT_COMMIT, NULL, 0, 0);
    te01f_apply(TePnl, TE01P_apply, EVENT_COMMIT, NULL, 0, 0);  
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspConfigTest(TCONTEXT *tc, void *p)
{
    char ppath[FNAMELEN+1];
    
    
    sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
    TPnl = LoadPanelEx(0, ppath, TCFG, __CVIUserHInst);

    InstallPopup(TPnl);
    
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int ch)
{
    int ind = -1;
    int j;
    int q = 0;


    if (!ch)
        readINI(tc->dllpath, tc->mdescr);

    memset(D, 0x00, sizeof(pluginADC));

    for (j = 0; j < LTR11_MAX_LCHANNEL; j++)
    {
        if (IniSet.vchan[j].onoff)
        {
            if (q == ch)
            {
                ind = j;
                break;
            }
            q++;
        }
    }

    D->type  = UTSADC_FAST_SYNC; 
    D->nchan = numOfVChan();
    D->fs    = calcFsPerChannel();

    if (ind == -1)
        return 1;

    D->channel = ch;

    makeAdcVChanDescr(ind, D->comment);

    D->minU = -theScalesVal[IniSet.vchan[ind].scale];
    D->maxU = theScalesVal[IniSet.vchan[ind].scale];

    strcpy(D->unit, "V"); 

    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspLoadADSP(TCONTEXT *tc, void *p)
{
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspStart(TCONTEXT *tc, void *p)
{
    DWORD          TmpDWord;
    plugStartStruc *X;


    X = (plugStartStruc *)p;

    if (testPlolog(tc))
        return 1;

    if (configHW(tc, &hltr11))
    {
        closeModule();
        return 1;
    }

    dataUpdateCBF = X->coreCBF;

    if (LTR11_Start(&hltr11))
    {
        if (tc->cbf != NULL)
            tc->cbf(MIDCER_STOP_ERROR, "Start fail");
        closeModule();
        return 1;  
    }

    tpassed = GetTickCount();

    runFlag = 1;

    hThread = CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, tc, CREATE_SUSPENDED,
        (LPDWORD)&TmpDWord);

    ResumeThread(hThread);              /* start thread here */

    if (IniSet.common.debugpanel_on)
    {
        if (DebugPnl == -1)
        {
            char ppath[FNAMELEN+1];
        
            sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
            DebugPnl = LoadPanelEx(0, ppath, DPNL, __CVIUserHInst);
        }
        DisplayPanel(DebugPnl);
    }

    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspStop(TCONTEXT *tc, void *p)
{
    INT err_code;
    

    runFlag = 0;

    //WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
    
    (void)WaitForSingleObject(hThread, INFINITE);

    CloseHandle(hThread);

    if (DebugPnl != -1)
    {
        DiscardPanel(DebugPnl);
        DebugPnl = -1;
    }

    err_code = LTR11_Stop(&hltr11);
    if (err_code != LTR_OK)
    {
        if (tc->cbf != NULL)
            tc->cbf(MIDCER_STOP_ERROR, (char *)LTR11_GetErrorString(err_code));
        closeModule();
        return 1;    
    }

    closeModule();

    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
int utspVirtualDevice(TCONTEXT *tc, void *p)
{
    return 0;
}
/*-----------------------------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------------------------*/
static void writeINI(void)
{
    FILE *f;
    char fname[FNAMELEN+1];  


    sprintf(fname, "%s\\%s", theDIR, theMDESCR);
    if((f = fopen(fname, "wb")) == NULL)
        return;
    fwrite(&IniSet, sizeof(IniSet_LTR11), 1, f);
    fclose(f);
}
/*-----------------------------------------------------------------------------------------------*/
/*===============================================================================================*/

