#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include <ansi_c.h>
#include "uts\\instruments\\te01\\te01api.h"
#include "ltr\\include\\ltrapi.h"
#include "ltr\\include\\ltr212api.h"
#include <userint.h>

#define TEST_PARITY_ERR   (0x80DB)
#define SERIAL_CHECK_CODE (53637)
#define PARITY_ERR		  (0x80DB)  //      

#define WR_FLASH            0x80CB
#define RD_FLASH            0x80CC  //       

static int         needOpen= 1;
static int Start_Flag;
static int test_err=TRES_T_OK;
int stop_flag=0; send_flag=0;
TLTR212 hltr212;
static TCONTEXT *tc_if_test;

HANDLE DataThread, CommandThread;

INT LTR212_WriteEEPROM_UTS(TLTR212 *hnd, INT n, INT Address, BYTE *image);  
INT LTR212_ReadEEPROM_UTS(TLTR212 *hnd, INT n, INT Address, BYTE *image); 
INT LTR212_WriteFlashCRC_UTS(TLTR212 *hnd, WORD Flash_CRC);  
INT LTR212_EvaluateFlashCRC_UTS(TLTR212 *hnd, WORD *Flash_CRC);   
WORD UpdateCRC16_UTS(WORD *crc, BYTE b);   

// *****************************************************************************************
void closeModule(void) {
  if(!needOpen) {
     needOpen= 1;
     LTR212_Close(&hltr212);
  };
};

int testPlolog(TCONTEXT *tc);

int test_eval_parity(DWORD cmd); 
int test_check_parity(DWORD cmd); 

int utspLoadADSP(TCONTEXT *tc, void *p) {  
  int r;
  
  closeModule();  // !!! tmp :    p  
  r= testPlolog(tc);
  if(r) MessagePopup(MSG_ERROR,  "Failed initialize ADSP");
  else  MessagePopup(MSG_PROMPT, "ADSP has been initialized successfully with standard BIOS file (!TMP)");
  return r; 
};

 // !!! tmp
int utspInitModule(TCONTEXT *tc, void *p) { 
  return utspLoadADSP(tc, p);
};
// *****************************************************************************************
int testPlolog(TCONTEXT *tc) {
 ltrTContext *tclocal= tc->tcontext;
 INT  rs;
 char tmp[FNAMELEN+1];
 LPCSTR error_string;
 
     if(!needOpen) return 0;
     if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL);   
     
     rs=LTR212_Init(&hltr212);
     
      
      if(rs!=0) 
      {
      
        error_string=LTR212_GetErrorString(rs);
       
        
        LTR212_Close(&hltr212);
        if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);  
        
        if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);
        
        return TRES_INIT_FAIL;
     };  
     
 
	
	 
	 strcpy(tmp, tc->dllpath);
	 strcat(tmp, "\\bios\\ltr212.bio");
     rs= LTR212_Open(&hltr212, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial,  tclocal->slot, tmp);
     
     
     if(rs&&rs!=LTR_WARNING_MODULE_IN_USE) 
      {
      
        error_string=LTR212_GetErrorString(rs);
       
        
        LTR212_Close(&hltr212);
        if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);  

        
        if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);
        
         return TRES_INIT_FAIL;
     };  
     
     
     rs= LTR212_TestEEPROM(&hltr212);
       

     
     if(rs)
      {
      
        error_string=LTR212_GetErrorString(rs);
       
        
        
        if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);
 		if(rs!=-2031)
 		  return TRES_INIT_FAIL; 
  
      } 
      
     
     if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
     needOpen= 0;
     return 0;
};
				
// *****************************************************************************************


int utspReadData(TCONTEXT *tc, void *p) { return 0;};
int utspWriteData(TCONTEXT *tc, void *p) { return 0;};
int utspWriteFile(TCONTEXT *tc, void *p) { return 0;};



int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel) { 
 return 0;
};

int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int channel) { 
 return 0;
};

int utspGetDIO(TCONTEXT *tc, void *p) { return 0;};
int utspPutDIO(TCONTEXT *tc, void *p) { return 0;};


// ****************************************************************************
int utspGetModuleInfo(TCONTEXT *tc, void *p) {
char sn[16+1];

 needOpen= 1;
 if(testPlolog(tc)) return TRES_INIT_FAIL;
 

 
 	 strcpy(sn,hltr212.ModuleInfo.Serial);
     if(tc->cbf) tc->cbf(TFMSG_SERIAL, sn);
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
     if(tc->cbf) tc->cbf(TFMSG_VER, "1.1");
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
 return 0;
};

// ****************************************************************************
int utspWriteMCUFlash(TCONTEXT *tc, void *p) 

 {
 
  burnMcuContext *BurnContext = p; 
  int err=0;
  LPCSTR error_string;
 
  err=testPlolog(tc);
  
  
  if(err)
   //if(err!=-2031)	 //     ,    .     ,  
     return TRES_INIT_FAIL; 
   
  
  
  if(err=(LTR212_WriteSerialNumber(&hltr212, BurnContext->serial, SERIAL_CHECK_CODE)))
   {
    
  error_string=LTR212_GetErrorString(err); 
  if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
   return TRES_HW_FAIL;
  
  }
  
  return utspGetModuleInfo(tc, NULL);
};
// ****************************************************************************

static void TestInterface_DataThread(void *par) 

  {
  
int samples_qnt_rcv;
int array_qnt=100;  // -   
int cntr;
DWORD bad_sample;
WORD command_cntr;

WORD cur_command, prev_command;
int fl;
int err_qnt,command_err_qnt;
int samples_qnt=20000;
int err=0;
DWORD ovf_flag=0;
int Command_Code=0;
int slot_num=     hltr212.Channel.cc -1;   
int ovf;
int i;
DWORD k;
int force_flag;
WORD j;
unsigned int command_common_cntr;
DWORD *samples, *samples_commands, *samples_data;
double *data;
char msg[512];
int tick, tick1;




ovf=0;
err_qnt=0;
command_err_qnt=0;
fl=0;
cntr=0;
command_cntr=0;
command_common_cntr=0;
 force_flag=0;



    samples=(DWORD *) calloc(samples_qnt, sizeof(DWORD));
    samples_data=(DWORD *) calloc(samples_qnt, sizeof(DWORD));  
    samples_commands=(DWORD *) calloc(100000, sizeof(DWORD));  
    
    data=(double *) calloc(samples_qnt, sizeof(double));


err=LTR212_TestInterfaceStart(&hltr212,100); 

if(err)

{
	sprintf(msg, "%s", "  !");
	 if(tc_if_test->cbf) 
	   (tc_if_test->cbf(TFMSG_REPORT, msg));
	   test_err=TRES_HW_FAIL; 

     goto Force_Stop;
 }

 j=0;

Start_Flag=1;



tick=GetTickCount();

while(Start_Flag)

 {
 
   k=0;
   
   
   
   samples_qnt_rcv=LTR_Recv(&(hltr212.Channel), samples, NULL, samples_qnt, 10000/*5000*/); 
   cntr++;
 
	    
	 if(samples_qnt_rcv!=samples_qnt)
	  {
		sprintf(msg, "%s", "    , ! %d  %d", samples_qnt_rcv, samples_qnt);
		 if(tc_if_test->cbf) 
		    (tc_if_test->cbf(TFMSG_REPORT, msg));
			
		test_err=TRES_HW_FAIL; 
			
		goto Force_Stop;	
	   }   
	   
	   
	   
	   
	 
   
   for(i=0;i<samples_qnt_rcv;i++)
     if((samples[i]&0x0000F000)==0x8000)
      {
       samples_commands[j]=samples[i];
       
         //    
    	 if(test_check_parity(samples_commands[j]))
    	  {
               sprintf(msg, "%s", "       !");
		       if(tc_if_test->cbf) 
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      test_err=TRES_HW_FAIL; 
			      goto Force_Stop;
			 }  
      
       
      	 if(((samples_commands[j])&0xFFDF)==(TEST_PARITY_ERR|slot_num<<8))
      	    {
               sprintf(msg, "%s", "      !");
		       if(tc_if_test->cbf) 
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      test_err=TRES_HW_FAIL; 
			      goto Force_Stop;
			   }  
      	 		   
      	 
      
         samples_commands[j]&=0xFFFFFFDF; //   , ..     ,  
       
      
      
      if(j)
       {
        cur_command=(samples_commands[j]&0xFFFF0000)>>16;
        prev_command=(samples_commands[j-1]&0xFFFF0000)>>16; 
      
        //Command_Code=samples_commands[j]&0x000000DF;   
    	ovf_flag=hltr212.Channel.flags;
       
      if((((cur_command-prev_command)!=1)||((samples[i]&0x0000F0FF)==0x80DC))&&(prev_command!=0xFFFF))
		{
		 command_err_qnt++;
		 Command_Code=samples_commands[j]&0x000000DF;
		 
		  if(ovf_flag==FLAG_RBUF_OVF)
		   {
		    sprintf(msg, "%s", " !");
		       if(tc_if_test->cbf) 
			     (tc_if_test->cbf(TFMSG_REPORT, msg));
			     
			   test_err=TRES_HW_FAIL; 
			      
			      goto Force_Stop;  
			}     
		   
		     
		    if(Command_Code==0xDC)
		     {
		      sprintf(msg, "%s", "    ,     DSP!");
		       if(tc_if_test->cbf) 
			     (tc_if_test->cbf(TFMSG_REPORT, msg));
			     
			      sprintf(msg, "%s   %x", "   :", prev_command);
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      
			      sprintf(msg, "%s   %x", "   :", cur_command);
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      
			      test_err=TRES_HW_FAIL; 
			      
			      goto Force_Stop;
			     
			     
			     
		 	  } //    if(Command_Code==0xDC)  
		 
		  
		    if(Command_Code==0xDD)
		    {
		      sprintf(msg, "%s", "    ,    DSP!");
		       if(tc_if_test->cbf)
		        {
			     (tc_if_test->cbf(TFMSG_REPORT, msg));
			     
			      sprintf(msg, "%s   %x", "   :", prev_command);
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      
			      sprintf(msg, "%s   %x", "   :", cur_command);
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      
			      
			      test_err=TRES_HW_FAIL;
			      goto Force_Stop;
		    	 } //    if(tc_if_test->cbf)   
			} //  if(Command_Code==0xDD) 
			 
			 else
			  {
		      sprintf(msg, "%s", "   DSP    !");
		       if(tc_if_test->cbf) 
			      (tc_if_test->cbf(TFMSG_REPORT, msg));
			      test_err=TRES_HW_FAIL; 
			      goto Force_Stop;
			   }
			  	  
		 
		 } //  if(cur_command)
		}  //  if(j)
       
        
      command_common_cntr++;  
      j++;
      
      if(command_common_cntr%array_qnt==0) 
      skip: ;
 
     
      }  //  if
    else
     {
      samples_data[k]=samples[i];
      k++;
      }
      
      
      
     //} //  for
     
   err=LTR212_ProcessDataTest(&hltr212, samples_data, data, &k, 0,&bad_sample); 
   
   if(err)
    {
              err_qnt++;
	 
		      sprintf(msg, "%s", "    ,  !");
		       if(tc_if_test->cbf)
		        {
			     (tc_if_test->cbf(TFMSG_REPORT, msg));
			     
			     if(bad_sample!=0)
			      {
			       sprintf(msg, "%s   %x", "    :", samples_data[bad_sample-1]);
			       (tc_if_test->cbf(TFMSG_REPORT, msg));
			      
			       sprintf(msg, "%s   %x", "    :", samples_data[bad_sample]);
			       (tc_if_test->cbf(TFMSG_REPORT, msg));
			      } 
			      
			      test_err=TRES_HW_FAIL;
			      goto Force_Stop;
	 } 
	  
	} 
     
 
 
 
 
   
   tick1=GetTickCount();
   
    if (tc_if_test->cbf(TFMSG_PROGRESS(100.0 * (tick1-tick) /120000), NULL)) 
       {
          
	    test_err=TRES_ABORT;  
	    goto Force_Stop;
	   }  
   
   
   
   if((tick1-tick)>=120000)
    {
      
	 test_err=TRES_T_OK;
	 
	 Sleep(1000);
	 
	 goto Force_Stop;
    }   
    
   /*if(stop_flag==2)
    goto Force_Stop; */
    send_flag=1;        //           ,     
 						//  
  } //  while  
  
 Force_Stop:									   
 
 
 Sleep(200);

 send_flag=0;
free(samples);
free(samples_data); 
free(samples_commands); 
//free(samples1);      
free(data);      
//free(data1);
//err=LTR212_Stop(&am);   

 
 
 //err=LTR212_Stop(&am);
 
/* stop_flag=2; */
 
 Sleep(500);
 
 /*
 if(force_flag)
 CloseHandle(DataThread);   
 */
  stop_flag=1; 
  ExitThread(0); 
  
  }


static void TestInterface_CommandThread(void *par) 
 {
 #define COMMAND_FOR_IF_TEST	0x80DD
 
 DWORD *command;
 WORD command_form_cntr=0;
 int Command_Delay=100;
 int array_qnt=100;
 int array_cntr=0;
 int  send_cntr=0;
 int slot_num=hltr212.Channel.cc -1;
 char msg[512];
 int err=0;
 int parity=0;
 
  
  
  
  //send_flag=0;
  //command_cntr=0;
  //while(Start_Flag==0) {;}
  //tick=GetTickCount();
  //speed=0;
  

  while(!send_flag)
   {
     if(stop_flag==2)
	 break;
	 
    ;}
   
  command=(DWORD *) calloc(array_qnt, sizeof(DWORD)); 
  

  
  
  
  
for(;;)
{
  
 /*if(send_flag)
   
 { */
  if(array_cntr>=array_qnt)
   {  
    
    if(err=(LTR_Send(&(hltr212.Channel), command, array_qnt, 2000))!=array_qnt)
     {
       sprintf(msg, "%s", "    !");
	    if(tc_if_test->cbf) 
	      (tc_if_test->cbf(TFMSG_REPORT, msg));
	   test_err=TRES_HW_FAIL;    

        goto Force_Stop_Commands;
      
     } //  if(err=LTR_Send...    
     
     
       Sleep(Command_Delay);     
       send_cntr++;
     
       														

        array_cntr=0; 

        
    } //  if(array_cntr>=...)


    
  command[array_cntr]=command_form_cntr;
  command[array_cntr]<<=16; 
  command[array_cntr]|=COMMAND_FOR_IF_TEST|(slot_num<<8);
  parity=test_eval_parity(command[array_cntr]);
  command[array_cntr]|=(parity<<5);



 
 if(stop_flag==2)
    { 
     Sleep(100); 
	 break;
	} 
	
	
	
	
command_form_cntr++;
//command_cntr_speed++;
array_cntr++;  
//command_cntr+=2;

   /*tick2=GetTickCount();
   
    if (tc_if_test->cbf(TFMSG_PROGRESS(100.0 * (tick2-tick) /180000), NULL)) 
       {
	    test_err=TRES_ABORT;  
	    goto Force_Stop_Commands;
	   }  


   if((tick2-tick)>=180000)
    {
	 test_err=TRES_T_OK;
	 
	 Sleep(1000);
	 
	 goto Force_Stop_Commands;
    }  */

   //} //  if(send_flag)

 }

 Force_Stop_Commands: 

free(command);
stop_flag=3;
ExitThread(0);


//Sleep(1000);

//*********************  !
/*
if(force_flag)
CloseHandle(Thread1); */  
  }




int testSNR(TCONTEXT *tc) 
{

DWORD DataResume, CommandResume;
DWORD TmpDWord;
char msg[512];


//tc->cbf=NULL;
tc_if_test=tc;


/*if(tc->cbf!=NULL) 
			{;;;}  */


DataThread=NULL;
CommandThread=NULL;

DataThread=CreateThread(NULL,0, (LPTHREAD_START_ROUTINE) TestInterface_DataThread, NULL, CREATE_SUSPENDED,(LPDWORD)&TmpDWord); 
CommandThread=CreateThread(NULL,0, (LPTHREAD_START_ROUTINE) TestInterface_CommandThread, NULL, CREATE_SUSPENDED,(LPDWORD)&TmpDWord);          

Start_Flag=1;
stop_flag=0;
send_flag=0;

DataResume=ResumeThread(DataThread);
CommandResume=ResumeThread(CommandThread);


Sleep(50);
while(Start_Flag)
 {
  ProcessSystemEvents();  
  if(stop_flag==1)
    break;
 ;}

   Sleep(200);
CloseHandle(DataThread);
   stop_flag=2;
   Sleep(200);
CloseHandle(CommandThread);

Sleep(500);
if((test_err==0)||(test_err==7)||(test_err==TRES_HW_FAIL))
 if(LTR212_Stop(&hltr212))
  {
   sprintf(msg, "%s", ":    !");
    if(tc->cbf)
      (tc->cbf(TFMSG_REPORT, msg));
 
  test_err=TRES_HW_FAIL;
  } 
	  





Start_Flag=0;

 return test_err;
};



int testSNR2(TCONTEXT *tc) {
 return TRES_HW_FAIL;
};


int test_eval_parity(DWORD cmd)
{
	unsigned long index;
	int           parity;
	
	
	parity = 0;
	for (index = 0x01UL; index <= 0x10UL; index <<= 1)
		parity ^= (cmd & index) != 0;  
	
	
	for (index = 0x80000000UL; index >= 0x010000UL; index >>= 1)
		parity ^= (cmd & index) != 0;
	
	
	return parity;
}

/***********************************************************************************************

                .
         
************************************************************************************************/         

int test_check_parity(DWORD cmd)
 {
   if(((cmd&0x20)>>5)==test_eval_parity(cmd))
     return(0);
   else
     return(1);
  } 
  
  
 INT LTR212_WriteEEPROM_UTS(TLTR212 *hnd, INT n, INT Address, BYTE *image) 
  {
  
    DWORD command[1024], command_ack[15000];
    INT slot_num     =hnd->Channel.cc -1; 
    INT i;
    INT cmd_cnt=0;
    INT tail; // 
    INT cycles_qnt;  // -   
    INT hdrd_cnt;    //  
    INT err=0;
    INT parity=0;
    
    
    cycles_qnt=(INT) (n/100);  // - 
    tail=n%100;				   // 
    
    if(hnd==NULL)
      return -2001;
      
      
    if((Address<0)||(Address+n-1)>=512)             
      return -2010;           
   
  
    
 for(hdrd_cnt=0;hdrd_cnt<cycles_qnt;hdrd_cnt++) //        
  { 
   for(i=0;i<100;i++)
	{
     command[2*i]=Address+100*hdrd_cnt+i; //   
     command[2*i]<<=16;
	 command[2*i]|=WR_FLASH|(slot_num<<8);  //    DSP
	 
	 parity=test_eval_parity(command[2*i]);
     command[2*i]|=(parity)<<5;
    
		         
     command[2*i+1]=*(image+100*hdrd_cnt+i); //   
	 command[2*i+1]<<=16;
	 command[2*i+1]|=WR_FLASH|(slot_num<<8);
	 
	 parity=test_eval_parity(command[2*i+1]);
     command[2*i+1]|=(parity)<<5;
	 
	 cmd_cnt++;
	 
	} 
      
    
   if((err=(LTR_Send(&(hnd->Channel), command, 2*cmd_cnt, 2000)))!=2*cmd_cnt) 
    if(err<0)
       return err;
     else 
       return LTR212_ERR_CANT_WRITE_EEPROM;     
                        
                                                             
   if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, cmd_cnt, 2000)))!=cmd_cnt)
    if(err<0)
       return err;
     else 
       return LTR212_ERR_CANT_WRITE_EEPROM;     
    
      
   for(i=0;i< cmd_cnt;i++)  
    {
    
     if(test_check_parity(command_ack[i]))
      return LTR212_ERR_PARITY_ERROR;  
    
  
     if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
      return LTR212_ERR_PARITY_ERROR; 
      
      
     if((command_ack[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))  
      return LTR212_ERR_CANT_WRITE_EEPROM;       
    
  
      
    }  
     
      
    cmd_cnt=0;  
   } //  for(hdrd_cntr...) 
   
   
   for(i=0;i<tail;i++)
	{
     command[2*i]=Address+100*cycles_qnt+i; //   
     command[2*i]<<=16;
	 command[2*i]|=WR_FLASH|(slot_num<<8);  //    DSP
	 
	 parity=test_eval_parity(command[2*i]);
     command[2*i]|=(parity)<<5;
    
		         
     command[2*i+1]=*(image+100*cycles_qnt+i); //   
	 command[2*i+1]<<=16;
	 command[2*i+1]|=WR_FLASH|(slot_num<<8);
	 
	 parity=test_eval_parity(command[2*i+1]);
     command[2*i+1]|=(parity)<<5;
	 
	 cmd_cnt++;
	 
	} 
      
    
   if((err=(LTR_Send(&(hnd->Channel), command, 2*cmd_cnt, 2000)))!=2*cmd_cnt)
    if(err<0)
       return err;
     else 
       return LTR212_ERR_CANT_WRITE_EEPROM;     
                        
                                                             
   if((LTR_Recv(&(hnd->Channel), command_ack, NULL, cmd_cnt, 2000))!=cmd_cnt)
    if(err<0)
       return err;
     else 
       return LTR212_ERR_CANT_WRITE_EEPROM;     
     
    
    for(i=0;i< cmd_cnt;i++)
    {
      
      if(test_check_parity(command_ack[i]))
        return LTR212_ERR_PARITY_ERROR;  
        
      if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
        return LTR212_ERR_PARITY_ERROR;   
      
      if((command_ack[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))  
        return LTR212_ERR_CANT_WRITE_EEPROM;         
      
    }  
      
   
   
      
    return LTR212_NO_ERR;  
     } 
     
     
INT LTR212_ReadEEPROM_UTS(TLTR212 *hnd, INT n, INT Address, BYTE *image)
  
    {
    DWORD command[1024], EEPROM_data[512];
    INT slot_num     =hnd->Channel.cc -1;   
    INT i;
    INT hdrd_cnt; //  
    INT tail; // 
    INT cycles_qnt; //    
    INT err=0;
   
       INT parity;

   
    cycles_qnt=(INT) (n/100);
    tail=n%100;
    
    
    if(hnd==NULL)
      return LTR212_ERR_INVALID_DESCR; 
    
    if((Address<0)||(Address+n-1)>=512)
      return LTR212_ERR_CANT_READ_EEPROM; 
     
     
   for(hdrd_cnt=0;hdrd_cnt<cycles_qnt;hdrd_cnt++) //     
    {
      for(i=0; i<100; i++)
       {
       command[i]=Address+100*hdrd_cnt+i; //    
	   command[i]<<=16;
	   command[i]|=RD_FLASH|(slot_num<<8);   //    DSP  
	   
	   parity=test_eval_parity(command[i]);
       command[i]|=(parity)<<5;  
	   
	   } //  for 
	 
	   if((err=(LTR_Send(&(hnd->Channel), command, 100, 2000)))!=100)
	     if(err<0)
           return err;
         else 
           return LTR212_ERR_CANT_READ_EEPROM;           
	   
	     
	   
	   if((err=(LTR_Recv(&(hnd->Channel), EEPROM_data, NULL, 100, 2000)))!=100)
	     if(err<0)
           return err;
         else 
           return LTR212_ERR_CANT_READ_EEPROM;      
	   
	   
	   
	  for(i=0; i<100; i++)
	   {
	   		 //  
	   		 
	   	  if(test_check_parity(EEPROM_data[i]))
              return LTR212_ERR_PARITY_ERROR;   
	   		 
	     if(((EEPROM_data[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
               return LTR212_ERR_PARITY_ERROR; 
	      
	       if((EEPROM_data[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))                
	        return LTR212_ERR_CANT_READ_EEPROM;      
	   
	    /*
	    if((EEPROM_data[i]&0x0000FFFF)!=(command[i]&0x0000FFFF))
	     return LTR212_ERR_CANT_READ_EEPROM; */
	 
	      EEPROM_data[i]>>=16;
	      EEPROM_data[i]&=0xFF;
	      *(image+100*hdrd_cnt+i)=EEPROM_data[i];
	   } //  for(i=...)
   } //  for(hdrd_cntr...)   
	 
   for(i=0; i<tail; i++)  // ...                                                       
	{                                                                           
	  command[i]=Address+100*cycles_qnt+i; //                  
	  command[i]<<=16;                                                           
	  command[i]|=RD_FLASH|(slot_num<<8);   //    DSP     
	  
	  parity=test_eval_parity(command[i]);
      command[i]|=(parity)<<5;
	  
	} //  for(i=...)                                                                   
	                                                                                
	if((err=(LTR_Send(&(hnd->Channel), command, tail, 2000)))!=tail)
	 if(err<0)
       return err;
     else 
       return LTR212_ERR_CANT_READ_EEPROM;      
	                                   
	                                                                                
	if((err=(LTR_Recv(&(hnd->Channel), EEPROM_data, NULL, tail, 2000)))!=tail) 
	 if(err<0)
       return err;
     else 
       return LTR212_ERR_CANT_READ_EEPROM;      
	                                      
	                                                                                
	     for(i=0; i<tail; i++)                                                         
	      { 
	      
	       if(test_check_parity(EEPROM_data[i]))
              return LTR212_ERR_PARITY_ERROR;  
	      
	        if(((EEPROM_data[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
               return LTR212_ERR_PARITY_ERROR; 
	      
	       if((EEPROM_data[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))                
	        return LTR212_ERR_CANT_READ_EEPROM;                                     
	                                                                                
	        EEPROM_data[i]>>=16;                                                    
	        EEPROM_data[i]&=0xFF;                                                   
	        *(image+100*cycles_qnt+i)=EEPROM_data[i];                                 
	      } //  for(i=...)                                                         
	                                                                             
	 	  
    return LTR212_NO_ERR;
   } 
     
INT LTR212_EvaluateFlashCRC_UTS(TLTR212 *hnd, WORD *Flash_CRC)
{

  INT Flash_Size=510;//510; //      
  BYTE Flash_Byte_CRC;
  BYTE Flash_Content[510];
  INT i;
  INT err;
  
   Flash_Byte_CRC=0;
   *Flash_CRC=0;
  
  err=LTR212_ReadEEPROM_UTS(hnd, Flash_Size, 0, Flash_Content);
      if (err) return(err); 
  
  
  for(i=0;i<Flash_Size;i++)
   {
   
    Flash_Byte_CRC=Flash_Content[i];
    UpdateCRC16_UTS(Flash_CRC, Flash_Byte_CRC);
   } 
    
  return LTR212_NO_ERR;   
}


INT LTR212_WriteFlashCRC_UTS(TLTR212 *hnd, WORD Flash_CRC)
  {
    INT err;
    BYTE CRC_HByte, CRC_LByte;
    BYTE CRC_Bytes[2];
    
    CRC_LByte=Flash_CRC&0x00FF; //    
    CRC_HByte=(Flash_CRC>>8)&0x00FF;  //   
    
    
    CRC_Bytes[0]=CRC_LByte;
    CRC_Bytes[1]=CRC_HByte;
    
       
    
    
  err=LTR212_WriteEEPROM_UTS(hnd, 2, 510, CRC_Bytes); //   . 80   
      if (err) return(err); 
  
 
 return LTR212_NO_ERR;   
  }

WORD UpdateCRC16_UTS(WORD *crc, BYTE b)
 {
 WORD w;
 INT j;
 w = *crc;
  w ^= b << 8;
  for(j=0;j<8;j++)  {
   if(w&0x8000) w = (w<<1) ^ 0x1021;
   else w <<= 1;
  }
 *crc = w;
 return w;
}
