#include <windows.h>
#include <ansi_c.h>
#include <userint.h>
#include "uts\\instruments\\te01\\te01api.h"
#include "pluginuir.h"
#include "UTS\\systems\\common\\include\\tfuncdef.h"
#include "localdefs.h"
#include "UTS\\systems\\common\\include\\plugindef.h"
#include "UTS\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "UTS\services\common\include\servicedef.h"
#include "ltr\\include\\ltr212api.h"
#include <analysis.h>


//static int PH_Regs;
static int Pnl= -1;
static int error=0;
char error_string[500]="";

//static int TePnl= -1;
#define P(x)  PANEL_##x

extern TLTR212 hltr212;

static char thePATH[FNAMELEN+1];

// -------------------------------------------------------------
void calcFS(double *fsBase, double *fs);

#define THE8CHANTIME 1.0/50e3  // !!! tmp

static char *theScalesVal[8]= {"+/-10mV", "+/-20mV", "+/-40mV", "+/-80mV", "0...10mV", "0...20mV", "0...40mV", "0...80mV"};
static double theScalesValDbl[4]= {10e-3, 20e-3, 40e-3, 80e-3};
static int   thePhysChannel[8]= {1,2,3,4,5,6,7,8};

static winScale[8]= {P(s_1), P(s_2), P(s_3), P(s_4), P(s_5), P(s_6), P(s_7), P(s_8)};
static winChan[8]= {P(c_1), P(c_2), P(c_3), P(c_4), P(c_5), P(c_6), P(c_7), P(c_8)};

#define MAX_CHANNEL 8
#define QFreq 4.9152e6


void closeUIR(void) {
  if(Pnl!= -1)   { DiscardPanel(Pnl);   Pnl= -1;   };
  //if(TePnl!= -1) { DiscardPanel(TePnl); TePnl= -1; };  
};


int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };
static int get_serial(void);


#ifndef LTR212METR
#pragma pack(1)
typedef struct {
  int mode;
  int clb;
  int FabricClb;
  int iir;
  int fir;
  int decimation;
  int taps;
  char iirname[512];
  char firname[512];
  int ac;
  int  ref;
  double fsFlt;
  
  int prev_calibr_mode;
} IniSet_common;

typedef struct {
  int  onoff;
  int  scale;
} IniSet_chan;

typedef struct {
  int point;  // - 
  int ppoint;  // - process points
  IniSet_common common; //    
  IniSet_chan  chan[MAX_CHANNEL];//     (, ...)
} IniSet_XXX;
#pragma pack()
#endif

IniSet_XXX IniSet;

static void fillINI(void) {  //   UIR- 
 int j;
 

 
 memset(&IniSet, 0x0, sizeof(IniSet_XXX));
 IniSet.point= 256;
 IniSet.ppoint= 256;
 IniSet.common.mode= 1;
 IniSet.common.clb= 0;
 IniSet.common.FabricClb= 0;  
 IniSet.common.iir= 0;
 IniSet.common.fir= 0;
 IniSet.common.decimation= 1;
 IniSet.common.taps= 0;
 //IniSet.common.fdiv= 40;
 //IniSet.common.chop= 0;
 IniSet.common.ac= 0;
 //IniSet.common.delay= 0;
 //IniSet.common.skip= 1;
 //IniSet.common.fast= 0;
 IniSet.common.ref= 1;
 IniSet.common.fsFlt= 0.0;
 IniSet.common.prev_calibr_mode=3;

 for(j= 0; j<MAX_CHANNEL; j++) {  //  : 1,3,5,7/2,4,6,8
 	 if(j<4)
 	  {
       IniSet.chan[j].onoff= 1;
       IniSet.chan[j].scale= 3;  // !!! tmp ??? 80 mV
      }
     else
 	  {
       IniSet.chan[j].onoff= 0;
       IniSet.chan[j].scale= 0;  // !!! tmp ??? 80 mV
      }
     
     
       
 };

};


//#define INIFNAME "inifile.ini"
static char theDIR[FNAMELEN+1], theMDESCR[COMMENTLEN+1];
void readINI(char *xdir, char *mdescr) {  //  INI  
  FILE *f;
  char fname[FNAMELEN+1];
  strcpy(theDIR, xdir);
  strcpy(theMDESCR, mdescr);  
  fillINI();
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);
  if((f= fopen(fname, "rb")) == NULL) 
    return;
   
    
    
  fread (&IniSet, sizeof(IniSet_XXX), 1, f); //     
  fclose(f);
};

static void writeINI(void) { //     
  FILE *f;
  char fname[FNAMELEN+1];  
  sprintf(fname, "%s\\%s", theDIR, theMDESCR);
  if((f= fopen(fname, "wb")) == NULL) return;
  fwrite (&IniSet, sizeof(IniSet_XXX), 1, f);
  fclose(f);
};

// -------------------------------------------------------------------------------------
static void showINI(void) {
 int  j;
 int Mode4_Or_8=0;

 SetCtrlVal(Pnl, P(point), IniSet.point);
 SetCtrlVal(Pnl, P(ppoint), IniSet.ppoint);
  
 SetCtrlVal(Pnl, P(acq_mode), IniSet.common.mode);
 SetCtrlVal(Pnl, P(clb),  IniSet.common.clb);
 SetCtrlVal(Pnl, P(fabric_clb),  IniSet.common.FabricClb); 
 SetCtrlVal(Pnl, P(iir),  IniSet.common.iir);
 SetCtrlVal(Pnl, P(fir),  IniSet.common.fir);
 SetCtrlVal(Pnl, P(decimation), IniSet.common.decimation);
 SetCtrlVal(Pnl, P(taps), IniSet.common.taps);
 //SetCtrlVal(Pnl, P(fdiv), IniSet.common.fdiv);
 //SetCtrlVal(Pnl, P(chop), IniSet.common.chop);
 SetCtrlVal(Pnl, P(ac),   IniSet.common.ac);
 //SetCtrlVal(Pnl, P(delay), IniSet.common.delay);
 //SetCtrlVal(Pnl, P(skip),  IniSet.common.skip);
 //SetCtrlVal(Pnl, P(fast),  IniSet.common.fast);
 SetCtrlVal(Pnl, P(ref),   IniSet.common.ref);
 
 SetCtrlVal(Pnl, P(iirname),  IniSet.common.iirname);
 SetCtrlVal(Pnl, P(firname),   IniSet.common.firname);
 SetCtrlVal(Pnl, P(fsFlt),   IniSet.common.fsFlt); 

 
 if(IniSet.common.mode==2)
  Mode4_Or_8=1;
 
 for(j= 0; j< (MAX_CHANNEL); j++) {
     if(j>=4) {
       SetCtrlAttribute(Pnl, winScale[j], ATTR_DIMMED, !Mode4_Or_8);
       SetCtrlAttribute(Pnl, winChan[j], ATTR_DIMMED, !Mode4_Or_8);
     };
     SetCtrlAttribute(Pnl, winScale[j], ATTR_VISIBLE, IniSet.chan[j].onoff);
     
     SetCtrlVal(Pnl, winChan[j], IniSet.chan[j].onoff);
     SetCtrlVal(Pnl, winScale[j], IniSet.chan[j].scale);     
 };
 

};

static int numOfVChan(void);

static void copyIni2Ltr212Struc(TLTR212 *hltr212) {
 int j, k;
 
 hltr212->AcqMode=  IniSet.common.mode;   // 0 : 4-x, 1: 8
 hltr212->UseClb= IniSet.common.clb;
 hltr212->UseFabricClb= IniSet.common.FabricClb;   
 
 hltr212->LChQnt= numOfVChan();
 for(k= 0, j= 0; j< 8; j++) {
   if(!IniSet.chan[j].onoff) continue;
   hltr212->LChTbl[k]=  LTR212_CreateLChannel(thePhysChannel[j], IniSet.chan[j].scale);
   k++;
 };

 hltr212->filter.IIR= IniSet.common.iir;
 hltr212->filter.FIR= IniSet.common.fir;
 hltr212->filter.Decimation= IniSet.common.decimation;
 hltr212->filter.TAP= IniSet.common.taps;
 strcpy(hltr212->filter.IIR_Name, IniSet.common.iirname);
 strcpy(hltr212->filter.FIR_Name, IniSet.common.firname);

 //hltr212->codec.Fdivider= IniSet.common.fdiv;
 //hltr212->codec.CHOP= IniSet.common.chop;
 //hltr212->codec.SKIP= IniSet.common.skip;
 //hltr212->codec.FAST= IniSet.common.fast;
 hltr212->AC= IniSet.common.ac;
 //hltr212->codec.Delay= IniSet.common.delay;
 hltr212->REF= IniSet.common.ref;

//   double VChRate;
//   char Serial[16]; 
};

// -------------------------------------------------------------------------------------

static TCONTEXT theTCONTEXT;

int utspConfigDevice(TCONTEXT *tc, void *q) {
  char ppath[FNAMELEN+1];
  
  
  
  memcpy(&theTCONTEXT, tc, sizeof(TCONTEXT));
  
  readINI(tc->dllpath, tc->mdescr);
  sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
  strcpy(thePATH, ppath);
  
  Pnl= LoadPanelEx (0, ppath, PANEL, __CVIUserHInst); 
 
  
  showINI();  
  
  SetCtrlAttribute(Pnl, P(point), ATTR_MAX_VALUE, MAXNPOINTS);
  
  InstallPopup(Pnl);

  mf_freq (Pnl, 0, EVENT_COMMIT, NULL, 0, 0);
  //mf_acq_mode (Pnl, P(mode), EVENT_COMMIT, NULL, 0, 0);    //   mf_freq
  mf_ac (Pnl, 0,  EVENT_COMMIT, NULL, 0, 0);
  //mf_ac (Pnl, P(delay), EVENT_COMMIT, NULL, 0, 0);              
  
  mf_point (Pnl, P(point), EVENT_COMMIT, NULL, 0, 0);
  
  //get_serial();
  return 0;
};

// ------------------------------------------------
static int numOfVChan(void) {
 int n= 0, j;
 for(j= 0; j< MAX_CHANNEL; j++) if(IniSet.chan[j].onoff) n++;
 return n;
};

static int getCtrlVals(void) {
int j;
			GetCtrlVal(Pnl, P(point), &IniSet.point);
			GetCtrlVal(Pnl, P(ppoint), &IniSet.ppoint);
			
 			GetCtrlVal(Pnl, P(acq_mode), &IniSet.common.mode);
 			GetCtrlVal(Pnl, P(clb),  &IniSet.common.clb);
 			GetCtrlVal(Pnl, P(fabric_clb),  &IniSet.common.FabricClb);    
 			GetCtrlVal(Pnl, P(iir),  &IniSet.common.iir);
 			GetCtrlVal(Pnl, P(fir),  &IniSet.common.fir);
 			GetCtrlVal(Pnl, P(decimation), &IniSet.common.decimation);
 			GetCtrlVal(Pnl, P(taps), &IniSet.common.taps);
 			GetCtrlVal(Pnl, P(ac),   &IniSet.common.ac);
 			GetCtrlVal(Pnl, P(ref),   &IniSet.common.ref);		    
            GetCtrlVal(Pnl, P(iirname),  IniSet.common.iirname);
            GetCtrlVal(Pnl, P(firname),   IniSet.common.firname); 
            GetCtrlVal(Pnl, P(fsFlt),   &IniSet.common.fsFlt); 
 
 			for(j= 0; j< MAX_CHANNEL; j++) {
     			GetCtrlVal(Pnl, winChan[j], &IniSet.chan[j].onoff);
     			GetCtrlVal(Pnl, winScale[j], &IniSet.chan[j].scale);     
 			}; 
 			return 0;
};

int CVICALLBACK mf_apply (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {


	switch (event) {
		case EVENT_COMMIT:
		    getCtrlVals();
		    
		    if(!numOfVChan()) {
		        MessagePopup(MSG_WARNING, "Invalid number of channels: 0");
		        break;
		    };		
 			
		    writeINI(); 
		    DiscardPanel(Pnl);
		    Pnl= -1;		    
		break;
	}
	return 0;
};

// ***********************************************************************
static HANDLE hThread;
static int (*dataUpdateCBF)(int nchan, serviceStrucData X[], char *info)= NULL;
static UINT32 rd_buf[MAXNPOINTS * MAX_CHANNEL];
static double rd_buf_double[MAXNPOINTS * MAX_CHANNEL];
static double rd_buf_double_u[MAXNPOINTS * MAX_CHANNEL];
static double ibuf[MAX_CHANNEL][MAXNPOINTS];
static double dbuf[MAX_CHANNEL][MAXNPOINTS];
static serviceStrucData serviceDATA[MAX_CHANNEL];

static int runFlag;
static int CalibrFlag=0; 


int calcTimeOutMs(void);

static void DataRecorder(void *par) {
 int cnt, j, r, p;
 int n=  numOfVChan(), to;/*= calcTimeOutMs()*/
 DWORD xp, xp2;
 int q;
 double fb;
 LPCSTR error_string;

 
 to=LTR212_CalcTimeOut(&hltr212, IniSet.point);
 
 while(runFlag) { 
 
 //  !!!
 
 //err=LTR212_Start(&hltr212);
 
 
   cnt= LTR212_Recv(&hltr212, rd_buf, NULL, 2*n*IniSet.point, /*15000/*5000*//*2**/to);


   for(j= 0; j< n; j++) {
       serviceDATA[j].point= 0;
       serviceDATA[j].iarray= NULL; 
       serviceDATA[j].darray= NULL; 
       serviceDATA[j].fs= 0;
   };
   
   if(cnt<= 0) 
   {
        
      MessagePopup(MSG_ERROR, "Samples are not received!!!");  
      runFlag=0;
      goto __skip_processing;
   }
   else {
     if(cnt != 2*n*IniSet.point) 
     {
     MessagePopup(MSG_ERROR, "Less samples received, than it was purchased");  
     runFlag=0;
     goto __skip_processing;  
     };
   };
   
   xp= 2*n*IniSet.ppoint; //cnt;
   xp2= xp;
    

 
   r= LTR212_ProcessData(&hltr212, rd_buf,rd_buf_double, &xp, 0/*, &bad_sample_num*/); // !!! tmp  : BOOL calibr
 
   
   if(r) 
   {
    
    error_string=LTR212_GetErrorString(r);
     
    MessagePopup(MSG_ERROR, error_string);   
    
    
 
    runFlag=0;
    goto __skip_processing;
    
   
   }//__skip_processing;}  
   
   r|= LTR212_ProcessData(&hltr212, rd_buf, rd_buf_double_u, &xp2, 1/*,&bad_sample_num*/); // !!! tmp    
   q= xp / n;   
   
   if(!q)
    {
     MessagePopup(MSG_ERROR, "LTR212: Less samples received, than it was purchased");  
     runFlag=0;
     goto __skip_processing;  
    } 
   
   if(r || !q) {

   };
   
   if(r) {
   };

   if(q!= IniSet.ppoint) {

        if(!q) goto __skip_processing;      
   };
   
   
   for(j= 0; j< n; j++) {
       serviceDATA[j].point=  q;
       serviceDATA[j].iarray= ibuf[j]; 
       serviceDATA[j].darray= dbuf[j];
       calcFS(&fb, &serviceDATA[j].fs); 
       for(p= 0; p< q; p++) {
           ibuf[j][p]= rd_buf_double[j + p*n];  
           dbuf[j][p]= rd_buf_double_u[j + p*n];  // !!! tmp
       };
   };


__skip_processing:


   
   dataUpdateCBF(n, serviceDATA, NULL);
   Sleep(0);
   
   
 
   
 };
__end_acq:

 


 



 ExitThread(0);
 
};

extern int testPlolog(TCONTEXT *tc);
extern void closeModule(void);

int configHW(TCONTEXT *tc, TLTR212 *hltr212) {
 int j;
 LPCSTR error_string;
 
 
 readINI(tc->dllpath, tc->mdescr);
 copyIni2Ltr212Struc(hltr212);
 
 
 
 if( (j=LTR212_SetADC(hltr212)) ) 
 {
 
 
 error_string=LTR212_GetErrorString(j);         
 if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 

 
 return j;
 }
 return 0;
};


int utspStart(TCONTEXT *tc, void *p) {
  DWORD TmpDWord;
  plugStartStruc *X;
  int err;
  LPCSTR error_string;
  

  X= (plugStartStruc *)p;
  if(testPlolog(tc)) return 1;  // !!! ??? tmp
  if(err=configHW(tc, &hltr212)) {
     closeModule();
     return err;
  };
  
  
  dataUpdateCBF= X->coreCBF; // (dataUpdateCBF_FPtr)p;
  if(error=LTR212_Start(&hltr212)) {
  
   error_string=LTR212_GetErrorString(error);
    if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
   
     closeModule();
     return 1;  
  };


//  !!!
//err=LTR212_Stop(&hltr212); 

  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);

  ResumeThread(hThread);        // start thread here
  
  return 0;
};


int utspStop(TCONTEXT *tc, void *p) {

  LPCSTR error_string;

  runFlag= 0;
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  
  if(error=LTR212_Stop(&hltr212)) {
  
  error_string=LTR212_GetErrorString(error);         
  if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);               
  
     closeModule();
     return 1;    
  };

  closeModule();   // !!!          - 
   //   openmodule    
  return 0;
};


// *******************************************************************************

// -------------------------------------------------------------
static int showWPanel(int ppnl, char *msg) {
  
  int p= LoadPanelEx(ppnl, thePATH, WP, __CVIUserHInst);  
  if(msg!= NULL) {
    // ... 
  };
  InstallPopup(p);
  return p;
};
// -------------------------------------------------------------
static void hideWPanel(int p) {
 DiscardPanel(p);
};
// -------------------------------------------------------------
int utspConfigTe01Ext(TCONTEXT *tc, void *p) {
  return 0;
};



// -------------------------------------------------------------

// -------------------------------------------------------------
static void makeAdcVChanDescr(int ind, char X[COMMENTLEN+1]) {
    double fsBase, fs;
    
    calcFS(&fsBase, &fs);
    
    sprintf(X, "Ch%d,D:%s,Fs=%.1lf Hz",
                  thePhysChannel[ind], theScalesVal[IniSet.chan[ind].scale], fs);    
};
// -------------------------------------------------------------
int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int ch) { 
 int    ind= -1, q= 0, j;
 double fb;
 if(!ch) readINI(tc->dllpath, tc->mdescr);
 
 memset(D, 0x0, sizeof(pluginADC));
 
 for(j= 0; j< 8; j++) {
     if(IniSet.chan[j].onoff) {
        if(q == ch) { ind= j; break; };
        q++;
     };
 };
 
 D->type= UTSADC_FAST_SYNC; 
 D->nchan= numOfVChan();
 calcFS(&fb, &D->fs);
 
 if(ind == -1) return 1;
 
 D->channel= ch;
 
 makeAdcVChanDescr(ind, D->comment);
 
 
 if(IniSet.chan[ind].scale <= 3) {
    D->minU= -theScalesValDbl[IniSet.chan[ind].scale % 4];
    D->maxU= theScalesValDbl[IniSet.chan[ind].scale % 4];
 }
 else {
    D->minU= 0.0;
    D->maxU= theScalesValDbl[IniSet.chan[ind].scale % 4];
 };
 
 strcpy(D->unit, "V");    
 
 return 0;
};


int CVICALLBACK mf_mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, flag= 0;
	switch (event) {
		case EVENT_COMMIT:
		//	GetCtrlVal(Pnl, P(mode), &IniSet.common.mode);
			for(j= 4; j<8; j++) {
			   SetCtrlAttribute(Pnl, winScale[j], ATTR_DIMMED, !IniSet.common.mode);
			   SetCtrlAttribute(Pnl, winChan[j], ATTR_DIMMED, !IniSet.common.mode);
			   
			   SetCtrlVal(Pnl, winChan[j], IniSet.common.mode);
			   SetCtrlAttribute(Pnl, winScale[j], ATTR_VISIBLE, IniSet.common.mode);
			};
			SetCtrlAttribute(Pnl, P(iirselect), ATTR_DIMMED, IniSet.common.mode);
			
			SetCtrlAttribute(Pnl, P(firselect), ATTR_DIMMED, IniSet.common.mode);
			SetCtrlAttribute(Pnl, P(iir), ATTR_VISIBLE, !IniSet.common.mode);
			SetCtrlAttribute(Pnl, P(fir), ATTR_VISIBLE, !IniSet.common.mode);
			
			SetCtrlAttribute(Pnl, P(decor), ATTR_VISIBLE, IniSet.common.mode);
			
			if(IniSet.common.mode) {
			   if(IniSet.common.iir || IniSet.common.fir) {
			      SetCtrlVal(Pnl, P(iir), IniSet.common.iir= 0);
			      SetCtrlVal(Pnl, P(fir), IniSet.common.fir= 0);
			      flag= 1;
			   };
			};
			
			mf_freq (Pnl, 0, EVENT_COMMIT, NULL, 0, 0);   
			
			if(flag) 
			   MessagePopup(MSG_WARNING, "S/W filters are forbidden for the 8-channel mode,\nfilters has been disabled");
			break;
	}
	return 0;
}

int CVICALLBACK mf_chan (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, onoff;
	switch (event) {
		case EVENT_COMMIT:
 			for(j= 0; j< MAX_CHANNEL; j++) {
     			GetCtrlVal(Pnl, winChan[j], &IniSet.chan[j].onoff);
     			GetCtrlVal(Pnl, winScale[j], &IniSet.chan[j].scale);     
 			}; 
 			
			GetCtrlVal(Pnl, control, &onoff);
			for(j= 0; j< 8; j++) {
			    if(winChan[j] == control) {
			       break;
			    };
			};
			
			SetCtrlAttribute(Pnl, winScale[j], ATTR_VISIBLE, onoff);
			break;
	}
	return 0;
}

// **********************************************************************


// **********************************************************************

int CVICALLBACK mf_iirselect (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
char tmp[FNAMELEN+1], msg[FNAMELEN+1];
ltr212filter  X;
double fs;
	switch (event) {
		case EVENT_COMMIT:
			if(FileSelectPopup (theDIR, "*.flt", "*.dat;*.iir;*.txt",
								"LTR-212 IIR filter selector", VAL_SELECT_BUTTON, 0,
								0, 1, 0, tmp)!=1) break;
								
								
			if(LTR212_ReadFilter(tmp, &X)) {
			   MessagePopup(MSG_ERROR, "Failed read the filter you specified");
			   break;
			};
			
			GetCtrlVal(Pnl, P(fs0), &fs);
			if(X.fs != fs) {
			   sprintf(msg, "This filter (calculated for %.1lf Hz) does not correspond to the current Fs= %.1lf Hz",
			                        X.fs, fs);
			   MessagePopup(MSG_WARNING, msg);
			   break;			
			};
			
			if(X.taps!= 5) {
			   MessagePopup(MSG_WARNING, "IIR filter must have 5 koeffs");
			   break;						  
			};
			
			SetCtrlVal(Pnl, P(iirname), tmp);
			SetCtrlAttribute(Pnl, P(iir), ATTR_DIMMED, 0);
			SetCtrlVal(Pnl, P(fsFlt), IniSet.common.fsFlt= X.fs);  // !!!     FIR

			strcpy(IniSet.common.iirname, tmp);
			
            mf_freq (Pnl, 0, EVENT_COMMIT, NULL, 0, 0);   
             
			break;
	}
	return 0;
}

int CVICALLBACK mf_firselect (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
char tmp[FNAMELEN+1], msg[FNAMELEN+1];
ltr212filter  X;
double fs;
	switch (event) {
		case EVENT_COMMIT:
			if(FileSelectPopup (theDIR, "*.flt", "*.dat;*.fir;*.txt",
								"LTR-212 FIR filter selector", VAL_SELECT_BUTTON, 0,
								0, 1, 0, tmp)!=1) break;
								
			if(LTR212_ReadFilter(tmp, &X)) {
			   MessagePopup(MSG_ERROR, "Failed read the filter you specified");
			   break;
			};
			
			GetCtrlVal(Pnl, P(fs0), &fs);
			if(X.fs != fs) {
			   sprintf(msg, "This filter (calculated for %.1lf Hz) does not correspond to the current Fs= %.1lf Hz",
			                        X.fs, fs);
			   MessagePopup(MSG_WARNING, msg);
			   break;			
			};
			
			if(X.taps > MAXTAPS || X.taps < MINTAPS) {
			   sprintf(msg, "Invalid taps of FIR filter (%d)", X.taps);
			   MessagePopup(MSG_WARNING, msg);
			   break;						  
			};			
			
			SetCtrlVal(Pnl, P(firname), tmp);
			SetCtrlAttribute(Pnl, P(fir), ATTR_DIMMED, 0);
			SetCtrlVal(Pnl, P(taps), IniSet.common.taps= X.taps);
			SetCtrlVal(Pnl, P(decimation), IniSet.common.decimation= X.decimation);
			// SetCtrlVal(Pnl, P(fs), fs/X.decimation);
			SetCtrlVal(Pnl, P(fsFlt), IniSet.common.fsFlt= X.fs);  // !!!     IIR
			
			strcpy(IniSet.common.firname, tmp);
			
			mf_freq (Pnl, 0, EVENT_COMMIT, NULL, 0, 0);   
			break;
	}
	return 0;
}

void calcFS(double *fsBase, double *fs) {
 int d= 1;
 
 double fs_AcqMode[3]={7680.0, 150.15, 150.15};
 
  
 
	  
*fsBase=fs_AcqMode[IniSet.common.mode];
	   

   
 if(IniSet.common.fir) 
   {
     d= IniSet.common.decimation;
     
     *fs= *fsBase / d;
   } 
 else   
   *fs= *fsBase;
   
 if(IniSet.common.mode==2)
   *fs=3.4;
   

};

int CVICALLBACK mf_freq (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
double fsEff, fsBase, fsFlt;


	switch (event) {
		case EVENT_COMMIT:

			GetCtrlVal(Pnl, P(acq_mode), &IniSet.common.mode);			

			ProcessSystemEvents();

			GetCtrlVal(Pnl, P(fir), &IniSet.common.fir);
	        GetCtrlVal(Pnl, P(decimation), &IniSet.common.decimation);
	        
			calcFS(&fsBase, &fsEff);
			SetCtrlVal(Pnl, P(fs0), fsBase);
			SetCtrlVal(Pnl, P(fs), fsEff);
			GetCtrlVal(Pnl, P(fsFlt), &fsFlt);

			GetCtrlVal(Pnl, P(iir), &IniSet.common.iir);
			GetCtrlVal(Pnl, P(fir), &IniSet.common.fir);

			if(IniSet.common.mode!= 0 ){
			   SetCtrlAttribute(Pnl, P(iir), ATTR_DIMMED, 1);
			   SetCtrlAttribute(Pnl, P(fir), ATTR_DIMMED, 1);
			   if(IniSet.common.iir || IniSet.common.fir) 
			      MessagePopup(MSG_WARNING, "S/W Filters will be swithed off because of non-corresponding Fs");
			   SetCtrlVal(Pnl, P(iir), IniSet.common.iir= 0);
			   SetCtrlVal(Pnl, P(fir), IniSet.common.fir= 0);	
			   
			   //SetCtrlVal(Pnl, P(fs), fsBase);
			}
			else {
			   SetCtrlAttribute(Pnl, P(iir), ATTR_DIMMED, IniSet.common.iirname[0] ? 0 : 1);
			   SetCtrlAttribute(Pnl, P(fir), ATTR_DIMMED, IniSet.common.firname[0] ? 0 : 1);			
			};
			
           
            
            
            mf_point (Pnl, P(point), EVENT_COMMIT, NULL, 0, 0);
			break;
	}
	return 0;
}

int CVICALLBACK mf_ac (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(Pnl, P(ac),    &IniSet.common.ac);

			
			if(!IniSet.common.mode)
			  if(IniSet.common.ac) 
			   MessagePopup(MSG_WARNING, "AC reference is not effective in this acqusition mode"); 
			
			
				
			break;
	}
	return 0;
}

// -------- !!!   ,  Ini-  !!! TMP !!! 
int calcTimeOutMs(void) {
 double to, fbase, fs;
 
 calcFS(&fbase, &fs);
 to= 1e3 * IniSet.point / fs +TIMEOUT_CMD_RECIEVE;
 //to= 4/*2*/ * 1e3 * IniSet.point / fs + 0.5; 
 
 //if(to < 10000.0) to= 10000.0;
 return (int)to;
};

int CVICALLBACK mf_point (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
double fs;
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(Pnl, P(fs), &fs);
			GetCtrlVal(Pnl, P(point), &IniSet.point);
			GetCtrlVal(Pnl, P(ppoint), &IniSet.ppoint);
			SetCtrlVal(Pnl, P(time), 1e3 * IniSet.point / fs);
			SetCtrlVal(Pnl, P(to), (double)calcTimeOutMs());
			/*if(IniSet.ppoint > IniSet.point) 
			{ */
			   IniSet.ppoint= IniSet.point;
			   SetCtrlVal(Pnl, P(ppoint), IniSet.ppoint);
			/*}; */
			break;
	}
	return 0;
}

// *****************************************************************************
//
//                              
//
// *****************************************************************************
static int wData[8]= {CLB_d_1, CLB_d_2, CLB_d_3, CLB_d_4, CLB_d_5, CLB_d_6, CLB_d_7, CLB_d_8};
static int wSel[8]= {CLB_c_1, CLB_c_2, CLB_c_3, CLB_c_4, CLB_c_5, CLB_c_6, CLB_c_7, CLB_c_8};
static int wLed[8]= {CLB_l_1, CLB_l_2, CLB_l_3, CLB_l_4, CLB_l_5, CLB_l_6, CLB_l_7, CLB_l_8};

static void jumpToCalibrPanel(TCONTEXT *tc) {
 if(Pnl == -1) {
    utspConfigDevice(tc, NULL);
    mf_calibr (-1, -1, EVENT_COMMIT, NULL, 0, 0);
 };
 
};

// ****************************************************************************
int utspCalibrModule(TCONTEXT *tc) {
 jumpToCalibrPanel(tc);
 return 0;
};

// ****************************************************************************
int utspVerifyModule(TCONTEXT *tc) {
 jumpToCalibrPanel(tc);
 return 0;
};

// ************************************************************************
static int clbPnl= -1;
static int calibrStartData(TCONTEXT *tc, void *p);
static int calibrStopData(TCONTEXT *tc, void *p);

int CVICALLBACK mf_calibr (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int  p;
char ppath[FNAMELEN+1];
int  j;
	switch (event) {
		case EVENT_COMMIT:
		
			CalibrFlag=0;
			SetCtrlVal (Pnl, PANEL_fabric_clb, 0);
		    
		    getCtrlVals();
		    if(!numOfVChan()) {
		        MessagePopup(MSG_WARNING, "Invalid number of channels: 0");
		        break;
		    };		

		    writeINI();
		    copyIni2Ltr212Struc(&hltr212); 
		    
            sprintf(ppath, "%s\\%s", theDIR, "pluginuir.uir");
            p= LoadPanelEx (0, ppath, CLB, __CVIUserHInst);
            
            
            clbPnl= p;  //       
            
            for(j= 0; j< 8; j++) 
            {
                SetCtrlAttribute(p, wData[j], ATTR_VISIBLE, IniSet.chan[j].onoff);
                SetCtrlAttribute(p, wLed[j], ATTR_VISIBLE, IniSet.chan[j].onoff);
                SetCtrlAttribute(p, wSel[j], ATTR_VISIBLE, IniSet.chan[j].onoff);
                
                SetCtrlVal(p, CLB_list,   IniSet.common.prev_calibr_mode);  
                
            };
            InstallPopup(p);

            p= showWPanel(0, NULL);
            if(calibrStartData(&theTCONTEXT, NULL)) {
               MessagePopup(MSG_ERROR, "Failed start module");
            };
            hideWPanel(p);
			break;
	}
	return 0;
}

int CVICALLBACK clbf_close (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int p;
	switch (event) {
		case EVENT_COMMIT:
            p= showWPanel(0, NULL);
            if(calibrStopData(&theTCONTEXT, NULL)) {
               MessagePopup(MSG_ERROR, "Failed stop module");
            };
            closeModule();  // !!!    calibrStopData
             // !!!          - 
   //   openmodule    
   
   		    GetCtrlVal(panel, CLB_list,   &IniSet.common.prev_calibr_mode); 
   
            hideWPanel(p);
			DiscardPanel(panel);
			break;
	}
	return 0;
}



int CVICALLBACK clbf_mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int m, j;
	switch (event) {
		case EVENT_COMMIT:
			GetCtrlVal(panel, control, &m);
			for(j= 0; j< 8; j++) {
				SetCtrlAttribute (panel, wData[j], ATTR_PRECISION, m ? 0 : 3);  //   
			};
			break;
	}
	return 0;
}

int CVICALLBACK clbf_channel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, s, n= 0;
	switch (event) {
		case EVENT_COMMIT:
            for(j= 0; j< 8; j++) {
                GetCtrlAttribute(panel, wSel[j], ATTR_VISIBLE, &s);            
                if(!s) continue;
                
                GetCtrlVal(panel, wSel[j], &s);            
                SetCtrlAttribute(panel, wData[j], ATTR_DIMMED, !s);
                SetCtrlAttribute(panel, wLed[j], ATTR_DIMMED, !s);
                if(s) n++;
            };			
            
            SetCtrlAttribute(panel, CLB_list, ATTR_DIMMED, n ? 0 : 1);
            SetCtrlAttribute(panel, CLB_stage1, ATTR_DIMMED, n ? 0 : 1);

			break;
	}
	return 0;
}


// ---------------------------------------------------------------------------
//
//
// ---------------------------------------------------------------------------

static int calibrMode_Stage2[4]= {0, 3, 2, 1};

// ---------------------------------------------------------------------------
int CVICALLBACK clbf_stage1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) 
		{
int mode, visible, dimmed;
int j, r= 0;
int p;
int reset=0;
LPCSTR error_string;

BYTE VChannel_Mask=0;
	switch (event) 
	{
		case EVENT_COMMIT:
		
		
            p= showWPanel(0, NULL);
            if(calibrStopData(&theTCONTEXT, NULL))
            
            {
               MessagePopup(MSG_ERROR, "Failed stop module"); 
               hideWPanel(p);               
               break;
            };  

			GetCtrlVal(clbPnl, CLB_list, &mode);
			GetCtrlVal(clbPnl, CLB_reset, &reset);
			
			
		   
			for(j= 0; j< 8; j++)
			 {
			    GetCtrlAttribute(clbPnl, wData[j], ATTR_VISIBLE, &visible);
			    GetCtrlAttribute(clbPnl, wData[j], ATTR_DIMMED, &dimmed);
			    if(!visible) continue;
			    if(!dimmed)
			    
			     VChannel_Mask|=(1<<j);
			     
			  }   
			    
			    // By Milovanov for debug!!!
			    
			    //LTR212_EvaluateDACValue(&hltr212, 2); 
			    
			 
			        //  !!!!!
			        
			       if(mode==6)
			        {
			        
			          MessagePopup(MSG_WARNING, "Please, set zero voltage and press OK to continue calibration"); 
			          
			          r|= LTR212_Calibrate(&hltr212, &VChannel_Mask, 3, reset);
			           if(r)                                                                                       
			            {                                                                                          
			             //MessagePopup(MSG_ERROR, "Error during calibration, calibration aborted\nTry again");
			             
			             error_string=LTR212_GetErrorString(r);         
			             if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);          
			             
			             goto end_calibr;
			             };                                                                                         
			         
			          MessagePopup(MSG_WARNING, "Please, set full range voltage and press OK to continue calibration");
			          
			          r|= LTR212_Calibrate(&hltr212, &VChannel_Mask, 6, reset);
			         } //  if (mode==5)   
			         
			       else  
			       
			         if((mode==3)||(mode==5))
			           MessagePopup(MSG_WARNING, "Please, set zero voltage and press OK to continue calibration");
			         if(mode==4)
			           MessagePopup(MSG_WARNING, "Please, set full range voltage and press OK to continue calibration");
			           
			           
			         
			         r|= LTR212_Calibrate(&hltr212, &VChannel_Mask, mode, reset);  // reset= 1 !
			         
			         
			       if(r) 
			       
			       {
			            error_string=LTR212_GetErrorString(r);  
			            
			            //if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
			            
        if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(TFMSG_INIT_END, NULL);  
        //WriteToLogFile(Error_String);
        
        if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string);
			            
			          
			                       
			          
			          goto end_calibr;
			          //break;
			       };
			   /* };
			    vchan++;  // !!! __
			}; */ //  !!!
	
			CalibrFlag=1; //  
 end_calibr:   
             
             if(calibrStartData(&theTCONTEXT, NULL)) 
              {
               MessagePopup(MSG_ERROR, "Failed start module");
               //if(theTCONTEXT.cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);  
              };
            
            hideWPanel(p);			
			break;
	} //  switch
	return 0;
}  //  

int CVICALLBACK clbf_stage2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
		
int mode, visible, dimmed;
int j;
int p;
BYTE VChannel_Mask=0; 

	switch (event) {
		case EVENT_COMMIT:
			if(!ConfirmPopup(MSG_WARNING, "Have you finished the first stage?")) break;
			
			
	p= showWPanel(0, NULL);
            if(calibrStopData(&theTCONTEXT, NULL)) {
               MessagePopup(MSG_ERROR, "Failed stop module"); 
               hideWPanel(p);               
               break;
            };  

            //tcontext_global=
			GetCtrlVal(clbPnl, CLB_list, &mode);
			
			mode= calibrMode_Stage2[mode - 4];
			
			for(j= 0; j< 8; j++)
			 {
			    GetCtrlAttribute(clbPnl, wData[j], ATTR_VISIBLE, &visible);
			    GetCtrlAttribute(clbPnl, wData[j], ATTR_DIMMED, &dimmed);
			    if(!visible) continue;
			    if(!dimmed)
			    
			     VChannel_Mask|=(1<<j);
			     
			  }   
			
			
			
            if(calibrStartData(&theTCONTEXT, NULL))
            
            {
               MessagePopup(MSG_ERROR, "Failed start module");
            };
            
            hideWPanel(p);					
			
			
			
			
			break;
			
	}  //  switch
	return 0;
} //  

int CVICALLBACK clbf_list (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int i;
	switch (event) {
		case EVENT_COMMIT:
	        GetCtrlVal(panel, control, &i);
	        //SetCtrlAttribute(panel, CLB_stage2, ATTR_VISIBLE, i > 3 ? 1:0);
	        //SetCtrlAttribute(panel, CLB_text, ATTR_VISIBLE, i > 3 ? 1:0);
			break;
	}
	return 0;
}

int CVICALLBACK clbf_toggle (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, flag= 0, s;
	switch (event) {
		case EVENT_COMMIT:
			for(j= 0; j< 8; j++) {
                GetCtrlAttribute(panel, wSel[j], ATTR_VISIBLE, &s);            
                if(!s) continue;
                
                GetCtrlVal(panel, wSel[j], &s);
                if(s) { flag= 1; break; };
			};
			
			for(j= 0; j< 8; j++) {
                GetCtrlAttribute(panel, wSel[j], ATTR_VISIBLE, &s);            
                if(!s) continue;
                SetCtrlVal(panel, wSel[j], !flag);
			};
			
			clbf_channel (panel, -1, EVENT_COMMIT, NULL, 0, 0);
			break;
	}
	return 0;
}

// *****************************************************************************************
/*
typedef struct {
  int     point;
  double *iarray;
  double *darray;
  double  fs;
} serviceStrucData;
*/

static int calibrDataUpdate(int nchan, serviceStrucData X[], char *info) {
  int j, s, mode, ind= 0;
  double mean;
  
  GetCtrlVal(clbPnl, CLB_mode, &mode);  // =0 : mV
  
  for(j= 0; j<nchan; j++) {
      GetCtrlAttribute(clbPnl, wData[j], ATTR_VISIBLE, &s);
      if(!s) continue;  //  ,   
      GetCtrlAttribute(clbPnl, wData[j], ATTR_DIMMED, &s);
      if(!s) {
         if(!mode && (X[ind].darray!= NULL) ) {
             Mean(X[ind].darray, X[ind].point, &mean);
             SetCtrlVal(clbPnl, wData[j], mean);
         };
         if(mode && (X[ind].iarray!= NULL) ) {
             Mean(X[ind].iarray, X[ind].point, &mean);
             SetCtrlVal(clbPnl, wData[j], mean);
         };      
       };
       
       ind++;        // !!!   !
  };
  GetCtrlVal(clbPnl, CLB_led, &j);
  SetCtrlVal(clbPnl, CLB_led, !j);
  return 0;
};

// *****************************************************************************************
static void calibrDataRecorder(void *par) {
 int    cnt, j, r, p;
 int    n=  numOfVChan(), to= calcTimeOutMs();
 DWORD xp, xp2;
 int    q;
 double fb;
 
 while(runFlag) { 
   cnt= LTR_Recv(&hltr212.Channel, rd_buf, NULL, 2*n*IniSet.point, to);

   for(j= 0; j< n; j++) {
       serviceDATA[j].point= 0;
       serviceDATA[j].iarray= NULL; 
       serviceDATA[j].darray= NULL; 
       serviceDATA[j].fs= 0;
   };
   
   if(cnt<= 0) goto __skip_processing;

   xp= 2*n*IniSet.ppoint; // cnt;
   xp2= xp;
   
   // By Milovanov for debug!!!
   r= LTR212_ProcessData (&hltr212, rd_buf, rd_buf_double, &xp, 0); 
   r|= LTR212_ProcessData (&hltr212, rd_buf, rd_buf_double_u, &xp2, 1); // !!! tmp    
   q= xp/n;   
   
   if(q!= IniSet.ppoint) if(!q) goto __skip_processing;      
   
   for(j= 0; j< n; j++) {
       serviceDATA[j].point=  q;
       serviceDATA[j].iarray= ibuf[j]; 
       serviceDATA[j].darray= dbuf[j];
       calcFS(&fb, &serviceDATA[j].fs); 
       for(p= 0; p< q; p++) {
           ibuf[j][p]= rd_buf_double[j + p*n];  
           dbuf[j][p]= rd_buf_double_u[j + p*n];  // !!! tmp
       };
   };

__skip_processing:

  if(IniSet.common.mode!=2)
   calibrDataUpdate(4, serviceDATA, NULL);
  else 
   calibrDataUpdate(8, serviceDATA, NULL); 
   
   Sleep(0);
 };
 
 
 // runFlag= 2;
 ExitThread(0);
 
};

// *****************************************************************************
static int calibrStartData(TCONTEXT *tc, void *p) {
  DWORD TmpDWord;
  plugStartStruc *X;
  int err=0;
  LPCSTR error_string;

//return 0;

  runFlag= 0;	   //      uts??Start    !!! tmp
  
  X= (plugStartStruc *)p;
  err=testPlolog(tc);
  if(err)
    return 1;  // !!! ??? tmp
  
  if(!CalibrFlag)
   {
    if(configHW(tc, &hltr212)) 
     {
      closeModule();
      return 1;
     }
    } 
  else
   {
   hltr212.UseClb=1;
   if(error=LTR212_SetADC(&hltr212))
    {
	  error_string=LTR212_GetErrorString(error);         
      if(theTCONTEXT.cbf!=NULL) theTCONTEXT.cbf(MIDCER_STOP_ERROR, (char*)error_string); 
      return 1;
    }  
   } 			             
     
  
  if(error=LTR212_Start(&hltr212)) {
  
     error_string=LTR212_GetErrorString(error); 
     if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);  
     
     //MessagePopup(MSG_ERROR, error_string);             
     
     
     closeModule();
     return 1;  
  }; 

  runFlag= 1;
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)calibrDataRecorder, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);

  ResumeThread(hThread);        // start thread here
  
  return 0;
};


static int calibrStopData(TCONTEXT *tc, void *p) {
  
  
  LPCSTR error_string;

//return 0;

  if(!runFlag) return 0;   //      uts??Start    !!! tmp        
  
  runFlag= 0;
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  if(error=LTR212_Stop(&hltr212)) {
  
     error_string=LTR212_GetErrorString(error);           
      if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);             
  
  
     closeModule();
     return 1;    
  };
  

  return 0;
};






int CVICALLBACK mf_acq_mode (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	
int j, flag= 0, Mode4_Or_8=0;                                                                                                                      
	switch (event) {                                                                                                                 
		case EVENT_COMMIT:                                                                                                           
			GetCtrlVal(Pnl, P(acq_mode), &IniSet.common.mode); 
			
			if(IniSet.common.mode==2)
			  Mode4_Or_8=1;
			else
			  Mode4_Or_8=0;
			
			 for(j= 4; j<8; j++) 
			 {                                                                                                    
			   SetCtrlAttribute(Pnl, winScale[j], ATTR_DIMMED, !Mode4_Or_8);                                                 
			   SetCtrlAttribute(Pnl, winChan[j], ATTR_DIMMED, !Mode4_Or_8);                                                  
			                                                                                                                         
			   SetCtrlVal(Pnl, winChan[j], Mode4_Or_8);                                                                      
			   SetCtrlAttribute(Pnl, winScale[j], ATTR_VISIBLE, Mode4_Or_8);                                                 
			  };
			
			
			SetCtrlAttribute(Pnl, P(iirselect), ATTR_DIMMED, Mode4_Or_8);                                                    
			SetCtrlAttribute(Pnl, P(firselect), ATTR_DIMMED, Mode4_Or_8);                                                    
			SetCtrlAttribute(Pnl, P(iir), ATTR_VISIBLE, !Mode4_Or_8);                                                        
			SetCtrlAttribute(Pnl, P(fir), ATTR_VISIBLE, !Mode4_Or_8);                                                        
			                                                                                                                         
			SetCtrlAttribute(Pnl, P(decor), ATTR_VISIBLE, Mode4_Or_8);                                                       
			                                                                                                                         
			if(Mode4_Or_8) {                                                                                                 
			   if(IniSet.common.iir || IniSet.common.fir) {                                                                          
			      SetCtrlVal(Pnl, P(iir), IniSet.common.iir= 0);                                                                     
			      SetCtrlVal(Pnl, P(fir), IniSet.common.fir= 0);                                                                     
			      flag= 1;                                                                                                           
			   };                                                                                                                    
			};                                                                                                                       
			                                                                                                                         
			mf_freq (Pnl, 0, EVENT_COMMIT, NULL, 0, 0);                                                                        
			                                                                                                                         
			if(flag)                                                                                                                 
			   MessagePopup(MSG_WARNING, "S/W filters are forbidden for the 8-channel mode,\nfilters has been disabled");            
			break;                                                                                                                   
	}                                                                                                                                
	return 0;                                                                                                                        
}                                                                                                                                    
                                                                                                                                     



int CVICALLBACK mf_UseClb (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		
		SetCtrlVal (Pnl, PANEL_fabric_clb, 0);
		

			break;
		}
	return 0;
}

int CVICALLBACK mf_UseFabricClb (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
		
		 SetCtrlVal (Pnl, PANEL_clb, 0);  

			break;
		}
	return 0;
}




