#ifndef XXX_LOCAL_DEFS__H
#define XXX_LOCAL_DEFS__H

#define MAXNPOINTS 32768

#define TE01EXTNAME   "TE-01-EXT" // 9 char maximum

#include "uts/services/common/include/servicedef.h"

#define MAX_CHANNEL 8
#define MAX_BAND 8

#define TE01ADC_BAND_for_LTR212 3
#define TE01DAC_BAND_for_LTR212 2

/*    .*/
typedef int (*DataUpdateFunc)(int nchan, serviceStrucData X[], void *descriptor);

/*   .*/
typedef void (*fDataRecorder)(void *par);

/* :    .*/
enum eMode {CODE_DATA_MODE, VALUE_DATA_MODE};

/*     .*/
typedef struct {
	/*   .*/
	DataUpdateFunc update_func;
	/*    timeout .*/
	int timeout;
	/*  ,  runFlag   0.*/
	int runFlag;
	/* .*/
	int errorFlag;
	/*    .*/
	int buf_size;
	/* .*/
	int channels;
	/*     .*/
	int *stored;
	/*  .*/
	double **buffer;
	/*  :    .*/
	enum eMode mode;
} tDataRecord;

#pragma pack(1)
typedef struct {
  int mode;
  int clb;
  int FabricClb;
  int iir;
  int fir;
  int decimation;
  int taps;
  char iirname[512];
  char firname[512];
  int ac;
  int  ref;
  double fsFlt;
  
  int prev_calibr_mode;
} IniSet_common;

typedef struct {
  int  onoff;
  int  scale;
} IniSet_chan;

typedef struct {
  int point;  // - 
  int ppoint;  // - process points
  IniSet_common common; //    
  IniSet_chan  chan[MAX_CHANNEL];//     (, ...)
} IniSet_XXX;
#pragma pack()
#define LTR212METR

int LC212DataUpdate(int nchan, serviceStrucData X[], void* descriptor);
void LC212DataRecorder(void *par);
int GetFrame(TCONTEXT *tc, double *buf);
int CalibrateModule(TCONTEXT *tc);
int VerifyModule(TCONTEXT *tc);
int metrVirtualDevice(TCONTEXT *tc, void *p);

#endif


