#ifndef ltr212clb_coeffs_h
#define ltr212clb_coeffs_h

#include "ltr/include/ltr212api.h"

typedef struct {
	int offset;
	int scale;
} LTR212clb_coeffs;

LTR212clb_coeffs** create_coeffs_table(void);

void delete_coeffs_table(LTR212clb_coeffs** coeffs);

int read_coeffs(descr_ltr212 *h, LTR212clb_coeffs **coeffs);

int write_coeffs(descr_ltr212 *h, LTR212clb_coeffs **coeffs);

int copy_coeffs(descr_ltr212 *h, int band);

int calc_coeffs(LTR212clb_coeffs **coeffs, int band, int channel,
								double max_etalon, double min_etalon, double max_val, double min_val,
								double zero_etalon, double zero_val);

double correct_value(LTR212clb_coeffs **coeffs, int band, int channel, double value);

double correct_code(LTR212clb_coeffs **coeffs, int band, int channel, double value);

double value2code(double value, int band);

double code2value(double code, int band);

#endif
