#include <ansi_c.h>
#include "uts/systems/common/include/plugindef.h"
#include "uts/systems/common/include/pluginexport.h"
#include "uts/systems/common/include/utspfunc.h"
#include "uts/systems/ltr/ltr212/tflist.h"
#include "localdefs.h"

extern void closeModule(void);
extern void closeUIR(void);

void closeThisPlugin(void) {
  closeModule();
  closeUIR();
};

static pluginDefine thePlugin= {
 PNAME("LTR212"), 
 PVERSION("1.0"), 
 PDESCR("Metrology LTR-212 module plugin"),
 PIMAGE_MCU(""),
 PIMAGE_MCU(""),
 PIMAGE_MCU("bios\\ltr212.bio"),
 
 {  NEED_TE01, PTE01EXT_NAME(NULL/*"TE-01A212"*/), 
   !NEED_KEITHLEY,
   PTYPE_STD
 },

 {
   PHELP_MANUAL("manual.pdf"),
   PHELP_DEV_HW_DESCR(NULL),
   PHELP_DEV_SCHEME(NULL), 
   PHELP_DEV_CABLES(NULL),
   PHELP_TE01EXT_HW_DESCR(NULL),   
   PHELP_TE01EXT_SCHEME(NULL),
 },

 PFPTR_INIT_MODULE(utspInitModule),
 PFPTR_READ_DATA(NULL),			//extern int utspReadData(TCONTEXT *tc, void *);         
 PFPTR_WRITE_DATA(NULL),		//extern int utspWriteData(TCONTEXT *tc, void *);        
 PFPTR_WRITE_DATAFILE(NULL),		//extern int utspWriteFile(TCONTEXT *tc, void *);        
 PFPTR_CALIBR(NULL/*utspCalibrModule*/),    	//extern int utspCalibrModule(TCONTEXT *tc);             
 PFPTR_VERIFY(utspVerifyModule),	//extern int utspVerifyModule(TCONTEXT *tc);             
 PFPTR_SHOWPNL_TESTCFG(NULL),	//extern int utspConfigTest(TCONTEXT *tc, void *);       
 PFPTR_SHOWPNL_VIRTDEVICE(metrVirtualDevice),	//extern int utspVirtualDevice(TCONTEXT *tc, void *);    
 PFPTR_SHOWPNL_DEVCFG(utspConfigDevice),//extern int utspConfigDevice(TCONTEXT *tc, void *);     
 PFPTR_SHOWPNL_TE01CFG(NULL),//extern int utspConfigTe01Ext(TCONTEXT *tc, void *);    
 PFPTR_GETDESCR_ADC(utspGetDescrADC),	//extern int utspGetDescrADC(pluginADC *D, int channel); 
 PFPTR_GETDESCR_DAC(NULL),		//extern int utspGetDescrDAC(pluginDAC *D, int channel); 
 PFPTR_GETDESCR_DIO(NULL),		//extern int utspGetDescrDIO(pluginDIO *D, int channel); 
 PFPTR_GET_DIO(NULL),			//extern int utspGetDIO(TCONTEXT *tc, void *);           
 PFPTR_PUT_DIO(NULL),			//extern int utspPutDIO(TCONTEXT *tc, void *);           
 PFPTR_WRITE_MCU(NULL), 	//extern int utspWriteMCU(TCONTEXT *tc, void *);         
 PFPTR_WRITE_MCU(utspWriteMCUFlash),	      /* flash_write -> int utspWriteMCU(TCONTEXT *tc, void *); */
 PFPTR_WRITE_MCU(NULL), 	      /* fuse_read  -> int utspReadMCU(TCONTEXT *tc, void *); */
 PFPTR_WRITE_MCU(NULL), 	  /* fuse_write -> int utspWriteMCU(TCONTEXT *tc, void *); */
 PFPTR_LOAD_ADSP(utspLoadADSP),
 PFPTR_MODULE_INFO(utspGetModuleInfo),	//extern int utspGetModuleInfo(TCONTEXT *tc, void *);
 PFPTR_START(utspStart),		//extern int utspStart(TCONTEXT *tc, void *);    
 PFPTR_STOP(utspStop)			//extern int utspStop(TCONTEXT *tc, void *);    
};

static TFuncDefine TFuncSet[]= {
#if 0
 {
  PNAME("TEST N"), 
  PVERSION("0.1"), 
  PDESCR("Test N description"),
    
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  testSNR
 }, 
#endif

 {
	PNAME("Calibrate"), 
	PVERSION("0.1"), 
	PDESCR("    Flash MCU"),
	
	{ TFTYPE_AUTO, !TFPASSPORT, TFUSE},
	CalibrateModule
 },
 
 {
  PNAME("Verify"),
  PVERSION("0.1"), 
  PDESCR("  ."),

  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  VerifyModule
 },

  NULL
};

pluginDefine * __stdcall readPluginDefine(void) {
  return &thePlugin;
};

int          __stdcall readTFuncNum(void) {
 int n= 0;
 TFuncDefine *p= &TFuncSet[0];
 while(p->name!=NULL) { n++; p++; };
 return n;
};

TFuncDefine * __stdcall readTFuncDefine(int num) {
 if(num > (readTFuncNum() - 1) ) return NULL;
 return &TFuncSet[num];
}

