#include "ltrspecificMy.h" 
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"  
#include <ansi_c.h>
#include "ltr\\include\\ltravrapi.h"
#include "ltr\\include\\ltr010api.h"
#include "localdefs.h" 

extern TLTR22 module;

//--------------------------------------------------------------
// 
//--------------------------------------------------------------
int utspReadMCUFlash(TCONTEXT *tc, void *p)
{ 
 int res=TRES_T_FAIL;
 ltrTContext *tclocal=tc->tcontext; 
 burnMcuContext *pbc=p;
 FILE *f;
 
 openModule(tc);  
 
 //
 if((f=fopen(pbc->fname, "rb"))!=NULL) 
 {
	 DWORD i, k, size, pages;
	 byte buf[ATMEGA8515_FLASH_SIZE]; 
	 memset(buf, 0xff, sizeof(buf));
	 
	 res=LTR22_ReadAVRBroaching(&module, buf, ATMEGA8515_FLASH_SIZE, 0, 16);
	 
	 size=fwrite(buf, sizeof(WORD), ATMEGA8515_FLASH_SIZE, f);
 }
 return res;
}

int utspWriteMCUFlash(TCONTEXT *tc, void *p)
{ 
 int res=TRES_T_FAIL;
 int i=0;
 ltrTContext *tclocal=tc->tcontext;
 burnMcuContext *pbc=p;
 TLTRAVR moduleAVR;
 FILE *f;
 
 //
 if((f=fopen(pbc->fname, "rb"))!=NULL) 
 {
	 DWORD i, k, size, pages;
	 WORD buf[ATMEGA8515_FLASH_SIZE];  
	 memset(buf, 0xff, sizeof(buf));
	 size=fread(buf, sizeof(WORD), ATMEGA8515_FLASH_SIZE, f);
 	 if(size>0) 
 	 {
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|10, "Read firmware from file -> ok");
		if (openModule(tc)==LTR_OK)
		{
			memset(module.ModuleInfo.Description.SerialNumber,0,sizeof(module.ModuleInfo.Description.SerialNumber));
			memcpy(module.ModuleInfo.Description.SerialNumber,pbc->serial,min(sizeof(pbc->serial),sizeof(module.ModuleInfo.Description.SerialNumber)));
			LTR22_WriteBroaching(&module,(BYTE *)buf,size*2,true, false); //      
	 		LTR22_Close(&module);
 		}
 		else
 		{  //    
 			//   
 			i=(sizeof(buf)-128+32);
			memcpy((byte*)buf+i,pbc->serial,min(sizeof(pbc->serial),16));												
 		}
 		
 		LTRAVR_Init(&moduleAVR);    
 	    //
 		if(LTRAVR_Open(&moduleAVR, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot)==LTR_OK) 
 		{
			if(LTRAVR_ChipErase(&moduleAVR)==LTR_OK) 
			{   
				DWORD t0;
				if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|20, "Chip erase -> ok");
				if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Write programm memory...");
				//
				pages=(size+ATMEGA8515_PAGE_SIZE-1)/ATMEGA8515_PAGE_SIZE;
				i=k=0;
				while(i<pages && k<3) 
				{
					DWORD offset=i*ATMEGA8515_PAGE_SIZE;
					if(LTRAVR_WriteProgrammMemory(&moduleAVR, buf+offset, ATMEGA8515_PAGE_SIZE, offset)==LTR_OK) 
					{
						if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|(80*(i+1)/pages+20), NULL);
						i++;
					} 
					else 
					{
						k++;	
					}
				}
				//
				if(i==pages) 
				{
					if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_PROGRESS|100, "Write programm memory -> ok");
					res=TRES_T_OK;
				} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't write programm memory!");
				
				
			} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't erase selected moduleAVR!");
			//
			LTRAVR_Close(&moduleAVR);
 		} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't open selected moduleAVR!");	
 	 } else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't read file with firmware!");
 	 //
 	 fclose(f);
 	 openModule(tc); 
 } else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't open file with firmware!");	 
 return res;
}
