#include "localdefs.h"
#include "tflist.h"
#include <ansi_c.h>
//-----------------------------------------------------------------------------
TLTR22 module;
TINFO_LTR22 description;
//-----------------------------------------------------------------------------
extern void closeUIR(void);
//-----------------------------------------------------------------------------
void openThisPlugin(void) 
{

}
//-----------------------------------------------------------------------------
void closeThisPlugin(void) 
{
 closeModule();
 closeUIR();
}   

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
static pluginDefine thePlugin= 
{
 PNAME("LTR22"), 
 PVERSION("1.0"), 
 PDESCR("Standart Factory LTR22 module tester"),

 PIMAGE_MCU("ATMega8515"),
 PIMAGE_MCU("ltr22_firmware.bin"),
 PIMAGE_MCU(NULL),
 { 
   NEED_TE01, PTE01EXT_NAME("TE-01 Supplementary LTR11 module"), 
   !NEED_KEITHLEY,
   PTYPE_STD
 },
 {
   PHELP_MANUAL("manual.pdf"),
   PHELP_DEV_HW_DESCR(NULL),
   PHELP_DEV_SCHEME("scheme.pdf"), 
   PHELP_DEV_CABLES("cables.pdf"),
   PHELP_TE01EXT_HW_DESCR(NULL),   
   PHELP_TE01EXT_SCHEME(NULL),
 },
 PFPTR_INIT_MODULE(NULL),    	    	    //extern int utspInitModule(TCONTEXT *tc, void *);       
 PFPTR_READ_DATA(NULL),						//extern int utspReadData(TCONTEXT *tc, void *);         
 PFPTR_WRITE_DATA(NULL),					//extern int utspWriteData(TCONTEXT *tc, void *);        
 PFPTR_WRITE_DATAFILE(NULL),				//extern int utspWriteFile(TCONTEXT *tc, void *);        
 PFPTR_CALIBR(utspCalibrModule),	 				   	//extern int utspCalibrModule(TCONTEXT *tc);             
 PFPTR_VERIFY(NULL),						//extern int utspVerifyModule(TCONTEXT *tc);             
 PFPTR_SHOWPNL_TESTCFG(utspConfigTest),		//extern int utspConfigTest(TCONTEXT *tc, void *);       
 PFPTR_SHOWPNL_VIRTDEVICE(NULL),			//extern int utspVirtualDevice(TCONTEXT *tc, void *);    
 PFPTR_SHOWPNL_DEVCFG(utspConfigDevice),    //extern int utspConfigDevice(TCONTEXT *tc, void *);     
 PFPTR_SHOWPNL_TE01CFG(utspConfigTe01Ext),  //extern int utspConfigTe01Ext(TCONTEXT *tc, void *);    
 PFPTR_GETDESCR_ADC(utspGetDescrADC),	  	//extern int utspGetDescrADC(pluginADC *D, int channel); 
 PFPTR_GETDESCR_DAC(NULL),					//extern int utspGetDescrDAC(pluginDAC *D, int channel); 
 PFPTR_GETDESCR_DIO(NULL),					//extern int utspGetDescrDIO(pluginDIO *D, int channel); 
 PFPTR_GET_DIO(NULL),						//extern int utspGetDIO(TCONTEXT *tc, void *);           
 PFPTR_PUT_DIO(NULL),						//extern int utspPutDIO(TCONTEXT *tc, void *);           
 PFPTR_WRITE_MCU(utspReadMCUFlash),	//extern int utspReadMCU(TCONTEXT *tc, void *);
 PFPTR_WRITE_MCU(utspWriteMCUFlash),	//extern int utspWriteMCU(TCONTEXT *tc, void *);         
 PFPTR_WRITE_MCU(utspDefaultReadMCUFuses),  //extern int utspReadMCUFuses(TCONTEXT *tc, void *);
 PFPTR_WRITE_MCU(utspDefaultWriteMCUFuses), //extern int utspWriteMCUFuses(TCONTEXT *tc, void *);
 PFPTR_LOAD_ADSP(NULL),  					//extern int utspLoadADSP(TCONTEXT *tc, void *);         
 PFPTR_MODULE_INFO(utspGetModuleInfo),		//extern int utspGetModuleInfo(TCONTEXT *tc, void *);
 PFPTR_START(utspStart),					//extern int utspStart(TCONTEXT *tc, void *);    
 PFPTR_STOP(utspStop)						//extern int utspStop(TCONTEXT *tc, void *);    
};
//-----------------------------------------------------------------------------
//   
//-----------------------------------------------------------------------------
static TFuncDefine TFuncSet[]= 
{
 {
  PNAME("Test MultiplexBus"), 
  PVERSION("0.1"), 
  PDESCR("Test module interface.       "),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestHardwareInterface
 },
 
 
 {
  PNAME("Test SNR"), 
  PVERSION("0.1"), 
  PDESCR("   - "),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestSNR
 },
 
 {
  PNAME("Test AFC DC"), 
  PVERSION("0.1"), 
  PDESCR("    DC"),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestAFC_DC
 },
 
 {
  PNAME("Test AFC AC"), 
  PVERSION("0.1"), 
  PDESCR("    AC"),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestAFC_AC
 },
 
 {
  PNAME("Test Sinfaz"), 
  PVERSION("0.1"), 
  PDESCR("  "),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestSinFaz
 },
 
  {
  PNAME("Test SyncStart"), 
  PVERSION("0.1"), 
  PDESCR("Test AlteraRanges.   "),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},
  utspTestSyncStart
 },
 
 {
  PNAME("Test Threshold"), 
  PVERSION("0.1"), 
  PDESCR("Test AlteraRanges.     "),
  { TFTYPE_AUTO, !TFPASSPORT, TFUSE},  
  utspVerifyThreshold
 },
 
 {
  PNAME("Test AlteraRanges"), 
  PVERSION("0.1"), 
  PDESCR("Test AlteraRanges.         "),
  { TFTYPE_AUTO, !TFPASSPORT, !TFUSE},
  utspTestRangesAltera
 },
 
 {
  PNAME("Test Ring"), 
  PVERSION("0.1"), 
  PDESCR("Test AlteraRanges.           "),
  { TFTYPE_AUTO, !TFPASSPORT, !TFUSE},
  utspTestRingSendRecieveData
 },
     
 NULL
};
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
pluginDefine * DLLEXPORT DLLSTDCALL readPluginDefine(void) 
{
 return &thePlugin;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
int DLLEXPORT DLLSTDCALL readTFuncNum(void) 
{
 int n= 0;
 TFuncDefine *p= &TFuncSet[0];
 while(p->name!=NULL) { n++; p++; };
 return n;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
TFuncDefine * DLLEXPORT DLLSTDCALL readTFuncDefine(int num) 
{
 if(num > (readTFuncNum() - 1) ) return NULL;
 return &TFuncSet[num];
}




