/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  P_CONFIG                        1       /* callback function: PanelConfigCallback */
#define  P_CONFIG_DECORATION_2           2
#define  P_CONFIG_DECORATION             3
#define  P_CONFIG_TEXTMSG_2              4
#define  P_CONFIG_TEXTMSG                5
#define  P_CONFIG_NUMERIC_FREQ_DIV_MAIN  6       /* callback function: ChangeFreqDivaser */
#define  P_CONFIG_BINSW_MES_ZERO         7       /* callback function: ChengeMeasureZero */
#define  P_CONFIG_BINSW_AC_DC_STATE      8       /* callback function: ChangeACDCState */
#define  P_CONFIG_BINSW_FREQ_DIV_EXTRA   9       /* callback function: ChangeFreqDivaser */
#define  P_CONFIG_RINGSLIDE_CH1          10      /* callback function: ChangeChanelRange1 */
#define  P_CONFIG_RINGSLIDE_CH2          11      /* callback function: ChangeChanelRange2 */
#define  P_CONFIG_RINGSLIDE_CH3          12      /* callback function: ChangeChanelRange3 */
#define  P_CONFIG_RINGSLIDE_CH0          13      /* callback function: ChangeChanelRange0 */
#define  P_CONFIG_ExternalStart          14      /* callback function: cbf_ExternalStart */
#define  P_CONFIG_MasterSlaveSelect      15      /* callback function: cbf_Generate_Sync_Out */
#define  P_CONFIG_calibr                 16      /* callback function: cbf_control */
#define  P_CONFIG_NUMERIC_FREQ           17
#define  P_CONFIG_SIZE_OSCIL_DISP        18      /* callback function: ChangeOscilDataSizeProc */
#define  P_CONFIG_SIZE_OSCIL             19      /* callback function: ChangeOscilDataSize */
#define  P_CONFIG_RING_FREQ_SAMPLES      20      /* callback function: SET_FREQ_SAMPLE */
#define  P_CONFIG_DECORATION_4           21
#define  P_CONFIG_DECORATION_3           22
#define  P_CONFIG_LISTBOX_CHANNELS       23      /* callback function: ChangeEnableChannel */
#define  P_CONFIG_TEXTMSG_4              24
#define  P_CONFIG_TOGGLEBUTTON           25      /* callback function: PhazeModule */
#define  P_CONFIG_TEXTMSG_3              26

#define  PANEL_LOG                       2       /* callback function: PANEL_LOG_CALLBACK */
#define  PANEL_LOG_LISTBOX_LOG           2
#define  PANEL_LOG_BUTTON_CLEAR_LOG      3       /* callback function: CLEAR_LOG */

#define  PANEL_TE01                      3       /* callback function: Panel_TE01_Callback */
#define  PANEL_TE01_comment              2
#define  PANEL_TE01_name                 3
#define  PANEL_TE01_serial3              4
#define  PANEL_TE01_mid                  5
#define  PANEL_TE01_revision             6
#define  PANEL_TE01_serial1              7
#define  PANEL_TE01_serial2              8
#define  PANEL_TE01_DECORATION_2         9
#define  PANEL_TE01_DECORATION           10
#define  PANEL_TE01_write                11      /* callback function: te01f_write */
#define  PANEL_TE01_read                 12      /* callback function: te01f_read */
#define  PANEL_TE01_DECORATION_4         13
#define  PANEL_TE01_setdefault           14      /* callback function: te01f_default */
#define  PANEL_TE01_TEXTMSG_2            15
#define  PANEL_TE01_TEXTMSG              16

#define  WP                              4
#define  WP_TEXTMSG                      2


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK cbf_control(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cbf_ExternalStart(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cbf_Generate_Sync_Out(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeACDCState(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeChanelRange0(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeChanelRange1(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeChanelRange2(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeChanelRange3(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeEnableChannel(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeFreqDivaser(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeOscilDataSize(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeOscilDataSizeProc(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChengeMeasureZero(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CLEAR_LOG(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PANEL_LOG_CALLBACK(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Panel_TE01_Callback(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PanelConfigCallback(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PhazeModule(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SET_FREQ_SAMPLE(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_default(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_read(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_write(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
