#include <analysis.h>         
#include <userint.h>		  
#include "localdefs.h"
#include "tflist.h"
#include <ansi_c.h>
#include "te01func.h"
#include "uts\\services\\common\\include\\utsmath.h"
#include "ltr\\include\ltrapi.h"
#include "ltr\\include\ltrapidefine.h"
#include "ltr\\include\ltr010api.h"  


extern TLTR22 module; 
char str[200];      

//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------

int openModule(TCONTEXT *tc) 
{
	int i=0, res=LTR_OK;
	TLTR22 temp;
//	for (i=0;i<17;i++)
//	LTR22_Init(&IniSet.ModulesConfiguration[i]);
	if(LTR22_IsOpened(&module)!=LTR_OK) {
	 	ltrTContext *tclocal=tc->tcontext;
	 	if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL); 
		//
		res=LTR22_Open(&module, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot);
		if(res!=LTR_OK) 
		{
			LTR22_Close(&module);
			memset(&str,0,200); 
			sprintf(str, "   %s", LTR22_GetErrorString(res));
			MessagePopup(MSG_ERROR, str); 
		}
		else
		{
			//       
			temp=module;
			module= IniSet.ModulesConfiguration[module.Channel.cc];
			module.Channel=temp.Channel;
			module.ModuleInfo=temp.ModuleInfo;
			memcpy(&module.ADCCalibration,&temp.ADCCalibration,sizeof(temp.ADCCalibration));
			module.Fdiv_rg=max(1,module.Fdiv_rg);
			if (LTR22_SetConfig(&module)==LTR_OK);
				writeINI(tc->dllpath);
		}
				
	 	if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
	 }	
	 return (LTR22_IsOpened(&module)==LTR_OK) ? 0 : TRES_INIT_FAIL;
}

//-----------------------------------------------------------------------------
int closeModule(void) 
{
 	LTR22_Close(&module);
 	return 0;
}

//-----------------------------------------------------------------------------
int utspInitModule(TCONTEXT *tc, void *p) { return 0; }
int utspReadData  (TCONTEXT *tc, void *p) { return 0; }
int utspWriteData (TCONTEXT *tc, void *p) { return 0; }
int utspWriteFile (TCONTEXT *tc, void *p) { return 0; }
int utspVerifyModule(TCONTEXT *tc) { return 0; }
int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel) { return 0; }
int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int channel) { return 0; }
int utspGetDIO(TCONTEXT *tc, void *p) { return 0; }
int utspPutDIO(TCONTEXT *tc, void *p) { return 0; }
//-----------------------------------------------------------------------------
//    :  ,   
//-----------------------------------------------------------------------------
int utspGetModuleInfo(TCONTEXT *tc, void *p) 
{
	int res=0;
	char str[256];
	openModule(tc);
	
	
	
	readINI(tc->dllpath);
	
	res=LTR22_GetModuleDescription(&module);
 
	if(res==LTR_OK) 
	{
	/*
 		char cstr[1024];
 		sprintf(cstr, "BootLoader Version  : v%d.%d (build %.14s)", (int)info1[0], (int)info1[1], info1+2);
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, cstr);
 		sprintf(cstr, "Application Version : v%d.%d (build %.14s)", (int)info2[0], (int)info2[1], info2+2);
 		
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, cstr);
 		
 		sprintf(cstr, "Module Name : %.16s", descr.Name);
 	*/
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, module.ModuleInfo.Description.DeviceName);
 		//sprintf(cstr, "Serial Number : %.16s", descr.SerialNumber);
 		//if(tc->cbf) tc->cbf(TFMSG_IMODULE, cstr);
		if(tc->cbf) tc->cbf(TFMSG_SERIAL, module.ModuleInfo.Description.SerialNumber);
 		if(tc->cbf) tc->cbf(TFMSG_VER, module.ModuleInfo.Description.Comment);
 		module.ModuleInfo.Description.CompanyName[15]=0;
 		sprintf(str," : %16s",module.ModuleInfo.Description.CompanyName);
 		if(tc->cbf) tc->cbf(TFMSG_IBLANK, str);  
 		module.ModuleInfo.CPU.Name[15]=0;
 		sprintf(str,"  : %16s",module.ModuleInfo.CPU.Name);
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, str);
 		//if(tc->cbf) tc->cbf(TFMSG_IBLANK, module.ModuleInfo.CPU.Name);
 		if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
 		return 0;
 	}

 return res;
};

/**************************************************************************************************************
    
****************************************************************************************************************/

typedef int __stdcall (*RunMetrologiaWindowType)(TCONTEXT *tc, TLTR22 * module, 
										   void * ACDCEstimatorPointer,  void * utsMath_DoFFTPointer, 
										   void * AddLog) ;
typedef int __stdcall (*RunMetrologiaFuncType)(int NumMethod);

HANDLE hh=NULL;
RunMetrologiaWindowType RunMetrologiaWindow;
RunMetrologiaFuncType RunMetrologiaFunc;

int utspCalibrModule(TCONTEXT *tc) 
{
	openModule(tc); 
	
	
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
  
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,NULL);

	return 0; 
}      


/*************************************************************************************************************
 
**************************************************************************************************************/
int utspTestHardwareInterface(TCONTEXT *tc)
{
	openModule(tc);
   	return  LTR22_TestHardwareInterface(&module);
}

int utspTestRangesAltera(TCONTEXT *tc)
{
	const int Size=100;
	int res=0,Ch0=0, Ch1=0, Ch2=0, Ch3=0, adc384=0, Fdiv_rg=0;
	 char str[200];
	int Counter=0;
	double * Data = malloc(Size*(sizeof(double)));
	openModule(tc);
	
	module.ChannelEnabled[0]=true;
	module.ChannelEnabled[1]=true;
	module.ChannelEnabled[2]=true;
	module.ChannelEnabled[3]=true;
	
	if(tc->cbf) tc->cbf(TFMSG_REPORT, " ...");  
	for (adc384=0;adc384<2;adc384++)
	{
		for (Fdiv_rg=1;Fdiv_rg<16;Fdiv_rg++)
		{
			res=LTR22_SetFreq(&module, adc384, Fdiv_rg);
			if (res!=LTR_OK) continue;
			else
			{
				memset(&str,0,200); 
				sprintf(str, "Fdiv=%d, adc384=%d",module.Fdiv_rg, module.Adc384+2);
				if(tc->cbf) tc->cbf(TFMSG_REPORT, str);  
			}
			
			for (Ch0=0;Ch0<LTR22_RANGE_NUMBER;Ch0++)
			{
				res=LTR22_SetADCRange(&module,0,Ch0); 
				for (Ch1=0;Ch1<LTR22_RANGE_NUMBER;Ch1++)
				{
					res=LTR22_SetADCRange(&module,1,Ch1); 
					for (Ch2=0;Ch2<LTR22_RANGE_NUMBER;Ch2++)
					{
						res=LTR22_SetADCRange(&module,2,Ch2);
						for (Ch3=0;Ch3<LTR22_RANGE_NUMBER;Ch3++)
						{
								
								res=LTR22_SetADCRange(&module,3,Ch3); 
								
								res=LTR22_GetADCData(&module,Data, Size,2000, false,false);
								
								if (res!=LTR_OK)
								{   
									memset(&str,0,200); 
									sprintf(str, "   %d,   : %d, %d, %d, %d, Fdiv=%d, adc384=%d", res,
											module.ADCChannelRange[0], module.ADCChannelRange[1], module.ADCChannelRange[2],
											module.ADCChannelRange[3], module.Fdiv_rg, module.Adc384+2);
									if(tc->cbf) tc->cbf(TFMSG_REPORT, str);
									free(Data);    
									return res;
								}
								else
								{
								
									tc->cbf(TFMSG_PROGRESS(100.0 * (++Counter) /(LTR22_RANGE_NUMBER*LTR22_RANGE_NUMBER*LTR22_RANGE_NUMBER*LTR22_RANGE_NUMBER)), NULL);     
								/*
									memset(&str,0,200); 
										sprintf(str, "    : %d, %d, %d, %d, Fdiv=%d, adc384=%d",
											module.ADCChannelRange[0], module.ADCChannelRange[1], module.ADCChannelRange[2],
											module.ADCChannelRange[3], module.Fdiv_rg, module.Adc384+2);
									if(tc->cbf) tc->cbf(TFMSG_REPORT, str);
									*/
								} 
						}
					}
				}									 
			}
		}
	} 
	
	if(tc->cbf) tc->cbf(TFMSG_REPORT, " ");   
	
	free(Data);
   	return  res;
}

int utspTestRingSendRecieveData(TCONTEXT *tc)
{
	const int SendSizeArray=32, 
				RecieveSizeArray=SendSizeArray*2,
				NumTransfers=1000;
	
	int CountTransfer, Counter;
	int res=0, SendSize=0, RecieveSize=0;
	char str[200];
	TLTR010 ControlPipe;
	BYTE ControlBuf[16];
	DWORD Counter1=0;	
	DWORD CounterThis=0; 
	DWORD * SendData = malloc(SendSizeArray*(sizeof(DWORD)));
	DWORD * RecieveData = malloc(RecieveSizeArray*(sizeof(DWORD)));  
	ltrTContext *tclocal=tc->tcontext;  
	
	for (CountTransfer=0;CountTransfer<SendSizeArray;CountTransfer++)  
	{
		SendData[CountTransfer]=(CountTransfer<<16)|0x8000|52|0xc0; // 52 -  
	}
	
	LTR010_Init(&ControlPipe);
	ControlPipe.ltr.cc=CC_CONTROL;
	res=LTR010_Open(&ControlPipe,ControlPipe.ltr.saddr, ControlPipe.ltr.sport, ControlPipe.ltr.csn);
	
	memset(ControlBuf,0,sizeof(ControlBuf));
	
	
	openModule(tc);
	
	           
	           /*
	ControlBuf[0]=tclocal->slot-1;
	res=LTR010_PutArray(&ControlPipe, ControlBuf, 1, SEL_AVR_DM|0x800F);
	if (res!=LTR_OK) tc->cbf(TFMSG_REPORT, "  ");  
	res=LTR010_GetArray(&ControlPipe, ControlBuf, 1, SEL_AVR_DM|0x800F);      
	if (res!=LTR_OK) tc->cbf(TFMSG_REPORT, "  ");  
	Counter1=ControlBuf[0];
	*/
	
	if(tc->cbf) tc->cbf(TFMSG_REPORT, " ...");  
	
	for (CountTransfer=0;CountTransfer<NumTransfers;CountTransfer++)
	{   
		
		/*
		res=LTR010_PutArray(&ControlPipe, ControlBuf, 1, SEL_AVR_DM|0x800F);
		if (res!=LTR_OK) tc->cbf(TFMSG_REPORT, "  ");  
		*/
	
		SendSize=LTR_Send(&module.Channel, SendData, SendSizeArray, 6000);
		if (SendSize==SendSizeArray)
		{
		
			Counter1+=SendSizeArray;
			Counter1&=0xFF;
			
			RecieveSize=LTR_Recv(&module.Channel, RecieveData, NULL, RecieveSizeArray, 6000); 
			
			/*
			res=LTR010_GetArray(&ControlPipe, ControlBuf, 2, SEL_AVR_DM|0x800E);      
			if (res!=LTR_OK) tc->cbf(TFMSG_REPORT, "  ");  			
			if ((ControlBuf[0])!=(ControlBuf[1]))
			{   
				memset(&str,0,200); 
				sprintf(str, "   %d,   %d", ControlBuf[0], ControlBuf[1]);
				if(tc->cbf) tc->cbf(TFMSG_REPORT, str);
			}
			*/
			if (RecieveSize==RecieveSizeArray)
			{
				for (Counter=0;Counter<SendSizeArray;Counter++)
				{
					if ((RecieveData[2*Counter]&0xffff00ff)!=0x0034001a)
					{   
						if(tc->cbf) (tc->cbf(TFMSG_REPORT, "     "));
						res=-1;
					}
					
					if ((SendData[Counter]&0xffff0000)!=(RecieveData[2*Counter+1]&0xffff0000))
					{   
						if(tc->cbf) (tc->cbf(TFMSG_REPORT, "  "));
						res=-1;
						break;
					}
				}
				
				tc->cbf(TFMSG_PROGRESS(100.0 * (CountTransfer) /NumTransfers), NULL);
				if(tc->cbf) (tc->cbf(TFMSG_REPORT, "OK"));    
				
			}
			else
			{		   
				res=LTR010_GetArray(&ControlPipe, ControlBuf, 16, SEL_AVR_DM|0x8000);      
				if (res!=LTR_OK) tc->cbf(TFMSG_REPORT, "  ");  			
				/*
				if ((ControlBuf[0])!=(ControlBuf[1]))
				{   
					memset(&str,0,200); 
					sprintf(str, "   %d,   %d", ControlBuf[0], ControlBuf[1]);
					if(tc->cbf) tc->cbf(TFMSG_REPORT, str);
				}
				*/
				
				if(tc->cbf) (tc->cbf(TFMSG_REPORT, "  "));   
			}
		}
		else
		{			 
			res=LTR010_GetArray(&ControlPipe, ControlBuf, 16, SEL_AVR_DM|0x8000);      
			if (res!=LTR_OK) tc->cbf(TFMSG_REPORT, "  ");  			
				
			if(tc->cbf) (tc->cbf(TFMSG_REPORT, "  "));    
		}  
	} 
	
	if(tc->cbf) tc->cbf(TFMSG_REPORT, " ");   
	
	
	free(SendData);
	free(RecieveData); 
	LTR010_Close(&ControlPipe);
   	return  res;
}

int utspTestSyncStart(TCONTEXT *tc)
{
	const int  	RecieveSizeArray=20000;
				
	
	int CountTransfer, Counter;
	int res=0, SendSize=0, RecieveSize=0;
	char str[200];
	
	TE01 * te01 = (TE01 *)tc->te01;   
	
	DWORD * RecieveData = malloc(RecieveSizeArray*(sizeof(DWORD)));   
	double * ProcessData = malloc(RecieveSizeArray*(sizeof(double)));   
	
	openModule(tc);
	
	module.Adc384=false;
	module.Fdiv_rg=1;
	module.ChannelEnabled[0]=1;
	
	LTR22_SetConfig(&module);
	
	if(tc->cbf) tc->cbf(TFMSG_REPORT, " ...");  
	
	res=LTR22_SetSyncPriority(&module,true); //    
		 
	if (res==LTR_OK)
	{
		res=LTR22_StartADC(&module,true);	  
	
		if (res==LTR_OK)
		{   
			res=LTR22_Recv(&module,RecieveData, NULL, RecieveSizeArray, 2000);
			if (res==RecieveSizeArray)
			{
				res=LTR22_ProcessData(&module, RecieveData, ProcessData,RecieveSizeArray,false,false,NULL);
			}
			else
			{
				if(tc->cbf) (tc->cbf(TFMSG_REPORT, "  "));   
				res=-1; //   
			}
		}
		else if(tc->cbf) (tc->cbf(TFMSG_REPORT, "  "));   
	}else  if(tc->cbf) (tc->cbf(TFMSG_REPORT, "  "));   
	
	LTR22_StopADC(&module);
	LTR22_ClearBuffer(&module,true);
	 
	
	if(tc->cbf) tc->cbf(TFMSG_REPORT, " ");   
	
	free(ProcessData);
	free(RecieveData); 
   	return  res;
}

int utspTestSNR(TCONTEXT *tc)
{   
	openModule(tc); 
	
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
	
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,tc->cbf);

	return RunMetrologiaFunc(0); 
}

int utspTestAFC_DC(TCONTEXT *tc)
{   
	openModule(tc); 
	
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
	
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,tc->cbf);

	return RunMetrologiaFunc(1); 
}

int utspTestAFC_AC(TCONTEXT *tc)
{   
	openModule(tc); 
	
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
	
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,tc->cbf);

	return RunMetrologiaFunc(2); 
}

int utspTestSinFaz(TCONTEXT *tc)
{   
	openModule(tc); 
	
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,tc->cbf);

	return RunMetrologiaFunc(3); 
}

int utspVerifyCalib_DC(TCONTEXT *tc)
{   
	openModule(tc); 
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,tc->cbf);

	return RunMetrologiaFunc(4); 
}

int utspVerifyThreshold(TCONTEXT *tc)
{   
	openModule(tc); 
	if (hh==NULL) 
	{
		char str[FNAMELEN+1]; 
		sprintf(str, "%s\\%s", tc->dllpath, "metrologia.dll");           
		hh=LoadLibrary(str); 
		RunMetrologiaWindow=(RunMetrologiaWindowType) GetProcAddress(hh,"RunMetrologiaWindow");
		RunMetrologiaFunc = (RunMetrologiaFuncType)  GetProcAddress(hh,"RunMetrologiaFunc");
	}
	RunMetrologiaWindow(tc, &module, (void *)ACDCEstimator, (void *)utsMath_DoFFT,tc->cbf);

	return RunMetrologiaFunc(5); 
}
