#include "localdefs.h"
#include "pluginuir.h"
#include <ansi_c.h>
#include <userint.h>
#define TE01EXT11NAME      "TE-01A-11"     

#define P(x)  PANEL_##x

extern TLTR22 module;
char str[200];      

//-----------------------------------------------------------------------------
int Pnl=-1, WPnl=-1, TePnl=-1, LogPnl=-1;
static dataUpdateCBF_FPtr dataUpdateCBF=NULL;
static HANDLE hThread=NULL;
static TE01 *theTE01;   
static char thePATH[FNAMELEN+1];
static int stopFlag;
//-----------------------------------------------------------------------------
void closeUIR(void) 
{
 if(Pnl !=-1) { DiscardPanel(Pnl);  Pnl =-1;  }
 if(WPnl!=-1) { DiscardPanel(WPnl); WPnl=-1; }  
 if(LogPnl!=-1) { DiscardPanel(LogPnl); LogPnl=-1; }   
}
//-----------------------------------------------------------------------------
void showWaitPanel(char *message)
{
 if(WPnl!=-1) 
 {
 	if(GetActivePanel()!=WPnl) InstallPopup(WPnl);
	SetCtrlVal(WPnl, WP_TEXTMSG, message);
 }
}
//-----------------------------------------------------------------------------
void hideWaitPanel(void)
{
 if(WPnl!=-1) { DiscardPanel(WPnl); WPnl=-1; }  
}


float ModuleADCFreq()
{
	return 156250.0/(module.Fdiv_rg*(module.Adc384+2));
}


void AddLog(char ItemString[])
{
	if (LogPnl!=-1)
	InsertListItem (LogPnl, PANEL_LOG_LISTBOX_LOG, -1, ItemString, 0);
}
//-----------------------------------------------------------------------------
int DataRecorder(void *param) 
{

 int res=0, ADC_Channles_Enabled=0;
 DWORD i, j, data_correction_flag, OffsetChannelValue=0;
 DWORD NumOfChan, AcqDataSizeTotal, TimeOut;
 double Frequency;
 DWORD *data_row;
 double *data_code, *data_value; 
 serviceStrucData serviceData[LTR22_ADC_NUMBERS];
 TCONTEXT *tc=param;
 byte OverflowFalgs[4];
 char str[200];
 bool DataReady=true; 
 
 //
 stopFlag=0;
 
 for (i=0,NumOfChan=0;i<LTR22_ADC_NUMBERS;i++)
 {
 	if (module.ChannelEnabled[i]) NumOfChan++; 
 }  
 
 AcqDataSizeTotal=NumOfChan*IniSet.AcqDataSize;
 Frequency=ModuleADCFreq();
 TimeOut=(int)(1300.0*((double)((IniSet.AcqDataSize/Frequency)+0.6)));
 data_correction_flag=IniSet.UseCalibration;
 
 //
 data_row  =malloc(AcqDataSizeTotal*sizeof(DWORD));
 data_code =malloc((AcqDataSizeTotal)*sizeof(double));
 data_value=malloc((AcqDataSizeTotal)*sizeof(double));
 
 
 for(i=0,OffsetChannelValue=0; i<NumOfChan; i++) 
 { 
 		serviceData[i].fs=Frequency;   
		serviceData[i].point=IniSet.ProcDataSize;
		serviceData[i].iarray=data_code+(OffsetChannelValue);
	   	serviceData[i].darray=data_value+(OffsetChannelValue);
	   	OffsetChannelValue+= IniSet.AcqDataSize; 
 }

 //
 if(data_row!=NULL && data_code!=NULL && data_value!=NULL) 
 {
	if(LTR22_StartADC(&module, IniSet.ExternalStart)==LTR_OK) 
	{
   		
		//      
		while(!stopFlag) 
		{ 
			DWORD sz;
		
			sz=LTR22_Recv(&module, data_row, NULL, AcqDataSizeTotal, TimeOut); 
			
			if(sz==AcqDataSizeTotal) 
			{
				DWORD size=AcqDataSizeTotal;  
				
				res= LTR22_ProcessData(&module, data_row, data_code,  size, IniSet.UseCalibration ,false, OverflowFalgs);
				res= LTR22_ProcessData(&module, data_row, data_value, size, IniSet.UseCalibration ,true,  OverflowFalgs);
					 
   				if (res!=LTR_OK)
				{
					memset(&str,0,200); 
					sprintf(str, "   %d, %s", res, LTR22_GetErrorString(res));
					AddLog(str);    
				}
				
				for(i=0;i<LTR22_ADC_NUMBERS;i++)
				{ 
					if (OverflowFalgs[i]==1)
					{
						memset(&str,0,200); 
						sprintf(str, "  %d", i+1);
						AddLog(str);
					}
				}   
   			
   				
				//
				//if(j!=AcqDataSizeTotal && tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "data format fail!"); 
   				//
   				dataUpdateCBF(NumOfChan, serviceData, NULL);
   				Sleep(0);      
   			} 
   			else 
   			{
	   			if (module.SyncType==2)
	   			{
	   				AddLog("  "); 
	   			}
	   			else
	   			{   
		   			memset(&str,0,200); 
					sprintf(str, "  ,   %d", sz);
					AddLog(str); 
				}
	   		}
			
		}
 		
		//
		if(LTR22_StopADC(&module)==LTR_OK) 
		{
			if(LTR22_ClearBuffer(&module,true)!=LTR_OK) if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "Clear Buffer Fail!");   
		}
		else  if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "stop fail!");  
		
 	} 
 	else if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "start fail!");
 }else if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "memory allocation fail!");	
 
 
 if(data_row  !=NULL) free(data_row);
 if(data_code !=NULL) free(data_code);
 if(data_value!=NULL) free(data_value); 

 return -100;
} 



//-----------------------------------------------------------------------------
//     "Module Configuration"
//-----------------------------------------------------------------------------

int UpdateConfigControls()
{
	int res=LTR_OK, temp=0, MainDiv=0, ExtraDiv=0, i=0;
	float ClkFreq=0;
	
	SetCtrlVal (Pnl, P_CONFIG_SIZE_OSCIL, IniSet.AcqDataSize);
	SetCtrlVal (Pnl, P_CONFIG_SIZE_OSCIL_DISP, IniSet.ProcDataSize); 
	SetCtrlVal (Pnl, P_CONFIG_calibr, IniSet.UseCalibration); 

	res=LTR22_GetConfig(&module);
	if (res==LTR_OK)
	{
		ClkFreq=20.0/module.Fdiv_rg; 
		
		MainDiv=module.Fdiv_rg;
		ExtraDiv=module.Adc384+2;
		if ((ExtraDiv*MainDiv)==6)
		{
			ExtraDiv=2;
			MainDiv=3;
		}
		
		if ((ExtraDiv*MainDiv)==12)
		{
			ExtraDiv=2;
			MainDiv=6;
		}
		
		if ((ExtraDiv*MainDiv)==18)
		{
			ExtraDiv=2;
			MainDiv=9;
		}
		
		if ((ExtraDiv*MainDiv)==30)
		{
			ExtraDiv=2;
			MainDiv=0xF;
		}
		
	
		
		temp=((ExtraDiv<<4)&0xf0)|(MainDiv&0xf);
		
		if ((ExtraDiv*MainDiv)==24)
			{
				ExtraDiv=2;
				MainDiv=0xC;
			}		
		SetCtrlVal (Pnl, P_CONFIG_MasterSlaveSelect, module.SyncMaster);
		SetCtrlVal (Pnl, P_CONFIG_NUMERIC_FREQ_DIV_MAIN, module.Fdiv_rg);
		SetCtrlVal (Pnl, P_CONFIG_BINSW_FREQ_DIV_EXTRA, module.Adc384); 
		SetCtrlVal (Pnl, P_CONFIG_NUMERIC_FREQ , ClkFreq); 
		SetCtrlVal (Pnl, P_CONFIG_RING_FREQ_SAMPLES , temp);     
		SetCtrlVal (Pnl, P_CONFIG_BINSW_AC_DC_STATE, module.AC_DC_State);
		SetCtrlVal (Pnl, P_CONFIG_BINSW_MES_ZERO, module.MeasureADCZero);
		SetCtrlVal (Pnl, P_CONFIG_RINGSLIDE_CH0, module.ADCChannelRange[0]);
		SetCtrlVal (Pnl, P_CONFIG_RINGSLIDE_CH1, module.ADCChannelRange[1]);
		SetCtrlVal (Pnl, P_CONFIG_RINGSLIDE_CH2, module.ADCChannelRange[2]);
		SetCtrlVal (Pnl, P_CONFIG_RINGSLIDE_CH3, module.ADCChannelRange[3]);
		
		for (i=0;i<LTR22_ADC_NUMBERS;i++)
		{ 
			CheckListItem (Pnl, P_CONFIG_LISTBOX_CHANNELS ,i, module.ChannelEnabled[i]);  
		}
		SetCtrlVal (Pnl, P_CONFIG_ExternalStart, IniSet.ExternalStart);     
	}
	else
	{
		memset(&str,0,200); 
		sprintf(str, "   %d", LTR22_GetErrorString(res));
		MessagePopup(MSG_ERROR, str); 
	}
	
	return res;
}

//-----------------------------------------------------------------------------

int CVICALLBACK cbf_control (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_COMMIT:
			GetCtrlVal (panel, control, &IniSet.UseCalibration);
			break;
	}
	return 0;
}

int CVICALLBACK ChangeOscilDataSize (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, control, &IniSet.AcqDataSize); 
			break;
		}
	return 0;
}

int CVICALLBACK ChangeOscilDataSizeProc (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			  GetCtrlVal (panel, control, &IniSet.ProcDataSize);  
			break;
		}
	return 0;
}



int CVICALLBACK ChangeFreqDivaser (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int res=0;
	byte MainDiv=0;
	byte ExtraDiv=0;
	
	
	switch (event)
	{
		case EVENT_VAL_CHANGED:
			
			GetCtrlVal (panel, P_CONFIG_NUMERIC_FREQ_DIV_MAIN, &MainDiv);
			GetCtrlVal (panel, P_CONFIG_BINSW_FREQ_DIV_EXTRA, &ExtraDiv);  
			
			res=LTR22_SetFreq(&module, ExtraDiv, MainDiv);
									 
			UpdateConfigControls();   
			break;
	}
	return 0;
}	


int CVICALLBACK SET_FREQ_SAMPLE (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int res=0, temp=0, MainDiv=0, ExtraDiv=0;

	switch (event)
	{
		case EVENT_VAL_CHANGED:
			
			GetCtrlVal (panel, control, &temp);
			
			MainDiv=temp&0xf;
			ExtraDiv=(temp&0xf0)>>4;
			ExtraDiv-=2;
			
			res=LTR22_SetFreq(&module, ExtraDiv, MainDiv);
									 
			UpdateConfigControls();   
			break;
	}
	return 0;
}



int CVICALLBACK ChangeACDCState (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0;
	switch (event)
	{   
		case EVENT_VAL_CHANGED:
			GetCtrlVal (panel, control, (byte*)&Value);
			res=LTR22_SwitchACDCState(&module, Value);
			UpdateConfigControls(); 
			break;
	}
	return 0;
}

int CVICALLBACK ChengeMeasureZero (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0;
	switch (event)
	{
		case EVENT_VAL_CHANGED: 
			GetCtrlVal (panel, control, (byte*)&Value); 
			res=LTR22_SwitchMeasureADCZero(&module, Value);
			UpdateConfigControls();
			break;
	}
	return 0;
}

int CVICALLBACK ChangeChanelRange0 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0;
	switch (event)
	{
		case EVENT_VAL_CHANGED: 
			GetCtrlVal (panel, control, &Value); 
			res=LTR22_SetADCRange(&module,0 ,Value);
			UpdateConfigControls();
			break;
	}
	return 0;
}

int CVICALLBACK ChangeChanelRange1 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0;
	switch (event)
	{
		case EVENT_VAL_CHANGED: 
			GetCtrlVal (panel, control, &Value); 
			res=LTR22_SetADCRange(&module,1 ,Value);
			UpdateConfigControls();
			break;
	}
	return 0;
}

int CVICALLBACK ChangeChanelRange2 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0;
	switch (event)
	{
		case EVENT_VAL_CHANGED: 
			GetCtrlVal (panel, control, &Value); 
			res=LTR22_SetADCRange(&module,2 ,Value);
			UpdateConfigControls();
			break;
	}
	return 0;
}

int CVICALLBACK ChangeChanelRange3 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0;
	switch (event)
	{
		case EVENT_VAL_CHANGED: 
			GetCtrlVal (panel, control, &Value); 
			res=LTR22_SetADCRange(&module,3 ,Value);
			UpdateConfigControls();
			break;
	}
	return 0;
}

int CVICALLBACK ChangeSyncType (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0; 
	switch (event)
		{
		case EVENT_VAL_CHANGED:
			GetCtrlVal (panel, control, &Value); 
			module.SyncType=Value;
			UpdateConfigControls();
			break;
		}
	return 0;
}

int CVICALLBACK ChangeEnableChannel (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0, Checked=0;   
	switch (event)
		{
		case EVENT_COMMIT:									  
			GetCtrlIndex (panel, control, &Value);				  
			IsListItemChecked  (panel, control, Value, &Checked); 
			res=LTR22_SetADCChannel(&module, Value, Checked);
			UpdateConfigControls();
			break;
		}
	return 0;
}

int CVICALLBACK PhazeModule (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0, Checked=0;   
	switch (event)
		{
		case EVENT_COMMIT:
		
		    GetCtrlVal (panel, control, &Value);
		    if (!Value)
		    {//      
		    	LTR22_Open(&module,module.Channel.saddr,module.Channel.sport,module.Channel.csn, module.Channel.cc);
		    	UpdateConfigControls();
		    }
		    else
		    {   
				res=LTR22_SyncPhaze(&module, 5000);
			
				Value=0;
				if (res!=LTR_OK) MessagePopup("Error","   ,     ");
				else SetCtrlVal (panel, control, 0);	
			}
			break;
		}
	return 0;
}

int CVICALLBACK cbf_Generate_Sync_Out (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0, Checked=0; 
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, control, &Value);  
			res=LTR22_SetSyncPriority(&module,Value);
			if (res!=LTR_OK) MessagePopup("Error","     ");
			break;
		}
	return 0;
}

int CVICALLBACK cbf_ExternalStart (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int Value=0, res=0, Checked=0; 
	switch (event)
		{
		case EVENT_COMMIT:
			GetCtrlVal (panel, control, &Value); 
			IniSet.ExternalStart=Value;
			break;
		}
	return 0;
}



int CVICALLBACK PanelConfigCallback (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
	{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			GetCtrlVal (Pnl, P_CONFIG_SIZE_OSCIL, &IniSet.AcqDataSize);
			GetCtrlVal (Pnl, P_CONFIG_SIZE_OSCIL_DISP, &IniSet.ProcDataSize); 
			DiscardPanel (Pnl);
			Pnl=-1;
			//memcpy(&IniSet.ModulesConfiguration[IniSet.CurrentModuleNumber],&module, sizeof(module));
			IniSet.ModulesConfiguration[module.Channel.cc]=module;
			writeINI(""); 
			break;
	}
	return 0;
}

int CVICALLBACK te01f_write (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	int  j;
    int  s1;
    char s2[2] = {0,0};
    int  s3;
    BYTE sn[6];


    switch (event)
    {
	    case EVENT_COMMIT:
	        showWaitPanel(NULL);

	        GetCtrlVal(panel, PANEL_TE01_serial1, &s1);
	        GetCtrlVal(panel, PANEL_TE01_serial2, s2);
	        GetCtrlVal(panel, PANEL_TE01_serial3, &s3);
	        sn[0] = s3 & 0xFF;
	        sn[1] = (s3 >> 8) & 0xFF;
	        sn[2] = (s3 >> 16) & 0xFF;
	        sn[3] = s2[0];
	        sn[4] = s1 & 0xFF;
	        sn[5] = 0;

	        for (j = 0; j < 6; j++)
	            theTE01->amodule_eeprom.sn[j] = sn[j];

	        GetCtrlVal(panel, PANEL_TE01_name, theTE01->amodule_eeprom.name);
	        GetCtrlVal(panel, PANEL_TE01_revision, &s1);
	        theTE01->amodule_eeprom.revision = s1;
	        GetCtrlVal(panel, PANEL_TE01_mid, &s1);
	        theTE01->amodule_eeprom.mid = s1;
	        GetCtrlVal(panel, PANEL_TE01_comment, theTE01->amodule_eeprom.comment);

	        if (TE01SystemAreaWriteEnable(theTE01) || TE01WriteAModuleEEPROM(theTE01))
	        {
	            hideWaitPanel();
	            MessagePopup(MSG_ERROR, "Failed update EEPROM");
	        }
	        else
	        {
	            hideWaitPanel();
	            MessagePopup(MSG_PROMPT, "EEPROM has been updated");
	        }

	        break;
    }
    return 0;
}

int CVICALLBACK te01f_read (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{   
    char q[2] = {0, 0};
    int  sn;
	switch (event)
		{
		case EVENT_COMMIT:
			showWaitPanel(NULL);
	        if(TE01ReadAModuleEEPROM(theTE01))
	        {
	            hideWaitPanel();
	            MessagePopup(MSG_ERROR, "Failed read EEPROM");
	            break;
	        }
	        SetCtrlVal(panel, PANEL_TE01_serial1, theTE01->amodule_eeprom.sn[4]);
	        q[0] = theTE01->amodule_eeprom.sn[3];
	        SetCtrlVal(panel, PANEL_TE01_serial2, q);
	        sn  = theTE01->amodule_eeprom.sn[0];
	        sn |= (((int)theTE01->amodule_eeprom.sn[1]) << 8);
	        sn |= (((int)theTE01->amodule_eeprom.sn[2]) << 16);
	        SetCtrlVal(panel, PANEL_TE01_serial3, sn);
	        SetCtrlVal(panel, PANEL_TE01_name, theTE01->amodule_eeprom.name);
	        SetCtrlVal(panel, PANEL_TE01_revision, theTE01->amodule_eeprom.revision);
	        SetCtrlVal(panel, PANEL_TE01_mid, theTE01->amodule_eeprom.mid);
	        SetCtrlVal(panel, PANEL_TE01_comment, theTE01->amodule_eeprom.comment);
        	hideWaitPanel();
			break;
		}
	return 0;
}

int CVICALLBACK CLEAR_LOG (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			 ClearListCtrl (panel, PANEL_LOG_LISTBOX_LOG);
			break;
		}
	return 0;
}

int CVICALLBACK te01f_default (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:
			SetCtrlVal(panel, PANEL_TE01_serial1, 1);
	        SetCtrlVal(panel, PANEL_TE01_serial2, "C");
	        SetCtrlVal(panel, PANEL_TE01_serial3, 1);
	        SetCtrlVal(panel, PANEL_TE01_name, TE01EXT11NAME);
	        SetCtrlVal(panel, PANEL_TE01_revision, 1);
	        SetCtrlVal(panel, PANEL_TE01_mid, 1);
	        SetCtrlVal(panel, PANEL_TE01_comment, " LTR-11");   
			break;
		}
	return 0;
}

int CVICALLBACK Panel_TE01_Callback (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			DiscardPanel (TePnl);
			TePnl=-1;
			break;
		}
	return 0;
}

int CVICALLBACK PANEL_LOG_CALLBACK (int panel, int event, void *callbackData,
		int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_GOT_FOCUS:

			break;
		case EVENT_LOST_FOCUS:

			break;
		case EVENT_CLOSE:
			DiscardPanel (LogPnl);
			LogPnl=-1;

			break;
		}
	return 0;
}


//-----------------------------------------------------------------------------






//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
int utspLoadADSP(TCONTEXT *tc, void *p) {  return 0; };
int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };

//-----------------------------------------------------------------------------

/********************************************************************************
  TE01
*********************************************************************************/
int utspConfigTe01Ext(TCONTEXT *tc, void *p) 
{ 
	char ppath[FNAMELEN+1];

    if (TePnl != -1)
    {
        SetActivePanel(TePnl);
        return 0;
    }

    theTE01 = (TE01 *)(tc->te01);
    sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
    strcpy(thePATH, ppath);

    TePnl = LoadPanelEx (0, ppath, PANEL_TE01, __CVIUserHInst);  
    DisplayPanel(TePnl);

    te01f_read(TePnl, PANEL_TE01_read, EVENT_COMMIT, NULL, 0, 0);
//    te01f_sel10(TePnl, PANEL_TE01_sel10, EVENT_COMMIT, NULL, 0, 0);
//    te01f_apply(TePnl, PANEL_TE01_apply, EVENT_COMMIT, NULL, 0, 0);  
    
	return 0; 
}




/*********************************************************************************
  
**********************************************************************************/
static void makeAdcVChanDescr(int ind, char X[COMMENTLEN+1])
{
    char *Range[]= {"1", "0.3", "0.1", "0.03", "10", "3"};
    sprintf(X, "Channel %02d,D:+/-%s", ind+1, Range[module.ADCChannelRange[ind]]);
}

int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int ch) 
{ 
 int i, j, ChannelsEnabled=0, ChannelNumber=0;
 
 readINI(tc->dllpath); 
 openModule(tc);   
 memset(D, 0x00, sizeof(pluginADC));
 
 
 for (i=0;i<LTR22_ADC_NUMBERS;i++)
 {
 	if (module.ChannelEnabled[i])ChannelsEnabled++;
 }
 
 for (i=0;i<LTR22_ADC_NUMBERS;i++)
 {
 	if (module.ChannelEnabled[i])
 	{
 		if (ChannelNumber==ch)
 		{
 			ChannelNumber=i;
 			break;
 		}
 		ChannelNumber++;  
 	}
 }  
 
 D->type=UTSADC_FAST_SYNC; 
 D->nchan=ChannelsEnabled;
 D->fs=ModuleADCFreq();
 
 D->channel=ChannelNumber; 
 
 if (ChannelNumber>=LTR22_ADC_NUMBERS)return 0;
    
 D->minU=-32768*module.ADCCalibration[ChannelNumber][0].UserCalibScale[module.ADCChannelRange[ChannelNumber]]+
					module.ADCCalibration[ChannelNumber][0].UserCalibOffset[module.ADCChannelRange[ChannelNumber]];
 D->maxU=32767*module.ADCCalibration[ChannelNumber][0].UserCalibScale[module.ADCChannelRange[ChannelNumber]]+
					module.ADCCalibration[ChannelNumber][0].UserCalibOffset[module.ADCChannelRange[ChannelNumber]];
    
 if (IniSet.UseCalibration)
 { 
	D->minU=D->minU*module.ADCCalibration[ChannelNumber][0].FactoryCalibScale[module.ADCChannelRange[ChannelNumber]]+
						module.ADCCalibration[ChannelNumber][0].FactoryCalibOffset[module.ADCChannelRange[ChannelNumber]];
	D->maxU=D->maxU*module.ADCCalibration[ChannelNumber][0].FactoryCalibScale[module.ADCChannelRange[ChannelNumber]]+
						module.ADCCalibration[ChannelNumber][0].FactoryCalibOffset[module.ADCChannelRange[ChannelNumber]];
 }
	
 makeAdcVChanDescr(ChannelNumber, D->comment);
	
 strcpy(D->unit, "V"); 
 	
 if((!openModule(tc))&&module.ChannelEnabled[ChannelNumber])
 { 
 	
 	return 0; 
 }

 return 1;
}
//-----------------------------------------------------------------------------
//   (   module->config)
//-----------------------------------------------------------------------------
int utspConfigDevice(TCONTEXT *tc, void *p)
{
	char str[FNAMELEN+1];
 	sprintf(str, "%s\\%s", tc->dllpath, "pluginuir.uir");
 	
	Pnl=LoadPanelEx(0, str, P_CONFIG, __CVIUserHInst); 
	InstallPopup(Pnl);
	
	readINI(tc->dllpath); 
	if(!openModule(tc)) UpdateConfigControls();
	
	return 0;
}


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
int utspStart(TCONTEXT *tc, void *p) 
{
	char str[FNAMELEN+1];
	readINI(tc->dllpath);

 if(!openModule(tc)) 
 {  
 	DWORD dw; 
 	if (module.ChannelEnabled[0]==false&&
 		module.ChannelEnabled[1]==false&&
 		module.ChannelEnabled[2]==false&&
 		module.ChannelEnabled[3]==false)
 		{
 			MessagePopup(MSG_ERROR, "No Channels Selected");
 			return 0;
 		}

	dataUpdateCBF=((plugStartStruc*)p)->coreCBF;
 	
	sprintf(str, "%s\\%s", tc->dllpath, "pluginuir.uir");
 		
	LogPnl=LoadPanelEx(0, str, PANEL_LOG, __CVIUserHInst); 
	DisplayPanel(LogPnl); 
		
	// start thread here
	hThread=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, tc, 0, &dw);
	if(hThread!=INVALID_HANDLE_VALUE) return 0;
 } 		
 //	   
 return 1;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------

int utspStop(TCONTEXT *tc, void *p) 
{

 int dw=0;
 int res=0;
 
 stopFlag=true; 
 
 while(dw!=-100) 
 {
 	if (!GetExitCodeThread(hThread, &dw)) 
 		break;
 	Sleep(2);
 }
 
 CloseHandle(hThread);
 if (LogPnl!=-1)
 {
 	DiscardPanel (LogPnl);
 	LogPnl=-1;
 };
 return 0;
}; 
