#include "localdefs.h"
#include "ltr\\include\\ltravrapi.h"  
#include "lib\\crc\\crc.h"  
#include <ansi_c.h>
//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------
int openModule(TCONTEXT *tc) 
{
 if(LTR27_IsOpened(&module)!=LTR_OK) {
 	ltrTContext *tclocal=tc->tcontext;
 	if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL); 
	//
	if(LTR27_Open(&module, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot)==LTR_OK) {
	 	INT res=LTR27_GetConfig(&module); 
	 	if(res==LTR_OK) {
		} 
		//
		if(res!=LTR_OK) LTR27_Close(&module);
	} 
 	if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
 }	
 return (LTR27_IsOpened(&module)==LTR_OK) ? 0 : TRES_INIT_FAIL;
}
//-----------------------------------------------------------------------------
int closeModule(void) 
{
 LTR27_Close(&module);
 return 0;
}
//-----------------------------------------------------------------------------
int configModule(void) 
{
 module.FrequencyDivisor=IniSet.FreqDivisor;
 if(LTR27_SetConfig(&module)!=LTR_OK ||
 	LTR27_GetConfig(&module)!=LTR_OK) {
 	//
	LTR27_Close(&module);	
 } else {
	int i;
	//   
	for(i=0; i<2*LTR27_MEZZANINE_NUMBER; i++) {
		int j=2*(i&1);
		if(module.ModuleInfo.Mezzanine[i>>1].Active) {
			module.Mezzanine[i>>1].CalibrCoeff[j+0]=module.ModuleInfo.Mezzanine[i>>1].Calibration[j+0];
			module.Mezzanine[i>>1].CalibrCoeff[j+1]=module.ModuleInfo.Mezzanine[i>>1].Calibration[j+1];
    	} else {
			module.Mezzanine[i>>1].CalibrCoeff[j+0]=1.0;
			module.Mezzanine[i>>1].CalibrCoeff[j+1]=0.0;
    	}
	}    	
 }
 return (LTR27_IsOpened(&module)==LTR_OK) ? 0 : TRES_INIT_FAIL;
}
//-----------------------------------------------------------------------------
int utspInitModule(TCONTEXT *tc, void *p) { return 0; }
int utspReadData  (TCONTEXT *tc, void *p) { return 0; }
int utspWriteData (TCONTEXT *tc, void *p) { return 0; }
int utspWriteFile (TCONTEXT *tc, void *p) { return 0; }
int utspCalibrModule(TCONTEXT *tc) { return 0; }
int utspVerifyModule(TCONTEXT *tc) { return 0; }
int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel) { return 0; }
int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int channel) { return 0; }
int utspGetDIO(TCONTEXT *tc, void *p) { return 0; }
int utspPutDIO(TCONTEXT *tc, void *p) { return 0; }
//-----------------------------------------------------------------------------
//   :  ,   
//-----------------------------------------------------------------------------
int utspGetModuleInfo(TCONTEXT *tc, void *p) 
{
 int tres=TRES_INIT_FAIL;
 //
 if(!openModule(tc)) 
 {
	if(LTR27_GetDescription(&module, LTR27_MODULE_DESCRIPTION)==LTR_OK) {
 		if(tc->cbf!=NULL) {
 			DWORD dw;
 			char cstr[1024];
	 		sprintf(cstr, " : %.16s", module.ModuleInfo.Module.DeviceName);
 			tc->cbf(TFMSG_IMODULE, cstr);
 			tc->cbf(TFMSG_SERIAL, module.ModuleInfo.Module.SerialNumber);
	 		sprintf(cstr, ": %.16s", module.ModuleInfo.Cpu.Name);
 			tc->cbf(TFMSG_IMODULE, cstr);
	 		sprintf(cstr, " : %.1f MHz", module.ModuleInfo.Cpu.ClockRate);
 			tc->cbf(TFMSG_IMODULE, cstr);
			dw=module.ModuleInfo.Cpu.FirmwareVersion;
 			sprintf(cstr, " : %d.%d.%d.%d", (int)((dw>>24)&255), (int)((dw>>16)&255), (int)((dw>>8)&255), (int)((dw>>0)&255));
 		    tc->cbf(TFMSG_IMODULE, cstr);
 		    tc->cbf(TFMSG_IBLANK, "");
 		
		}
		tres=TRES_T_OK;
	} else {
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_ISTART, "LTR27_GetDescription() -> error"); 
	}
	//
	closeModule(); 
 }
 //
 return tres;
};
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
int utspTestEcho(TCONTEXT *tc) 
{
 int tres=TRES_INIT_FAIL;
 //
 if(!openModule(tc)) {
	if(LTR27_Echo(&module)==LTR_OK) {
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_ISTART, "LTR27_Echo() -> ok"); 
		tres=TRES_T_OK;
	} else {
		if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE|MIDFC_ISTART, "LTR27_Echo() -> error"); 
	}
	closeModule(); 
 }
 //
 return tres;
}
//--------------------------------------------------------------
// 
//--------------------------------------------------------------
int utspWriteMCUFlash(TCONTEXT *tc, void *p)
{ 
 int res=TRES_T_FAIL;
 ltrTContext *tclocal=tc->tcontext;
 burnMcuContext *pbc=p;
 FILE *f;
 //
 if((f=fopen(pbc->fname, "rb+"))!=NULL) {
	DWORD  size;
	BYTE buf[128]; 
	memset(buf, 0xff, sizeof(buf));
	//
	if(!fseek(f, 2*ATMEGA8515_FLASH_SIZE-sizeof(buf), SEEK_SET)) {
 		if(fread(buf, 1, sizeof(buf), f)==sizeof(buf)) {
			//  
    	    strncpy(buf+32, pbc->serial, 16);
        	//  
			*(WORD*)(buf+sizeof(buf)-2)=eval_crc16(0, buf, sizeof(buf)-2);
			if(!fseek(f, 2*ATMEGA8515_FLASH_SIZE-sizeof(buf), SEEK_SET)) {
				//   
				if(fwrite(buf, 1, sizeof(buf), f)==sizeof(buf)) {
					fflush(f);
					//  
					res=utspDefaultWriteMCUFlash(tc, p);
					//  
					if(res==TRES_T_OK) res=utspGetModuleInfo(tc, p); 
				} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't change file with firmware!");
			} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't seek in file with firmware!");
 	 	} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't read file with firmware!");
	} else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't seek in file with firmware!");
 	fclose(f);
 } else if(tc->cbf!=NULL) tc->cbf(MIDFD_CORE, "Can't open file with firmware!");	 
 return res;
}


