#include "localdefs.h"
#include "pluginuir.h"
#include <ansi_c.h>
#include <userint.h>
#define P(x)  PANEL_##x
//-----------------------------------------------------------------------------
int Pnl=-1, WPnl=-1;
static dataUpdateCBF_FPtr dataUpdateCBF=NULL;
static HANDLE hThread=NULL;
static int stopFlag;
//-----------------------------------------------------------------------------
void closeUIR(void) 
{
 if(Pnl !=-1) { DiscardPanel(Pnl);  Pnl =-1;  }
 if(WPnl!=-1) { DiscardPanel(WPnl); WPnl=-1; }  
}
//-----------------------------------------------------------------------------
void showWaitPanel(char *message)
{
 if(WPnl!=-1) {
 	if(GetActivePanel()!=WPnl) InstallPopup(WPnl);
	SetCtrlVal(WPnl, WP_TEXTMSG, message);
 }
}
//-----------------------------------------------------------------------------
void hideWaitPanel(void)
{
 if(WPnl!=-1) { DiscardPanel(WPnl); WPnl=-1; }  
}





//-----------------------------------------------------------------------------
static int numOfLogChan(void) 
{
 int i, n;
 for(i=n=0; i<(2*LTR27_MEZZANINE_NUMBER); i++) 
 	if(IniSet.LogChan[i].onoff) n++;
 return n;
}
//-----------------------------------------------------------------------------
void DataRecorder(void *param) 
{
 DWORD i, j, data_correction_flag;
 DWORD NumOfChan, AcqDataSizeTotal, TimeOut;
 double Frequency;
 DWORD *data_row;
 double *data_process, *data_code, *data_value;
 serviceStrucData serviceData[2*LTR27_MEZZANINE_NUMBER];
 TCONTEXT *tc=param;
 //
 stopFlag=0;
 NumOfChan=numOfLogChan(); 
 AcqDataSizeTotal=2*LTR27_MEZZANINE_NUMBER*IniSet.AcqDataSize;
 Frequency=1000.0/(IniSet.FreqDivisor+1);
 TimeOut=1000.0*((int)(IniSet.AcqDataSize/Frequency+2.0));
 data_correction_flag=IniSet.UseCalibration ? LTR27_DATA_CORRECTION : 0;
 //
 for(i=0; i<2*LTR27_MEZZANINE_NUMBER; i++) {
	serviceData[i].point=0;
	serviceData[i].fs=Frequency;
	serviceData[i].iarray=NULL;
	serviceData[i].darray=NULL;
 }
 //
 data_row     =malloc(AcqDataSizeTotal*sizeof(DWORD));
 data_process =malloc(AcqDataSizeTotal*sizeof(double));
 data_code    =malloc(AcqDataSizeTotal*sizeof(double));
 data_value   =malloc(AcqDataSizeTotal*sizeof(double));
 //
 if(data_row!=NULL && data_process!=NULL && data_code!=NULL && data_value!=NULL) {
	if(LTR27_ADCStart(&module)==LTR_OK) {
		//      
		while(!stopFlag) 
		{ 
			INT sz=LTR27_Recv(&module, data_row, NULL, AcqDataSizeTotal, TimeOut);
			if(sz==AcqDataSizeTotal) 
			{
				DWORD size, offset;
				size=AcqDataSizeTotal;
				offset=size/(2*LTR27_MEZZANINE_NUMBER);
				//   
				LTR27_ProcessData(&module, data_row, data_process, &size, data_correction_flag, 0);
   				//   
   				for(i=0; i<offset; i++) 
   					for(j=0; j<(2*LTR27_MEZZANINE_NUMBER); j++) 
						data_code[j*offset+i]=data_process[i*(2*LTR27_MEZZANINE_NUMBER)+j];
   				//        
				LTR27_ProcessData(&module, data_row, data_process, &size, data_correction_flag, 1);
   				//   
   				for(i=0; i<offset; i++) 
   					for(j=0; j<(2*LTR27_MEZZANINE_NUMBER); j++) 
						data_value[j*offset+i]=data_process[i*(2*LTR27_MEZZANINE_NUMBER)+j];
   				//
   				for(i=j=0; i<(2*LTR27_MEZZANINE_NUMBER); i++) {
   					if(IniSet.LogChan[i].onoff) {
	   					serviceData[j].point=offset;
	   					serviceData[j].iarray=data_code +i*offset;
	   					serviceData[j].darray=data_value+i*offset;
	   					j++;
	   				}	
   				}
				//
				//if(j!=AcqDataSizeTotal && tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "data format fail!"); 
   				//
   				dataUpdateCBF(NumOfChan, serviceData, NULL);
   				Sleep(0);
   			} 
   			else 
   			{
				if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "recv fail!");				   			
   				break;
	   		}
			Sleep(0);
		}
		//
		if(LTR27_ADCStop(&module)!=LTR_OK) if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "stop fail!");
 	} else if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "start fail!");
 } else if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, "memory allocation fail!");	
 //
 if(data_row    !=NULL) free(data_row);
 if(data_process!=NULL) free(data_process);
 if(data_code   !=NULL) free(data_code);
 if(data_value  !=NULL) free(data_value);
 //
 ExitThread(0);
} 



//-----------------------------------------------------------------------------
int CVICALLBACK read_descriptor(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 switch(event) 
 {
	case EVENT_COMMIT:
	{			
	}
	break;
 }
 return 0;
}
//--------------------------------------------------------------
int CVICALLBACK write_descriptor (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2)
{
	switch (event)
		{
		case EVENT_COMMIT:

			break;
		}
	return 0;
}  




//-----------------------------------------------------------------------------
//     "Module Configuration"
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
static void GetConfiguration(void)
{
 int i, k;
 double freq;
 //    
 for(i=k=0; i<16; i++) {
	IsListItemChecked(Pnl, P(list), i, &IniSet.LogChan[i].onoff);  
	if(IniSet.LogChan[i].onoff) k++;
 }
 SetCtrlVal(Pnl, P(nlchan), k);
 //     
 GetCtrlVal(Pnl, P(divider), &IniSet.FreqDivisor);
 GetCtrlVal(Pnl, P(point), &IniSet.AcqDataSize);
 //
 GetCtrlVal(Pnl, P(calibr), &IniSet.UseCalibration);
 //
 freq=1000.0/(IniSet.FreqDivisor+1);
 SetCtrlVal(Pnl, P(freq), freq);
 SetCtrlVal(Pnl, P(fch),  freq);
 //
 SetCtrlVal(Pnl, P(total), IniSet.AcqDataSize);
 SetCtrlVal(Pnl, P(time),  IniSet.AcqDataSize/freq*1000.0);
 SetCtrlVal(Pnl, P(to),    1000.0*((int)(IniSet.AcqDataSize/freq+2.0)));
 //
 SetCtrlAttribute(Pnl, P(procpoint), ATTR_MAX_VALUE, IniSet.AcqDataSize);
 GetCtrlVal(Pnl, P(procpoint), &IniSet.ProcDataSize);
}
//-----------------------------------------------------------------------------
static void SetConfiguration(void)
{
 int i, k;
 double freq;
 //   
 for(i=k=0; i<16; i++) {
	CheckListItem(Pnl, P(list), i, IniSet.LogChan[i].onoff);  
	if(IniSet.LogChan[i].onoff) k++;
 }
 SetCtrlVal(Pnl, P(nlchan), k);
 //     
 freq=1000.0/(IniSet.FreqDivisor+1);
 SetCtrlVal(Pnl, P(divider), IniSet.FreqDivisor);
 SetCtrlVal(Pnl, P(freq), freq);
 SetCtrlVal(Pnl, P(fch),  freq);
 //
 SetCtrlVal(Pnl, P(calibr), IniSet.UseCalibration);
 //
 SetCtrlVal(Pnl, P(point), IniSet.AcqDataSize);
 SetCtrlAttribute(Pnl, P(procpoint), ATTR_MAX_VALUE, IniSet.AcqDataSize);
 SetCtrlVal(Pnl, P(procpoint), IniSet.ProcDataSize);
 //
 SetCtrlVal(Pnl, P(total), IniSet.AcqDataSize);
 SetCtrlVal(Pnl, P(time),  IniSet.AcqDataSize/freq*1000.0);
 SetCtrlVal(Pnl, P(to),    1000.0*((int)(IniSet.AcqDataSize/freq+2.0)));
}
//-----------------------------------------------------------------------------
static void ShowChannelInfo(void)
{
 int i, j;
 char str[1024];
 GetCtrlAttribute (Pnl, P(list), ATTR_CTRL_INDEX, &i);
 //
 if(module.ModuleInfo.Mezzanine[i>>1].Active) {
	sprintf(str, "Slot%d SubChan%d (%s) :\n"
    	         "SerialNumber      = %s\n"
        	     "Revision            = %c\n"
            	 "CalibrationScale  = %.5f\n"
        	     "CalibrationOffset = %.1f\n", 
            	 (i>>1)+1, (i&1)+1, 
  	             module.ModuleInfo.Mezzanine[i>>1].Name, 
      	         module.ModuleInfo.Mezzanine[i>>1].SerialNumber, 
                 module.ModuleInfo.Mezzanine[i>>1].Revision,
                 module.ModuleInfo.Mezzanine[i>>1].Calibration[2*(i&1)+0],
                 module.ModuleInfo.Mezzanine[i>>1].Calibration[2*(i&1)+1]);
 } else {
	sprintf(str, "Slot%d SubChan%d (%s)", (i>>1)+1, (i&1)+1, module.Mezzanine[i>>1].Name);
 }
 //
 ResetTextBox(Pnl, P(info), str);
}
//-----------------------------------------------------------------------------
int CVICALLBACK cbf_control(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 switch(event) {
	case EVENT_COMMIT :
		GetConfiguration();
	break;
 }
 return 0;
}
//-----------------------------------------------------------------------------
int CVICALLBACK cbf_list(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 switch(event) {
	case EVENT_COMMIT :
	case EVENT_VAL_CHANGED :
		GetConfiguration();
		ShowChannelInfo();
	break;	
 }
 return 0;
}
//-----------------------------------------------------------------------------
int CVICALLBACK cbf_clear(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
 int i=0;
 switch (event) {
	case EVENT_COMMIT:
		for(i=0; i<(2*LTR27_MEZZANINE_NUMBER); i++) IniSet.LogChan[i].onoff=0;  
		SetConfiguration();
	break;
 }
 return 0;
}
//-----------------------------------------------------------------------------
int CVICALLBACK mf_apply(int panel, int control, int event, void *callbackData, int eventData1, int eventData2) 
{
 switch (event) {
	case EVENT_COMMIT:
	    if(!numOfLogChan()) MessagePopup(MSG_WARNING, "Invalid number of channels: 0");
		else {
			writeINI(); 
			closeUIR();
	    }	
	break;
 }
 return 0;
}
//-----------------------------------------------------------------------------






//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
int utspLoadADSP(TCONTEXT *tc, void *p) {  return 0; };
int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };
int utspConfigTe01Ext(TCONTEXT *tc, void *p) { return 0; }
//-----------------------------------------------------------------------------
int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int ch) 
{ 
 int i, j;
 memset(D, 0x00, sizeof(pluginADC));
 readINI(tc->dllpath);
 if(!openModule(tc)) {
 	//
 	for(i=j=0; i<(2*LTR27_MEZZANINE_NUMBER); i++) 
 		if(IniSet.LogChan[i].onoff)	{
 			if(j==ch) break;
 			j++;
 		}
 	//
 	if(i<(2*LTR27_MEZZANINE_NUMBER)) {
		double scale =module.Mezzanine[i>>1].ConvCoeff[0],
		       offset=module.Mezzanine[i>>1].ConvCoeff[1];
		//
		D->type=UTSADC_SLOW_SYNC; 
 		D->nchan=numOfLogChan();
 		D->fs=1000.0/(IniSet.FreqDivisor+1);
    	D->channel=ch;
		D->minU=0*scale+offset;
 		D->maxU=32767*scale+offset;
 		strcpy(D->unit, module.Mezzanine[i>>1].Unit); 
 		sprintf(D->comment, "<LC%02d><H27_%s><SubChan%d><D:%.1f..%.1f %s><Fs:%.3f Hz>", ch, module.Mezzanine[i>>1].Name, (i&1)+1, D->minU, D->maxU, module.Mezzanine[i>>1].Unit, 1000.0/(IniSet.FreqDivisor+1));
 		return 0; 
 	}
 }	
 return 1;
}
//-----------------------------------------------------------------------------
//   (   module->config)
//-----------------------------------------------------------------------------
int utspConfigDevice(TCONTEXT *tc, void *p)
{
 int i;
 char str[FNAMELEN+1];
 sprintf(str, "%s\\%s", tc->dllpath, "pluginuir.uir");
 Pnl =LoadPanelEx(0, str, PANEL, __CVIUserHInst);  
 WPnl=LoadPanelEx(0, str, WP,    __CVIUserHInst);  
 if(Pnl>0 && WPnl>0) {
	showWaitPanel("Now opening module...");
	//
	if(!openModule(tc)) {
		INT res;
		//
		showWaitPanel("Now reading module module.ModuleInfo...");
		res=LTR27_GetDescription(&module, LTR27_MODULE_DESCRIPTION);
		//
		ClearListCtrl(Pnl, P(list));
		for(i=0; res==LTR_OK && i<LTR27_MEZZANINE_NUMBER; i++) 
		{
			//
			sprintf(str, "Now reading mezzanine %d module.ModuleInfo...", i+1);
			showWaitPanel(str);
			res=LTR27_GetDescription(&module, LTR27_MEZZANINE1_DESCRIPTION<<i);
			//			 
			sprintf(str, "Slot%d SubChan1 (%s)", i+1, module.Mezzanine[i].Name);
			InsertListItem(Pnl, P(list), -1, str, 2*i+0);
			sprintf(str, "Slot%d SubChan2 (%s)", i+1, module.Mezzanine[i].Name);
			InsertListItem(Pnl, P(list), -1, str, 2*i+1);
		}
		showWaitPanel("Now closing module. Please, wait...");
		closeModule();
		hideWaitPanel();
		//
		if(res==LTR_OK) {
			sprintf(str, "<LTR><SLOT%0.2d> : LTR27 Module Configuration", ((ltrTContext*)tc->tcontext)->slot+1);
			SetPanelAttribute(Pnl, ATTR_TITLE, str);
			//
			readINI(tc->dllpath);
			SetConfiguration();
			ShowChannelInfo();
			//
			InstallPopup(Pnl);
		}	
 	} 
 }	
 return 0;
}


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
int utspStart(TCONTEXT *tc, void *p) 
{
 if(!openModule(tc)) 
 {
 	readINI(tc->dllpath);
	if(!configModule()) 
	{
	 	DWORD dw;
 		dataUpdateCBF=((plugStartStruc*)p)->coreCBF; 
		// start thread here
 		hThread=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataRecorder, tc, 0, &dw);
		SetThreadPriority(hThread, THREAD_PRIORITY_ABOVE_NORMAL);
 		if(hThread!=INVALID_HANDLE_VALUE) return 0;
	} 		
 }
 //
 return 1;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
int utspStop(TCONTEXT *tc, void *p) 
{
 DWORD dw;
 //
 stopFlag=1;
 while(!GetExitCodeThread(hThread, &dw) || dw);
 CloseHandle(hThread);
 hThread=NULL;
 //
 closeModule();
 //
 return 0;
};






