/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  P_CONFIG                        1       /* callback function: PanelConfigCallback */
#define  P_CONFIG_LISTBOX_LOG            2
#define  P_CONFIG_DECORATION_2           3
#define  P_CONFIG_DECORATION             4
#define  P_CONFIG_TEXTMSG_2              5
#define  P_CONFIG_TEXTMSG                6
#define  P_CONFIG_Live_Sinus             7       /* callback function: cbf_Live_Sinus */
#define  P_CONFIG_calibr                 8       /* callback function: cbf_control */
#define  P_CONFIG_NUMERIC_15             9
#define  P_CONFIG_NUMERIC_16             10
#define  P_CONFIG_NUMERIC_13             11
#define  P_CONFIG_NUMERIC_14             12
#define  P_CONFIG_RING_9                 13
#define  P_CONFIG_NUMERIC_11             14
#define  P_CONFIG_NUMERIC_12             15
#define  P_CONFIG_RING_8                 16
#define  P_CONFIG_NUMERIC_9              17
#define  P_CONFIG_NUMERIC_10             18
#define  P_CONFIG_RING_7                 19
#define  P_CONFIG_NUMERIC_7              20
#define  P_CONFIG_NUMERIC_8              21
#define  P_CONFIG_RING_6                 22
#define  P_CONFIG_NUMERIC_5              23
#define  P_CONFIG_NUMERIC_6              24
#define  P_CONFIG_RING_5                 25
#define  P_CONFIG_NUMERIC_3              26
#define  P_CONFIG_NUMERIC_4              27
#define  P_CONFIG_RING_4                 28
#define  P_CONFIG_NUMERIC_1              29
#define  P_CONFIG_NUMERIC_FREQUENCY_8    30
#define  P_CONFIG_NUMERIC_FREQUENCY_7    31
#define  P_CONFIG_NUMERIC_FREQUENCY_6    32
#define  P_CONFIG_NUMERIC_FREQUENCY_5    33
#define  P_CONFIG_NUMERIC_FREQUENCY_4    34
#define  P_CONFIG_NUMERIC_FREQUENCY_3    35
#define  P_CONFIG_NUMERIC_FREQUENCY_2    36
#define  P_CONFIG_NUMERIC_FREQUENCY_1    37
#define  P_CONFIG_NUMERIC_2              38
#define  P_CONFIG_RING_3                 39
#define  P_CONFIG_RING_2                 40
#define  P_CONFIG_RINGSLIDE_NUMCHANNELS  41      /* callback function: ChangeNumChannels */
#define  P_CONFIG_NUMERIC_FREQ_DIV       42      /* callback function: ChangeFreqDiv */
#define  P_CONFIG_TOGGLEBUTTON_CONFIRMA  43      /* callback function: ChangeConfirmationType */
#define  P_CONFIG_BINARYSWITCH_GEN_TYPE  44      /* callback function: ChangeGenerationType */
#define  P_CONFIG_TEXTMSG_4              45
#define  P_CONFIG_TOGGLEBUTTON           46      /* callback function: StartStopGeneration */
#define  P_CONFIG_ChannelGroup_SW        47      /* callback function: ChangeChannelGroup */
#define  P_CONFIG_Serial_STR             48
#define  P_CONFIG_ModuleName_STR         49
#define  P_CONFIG_DECORATION_3           50
#define  P_CONFIG_Frequency_NUM          51
#define  P_CONFIG_DECORATION_4           52

#define  PANEL_TE01                      2       /* callback function: Panel_TE01_Callback */
#define  PANEL_TE01_comment              2
#define  PANEL_TE01_name                 3
#define  PANEL_TE01_serial3              4
#define  PANEL_TE01_mid                  5
#define  PANEL_TE01_revision             6
#define  PANEL_TE01_serial1              7
#define  PANEL_TE01_serial2              8
#define  PANEL_TE01_DECORATION_2         9
#define  PANEL_TE01_DECORATION           10
#define  PANEL_TE01_write                11      /* callback function: te01f_write */
#define  PANEL_TE01_read                 12      /* callback function: te01f_read */
#define  PANEL_TE01_DECORATION_4         13
#define  PANEL_TE01_setdefault           14      /* callback function: te01f_default */
#define  PANEL_TE01_TEXTMSG_2            15
#define  PANEL_TE01_TEXTMSG              16

#define  WP                              3
#define  WP_TEXTMSG                      2


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK cbf_control(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK cbf_Live_Sinus(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeChannelGroup(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeConfirmationType(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeFreqDiv(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeGenerationType(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeNumChannels(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Panel_TE01_Callback(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK PanelConfigCallback(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK StartStopGeneration(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_default(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_read(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK te01f_write(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
