#ifndef TE01FUNC_H_
#define TE01FUNC_H_


#include "uts\\instruments\\te01\\te01api.h"


/*===============================================================================================*/
#define TE01_FDAC_FREQ_QNT  5       /*      TE01 */
#define TE01_FDAC_RANGE_QNT 9       /*     TE01 */
/* ,     LTR-11      TE-01.
 *  :
 *   U[<F|S><P|N|0>]|[0]TO<X|Y|GND32>, 
 *     F     -  ;
 *     S     -  ;
 *     P     - (U<F|S>+)    ( U<F-|S0>);
 *     N     - (UF-)    () ;
 *     0     - (UF0) -   TE-01 (  UF-);
 *             (US0) -   () ;
 *             (U0)  -     ;
 *     X     -  X LTR-11;
 *     Y     -  Y LTR-11;            
 *     GND32 -  GND32 LTR-11.
 */
#define UFPTOX_UFNTOY_CONNECT 0       /*  16-  */
#define UFPTOX_UFPTOY_CONNECT 1       /*  32-  */
#define USPTOX_US0TOY_CONNECT 2       /*  16-  */
#define U0TOX_U0TOY_CONNECT   3       /*  16-  32-  */
#define USPTOX_USPTOY_CONNECT 2       /*  32-  */
#define US0TOGND32_CONNECT    0
#define UFNTOGND32_CONNECT    1
#define UF0TOGND32_CONNECT    2
#define UFPTOGND32_CONNECT    3
/*    */
#define SIGNALTOVOLTMETER_CONNECT 0   /*    LTR-11 (.   
                                       * 
                                       */
#define ZEROTOVOLTMETER_CONNECT   3   /*      */

/*     */
#define EXT_SYNC  (0x01)                 /*   - */
#define EXT_START (0x02)                 /*     */
/*===============================================================================================*/

/*===============================================================================================*/
/*      TE-01,    */
enum te01fdac_filt {te01fdac_filtoff, te01fdac_filt20kHz, te01fdac_filt5kHz, te01fdac_filt400Hz};
/*===============================================================================================*/

/*===============================================================================================*/
extern int    Check_TE01A11     (TE01 *te01);
extern double GetUADC_Val       (TE01 *te01);
extern void   SetAModule_Config (TE01 *te01, int ch1_connection, int ch2_connection,
                                 int gnd32_connection, int voltmeter_connection);
extern void   SetADC_Range      (TE01 *te01, int range);
extern void   SetExt_Inputs     (TE01 *pte01, int inputs);
extern void   SetFDAC_DCValue   (TE01 *pte01, double val, int range);
extern void   SetFDAC_Sinus     (TE01 *pte01, double *freq, double amp, int filt, int range);
extern void   SetSDAC_Value     (TE01 *te01, double t_val, char range);
extern void   SetUADC_Config    (TE01 *te01, int range);
/*===============================================================================================*/

#endif                      /* #ifndef TE01FUNC_H_ */
