#define SERIAL_CHECK_CODE  (53637)

#include <userint.h>
#include "localdefs.h"
#include "tflist.h"
#include <ansi_c.h>

extern TLTR34 module; 
char str[200];      

//-----------------------------------------------------------------------------
//    
//-----------------------------------------------------------------------------

int openModule(TCONTEXT *tc) 
{
	int i=0, res=LTR_OK;
	TLTR34 temp;
	if(LTR34_IsOpened(&module)!=LTR_OK) 
	{
	 	ltrTContext *tclocal=tc->tcontext;
	 	if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL); 
		//
		res=LTR34_Open(&module, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial, tclocal->slot);
		if(res!=LTR_OK) 
		{
		  if(res==-10)
		    {
			 sprintf(str, LTR34_GetErrorString(res));
			 MessagePopup(MSG_ERROR, str);
			} 
		 else
		   {
			LTR34_Close(&module);
			memset(&str,0,200); 
			sprintf(str, LTR34_GetErrorString(res)); 
		//	sprintf(str, "   %d", res);
			MessagePopup(MSG_ERROR, str); 
		  }
		}
		else
		{
			//       
			temp=module;
			//module= IniSet.ModulesConfiguration[module.Channel.cc];
			//module.Channel=temp.Channel;
			//module.ModuleDescription=temp.ModuleDescription;
			//memcpy(&module.DacCalibration,&temp.DacCalibration,sizeof(temp.DacCalibration));
			/*if (LTR34_SetDescription(&module)==LTR_OK);  */
			//	writeINI(); 
		}
				
	 	if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
	 }
	 
	 return (LTR34_IsOpened(&module)==LTR_OK) ? 0 : TRES_INIT_FAIL;
}

//-----------------------------------------------------------------------------
int closeModule(void) 
{
 	LTR34_Close(&module);
 	return 0;
}

//-----------------------------------------------------------------------------
int utspInitModule(TCONTEXT *tc, void *p) { return 0; }
int utspReadData  (TCONTEXT *tc, void *p) { return 0; }
int utspWriteData (TCONTEXT *tc, void *p) { return 0; }
int utspWriteFile (TCONTEXT *tc, void *p) { return 0; }
int utspVerifyModule(TCONTEXT *tc) { return 0; }
int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel) { return 0; }
int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int channel) { return 0; }
int utspGetDIO(TCONTEXT *tc, void *p) { return 0; }
int utspPutDIO(TCONTEXT *tc, void *p) { return 0; }
//-----------------------------------------------------------------------------
//    :  ,   
//-----------------------------------------------------------------------------


int utspGetModuleInfo(TCONTEXT *tc, void *p) {
char sn[16+1];

 //needOpen= 1;
 if(/*testPlolog*/openModule(tc)) return TRES_INIT_FAIL;
 

 
 	 strcpy(sn,module.ModuleInfo.Serial);
     if(tc->cbf) tc->cbf(TFMSG_SERIAL, sn);
     if(tc->cbf) tc->cbf(TFMSG_IMODULE, module.ModuleInfo.Name); 
    // if(tc->cbf) tc->cbf(TFMSG_VER, "1.1");
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
 return 0;
};

// ****************************************************************************
int utspWriteMCUFlash(TCONTEXT *tc, void *p) 

 {
 
  burnMcuContext *BurnContext = p; 
  int err=0;
  LPCSTR error_string;
 
  err=openModule(tc);
  
  
  if(err)
   //if(err!=-2031)	 //     ,    .     ,  
     return TRES_INIT_FAIL; 
   
  
  
/*  if(err=(LTR34_WriteSerialNumber(&module, BurnContext->serial, SERIAL_CHECK_CODE)))
   {
    
  error_string=LTR34_GetErrorString(err); 
  if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
   return TRES_HW_FAIL;
  
  } */
  
  err=LTR34_Close(&module);
  
  return utspGetModuleInfo(tc, NULL);
};



#ifdef ABC


int utspGetModuleInfo(TCONTEXT *tc, void *p) 
{
	int res=0;
	openModule(tc);
	
	res=LTR34_GetDescription(&module);
 
	if(res==LTR_OK) {
	/*
 		char cstr[1024];
 		sprintf(cstr, "BootLoader Version  : v%d.%d (build %.14s)", (int)info1[0], (int)info1[1], info1+2);
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, cstr);
 		sprintf(cstr, "Application Version : v%d.%d (build %.14s)", (int)info2[0], (int)info2[1], info2+2);
 		
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, cstr);
 		
 		sprintf(cstr, "Module Name : %.16s", descr.Name);
 		*/
 		if(tc->cbf) tc->cbf(TFMSG_IMODULE, module.ModuleInfo.Name);
 		//sprintf(cstr, "Serial Number : %.16s", descr.SerialNumber);
 		//if(tc->cbf) tc->cbf(TFMSG_IMODULE, cstr);
		if(tc->cbf) tc->cbf(TFMSG_SERIAL, module.ModuleInfo.Serial);
 		if(tc->cbf) tc->cbf(TFMSG_VER, module.ModuleInfo.FPGA_Version);
 		//if(tc->cbf) tc->cbf(TFMSG_IBLANK, " :");  
 		//if(tc->cbf) tc->cbf(TFMSG_IBLANK, module.ModuleDescription.Description.CompanyName);
 		//if(tc->cbf) tc->cbf(TFMSG_IBLANK, "  :");
 		//if(tc->cbf) tc->cbf(TFMSG_IMODULE, module.ModuleDescription.CPU.Name);
 		//if(tc->cbf) tc->cbf(TFMSG_IBLANK, module.ModuleDescription.CPU.Name);
 		if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
 		return 0;
 	}

 return res;
};

#endif

/**************************************************************************************************************
    
****************************************************************************************************************/

int utspCalibrModule(TCONTEXT *tc) 
{
	#define ADC_FRAME_SIZE (1024)
    int          band;
    int          cnt_adcdata_err = 0;
    const int    divider = 749;
    double       e;
    int          err_code;
    double       frame[ADC_FRAME_SIZE];
    double       frame_avg[LTR34_DAC_NUMBER_MAX];
    int          frame_size;
    double       ltr11_max;
    double       ltr11_min;
    double       ltr11_zero;
    char         msg[512];
    const int    prescaler = 1;
    double       scale;
    TE01         *te01;
    double       te01_adc_max;
    double       te01_adc_min;
    double       te01_adc_zero;
    double       te01_dac_value;
    const double te01_max_sdac_err = 0.1;
    double       zero;
	char         ini_file_name[256], ini_val_buf[64];
	int useTE01A11 = 1;
	
	
 
 /*
    if (testPlolog(tc))
        return TRES_INIT_FAIL;
        

    te01 = (TE01 *)tc->te01;


	if (useTE01A11) {
	    if (!Check_TE01A11(te01))
    	{
        	sprintf(msg, "!    .");
	        if (tc->cbf != NULL)
    	        tc->cbf(TFMSG_REPORT, msg);
        	goto bad_ret;
    	}
	    SetAModule_Config(te01, USPTOX_US0TOY_CONNECT, USPTOX_US0TOY_CONNECT, US0TOGND32_CONNECT,
    	    SIGNALTOVOLTMETER_CONNECT);
    }

    TE01ReadCoeffFromEEPROM(te01);
    for (band = 0; band < LTR11BANDS; band++)
    {
        ProcessSystemEvents();
        SetUADC_Config(te01, te01adc_band_ltr11[band]);
        sprintf(msg, " %.3f", ranges[band]);
        if (tc->cbf != NULL)
            tc->cbf(TFMSG_REPORT, msg);
        if (tc->cbf != NULL)
        {
            if (tc->cbf(TFMSG_PROGRESS(100.0 * band / LTR11BANDS), NULL))
                goto uabort;
        }

		///* MAX 
        te01_dac_value = ranges[band] * 900.0;

        SetSDAC_Value(te01, te01_dac_value, te01sdac_band_ltr11[band]);
        te01_adc_max = GetUADC_Val(te01);
        
        e = 100 * (te01_adc_max - te01_dac_value) / te01_uadc_ranges[te01adc_band_ltr11[band]];
        if (fabs(e) > te01_max_sdac_err)
        {
            sprintf(msg, " SDAC TE-01   (%+.2f%%)", e);
            if (tc->cbf != NULL)
                tc->cbf(TFMSG_REPORT, msg);
            goto bad_ret;
        }
        
        te01_adc_max /= 1000;
	  
        sprintf(msg, ": %.3f, : %.3f", te01_dac_value / 1000.0, te01_adc_max);
        if (tc->cbf != NULL)
        {
            if (tc->cbf(TFMSG_REPORT, msg))
                goto uabort;
        }
	
        hltr11.InpMode           = LTR11_INPMODE_INT;
        hltr11.ADCRate.divider   = divider;
        hltr11.ADCRate.prescaler = prescaler;
        hltr11.LChQnt            = 1;
        hltr11.ADCMode           = LTR11_ADCMODE_ACQ;
        hltr11.StartADCMode      = LTR11_STARTADCMODE_INT;
        hltr11.LChTbl[0]         = (band << 6) | (0 << 4);

        frame_size = ADC_FRAME_SIZE;
        err_code   = getframe(tc, frame, FALSE, &frame_size);
        if (err_code != LTR_OK)
        {
            if (   err_code == LTR11_ERR_ADCDATA_CHNUM
                || err_code == LTR11_ERR_ADCDATA_SLOTNUM
                || err_code == LTR11_ERR_ADCDATA_CNT
               )
            {
                if (tc->cbf != NULL)
                    tc->cbf(TFMSG_REPORT, "!!!     ");
                if (++cnt_adcdata_err >= max_adcdata_err)
                {
                    if (tc->cbf != NULL)
                        tc->cbf(TFMSG_REPORT, "      ");
                    goto bad_ret;
                }
            }
            else
            {
                if (tc->cbf != NULL)
                    tc->cbf(TFMSG_REPORT, ".    LTR-11");
                goto bad_ret;
            }
        }
        getframe_avg(frame, frame_size, frame_avg);
		
        ltr11_max = frame_avg[0];
        sprintf(msg, ": te01=%10.5f, ltr11=%10.5f", te01_adc_max, ltr11_max);
        if (tc->cbf != NULL)
            tc->cbf(TFMSG_REPORT, msg);

		///* MIN 
        te01_dac_value = -ranges[band] * 900.0;

        SetSDAC_Value(te01, te01_dac_value, te01sdac_band_ltr11[band]);
        te01_adc_min = GetUADC_Val(te01);
        
        e = 100 * (te01_adc_min - te01_dac_value) / te01_uadc_ranges[te01adc_band_ltr11[band]];
        if (fabs(e) > te01_max_sdac_err)
        {
            sprintf(msg, " SDAC TE-01 SDAC   (%+.2f%%)", e);
            if (tc->cbf != NULL)
                tc->cbf(TFMSG_REPORT, msg);
            goto bad_ret;
        }
        te01_adc_min /= 1000.0;
	  
        sprintf(msg, ": %.5f, : %.5f", te01_dac_value / 1000.0, te01_adc_min);
        if (tc->cbf != NULL)
            tc->cbf(TFMSG_REPORT, msg);
	
        hltr11.InpMode           = LTR11_INPMODE_INT;
        hltr11.ADCRate.divider   = divider;
        hltr11.ADCRate.prescaler = prescaler;
        hltr11.LChQnt            = 1;
        hltr11.ADCMode           = LTR11_ADCMODE_ACQ;
        hltr11.StartADCMode      = LTR11_STARTADCMODE_INT;
        hltr11.LChTbl[0]         = (band << 6) | (0 << 4);

        frame_size = ADC_FRAME_SIZE;
        err_code   = getframe(tc, frame, FALSE, &frame_size);
        if (err_code != LTR_OK)
        {
            if (   err_code == LTR11_ERR_ADCDATA_CHNUM
                || err_code == LTR11_ERR_ADCDATA_SLOTNUM
                || err_code == LTR11_ERR_ADCDATA_CNT
               )
            {
                if (tc->cbf != NULL)
                    tc->cbf(TFMSG_REPORT, "!!!     ");
                if (++cnt_adcdata_err >= max_adcdata_err)
                {
                    if (tc->cbf != NULL)
                        tc->cbf(TFMSG_REPORT, "      ");
                    goto bad_ret;
                }
            }
            else
            {
                if (tc->cbf != NULL)
                    tc->cbf(TFMSG_REPORT, ".    LTR-11");
                goto bad_ret;
            }
        }
        getframe_avg(frame, frame_size, frame_avg);
		
        ltr11_min = frame_avg[0];
        sprintf(msg, ": te01=%.5f, ltr11=%.5f", te01_adc_min, ltr11_min);
        if (tc->cbf)
            tc->cbf(TFMSG_REPORT, msg);
            
		//ZERO 
        te01_dac_value = 0.0;

        SetSDAC_Value(te01, te01_dac_value, te01sdac_band_ltr11[band]);
        te01_adc_zero = GetUADC_Val(te01);
        
        e = 100 * (te01_adc_zero - te01_dac_value) / te01_uadc_ranges[te01adc_band_ltr11[band]];
        if (fabs(e) > te01_max_sdac_err)
        {
            sprintf(msg, " SDAC TE-01   (%+.2f%%)", e);
            if (tc->cbf != NULL)
                tc->cbf(TFMSG_REPORT, msg);
            goto bad_ret;
        }
        te01_adc_zero /= 1000.0;
	  
        sprintf(msg, ": %.3f, : %.3f", te01_dac_value / 1000.0, te01_adc_zero);
        if (tc->cbf)
            tc->cbf(TFMSG_REPORT, msg);
	
        hltr11.InpMode           = LTR11_INPMODE_INT;
        hltr11.ADCRate.divider   = divider;
        hltr11.ADCRate.prescaler = prescaler;
        hltr11.LChQnt            = 1;
        hltr11.ADCMode           = LTR11_ADCMODE_ACQ;
        hltr11.StartADCMode      = LTR11_STARTADCMODE_INT;
        hltr11.LChTbl[0]         = (band << 6) | (0 << 4);

        frame_size = ADC_FRAME_SIZE;
        err_code   = getframe(tc, frame, FALSE, &frame_size);
        if (err_code != LTR_OK)
        {
            if (   err_code == LTR11_ERR_ADCDATA_CHNUM
                || err_code == LTR11_ERR_ADCDATA_SLOTNUM
                || err_code == LTR11_ERR_ADCDATA_CNT
               )
            {
                if (tc->cbf != NULL)
                    tc->cbf(TFMSG_REPORT, "!!!     ");
                if (++cnt_adcdata_err >= max_adcdata_err)
                {
                    if (tc->cbf != NULL)
                        tc->cbf(TFMSG_REPORT, "      ");
                    goto bad_ret;
                }
            }
            else
            {
                if (tc->cbf != NULL)
                    tc->cbf(TFMSG_REPORT, ".    LTR-11");
                goto bad_ret;
            }
        }
        getframe_avg(frame, frame_size, frame_avg);

        ltr11_zero = frame_avg[0];
        sprintf(msg, ": te01=%.5f, ltr11=%.5f", te01_adc_zero, ltr11_zero);
        if (tc->cbf)
            tc->cbf(TFMSG_REPORT, msg);

	
        scale = (te01_adc_max - te01_adc_min) / (ltr11_max - ltr11_min);
        zero  = (te01_adc_zero / scale - ltr11_zero) * RESOLUTION / ranges[band];
        sprintf(msg, "zero %10.3f  scale %10.3f", zero, scale);
        if (tc->cbf)
            tc->cbf(TFMSG_REPORT, msg);

        e = 100 * fabs(zero / RESOLUTION);
        if (e > ltr11_max_cbrcoef[band].offset)
        {
            if (tc->cbf != NULL)
                tc->cbf(TFMSG_REPORT, "   ");
            goto bad_ret;
        }
        e = 100 * fabs(scale - 1);
        if (e > ltr11_max_cbrcoef[band].gain)
        {
            if (tc->cbf != NULL)
                tc->cbf(TFMSG_REPORT, "  ");
            goto bad_ret;
        }
        hltr11.CbrCoef[band].Offset = zero;
        hltr11.CbrCoef[band].Gain   = scale;
	} //for (band = 0; band < LTR11BANDS; band++)
    if (tc->cbf != NULL)
    {
        if (tc->cbf(TFMSG_PROGRESS(100.0), NULL))
            goto uabort;
    }
	
	if (tc->cbf != NULL)
	{
	    tc->cbf(TFMSG_REPORT, " ...");
	    err_code = write_coeffs(tc, bin_fname, 0);
	    if (tc->cbf != NULL)
	    {
	        tc->cbf(TFMSG_REPORT, (!err_code) ? "  " :
	            "  ");
	    }
	    
	    if (err_code)
            goto bad_ret;
	        
	    if (tc->cbf != NULL)
	        tc->cbf(TFMSG_REPORT, "  (k - , b -  )");
	    for (band = 0; band < LTR11_ADC_RANGEQNT; band++)
	    {
	        sprintf(msg, "Range %.3fV: k=%.4f  b=%.4f", ranges[band], hltr11.CbrCoef[band].Gain,
	            hltr11.CbrCoef[band].Offset);
	        if (tc->cbf != NULL)
	            tc->cbf(TFMSG_REPORT, msg);
	    }
	    
	    closeModule();
	    testPlolog(tc);
	    
	    utspGetModuleInfo(tc, NULL);
	}
 
    return TRES_T_OK;
 
bad_ret:
    return TRES_T_FAIL;

uabort:
    return TRES_ABORT;
    
#undef ADC_FRAME_SIZE
*/
	return 0; 
}      


/*************************************************************************************************************
 
**************************************************************************************************************/



