#include "toolbox.h"
#include "localdefs.h"
#include "pluginuir.h"
#include "Windows.h"
#include <ansi_c.h>
#include <userint.h>
#define TE01EXT11NAME      "TE-01A-11"     

#define P(x)  PANEL_##x
#define Pi (3.1415926535897932384626433832795)
#define ROM_IO (0x60)  

extern TLTR34 module;
extern IniSet_LTR34 IniSet;

char str[200];
char dllpath[FNAMELEN+1];
int LiveSinus =0;

//-----------------------------------------------------------------------------
int Pnl=-1, WPnl=-1, TePnl=-1, LogPnl=-1;
dataUpdateCBF_FPtr dataUpdateCBF=NULL;
HANDLE hThread=NULL;
HANDLE hThread1=NULL;     
TE01 *theTE01;   
char thePATH[FNAMELEN+1];
int stopFlag;
LPCSTR ErrorString;  




/*static void MakeWriteFlashCmd(WORD Address, BYTE ByteToWrite, DWORD *FlashCommand); 
static void  MakeEwenFlashCmd(DWORD *FlashCommand); 
static void  MakeEwdsFlashCmd(DWORD *FlashCommand); 
static void  MakeReadFlashCmd(WORD Address, DWORD *FlashCommand); 
static void  FlashReadRecover(DWORD *FlashCommand, BYTE *ReadBytes); */


void fillINI(void);
void readINI_my(char *xdir, char *mdescr);  
int getCtrlVals(void);

DWORD *CodeToSend; //  -          

//-----------------------------------------------------------------------------
void closeUIR(void) 
{
	if(Pnl !=-1) { DiscardPanel(Pnl);  Pnl =-1;  }
	if(WPnl!=-1) { DiscardPanel(WPnl); WPnl=-1; }  
	if(LogPnl!=-1) { DiscardPanel(LogPnl); LogPnl=-1; }   
}
//-----------------------------------------------------------------------------
void showWaitPanel(char *message)
{
	if(WPnl!=-1) 
	{
		if(GetActivePanel()!=WPnl) InstallPopup(WPnl);
		SetCtrlVal(WPnl, WP_TEXTMSG, message);
	}
}
//-----------------------------------------------------------------------------
void hideWaitPanel(void)
{
	if(WPnl!=-1) { DiscardPanel(WPnl); WPnl=-1; }  
}



void AddLog(char ItemString[])
{
	if (Pnl!=-1)
	{
		InsertListItem (Pnl, P_CONFIG_LISTBOX_LOG, -1, ItemString, 0);
	}   
}
//-----------------------------------------------------------------------------


void fillINI(void) 
{  //   UIR- 
	int j;


	memset(&IniSet, 0x0, sizeof(IniSet_LTR34));
	IniSet.ChannelQnt=1;
	IniSet.ChannelGroup=0;
	IniSet.RingMode= 1;
	IniSet.AckMode= 0;
	IniSet.FreqDivisor=60;  
	IniSet.UseCalibration=1;
	IniSet.FreqDAC=2e6/((64-60)*1);



	for (j=0;j<(LTR34_DAC_NUMBER_MAX*17);j++)
	{
		IniSet.ChannelGen[j].off=0;
		IniSet.ChannelGen[j].Type=0;
		IniSet.ChannelGen[j].Max=32767;
		IniSet.ChannelGen[j].Min=-32768;
		IniSet.ChannelGen[j].GEN_Freq=100;
	}

}


static char theDIR[FNAMELEN+1], theMDESCR[COMMENTLEN+1];    




void writeINI_my(void) 
{                           
	FILE *f;                                             
	char fname[FNAMELEN+1];                              
	sprintf(fname, "%s\\%s", theDIR, theMDESCR);         
	if((f= fopen(fname, "wb")) == NULL) return;          
	fwrite (&IniSet, sizeof(IniSet_LTR34), 1, f);           
	fclose(f);                                           
};                                                     




void readINI_my(char *xdir, char *mdescr) 
{
	FILE *f;
	char fname[FNAMELEN+1];
	strcpy(theDIR, xdir);
	strcpy(theMDESCR, mdescr);  
	fillINI();
	sprintf(fname, "%s\\%s", theDIR, theMDESCR);
	if((f= fopen(fname, "rb")) == NULL) return;
	fread (&IniSet, sizeof(IniSet_LTR34), 1, f);
	fclose(f);
};



void PrepareData(double* GenerateData, int Length, double *angle, double * Period)
{												 
	int NumChannels=module.ChannelQnt; 
	int j=0,ChannelNumber=0;
	double Amp=0;  
	double TempValue=0;
	double AddValue=0;
	for (j=0;j<Length;j+=ChannelNumber)
	{
		for (ChannelNumber=0;ChannelNumber<NumChannels;ChannelNumber++)
		{				  
			Amp=(IniSet.ChannelGen[ChannelNumber].Max-IniSet.ChannelGen[ChannelNumber].Min);
			switch (IniSet.ChannelGen[ChannelNumber].Type)
			{
			case 0:  // 		  
				TempValue=sin(angle[ChannelNumber])*(Amp/2);
				TempValue+=((Amp/2)+IniSet.ChannelGen[ChannelNumber].Min);
				
				AddValue = 2 * Pi / Period[ChannelNumber];       
				angle[ChannelNumber]+=AddValue;
				break;

			case 1:  // 
				TempValue=(Amp*angle[ChannelNumber]+IniSet.ChannelGen[ChannelNumber].Min);
				angle[ChannelNumber]+=1/Period[ChannelNumber];
				if (angle[ChannelNumber]>=IniSet.ChannelGen[ChannelNumber].Max)
				{
					angle[ChannelNumber] = IniSet.ChannelGen[ChannelNumber].Min;
				}
				break;

			case 2:  // 
				if (angle[ChannelNumber]<Period[ChannelNumber]/2)
				{
					TempValue=IniSet.ChannelGen[ChannelNumber].Min;
				}
				else
				{
					TempValue=IniSet.ChannelGen[ChannelNumber].Max;
				}
				angle[ChannelNumber]+=1/Period[ChannelNumber]; 
				if (angle[ChannelNumber]>=Period[ChannelNumber])angle[ChannelNumber]=0;
				break;

			case 3:  //  
				TempValue=IniSet.ChannelGen[ChannelNumber].Max;
				break;
			default:
				break;
			}

			if (TempValue>32767)TempValue=32767;
			if (TempValue<-32768)TempValue=-32768;

			GenerateData[j+ChannelNumber]=TempValue;
		}
	}
}


double * GenerateData=NULL;  

int DataReaderRunning=0; 
void DataReader(int * Leng)
{  
	int Length = *Leng;//*Leng; !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!        
	DWORD * RecieveData=(DWORD *) malloc(Length*sizeof(DWORD));
	int counter=0;
	int ErrorCounter;
	int WordsRecieved;

	int iter=0;
	DataReaderRunning = 1;

	AddLog("  ");    

	if (module.AcknowledgeType==1) WordsRecieved=LTR34_Recv(&module, RecieveData, NULL, Length, 3000); 

	while (DataReaderRunning)
	{

		if (module.AcknowledgeType==1)
		{ 
			if (WordsRecieved!=Length)
		 {
			 AddLog("  ");
		 }

			else
			{

				if (module.BufferEmpty)
				{
					AddLog(" ");
				}

				if (module.BufferFull)
				{
					AddLog(" ");
				}

				ErrorCounter=0;

				if (!LiveSinus)
				{
					for (counter=0;counter<Length;counter++)
					{  
						if ((CodeToSend[counter]>>16)!=(RecieveData[counter]>>16))
						{  

							sprintf(str, "  ,     %X,  %X", (CodeToSend[counter])>>16, (RecieveData[counter]>>16));     
							AddLog(str);
							AddLog("  :   - ");


						}
					}	 
				}		 
			}
			WordsRecieved=LTR34_Recv(&module, RecieveData, NULL, Length, 3000);	   
		}
		else
		{

			Sleep(10);   
		} 
	}

	if (RecieveData!=NULL) free(RecieveData);    

	AddLog("  ");
	ExitThread(0);    	
}


void DataRecorder(void *param) 
{	
	int Counter, i;
	int Clb=0, ChGroup=0;   
	int Res=LTR_OK;
	int NumChannels=/*1<<*/module.ChannelQnt; 
	int Length=((int)((module.FrequencyDAC/NumChannels)))*NumChannels; //  int  
	//   numChannels,  length    numchannels
	double angle[16];
	double period[16];
	memset(angle,0,sizeof(angle));
	for (i=0;i<NumChannels;i++)
	{		   
		if (LiveSinus&&!IniSet.RingMode)
		{
			period[i] = module.FrequencyDAC/IniSet.ChannelGen[i].GEN_Freq;
		}
		else
		{
			period[i] = module.FrequencyDAC/IniSet.ChannelGen[0].GEN_Freq;  
		}
	}

	AddLog("  ");	   

	//    
	Clb=IniSet.UseCalibration;

	//   							
	if (module.RingMode)
	{  //     

		Length=((int)((module.FrequencyDAC/IniSet.ChannelGen[0].GEN_Freq)))*NumChannels; //  int  
		if (Length>LTR34_MAX_BUFFER_SIZE)Length=LTR34_MAX_BUFFER_SIZE;

		GenerateData=malloc(Length*sizeof(double));
		CodeToSend=malloc(Length*sizeof(DWORD));
		
		if (GenerateData==NULL) 
		{
			AddLog("   ");
			Res=-1;
		}

		PrepareData(GenerateData, Length, angle, period);
		LTR34_ProcessData(&module, GenerateData, CodeToSend, Length, 0); //    
		//    
		hThread1=CreateThread(NULL, 20000, (LPTHREAD_START_ROUTINE)DataReader, &Length , 0 , NULL);
		
		if (LTR34_Send(&module,CodeToSend,Length,10000)==Length) 
		{
			if (LTR34_DACStart(&module)==LTR_OK)
			{   
				//DataReaderRunning=1;       
				//hThread1=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)DataReader,&Length , NULL , NULL);
				AddLog("  ");

				while(!stopFlag) 
				{
					//ProcessSystemEvents();     
					Sleep(10);		
				};

			}else { MessagePopup("dsfg","  !"); AddLog("   ");}
		}
	} //  if 
	else
	{   //    
		//     -     
		//   ,      
		Length=((int)((module.FrequencyDAC/NumChannels)))*NumChannels; //  int     
		if (Length>LTR34_MAX_BUFFER_SIZE)Length=LTR34_MAX_BUFFER_SIZE;   

		GenerateData=malloc(Length*sizeof(double));
		CodeToSend=malloc(Length*sizeof(DWORD)); 
		
		if (GenerateData==NULL) 
		{
			AddLog("   ");
			Res=-1;
		}

		//      
		PrepareData(GenerateData, Length, angle, period);
		LTR34_ProcessData(&module, GenerateData, CodeToSend, Length, 0); 
		if (LTR34_Send(&module,CodeToSend,Length,3000)==Length) 
		{
			if (LTR34_DACStart(&module)==LTR_OK)
			{ 
				AddLog("  ");
				
				//    
				hThread1=CreateThread(NULL, 20000, (LPTHREAD_START_ROUTINE)DataReader,&Length , 0 , NULL);

				while(!stopFlag) 
				{
					if (LiveSinus)      
					{	
						PrepareData(GenerateData, Length, angle, period);  
						LTR34_ProcessData(&module, GenerateData, CodeToSend, Length, 0);
						Sleep(1);
					}

					if (LTR34_Send(&module,CodeToSend, Length,3000)!=Length)              
					{
						AddLog("  ");						
					}
				};
				AddLog("  "); 
			}else { MessagePopup("dsfg","  !"); AddLog("   ");} //else AddLog("   ");
		}
		else AddLog("     ");		 

	}

	DataReaderRunning=0; 
	if (hThread1!=NULL)
	{
		WaitForSingleObject(hThread1, INFINITE);
		CloseHandle(hThread1);
		hThread1=NULL;
	}

	if (GenerateData!=NULL) free(GenerateData);
	if (CodeToSend!=NULL)free(CodeToSend); 

	AddLog("  ");

	

	ExitThread(0);  


} 



//-----------------------------------------------------------------------------
//     "Module Configuration"
//-----------------------------------------------------------------------------

int LastValueNumChannels=-1;

/**************************************************************************

        IniSet

**************************************************************************/    

int getCtrlVals(void)
{
	int panel=Pnl;

	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_1, &IniSet.ChannelGen[0].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_2, &IniSet.ChannelGen[1].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_3, &IniSet.ChannelGen[2].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_4, &IniSet.ChannelGen[3].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_5, &IniSet.ChannelGen[4].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_6, &IniSet.ChannelGen[5].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_7, &IniSet.ChannelGen[6].GEN_Freq); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_8, &IniSet.ChannelGen[7].GEN_Freq); // 

	GetCtrlVal(panel, P_CONFIG_RING_2, &IniSet.ChannelGen[0].Type); //  
	GetCtrlVal(panel, P_CONFIG_RING_3, &IniSet.ChannelGen[1].Type); 
	GetCtrlVal(panel, P_CONFIG_RING_4, &IniSet.ChannelGen[2].Type); 
	GetCtrlVal(panel, P_CONFIG_RING_5, &IniSet.ChannelGen[3].Type); 
	GetCtrlVal(panel, P_CONFIG_RING_6, &IniSet.ChannelGen[4].Type); 
	GetCtrlVal(panel, P_CONFIG_RING_7, &IniSet.ChannelGen[5].Type); 
	GetCtrlVal(panel, P_CONFIG_RING_8, &IniSet.ChannelGen[6].Type); 
	GetCtrlVal(panel, P_CONFIG_RING_9, &IniSet.ChannelGen[7].Type); 

	GetCtrlVal(panel, P_CONFIG_NUMERIC_1, &IniSet.ChannelGen[0].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_3, &IniSet.ChannelGen[1].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_5, &IniSet.ChannelGen[2].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_7, &IniSet.ChannelGen[3].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_9, &IniSet.ChannelGen[4].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_11, &IniSet.ChannelGen[5].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_13, &IniSet.ChannelGen[6].Min); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_15, &IniSet.ChannelGen[7].Min); // 

	GetCtrlVal(panel, P_CONFIG_NUMERIC_2, &IniSet.ChannelGen[0].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_4, &IniSet.ChannelGen[1].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_6, &IniSet.ChannelGen[2].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_8, &IniSet.ChannelGen[3].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_10, &IniSet.ChannelGen[4].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_12, &IniSet.ChannelGen[5].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_14, &IniSet.ChannelGen[6].Max); // 
	GetCtrlVal(panel, P_CONFIG_NUMERIC_16, &IniSet.ChannelGen[7].Max); // 


	GetCtrlVal (panel, P_CONFIG_RINGSLIDE_NUMCHANNELS, &IniSet.ChannelQnt); 
	if(IniSet.ChannelQnt>module.ModuleInfo.MaxChannelQnt)
	{
		MessagePopup("!","!  4-     4 !");
		IniSet.ChannelQnt=4;
	}

	GetCtrlVal(panel, P_CONFIG_BINARYSWITCH_GEN_TYPE, &IniSet.RingMode);  
	GetCtrlVal(panel, P_CONFIG_calibr, &IniSet.UseCalibration); 
	GetCtrlVal(panel, P_CONFIG_TOGGLEBUTTON_CONFIRMA, &IniSet.AckMode);  
	GetCtrlVal(panel, P_CONFIG_NUMERIC_FREQ_DIV, &IniSet.FreqDivisor);
	GetCtrlVal(panel, P_CONFIG_ChannelGroup_SW, &IniSet.ChannelGroup); 

	return(0);   
}

int UpdateConfigControls()
{   
	byte i=0;
	float Freq=0;
	int panel=Pnl;
	double FreqValue;
	int Value=0;

	if (LastValueNumChannels!=IniSet.ChannelQnt)
	{
		LastValueNumChannels=IniSet.ChannelQnt;
		//	ClearListCtrl (panel, P_CONFIG_RING_FREQ_DAC);
		/*	for (i=0;i<=60;i++)
		{
		Freq=2000000/((64-i)*(IniSet.ChannelQnt));
		sprintf(str, "%6.1f", Freq);  
		InsertListItem (panel, P_CONFIG_RING_FREQ_DAC, i, str,i);
		}; */
	}

	SetCtrlVal (panel, P_CONFIG_ModuleName_STR,  module.ModuleInfo.Name);  
	SetCtrlVal (panel, P_CONFIG_Serial_STR,  module.ModuleInfo.Serial);  

	SetCtrlVal (panel, P_CONFIG_NUMERIC_FREQ_DIV,  IniSet.FreqDivisor);
	SetCtrlVal (panel, P_CONFIG_RINGSLIDE_NUMCHANNELS, IniSet.ChannelQnt);
	SetCtrlVal (panel, P_CONFIG_BINARYSWITCH_GEN_TYPE, IniSet.RingMode);
	SetCtrlVal (panel, P_CONFIG_TOGGLEBUTTON_CONFIRMA, IniSet.AckMode);  
	SetCtrlVal(panel,  P_CONFIG_calibr, IniSet.UseCalibration);   
	SetCtrlVal(panel,  P_CONFIG_ChannelGroup_SW, IniSet.ChannelGroup);   
	
	if(IniSet.ChannelQnt>module.ModuleInfo.MaxChannelQnt)
	{
		MessagePopup("!","!  4-     4 !");
		IniSet.ChannelQnt=4;
	}


	FreqValue=2E6/((64-IniSet.FreqDivisor)*IniSet.ChannelQnt);
	SetCtrlVal (panel, P_CONFIG_Frequency_NUM, FreqValue);  
	
	if (!IniSet.RingMode&&LiveSinus) Value=0;
	else Value=1;
	
	SetCtrlAttribute (panel, P_CONFIG_Live_Sinus, ATTR_DIMMED, IniSet.RingMode);           


	SetCtrlAttribute (panel, P_CONFIG_RING_2, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_RING_3, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_RING_4, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_RING_5, ATTR_DIMMED, false);

	SetCtrlAttribute (panel, P_CONFIG_RING_6, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_RING_7, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_RING_8, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_RING_9, ATTR_DIMMED, false);	  

	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_1, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_2, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_3, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_4, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_5, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_6, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_7, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_8, ATTR_DIMMED, false);

	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_9, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_10, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_11, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_12, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_13, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_14, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_15, ATTR_DIMMED, false);
	SetCtrlAttribute (panel, P_CONFIG_NUMERIC_16, ATTR_DIMMED, false);  
	
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_2, ATTR_DIMMED , Value); // 
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_3, ATTR_DIMMED , Value); // 
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_4, ATTR_DIMMED , Value); // 
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_5, ATTR_DIMMED , Value); // 
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_6, ATTR_DIMMED , Value); // 
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_7, ATTR_DIMMED , Value); // 
	SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_8, ATTR_DIMMED , Value); // 

	switch(IniSet.ChannelQnt)
	{

	case 1:
		SetCtrlAttribute (panel, P_CONFIG_RING_3, ATTR_DIMMED, true);

		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_3, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_4, ATTR_DIMMED, true);
		
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_2, ATTR_DIMMED , true); // 
	case 2:																 
		SetCtrlAttribute (panel, P_CONFIG_RING_4, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_RING_5, ATTR_DIMMED, true);

		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_5, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_6, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_7, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_8, ATTR_DIMMED, true);	  
		
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_3, ATTR_DIMMED , true); // 
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_4, ATTR_DIMMED , true); // 
	case 4:
		SetCtrlAttribute (panel, P_CONFIG_RING_6, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_RING_7, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_RING_8, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_RING_9, ATTR_DIMMED, true);	 

		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_9, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_10, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_11, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_12, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_13, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_14, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_15, ATTR_DIMMED, true);
		SetCtrlAttribute (panel, P_CONFIG_NUMERIC_16, ATTR_DIMMED, true);
		
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_5, ATTR_DIMMED , true); // 
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_6, ATTR_DIMMED , true); // 
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_7, ATTR_DIMMED , true); // 
		SetCtrlAttribute(panel, P_CONFIG_NUMERIC_FREQUENCY_8, ATTR_DIMMED , true); // 
	case 8:
	default: break;
	}


	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_1, IniSet.ChannelGen[0].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_2, IniSet.ChannelGen[1].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_3, IniSet.ChannelGen[2].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_4, IniSet.ChannelGen[3].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_5, IniSet.ChannelGen[4].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_6, IniSet.ChannelGen[5].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_7, IniSet.ChannelGen[6].GEN_Freq); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_FREQUENCY_8, IniSet.ChannelGen[7].GEN_Freq); // 

	SetCtrlVal(panel, P_CONFIG_RING_2, IniSet.ChannelGen[0].Type); //  
	SetCtrlVal(panel, P_CONFIG_RING_3, IniSet.ChannelGen[1].Type); 
	SetCtrlVal(panel, P_CONFIG_RING_4, IniSet.ChannelGen[2].Type); 
	SetCtrlVal(panel, P_CONFIG_RING_5, IniSet.ChannelGen[3].Type); 
	SetCtrlVal(panel, P_CONFIG_RING_6, IniSet.ChannelGen[4].Type); 
	SetCtrlVal(panel, P_CONFIG_RING_7, IniSet.ChannelGen[5].Type); 
	SetCtrlVal(panel, P_CONFIG_RING_8, IniSet.ChannelGen[6].Type); 
	SetCtrlVal(panel, P_CONFIG_RING_9, IniSet.ChannelGen[7].Type); 

	SetCtrlVal(panel, P_CONFIG_NUMERIC_1, IniSet.ChannelGen[0].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_3, IniSet.ChannelGen[1].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_5, IniSet.ChannelGen[2].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_7, IniSet.ChannelGen[3].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_9, IniSet.ChannelGen[4].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_11,IniSet.ChannelGen[5].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_13,IniSet.ChannelGen[6].Min); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_15,IniSet.ChannelGen[7].Min); // 

	SetCtrlVal(panel, P_CONFIG_NUMERIC_2, IniSet.ChannelGen[0].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_4, IniSet.ChannelGen[1].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_6, IniSet.ChannelGen[2].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_8, IniSet.ChannelGen[3].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_10,IniSet.ChannelGen[4].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_12,IniSet.ChannelGen[5].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_14,IniSet.ChannelGen[6].Max); // 
	SetCtrlVal(panel, P_CONFIG_NUMERIC_16,IniSet.ChannelGen[7].Max); // 
	
	return 0;
}


static void copyIni2Ltr34Struc() 
{
	int i;
	//bool ChannelScaleFlag;



	module.FrequencyDivisor=IniSet.FreqDivisor;


	module.RingMode=IniSet.RingMode;
	module.ChannelQnt=IniSet.ChannelQnt;
	module.AcknowledgeType=IniSet.AckMode;
	module.ExternalStart=0;
	module.UseClb=IniSet.UseCalibration;


	for(i=0;i<module.ChannelQnt;i++)
		module.LChTbl[i]=LTR34_CreateLChannel(i+1, IniSet.ChannelGroup);   
}




int CVICALLBACK ChangeFreqDiv (int panel, int control, int event,
							   void *callbackData, int eventData1, int eventData2)
{
	double FreqValue;
	int FreqDiv;

	switch (event)
	{
	case EVENT_COMMIT:

		getCtrlVals();   
		UpdateConfigControls(); 

		break;
	}
	return 0;
}

int CVICALLBACK ChengeFreqDiv_2 (int panel, int control, int event,
								 void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_COMMIT:
		GetCtrlVal(panel, control, &module.FrequencyDivisor); 
		if (LTR34_Config(&module)==LTR_OK)  
		{
			//UpdateConfigControls();
		}
		else
		{
			MessagePopup("", "   ");
		}						   
		break;
	}
	return 0;
}

//-----------------------------------------------------------------------------
int CVICALLBACK cbf_control(int panel, int control, int event, void *callbackData, int eventData1, int eventData2)
{
	switch(event) {
	case EVENT_COMMIT :

		getCtrlVals();   
		UpdateConfigControls(); 

		break;
	}
	return 0;
}

//-----------------------------------------------------------------------------
int CVICALLBACK StartStopGeneration (int panel, int control, int event,
									 void *callbackData, int eventData1, int eventData2)
{
	int dw=0;  
	int Value=0;
	int Res;
	switch (event)
	{
	case EVENT_COMMIT:	  


		GetCtrlVal(panel, control, &Value); 

		if (Value)
		{  

			//   
			getCtrlVals();

			//      
			copyIni2Ltr34Struc(); 

			Res=LTR34_Reset(&module); //       
			if (Res!=LTR_OK)  
		 {
			 ErrorString=LTR34_GetErrorString(Res);
			 MessagePopup("", ErrorString);
			 return(1);
			}  




			//   
			Res=LTR34_Config(&module);
			if (Res!=LTR_OK)
		 {
			 ErrorString=LTR34_GetErrorString(Res);
			 MessagePopup("", ErrorString);
			 return(1);
			} 


			if (hThread!=NULL)
			{
				GetExitCodeThread(hThread, &dw);
				if (dw==-100)
				{
					CloseHandle(hThread);
					hThread=NULL;
				}
				else
				{
					Value=0;
					SetCtrlVal(panel, control, Value);
				}
			}

			if (hThread==NULL) 
			{
				ClearListCtrl (panel, P_CONFIG_LISTBOX_LOG);


				stopFlag=false;
				
				//    
				hThread=CreateThread(NULL, 20000, (LPTHREAD_START_ROUTINE)DataRecorder,NULL , 0 , NULL);
			}

			//SetThreadPriority(hThread, THREAD_PRIORITY_ABOVE_NORMAL);  
		}
		else
		{
			stopFlag=true;
			
			WaitForSingleObject(hThread, INFINITE);
			CloseHandle(hThread);
			hThread=NULL; 

			if (LTR34_DACStop(&module)!=LTR_OK) AddLog("   ") ;
			else  AddLog(" "); 		 

		}
		break;
	}
	return 0;
}

int CVICALLBACK ChangeGenerationType (int panel, int control, int event,
									  void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_COMMIT:										  

		getCtrlVals();   
		UpdateConfigControls(); 
		break;
	}
	return 0;
}

int CVICALLBACK ChangeNumChannels (int panel, int control, int event,
								   void *callbackData, int eventData1, int eventData2)
{
	unsigned char i=0;
	float Freq;
	switch (event)
	{
	case EVENT_COMMIT:


		getCtrlVals();   
		UpdateConfigControls(); 


		break;
	}
	return 0;
}

int CVICALLBACK ChangeConfirmationType (int panel, int control, int event,
										void *callbackData, int eventData1, int eventData2)
{
	int Value=0;
	switch (event)
	{
	case EVENT_COMMIT:

		getCtrlVals();   
		UpdateConfigControls();

		break;
	}
	return 0;
}


int CVICALLBACK PanelConfigCallback (int panel, int event, void *callbackData,
									 int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_GOT_FOCUS:

		break;
	case EVENT_LOST_FOCUS:

		break;
	case EVENT_CLOSE:
		stopFlag=true;


		getCtrlVals();    

		DiscardPanel (Pnl);
		Pnl=-1;
		IniSet.ModulesConfiguration[module.Channel.cc]=module;
		writeINI_my(); 
		break;
	}
	return 0;
}

int CVICALLBACK te01f_write (int panel, int control, int event,
							 void *callbackData, int eventData1, int eventData2)
{
	int  j;
	int  s1;
	char s2[2] = {0,0};
	int  s3;
	BYTE sn[6];


	switch (event)
	{
	case EVENT_COMMIT:
		showWaitPanel(NULL);

		GetCtrlVal(panel, PANEL_TE01_serial1, &s1);
		GetCtrlVal(panel, PANEL_TE01_serial2, s2);
		GetCtrlVal(panel, PANEL_TE01_serial3, &s3);
		sn[0] = s3 & 0xFF;
		sn[1] = (s3 >> 8) & 0xFF;
		sn[2] = (s3 >> 16) & 0xFF;
		sn[3] = s2[0];
		sn[4] = s1 & 0xFF;
		sn[5] = 0;

		for (j = 0; j < 6; j++)
			theTE01->amodule_eeprom.sn[j] = sn[j];

		GetCtrlVal(panel, PANEL_TE01_name, theTE01->amodule_eeprom.name);
		GetCtrlVal(panel, PANEL_TE01_revision, &s1);
		theTE01->amodule_eeprom.revision = s1;
		GetCtrlVal(panel, PANEL_TE01_mid, &s1);
		theTE01->amodule_eeprom.mid = s1;
		GetCtrlVal(panel, PANEL_TE01_comment, theTE01->amodule_eeprom.comment);

		if (TE01SystemAreaWriteEnable(theTE01) || TE01WriteAModuleEEPROM(theTE01))
		{
			hideWaitPanel();
			MessagePopup(MSG_ERROR, "Failed update EEPROM");
		}
		else
		{
			hideWaitPanel();
			MessagePopup(MSG_PROMPT, "EEPROM has been updated");
		}

		break;
	}
	return 0;
}

int CVICALLBACK te01f_read (int panel, int control, int event,
							void *callbackData, int eventData1, int eventData2)
{   
	char q[2] = {0, 0};
	int  sn;
	switch (event)
	{
	case EVENT_COMMIT:
		showWaitPanel(NULL);
		if(TE01ReadAModuleEEPROM(theTE01))
		{
			hideWaitPanel();
			MessagePopup(MSG_ERROR, "Failed read EEPROM");
			break;
		}
		SetCtrlVal(panel, PANEL_TE01_serial1, theTE01->amodule_eeprom.sn[4]);
		q[0] = theTE01->amodule_eeprom.sn[3];
		SetCtrlVal(panel, PANEL_TE01_serial2, q);
		sn  = theTE01->amodule_eeprom.sn[0];
		sn |= (((int)theTE01->amodule_eeprom.sn[1]) << 8);
		sn |= (((int)theTE01->amodule_eeprom.sn[2]) << 16);
		SetCtrlVal(panel, PANEL_TE01_serial3, sn);
		SetCtrlVal(panel, PANEL_TE01_name, theTE01->amodule_eeprom.name);
		SetCtrlVal(panel, PANEL_TE01_revision, theTE01->amodule_eeprom.revision);
		SetCtrlVal(panel, PANEL_TE01_mid, theTE01->amodule_eeprom.mid);
		SetCtrlVal(panel, PANEL_TE01_comment, theTE01->amodule_eeprom.comment);
		hideWaitPanel();
		break;
	}
	return 0;
}


int CVICALLBACK te01f_default (int panel, int control, int event,
							   void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_COMMIT:
		SetCtrlVal(panel, PANEL_TE01_serial1, 1);
		SetCtrlVal(panel, PANEL_TE01_serial2, "C");
		SetCtrlVal(panel, PANEL_TE01_serial3, 1);
		SetCtrlVal(panel, PANEL_TE01_name, TE01EXT11NAME);
		SetCtrlVal(panel, PANEL_TE01_revision, 1);
		SetCtrlVal(panel, PANEL_TE01_mid, 1);
		SetCtrlVal(panel, PANEL_TE01_comment, " LTR-11");   
		break;
	}
	return 0;
}

int CVICALLBACK Panel_TE01_Callback (int panel, int event, void *callbackData,
									 int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_GOT_FOCUS:

		break;
	case EVENT_LOST_FOCUS:

		break;
	case EVENT_CLOSE:
		DiscardPanel (TePnl);
		TePnl=-1;
		break;
	}
	return 0;
}

int CVICALLBACK PANEL_LOG_CALLBACK (int panel, int event, void *callbackData,
									int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_GOT_FOCUS:

		break;
	case EVENT_LOST_FOCUS:

		break;
	case EVENT_CLOSE:
		DiscardPanel (LogPnl);       
		LogPnl=-1;
		break;
	}
	return 0;
}


int utspLoadADSP(TCONTEXT *tc, void *p) {  return 0; };
int utspConfigTest(TCONTEXT *tc, void *p) {  return 0; };
int utspVirtualDevice(TCONTEXT *tc, void *p) { return 0; };

//-----------------------------------------------------------------------------

/********************************************************************************
  TE01
*********************************************************************************/
int utspConfigTe01Ext(TCONTEXT *tc, void *p) 
{ 
	char ppath[FNAMELEN+1];


	if (TePnl != -1)
	{
		SetActivePanel(TePnl);
		return 0;
	}	  \


		//TempFunc funcPointer= (TempFunc)GetProcAddress(descr,"funcName")

		theTE01 = (TE01 *)(tc->te01);
	sprintf(ppath, "%s\\%s", tc->dllpath, "pluginuir.uir");
	strcpy(thePATH, ppath);

	TePnl = LoadPanelEx (0, ppath, PANEL_TE01, __CVIUserHInst);  
	DisplayPanel(TePnl);


	te01f_read(TePnl, PANEL_TE01_read, EVENT_COMMIT, NULL, 0, 0);

	return 0; 
}

/*********************************************************************************
  
**********************************************************************************/

int utspGetDescrADC(TCONTEXT *tc, pluginADC *D, int ch) 
{
	return 0;
}
//-----------------------------------------------------------------------------
//   (   module->config)
//-----------------------------------------------------------------------------
typedef void (*Function) (void);
int utspConfigDevice(TCONTEXT *tc, void *p)
{	
	HMODULE descr;  
	Function ff;

	descr= LoadLibrary("WindowsApplication3.dll");


	ff = (Function)GetProcAddress(descr, TEXT("_Form1")); 

	sprintf(dllpath, "%s\\%s", tc->dllpath, "pluginuir.uir");

	Pnl=LoadPanelEx(0, dllpath, P_CONFIG, __CVIUserHInst); 
	InstallPopup(Pnl);   

	if(!openModule(tc))
	{   
		LastValueNumChannels=-1;


		readINI_my(tc->dllpath, tc->mdescr); 
		UpdateConfigControls();
		copyIni2Ltr34Struc();  
	}
	return 0;
}


int CVICALLBACK Temp_CLB (int panel, int control, int event,
						  void *callbackData, int eventData1, int eventData2)
{

	double TmpArray[10000];
	int i;
	int res;
	DWORD cmd[5];
	DWORD ack_cmd;
	DWORD data[5001];
	int tick;


	switch (event)
	{
	case EVENT_COMMIT:


		/***  STOP-RESET-STOP  ****/

		cmd[0]=LTR010CMD_STOP;   //  0x8000
		cmd[1]=LTR010CMD_RESET;  //  0x8080

		//  STOP-RESET 		
		res=LTR_Send(&module.Channel, cmd, 2, 4000); 

		//    RESET 
		res=LTR_Recv(&module.Channel, &ack_cmd, NULL,1, 4000); //  STOP-RESET 

		//  STOP
		cmd[0]=LTR010CMD_STOP;   //  0x8000
		res=LTR_Send(&module.Channel, cmd, 1, 4000);   


		/*   CONTROL         

		 nn=1, ..    
		 S=1, ..       
		 G=1, ..   
		 E=0, ..   										  
		 ""   FIFO-

		  CODE  0.
		  :2*1000000/(64*2)=15625 

		 CONTROL  3- :

		1
		11100000
		01001110
		00000000

		  32- :

		4E 00 80 E0	   */

		//   

		//cmd[0]=0x4E0080E0;

		// 
		cmd[0]=0x4C0080E0;  

		res=LTR_Send(&module.Channel, cmd, 1, 4000); 

		/*    . 
		   - 2     0  25000
		*/

		/* data[0]=0x00000002; // 1-  1- 
		data[1]=0x00000000; // 1-  2-   
		data[2]=0x61A80002; // 1-  2-      
		data[3]=0x61A80000; // 2-  1- 
		data[4]=0x7FFF0002; // 2-  2-   
		data[5]=0x7FFF0000; // 2-  2-  */ 


		data[0]=0x00000000; // 1-  1- 
		data[1]=0x00000002; // 1-  2-   
		data[2]=0x61A80000; // 1-  2-    
		data[3]=0x61A80002; // 2-  1- 


		memset(data,0,sizeof(data));


		/*  */


		/*    *************************/
		/*   for(i=1;i<5001;i++)
		{
		if((i%2))
		data[i]|=0;
		else
		data[i]|=2;
		} 



		for(i=3;i<5001;i+=4)
		{

		data[i]|=0x61A80000;
		} 

		for(i=4;i<5001;i+=4)
		{

		data[i]|=0x61A80000;
		}  
		*/





		/***************************************************/

		/*   **********************************/


		for(i=1;i<5000;i++)
		{
			if(!(i%2))
				data[i]|=0;
			else
				data[i]|=2;
		} 



		for(i=2;i<5001;i+=4)
		{

			data[i]|=0x61A80000;
		} 

		for(i=3;i<5001;i+=4)
		{

			data[i]|=0x61A80000;
		} 		


		/*************************************************/ 

		//    FIFO-

		res=LTR_Send(&module.Channel, data, 5000, 4000);  

		//  

		cmd[0]=0x000080C0;
		res=LTR_Send(&module.Channel, cmd, 1, 4000); 


		tick=GetTickCount();

		while(1)
		{
			res=LTR_Send(&module.Channel, data, 5000, 4000); 

			if((GetTickCount()-tick)>5000)
				break; 
		}


		//
		cmd[0]=LTR010CMD_STOP;   //  0x8000
		res=LTR_Send(&module.Channel, cmd, 1, 4000);   


		/*
		cmd[0]=LTR010CMD_RESET;  //  0x8080

		//  STOP-RESET 		
		res=LTR_Send(&module.Channel, cmd, 1, 4000); 

		//    RESET 
		res=LTR_Recv(&module.Channel, &ack_cmd, NULL,1, 4000); //  STOP-RESET 




		//
		cmd[0]=LTR010CMD_STOP;   //  0x8000
		res=LTR_Send(&module.Channel, cmd, 1, 4000);  */ 


		Sleep(2000);


		cmd[0]=0x4C0080E0;  
		res=LTR_Send(&module.Channel, cmd, 1, 4000); 

		//    FIFO-

		res=LTR_Send(&module.Channel, data, 5000, 4000);  

		//  

		cmd[0]=0x000080C0;
		res=LTR_Send(&module.Channel, cmd, 1, 4000); 


		tick=GetTickCount();

		while(1)
		{
			res=LTR_Send(&module.Channel, data, 5000, 4000); 

			if((GetTickCount()-tick)>20000)
				break;
		}


		//
		cmd[0]=LTR010CMD_STOP;   //  0x8000
		res=LTR_Send(&module.Channel, cmd, 1, 4000);   





		break;
	}
	return 0;
}


#ifdef ABC
int CVICALLBACK Exp_CLB (int panel, int control, int event,
						 void *callbackData, int eventData1, int eventData2)
{
	double TmpArray[10000];
	int i;
	int res;
	DWORD cmd[5];
	DWORD ack_cmd;
	DWORD data[5001];
	DWORD ack[5000];
	int tick;
	int SS;
	char s[255];
	int StopFlag=0;
	BYTE freq_div;
	INT fr_div_int;


	switch (event)
	{
	case EVENT_COMMIT:



		GetCtrlVal (panel, P_CONFIG_Exp_SW, &SS);
		GetCtrlVal (panel, P_CONFIG_NUMERIC_FREQ_DIV, &freq_div);
		fr_div_int=(INT) freq_div;



		if(SS==1)
		{  



			/***  STOP-RESET-STOP  ****/

			cmd[0]=LTR010CMD_STOP;   //  0x8000
			cmd[1]=LTR010CMD_RESET;  //  0x8080

			//  STOP-RESET 		
			res=LTR_Send(&module.Channel, cmd, 2, 4000); 

			//    RESET 
			res=LTR_Recv(&module.Channel, &ack_cmd, NULL,1, 4000); //  STOP-RESET 

			//  STOP
			cmd[0]=LTR010CMD_STOP;   //  0x8000
			res=LTR_Send(&module.Channel, cmd, 1, 4000);   


			/*   CONTROL         

			 nn=1, ..    
			 S=1, ..       
			 G=1, ..   
			 E=0, ..   										  
			 ""   FIFO-

			  CODE  0.
			  :2*1000000/(64*2)=15625 

			 CONTROL  3- :

			1
			11100000
			01001110
			00000000

			  32- :

			4E 00 80 E0	   */

			//   

			//cmd[0]=0x4E0080E0;
			cmd[0]=0x4A0080E0;

			//fr_div_int=59;//59;
			cmd[0]|=(fr_div_int<<16);




			// 
			// cmd[0]=0x4C0080E0;  

			res=LTR_Send(&module.Channel, cmd, 1, 4000); 

			/*    . 
			   - 2     0  25000
			*/

			/* data[0]=0x00000002; // 1-  1- 
			data[1]=0x00000000; // 1-  2-   
			data[2]=0x61A80002; // 1-  2-      
			data[3]=0x61A80000; // 2-  1- 
			data[4]=0x7FFF0002; // 2-  2-   
			data[5]=0x7FFF0000; // 2-  2-  */ 


			data[0]=0x00000000; // 1-  1- 
			data[1]=0x00000002; // 1-  2-   
			data[2]=0x61A80000; // 1-  2-    
			data[3]=0x61A80002; // 2-  1- 



			//    FIFO-

			res=LTR_Send(&module.Channel, data, 4, 4000);  

			//  

			cmd[0]=0x000080C0;
			res=LTR_Send(&module.Channel, cmd, 1, 4000); 


			res=LTR_Recv(&module.Channel, ack, NULL,5000, 4000); //  

			//

			for(i=0;i<16;i++)
			{
				sprintf(s,"%x", ack[i]);
				InsertTextBoxLine (panel, P_CONFIG_TEXTBOX, -1, s);

			}



			while(1)
			{
				res=LTR_Recv(&module.Channel, ack, NULL,5000, 4000); //  
				ProcessSystemEvents();   

				GetCtrlVal (panel, P_CONFIG_Exp_SW, &SS);


				if(!SS)
					break;

			}  

			/*	//  STOP
			cmd[0]=LTR010CMD_STOP;   //  0x8000
			res=LTR_Send(&module.Channel, cmd, 1, 4000);   */

			LTR34_DACStop(&module);
			; 


		}
		else
		{ 
			//  STOP
			cmd[0]=LTR010CMD_STOP;   //  0x8000
			res=LTR_Send(&module.Channel, cmd, 1, 4000);  

		}


		break;
	}
	return 0;
}

#endif

int CVICALLBACK ChangeChannelGroup (int panel, int control, int event,
									void *callbackData, int eventData1, int eventData2)
{
	switch (event)
	{
	case EVENT_COMMIT:

		getCtrlVals();   
		UpdateConfigControls();


		break;
	}
	return 0;
}

int CVICALLBACK cbf_Live_Sinus (int panel, int control, int event,
								void *callbackData, int eventData1, int eventData2)
{   
	switch (event)
	{
	case EVENT_COMMIT:
		GetCtrlVal(panel, control, &LiveSinus); //    
		UpdateConfigControls();
		
		break;
	}
	return 0;
}
