#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
#include <ansi_c.h>
#include "uts\\instruments\\te01\\te01api.h"
//#include "ltr\\include\\ltravrapi.h"
#include "ltr\\include\\ltrapi.h"
#include "ltr\\include\\ltr41api.h"  
#include <userint.h>  



static int         needOpen= 1;
TLTR41 hltr41;
LPCSTR error_string;

// *****************************************************************************************
void closeModule(void) {
  if(!needOpen) {
     needOpen= 1;
     LTR41_Close(&hltr41);
  };
};


int testPlolog(TCONTEXT *tc);
static int write_serial(TCONTEXT *tc, const char *fname, char *serial);  

//int utspWriteMCU(TCONTEXT *tc, void *p);

int utspLoadADSP(TCONTEXT *tc, void *p) {  
  int r;
  
  closeModule();  // !!! tmp :    p  
  r= testPlolog(tc);
  if(r) MessagePopup(MSG_ERROR,  "Failed initialize ADSP");
  else  MessagePopup(MSG_PROMPT, "ADSP has been initialized successfully with standard BIOS file (!TMP)");
  return r; 
};

 // !!! tmp
int utspInitModule(TCONTEXT *tc, void *p) { 
  /* return utspWriteMCUFlash(tc, p); /*utspLoadADSP*/
  return(0);
  ;;;;;;;;;;;;;;;;;;;;;
};
// *****************************************************************************************
int testPlolog(TCONTEXT *tc) {
 ltrTContext *tclocal= tc->tcontext;
 INT  rs;
 char tmp[FNAMELEN+1];
 
 
 
 
 
     if(!needOpen) return 0;
     if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL);   
     
     rs=LTR41_Init(&hltr41);
     if(rs) {
        //LTR212_Close(&hltr212);
        error_string=LTR41_GetErrorString(rs); 
           if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           return TRES_INIT_FAIL; 
     };  
     
	 
     rs= LTR41_Open(&hltr41, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial,  tclocal->slot);
     if(rs) 
     {
      if(rs==-10)
      {
      error_string=LTR41_GetErrorString(rs); 
           if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
      }
      else
      {
        
        LTR41_Close(&hltr41);
        
     
		   error_string=LTR41_GetErrorString(rs); 
           if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string); 
           return TRES_INIT_FAIL; 
        }
       }	  
        /*if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
        return TRES_INIT_FAIL;
     }; */ 
     
     if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
     needOpen= 0;
     return 0;
};

// *****************************************************************************************

// ****************************************************************************
// ****************************************************************************
//
//
//
// ****************************************************************************
// ****************************************************************************

int utspReadData(TCONTEXT *tc, void *p) { return 0;};
int utspWriteData(TCONTEXT *tc, void *p) { return 0;};
int utspWriteFile(TCONTEXT *tc, void *p) { return 0;};



int utspGetDescrDAC(TCONTEXT *tc, pluginDAC *D, int channel) { 
 return 0;
};

/*
int utspGetDescrDIO(TCONTEXT *tc, pluginDIO *D, int line) { 
 return 0;
}; */

int utspGetDIO(TCONTEXT *tc, void *p) { return 0;};
int utspPutDIO(TCONTEXT *tc, void *p) { return 0;};


// ****************************************************************************
int utspGetModuleInfo(TCONTEXT *tc, void *p) 

{
 needOpen=1;
 if(testPlolog(tc)) return TRES_INIT_FAIL;
     if(tc->cbf) tc->cbf(TFMSG_SERIAL, hltr41.ModuleInfo.Serial);
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
     if(tc->cbf) tc->cbf(TFMSG_VER, hltr41.ModuleInfo.FirmwareVersion);
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");  
 return 0;
};




static int ReadAVR_PM(const char *filename, char **buf)
{
    FILE *f;
    int  size;
    int size_w=0;
	
	
    if ((f = fopen(filename, "r")) == NULL)
    {
        return -1;
    }
	
    /*  :*/
    fseek(f, 0, SEEK_END);              /*   .*/
    size = ftell(f);                    /*  .*/
    fseek(f, 0, SEEK_SET);              /*   .*/
	
    /*   .*/
    *buf = (char *)malloc(size);
    /* .*/
    
    size_w=fread(*buf, 1, size, f);
	if (size_w != size) /*    .*/
	{
        /*    .*/
        
        free(*buf);
        fclose(f);
        /* .*/
        return -2;  
    }
	
    fclose(f);
    return size;
}



static int WriteAVR_PM(const char *filename, char *buf, int size)
 {
    FILE *f;
    //int  size;
    int size_w;
 
    if ((f = fopen(filename, "r+b")) == NULL)
    {
        return -1;
    }
 
    rewind(f);
    

    
    
    size_w=fwrite(buf, 1, size, f);  
    
    fclose(f);
    return size;
    
    
  return 0;
 
 }





int WriteMCUFlash(TCONTEXT *tc, void *p)
 {
 
 burnMcuContext *BurnContext = p;
 write_serial(tc, BurnContext->fname, BurnContext->serial); 
 

 utspDefaultWriteMCUFlash(tc, p);
 
 
 /*return*/ utspGetModuleInfo(tc, NULL);      
 
 return (0);
 }


static WORD CRC_Calc_UTS(BYTE *b, WORD N)
/*  .
:
  b --  .
  N --  .
:
    .
*/
{
	WORD crc= 0;
	int i, j;

	for(i=0; i<N; i++) {
		crc ^= b[i] << 8;
		for(j=0;j<8;j++) {
			if(crc&0x8000) crc = (crc<<1) ^ 0x1021;
			else crc <<= 1;
		}
	}
	return crc;
}


static int write_serial(TCONTEXT *tc, const char *fname, char *serial)
{
    #define CONFIG_DATA_SIZE (42)
    char *buf;
    int  crc;
    int  i;
    char *pbuf;
    int  size;
    int  wnd_size;
    int kot;
    
    //kot=sizeof(*serial);

	
    if ((size = ReadAVR_PM(fname, &buf)) <= 0)
        return size;

    memcpy(buf + 0x99, serial, 17/ sizeof(serial[0]));
    
    
	crc       = CRC_Calc_UTS((BYTE *)buf + 0x80, CONFIG_DATA_SIZE);
	buf[0xAB] = (crc >> 8) & 0xFF;
	buf[0xAA] = crc & 0xFF;	   
    
    
    
    
    WriteAVR_PM(fname, buf, size);   
    
    
    
   
    
	
	free(buf);
	
	return 0;
}

// ****************************************************************************
/*int utspWriteMCUFlash(TCONTEXT *tc, void *p) 
{ 
  if(testPlolog(tc)) return TRES_INIT_FAIL; 
  return utspGetModuleInfo(tc, NULL);
}; */

/*
int utspReadMCUFuses(TCONTEXT *tc, void *p)  
{ 
return(0);
}  */

/*
int utspReadMCUFuses(TCONTEXT *tc, void *p)
{ 
    burnMcuContext *pbc = p;
    int            res = TRES_T_OK;
    ltrTContext    *tclocal = tc->tcontext;
    
    
    if (!needOpen)
        LTR41_Close(&hltr41);
    needOpen = 1;

    hltr41.size = sizeof (hltr41);
    LTR41_Init(&hltr41);
    if (LTR41_Open(&hltr41, tclocal->serverAddr, tclocal->crateSerial, tclocal->slot) == LTR_OK)
    {
        needOpen = 0;

        if (LTRAVR_ReadFuseBits(&hltr41.channel, (BYTE*)&pbc->fuses, TRUE) != LTR_OK)
            res = TRES_T_FAIL;

        LTR41_Close(&hltr41);
        needOpen = 1;
    }
    else
    {
        res = TRES_INIT_FAIL;
    }
    return res;
}
  */
 /*
int utspWriteMCUFuses(TCONTEXT *tc, void *p)  
{ 
return(0);
}  */

// ****************************************************************************
// ****************************************************************************
// ****************************************************************************
// ****************************************************************************
// ****************************************************************************
int testSNR(TCONTEXT *tc) {
 return TRES_ABORT;
};
