#ifndef _LTR_STAND__DFLTMSG__H_
#define _LTR_STAND__DFLTMSG__H_

#define MSG_ERROR    "UTS: ERROR"
#define MSG_WARNING  "UTS: WARNING"
#define MSG_PROMPT   "UTS: Information"

#define FNAMELEN     8192
#define COMMENTLEN   255
// #define MAXFNAMELEN (MAX_PATHNAME_LEN + MAX_DRIVENAME_LEN + MAX_DIRNAME_LEN + MAX_FILENAME_LEN + 1)


// --------------------------------------------------
// MID: Message ID
// C - Core
// E - Entry
// R - Run-All mode
#define MIDCER__MASK        (0x7 << 29L)
#define MIDCET__MASK        MIDCER__MASK

#define MIDCER_BEGIN        (0 << 29L)  
#define MIDCER_END          (1 << 29L)
#define MIDCER_ABORT        (2 << 29L)  // checked before calling t.f
#define MIDCER_STOP_ABORT   (3 << 29L)  // aborted in t.f
#define MIDCER_STOP_ERROR   (4 << 29L)  // stopped on error
// E - Entry, T - test 
#define MIDCET_BEGIN        (0 << 29L)
#define MIDCET_END			(1 << 29L)
#define MIDCET_NOTNEED      (2 << 29L)
#define MIDCET_LATER        (3 << 29L)


// T_ - type
#define MIDCT__MASK        (0xF << 25L)
#define MIDCT_LOG          (0 << 25L)  // general info
#define MIDCT_DATE		   (1 << 25L)  // date and time
#define MIDCT_OPER		   (2 << 25L)  // operator name
#define MIDCT_MDESCR	   (3 << 25L)  // module description
#define MIDCT_PDESCR	   (4 << 25L)  // plugin description
#define MIDCT_REFS		   (5 << 25L)  // all tests info for refs
#define MIDCT_EALL		   (6 << 25L)  // entry : run all test
#define MIDCT_ERTEST	   (7 << 25L)  // entry : run test in run-all mode
#define MIDCT_ESTEST       (8 << 25L)  // entry : run test in single test
#define MIDCT_STATISTIC	   (9 << 25L)  // 
#define MIDCT_SUMMARY	   (10 << 25L)  //
#define MIDCT_MNAME	       (11 << 25L)  // module name
#define MIDCT_SNAME	       (12 << 25L)  // system name


// SRC - source of msg
#define MIDCSRC__MASK      (0x1 << 24L)
#define MIDCSRC_TFUNC      (0 << 24L)
#define MIDCSRC_CORE	   (1 << 24L)

// F - function	   :  bit mask fields !!!
#define MIDCF_BIT_MANUAL   (1 << 20L)
#define MIDCF_BIT_PASSPORT (1 << 21L)
#define MIDCF_BIT_USE      (1 << 22L)
#define MIDCF_BIT_RSV      (1 << 23L)

#define TRES_T_OK             0
#define TRES_T_FAIL           1
#define TRES_T_RSV			  2
#define TRES_HW_FAIL		  3
#define TRES_TE01_FAIL		  4
#define TRES_TE01EX_FAIL	  5
#define TRES_KEITHLEY_FAIL	  6
#define TRES_ABORT   		  7
#define TRES_INIT_FAIL		  8
#define TRES_RSV			  9

// R - result
#define MIDCR__MASK          (0xF << 16L)
#define MIDCR_T_OK   		 (TRES_T_OK << 16L)         
#define MIDCR_T_FAIL   		 (TRES_T_FAIL << 16L)       
#define MIDCR_T_RSV   		 (TRES_T_RSV << 16L)		
#define MIDCR_HW_FAIL 		 (TRES_HW_FAIL << 16L)	
#define MIDCR_TE01_FAIL 	 (TRES_TE01_FAIL << 16L)	
#define MIDCR_TE01EX_FAIL 	 (TRES_TE01EX_FAIL << 16L)
#define MIDCR_KEITHLEY_FAIL  (TRES_KEITHLEY_FAIL << 16L)
#define MIDCR_ABORT          (TRES_ABORT << 16L)	
#define MIDCR_INIT_FAIL   	 (TRES_INIT_FAIL << 16L)	
#define MIDCR_RSV   		 (TRES_RSV << 16L)

// F - function
// D - destination
#define MIDFD__MASK      (0xF << 16L)

#define MIDFD_LOG        (0 << 16L)
#define MIDFD_CORE		 (1 << 16L)
#define MIDFD_R	         (2 << 16L)
#define MIDFD_P          (3 << 16L)
#define MIDFD_RP		 (4 << 16L)  // report + passport
#define MIDFD_SPEC	     (5 << 16L)  // special for passport/report

// C - core dest.
// S - special dest. for passport/report
#define MIDFC__MASK        (0xFF << 8L)
#define MIDFS__MASK        MIDFC__MASK

// C - core
#define MIDFC_PROGRESS     (0 << 8L)
#define MIDFC_DEBUG        (1 << 8L)
#define MIDFC_ISTART       (2 << 8L)
#define MIDFC_IEND	       (3 << 8L)

// S - special info for Passport/Report/Log
#define MIDFS_NONE       (0 << 8L)
#define MIDFS_SERIAL     (1 << 8L)
#define MIDFS_VERSION	 (2 << 8L)
#define MIDFS_IMODULE    (3 << 8L)
#define MIDFS_ICALIBR	 (4 << 8L)

// L - lines start/next/end, single for special passport info
#define MIDFSL_SINGLE    0
#define MIDFSL_BEGIN     1
#define MIDFSL_NEXT		 2
#define MIDFSL_END       3

// --------------------------------------------------------------------------------
#define TFMSG_PROGRESS(x)   ( MIDFD_CORE | MIDFC_PROGRESS | (((int)(x))&0xFF))

#define TFMSG_INIT_START    ( MIDFD_CORE | MIDFC_ISTART )
#define TFMSG_INIT_END      ( MIDFD_CORE | MIDFC_IEND )

#define TFMSG_LOG           0
#define TFMSG_DEBUG         ( MIDFD_CORE | MIDFC_DEBUG )
#define TFMSG_PASSPORT      MIDFD_P
#define TFMSG_REPORT        MIDFD_R
#define TFMSG_RP            MIDFD_RP

#define TFMSG_IBLANK        ( MIDFD_SPEC | MIDFS_NONE | MIDFSL_SINGLE )

#define TFMSG_SERIAL		( MIDFD_SPEC | MIDFS_SERIAL | MIDFSL_SINGLE )
#define TFMSG_VER			( MIDFD_SPEC | MIDFS_VERSION | MIDFSL_SINGLE )
#define TFMSG_IMODULE		( MIDFD_SPEC | MIDFS_IMODULE | MIDFSL_SINGLE )
#define TFMSG_ICALIBR		( MIDFD_SPEC | MIDFS_ICALIBR | MIDFSL_SINGLE )

#define TFMSG_BEGIN_SERIAL   ( MIDFD_SPEC | MIDFS_SERIAL | MIDFSL_BEGIN )
#define TFMSG_NEXT_SERIAL    ( MIDFD_SPEC | MIDFS_SERIAL | MIDFSL_NEXT )
#define TFMSG_END_SERIAL     ( MIDFD_SPEC | MIDFS_SERIAL | MIDFSL_END )

#define TFMSG_BEGIN_VER		( MIDFD_SPEC | MIDFS_VERSION | MIDFSL_BEGIN ) 
#define TFMSG_NEXT_VER		( MIDFD_SPEC | MIDFS_VERSION | MIDFSL_NEXT )  
#define TFMSG_END_VER		( MIDFD_SPEC | MIDFS_VERSION | MIDFSL_END )   

#define TFMSG_BEGIN_IMODULE  ( MIDFD_SPEC | MIDFS_IMODULE | MIDFSL_BEGIN ) 
#define TFMSG_NEXT_IMODULE   ( MIDFD_SPEC | MIDFS_IMODULE | MIDFSL_NEXT )  
#define TFMSG_END_IMODULE	( MIDFD_SPEC | MIDFS_IMODULE | MIDFSL_END )   

#define TFMSG_BEGIN_ICALIBR  ( MIDFD_SPEC | MIDFS_ICALIBR | MIDFSL_BEGIN ) 
#define TFMSG_NEXT_ICALIBR   ( MIDFD_SPEC | MIDFS_ICALIBR | MIDFSL_NEXT )  
#define TFMSG_END_ICALIBR	( MIDFD_SPEC | MIDFS_ICALIBR | MIDFSL_END )   


// ----------------------------------------------------------------------------------

#define THISPC_IP_ADDR  ( (127 << 24) | (0 << 16) | (0 << 8) | (1 << 0) )

#pragma pack(1)
typedef struct {
  char fname[FNAMELEN+1];
  char serial[COMMENTLEN + 1];
} burnMcuContext;

#pragma pack()


// --------------------------------------------------------------------------
#define UTS_CHTYPE__MASK (0xF << 12U)
#define UTS_CHTYPE_NONE  (0<<12U)
#define UTS_CHTYPE_ADC   (1<<12U)
#define UTS_CHTYPE_DAC   (2<<12U)
#define UTS_CHTYPE_DIO   (3<<12U)
#define UTS_CHTYPE_SPEC  (4<<12U)

#define UTS_CHMODE_SYNC  (1<<4U)
#define UTS_CHMODE_ASYNC (1<<5U)
#define UTS_CHMODE_SLOW  (1<<8U)
#define UTS_CHMODE_FAST  (1<<9U)

#define UTS_CHDIR_INP    (1<<0U)
#define UTS_CHDIR_OUT    (1<<1U)

#define UTSADC_FAST_SYNC  (UTS_CHTYPE_ADC | UTS_CHMODE_SYNC  | UTS_CHMODE_FAST | UTS_CHDIR_INP)
#define UTSADC_SLOW_ASYNC (UTS_CHTYPE_ADC | UTS_CHMODE_ASYNC | UTS_CHMODE_SLOW | UTS_CHDIR_INP)
#define UTSADC_SLOW_SYNC  (UTS_CHTYPE_ADC | UTS_CHMODE_SYNC  | UTS_CHMODE_SLOW | UTS_CHDIR_INP)
#define UTSADC (UTS_CHTYPE_ADC | UTS_CHMODE_SYNC | UTS_CHMODE_ASYNC | UTS_CHMODE_SLOW | UTS_CHMODE_FAST | UTS_CHDIR_INP)

// ------------------------------------------------------------
#define UTS_DATAMODE_DOUBLE 0   // double *
#define UTS_DATAMODE_CODE   1   // int32 *
#define UTS_DATAMODE_MIXED  2   //  both, in-turn:  

#endif


