/**************************************************************************/
/* LabWindows/CVI User Interface Resource (UIR) Include File              */
/* Copyright (c) National Instruments 2007. All Rights Reserved.          */
/*                                                                        */
/* WARNING: Do not add to, delete from, or otherwise modify the contents  */
/*          of this include file.                                         */
/**************************************************************************/

#include <userint.h>

#ifdef __cplusplus
    extern "C" {
#endif

     /* Panels and Controls: */

#define  CONF                            1       /* callback function: Close */
#define  CONF_Exit_BTN                   2       /* callback function: Exit_CLB */
#define  CONF_Channels_LST               3       /* callback function: ClickChannel_CLB */
#define  CONF_Fs_NUM                     4       /* callback function: FsChange_CLB */
#define  CONF_Base_NUM                   5       /* callback function: BaseChange_CLB */
#define  CONF_EdgeMode_RNG               6       /* callback function: ChangeEdgeMode_CLB */
#define  CONF_FreqBase_NUM               7
#define  CONF_LowThreshold_NUM           8       /* callback function: SetLowThreshold */
#define  CONF_HighThreshold_NUM          9       /* callback function: SetHighThreshold */
#define  CONF_Setings_TXT                10
#define  CONF_DECORATION                 11
#define  CONF_Work_BTN                   12      /* callback function: Work_CLB */
#define  CONF_TEXTMSG                    13
#define  CONF_DECORATION_2               14
#define  CONF_ThresholdRange_SW          15
#define  CONF_ChanInfo_TBX               16
#define  CONF_PointsQnt_NUM              17      /* callback function: SetPointsQnt_CLB */
#define  CONF_AcqTime_NUM                18      /* callback function: SetAcqTime_NUM */
#define  CONF_DECORATION_3               19
#define  CONF_Serial_STR                 20
#define  CONF_AllChannels_CHK            21

#define  WAIT                            2
#define  WAIT_TEXTMSG                    2

#define  WORK                            3       /* callback function: CloseW */
#define  WORK_Start_BTN                  2       /* callback function: Start_CLB */
#define  WORK_Stop_BTN                   3       /* callback function: Stop_CLB */
#define  WORK_Freq_NUM                   4
#define  WORK_ExitWork_BTN               5       /* callback function: ExitWork_CLB */
#define  WORK_FreqS_NUM                  6
#define  WORK_Tw_NUM                     7
#define  WORK_Tps_NUM                    8
#define  WORK_FreqBase_NUM               9
#define  WORK_Process_LED                10
#define  WORK_CorrectLowThr_NUM          11
#define  WORK_CorrectHighThr_NUM         12
#define  WORK_Channel_NUM                13
#define  WORK_TEXTMSG                    14
#define  WORK_TEXTMSG_2                  15
#define  WORK_TEXTMSG_4                  16
#define  WORK_TEXTMSG_3                  17
#define  WORK_Period_NUM                 18
#define  WORK_DECORATION_2               19
#define  WORK_DECORATION                 20
#define  WORK_FreqUnit_RNG               21
#define  WORK_PeriodUnit_RNG             22
#define  WORK_PeriodPrecision_NUM        23      /* callback function: ChangePeriodPrecision_CLB */
#define  WORK_FreqPrecision_NUM          24      /* callback function: ChangeFreqPrecision_CLB */
#define  WORK_TEXTMSG_5                  25


     /* Menu Bars, Menus, and Menu Items: */

          /* (no menu bars in the resource file) */


     /* Callback Prototypes: */ 

int  CVICALLBACK BaseChange_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeEdgeMode_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangeFreqPrecision_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ChangePeriodPrecision_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ClickChannel_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Close(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK CloseW(int panel, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Exit_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK ExitWork_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK FsChange_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetAcqTime_NUM(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetHighThreshold(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetLowThreshold(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK SetPointsQnt_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Start_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Stop_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);
int  CVICALLBACK Work_CLB(int panel, int control, int event, void *callbackData, int eventData1, int eventData2);


#ifdef __cplusplus
    }
#endif
