#include "uts\\systems\\common\\include\\tfuncdef.h"
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "uts\\systems\\common\\include\\utspfunc.h"
//#include "uts\\systems\\ltr\\ltr51\\localdefs.h"  
#include <ansi_c.h>

//#include "ltr\\include\\ltravrapi.h"
#include "ltr\\include\\ltrapi.h"
#include "ltr\\include\\ltr51api.h"  
#include "uts\\instruments\\te01\\te01api.h" 
#include "uts\\instruments\\te01\\te01func.h"   
#include <userint.h>  

#define FDAC_FREQ (100.0)
#define THRESHOLD_RANGE_1 (2.438)
#define HIGH_THRESHOLD_MAX_1 (1.224) 
#define LOW_THRESHOLD_MAX_1 (-1.214) 
#define HIGH_THRESHOLD_MAX_0 (10.19) 
#define LOW_THRESHOLD_MAX_0 (-10.11) 
#define THRESHOLD_RANGE_0 (20.30)

#ifndef MAX_CHANNEL
 #define MAX_CHANNEL (16) 
#endif 

 #define DETECTOR_CORRECT (105) //  ,    .      

/*#define FDAC_Fs        (2000000)
#define FDAC_RAM_SIZE  (20000) 
#define FDAC_MAX_CODE  (0xFFFF)
#define PI (3.14159265358979323846)		 */



LPCSTR error_string;
static int         needOpen= 1;
int StopFlag=0;
int NeedEvalCriticalThr=0;



TLTR51 hltr51;

char info_mes[255]; 
char error_mes[255];

LPCSTR msg;
int test_err=TRES_T_OK;

   


typedef struct
		  {
		   TCONTEXT *tc;
		   double HighThresholdDef;
		   double LowThresholdDef;
		   double Umax;
		   double Umin;
		   double HighCriticalThreshold[16];
		   double LowCriticalThreshold[16];
		   double frequency[16];
		   double HighThresholdHighLimit;
		   double HighThresholdLowLimit;
		   double LowThresholdHighLimit;
		   double LowThresholdLowLimit;
		   double step;
		   int Base;
		   int AcqTime;
		   double EtalFreq;
		   double MesFreq;
		   int range;
		   int ShortCircuitFlag;
		   
		   double BeginPercentage;
		   double MediumPercentage;
		   double EndPercentage;
		   int Error;
		   
		  } ThrDefPars;
		  
//ThrDefPars Pars;		  

int testPlolog(TCONTEXT *tc); 
double eval_delta(double N, double M1, double Mk, double tau, int size);  

int CriticalThresholdDef(ThrDefPars *Pars);
int CriticalThresholdDef_Ex(ThrDefPars *Pars);     
int CriticalThresholdDef_Ex2(ThrDefPars *Pars);
//void CriticalThresholdDef_Ex3();

void EmptyStr(TCONTEXT *tc);   
int EvenChannelCheck(TCONTEXT *tc, double *frequency);  
int OddChannelCheck(TCONTEXT *tc, double *frequency);  

void CreateSinImage(WORD *image, int FDAC_MaxCode, int FDAC_MinCode); 

// *****************************************************************************************
void closeModule(void) {
  if(!needOpen) {
     needOpen= 1;
     LTR51_Close(&hltr51);
  }
}

static int write_serial(TCONTEXT *tc, const char *fname, char *serial);  

//int utspWriteMCU(TCONTEXT *tc, void *p);

int utspLoadADSP(TCONTEXT *tc, void *p) {  
  int r;
  
  closeModule();  // !!! tmp :    p  
  r= testPlolog(tc);
  if(r) MessagePopup(MSG_ERROR,  "Failed initialize ADSP");
  else  MessagePopup(MSG_PROMPT, "ADSP has been initialized successfully with standard BIOS file (!TMP)");
  return r; 
};

 // !!! tmp
int utspInitModule(TCONTEXT *tc, void *p) { 
  /* return utspWriteMCUFlash(tc, p); /*utspLoadADSP*/
  return(0);

};


/*******************************************************************************************

        
    
********************************************************************************************/    

int testPlolog(TCONTEXT *tc) 
 {
  ltrTContext *tclocal= tc->tcontext;
  INT  rs;
  
  
  char tmp[FNAMELEN+1];
  
   if(!needOpen) return 0;
   if(tc->cbf) tc->cbf(TFMSG_INIT_START, NULL);   
   
   
   if(!LTR51_IsOpened(&hltr51))
      LTR51_Close(&hltr51);  
   
   rs=LTR51_Init(&hltr51);
 
   
   if(rs!=0) 
    {
      error_string=LTR51_GetErrorString(rs);
      LTR51_Close(&hltr51);
      if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);  
      if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);
        
        return TRES_INIT_FAIL;
     }  
     
     
	 strcpy(tmp, tc->dllpath);
	 strcat(tmp, "\\ltr51.ttf"); 
	 
	 
	 LTR51_Close(&hltr51); 
	 
     rs=LTR51_Open(&hltr51, tclocal->serverAddr, tclocal->serverPort, tclocal->crateSerial,  tclocal->slot, tmp); 

    if(rs)
     {
       error_string=LTR51_GetErrorString(rs);   
       LTR51_Close(&hltr51);
       if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL); 
       
       if(tc->cbf!=NULL) tc->cbf(MIDCER_STOP_ERROR, (char*)error_string);  
       return TRES_INIT_FAIL;
     };  
     
     
     if(tc->cbf) tc->cbf(TFMSG_INIT_END, NULL);   
     needOpen= 0;
     return 0;
};

// ****************************************************************************
int utspGetModuleInfo(TCONTEXT *tc, void *p) 

{
 needOpen=1;
 if(testPlolog(tc)) return TRES_INIT_FAIL;
     if(tc->cbf) tc->cbf(TFMSG_SERIAL, hltr51.ModuleInfo.Serial);
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, ".  AVR");
     if(tc->cbf) tc->cbf(TFMSG_VER, hltr51.ModuleInfo.FirmwareVersion);
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, "");    
     if(tc->cbf) tc->cbf(TFMSG_IBLANK, " ");  
     if(tc->cbf) tc->cbf(TFMSG_VER, hltr51.ModuleInfo.FPGA_Version); 
 return 0;
};

static int ReadAVR_PM(const char *filename, char **buf)
{
    FILE *f;
    int  size;
    int size_w=0;
	
	
    if ((f = fopen(filename, "r")) == NULL)
    {
        return -1;
    }
	
    /*  :*/
    fseek(f, 0, SEEK_END);              /*   .*/
    size = ftell(f);                    /*  .*/
    fseek(f, 0, SEEK_SET);              /*   .*/
	
    /*   .*/
    *buf = (char *)malloc(size);
    /* .*/
    
    size_w=fread(*buf, 1, size, f);
	if (size_w != size) /*    .*/
	{
        /*    .*/
        
        free(*buf);
        fclose(f);
        /* .*/
        return -2;  
    }
	
    fclose(f);
    return size;
}


static int WriteAVR_PM(const char *filename, char *buf, int size)
 {
    FILE *f;
    //int  size;
    int size_w;
 
    if ((f = fopen(filename, "r+b")) == NULL)
    {
        return -1;
    }
 
    rewind(f);
   
    size_w=fwrite(buf, 1, size, f);  
    
    fclose(f);
    return size;
 }

int WriteMCUFlash(TCONTEXT *tc, void *p)
 {
 
 burnMcuContext *BurnContext = p;
 write_serial(tc, BurnContext->fname, BurnContext->serial); 
 

 utspDefaultWriteMCUFlash(tc, p);
 
 //return (0);
 return utspGetModuleInfo(tc, NULL);              
 
 }


static WORD CRC_Calc_UTS(BYTE *b, WORD N)
/*  .
:
  b --  .
  N --  .
:
    .
*/
{
	WORD crc= 0;
	int i, j;

	for(i=0; i<N; i++) {
		crc ^= b[i] << 8;
		for(j=0;j<8;j++) {
			if(crc&0x8000) crc = (crc<<1) ^ 0x1021;
			else crc <<= 1;
		}
	}
	return crc;
}


static int write_serial(TCONTEXT *tc, const char *fname, char *serial)
{
  #define  CONFIG_DATA_SIZE (42)
  
    char *buf;
    int  crc;
    int  size;
	
    if ((size = ReadAVR_PM(fname, &buf)) <= 0)
        return size;

    memcpy(buf + 0x99, serial, 17/ sizeof(serial[0]));
    
    
    
    crc=0;
    
	crc       = CRC_Calc_UTS((BYTE *)buf + 0x80, CONFIG_DATA_SIZE);
	buf[0xAB] = (crc >> 8) & 0xFF;
	buf[0xAA] = crc & 0xFF;	   
    
    
  
    
    WriteAVR_PM(fname, buf, size);   
    
   
	
	free(buf);
	
	return 0;
}


/****************************************************************************************

        +/-1.2 
   
****************************************************************************************/  

int ThresholdVerify1(TCONTEXT *tc) 
{
  #define FREQ_ERR_MAX (1E-2)

  TE01 *te01;
  int i, j;
  int size;
  int periods;
  double HighThreshold, LowThreshold;
  double HighThresholdMax, LowThresholdMax;
  double CriticalThreshold[16];
  double threshold_error[16];
  int FreqErrorFlag=0;
  int cnt=0;
  double freq;
  double voltage, voltage_fact;
  double frequency[16];
  double freq_error[16];
  int ThresholdAchieve[16];
  double K, B; 
  int PhysChannel;
  //HANDLE hThread;
  //DWORD TmpDWord;
  DWORD data_size;
  
  ThrDefPars Pars;
  DWORD rd_buf[32*100];
 
  
  int err; 

  memset(ThresholdAchieve,0,MAX_CHANNEL*sizeof(int));
  memset(CriticalThreshold,0,MAX_CHANNEL*sizeof(double));   

  
	  //     
	 needOpen=1;
  	if(testPlolog(tc))
		return TRES_INIT_FAIL;
		
		
	MessagePopup ("!", " X3, X4      ,     +/-1,2 !");  	
	
   hltr51.SetUserPars=1;
   hltr51.LChQnt=16;           //        
   hltr51.Fs=500000;           //   .   
   hltr51.Base=10000;          // ,   
  
  
  te01 = (TE01 *)tc->te01; 
  
  //  . -  EEPROM
  
  err=TE01ReadCoeffFromEEPROM(te01); 
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  	 
   
  
  K = te01->Kf1[2]; 	//  - 01
  B = te01->Bf1[2];
  
  
  freq=100;
  voltage=1000*K+B;  //  .      . 
  size=20000;
  periods=1;  
  

   //   100 

   strcpy(info_mes, "  01.   100 ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
     
  err=FDAC_set_image(te01, size, periods);
  
 if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  
  
 te01->uadc_range=1;
 te01->cflags|=UADC_DATA_CORRECTION;
 
 TE01SetUADCConfiguration(te01, 0, 1, 19000);      
  
  
  err=TE01SetFDACConfiguration(te01, size, 1, 1, 2, 0, /*-*/voltage, (0*K+B), 1);
  if(err)  
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  	 
    //       0.   -       
 SetSDAC_Value(te01, 0, 0);
  
  
 //TE01SetConfiguration(te01, FORCE_UPDATE_RAM|FORCE_UPDATE_FDAC);      
  
  
 err=TE01UMeasurement(te01, &voltage, 8, 1000.0, NULL);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  	 
  voltage_fact=(TE01UModuleValue(te01, voltage, 1)+DETECTOR_CORRECT)/1000;  
  
EmptyStr(tc);  
 sprintf(info_mes, "   : %.3f ", voltage_fact);
	 if(tc->cbf) 
		if(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		 
  
  
  
 //  ,         
 
 strcpy(info_mes, "    ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
 
 LowThreshold=0.3;
 HighThreshold=0.7;		
		

//       	

 j=0;
 for(i=0;i<MAX_CHANNEL;i++)
 {
   if((hltr51.ChannelsEna>>i)&0x1)
   {
   hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, 1, 0);  
   j++;
   }
 }
 
 hltr51.LChQnt=j;   
 hltr51.Base=20000;
 hltr51.AcqTime=4000;

 //   
 
 err=LTR51_Config(&hltr51);
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) msg));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }


 //   
 err=LTR51_Start(&hltr51);
 
 if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) msg));
	     test_err=TRES_HW_FAIL; 
	     return (test_err);
  	}
  
  cnt= LTR_Recv(&hltr51.Channel, rd_buf, NULL, 32*hltr51.TbaseQnt, 10000); 
  
  if(cnt==0)
  {
   sprintf(info_mes, "    !"); 
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     return (test_err);
  }	     
 
 
 if(cnt!=32*hltr51.TbaseQnt)
  {
   sprintf(info_mes, "  ,  !"); 
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     return (test_err);
  }	     
 
  data_size=32*hltr51.TbaseQnt;
  
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, &data_size); 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     return (test_err);
  	}
  
 err=LTR51_Stop(&hltr51);
 if(err)  
  {
     msg=LTR51_GetErrorString(err);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) msg));
	     test_err=TRES_HW_FAIL; 
	     return (test_err);
  	}
 
 
 
 EmptyStr(tc);
 sprintf(info_mes, "        100   .  :");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
		
 for(i=0;i<hltr51.LChQnt;i++)
  {
   freq_error[i]=100*(FDAC_FREQ-frequency[i])/FDAC_FREQ; 
   PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
   
   sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, freq_error[i]);
	if(tc->cbf) 
	 (tc->cbf(TFMSG_REPORT, (char *) info_mes));
  } 
  
  EmptyStr(tc);  
  sprintf(info_mes, "  :");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));  
		
		
  for(i=0;i<hltr51.LChQnt;i++)
  {
   PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
   
   if(frequency[i]==0.0)
    {
     sprintf(info_mes, "  %d       ", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
     sprintf(info_mes, "       ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
	EmptyStr(tc); 	
		
	 FreqErrorFlag=1;
	 }
    
   else
   
   if(freq_error[i]>FREQ_ERR_MAX)
    {
     sprintf(info_mes, "    %d     %.3f:",PhysChannel, freq_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
		
	 FreqErrorFlag=1;
     }
   
   }																				   


 if(!FreqErrorFlag)
  {
   sprintf(info_mes, "    ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
   }
  else
  {
   EmptyStr(tc);
   sprintf(info_mes, "   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
   return TRES_HW_FAIL;  
   }
  
  
  
 
   /********     ****************/
 
 //    ( )     
 Pars.Error=0;
 Pars.tc=tc;
 Pars.HighThresholdDef=HighThreshold;
 Pars.LowThresholdDef=LowThreshold;
 Pars.HighThresholdHighLimit=HIGH_THRESHOLD_MAX_1;
 Pars.HighThresholdLowLimit=0.7;//0.8;//0.9;//0.8; 
 Pars.LowThresholdHighLimit=0.1;//0.1;//0.2;
 Pars.LowThresholdLowLimit=LOW_THRESHOLD_MAX_1;  
 
 
 Pars.Umax=voltage_fact;//1.0;  // .  ()   
 Pars.Umin=0.0;  // .     
 Pars.step=0.01; //   
 Pars.range=1;
 Pars.ShortCircuitFlag=0; // , ,      
 Pars.EtalFreq=100.0; 
 Pars.MesFreq=100.0;   
 Pars.Base=1000;//1000;
 Pars.AcqTime=200;
 
 Pars.BeginPercentage=0.0;
 Pars.MediumPercentage=50.0;
 Pars.EndPercentage=100.0;
 
 HighThresholdMax=HIGH_THRESHOLD_MAX_1; 
 LowThresholdMax=LOW_THRESHOLD_MAX_1;  
 
  /*
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)CriticalThresholdDef_Ex3, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);
  ResumeThread(hThread); 
  
  
  
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);  */
  
 
 
  /******       ******/
  err=CriticalThresholdDef_Ex2(&Pars);
  
  //CriticalThresholdDef_Ex3();   
 
  //err=Pars.Error;
  if(err)
   {
	
	test_err=err;
	goto exit;
   }
   
   
   test_err=TRES_T_OK;   
   
   EmptyStr(tc);   
   sprintf(info_mes, ":");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
	
   sprintf(info_mes, " :");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));			
		
   	
   for(i=0;i<hltr51.LChQnt;i++)
   {
   
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;   
    threshold_error[i]=100.0*((Pars.HighCriticalThreshold[i])-(Pars.Umax))/(HighThresholdMax-LowThresholdMax);
	
	sprintf(info_mes, " %d.     : %.3f%%", PhysChannel,threshold_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		

	 if(fabs(threshold_error[i])>2.0)  //    
	  {
	   sprintf(info_mes, "!      %d    2%%!", PhysChannel);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		  
	   //EmptyStr(tc);  
	   sprintf(info_mes, "     %d  %f ", PhysChannel,Pars.HighCriticalThreshold[i]);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));  
	  	  
		EmptyStr(tc);  
		  
	   test_err=TRES_T_FAIL;
	   }
	  } //  for(..) 
 
   
  EmptyStr(tc);
  sprintf(info_mes, " :");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		
  
 
 //   
 for(i=0;i<hltr51.LChQnt;i++)
   {
   
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;   
	threshold_error[i]=100.0*(Pars.LowCriticalThreshold[i]-Pars.Umin)/(HighThresholdMax-LowThresholdMax);
	
	 sprintf(info_mes, " %d.     : %.3f%%", PhysChannel,threshold_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		

	 if(fabs(threshold_error[i])>2.0)  //    
	  {
	   
	   sprintf(info_mes, "!      %d   !", PhysChannel);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		  
	   sprintf(info_mes, "     %d  %f ", PhysChannel,Pars.LowCriticalThreshold[i]);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));  
	  	  
		EmptyStr(tc);  
       		  
	   test_err=TRES_T_FAIL;
	   }
	  }  
   
 exit:  
 EmptyStr(tc);  
 
 return (test_err);
 
};

void CreateSinImage(WORD *image, int FDAC_MaxCode, int FDAC_MinCode)
{
 /*int i;
 //double period = FDAC_RAM_SIZE;
	for (i=0;i<FDAC_RAM_SIZE;++i) 
	image[i] = (WORD)((FDAC_MaxCode-FDAC_MinCode)*sin(2*PI*i)/2+(FDAC_MaxCode+FDAC_MinCode)/2);  */
}

double eval_delta(double N, double M1, double Mk, double tau, int size)
{
 double delta;
 
 delta=(M1-Mk+hltr51.Base*(size-1))*tau;
 return(delta);

}


/****************************************************************************************

        +/-10 
   
****************************************************************************************/   


int ThresholdVerify2(TCONTEXT *tc)
{

TE01 *te01; 
double K,B,Ks,Bs;
double freq;
double voltage_max, voltage_min; 
int size;
int periods;
double HighThresholdMax, LowThresholdMax;
double threshold_error[16];
double voltage, voltage_fact, t_voltage;
int i;
int err=TRES_T_OK;
int PhysChannel;
//HANDLE hThread;
//DWORD TmpDWord;
ThrDefPars Pars;    


 MessagePopup ("!", "  LTR51   ,       X3, X4           !");     


		
		
  // hltr51.LChQnt=16;       //        
 //  hltr51.Fs=500000;           //   .   
 //  hltr51.Base=10000;      // ,   
 //  hltr51.AcqTime=4000;	   //   - 4
  
   //double Fref;			   //  :    
   //double Fbase;		   //  :   
 
 
 
 



		
  te01 = (TE01 *)tc->te01; 
  
  //  . -  EEPROM
  
  err=TE01ReadCoeffFromEEPROM(te01); 
  
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  
  
  K =te01->Kf1[0]; 	//  - 01
  B =te01->Bf1[0];
  Ks=te01->Ks1[0];
  Bs=te01->Bs1[0];
  
  //te01->cflags|=FDAC_DATA_CORRECTION;
  
  freq=100;
  voltage_max=9400*K+B;
  voltage_min=(-9400)*K+B;
  
  size=20000;
  periods=1;
  
   //   100 
  /*********      . -!!! **********/
  
   strcpy(info_mes, "  01.   100 ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
  //      100    
  err=FDAC_set_image(te01, size, periods);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
   
 te01->uadc_range=0;
 te01->cflags|=UADC_DATA_CORRECTION;
 //te01->cflags|=SDAC_DATA_CORRECTION; 
 
 TE01SetUADCConfiguration(te01, 0, 1, 19000);      
   
   
  //   
  err=TE01SetFDACConfiguration(te01, size, 1, 1, 0, 0, voltage_max, voltage_min, 1);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  
   //      0.
  SetSDAC_Value(te01, 0, 0);
  
 err=TE01UMeasurement(te01, &voltage, 8, 1000.0, NULL);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  	 
  t_voltage=TE01UModuleValue(te01, voltage, 1);	 
  voltage_fact=(t_voltage+DETECTOR_CORRECT)/1000; 
  
EmptyStr(tc);  
 sprintf(info_mes, "   : %.3f ", voltage_fact);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	   
  

  																	 
	  //   , ..       
	 needOpen=1;
  	if(testPlolog(tc))
		return TRES_INIT_FAIL;
  																	 
   /********    ****************/
 
 //    ( )  
 
 
 Pars.Error=0;
 Pars.tc=tc;
 Pars.HighThresholdDef=7.0;//HighThreshold;
 Pars.LowThresholdDef=-7.0;//LowThreshold;
 Pars.Umax=voltage_fact;
 Pars.Umin=-voltage_fact;
 Pars.step=0.1;
 Pars.range=0;
 Pars.ShortCircuitFlag=0;  
 Pars.Base=1000;//100000;    
 Pars.AcqTime=200;
 
 
 Pars.HighThresholdHighLimit=HIGH_THRESHOLD_MAX_0;
 Pars.HighThresholdLowLimit=8.0; 
 Pars.LowThresholdHighLimit=-8.0;
 Pars.LowThresholdLowLimit=LOW_THRESHOLD_MAX_0;  
 
 Pars.BeginPercentage=0.0;
 Pars.MediumPercentage=50.0;
 Pars.EndPercentage=100.0;
 
 HighThresholdMax=10.19;
 LowThresholdMax=-10.11;
 
 
  /******       ******/   
  err=CriticalThresholdDef_Ex2(&Pars);
  
  //tc->cbf(TFMSG_PROGRESS(100.0), NULL); 
	
 /*
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)CriticalThresholdDef_Ex3, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);
  ResumeThread(hThread); 
  
  
  
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  
  err=Pars.Error;*/	
	
	
  if(err)
   {
    EmptyStr(tc);  
    sprintf(info_mes, "!      ! .!");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
	return 	 TRES_T_FAIL; 
   }
   											 
    test_err=TRES_T_OK;       
   
   EmptyStr(tc);   
   sprintf(info_mes, ":");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
	
   sprintf(info_mes, " :");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));			
		
   	
   for(i=0;i<hltr51.LChQnt;i++)
   {
   
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;   
    threshold_error[i]=100.0*((Pars.HighCriticalThreshold[i])-(Pars.Umax))/(HighThresholdMax-LowThresholdMax);
	
	sprintf(info_mes, " %d.     : %.3f%%", PhysChannel,threshold_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		

	 if(fabs(threshold_error[i])>2.0)  //    
	  {
	   sprintf(info_mes, "!      %d   !", PhysChannel);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		  
	   EmptyStr(tc);  
	   /*sprintf(info_mes, "     %d  %f", PhysChannel,Pars.HighCriticalThreshold[i]);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));  */
	  	  
		  
		  
	   test_err=TRES_T_FAIL;
	   }
	  } //  for(..) 
 
   
  EmptyStr(tc);
  sprintf(info_mes, " :");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		
  
 
 //   
 for(i=0;i<hltr51.LChQnt;i++)
   {
   
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;   
	threshold_error[i]=100.0*(Pars.LowCriticalThreshold[i]-Pars.Umin)/(HighThresholdMax-LowThresholdMax);
	
	 sprintf(info_mes, " %d.     : %.3f%%", PhysChannel,threshold_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		

	 if(fabs(threshold_error[i])>2.0)  //    
	  {
	   
	   sprintf(info_mes, "!      %d   !", PhysChannel);
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		  
	EmptyStr(tc);
		  
	   test_err=TRES_T_FAIL;
	   }
	  }  
   
 exit:
  
 EmptyStr(tc);  
 
 return (test_err);
 
}


/*****************************************************************************************

                         
    
******************************************************************************************/    

int ShortCircuit_Verify(TCONTEXT *tc)
{

 TE01 *te01; 
 double K,B;
 double freq;
 int i;
 int PhysChannel;
 int size;
 int err;
 int periods;
 double voltage, voltage_fact;
 double HighThreshold, LowThreshold;
 double HighThresholdMax, LowThresholdMax;
 double threshold_error[16];
 ThrDefPars Pars; 
 //HANDLE hThread;
 //DWORD TmpDWord;

 
  te01 = (TE01 *)tc->te01; 
  
  //  . -  EEPROM
  
  err=TE01ReadCoeffFromEEPROM(te01); 
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  
  
  K = te01->Kf1[2]; 	//  - 01
  B = te01->Bf1[2];
  
  
  freq=100;
  voltage=1000*K+B;  //  .      . 
  size=20000;
  periods=1;  
  

   //   100 

   strcpy(info_mes, "  01.   100 ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
     
  err=FDAC_set_image(te01, size, periods);
  
 if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  
  
 te01->uadc_range=1;
 te01->cflags|=UADC_DATA_CORRECTION;
 
 TE01SetUADCConfiguration(te01, 0, 1, 19000);      
  
  
  err=TE01SetFDACConfiguration(te01, size, 1, 1, 2, 0, /*-*/voltage, (0*K+B), 1);
  if(err)  
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  	 
    //       0.   -       
   SetSDAC_Value(te01, 5000, 0);
  
  
 //TE01SetConfiguration(te01, FORCE_UPDATE_RAM|FORCE_UPDATE_FDAC);      
  
 err=TE01UMeasurement(te01, &voltage, 8, 1000.0, NULL);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  	 
  voltage_fact=(TE01UModuleValue(te01, voltage, 1)+DETECTOR_CORRECT)/1000;  
  
EmptyStr(tc);  
 sprintf(info_mes, "   : %.3f ", voltage_fact);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	   
  
  HighThreshold=0.7;
  LowThreshold=0.3;  
  
  
 Pars.Error=0;  
 Pars.tc=tc;
 Pars.HighThresholdDef=HighThreshold;
 Pars.LowThresholdDef=LowThreshold;
 Pars.Umax=voltage_fact;//1.0;
 Pars.Umin=0.0;
 Pars.step=0.02;
 Pars.range=1;
 Pars.ShortCircuitFlag=1;
 Pars.Base=1000;//10000;
 Pars.AcqTime=200;
 
 Pars.HighThresholdHighLimit=1.224;
 Pars.HighThresholdLowLimit=0.9;
 
 Pars.BeginPercentage=0.0;
 Pars.MediumPercentage=50.0;
 Pars.EndPercentage=100.0;
 
 HighThresholdMax=1.224;
 LowThresholdMax=-1.214;
 
 
  err=CriticalThresholdDef_Ex2(&Pars/*tc, &HighThreshold, &LowThreshold, 1.0, 0.0, CriticalThreshold, 0.02, 1*/);
  
  
  /*
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)CriticalThresholdDef_Ex3, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);
  ResumeThread(hThread); 
  
  
  
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  
  err=Pars.Error;*/	
  
  
  
  if(err)
   {
    EmptyStr(tc);  
    //sprintf(info_mes, "!      ! .!");
	 //if(tc->cbf) 
		//(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
	 
	//return (err);	
	test_err=err;
	goto exit;
	
   }
   
  
  for(i=0;i<hltr51.LChQnt;i++)
     {
   
      PhysChannel=((hltr51.LChTbl[i])&0xF)+1;  
      
      if(PhysChannel%2)
      {
       threshold_error[i]=100.0*(Pars.HighCriticalThreshold[i]-Pars.Umax)/(HighThresholdMax-LowThresholdMax);
	
	   sprintf(info_mes, " %d.     : %.3f%%", PhysChannel,threshold_error[i]);
	   if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));		

	   if(fabs(threshold_error[i])>3.0)
	    {
	     sprintf(info_mes, "!      %d   !", i);
	     if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		  
		  EmptyStr(tc);  
		  
	      test_err=TRES_T_FAIL;
	    }
	  }  //  if(PhysChannel%2)
	 } //  for 
   
   
   
 exit:  
   
 EmptyStr(tc);  
 
 return (test_err);  
  
 }


/**********************************************************************************************

                                  
     
**********************************************************************************************/     

int FrequencyResponce(TCONTEXT *tc)
{

#define FREQ_ERR_MAX_FL_35KHZ 40
#define FREQ_ERR_MIN_FL_35KHZ 20
#define FREQ_ERR_MAX_FL_170KHZ 75
#define FREQ_ERR_MAX_FH_170KHZ 60
#define FREQ_ERR_MIN_FH_170KHZ 20
#define FREQ_ERR_MIN_FH_35KHZ 7

int test_err=TRES_T_OK; 
TE01 *te01;
  int i;
  int size;
  int periods;
  double HighThreshold, LowThreshold;
  double HighThresholdMax, LowThresholdMax;
  double CriticalThreshold[16];
  double threshold_error[16];
  double freq;
  double voltage_max, voltage_min;
  double voltage, voltage_fact;
  int ThresholdAchieve[16];
  double K, B; 
  int PhysChannel;
  
  int FL_35_Flags[16];
  int FH_35_Flags[16];
  int FL_170_Flags[16];
  int FH_170_Flags[16];
  int BadChannels[16];
  int ErrorFlag=0;
  
  char tmp_str[255];
  
  
  ThrDefPars Pars;
  
  int err; 
 
  //HANDLE hThread;
  //DWORD TmpDWord;
  
 
  
  memset(ThresholdAchieve,0,16*sizeof(int));
  memset(CriticalThreshold,0,16*sizeof(double));  
  
  memset(FL_35_Flags,0,16*sizeof(int));  
  memset(FH_35_Flags,0,16*sizeof(int));  
  memset(FL_170_Flags,0,16*sizeof(int));  
  memset(FH_170_Flags,0,16*sizeof(int)); 
  memset(BadChannels,0,16*sizeof(int));

  
  	if(testPlolog(tc))
		return TRES_INIT_FAIL;
	
   hltr51.SetUserPars=1;   //    Fs  Base
   hltr51.LChQnt=16;       //        
   hltr51.Fs=500000;       //   .   
   hltr51.Base=1000;        // ,   
   hltr51.AcqTime=200;
  
   //double Fref;			   //  :    
   //double Fbase;		   //  :   
 
 
		
  te01 = (TE01 *)tc->te01; 
  
  //  . -  EEPROM
  
  err=TE01ReadCoeffFromEEPROM(te01);  
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);
  	 }
  
  
  K = te01->Kf1[2]; 	//  - 01
  B = te01->Bf1[2];
  
  
  freq=35000;//35000;//35000;//100;
  voltage_max=1000*K+B;
  voltage_min=-1000*K+B;
  size=20000;
  periods=35;
  
  
  
  te01->uadc_range=1;
  te01->cflags|=UADC_DATA_CORRECTION;
  
  //te01->cflags|=UADC_DATA_CORRECTION;  
  SetADC_Range(te01, 1);    
  FDAC_set_image(te01, size, periods);  
  TE01SetUADCConfiguration(te01, 0, 1, 19000);  
  TE01SetFDACConfiguration(te01, size, 1, 0, 2, 0, voltage_max, voltage_min , 1);
  
  SetSDAC_Value(te01, 0, 0);     
  //TE01SetConfiguration(te01, FORCE_UPDATE_RAM|FORCE_UPDATE_FDAC|FORCE_UPDATE_UMODULE);    
  
  
  
  /*********      . -!!! **********/
  
   strcpy(info_mes, "  01.   35 ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
  
   //   
    //SetADC_Range(te01, 1); 
  
  											 
                     
  
  //te01->uadc_range=1;
  //te01->cflags|=UADC_DATA_CORRECTION;
  
  //voltage=TE01UModuleValue(te01, voltage, 1);
  
 err=TE01UMeasurement(te01, &voltage, 8, 1000.0, NULL);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);   
  	 }
  
  
 voltage_fact=(TE01UModuleValue(te01, voltage, 1)+DETECTOR_CORRECT)/1000;   
  
  
EmptyStr(tc);  
 sprintf(info_mes, "   : %.3f ", voltage_fact);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	   

 HighThreshold=0.3;	   
 LowThreshold=-0.3;
 
 Pars.Error=0;
 Pars.tc=tc;
 Pars.HighThresholdDef=HighThreshold;
 Pars.LowThresholdDef=LowThreshold;
 Pars.HighThresholdHighLimit=1.224;
 Pars.HighThresholdLowLimit=0.4;
 Pars.LowThresholdHighLimit=-0.4;
 Pars.LowThresholdLowLimit=-1.214;  
 

 Pars.step=0.04;//0.02;
 Pars.range=1;
 Pars.ShortCircuitFlag=0;
 Pars.EtalFreq=35000.0;
 Pars.MesFreq=35000.0;   
 Pars.Base=1000;//10000;
 Pars.AcqTime=200;
 
 Pars.Umax=voltage_fact;//1.0;
 Pars.Umin=-voltage_fact;
 
 
 Pars.BeginPercentage=0.0;
 Pars.MediumPercentage=25.0;
 Pars.EndPercentage=50.0;
 
 HighThresholdMax=1.224;
 LowThresholdMax=-1.214;
 
 

 //  
// voltage_fact=GetUADC_Val(te01); 
 
 //goto lomty;     
 err=CriticalThresholdDef_Ex2(&Pars); 
 
 
 //EmptyStr(tc);
 
 
 
   /*
  
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)CriticalThresholdDef_Ex3, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);
  ResumeThread(hThread); 
  
  
  
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  
  err=Pars.Error;   */
  if(err)
   {
    EmptyStr(tc);  
	test_err=err;
	return(test_err);
	
   }
  
 
 
		
EmptyStr(tc);    		
		
 
 for(i=0;i<hltr51.LChQnt;i++)
 {
   threshold_error[i]=100*((Pars.Umax-Pars.Umin)-(Pars.HighCriticalThreshold[i]-Pars.LowCriticalThreshold[i]))/(/*U_Range*/Pars.Umax-Pars.Umin);
 
 
   PhysChannel=((hltr51.LChTbl[i])&0xF)+1;   

   sprintf(info_mes, " %d.       : %.3f%%", PhysChannel,threshold_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
 if(threshold_error[i]<FREQ_ERR_MIN_FH_35KHZ)
  FH_35_Flags[i]=1;
 
 if((threshold_error[i]>FREQ_ERR_MIN_FL_35KHZ)&&(threshold_error[i]<FREQ_ERR_MAX_FL_35KHZ))
  FL_35_Flags[i]=1;
   
 }
 

 size=20000;
 freq=170000;
 periods=170;
 
 EmptyStr(tc);      
 strcpy(info_mes, "  01.   170 ");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
  
  te01->cflags|=UADC_DATA_CORRECTION;  
  //SetADC_Range(te01, 1);    
  FDAC_set_image(te01, size, periods);  
  TE01SetFDACConfiguration(te01, size, 1, 0, 2, 0, voltage_max, voltage_min , 1);
  //SetSDAC_Value(te01, 0, 0);     
  TE01SetConfiguration(te01, FORCE_UPDATE_RAM|FORCE_UPDATE_FDAC|FORCE_UPDATE_UMODULE);    
  																	 

 //  
 
   
 err=TE01UMeasurement(te01, &voltage, 8, 1000.0, NULL);
  if(err)
    {
     strcpy(info_mes," TE01!   !");
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 	 test_err=TRES_HW_FAIL; 
	     return (test_err);   
  	 }
  
  
  voltage_fact=(TE01UModuleValue(te01, voltage, 1)+DETECTOR_CORRECT)/1000;   
   
   
 
  EmptyStr(tc);  
  sprintf(info_mes, "   : %.3f ", voltage_fact);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
 
 Pars.Error=0;  
 Pars.EtalFreq=170000.0;
 Pars.MesFreq=170000.0; 
 
 Pars.Umax=voltage_fact;//1.0;
 Pars.Umin=-voltage_fact;
 
 Pars.HighThresholdDef=0.01;
 Pars.LowThresholdDef=-0.01;
 Pars.HighThresholdHighLimit=1.224;
 Pars.HighThresholdLowLimit=0.01;//0.9; 
 Pars.LowThresholdHighLimit=-0.01;//0.2;
 Pars.LowThresholdLowLimit=-1.214; 
 Pars.step=0.04;
 
 Pars.BeginPercentage=50.0;
 Pars.MediumPercentage=75.0;
 Pars.EndPercentage=100.0;
 
 
 //   
 //SetADC_Range(te01, 1);
 //  
 //voltage_fact=GetUADC_Val(te01); 
 
 
//   ,       
err=CriticalThresholdDef_Ex2(&Pars); 

  /*
  
  hThread= CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)CriticalThresholdDef_Ex3, 
                        NULL, CREATE_SUSPENDED, (LPDWORD)&TmpDWord);
  ResumeThread(hThread); 
  
  
  
  WaitForMultipleObjects(1, &hThread, TRUE, INFINITE);
  CloseHandle(hThread);
  
  err=Pars.Error;   */



if(err)
 {
  test_err=err;
  return (test_err);
 }
 
  
EmptyStr(tc);  
 test_err=TRES_T_OK; 
		
 
 for(i=0;i<hltr51.LChQnt;i++)
 {
   threshold_error[i]=100*((Pars.Umax-Pars.Umin)-(Pars.HighCriticalThreshold[i]-Pars.LowCriticalThreshold[i]))/(Pars.Umax-Pars.Umin);
 
   PhysChannel=((hltr51.LChTbl[i])&0xF)+1;   

   sprintf(info_mes, " %d.       : %.3f%%", PhysChannel,threshold_error[i]);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
		
	
 if(threshold_error[i]>FREQ_ERR_MAX_FL_170KHZ)
  FL_170_Flags[i]=1;
 
 if((threshold_error[i]>FREQ_ERR_MIN_FH_170KHZ)&&(threshold_error[i]<FREQ_ERR_MAX_FH_170KHZ))
  FH_170_Flags[i]=1;

 }

 EmptyStr(tc); 
 
 
 // ,     

 for(i=0;i<hltr51.LChQnt;i++)
 {
  PhysChannel=((hltr51.LChTbl[i])&0xF)+1; 
  
   // ,     FL  FH          
   
   //           ,  FH  FL!!!
   
  if(((FH_170_Flags[i]==1)&&(FL_170_Flags[i]==1))||((FH_170_Flags[i]==0)&&(FL_170_Flags[i]==0)))
   {
     BadChannels[i]=1;
     ErrorFlag=1;
     sprintf(info_mes, "  %d  !   . ! .    ", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	continue;	
	}	
   
  
  if(((FH_35_Flags[i]==1)&&(FL_170_Flags[i]==1))||((FH_35_Flags[i]==0)&&(FL_170_Flags[i]==0)))
   {
     BadChannels[i]=1;
     ErrorFlag=1;
     sprintf(info_mes, "  %d  !   . ! .    ", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
	continue;
	}	
	
	
  if(((FH_35_Flags[i]==1)&&(FL_35_Flags[i]==1))||((FH_35_Flags[i]==0)&&(FL_35_Flags[i]==0)))
   {
     BadChannels[i]=1;
     ErrorFlag=1;
     sprintf(info_mes, "  %d  !   . ! .    ", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	continue;	
	}
	
  if(((FH_170_Flags[i]==1)&&(FL_35_Flags[i]==1))||((FH_170_Flags[i]==0)&&(FL_35_Flags[i]==0)))
   {
     BadChannels[i]=1;
     ErrorFlag=1;
     sprintf(info_mes, "  %d  !   . ! .    ", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	continue;	
	}	
	
	
   
   
  
  if(FH_170_Flags[i]==FH_35_Flags[i])
  {
   if(FH_170_Flags[i]==1)
   {
     sprintf(info_mes, " %d   H51-FH", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
	}	
   }	
  else //  if(FH_170_Flags[i]==FH_35_Flags[i]) 
   {
     BadChannels[i]=1;
     ErrorFlag=1;
     sprintf(info_mes, "  %d  !   .   H51-FH! .    ", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
	continue;	
	}	
    
   
   
  if(FL_170_Flags[i]==FL_35_Flags[i])
  {
   if(FL_170_Flags[i]==1)
   {
     sprintf(info_mes, " %d   H51-FL", PhysChannel);
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
	}
   }
  else //  if(FH_170_Flags[i]==FH_35_Flags[i]) 
    {
      BadChannels[i]=1;
      ErrorFlag=1;
      sprintf(info_mes, "  %d  !.   .   H51-FL! .    ", PhysChannel);
	  if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));
	continue;	
	 }	

 }
 
 
 //      ,   
 
if(ErrorFlag)
 {
 	 test_err=TRES_T_FAIL;   
     sprintf(info_mes, "       :");
	 /*if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));   */
		
		
  
  for(i=0;i<hltr51.LChQnt;i++)
   {
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
 
    if(BadChannels[i]==1)
     {
     sprintf(tmp_str," %d", PhysChannel);
     strcat(info_mes, tmp_str);
	 /*if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	   */
     } //  if(BadChannels[i]==1)       		
   } //  for
   
	 if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
   
 }   //  if(ErrorFlag)        
 
 

 
return test_err; 
}



/****************************************************************************************************
*****************************************************************************************************

                 
           
*****************************************************************************************************
*****************************************************************************************************/

int CriticalThresholdDef_Ex2(ThrDefPars *Pars/*TCONTEXT *tc, double *HighThresholdDef, double *LowThresholdDef, double Umax, double Umin, double *CriticalThreshold, double step, int range*/)

{

double HighThreshold, LowThreshold;
int i, j, k;
int err=TRES_T_OK;
int test_err=TRES_T_OK;
int cnt;
int OddChQnt=0;
DWORD *rd_buf; 
double frequency[16];
double etal_frequency[16];
int PhysChannel;
double delta_d;
double delta_f;
double TmpZeroThreshold;
double step;
double HighThresholdFix;
double delta[16];
int ThresholdAchieve[16]; 
int ThresholdAchieveFlag=0;  
int TmpFlag=0;
int FirstErrorFlag=1;
DWORD data_size;


memset(ThresholdAchieve,0,16*sizeof(int));  
memset(Pars->HighCriticalThreshold,0.0,16*sizeof(double));  
memset(Pars->LowCriticalThreshold,0.0,16*sizeof(double));  

/******      ,        ****/

HighThreshold=Pars->HighThresholdDef;
LowThreshold=Pars->LowThresholdDef; 

//  . 
				   
j=0;
 for(i=0;i<MAX_CHANNEL;i++)
 {
   if((hltr51.ChannelsEna>>i)&0x1)
   {
   hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, Pars->range, 0);  
   j++;
   }
  
 }
 
 hltr51.SetUserPars=1;
 hltr51.LChQnt=j;  
 hltr51.Base=Pars->Base;//10000;
 hltr51.AcqTime=Pars->AcqTime;

 //   
 
 err=LTR51_Config(&hltr51);
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 return test_err;
  	 }
  	 
  //      
  EmptyStr(Pars->tc);  
  sprintf(info_mes, "  ");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
  
  err=LTR51_Start(&hltr51);
  if(err)
   {
    msg=LTR51_GetErrorString(err);
	if(Pars->tc->cbf) 
	 (Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	test_err=TRES_HW_FAIL; 
	return test_err;
  	}
  
  rd_buf=(DWORD*) malloc(MAX_CHANNEL*2*hltr51.TbaseQnt*sizeof(DWORD));
  
  cnt= LTR_Recv(&hltr51.Channel, rd_buf, NULL, MAX_CHANNEL*2*hltr51.TbaseQnt, 10000);
  
  if(cnt==0)
  {
   sprintf(info_mes, "    !"); 
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     free(rd_buf);
	     return (test_err);
  }	     
 
 if(cnt!=32*hltr51.TbaseQnt)
  {
   sprintf(info_mes, "  ,  !"); 
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	      free(rd_buf);
	     return (test_err);
  }	     
  
  data_size=MAX_CHANNEL*2*100;
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, &data_size); 
  
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL;
	  free(rd_buf);
	 return test_err;
  	}
  
 err=LTR51_Stop(&hltr51);
 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	  free(rd_buf);
	 return test_err;
  	}
 
 //       
 
 for(i=0;i<hltr51.LChQnt;i++)
   etal_frequency[i]=frequency[i];   
   
  //  ,       
  
  if(Pars->ShortCircuitFlag)
  {
    test_err= EvenChannelCheck(Pars->tc, frequency); 
    test_err|= OddChannelCheck(Pars->tc, frequency); 
    
    if(test_err!=TRES_T_OK)
     {
      free(rd_buf); 
      return(test_err);
     }
  }
  
 //   ,   ,  -    
  delta_d=1E-2;
 
  EmptyStr(Pars->tc);
  
  sprintf(info_mes, "   ");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
  sprintf(info_mes, "  : U=%f ", LowThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
		
  sprintf(info_mes, ",   ");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
 		

  HighThresholdFix=HighThreshold; //      (     )



  HighThreshold=Pars->HighThresholdLowLimit;
  
  if(Pars->range)
    step=0.07; //     
  else
    step=0.7;

 //      
 for(;;)
  {
   //Pars->tc->cbf(TFMSG_PROGRESS(100.0 * (20-19) /120000), NULL);
   
   //       ,   " ",     
   if(HighThreshold>Pars->HighThresholdHighLimit)
    {
    
    for(i=0;i<hltr51.LChQnt;i++)
    {
     PhysChannel=((hltr51.LChTbl[i])&0xF)+1; 
     if(ThresholdAchieve[i]!=1)
     {
     
     sprintf(info_mes, "!     ,    %d     !", PhysChannel);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 }	
	}	
		
	 test_err=TRES_T_FAIL; 
	 free(rd_buf);
	 return (test_err);
	 
	 
	 
	}
     
 
   if (Pars->tc->cbf(TFMSG_PROGRESS(Pars->BeginPercentage), NULL)) 
	    return TRES_ABORT;  
	    //goto Force_Stop;
   /*if(!TmpFlag)
    memset(ThresholdAchieve,0,16*sizeof(int)); */ 
 
   j=0;
   
   for(i=0;i<16;i++)
    {
     if((hltr51.ChannelsEna>>i)&0x1)
     {
       hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, Pars->range, 0);  
       j++;
     }
  }
 
 /*******/////////////////////////////////////////////////////////////////////////////////////
 	 
 //EmptyStr(Pars->tc);
 
 
/*		
sprintf(info_mes, "%s %f", " , : ", HighThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));    */
		
		
 /*******/////////////////////////////////////////////////////////////////////////////////////
 
		
  
 //   
 
 err=LTR51_Config(&hltr51);
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 free(rd_buf);
	 return(test_err);
  	 }
  
  //   
 err=LTR51_Start(&hltr51);
 
 if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	  free(rd_buf); 
	 return(test_err);
  	}
  
  cnt= LTR_Recv(&hltr51.Channel, rd_buf, NULL, 32*hltr51.TbaseQnt, 5000);
  
  if(cnt==0)
  {
   sprintf(info_mes, "    !"); 
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     free(rd_buf); 
	     return (test_err);
  }	     
 
 if(cnt!=32*hltr51.TbaseQnt)
  {
   sprintf(info_mes, "  ,  !"); 
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     free(rd_buf); 
	     return (test_err);
  }	 
 
  data_size=32*hltr51.TbaseQnt;
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, &data_size); 
  
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 free(rd_buf); 
	 return(test_err);
  	}
  
  err=LTR51_Stop(&hltr51);
 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 free(rd_buf);
	 return test_err;
  	}
  
  
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
  
  if(!Pars->ShortCircuitFlag)
  {
    //           
    for(i=0;i<hltr51.LChQnt;i++)
     {
      PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
      delta_f=100*fabs((etal_frequency[i]-frequency[i])/etal_frequency[i]);
      delta[i]=delta_f;
    
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
     /*
    
      sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, delta_f);
	  if(Pars->tc->cbf) 
	    (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));      */
	    
	    
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
	    
    
      //  .  ,  .     ,    
      if(delta[i]>delta_d)
       {
        ThresholdAchieveFlag=1;
        if(!ThresholdAchieve[i])
        Pars->HighCriticalThreshold[i]=HighThreshold;
  
        ThresholdAchieve[i]=1;
        } 
      } //     
    } //  if(!Pars->ShortCircuitFlag)
    
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      , :  
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
    
    
   else   //       
    {
      //   ,     ,    
      
       test_err=EvenChannelCheck(Pars->tc, frequency); //        
        if(test_err!=TRES_T_OK)						   //   
         return(test_err);
    
     //           
     //         . 
     //    -
      OddChQnt=0;
      
      for(i=0;i<hltr51.LChQnt;i++)
       {
        PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
       
        if(PhysChannel%2)
        {
         OddChQnt++;
         delta_f=100*fabs((etal_frequency[i]-frequency[i])/etal_frequency[i]);
         delta[i]=delta_f;
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
    	 
    	 /*
         sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, delta_f);
	     if(Pars->tc->cbf) 
	       (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));  */   
	       
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
	       
    
         //  .  ,  .     ,    
         if(delta[i]>delta_d)
          {
           ThresholdAchieveFlag=1;   
           if(!ThresholdAchieve[i])
           Pars->HighCriticalThreshold[i]=HighThreshold;
           ThresholdAchieve[i]=1;
          }
        } //  if(PhysChanne%2)    
      } //     
    } //  else...
    
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
    
   
   if(ThresholdAchieveFlag==0) 
    {
     TmpZeroThreshold=HighThreshold; 
     FirstErrorFlag=0;
     }
     
   else  //  -  .  , 
    {
     if(TmpFlag)
      {
       k=0;
       for(i=0; i<hltr51.LChQnt; i++)
        {
         if(ThresholdAchieve[i])
         k++;
        } //  for(..)
    
     if(!Pars->ShortCircuitFlag) 		
      {
       if(k==hltr51.LChQnt)
         break;
      } //  if(!Pars...) 
     else
      if(k==OddChQnt)
       break;	
     } //  if(TmpFlag..)
     else
      {
       if(FirstErrorFlag) //         , ,   
        {
         EmptyStr(Pars->tc); 
         for(i=0;i<hltr51.LChQnt;i++)
         {
          PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
          
          if(ThresholdAchieve[i]==1)
           {
            sprintf(info_mes, "  %d         %f ", PhysChannel, Pars->HighThresholdLowLimit);
	        if(Pars->tc->cbf) 
	         (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	        } //  if
	       } //  for
          
          test_err=TRES_T_FAIL;
          return(test_err);
        }
        
       
       TmpFlag=1;
       step=Pars->step;
       HighThreshold=TmpZeroThreshold;
       memset(ThresholdAchieve,0,16*sizeof(int)); 
       
      } //  else
   } //  else 
    
   HighThreshold+=step; 
   ThresholdAchieveFlag=0; 
  
  }  //  for(HighThreshold...)
  
     sprintf(info_mes, "");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
   sprintf(info_mes, " . ,  . .      : %f.6 ", HighThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));	
		
	EmptyStr(Pars->tc);	
	
	if(Pars->ShortCircuitFlag)
	{
	 free(rd_buf);
	 return test_err;
	}
	 
/***********************************************************************/
//       


 //     
  memset(ThresholdAchieve,0,16*sizeof(int)); 
  memset(Pars->LowCriticalThreshold,0,16*sizeof(double));  
  FirstErrorFlag=1;
  
  HighThreshold=Pars->LowThresholdHighLimit;   
  TmpZeroThreshold=LowThreshold;
  ThresholdAchieveFlag=0;  
  TmpFlag=0;
  
  
  sprintf(info_mes, "   ");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
  
 
  sprintf(info_mes, "  : U=%f ", HighThresholdFix);
	if(Pars->tc->cbf) 
	 (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 
  sprintf(info_mes, ",   ");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 

  HighThreshold=HighThresholdFix; 

  //step=0.1;
  
  if(Pars->range)
    step=0.1; //     
  else
    step=0.7;
  
   
  for(;;)
  {
     //       ,   " ",      
   if(LowThreshold<Pars->LowThresholdLowLimit)
   {
    for(i=0;i<hltr51.LChQnt;i++)
    {
     PhysChannel=((hltr51.LChTbl[i])&0xF)+1; 
     if(ThresholdAchieve[i]!=1)
     {
     sprintf(info_mes, "!     ,    %d     !", PhysChannel);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 }	
	}	
		
	 test_err=TRES_T_FAIL; 
	 free(rd_buf);
	 return (test_err);
   }
  
  
     if (Pars->tc->cbf(TFMSG_PROGRESS(Pars->MediumPercentage), NULL)) 
	    return TRES_ABORT; 
  
   j=0;
   
   for(i=0;i<16;i++)
    {
     if((hltr51.ChannelsEna>>i)&0x1)
      {
       hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, Pars->range, 0);  
       j++;
      }
  
    }

 /*******/////////////////////////////////////////////////////////////////////////////////////
 	 
 /*sprintf(info_mes, "");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));  
 
		
 sprintf(info_mes, "%s %f", " , : ", LowThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));  */
		
 /*******/////////////////////////////////////////////////////////////////////////////////////
 
		
 
 //   
 
 err=LTR51_Config(&hltr51);
 
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 free(rd_buf);
	 return(test_err);
  	 }
  
 err=LTR51_Start(&hltr51);
 
 if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 free(rd_buf); 
	 return(test_err);
  	}
  
  cnt= LTR_Recv(&hltr51.Channel, rd_buf, NULL, 32*hltr51.TbaseQnt, hltr51.AcqTime+1000);
  
  
 if(cnt!=32*hltr51.TbaseQnt)
  {
   sprintf(info_mes, "  ,  !"); 
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     free(rd_buf); 
	     return (test_err);
  }	 
  
  
  
  data_size=32*hltr51.TbaseQnt;
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, &data_size); 
  
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL;
	 free(rd_buf); 
	return(test_err);
  	}
  
  err=LTR51_Stop(&hltr51);
 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 free(rd_buf);
	 return(test_err);
  	}
  
   for(i=0;i<hltr51.LChQnt;i++)
   {
   
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
    delta_f=100*fabs((etal_frequency[i]-frequency[i])/etal_frequency[i]);
    delta[i]=delta_f;
    
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
    
    /*
    sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, delta_f);
	if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));   */
		
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
		
    
    
    if(delta[i]>delta_d)
     {
       ThresholdAchieveFlag=1;  
       
      if(!ThresholdAchieve[i])
       Pars->LowCriticalThreshold[i]=LowThreshold;
       
      ThresholdAchieve[i]=1;
     } 

   } 
   
    
   if(ThresholdAchieveFlag==0) 
    {
     FirstErrorFlag=0;
     TmpZeroThreshold=LowThreshold; 
    }
     
   else  //  -  .  , 
    {
     if(TmpFlag)
      {
       k=0;
       for(i=0; i<hltr51.LChQnt; i++)
        {
         if(ThresholdAchieve[i])
         k++;
        } //  for(..)
    
       if(k==hltr51.LChQnt)
         break;
     } //  if(TmpFlag..)
     else
      {
      
       if(FirstErrorFlag) //         , ,   
        {
         EmptyStr(Pars->tc); 
         for(i=0;i<hltr51.LChQnt;i++)
         {
          PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
          
          if(ThresholdAchieve[i]==1)
           {
            sprintf(info_mes, "  %d         %f ", PhysChannel, Pars->LowThresholdHighLimit);
	        if(Pars->tc->cbf) 
	         (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
	        } //  if
	       } //  for
        }
      
      
       TmpFlag=1;
       step=Pars->step;
       LowThreshold=TmpZeroThreshold;
       memset(ThresholdAchieve,0,16*sizeof(int)); 
       
      } //  else
   } //  else  
    
    
   LowThreshold-=step;             
   ThresholdAchieveFlag=0; 
  
  }  //  for(HighThreshold...)
  
     sprintf(info_mes, "");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
	 sprintf(info_mes, "  ,      : %f.3 ", LowThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));	
	
     EmptyStr(Pars->tc);	
		
	 if (Pars->tc->cbf(TFMSG_PROGRESS(Pars->EndPercentage), NULL)) 
	  return TRES_ABORT;     


//	ExitThread(0);       
	 free(rd_buf);
     return(test_err);
}




 #ifdef ABC

/****************************************************************************************************
*****************************************************************************************************

                !!!  
           
*****************************************************************************************************
*****************************************************************************************************/



void CriticalThresholdDef_Ex3(/*ThrDefPars *Pars/*TCONTEXT *tc, double *HighThresholdDef, double *LowThresholdDef, double Umax, double Umin, double *CriticalThreshold, double step, int range*/)

{

double HighThreshold, LowThreshold;
int i, j, k;
int err=TRES_T_OK;
int test_err=TRES_T_OK;
int cnt;
int OddChQnt=0;
DWORD rd_buf[32*100]; 
double frequency[16];
double etal_frequency[16];
int PhysChannel;
double delta_d;
double delta_f;
double TmpZeroThreshold;
int TmpFlag1, TmpFlag2;
double step;
double threshold_error[16];
double HighThresholdFix;
double HighThresholdMax[2]={HIGH_THRESHOLD_MAX_0,  HIGH_THRESHOLD_MAX_1};
double LowThresholdMax[2]={LOW_THRESHOLD_MAX_0,  LOW_THRESHOLD_MAX_1};   
double delta[16];
int ThresholdAchieve[16]; 
int ThresholdAchieveFlag=0;  
double tmp1, tmp2, tmp3;
int TmpFlag=0;
int FirstErrorFlag=1;




   if (Pars.tc->cbf(TFMSG_PROGRESS(Pars.BeginPercentage), NULL)) 
	  {
	    Pars.Error=TRES_ABORT;
	     goto exit;
	   }  


memset(ThresholdAchieve,0,16*sizeof(int));  
memset(Pars.HighCriticalThreshold,0.0,16*sizeof(double));  
memset(Pars.LowCriticalThreshold,0.0,16*sizeof(double));  

/******      ,        ****/

HighThreshold=Pars.HighThresholdDef;
LowThreshold=Pars.LowThresholdDef; 

//  . 
				   
j=0;
 for(i=0;i<MAX_CHANNEL;i++)
 {
   if((hltr51.ChannelsEna>>i)&0x1)
   {
   hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, Pars.range, 0);  
   j++;
   }
  
 }
 
 hltr51.LChQnt=j;  
 hltr51.Base=Pars.Base;//10000;

 //   
 
 err=LTR51_Config(&hltr51);
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 //return test_err;
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;
  	 }
  	 
  //      
  EmptyStr(Pars.tc);  
  sprintf(info_mes, "  ");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
  
  err=LTR51_Start(&hltr51);
  if(err)
   {
    msg=LTR51_GetErrorString(err);
	if(Pars.tc->cbf) 
	 (Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	test_err=TRES_HW_FAIL;
	Pars.Error=TRES_HW_FAIL;
	goto exit;
  	}
  
  
  cnt= LTR_Recv(&hltr51.channel, rd_buf, NULL, MAX_CHANNEL*2*100, 10000);
  
  if(cnt==0)
  {
   sprintf(info_mes, "    !"); 
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     Pars.Error=TRES_HW_FAIL;
	     goto exit;
	     
  }	     
 
 if(cnt!=32*100)
  {
   sprintf(info_mes, "  ,  !"); 
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     
	    Pars.Error=TRES_HW_FAIL;
	     goto exit;

  }	     
  
  
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, MAX_CHANNEL*2*100); 
  
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 	     Pars.Error=TRES_HW_FAIL;
	     goto exit;

  	}
  
 err=LTR51_Stop(&hltr51);
 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 Pars.Error=TRES_HW_FAIL;
	   goto exit;

  	}
 
 //       
 
 for(i=0;i<hltr51.LChQnt;i++)
   etal_frequency[i]=frequency[i];   
   
  //  ,       
  
  if(Pars.ShortCircuitFlag)
  {
    test_err= EvenChannelCheck(Pars.tc, frequency); 
    test_err|= OddChannelCheck(Pars.tc, frequency); 
    
    if(test_err!=TRES_T_OK)
    {
      Pars.Error=TRES_HW_FAIL;
	  goto exit;
	 } 

     
  }
  
 //   ,   ,  -    
  delta_d=1E-2;
 
  EmptyStr(Pars.tc);
  
  sprintf(info_mes, "   ");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
		
  sprintf(info_mes, "  : U=%f ", LowThreshold);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
		
  sprintf(info_mes, ",   ");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
 		

  HighThresholdFix=HighThreshold; //      (     )



  HighThreshold=Pars.HighThresholdLowLimit;
  
  if(Pars.range)
    step=0.07; //     
  else
    step=0.7;

 //      
 for(;;)
  {
 
  ProcessSystemEvents();
   
   //Pars->tc->cbf(TFMSG_PROGRESS(100.0 * (20-19) /120000), NULL);
   
   //       ,   " ",     
   if(HighThreshold>Pars.HighThresholdHighLimit)
    {
    
    for(i=0;i<16;i++)
    {
     PhysChannel=((hltr51.LChTbl[i])&0xF)+1; 
     if(ThresholdAchieve[i]!=1)
     {
     
     sprintf(info_mes, "!     ,    &d     !", PhysChannel);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 }	
	}	
		
	 test_err=TRES_T_FAIL;     
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;
	 
	 
	}
     
 
   if (Pars.tc->cbf(TFMSG_PROGRESS(Pars.BeginPercentage), NULL)) 
	  {
	    Pars.Error=TRES_ABORT;
	     goto exit;
	   }  

	    //goto Force_Stop;
   /*if(!TmpFlag)
    memset(ThresholdAchieve,0,16*sizeof(int)); */ 
 
   j=0;
   
   for(i=0;i<16;i++)
    {
     if((hltr51.ChannelsEna>>i)&0x1)
     {
       hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, Pars.range, 0);  
       j++;
     }
  }
 
 /*******/////////////////////////////////////////////////////////////////////////////////////
 	 
 //EmptyStr(Pars->tc);
 
 
/*		
sprintf(info_mes, "%s %f", " , : ", HighThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));    */
		
		
 /*******/////////////////////////////////////////////////////////////////////////////////////
 
		
  
 //   
 
 err=LTR51_Config(&hltr51);
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL;
	 
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;
	 
  	 }
  
  //   
 err=LTR51_Start(&hltr51);
 
 if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;

  	}
  
  cnt= LTR_Recv(&hltr51.channel, rd_buf, NULL, 32*100, 5000);
  
  if(cnt==0)
  {
   sprintf(info_mes, "    !"); 
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     Pars.Error=TRES_HW_FAIL;
	     goto exit;

  }	     
 
 if(cnt!=32*100)
  {
   sprintf(info_mes, "  ,  !"); 
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	     test_err=TRES_HW_FAIL; 
	     Pars.Error=TRES_HW_FAIL;
	     goto exit;

  }	 
  
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, 32*100); 
  
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;
  	}
  
  err=LTR51_Stop(&hltr51);
 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 	Pars.Error=TRES_HW_FAIL;
	 goto exit;

  	}
  
  
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
         
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
  
  if(!Pars.ShortCircuitFlag)
  {
    //           
    for(i=0;i<hltr51.LChQnt;i++)
     {
      PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
      delta_f=100*fabs((etal_frequency[i]-frequency[i])/etal_frequency[i]);
      delta[i]=delta_f;
    
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
     /*
    
      sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, delta_f);
	  if(Pars->tc->cbf) 
	    (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));      */
	    
	    
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
	    
    
      //  .  ,  .     ,    
      if(delta[i]>delta_d)
       {
        ThresholdAchieveFlag=1;
        if(!ThresholdAchieve[i])
        Pars.HighCriticalThreshold[i]=HighThreshold;
  
        ThresholdAchieve[i]=1;
        } 
      } //     
    } //  if(!Pars->ShortCircuitFlag)
    
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
      , :  
  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
    
    
   else   //       
    {
      //   ,     ,    
      
       test_err=EvenChannelCheck(Pars.tc, frequency); //        
        if(test_err!=TRES_T_OK)						   //   
        {
	     Pars.Error=test_err;
	     goto exit;
	    } 
         
    
     //           
     //         . 
     //    -
      OddChQnt=0;
      
      for(i=0;i<hltr51.LChQnt;i++)
       {
        PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
       
        if(PhysChannel%2)
        {
         OddChQnt++;
         delta_f=100*fabs((etal_frequency[i]-frequency[i])/etal_frequency[i]);
         delta[i]=delta_f;
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
    	 
    	 /*
         sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, delta_f);
	     if(Pars->tc->cbf) 
	       (Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));  */   
	       
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
	       
    
         //  .  ,  .     ,    
         if(delta[i]>delta_d)
          {
           ThresholdAchieveFlag=1;   
           if(!ThresholdAchieve[i])
           Pars.HighCriticalThreshold[i]=HighThreshold;
           ThresholdAchieve[i]=1;
          }
        } //  if(PhysChanne%2)    
      } //     
    } //  else...
    
  /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/
    
   
   if(ThresholdAchieveFlag==0) 
    {
     TmpZeroThreshold=HighThreshold; 
     FirstErrorFlag=0;
     }
     
   else  //  -  .  , 
    {
     if(TmpFlag)
      {
       k=0;
       for(i=0; i<hltr51.LChQnt; i++)
        {
         if(ThresholdAchieve[i])
         k++;
        } //  for(..)
    
     if(!Pars.ShortCircuitFlag) 		
      {
       if(k==hltr51.LChQnt)
         break;
      } //  if(!Pars...) 
     else
      if(k==OddChQnt)
       break;	
     } //  if(TmpFlag..)
     else
      {
       if(FirstErrorFlag) //         , ,   
        {
         EmptyStr(Pars.tc); 
         for(i=0;i<hltr51.LChQnt;i++)
         {
          PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
          
          if(ThresholdAchieve[i]==1)
           {
            sprintf(info_mes, "  %d           %f", PhysChannel, Pars.HighThresholdLowLimit);
	        if(Pars.tc->cbf) 
	         (Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	        } //  if
	       } //  for
          
          test_err=TRES_T_FAIL;
          	 Pars.Error=TRES_HW_FAIL;
	     goto exit;

        }
        
       
       TmpFlag=1;
       step=Pars.step;
       HighThreshold=TmpZeroThreshold;
       memset(ThresholdAchieve,0,16*sizeof(int)); 
       
      } //  else
   } //  else 
    
   HighThreshold+=step; 
   ThresholdAchieveFlag=0; 
  
  }  //  for(HighThreshold...)
  
     sprintf(info_mes, "");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
   sprintf(info_mes, " . ,  . .      : %f.6 ", HighThreshold);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));	
		
	EmptyStr(Pars.tc);	
	
	if(Pars.ShortCircuitFlag)
	{
	 Pars.Error=test_err;
	 goto exit;
	 }
	 
/***********************************************************************/
//       


 //     
  memset(ThresholdAchieve,0,16*sizeof(int)); 
  memset(Pars.LowCriticalThreshold,0,16*sizeof(double));  
  FirstErrorFlag=1;
  
  HighThreshold=Pars.LowThresholdHighLimit;   
  TmpZeroThreshold=LowThreshold;
  ThresholdAchieveFlag=0;  
  TmpFlag=0;
  
  
  sprintf(info_mes, "   ");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes)); 
  
 
  sprintf(info_mes, "  : U=%f ", HighThresholdFix);
	if(Pars.tc->cbf) 
	 (Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 
  sprintf(info_mes, ",   ");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	 

  HighThreshold=HighThresholdFix; 

  //step=0.1;
  
  if(Pars.range)
    step=0.1; //     
  else
    step=0.7;
  
   
  for(;;)
  {
  
 
  ProcessSystemEvents();
  
     //       ,   " ",      
    if(LowThreshold<Pars.LowThresholdLowLimit)
    {
     sprintf(info_mes, "!     !");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
	 test_err=TRES_T_FAIL;     
	 Pars.Error=TRES_T_FAIL;
	 goto exit;

	}
  
  
     if (Pars.tc->cbf(TFMSG_PROGRESS(Pars.MediumPercentage), NULL))
     {
     Pars.Error=TRES_ABORT;
	 goto exit;
	 }
	 
	 ProcessSystemEvents();
  
   j=0;
   
   for(i=0;i<16;i++)
    {
     if((hltr51.ChannelsEna>>i)&0x1)
      {
       hltr51.LChTbl[j]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold, Pars.range, 0);  
       j++;
      }
  
    }

 /*******/////////////////////////////////////////////////////////////////////////////////////
 	 
 /*sprintf(info_mes, "");
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));  
 
		
 sprintf(info_mes, "%s %f", " , : ", LowThreshold);
	 if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));  */
		
 /*******/////////////////////////////////////////////////////////////////////////////////////
 
		
 
 //   
 
 err=LTR51_Config(&hltr51);
 
 
 if(err)
    {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;

  	 }
  
 err=LTR51_Start(&hltr51);
 
 if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;

	 
  	}
  
  cnt= LTR_Recv(&hltr51.channel, rd_buf, NULL, 32*100, 5000); 
  
  err=LTR51_ProcessData(&hltr51, rd_buf, NULL, frequency, 32*100); 
  
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 Pars.Error=TRES_HW_FAIL;
	 goto exit;

  	}
  
  err=LTR51_Stop(&hltr51);
 
  if(err)
   {
     msg=LTR51_GetErrorString(err);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) msg));
	 test_err=TRES_HW_FAIL; 
	 	 Pars.Error=TRES_HW_FAIL;
	 goto exit;

  	}
  
   for(i=0;i<hltr51.LChQnt;i++)
   {
   
    PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
    delta_f=100*fabs((etal_frequency[i]-frequency[i])/etal_frequency[i]);
    delta[i]=delta_f;
    
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
    
    /*
    sprintf(info_mes, ": %d. : %.3f%%", PhysChannel, delta_f);
	if(Pars->tc->cbf) 
		(Pars->tc->cbf(TFMSG_REPORT, (char *) info_mes));   */
		
    	 /****************************************************************************/
    	 /*//////////////////////////////////////////////////////////////////////*/
		
    
    
    if(delta[i]>delta_d)
     {
       ThresholdAchieveFlag=1;  
       
      if(!ThresholdAchieve[i])
       Pars.LowCriticalThreshold[i]=LowThreshold;
       
      ThresholdAchieve[i]=1;
     } 

   } 
   
    
   if(ThresholdAchieveFlag==0) 
    {
     FirstErrorFlag=0;
     TmpZeroThreshold=LowThreshold; 
    }
     
   else  //  -  .  , 
    {
     if(TmpFlag)
      {
       k=0;
       for(i=0; i<hltr51.LChQnt; i++)
        {
         if(ThresholdAchieve[i])
         k++;
        } //  for(..)
    
       if(k==hltr51.LChQnt)
         break;
     } //  if(TmpFlag..)
     else
      {
      
       if(FirstErrorFlag) //         , ,   
        {
         EmptyStr(Pars.tc); 
         for(i=0;i<hltr51.LChQnt;i++)
         {
          PhysChannel=((hltr51.LChTbl[i])&0xF)+1;
          
          if(ThresholdAchieve[i]==1)
           {
            sprintf(info_mes, "  %d           %f", PhysChannel, Pars.HighThresholdLowLimit);
	        if(Pars.tc->cbf) 
	         (Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
	        } //  if
	       } //  for
        }
      
      
       TmpFlag=1;
       step=Pars.step;
       LowThreshold=TmpZeroThreshold;
       memset(ThresholdAchieve,0,16*sizeof(int)); 
       
      } //  else
   } //  else  
    
    
   LowThreshold-=step;             
   ThresholdAchieveFlag=0; 
  
  }  //  for(HighThreshold...)
  
     sprintf(info_mes, "");
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));
		
	 sprintf(info_mes, "  ,      : %f.3 ", LowThreshold);
	 if(Pars.tc->cbf) 
		(Pars.tc->cbf(TFMSG_REPORT, (char *) info_mes));	
	
     EmptyStr(Pars.tc);	
		
	 if (Pars.tc->cbf(TFMSG_PROGRESS(100), NULL)) 
	 {
	 Pars.Error=TRES_ABORT;
	 goto exit;
	 
	 }
   
  exit:

	ExitThread(0);       

     //return(test_err);
}






 #endif




/**************************************************************************
                  
/**************************************************************************/  


void EmptyStr(TCONTEXT *tc)
 {
  sprintf(info_mes, "");
	   if(tc->cbf) 
		  (tc->cbf(TFMSG_REPORT, (char *) info_mes));	
 }
 


/**************************************************************************
                   
/**************************************************************************/   
 
int EvenChannelCheck(TCONTEXT *tc, double *frequency)
 {
  int i;
  int PhysChannel;
  int ErrorFlagZero=0;
  int ErrorChannelsZero[16];
  int res=TRES_T_OK;
  
  memset(ErrorChannelsZero,0,16*sizeof(int));

  
  for(i=0;i<hltr51.LChQnt;i++)
  {
     PhysChannel=((hltr51.LChTbl[i])&0xF)+1;  
     
     if(!(PhysChannel%2)) //   
     
      if(frequency[i]!=0)   //     
       {
        ErrorFlagZero=1;
        ErrorChannelsZero[i]=1;
       } 
       
    } //  //  for(...)   
     
     //EmptyStr(tc);
      
     if(ErrorFlagZero)   //    -      "0"
     {
       EmptyStr(tc); 
     
       sprintf(info_mes, ":          0!:");
	    if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
		
       EmptyStr(tc); 	
		
	   for(i=0;i<hltr51.LChQnt;i++) 
	    {
	      PhysChannel=((hltr51.LChTbl[i])&0xF)+1;        
	      
	      if(ErrorChannelsZero[i])
	       {
	         sprintf(info_mes, " %d", PhysChannel);
	         if(tc->cbf) 
		       (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		    }  
	        
	      } //  for(...)
	      
		res=TRES_HW_FAIL;
      } //  if 
       
  return res;   
      
  }
  

/**************************************************************************
                 
/**************************************************************************/  
  
int OddChannelCheck(TCONTEXT *tc, double *frequency)
 {
  int i;
  int PhysChannel;
  int ErrorFlagNotZero=0;
  int ErrorChannelsNotZero[16];
  int res=TRES_T_OK;

  memset(ErrorChannelsNotZero,0,16*sizeof(int));
  
  for(i=0;i<hltr51.LChQnt;i++)
  {
     PhysChannel=((hltr51.LChTbl[i])&0xF)+1;  
     
     if(PhysChannel%2) //  . ,    
      {
       if(frequency[i]==0)
        {
         ErrorFlagNotZero=1;
         ErrorChannelsNotZero[i]=1;
        }
       }
    } //  //  for(...)   
     
     EmptyStr(tc);
     
    if(ErrorFlagNotZero)   //    -     "0"
     {
       sprintf(info_mes, ":          :");
	    if(tc->cbf) 
		(tc->cbf(TFMSG_REPORT, (char *) info_mes));	
		
	EmptyStr(tc); 	
		
	   for(i=0;i<hltr51.LChQnt;i++) 
	    {
	      PhysChannel=((hltr51.LChTbl[i])&0xF)+1;        
	      
	      if(ErrorChannelsNotZero[i])
	       {
	         sprintf(info_mes, " %d", PhysChannel);
	         if(tc->cbf) 
		       (tc->cbf(TFMSG_REPORT, (char *) info_mes));
		    }  
	        
	      } //  for(...)
		res=TRES_HW_FAIL;
		
      } //  if
      				 
  return res;   
      
  }  
