#include "uts\\common\\include\\commondef.h"                
#include "uts\\systems\\common\\include\\systemdef.h"       
#include "uts\\systems\\common\\include\\systemexport.h"    
#include "uts\\systems\\ltr\\common\\include\\ltrspecific.h"
#include "ltr\\include\\ltrapi.h"     
#include <ansi_c.h>
#include <userint.h>




static ltrTContext  tcontextLTR= {"", 0, 0, -1};

static int  openUTFSystem(void);
static int  closeUTFSystem(void);
static int  configUTFSystem(void) {
  MessagePopup("LTR System on USB", "The system is autoconfigured");
  return 0;
};

static systemDefine systemLTR= {
 {
 PSYSNAME("LTR"), 
 PSYSVERSION("1.0"), 
 PSYSDESCR("LTR Crate System on USB-bus")
 },
 configUTFSystem, // system cfg function
 openUTFSystem,
 closeUTFSystem,
 
 PSYS_MODULEDEF_PTR(NULL) // will be allocated at-the-place
};

// -----------------------------------------------------------------------


// -----------------------------------------------------------------------
systemDefine * __stdcall getUTFSystemDefine(void) {
  return &systemLTR; 
};

// -----------------------------------------------------------------------
void         * __stdcall getUTFSystemTContext(moduleDefine *mi) {
  tcontextLTR.slot= mi->context;
  return (void *)&tcontextLTR;
}

static int readINI(int *addr) {
 FILE *f= fopen("server.ini", "r");  // !!! tmp
 int a, b, c, d;
 *addr= 0x7F000001L;
 
 if(f == NULL) return 1;
 if(fscanf(f, "%d", &a)!=1) goto _b_e;
 if(fscanf(f, "%d", &b)!=1) goto _b_e; 
 if(fscanf(f, "%d", &c)!=1) goto _b_e; 
 if(fscanf(f, "%d", &d)!=1) goto _b_e; 
 
 *addr= a<<24;
 (*addr) |= b<<16;
 (*addr) |= c<<8;
 (*addr) |= d;
 fclose(f);
 return 0;
 
_b_e:
 fclose(f);
 return 1;
};

// *********************************************************************
static int openUTFSystem(void) {
  TLTR ltr;
  moduleDefine module;
  int  j, mid, addr;
  WORD mconfig[16]; 

  closeUTFSystem(); 
  
// goto __tmp1;
  
  LTR_Init(&ltr);
  strcpy(ltr.csn, "");          // !!! tmp    
  if(!readINI(&addr)) {
    ltr.saddr= addr;
  };  
  if(LTR_Open(&ltr)) goto __bad_ret;
 
  if(LTR_GetCrateModules(&ltr, mconfig)) goto __bad_ret;

  memcpy(tcontextLTR.crateSerial, ltr.csn, 16);  
  tcontextLTR.serverAddr= ltr.saddr;
  
  tcontextLTR.serverPort= ltr.sport;  
  tcontextLTR.slot= -1;
  LTR_Close(&ltr);

//__tmp1:  
  memset(&module, 0x0, sizeof(moduleDefine));
  strcpy(module.name,  "LTR010");
  strcpy(module.descr, "Controller LTR010");
  module.context= -1;
  if((systemLTR.module= systemAddModule(systemLTR.module, module)) == NULL) goto __bad_ret;
  //
  for(j= 0; j< 16; j++) {
      if(!mconfig[j]) continue;
      if( (mid= (mconfig[j] & 0xFF)) != ((mconfig[j]>>8) & 0xFF)) continue;
      memset(&module, 0x0, sizeof(moduleDefine));
      sprintf(module.name, "LTR%d", mid);
      sprintf(module.descr, "Slot %d: LTR%d", j+1, mid);      
      module.context= j+1;
      if((systemLTR.module= systemAddModule(systemLTR.module, module)) == NULL) goto __bad_ret;  
  };
  //
  return 0;
  
__bad_ret:  
  LTR_Close(&ltr);
  closeUTFSystem();
  return 1;
}



static int closeUTFSystem(void) {
  systemFreeDefine(&(systemLTR.module));
  //systemLTR.module= NULL;
  return 0;
}

