#include "core.h"
#include "common\\include\\commondef.h"
#include "coreuir.h"
#include "uirprocessor.h"
#include "serviceprocessor.h"
#include <userint.h>
#include <ansi_c.h>

static COREINISET TheSet;

static int Pnl= -1, Bar= -1;
static char  currentModule_Descr[FNAMELEN+1];

extern void *getTE01Handle(void);
extern void initTE01(void);
extern int  connectTE01(int port);
extern int  connectKeithley(int port);
extern int  disconnectTE01(void);
extern int  disconnectKeithley(int port);

extern void closeExecutor(void);
extern void openExecutor(char *moduleDescr, void cbf(void));
static void EnaDisVsHW(void);

int  activateWaitPnl(int pnl) {
 int p;
 p= LoadPanel(pnl, "coreuir.uir", WP);
 InstallPopup(p);
 return p;
};
void deactivateWaitPnl(int p) {
 DiscardPanel(p);
};

static void  EnaDisVsModule(void);
static void CVICALLBACK ModuleFunction ( int menuBarHandle,
         int menuItemID, void *callbackData, int panelHandle );
         
#define P(x) PANEL_##x
#define B(x) bar_##x
#define BS(x) bar_system_##x
#define BP(x) bar_plugin_##x
#define BM(x) bar_module_##x
#define BT(x) bar_tools_##x
#define BH(x) bar_help_##x

void openUir(char *title, uirData *u) {
  int n;
  char tmp[FNAMELEN+1];
  
  coreReadIni(&TheSet);
  
  initTE01();
  
  Pnl = LoadPanel (0, "coreuir.uir", PANEL);  
  Bar= GetPanelMenuBar(Pnl); 

  sprintf(tmp, "UTStand: <%s>", title);
  SetPanelAttribute (Pnl, ATTR_TITLE, tmp);
  
  u->pnl= Pnl;
  u->pbar= Bar;
  u->plugMenuItem= B(plugin);
  u->moduleMenuItem= B(module);
  u->vdevMenuItem= B(service);
  
  SetMenuBarAttribute (Bar, BM(unselect), ATTR_CHECKED, 1);
  SetMenuBarAttribute (Bar, BS(syscfg), ATTR_DIMMED, 1);
  SetCtrlVal (Pnl, P(text), "");
  
  EnaDisVsHW();
  
  //SetMenuBarAttribute (Bar, BP(unselect), ATTR_CHECKED, 1);
  
};

static void CVICALLBACK ServiceFunction ( int menuBarHandle,
         int menuItemID, void *callbackData, int panelHandle );

// **********************************************************************
void showUir(void) {
  EnaDisVsModule();
  DisplayPanel(Pnl);
   // DisplayPanel(MsgPnl);  
   
   mb_connect(-1, -1, NULL, -1);
   
   // show services
  insertServiceList2Bar(Pnl, Bar, B(service), ServiceFunction);
};

extern int closeReporter(void);

void closeUir(void) {
  closeExecutor();
  closeReporter();
  deselectPlugin();
  disconnectSystem();
  DiscardPanel(Pnl);

  disconnectTE01();
  disconnectKeithley(TheSet.keithley.port);  
  
  coreWriteIni(&TheSet);
};

int  CVICALLBACK mf_panelCB(int panel, int event, void *callbackData, 
        int eventData1, int eventData2) {
  if(event == EVENT_CLOSE && panel == Pnl) 
     QuitUserInterface(0);		  
  return 0;
}

void CVICALLBACK mb_syscfg (int menuBar, int menuItem, void *callbackData,
		int panel) {
  systemCore()->system()->config();
};

static int connectSystem(void) {
 int id;
 int res= 0;
     deselectPlugin();
     SetMenuBarAttribute (Bar, BM(unselect), ATTR_CHECKED, 1);     
     SetMenuBarAttribute (Bar, BM(unselect), ATTR_DIMMED, 0);
     EnaDisVsModule();

     while(1) {
		  GetMenuBarAttribute (Bar, B(module), ATTR_FIRST_ITEM_ID, &id);
          if(id == BM(unselect)) break;
          else DiscardMenuItem (Bar, id);
     };
        
     if(connect2System()) {
        // MessagePopup(MSG_ERROR, "Failed to connect to the system or no any module has been identifyied");
        res= 1;
     }
     else {
        insertModuleList2Bar(Pnl, Bar, B(module), ModuleFunction);
     };
     
     SetMenuBarAttribute (Bar, B(system_syscfg), ATTR_DIMMED, 1);
     if(!res) {
        if(systemCore()->system()->config != NULL) {
           SetMenuBarAttribute (Bar, B(system_syscfg), ATTR_DIMMED, 0);
        };
     };
     return res;
};

void CVICALLBACK mb_connect (int menuBar, int menuItem, void *callbackData,
		int panel) {
 int r, p;
 
 p= activateWaitPnl(Pnl);
 SetCtrlVal(Pnl, P(ledsystem), 0);
 SetCtrlVal(Pnl, P(ledte01), 0);
 SetCtrlVal(Pnl, P(ledkeithley), 0);
 ProcessSystemEvents();
 
 SetCtrlVal (Pnl, P(text), "Connecting device...");
 r= connectSystem();
 SetCtrlAttribute(Pnl, P(ledsystem), ATTR_ON_COLOR, r ? VAL_RED : VAL_GREEN);
 SetCtrlVal(Pnl, P(ledsystem), 1);
 
 if(TheSet.te01.use) {
   SetCtrlVal (Pnl, P(text), "Connecting TE-01...");
   r= connectTE01(TheSet.te01.port); 
   SetCtrlAttribute(Pnl, P(ledte01), ATTR_ON_COLOR, r ? VAL_RED : VAL_GREEN);
   SetCtrlVal(Pnl, P(ledte01), 1);
   
   SetMenuBarAttribute (Bar, BT(te01), ATTR_DIMMED, r ? 1 : 0);
 }
 else {
   disconnectTE01(); 
   SetCtrlVal(Pnl, P(ledte01), 0);
   SetMenuBarAttribute (Bar, BT(te01), ATTR_DIMMED, 1);
 };
 
 if(TheSet.keithley.use) { 
   SetCtrlVal (Pnl, P(text), "Connecting Keithley...");
   r= connectKeithley(TheSet.keithley.port);
   SetCtrlAttribute(Pnl, P(ledkeithley), ATTR_ON_COLOR, r ? VAL_RED : VAL_GREEN);
   SetCtrlVal(Pnl, P(ledkeithley), 1); 
   
   SetMenuBarAttribute (Bar, BT(keithley), ATTR_DIMMED, r ? 1 : 0);
 }
 else {
   disconnectKeithley(TheSet.keithley.port);
   SetCtrlVal(Pnl, P(ledkeithley), 0); 
   SetMenuBarAttribute (Bar, BT(keithley), ATTR_DIMMED, 1);
 };
 
 SetCtrlVal (Pnl, P(text), "");
 
 deactivateWaitPnl(p);
}


void CVICALLBACK mb_init_system (int menuBar, int menuItem, void *callbackData,
		int panel) {
 int r, p;
 
 p= activateWaitPnl(Pnl);
 
 SetCtrlVal (Pnl, P(text), "Connecting device..."); 
 SetCtrlVal(Pnl, P(ledsystem), 0);
 ProcessSystemEvents();
 
 r= connectSystem();	
 SetCtrlAttribute(Pnl, P(ledsystem), ATTR_ON_COLOR, r ? VAL_RED : VAL_GREEN);
 SetCtrlVal(Pnl, P(ledsystem), 1); 
 SetCtrlVal (Pnl, P(text), "");
 
 deactivateWaitPnl(p);
}

void CVICALLBACK mb_init_te01 (int menuBar, int menuItem, void *callbackData,
		int panel) {
 int r;
 int p;
 
 if(!TheSet.te01.use) {
    disconnectTE01(); 
    SetCtrlVal(Pnl, P(ledte01), 0); 
    SetMenuBarAttribute (Bar, BT(te01), ATTR_DIMMED, 1);
    return;
 };
 
 p= activateWaitPnl(Pnl);
 SetCtrlVal (Pnl, P(text), "Connecting TE-01...");
 SetCtrlVal(Pnl, P(ledte01), 0);
 ProcessSystemEvents();
 
 r= connectTE01(TheSet.te01.port);
 SetCtrlAttribute(Pnl, P(ledte01), ATTR_ON_COLOR, r ? VAL_RED : VAL_GREEN);
 SetCtrlVal(Pnl, P(ledte01), 1);
 SetCtrlVal (Pnl, P(text), "");
 SetMenuBarAttribute (Bar, BT(te01), ATTR_DIMMED, r ? 1 : 0);
 deactivateWaitPnl(p);
}

void CVICALLBACK mb_init_keithley (int menuBar, int menuItem, void *callbackData,
		int panel) {
 int r;
 int p;
 
 if(!TheSet.keithley.use) {
     disconnectKeithley(TheSet.keithley.port);
     SetCtrlVal(Pnl, P(ledkeithley), 0);  
     
     SetMenuBarAttribute (Bar, BT(keithley), ATTR_DIMMED, 1);
     return;
 };
 
 p= activateWaitPnl(Pnl);
 SetCtrlVal (Pnl, P(text), "Connecting Keithley...");
 SetCtrlVal(Pnl, P(ledkeithley), 0);		
 ProcessSystemEvents();
 
 r= connectKeithley(TheSet.keithley.port);
 SetCtrlAttribute(Pnl, P(ledkeithley), ATTR_ON_COLOR, r ? VAL_RED : VAL_GREEN);
 SetCtrlVal(Pnl, P(ledkeithley), 1); 
 SetCtrlVal (Pnl, P(text), "");
 
 SetMenuBarAttribute (Bar, BT(keithley), ATTR_DIMMED, r ? 1 : 0); 
 deactivateWaitPnl(p);
}

void CVICALLBACK mb_log (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mb_report (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mb_exit (int menuBar, int menuItem, void *callbackData,
		int panel) {
  mf_panelCB(Pnl, EVENT_CLOSE, NULL, 0, 0);		
}

void CVICALLBACK mbmod_unselect (int menuBar, int menuItem, void *callbackData,
		int panel) {
}





extern int BurnMcuFlash(char *moduleDescr, char *fname);
extern int BurnMcuFuses(char *moduleDescr);
//--------------------------------------------------------------
//     mcu
//--------------------------------------------------------------
void CVICALLBACK mbmod_burnmcu_main(int menuBar, int menuItem, void *callbackData, int panel) 
{
  char tmp[FNAMELEN+1];
  if(moduleCore()->plugin()->mcuimage != NULL) {
     sprintf(tmp, "%s\\%s", pluginCurrentPath(), moduleCore()->plugin()->mcuimage);
     BurnMcuFlash(currentModule_Descr, tmp);          // ??? !!! tmp -->    ?
  } else mbmod_burnmcu_special(-1, -1, NULL, -1);  // ??? !!! tmp
}


//--------------------------------------------------------------
//
//--------------------------------------------------------------
static int cbFunction(unsigned int id, char *msg) 
{
 ProcessSystemEvents();
 //
 if((id&MIDCER__MASK)==MIDCER_STOP_ERROR && msg!=NULL) {
	char str[1024];
    sprintf(str, "%s (%s)", MSG_ERROR, currentModule_Descr);
  	MessagePopup(str, msg);
 }	
 //
 return 0;
}
//--------------------------------------------------------------
//
//--------------------------------------------------------------
void CVICALLBACK mbmod_loadadsp_special(int menuBar, int menuItem, void *callbackData, int panel) 
{
 TCONTEXT tc;
 fillTContext(&tc, cbFunction, currentModule_Descr, getTE01Handle());
 moduleCore()->plugin()->init_module(&tc, NULL);		 // !!! TMP		
}
//--------------------------------------------------------------
//         mcu
//--------------------------------------------------------------
void CVICALLBACK mbmod_burnmcu_special(int menuBar, int menuItem, void *callbackData, int panel) 
{
  char tmp[FNAMELEN+1];
  if(FileSelectPopup ("", "*.tsk", "*.hex;*.a90",
				   "UTS: select appropiate image to burn",
				   VAL_SELECT_BUTTON, 0, 0, 1, 0, tmp) !=1 ) return;
   
  BurnMcuFlash(currentModule_Descr, tmp);
}
//--------------------------------------------------------------
//     -
//--------------------------------------------------------------
void CVICALLBACK mbmod_burnmcu_fuses(int menuBar, int menuItem, void *callbackData, int panel) 
{
  BurnMcuFuses(currentModule_Descr);
}





void CVICALLBACK mbmod_calibrate (int menuBar, int menuItem, void *callbackData,
		int panel) {
 TCONTEXT tc;
 fillTContext(&tc, cbFunction, currentModule_Descr, getTE01Handle());
 moduleCore()->plugin()->calibr(&tc);
}

void CVICALLBACK mbmod_verify (int menuBar, int menuItem, void *callbackData,
		int panel) {
 TCONTEXT tc;
 fillTContext(&tc, cbFunction, currentModule_Descr, getTE01Handle());
 moduleCore()->plugin()->verify(&tc);		
}

void CVICALLBACK mbmod_cfgmodule(int menuBar, int menuItem, void *callbackData, int panel) 
{
 TCONTEXT tc;

 fillTContext(&tc, cbFunction, currentModule_Descr, getTE01Handle());
 moduleCore()->plugin()->devcfg_pnl(&tc, NULL);
}

void CVICALLBACK mbmod_vdevice (int menuBar, int menuItem, void *callbackData, int panel) 
{
 TCONTEXT tc;
	
 fillTContext(&tc, cbFunction, currentModule_Descr, getTE01Handle());
 moduleCore()->plugin()->vdev_pnl(&tc, NULL);		 //		
}

void CVICALLBACK mbmod_init (int menuBar, int menuItem, void *callbackData,
		int panel) {
	 TCONTEXT tc;
	
     fillTContext(&tc, NULL, currentModule_Descr, getTE01Handle());
	 moduleCore()->plugin()->init_module(&tc, NULL);		 //
}




static void function2Do_QuitExecutor(void) {
  DisplayPanel(Pnl);
};

extern int isReporterActive(void);
void CVICALLBACK mbmod_run (int menuBar, int menuItem, void *callbackData, int panel) 
{
	
 if(isReporterActive()) {
    if(!ConfirmPopup(MSG_WARNING, "Running a module now will destroy the reporter.\nContinue?")) return;
 }
   
 closeReporter();
 openExecutor(currentModule_Descr, function2Do_QuitExecutor);
 HidePanel(Pnl);
}


void CVICALLBACK mbplug_view (int menuBar, int menuItem, void *callbackData,
		int panel) {
 int n, j, p;
 char tmp[2*FNAMELEN+16];
 
 p= LoadPanel (0, "coreuir.uir", PINFO);
 
 n= core_getPlugNum();
 for(j= 0; j<n; j++) {
    sprintf(tmp, "%s:\n   - %s\n   - %s", core_getPlugName(j), core_getPlugDescr(j), core_getPlugPath(j));
	InsertTextBoxLine (p, PINFO_text, -1, tmp);
 };
 InstallPopup(p);
}

void bringUpPCfgPanel(void);
void CVICALLBACK mbplug_cfg (int menuBar, int menuItem, void *callbackData,
		int panel) {
  bringUpPCfgPanel();
}

extern void te01main(void *handle);
void CVICALLBACK mbtool_te01 (int menuBar, int menuItem, void *callbackData,
		int panel) {
  te01main(getTE01Handle());
}

void CVICALLBACK mbtool_cfgte01ext (int menuBar, int menuItem, void *callbackData,
		int panel) {
	 TCONTEXT tc;

         fillTContext(&tc, cbFunction, currentModule_Descr, getTE01Handle());
	 moduleCore()->plugin()->te01ext_pnl(&tc, NULL);				
}

void CVICALLBACK mbtool_keithley (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbtool_openmodule (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbtool_record (int menuBar, int menuItem, void *callbackData,
		int panel) {
}


void CVICALLBACK mbs_view (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbset_environment (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbset_tcondition (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbset_images (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbset_help (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

static void settingPorts(void);
void CVICALLBACK mbset_ports (int menuBar, int menuItem, void *callbackData,
		int panel) {
   settingPorts();
}

void CVICALLBACK mbhelp_contents (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_plugin (int menuBar, int menuItem, void *callbackData,
		int panel) {
 int p= LoadPanel(0, "coreuir.uir", PINFO);		
 int n, j;
 char tmp[FNAMELEN+1];
 
 SetPanelAttribute (p, ATTR_TITLE, "UTS: Plugin Information");
 if(moduleCore()->plugin()->name!= NULL) {
    SetCtrlVal(p, PINFO_text,  "Name: ");
    SetCtrlVal(p, PINFO_text,  moduleCore()->plugin()->name);
 };
 if(moduleCore()->plugin()->version!= NULL) {
    SetCtrlVal(p, PINFO_text,  "\nVersion: ");
    SetCtrlVal(p, PINFO_text,  moduleCore()->plugin()->version);
 }; 
 if(moduleCore()->plugin()->descr!= NULL) {
    SetCtrlVal(p, PINFO_text,  "\nDescription:\n   ");
    SetCtrlVal(p, PINFO_text,  moduleCore()->plugin()->descr);
 };  
    
    SetCtrlVal(p, PINFO_text,  "\nRelative path to DLL:\n   ");
    SetCtrlVal(p, PINFO_text,  pluginCurrentPath());
    
 if(moduleCore()->plugin()->mcuimage!= NULL) {
    SetCtrlVal(p, PINFO_text,  "\nMust have MCU image:\n   ");
    SetCtrlVal(p, PINFO_text,  pluginCurrentPath());
    SetCtrlVal(p, PINFO_text,  "\\");
    SetCtrlVal(p, PINFO_text,  moduleCore()->plugin()->mcuimage);
 };   
 if(moduleCore()->plugin()->adspimage!= NULL) {
    SetCtrlVal(p, PINFO_text,  "\nMust have ADSP BIOS:\n   ");
    SetCtrlVal(p, PINFO_text,  moduleCore()->plugin()->adspimage);
    
 };    
 
 if(moduleCore()->plugin()->flag.te01) {
    SetCtrlVal(p, PINFO_text,  "\nNeeds TE-01"); 
 }
 if(moduleCore()->plugin()->flag.te01ext!= NULL) {
    SetCtrlVal(p, PINFO_text,  "\nNeeds TE-01 Supplementary Card:\n   "); 
    SetCtrlVal(p, PINFO_text,  moduleCore()->plugin()->flag.te01ext);
 } 
if(moduleCore()->plugin()->flag.keithley) {
    SetCtrlVal(p, PINFO_text,  "\nNeeds Keithley"); 
 };
 
 SetCtrlVal(p, PINFO_text,  "\n"); 
 
 if((n= moduleCore()->fnum())) {
     sprintf(tmp, "\nHas %d tests functions:\n", n); 
     SetCtrlVal(p, PINFO_text, tmp);
     
     for(j= 0; j<n; j++) {
        if(moduleCore()->f(j)->name!= NULL)  {
           sprintf(tmp, "%d. %s %s %s", j+1, 
              moduleCore()->f(j)->name, 
              moduleCore()->f(j)->set.manual? "(manual)" : "",
              moduleCore()->f(j)->set.passport? "(passport)" : "");
           SetCtrlVal(p, PINFO_text, tmp);
           if(moduleCore()->f(j)->descr!= NULL)  {
              SetCtrlVal(p, PINFO_text, "\n   ");
              SetCtrlVal(p, PINFO_text, moduleCore()->f(j)->descr);
              SetCtrlVal(p, PINFO_text, "\n");
            }
        };
        
     };
 };
   
  // InsertTextBoxLine (p, PINFO_text, 0, "");
   
 InstallPopup(p);
}

void CVICALLBACK mbhelp_manual (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_module_hw (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_module_scheme (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_cables (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_te01ext_hw (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_te01ext_scheme (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

void CVICALLBACK mbhelp_about (int menuBar, int menuItem, void *callbackData,
		int panel) {
}

// *********************************************************************
static void  EnaDisVsPlugin(int mode) {
  SetMenuBarAttribute (Bar, BT(te01ext), ATTR_DIMMED, mode);
  SetMenuBarAttribute (Bar, BP(configure), ATTR_DIMMED, mode);
  SetMenuBarAttribute (Bar, BT(record), ATTR_DIMMED, mode);
  SetMenuBarAttribute (Bar, BH(plugin), ATTR_DIMMED, mode);
  SetMenuBarAttribute (Bar, BH(manual), ATTR_DIMMED, mode);
  SetMenuBarAttribute (Bar, BH(module), ATTR_DIMMED, mode);
  SetMenuBarAttribute (Bar, BH(te01ext), ATTR_DIMMED, mode);
  
  if(mode) return;
  
  SetMenuBarAttribute (Bar, BP(configure), ATTR_DIMMED, moduleCore()->fnum() ? 0:1);  // !!! tmp    
  if(moduleCore()->plugin()->te01ext_pnl == NULL ||
     !TheSet.te01.use) SetMenuBarAttribute (Bar, BT(te01ext), ATTR_DIMMED, 1);
  if(moduleCore()->plugin()->wfile == NULL) SetMenuBarAttribute (Bar, BT(record), ATTR_DIMMED, 1);
  SetMenuBarAttribute (Bar, BH(plugin), ATTR_DIMMED, 0);
  if(moduleCore()->plugin()->help.manual== NULL) SetMenuBarAttribute (Bar, BH(manual), ATTR_DIMMED, 1);
  
  if(moduleCore()->plugin()->help.dhw == NULL &&
     moduleCore()->plugin()->help.dscheme == NULL &&
     moduleCore()->plugin()->help.cables == NULL) {
    
     SetMenuBarAttribute (Bar, BH(module), ATTR_DIMMED, 1);
  }
  else {
     SetMenuBarAttribute (Bar, BH(module_descr), ATTR_DIMMED, moduleCore()->plugin()->help.dhw == NULL ? 1:0);
     SetMenuBarAttribute (Bar, BH(module_scheme), ATTR_DIMMED, moduleCore()->plugin()->help.dscheme == NULL ? 1:0);
     SetMenuBarAttribute (Bar, BH(module_cables), ATTR_DIMMED, moduleCore()->plugin()->help.cables == NULL ? 1:0);
  };
  
  if(moduleCore()->plugin()->help.te01exthw == NULL &&
     moduleCore()->plugin()->help.te01extscheme == NULL) {
    
     SetMenuBarAttribute (Bar, BH(te01ext), ATTR_DIMMED, 1);
  }
  else {
     SetMenuBarAttribute (Bar, BH(te01ext_descr), ATTR_DIMMED, moduleCore()->plugin()->help.te01exthw == NULL ? 1:0);
     SetMenuBarAttribute (Bar, BH(te01ext_scheme), ATTR_DIMMED, moduleCore()->plugin()->help.te01extscheme == NULL ? 1:0);
  };
  
};

// *********************************************************************
static void  EnaDisVsModule(void) 
{
 int moduleID, ischecked;
 int mm[]= {BM(burnmcu), BM(more), BM(calibrate), BM(verify), 
             BM(module), BM(vdevice), BM(init), BM(run), -1};
 int i, mcuflash_flag, mcufuses_flag, loadadsp_flag;  
 // 
 GetMenuBarAttribute (Bar, BM(unselect), ATTR_CHECKED, &ischecked);
 // 
 SetMenuBarAttribute (Bar, BT(open), ATTR_DIMMED, ischecked);
 SetMenuBarAttribute (Bar, B(service), ATTR_DIMMED, ischecked);
 for(i=0; mm[i]!=-1; i++) 
 	SetMenuBarAttribute (Bar, mm[i], ATTR_DIMMED, ischecked);
 //
 if(ischecked) {
	EnaDisVsPlugin(1);
    return;
 }
 //
 mcuflash_flag=(moduleCore()->plugin()->flash_read!=NULL || moduleCore()->plugin()->flash_write!=NULL) ? 1 : 0;
 mcufuses_flag=(moduleCore()->plugin()->fuses_read!=NULL || moduleCore()->plugin()->fuses_write!=NULL) ? 1 : 0;
 loadadsp_flag=(moduleCore()->plugin()->load_adsp!=NULL)  ? 1 : 0;
 //	
 SetMenuBarAttribute(Bar, BM(burnmcu), ATTR_DIMMED, !mcuflash_flag);
 SetMenuBarAttribute(Bar, BM(more), ATTR_DIMMED, mcuflash_flag || mcufuses_flag || loadadsp_flag ? 0 : 1); 
 SetMenuBarAttribute(Bar, BM(more_loadadsp), ATTR_DIMMED, !loadadsp_flag);
 SetMenuBarAttribute(Bar, BM(more_burnmcu), ATTR_DIMMED, !mcuflash_flag);
 SetMenuBarAttribute(Bar, BM(more_burnmcu_fuses), ATTR_DIMMED, !mcufuses_flag);
 //
 SetMenuBarAttribute (Bar, BM(calibrate), ATTR_DIMMED, moduleCore()->plugin()->calibr == NULL ? 1:0);
 SetMenuBarAttribute (Bar, BM(verify), ATTR_DIMMED, moduleCore()->plugin()->verify == NULL ? 1:0);
 // 
 SetMenuBarAttribute (Bar, BM(module), ATTR_DIMMED, moduleCore()->plugin()->devcfg_pnl == NULL ? 1:0);
 SetMenuBarAttribute (Bar, BM(vdevice), ATTR_DIMMED, moduleCore()->plugin()->vdev_pnl == NULL ? 1:0);
 SetMenuBarAttribute (Bar, BM(init), ATTR_DIMMED, moduleCore()->plugin()->init_module == NULL ? 1:0);
 // 
 SetMenuBarAttribute (Bar, BM(run), ATTR_DIMMED, moduleCore()->fnum() ? 0:1);  // !!! tmp    
 // 
 EnaDisVsPlugin(0);
};

// *********************************************************************


int CVICALLBACK pinfo_done (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
			DiscardPanel(panel);
			break;
	}
	return 0;
}

static int flagSelectPlugin;

static char __PrevModuleName[FNAMELEN + 1]= "";
static char __PrevPlugPath[FNAMELEN + 1]= "";
// *********************************************************************
//     MODULE
// *********************************************************************
static void CVICALLBACK ModuleFunction (int menuBarHandle, int menuItemID, void *callbackData, int panelHandle ) 
{
 char  plugPath[FNAMELEN+1];
 char *moduleName;
 int   n, j, p, flag1, flag2;
 char tmp[FNAMELEN+1];
 IntListAndLength plugList;
 IntList *indexList, *next;

 GetMenuBarAttribute (Bar, menuItemID, ATTR_ITEM_NAME, tmp);
  if((moduleName= core_getModuleName(tmp)) == NULL) {
      MessagePopup(MSG_ERROR, "Failed get module name");
      return;
  };
  
  plugList = core_getPluginList4Module(moduleName);
  /*if(!(n= core_getPluginNum4Module(moduleName))) {*/
  if(!plugList.number) {
      MessagePopup(MSG_WARNING, "No any plugin exists for this type of modules");
      return;  
  };
  
  strcpy(currentModule_Descr, tmp);   // ??? !!! tmp   ---> here ???
  
  indexList = plugList.list;
  if(plugList.number > 1) {
     flagSelectPlugin= 0;
     p= LoadPanel(0, "coreuir.uir", SPLUG);
     SetCtrlVal(p, SPLUG_module, moduleName);
     /*for(j= 0; j< n; j++) {
         InsertListItem(p, SPLUG_list, -1, 
            core_getPluginDescr4Module(j, moduleName), core_getPluginPath4Module(j, moduleName));
     };*/
     while (indexList) {
		   InsertListItem(p, SPLUG_list, -1, core_getPlugDescr(indexList->data), indexList->data);
		   indexList = indexList->next;
     }
     InstallPopup(p);
     while(!flagSelectPlugin) ProcessSystemEvents();
     GetCtrlVal(p, SPLUG_list, /*plugPath*/&j);
     DiscardPanel(p);
     if(flagSelectPlugin == -1) return;
  }
  else {
  	j = indexList->data;
		/*strcpy(plugPath, core_getPluginPath4Module(0, moduleName));*/
  };
  freeIntList(plugList.list);
  // MessagePopup("", plugPath);
  if(selectPlugin(/*plugPath*/j)) {
     MessagePopup(MSG_ERROR, "Failed load the plugin for the module");
     SetMenuBarAttribute (Bar, BM(unselect), ATTR_CHECKED, 1);     
     EnaDisVsModule();
     return;
  };
  strcpy(plugPath, core_getPlugPath(j));
  
  flag1= 0;
  if(moduleCore()->plugin()->flag.te01) {
    if(!TheSet.te01.use) { TheSet.te01.use= 1; flag1= 1; };
  }
  else  { TheSet.te01.use= 0; flag1= 1; };
  
  if(moduleCore()->plugin()->flag.keithley) {
    if(!TheSet.keithley.use) { TheSet.keithley.use= 1; flag2= 1; };
  }
  else  { TheSet.keithley.use= 0; flag2= 1; };  
  
  if(flag1 || flag2) {
     EnaDisVsHW();
	 if(flag1) mb_init_te01(-1, -1, NULL, -1);
     if(flag2) mb_init_keithley(-1, -1, NULL, -1);			  
  };

  
  // MessagePopup("", moduleCore()->plugin()->descr);
     SetMenuBarAttribute (Bar, BM(unselect), ATTR_CHECKED, 0);
     
	 GetMenuBarAttribute (Bar, B(module), ATTR_FIRST_ITEM_ID, &p);
     SetMenuBarAttribute (Bar, p, ATTR_CHECKED, 0);
     while(1) {
		GetMenuBarAttribute (Bar, p, ATTR_NEXT_ITEM_ID, &p);
		if(p == BM(unselect)) break;
		GetMenuBarAttribute (Bar, p, ATTR_IS_SEPARATOR, &j);
		if(!j) SetMenuBarAttribute (Bar, p, ATTR_CHECKED, 0);
     };
     
     SetMenuBarAttribute (Bar, BM(unselect), ATTR_DIMMED, 1);
     SetMenuBarAttribute (Bar, menuItemID, ATTR_CHECKED, 1);
     
     EnaDisVsModule();  
     
     
     if(__PrevModuleName[0] == 0 || 
          strcmp(moduleName, __PrevModuleName) ||
        __PrevPlugPath[0] == 0 ||
          strcmp(plugPath, __PrevPlugPath)) {
          
             core_fillLocalTFUseFlags();
     };
        
     strcpy(__PrevModuleName, moduleName);
     strcpy(__PrevPlugPath, plugPath);   
     
     
};

int CVICALLBACK cancelplug_func (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
			flagSelectPlugin= -1;
			break;
	}
	return 0;
}

int CVICALLBACK selplug_func (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
	switch (event) {
		case EVENT_COMMIT:
		case EVENT_LEFT_DOUBLE_CLICK:
			flagSelectPlugin= 1;
			break;
	}
	return 0;
}

// ---------------------------------------------------------------------
static int PlugCfgPnl;
void bringUpPCfgPanel(void) {
     TFuncDefine *tfd; 
	 int ind= 0;
	 char tmp[FNAMELEN+1];
	 
	 PlugCfgPnl= LoadPanel(0, "coreuir.uir", PCFGPNL);
     if(moduleCore()->plugin()->tcfg_pnl == NULL) 
        SetCtrlAttribute (PlugCfgPnl, PCFGPNL_more, ATTR_DIMMED, 1);	 	 
        
     tfd= moduleCore()->f(0);
     while(tfd->name!= NULL) {
      sprintf(tmp, "%s%s", tfd->set.passport ? "\033fg0000FF": "", tfd->descr);
      InsertListItem (PlugCfgPnl, PCFGPNL_list, -1, tmp, tfd->name);
      CheckListItem (PlugCfgPnl, PCFGPNL_list, ind, /*tfd->set.use*/ core_isUseTF(ind));
   
      tfd++;
      ind++;
     };
  
	 InstallPopup(PlugCfgPnl);
};

static void applyPlugCfgPnlChanges(void) {
  int n, j;
  int usemask[256];

  GetNumListItems (PlugCfgPnl, PCFGPNL_list, &n);
  for(j= 0; j<256; j++) usemask[j]= 0;
  for(j= 0; j<n; j++) IsListItemChecked (PlugCfgPnl, PCFGPNL_list, j, &usemask[j]);
  core_updateLocalTFUseFlags(n, usemask);  
};

int CVICALLBACK pcfgf_tcfgdone (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {

	switch (event) {
		case EVENT_COMMIT:
            applyPlugCfgPnlChanges();
			DiscardPanel(PlugCfgPnl);
			break;
	}
	return 0;
}

int CVICALLBACK pcfgf_passport (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, n;
	switch (event) {
		case EVENT_COMMIT:
			GetNumListItems (PlugCfgPnl, PCFGPNL_list, &n);	
			for(j= 0; j< n; j++)  
			  CheckListItem (PlugCfgPnl, PCFGPNL_list, j, moduleCore()->f(j)->set.passport ? 1:0);
			  
			applyPlugCfgPnlChanges();  
			break;
	}
	return 0;
}

int CVICALLBACK pcfgf_more (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
TCONTEXT tc;		
	switch (event) {
		case EVENT_COMMIT:
            fillTContext(&tc, NULL, currentModule_Descr, getTE01Handle());
	        moduleCore()->plugin()->tcfg_pnl(&tc, NULL);		
			break;
	}
	return 0;
}

int CVICALLBACK pcfgf_default (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int j, n;
	switch (event) {
		case EVENT_COMMIT:
			GetNumListItems (PlugCfgPnl, PCFGPNL_list, &n);	
			for(j= 0; j< n; j++)  
			  CheckListItem (PlugCfgPnl, PCFGPNL_list, j, moduleCore()->f(j)->set.use ? 1:0);
            applyPlugCfgPnlChanges();
			break;
	}
	return 0;
}



// ***********************************************************************************
static int CfgPortPnl;
static void settingPorts(void) {
 CfgPortPnl= LoadPanel(0, "coreuir.uir", CFG);
 SetCtrlVal(CfgPortPnl, CFG_te01, TheSet.te01.port);
 SetCtrlVal(CfgPortPnl, CFG_keithley, TheSet.keithley.port);
 SetCtrlVal(CfgPortPnl, CFG_lpt, TheSet.burn.port); 
 
 SetCtrlVal(CfgPortPnl, CFG_usete01, TheSet.te01.use);
 SetCtrlVal(CfgPortPnl, CFG_usekeithley, TheSet.keithley.use);
 //SetCtrlVal(CfgPortPnl, CFG_uselpt, TheSet.burn.use); 
 
 SetCtrlAttribute(CfgPortPnl, CFG_te01, ATTR_DIMMED, !TheSet.te01.use);
 SetCtrlAttribute(CfgPortPnl, CFG_keithley, ATTR_DIMMED, !TheSet.keithley.use); 
 InstallPopup(CfgPortPnl);
};

int CVICALLBACK cfghw_changeport (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int port_te01, port_keithley, use1, use2;
	switch (event) {
		case EVENT_COMMIT:
		    GetCtrlVal(CfgPortPnl, CFG_te01, &port_te01);
		    GetCtrlVal(CfgPortPnl, CFG_keithley, &port_keithley);
		    
		    GetCtrlVal(CfgPortPnl, CFG_usekeithley, &use1);
		    GetCtrlVal(CfgPortPnl, CFG_usete01, &use2);
		    
		    if( (port_te01 == port_keithley) && use1 && use2 ) {
		       MessagePopup(MSG_WARNING, "There is a conflict with port assignment!");
		    };
			break;
	}
	return 0;
}

int CVICALLBACK cfghw_done (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int port_te01, port_keithley, use1, use2;
int f_te01= 0, f_keithley= 0;
	switch (event) {
		case EVENT_COMMIT:
		    GetCtrlVal(CfgPortPnl, CFG_te01, &port_te01);
		    GetCtrlVal(CfgPortPnl, CFG_keithley, &port_keithley);
		    GetCtrlVal(CfgPortPnl, CFG_usekeithley, &use1);
		    GetCtrlVal(CfgPortPnl, CFG_usete01, &use2);
		    
		    if( (port_te01 == port_keithley) && use1 && use2 ) {
		       MessagePopup(MSG_WARNING, "There is a conflict with port assignment!\n\nPlease, remove the conflict!");
		       break;
		    };		    
		    
		    if( (TheSet.te01.port != port_te01) ||
		        (use2!= TheSet.te01.use)) f_te01= 1;
		        
		    if( (TheSet.keithley.port != port_keithley) ||
		        (use1!= TheSet.keithley.use)) f_keithley= 1;		        
		        
            GetCtrlVal(CfgPortPnl, CFG_te01, &TheSet.te01.port);
            GetCtrlVal(CfgPortPnl, CFG_keithley, &TheSet.keithley.port);
            GetCtrlVal(CfgPortPnl, CFG_lpt, &TheSet.burn.port); 
            
            GetCtrlVal(CfgPortPnl, CFG_usete01, &TheSet.te01.use);
            GetCtrlVal(CfgPortPnl, CFG_usekeithley, &TheSet.keithley.use);            
            
            EnaDisVsHW();
            
			DiscardPanel(CfgPortPnl);
			
			if(f_te01) mb_init_te01(-1, -1, NULL, -1);
			if(f_keithley) mb_init_keithley(-1, -1, NULL, -1);			

			break;
	}
	return 0;
}

int CVICALLBACK cfghw_usete01 (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int use, j;
	switch (event) {
		case EVENT_COMMIT:
            GetMenuBarAttribute (Bar, BM(unselect), ATTR_DIMMED, &j);  // j == 1 --> some module active
            GetCtrlVal(CfgPortPnl, CFG_usete01, &use);
            if(j) {
               if(moduleCore()->plugin()->flag.te01 && !use) {
                  MessagePopup(MSG_WARNING, "Current module's plugin needs TE-01, operation aborted");
                  SetCtrlVal(CfgPortPnl, CFG_usete01, 1);
                  break;
               };
            };
		    
		    SetCtrlAttribute(CfgPortPnl, CFG_te01, ATTR_DIMMED, !use);
		  	break;
	}
	return 0;
}

int CVICALLBACK cfghw_usekeithley (int panel, int control, int event,
		void *callbackData, int eventData1, int eventData2) {
int use, j;
	switch (event) {
		case EVENT_COMMIT:
		    GetCtrlVal(CfgPortPnl, CFG_usekeithley, &use);
            GetMenuBarAttribute (Bar, BM(unselect), ATTR_DIMMED, &j);  // j == 1 --> some module active
            if(j) {
               if(moduleCore()->plugin()->flag.keithley && !use) {
                  MessagePopup(MSG_WARNING, "Current module's plugin needs Keithley, operation aborted");
                  SetCtrlVal(CfgPortPnl, CFG_usekeithley, 1);
                  break;
               };
            };		    
		    SetCtrlAttribute(CfgPortPnl, CFG_keithley, ATTR_DIMMED, !use);
		  	break;
	}
	return 0;
}

static void EnaDisVsHW(void) {
  int j;
  
  SetCtrlAttribute(Pnl, P(ledte01), ATTR_DIMMED, !TheSet.te01.use);
  SetCtrlAttribute(Pnl, P(ledkeithley), ATTR_DIMMED, !TheSet.keithley.use);
  
  if(!TheSet.te01.use) SetCtrlVal(Pnl, P(ledte01), 0);
  if(!TheSet.keithley.use) SetCtrlVal(Pnl, P(ledkeithley), 0);
  
  SetMenuBarAttribute (Bar, BS(more_te01), ATTR_DIMMED, !TheSet.te01.use);
  SetMenuBarAttribute (Bar, BS(more_keithley), ATTR_DIMMED, !TheSet.keithley.use);
  
  //SetMenuBarAttribute (Bar, BT(te01), ATTR_DIMMED, !TheSet.te01.use);
  //SetMenuBarAttribute (Bar, BT(keithley), ATTR_DIMMED, !TheSet.keithley.use);    
  
  SetMenuBarAttribute (Bar, BT(te01ext), ATTR_DIMMED, 0);
  GetMenuBarAttribute (Bar, BM(unselect), ATTR_DIMMED, &j);  // j == 1 --> some module active
  if(j) {
     if(moduleCore()->plugin()->te01ext_pnl == NULL ||
        !TheSet.te01.use) SetMenuBarAttribute (Bar, BT(te01ext), ATTR_DIMMED, 1);  
  }
  else {
     SetMenuBarAttribute (Bar, BT(te01ext), ATTR_DIMMED, 1);
  };
  
};

// ----------------------------------------------------------------------------
static void CVICALLBACK ServiceFunction ( int menuBarHandle,
         int menuItemID, void *callbackData, int panelHandle ) {
 char tmp[FNAMELEN+1];

 GetMenuBarAttribute (Bar, menuItemID, ATTR_ITEM_NAME, tmp);
 //MessagePopup(MSG_WARNING, tmp);
 // servprocShowDescription(tmp);

 ServiceLauncher(Pnl, tmp, moduleCore()->plugin(), currentModule_Descr);         

};

void EnaDisBarMenuVsStart(int ena) {
  SetMenuBarAttribute (Bar, B(system), ATTR_DIMMED, !ena);
  SetMenuBarAttribute (Bar, B(module), ATTR_DIMMED, !ena);
  SetMenuBarAttribute (Bar, B(plugin), ATTR_DIMMED, !ena);
  SetMenuBarAttribute (Bar, B(set), ATTR_DIMMED, !ena);
};

