#include "channel.h"
#include <algorithm>
#include "ltr\\include\\ltrapi.h"
//---------------------------------------------------------------------------
//                        tchannel constructor
//---------------------------------------------------------------------------
TChannel::TChannel(void)
{
	socket=INVALID_SOCKET;
	memset(&wsaovr, 0, sizeof(wsaovr));
	memset(&wsaovw, 0, sizeof(wsaovw));
	wsaovr.hEvent=WSA_INVALID_EVENT;
	wsaovw.hEvent=WSA_INVALID_EVENT;
    ReadSocketInUse=false;
    WriteSocketInUse=false;
}
//---------------------------------------------------------------------------
//                       tchannel destructor
//---------------------------------------------------------------------------
TChannel::~TChannel(void)
{
	Close();
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
BOOL TChannel::Close(void)
{
    LastError=CHANNEL_ERROR_ASYNC_TRANSFER;
	if(socket!=INVALID_SOCKET)
	{
		DWORD flag=0;
		DWORD flgs=0;
		DWORD sz=0;
		if(!WSAGetOverlappedResult(socket, &wsaovr, &sz, FALSE, &flag)||
			!WSAGetOverlappedResult(socket, &wsaovw, &sz, FALSE, &flgs))
		{
			CancelIo((HANDLE)socket);
		}
		shutdown(socket, SD_BOTH);
		closesocket(socket);
		socket=INVALID_SOCKET;
	}

	if(wsaovr.hEvent!=WSA_INVALID_EVENT)
	{
		WSACloseEvent(wsaovr.hEvent);
		wsaovr.hEvent=WSA_INVALID_EVENT;
	}
	if(wsaovw.hEvent!=WSA_INVALID_EVENT)
	{
		WSACloseEvent(wsaovw.hEvent);
		wsaovw.hEvent=WSA_INVALID_EVENT;
	}

    ReadSocketInUse=false;
    WriteSocketInUse=false;

	return TRUE;
}
//---------------------------------------------------------------------------
//
//---------------------------------------------------------------------------
BOOL TChannel::Open(DWORD addr, WORD port)
{
	Close();
	LastError=0;
    ReadSocketInUse=false;
    WriteSocketInUse=false;

	socket=WSASocket(AF_INET, SOCK_STREAM,IPPROTO_IP, NULL, 0, WSA_FLAG_OVERLAPPED);
	if(socket!=INVALID_SOCKET)
	{
		sockaddr_in peer;
		peer.sin_family=AF_INET;
		peer.sin_port=htons(port);
		peer.sin_addr.S_un.S_addr=htonl(addr);
		int res=SOCKET_ERROR;
		DWORD endtime=GetTickCount()+3000;
		while (res==SOCKET_ERROR&&GetTickCount()<endtime)
		{
			if ((res=WSAConnect(socket, (sockaddr*)&peer, sizeof(peer), NULL, NULL, NULL, NULL))==SOCKET_ERROR)
			{
				int Value=WSAGetLastError();
				if (!(Value==WSAETIMEDOUT||Value==WSAENETUNREACH||Value==WSAECONNREFUSED)) break;
				Sleep(2);
			}
		}

		if(res!=SOCKET_ERROR)
		{
			wsaovr.hEvent=WSACreateEvent();
			wsaovw.hEvent=WSACreateEvent();

			if(wsaovr.hEvent!=WSA_INVALID_EVENT &&
				wsaovw.hEvent!=WSA_INVALID_EVENT)
			{
				//
			} else Close();
		} else Close();
	}
	return socket!=INVALID_SOCKET ? TRUE : FALSE;
}
//---------------------------------------------------------------------------
//     
//---------------------------------------------------------------------------
INT TChannel::Recv(BYTE *buf, DWORD size, DWORD timeout)
{
	if (socket==INVALID_SOCKET)
	{
		Sleep(1); //       
		LastError=CHANNEL_ERROR_ASYNC_TRANSFER;
		return -1;
	}
    while (ReadSocketInUse)Sleep(5);
    ReadSocketInUse=true;
        
	DWORD SizeRecieved=0;
	LastError=0;

	DWORD tend=GetTickCount()+timeout;
	while(size&&GetTickCount()<tend)
	{
		wsabufr.len=size;
		wsabufr.buf=buf;

		DWORD sz=0;

		DWORD flag1=0;
		int res= WSARecv(socket, &wsabufr, 1, &sz, &flag1, &wsaovr, NULL);
		if(res==SOCKET_ERROR)
		{
			if (WSAGetLastError()==WSA_IO_PENDING)
			{
				DWORD flag=0;
				if(WSAWaitForMultipleEvents(1, &wsaovr.hEvent, TRUE, timeout, FALSE)==WSA_WAIT_EVENT_0)
				{
					if (!WSAGetOverlappedResult(socket, &wsaovr, &sz, FALSE, &flag))
					{
						Close();
						break;
					}
				}
				else
				{
					CancelIo((HANDLE)socket);
					WSAGetOverlappedResult(socket, &wsaovr, &sz, FALSE, &flag);
				}
			}
			else
			{
				Close();
				break;
			}
		}
		else if (res==0&&sz==0)
		{
			Close();
			break;
		}
        size-=sz;
		SizeRecieved+=sz;
        buf+=sz;
	}
    
    ReadSocketInUse=false;
	return SizeRecieved;
}
//---------------------------------------------------------------------------
INT TChannel::Send(BYTE *buf, DWORD size, DWORD timeout)
{
	if (socket==INVALID_SOCKET)
	{
		Sleep(1); //       
		LastError=CHANNEL_ERROR_ASYNC_TRANSFER;
		return -1;
	};

    while (WriteSocketInUse)Sleep(5);
    WriteSocketInUse=true;

	DWORD sz=0;
	LastError=0;

	wsabufw.len=size;
	wsabufw.buf=buf;

	int res=WSASend(socket, &wsabufw, 1, &sz, 0, &wsaovw, NULL);
	if(res==SOCKET_ERROR)
	{
		if (WSAGetLastError()==WSA_IO_PENDING)
		{
			DWORD flgs=0;
			if(WSAWaitForMultipleEvents(1, &wsaovw.hEvent, FALSE, timeout, FALSE)==WSA_WAIT_EVENT_0)
			{
				if (!WSAGetOverlappedResult(socket, &wsaovw, &sz, FALSE, &flgs))
				{
					Close();
				}
			}
			else
			{
				CancelIo((HANDLE)socket);
				WSAGetOverlappedResult(socket, &wsaovw, &sz, FALSE, &flgs);
			}
		}
		else
		{
			Close();
		}
	}
	else if (res==0&&sz==0)
	{
		Close();
	};
    
    WriteSocketInUse=false;
	return sz;
}

