//---------------------------------------------------------------------------

#include <windows.h>
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------
#define SEND_RECIEVE_TIMEOUT 5000

#include <algorithm>
#include "ltr\\include\\ltravrapi.h"
#include "ltr\\include\\ltr010api.h"
LPCSTR ErrorStrings[]={
 "      .",
 "     avr.",
 "       .",
 "      .",
 "  flash  avr.",
 "  flash  avr.",
 "  flash  avr.",
 "  fuse  avr.",
 "  fuse  avr.",
 "   avr."
};
//-----------------------------------------------------------------------------
//                  
//-----------------------------------------------------------------------------
INT LTRAVR_Exchange(TLTRAVR *module, WORD *xbuf, DWORD xsize)
{
 INT res=LTR_IsOpened(&module->ltr);
 if(res==LTR_OK)
 {
    DWORD ssz, rsz;
    DWORD *buf=new DWORD[16*1024];
    //   " "
    buf[0]=LTR010CMD_PROGR|(0xAC53<<16);
    buf[1]=LTR010CMD_PROGR|(0x0000<<16);
    //    
    if(LTR_Send(&module->ltr, buf, 2, SEND_RECIEVE_TIMEOUT)==2)
    {
        if((module->low_speed_flag==FALSE  &&
            LTR_Recv(&module->ltr, buf, NULL, 2, SEND_RECIEVE_TIMEOUT)==2 && (buf[1]>>16)==0x5300) ||
           (module->low_speed_flag==TRUE && (Sleep(100), 1)))
        {
            //    
            for(DWORD i=0; i<xsize; i++) buf[i]=LTR010CMD_PROGR|(xbuf[i]<<16);
            //    
            if(LTR_Send(&module->ltr, buf, xsize, SEND_RECIEVE_TIMEOUT)==(int)xsize)
            {
                if(module->low_speed_flag==FALSE)
                {
                    if(LTR_Recv(&module->ltr, buf, NULL, xsize, SEND_RECIEVE_TIMEOUT)==(int)xsize)
                    {
                        //   
                        for(DWORD i=0; i<xsize; i++) xbuf[i]=buf[i]>>16;
                    } else res=LTRAVR_ERROR_RECV_PRG_DATA_ECHO;
                } else Sleep(100);
            } else res=LTRAVR_ERROR_SEND_PRG_DATA;
        } else res=LTRAVR_ERROR_RECV_PRG_ENABLE_ACK;
    } else res=LTRAVR_ERROR_SEND_PRG_ENB_CMD;
    //
    delete[] buf;
 }
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI __export LTRAVR_Init(TLTRAVR *module)
{
 INT res;
 if(module!=NULL)
 {
    module->low_speed_flag=FALSE;
    res=LTR_Init(&module->ltr);
 } else res=LTR_ERROR_PARAMETRS;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI __export LTRAVR_Open(TLTRAVR *module, DWORD saddr, WORD sport, CHAR *csn, WORD cc)
{
 INT res;
 if(module!=NULL && csn!=NULL)
 {
    res=LTRAVR_Close(module);
    if(res==LTR_OK)
    {
        module->ltr.saddr=saddr;
        module->ltr.sport=sport;
        memcpy(module->ltr.csn, csn, SERIAL_NUMBER_SIZE);
        module->ltr.cc=cc;
        res=LTR_Open(&module->ltr);
        if (res==LTR_OK||res==LTR_WARNING_MODULE_IN_USE)
        {
            DWORD sbuf[] = {LTR010CMD_STOP, LTR010CMD_RESET};
            LTR_Send(&module->ltr,sbuf,2,1000);
            while (LTR_Recv(&module->ltr,sbuf,NULL,1,100)>0)Sleep(10);
            Sleep(100);
        }
    }
 }
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI __export LTRAVR_Close(TLTRAVR *module)
{
    Sleep(200);
    DWORD sbuf[] = {LTR010CMD_STOP,LTR010CMD_RESET,LTR010CMD_STOP};
    LTR_Send(&module->ltr,sbuf,3,1000);
    while (LTR_Recv(&module->ltr,sbuf,NULL,1,100)>0)Sleep(10);
    Sleep(200);
    return LTR_Close(&module->ltr);
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_ChipErase(TLTRAVR *module)
{
 WORD xbuf[2]={0xAC80, 0xAC80};
 INT res=LTRAVR_Exchange(module, xbuf, 2);
 if(res!=LTR_OK) res=LTRAVR_ERROR_CHIP_ERASE;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_ReadProgrammMemory(TLTRAVR *module, WORD *buf, DWORD size, DWORD addr)
{
 WORD *xbuf=new WORD[4*ATMEGA8515_FLASH_SIZE];
 size=std::min<int>(size, ATMEGA8515_FLASH_SIZE);
 addr=std::min<int>(addr, ATMEGA8515_FLASH_SIZE-size);
 for(DWORD i=0; i<size; i++) {
    xbuf[4*i+0]=0x2000|(addr>>8);
    xbuf[4*i+1]=(addr<<8);
    xbuf[4*i+2]=0x2800|(addr>>8);
    xbuf[4*i+3]=(addr<<8);
    addr++;
 }
 INT res=LTRAVR_Exchange(module, xbuf, 4*size);
 if(res==LTR_OK) {
    for(DWORD i=0; i<size; i++)
        buf[i]=(xbuf[4*i+1]&0xFF)|(xbuf[4*i+3]<<8);
 } else res=LTRAVR_ERROR_READ_PRG_MEM;
 delete[] xbuf;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_WriteProgrammMemory(TLTRAVR *module, WORD *buf, DWORD size, DWORD addr)
{
 INT res;
 WORD *xbuf=new WORD[4*ATMEGA8515_PAGE_SIZE+2];
 size=std::min<int>(size, ATMEGA8515_FLASH_SIZE);
 addr=std::min<int>(addr, ATMEGA8515_FLASH_SIZE-size);
 do
 {
    WORD sz=std::min(size, ATMEGA8515_PAGE_SIZE-(addr&(ATMEGA8515_PAGE_SIZE-1)));
    for(int i=0; i<sz; i++)
    {
        WORD _addr=(addr+i)&(ATMEGA8515_PAGE_SIZE-1);
        WORD _data=buf[i];
        xbuf[4*i+0]=0x4000;
        xbuf[4*i+1]=(_addr<<8)|((_data>>0)&0xFF);
        xbuf[4*i+2]=0x4800;
        xbuf[4*i+3]=(_addr<<8)|((_data>>8)&0xFF);
    }
    xbuf[4*sz+0]=0x4C00|(addr>>8);
    xbuf[4*sz+1]=((addr&0xE0)<<8);
    res=LTRAVR_Exchange(module, xbuf, 4*sz+2);
    if(res!=LTR_OK) res=LTRAVR_ERROR_WRITE_PRG_MEM;
    buf+=sz;
    addr+=sz;
    size-=sz;
 } while(size && res==LTR_OK);
 delete[] xbuf;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_ReadFuseBits(TLTRAVR *module, BYTE *buf)
{
 WORD xbuf[4]={0x5000, 0x0000, 0x5808, 0x0000};
 INT res=LTRAVR_Exchange(module, xbuf, 4);
 if(res==LTR_OK)
 {
    for(int i=0; i<2; i++) buf[i]=xbuf[2*i+1];
 } else res=LTRAVR_ERROR_READ_FUSE_BITS;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_WriteFuseBits(TLTRAVR *module, BYTE *buf)
{
DWORD sbuf[] = {LTR010CMD_STOP, LTR010CMD_RESET};
LTR_Send(&module->ltr,sbuf,2,1000);
while (LTR_Recv(&module->ltr,sbuf,NULL,1,100)>0)Sleep(10);
Sleep(100);

 WORD xbuf[4]={0xACA0, buf[0], 0xACA8, buf[1]};
 INT res=LTRAVR_Exchange(module, xbuf+0, 2);
 if(res==LTR_OK)
 {
    res=LTRAVR_Exchange(module, xbuf+2, 2);
    if(res!=LTR_OK) res=LTRAVR_ERROR_WRITE_FUSE_BITS;
 } else res=LTRAVR_ERROR_WRITE_FUSE_BITS;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_ReadSignature(TLTRAVR *module, BYTE *buf)
{
 WORD xbuf[8]={0x3000, 0x0000, 0x3000, 0x0100, 0x3000, 0x0200, 0x3000, 0x0300};
 INT res=LTRAVR_Exchange(module, xbuf, 8);
 if(res==LTR_OK)
 {
    for(int i=0; i<4; i++) buf[i]=xbuf[2*i+1];
 } else res=LTRAVR_ERROR_READ_SIGN;
 return res;
}
//-----------------------------------------------------------------------------
INT WINAPI LTRAVR_SetSpeedFlag(TLTRAVR *module, BOOL sflag)
{
 INT res;
 if(module!=NULL && (res=LTR_IsOpened(&module->ltr))==LTR_OK)
 {
    TLTR010 control;
    LTR010_Init(&control);
    if((res=LTR010_Open(&control, module->ltr.saddr, module->ltr.sport, module->ltr.csn))==LTR_OK)
    {
        WORD buf=0;
        res=LTR010_PutArray(&control, (BYTE*)&buf, 2, SEL_AVR_DM|0x8006);
        if(res==LTR_OK)
        {
            buf= sflag ? (1<<1) : (0<<1);
            res=LTR010_PutArray(&control, (BYTE*)&buf, 1, SEL_AVR_DM|0x8002);
            if(res==LTR_OK) module->low_speed_flag=sflag;
        }
        LTR010_Close(&control);
    }
 }
 return res;
}
//-----------------------------------------------------------------------------
LPCSTR WINAPI LTRAVR_GetErrorString(INT error)
{
 if(error>=-209 && error<=-200) return ErrorStrings[-error-200];
 else return LTR_GetErrorString(error);
}
//-----------------------------------------------------------------------------
#pragma argsused
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
 return 1;
}

