unit LTR11RECTHREAD;

interface

uses
  Classes {$IFDEF MSWINDOWS},SyncObjs ,SysUtils,StdCtrls, Windows {$ENDIF},ltrapi,ltr11api,ltr021api,ltrapidefine,ltrapitypes;

type
  LTR11THREAD = class(TThread)
  private
    procedure SetName;
  protected
    procedure Execute; override;
  end;

var
  LTR:TLTR;
  LTR11:TLTR11;
  LTR021:TLTR021;
  NEED_RESET_RESULT:integer;

  LTR_CRATES:array[0..CRATE_MAX-1]of SERNUMtext;
  NOM_OF_CRATES:integer;
  SELECTED_CRATE:integer;
  LTRONLINE:integer;

  LTR11ALL:array[0..MODULE_MAX-1]of integer;
  LTR11COUNT:integer;
  LTR021ALL:array[0..MODULE_MAX-1]of integer;
  LTR021COUNT:integer;

  LTR11ONLINE:BOOLEAN;
  LTR021ONLINE:BOOLEAN;
  LTR11REC: BOOLEAN;
  DO11REC:BOOLEAN;
  SLOTINUSE:byte;

  section: tcriticalsection;

  DATA_SCREEN:array[0..36]of STRING;

  MYTHREAD:LTR11THREAD;

  data:array[0..100000]of cardinal;
  Time:array[0..100000]of cardinal;
  VOLTAGE:array[0..100000]of real;
implementation
{$IFDEF MSWINDOWS}
type
  TThreadNameInfo = record
    FType: LongWord;     // must be 0x1000
    FName: PChar;        // pointer to name (in user address space)
    FThreadID: LongWord; // thread ID (-1 indicates caller thread)
    FFlags: LongWord;    // reserved for future use, must be zero
  end;
{$ENDIF}
{ LTR11THREAD }
procedure LTR11THREAD.SetName;
{$IFDEF MSWINDOWS}
var
  ThreadNameInfo: TThreadNameInfo;
{$ENDIF}
begin
{$IFDEF MSWINDOWS}
  ThreadNameInfo.FType := $1000;
  ThreadNameInfo.FName := 'LTR11THREAD';
  ThreadNameInfo.FThreadID := $FFFFFFFF;
  ThreadNameInfo.FFlags := 0;
  try
    RaiseException( $406D1388, 0, sizeof(ThreadNameInfo) div sizeof(LongWord), @ThreadNameInfo );
  except
  end;

{$ENDIF}
end;

procedure LTR11THREAD.Execute;
var
  ED:^TEdit;
  LIST:^Tlistbox;
  i,counter,counterRESULT:integer;
  DATAS,GGG:integer;
  re:real;
  SEC,START,OLDSEC,OLDSTART:integer;
  MAX,MIN,NOM:integer;
begin
  NEED_RESET_RESULT:=0;
  counterRESULT:=0;
  NOM:=5;
  MAX:=0;
  MIN:=1000000;
  DO11REC:=true;//
  SetName;
  DATAS:=round(LTR11.ChRate*250)*LTR11.LChQnt;
  //start LTR11
  LTR11_Start(@LTR11);
  while LTR11REC do
  begin
    //Receive LTR11
    DATAS:=round(LTR11.ChRate*250)*LTR11.LChQnt;
    DATAS:=LTR_Recv(@LTR11.Channel,@DATA[0],@TIME[0],DATAS,10000);
    if  DATAS<0 then
    LTR11REC:=false
    else
    begin
      for i:=0 to DATAS-1 do
      begin
        counter:=counter+1;
        START :=TIME[i] shr 16;
        SEC  := TIME[i] - START shl 16;
        if (OLDSTART<>START) or (OLDSEC<>SEC) then
        begin
          counterRESULT:=counter;
          DATA_SCREEN[34]:=inttostr(counterRESULT);
          counter:=0;
          OLDSTART:=START;
          OLDSEC:=SEC;
          if NOM>0 then NOM:=NOM-1 else
          begin
            if MAX< counterRESULT then MAX:=counterRESULT;
            if MIN> counterRESULT then MIN:=counterRESULT;
            DATA_SCREEN[35]:=intToStr(MAX);
            DATA_SCREEN[36]:=intToStr(MIN);
          end;
          if NEED_RESET_RESULT=1 then
          begin
            MAX:=0;
            MIN:=1000000;
            NEED_RESET_RESULT:=0;
          end;
        end;
      end;
      //PROCESS LTR11;
      i:=LTR11_Processdata(@LTR11,@DATA[0],@VOLTAGE[0],@DATAS,true,true);

      if i=LTR_OK then
      begin
        //COUNTERS AND DATA PACKET READER
        //WRITING REZULTS...
        section.Enter;
        for i:=0 to LTR11.LChQnt-1 do
        begin
          DATA_SCREEN[i]:=FloatToStrF(voltage[i],ffFixed,6,6);
        end;
        DATA_SCREEN[32]:=intToStr(START);
        DATA_SCREEN[33]:=intToStr(SEC);
        section.Leave;
      end else
      LTR11REC:=false;
    end;

  end;
  //STOP LTR11
  LTR11_Stop(@LTR11);
  { Place thread code here }
  DO11REC:=false;//
end;

end.
