/*     LTR114
           
     
   */


#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>

#include "ltr\\include\\ltr114api.h"
#include "ltr\\include\\ltrapi.h"



#define SLOT_NUM  CC_MODULE2
#define FRAME_CNT   10  //      LTR114_Read()
#define READ_CNT    10  //  LTR114_Read()
#define RECV_TIMEOUT  1000

static void printf_oem(char *s)
{
	/*     DOS */
	char *pstr;
	pstr = malloc((strlen(s) + 1) * sizeof(char));
	if (pstr != NULL)
	{
		CharToOem(s, pstr);
		printf(pstr);
		free(pstr);
	}
}


int main()
{
	INT res;
	TLTR114 hltr114;  //  
	char temp_str[255];
	
	//     
	res = LTR114_Init(&hltr114);
	if (res == LTR_OK)
	{
		//   ,    SLOT_NUM    
		res = LTR114_Open(&hltr114, SADDR_DEFAULT, SPORT_DEFAULT,"", SLOT_NUM);
		//   -  
		//    
		if (res == LTR_WARNING_MODULE_IN_USE)  
		{
			res = LTR_OK;
			printf(LTR114_GetErrorString(res));
		}
		if (res == LTR_OK)
		{
			//   
			res = LTR114_GetConfig(&hltr114);
			if (res == LTR_OK)
			{
				hltr114.FreqDivider = 4; //   2
				hltr114.LChQnt = 2;      //2  
				//    ,  +/- 10 
				hltr114.LChTbl[0] = LTR114_CreateLChannel(LTR114_MEASMODE_U, 0, LTR114_URANGE_10);
				//  16-,  +/- 0.4 
				hltr114.LChTbl[1] = LTR114_CreateLChannel(LTR114_MEASMODE_U, 15, LTR114_URANGE_04);
				hltr114.SyncMode = LTR114_SYNCMODE_INTERNAL; // 
				hltr114.Interval = 0;  //  

				//  
				res = LTR114_SetADC(&hltr114);
				if (res == LTR_OK)
				{
					//   
					res = LTR114_Calibrate(&hltr114);
					if (res == LTR_OK)
					{
						//-     = -  *  
						INT size = FRAME_CNT * hltr114.FrameLength;
						DWORD* recv_data;
						double* proc_data;

						//       
						recv_data = (DWORD*)malloc(size*sizeof(DWORD));  // size 
						//    LChQnt   
						proc_data = (double*)malloc(FRAME_CNT*hltr114.LChQnt*sizeof(double));  

						if ((recv_data!=NULL)&&(proc_data!=NULL))
						{
							// 
							res = LTR114_Start(&hltr114);
							if (res == LTR_OK)
							{
								INT i;
								for (i=0; i < READ_CNT; i++)
								{
									// size,        process_data
									size = FRAME_CNT * hltr114.FrameLength; 
									//   
									res = LTR114_Recv(&hltr114, recv_data, NULL, size, RECV_TIMEOUT);
									if (res == 0) //  
									{
										sprintf(temp_str, "!! READ %d. Error:   ", i);
										printf_oem(temp_str);
									}
									else if (res > 0)
									{
										// ,    ,  size
										if (res < size) 
										{
											sprintf(temp_str, "!! READ %d. Warning!    . \
															  : %d; : %d", i, res, size);
											printf_oem(temp_str);
											size = res;
										}

										res = LTR114_ProcessData(&hltr114, recv_data, proc_data, &size, 
											LTR114_CORRECTION_MODE_INIT, LTR114_PROCF_VALUE);

										if (res == LTR_OK)
										{
											INT j;
											for (j = 0; j < size; j+=hltr114.LChQnt)
											{
												sprintf(temp_str, ">> READ %d, FRAME %d, LC1_DATA = %6.4f, LC2_DATA = %6.5f \n",
													i,j/hltr114.LChQnt,proc_data[j], proc_data[j+1]);
												printf_oem(temp_str);
											}
										}
										else //    
										{
											sprintf(temp_str, "!! READ %d. Error : %s!! \n", i, LTR114_GetErrorString(res));
											printf_oem(temp_str);
										}
									}
									else //    
									{
										sprintf(temp_str, "!! READ %d. Error : %s!!", i, LTR114_GetErrorString(res));
										printf_oem(temp_str);
									}
								}
								// 
								res = LTR114_Stop(&hltr114);
							} //if Start
							//  
							free(recv_data);
							free(proc_data);
						}
						else  //if ((recv_data!=NULL)&&(proc_data!=NULL))
							printf_oem("  ");
						
					}  //if Calibrate
				} //if SetADC
			} //if GetConfig
			if (res!=LTR_OK)
				printf_oem((char*)LTR114_GetErrorString(res));
			res = LTR114_Close(&hltr114);
		}  //if Open
	}  //if Init
	if (res!=LTR_OK)
		printf_oem((char*)LTR114_GetErrorString(res));

	while (!kbhit());
}