
#pragma hdrstop

#include "C:\Program Files\L-Card\ltrlibrary\\include\\ltr212api.h"
/*    */
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <conio.h>

#define ACQ_BLOCKS_QNT (2)
#define TOTAL_BLOCKS_QNT (10)
#define POINTS_PER_CHANNEL (256)
#define CHANNELS_QNT (4)

TLTR212 hltr212;       //    
HANDLE AcqThreadHnd;   //   
CHAR ErrorString[255]; //     
CHAR MsgString[255];   //      

double voltage[ACQ_BLOCKS_QNT][CHANNELS_QNT*POINTS_PER_CHANNEL];
static volatile int RunFlag = 0; // , ,    
static volatile int BlockReady[ACQ_BLOCKS_QNT];

static DWORD WINAPI AcqThread (LPVOID param);

static DWORD WINAPI AcquireThread(LPVOID param)
{
 int i;
 int err=0;
 INT DataCntr=0;
 DWORD data[2*POINTS_PER_CHANNEL*CHANNELS_QNT];
 DWORD to; // 
 INT AcqBlockCntr=0;
 int BlockCntr=0;
 DWORD size; //   
 DWORD ExitCode;
 
    /* ,      . */
 for(i=0;i<ACQ_BLOCKS_QNT;i++)
    BlockReady[i]=0;

 err=LTR212_Start(&hltr212);
 if(err)
 {
	strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	LTR212_Stop(&hltr212);
	RunFlag=0;
   }

  size=2*POINTS_PER_CHANNEL*CHANNELS_QNT; //    
  to=LTR212_CalcTimeOut(&hltr212, POINTS_PER_CHANNEL);

  while(RunFlag) //    ...
  {
   size=2*POINTS_PER_CHANNEL*CHANNELS_QNT;

   DataCntr=LTR212_Recv(&hltr212, data, NULL, size, to);
   if(DataCntr!=size)
    {
     RunFlag=0;
     if(DataCntr>=0)
	 {
       sprintf(MsgString,"%s", "!   ,   !\n");
       CharToOem(MsgString,MsgString);
       printf("%s\n",MsgString); 
	 }
     else
       {
        err=DataCntr;
        strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	    CharToOem(ErrorString,ErrorString);
	    printf("%s",ErrorString);
       }
       break;
     } //  if(DataCntr!=size)

    
     err=LTR212_ProcessData(&hltr212, data, voltage[BlockCntr], &size, 1);
     if(err)
      {
        strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	    CharToOem(ErrorString,ErrorString);
	    printf("%s",ErrorString);
        RunFlag=0;
        break;
       }
      
	  AcqBlockCntr++;

      sprintf(MsgString," %d-  ", AcqBlockCntr);
      CharToOem(MsgString,MsgString);
      printf("%s\n",MsgString); 
      
	  /*      ,    ,
	  /   */

      BlockReady[BlockCntr]=1;
      BlockCntr++;

      if(BlockCntr>=ACQ_BLOCKS_QNT)
        BlockCntr=0;

  } //  while(RunFlag)

  RunFlag=0;
  err=LTR212_Stop(&hltr212);
  if(err)
  {
    strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
  }

  ExitThread(0);
  return 0;
}

void main()
{

DWORD AcqThreadId;
DWORD ThreadSatus;

INT TotalBlockCntr; //  ,   
INT err;            //     
INT i;              //      
DWORD data[2*5000]; /* ,    ,  
                       */
FILE       *DataFile;
const char FileName[] = "ltr212_data.bin";

int BlockCntr=0;
int BlockNumber;

/*     .        . */

sprintf(MsgString,"%s", "   \n");
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString);

 err=LTR212_Init(&hltr212);
 if(err) 
  {
	strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	LTR212_Close(&hltr212);
	Sleep(3000);
	return;
   }

//     .      -  
//      ;
//   - 0;

 err=LTR212_Open(&hltr212, SADDR_DEFAULT, SPORT_DEFAULT, "", CC_MODULE1, "c:\\ltr212.bio");
 if(err) 
  {
	if(err==LTR_WARNING_MODULE_IN_USE)
	 {
		strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	    CharToOem(ErrorString,ErrorString);
	    printf("%s",ErrorString);
	 }
	else
	{
	 strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	 CharToOem(ErrorString,ErrorString);
	 printf("%s",ErrorString);
	 Sleep(3000); 
	 return;
	}
   }

/*    .      */
sprintf(MsgString," : %s", hltr212.ModuleInfo.Name);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 


sprintf(MsgString," : %s", hltr212.ModuleInfo.BiosVersion);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 


sprintf(MsgString,"  : %s", hltr212.ModuleInfo.BiosDate);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 


sprintf(MsgString,"  : %s", hltr212.ModuleInfo.Serial);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 

 //        

hltr212.size=sizeof(TLTR212);  //  
hltr212.AcqMode=1;             // 4-   
hltr212.UseClb=0;              //     
hltr212.UseFabricClb=1;        //     . .
hltr212.LChQnt=4;              //    - 4

hltr212.REF=1;      //    5 .
hltr212.AC=0;      //    


for(i=0; i<hltr212.LChQnt; i++)
  hltr212.LChTbl[i]=LTR212_CreateLChannel(i+1,3);

//      

err=LTR212_SetADC(&hltr212);
if(err)
 if(err) 
  {
	strcpy(ErrorString, (char *) LTR212_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	LTR212_Close;
	Sleep(3000);
	return;
   }

 DataFile = fopen(FileName, "wb");
 if(DataFile==NULL)
  {
   strcpy(MsgString,"  !");
   CharToOem(MsgString,MsgString);
   printf("%s\n",MsgString); 
   LTR212_Close(&hltr212);
   Sleep(3000); 
   return;
  }

RunFlag = 1;

//    
AcqThreadHnd=CreateThread(NULL, 0, (LPTHREAD_START_ROUTINE)AcquireThread,
                        NULL, CREATE_SUSPENDED, (LPDWORD) &AcqThreadId);

if(AcqThreadHnd==NULL)
{
   strcpy(MsgString,"    !");
   CharToOem(MsgString,MsgString);
   printf("%s\n",MsgString); 
   LTR212_Close(&hltr212);
   Sleep(3000); 
   return;
}

//  
ResumeThread(AcqThreadHnd);

 strcpy(MsgString,"   !\n");
 CharToOem(MsgString,MsgString);
 printf("%s\n",MsgString); 

TotalBlockCntr  = 0;

while(RunFlag)
{
 if(BlockReady[BlockCntr]) //    
 {
   fwrite(voltage[BlockCntr], sizeof voltage[0][0],
   CHANNELS_QNT*POINTS_PER_CHANNEL, DataFile);

   TotalBlockCntr++; //  

   sprintf(MsgString,"%d- %s\n",TotalBlockCntr, "   ");
   CharToOem(MsgString,MsgString);
   printf("%s\n",MsgString); 

   BlockReady[BlockCntr]=0;
   BlockCntr++;

   if(BlockCntr>=2)
    BlockCntr=0;

    if (TotalBlockCntr >= TOTAL_BLOCKS_QNT)
    {
     strcpy(MsgString,">>    .\n");
     CharToOem(MsgString,MsgString);
     printf("%s\n",MsgString); 

     RunFlag = 0;
     }
    } //  if(BlockReady[BlockCntr]...)
  }    //  while(RunFlag)

//  
  WaitForSingleObject(AcqThreadHnd, INFINITE);
  GetExitCodeThread(AcqThreadHnd, &ThreadSatus);

  CloseHandle(AcqThreadHnd);

   strcpy(MsgString,"   .\n");
   CharToOem(MsgString,MsgString);
   printf("%s\n",MsgString); 

   fclose(DataFile);
   strcpy(MsgString,"    .\n");
   CharToOem(MsgString,MsgString);
   printf("%s\n",MsgString); 


   strcpy(MsgString,">>     \n");
   CharToOem(MsgString,MsgString);
   printf("%s\n",MsgString); 
    while(!kbhit())
        continue;
	return;
}

