#include "stdafx.h"
#include "ltr\\include\\ltr212api.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>




#ifdef _MANAGED
#pragma managed(push, off)
#endif

BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{
	return TRUE;
}



/*    DSP */

#define RESET_CODECS        (0x80C1)  //     
#define SEL_CODEC           (0x80C2)  //   ()
#define WRITE_8REG          (0x80C3)	//   8-  		
#define READ_8REG			(0x80C4)  //   8-  
#define WRITE_16REG         (0x80C5)  //   16-  
#define READ_16REG			(0x80C6)  //   16-  
#define WRITE_24REG			(0x80C7)  //   24-    
#define READ_24REG			(0x80C8)  //   24-  
#define START_ACQ           (0x80C9)  //   
#define CALIBR_4CH          (0x80CA)  //   4- 
#define WR_FLASH            (0x80CB)  //   
#define RD_FLASH            (0x80CC)  //   
#define LOAD_CHANNEL        (0x80CD)  //    
#define SET_REF             (0x80CE)  //   
#define LOAD_FIR            (0x80CF)  //   -
#define LOAD_IIR            (0x80D0)  //   - 
#define ENA_DIS_FILTERS     (0x80D1)  //      
#define TEST_BIOS           (0x80D2)  //   
#define LOAD_DAC            (0x80D3)  //    
#define CALIBR_8CH          (0x80D4)  //   8- 
#define TEST_INTERFACE      (0x80D5)  //    
#define WRITE_SN_CHECK      (0x80D6)  //         
#define GET_SW_VER			(0x80D7)  //   
#define GET_SW_DATE			(0x80D8)  //    
#define CHECK_CH_MODE       (0x80D7)  //   
#define PARITY_ERR			(0x80DB)  //              
#define COMAND_SEQUENCE_ERR (0x80DC)
#define COMMAND_FOR_IF_TEST	(0x80DD)  //      
#define FIRST_INSTR         (0x80DE)  //     
#define STOP_ACQ            (0x80DF)  //   


//   :

#define COMM_REG_RD         (0x10)    //  ,   
#define COMM_REG_WR         (0x0 )    //  ,  

#define STATUS_REG          (0x0)
#define DATA_REG            (0x1)
#define MODE_REG            (0x2)
#define FILTER_REG          (0x3)
#define DAC_REG             (0x4)
#define OFFSET_REG          (0x5)
#define GAIN_REG            (0x6)
#define TEST_REG            (0x7)

#define MAX_PHYSCH_NUM      (8) // . -    
#define MAX_SLOT_NUM	    (16)  // .  
#define LTR212_MAX_LChQnt   (8)  // .  . 


/*******************************************************************************

  ,    

*******************************************************************************/


static double eval_LChRate(INT divider, INT Is_CHOP_Ena, INT Delay);
static INT LTR212_LoadFIRFilter(PTLTR212 hnd, SHORT *koeff); 
static INT LTR212_LoadIIRFilter(PTLTR212 hnd, SHORT *koeff);
static WORD UpdateCRC16(WORD *crc, BYTE b); 
static DWORD CalkTickInterval(DWORD PrevTick, DWORD ActTick);       


//    
INT LTR212_CalibrStages(PTLTR212 hnd, BYTE *LChannel_Mask, INT mode, INT reset);
INT LTR212_ResetAll_AD7730(PTLTR212 hnd);
INT LTR212_Write_8bitReg(PTLTR212 hnd, INT RegCode, BYTE value); 
INT LTR212_Read_8bitReg(PTLTR212 hnd, INT RegCode, BYTE *value); 
INT LTR212_Write_16bitReg(PTLTR212 hnd, INT RegCode, WORD value); 
INT LTR212_Read_16bitReg(PTLTR212 hnd, INT RegCode, WORD *value);   
INT LTR212_Write_24bitReg(PTLTR212 hnd, INT RegCode, DWORD value); 
INT LTR212_Read_24bitReg(PTLTR212 hnd, INT RegCode, DWORD *value);
INT LTR212_SelectCodec(PTLTR212 hnd, INT CodecNum);
INT LTR212_TestBios(PTLTR212 hnd, WORD *CRC_Rcv); 
INT LTR212_EvaluateDACValue(PTLTR212 hnd, BYTE *LChannel_Mask, BYTE *DAC_Val);
INT LTR212_LoadDACBuffer(PTLTR212 hnd);
INT LTR212_EvaluateFlashCRC(PTLTR212 hnd, WORD *Flash_CRC);
INT LTR212_WriteFlashCRC(PTLTR212 hnd, WORD Flash_CRC);
INT LTR212_EvalIntlOffsetVal(INT *Offset_Val);  
INT LTR212_EvalIntlGainVal(INT *Gain_Val); 
INT LTR212_EvalIntlOffsetValUnipol(INT *Offset_Val, INT Range_Val);  
INT LTR212_SetADCcalibr(PTLTR212 hnd);  
INT LTR212_ReadEEPROM(PTLTR212 hnd, INT n, INT Address, BYTE *image);           
INT LTR212_WriteEEPROM(PTLTR212 hnd, INT n, INT Address, BYTE *image);
INT LTR212_ReadSerialNumber(PTLTR212 hnd, CHAR *sn);     
INT LTR212_ReadBiosVersion(PTLTR212 hnd, CHAR *version); 
INT LTR212_ReadBiosDate(PTLTR212 hnd, CHAR *date);
INT LTR212_ReadModuleName(PTLTR212 hnd, CHAR *name);


INT LTR212_LoadClbCoeffs(PTLTR212 hnd); 
INT LTR212_LoadFabricClbCoeffs(PTLTR212 hnd); 
INT LTR212_InternalCalibrProcessing(PTLTR212 hnd, BYTE *LChannel_Mask);   

INT eval_parity(DWORD cmd);
INT check_parity(DWORD cmd);  

/*
int __stdcall DllMain (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{


return 1;
}  */

int __stdcall DllEntryPoint (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	// Included for compatibility with Borland 

	return 1;
}



/***************************************************************************************************

           

***************************************************************************************************/     

LTR212API_DllExport(INT) LTR212_Init(PTLTR212 hnd)

{
	INT i;
	INT err;
	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR;

	hnd->size=sizeof(TLTR212); //  
	hnd->UseClb=0;   //    ,    
	hnd->LChQnt=4;   //    - 4.


	// eval_parity(0xB);


	//    

	for(i=0; i<8; i++) 
		hnd->LChTbl[i]=0; 

	hnd->LChTbl[0]=LTR212_CreateLChannel(1,3); 	   //   -80 /+80   4-   
	hnd->LChTbl[1]=LTR212_CreateLChannel(2,3); //////////   0  ?   ,    ?
	hnd->LChTbl[2]=LTR212_CreateLChannel(3,3);
	hnd->LChTbl[3]=LTR212_CreateLChannel(4,3);

	hnd->filter.IIR=0;  //     
	hnd->filter.FIR=0;
	hnd->filter.Decimation=1; //   1       -
	hnd->filter.TAP=0;

	hnd->AcqMode=1; //        	

	//hnd->VChRate=150.1;//      

	strcpy((CHAR *)hnd->ModuleInfo.Serial, "\0"); //    
	strcpy((CHAR *)hnd->ModuleInfo.BiosVersion, "\0"); //       
	strcpy((CHAR *)hnd->ModuleInfo.BiosDate, "\0"); //     
	strcpy((CHAR *)hnd->ModuleInfo.Name, "\0"); //        

	if(err=LTR_Init(&(hnd->Channel))==LTR_OK)		//  
		return LTR212_NO_ERR;
	else return err;

}


/***************************************************************************************

 :   

****************************************************************************************/               

LTR212API_DllExport(INT) LTR212_IsOpened(PTLTR212 hnd)
{

	INT err;
	if(hnd!=NULL)  err=LTR_IsOpened(&hnd->Channel);   
	else err=LTR_ERROR_PARAMETRS;
	return err;

}  

/******************************************************************************************

         DSP 

*******************************************************************************************/

LTR212API_DllExport(INT) LTR212_Open(PTLTR212 hnd, DWORD net_addr, WORD net_port, CHAR *crate_sn, INT slot_num, CHAR *biosname)
{

	//#define LTR010CMD_NOP   0x8060  
	DWORD cmd_progr; //      PROGR
	BYTE h_byte; //  
	BYTE l_byte; //  
	INT i, j; // 
	INT read_cntr;
	INT tick;
	FILE *BiosFile;  //     
	DWORD DM_Size, PM_Size;  // ,   DM  PM  
	DWORD LoadCommand[48],DM_LoadCommand[4096], PM_LoadCommand[6144]; //  PROGR    DSP
	//,      .
	BYTE PM_ord[24576]; //  
	DWORD command[2], stop[1], rbuf[1024], Dummy_command[1]; //       /  
	const INT max_slot_num = 16;   //   


	BYTE byte_for_CRC; //     
	WORD CRC_From_CC;


	INT err=0;
	INT warning=0;

	//  ,          *.bio

	struct {

		CHAR  signature[14+1];             // bio signature
		CHAR  reserved0[4];
		WORD ver;                       // file version
		WORD subver;                    // file sub-version
		CHAR  reserved1[12];

		WORD dsptype;                   // target dsp type
		WORD exetype;                   // exe type
		CHAR  reserved2[12];
		DWORD   DOff;                      // DM offset in file
		DWORD   DSize;                     // DM size (bytes)
		CHAR  reserved3[8];
		DWORD   POff;                      // PM offset in file
		DWORD   PSize;                     // PM size (bytes)
		CHAR  reserved4[8];
		DWORD   LOff;                      // Loader offset in file
		DWORD   LSize;                     // Loader size (bytes)
		CHAR  reserved5[8];
		DWORD   SOff;
		DWORD   SSize;
		CHAR  reserved6[6+(9*16)];
		BYTE  PM[32768];
		BYTE  DM[32768];
		BYTE  L32[4*32];
		BYTE  Smart[4096];               
	} bios_info;

	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 


	memset(PM_ord, 0, sizeof(PM_ord));  
	memset(DM_LoadCommand, 0, sizeof(DM_LoadCommand));
	memset(PM_LoadCommand, 0, sizeof(PM_LoadCommand)); 
	memset(LoadCommand, 0, sizeof(LoadCommand)); 


	//    
	BiosFile=fopen(biosname, "rb");
	if(BiosFile == NULL) 
		return LTR212_ERR_WRONG_BIOS_FILE;


	fread(bios_info.signature, 1, 14, BiosFile);
	bios_info.signature[14]= 0x0;
	if(strcmp ("SAEXE@L - Card", bios_info.signature)!=0) {
		fclose(BiosFile);
		return LTR212_ERR_WRONG_BIOS_FILE;
	}  

	fread(bios_info.reserved0,1,4, BiosFile);
	fread(&bios_info.ver,1,2, BiosFile);
	fread(&bios_info.subver,1,2, BiosFile);
	fread(bios_info.reserved1,1,12, BiosFile);
	fread(&bios_info.dsptype,1,2, BiosFile);
	fread(&bios_info.exetype,1,2, BiosFile);
	fread(bios_info.reserved2,1,12, BiosFile);
	fread(&bios_info.DOff,1,4, BiosFile);
	fread(&bios_info.DSize,1,4, BiosFile);
	fread(bios_info.reserved3,1,8, BiosFile);
	fread(&bios_info.POff,1,4, BiosFile);
	fread(&bios_info.PSize,1,4, BiosFile);
	fread(bios_info.reserved4,1,8, BiosFile);
	fread(&bios_info.LOff,1,4, BiosFile);
	fread(&bios_info.LSize,1,4, BiosFile);
	fread(bios_info.reserved5,1,8, BiosFile);
	fread(&bios_info.SOff,1,4, BiosFile);
	fread(&bios_info.SSize,1,4, BiosFile);
	fread(bios_info.reserved6,1,6+(9*16), BiosFile);

	fread(bios_info.DM, 1, bios_info.DSize, BiosFile);
	fread(bios_info.PM, 1, bios_info.PSize, BiosFile);
	fread(bios_info.L32, 1, bios_info.LSize, BiosFile);  

	fclose(BiosFile);  



	// *********************** Load BIOS Loader32 *****************************

	//     - (32 )
	j=0;
	for(i=0;i<96;i=i+2)        
	{                          
		cmd_progr=0x0;                 
		h_byte=bios_info.L32[i];  //       
		l_byte=bios_info.L32[i+1];   //    

		cmd_progr=h_byte;
		cmd_progr<<=8;
		cmd_progr|=l_byte;

		cmd_progr<<=16;                
		cmd_progr=cmd_progr|LTR010CMD_PROGR; 

		LoadCommand[j]=cmd_progr;      
		j++;                     
	}                         

	j=0;  


	DM_Size=(DWORD) bios_info.DSize/2;   //     !!!!!!! ( 2 )   
	PM_Size=(DWORD) 3*bios_info.PSize/8; //     !!!!!!!! ( 3 ) 


	//*********************************************************
	//     
	for(i=0;i<(2*DM_Size-1);i+=2)
	{
		cmd_progr=0x0;
		h_byte=bios_info.DM[i+1]; //      
		l_byte=bios_info.DM[i];  //  

		cmd_progr=h_byte;
		cmd_progr<<=8;
		cmd_progr|=l_byte; 

		cmd_progr<<=16;                
		cmd_progr=cmd_progr|LTR010CMD_PROGR; 

		DM_LoadCommand[j]=cmd_progr;

		j++;
	}
	j=0;

	//      .      : , , .
	//        : , ,  

	for(i=0;i<bios_info.PSize;i=i+4)
	{
		PM_ord[j]=bios_info.PM[i+1];
		PM_ord[j+1]=bios_info.PM[i];
		PM_ord[j+2]=bios_info.PM[i+2];

		j=j+3;
	}

	j=0; //  

	//  CRC
	hnd->CRC_PM=0;

	for(i=0;i<4096*3;i++)
	{
		//  CRC   

		byte_for_CRC=PM_ord[i];
		UpdateCRC16(&(hnd->CRC_PM), byte_for_CRC);
	}




	//***********************************************************  

	//                                                
	for(i=0;i<(2*PM_Size-1);i+=2)                                                 
	{                                                                                   
		cmd_progr=0x0;                                                                           
		h_byte=PM_ord[i];                                                
		l_byte=PM_ord[i+1]; 

		cmd_progr=h_byte;
		cmd_progr<<=8;
		cmd_progr|=l_byte;
		cmd_progr<<=16;                                                                         
		cmd_progr=cmd_progr|LTR010CMD_PROGR;                                                          

		PM_LoadCommand[j]=cmd_progr;                                                            

		j++;                                                                               
	}                                                                                  



	/******    **********************************/     

	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR;

	hnd->Channel.saddr=net_addr;

	if(crate_sn==NULL)
		return LTR212_ERR_INVALID_CRATE_SN;

	sprintf(hnd->Channel.csn, crate_sn);


	if((slot_num<1)||(slot_num)>max_slot_num)
		return LTR212_ERR_INVALID_SLOT_NUM;

	hnd->Channel.cc=slot_num;   

	slot_num-=1;

	//      
	if((err=LTR_Open(&(hnd->Channel)))!=LTR_OK)
		if(err==LTR_WARNING_MODULE_IN_USE)
		{
			warning=err;
			err=LTR_OK;
		}
		else 
			return err;


	//  :  : , , 

	command[0]=LTR010CMD_STOP|(slot_num<<8);
	command[1]=LTR010CMD_RESET|(slot_num<<8);
	stop[0]=LTR010CMD_STOP|(slot_num<<8);


	if((err=(LTR_Send(&(hnd->Channel), stop, 1, TIMEOUT_CMD_SEND))) <1 )
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SEND_COMMAND;


	command[0]=LTR010CMD_RESET|(slot_num<<8);

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) <1)
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SEND_COMMAND;



	tick=GetTickCount();

	while(1)
	{
		read_cntr=LTR_Recv(&(hnd->Channel), rbuf, NULL, 1024, 100); //  ,   FIFO

		if(read_cntr!=0)
			if((rbuf[read_cntr-1]&0xFFFF0000)==(0xD4D40000)) 
				break;



		if(CalkTickInterval(tick, GetTickCount())>=TIMEOUT_CMD_RECIEVE) //    5    
			return LTR212_ERR_CANT_RESET_MODULE; 

	} 

	Sleep(100);   

	/**************  DSP ****************************/

	//  -  BDMA 
	if((err=(LTR_Send(&(hnd->Channel), LoadCommand, 48, TIMEOUT_CMD_SEND)))!=48)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_LOAD_BIOS;

	Sleep(100); 	
	//   		

	if((err=(LTR_Send(&(hnd->Channel), DM_LoadCommand, DM_Size, 10000)))!=DM_Size)   		
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_LOAD_BIOS;                            		


	//   

	//Sleep(100); 
	if((err=(LTR_Send(&(hnd->Channel), PM_LoadCommand, PM_Size, 10000)))!=PM_Size)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_LOAD_BIOS;                            		

	Sleep(50);         

	if((err=(LTR_Send(&(hnd->Channel), stop, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SEND_COMMAND;                            		


	// "" ,     

	Sleep(50);//Sleep(100); 	
	Dummy_command[0]=FIRST_INSTR|(slot_num<<8);

	if((err=(LTR_Send(&(hnd->Channel), Dummy_command, 1, TIMEOUT_CMD_SEND)))<1)   		
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SEND_COMMAND;                            		



	if((err=(LTR_Recv(&(hnd->Channel), rbuf, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) 
		if(err<0)
			return err;
		else 
			return LTR212_ERR_MODULE_NO_RESPONCE;                            		


	if(rbuf[0]!=Dummy_command[0])
		return LTR212_ERR_MODULE_NO_RESPONCE;   

	//            	  

	err=LTR212_TestBios(hnd, &CRC_From_CC);   //    
	if(err) return(err);   



	err=LTR212_ResetAll_AD7730(hnd);  //    AD7730
	if(err) return err;  



	err=LTR212_ReadSerialNumber(hnd, hnd->ModuleInfo.Serial);
	if(err) return err;  

	err=LTR212_ReadBiosVersion(hnd, hnd->ModuleInfo.BiosVersion);
	if(err) return(err);  

	err=LTR212_ReadBiosDate(hnd, hnd->ModuleInfo.BiosDate); 
	if(err) return(err);  

	err=LTR212_ReadModuleName(hnd, hnd->ModuleInfo.Name); 
	if(err) return(err);


	if(warning)
		return(warning);
	else 
		return LTR212_NO_ERR;
}

/*************************************************************************************

  

**************************************************************************************/

LTR212API_DllExport(INT) LTR212_Close(PTLTR212 hnd)
{

	DWORD command[1];
	INT err=0;
	INT slot_num     =hnd->Channel.cc-1;     

	if (hnd==NULL)
		return LTR212_ERR_INVALID_DESCR;


	command[0]=LTR010CMD_STOP|(slot_num<<8);     

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) <= 0)
		return err;    


	if ((LTR_Close(&(hnd->Channel))))
		return LTR212_ERR_CANT_CLOSE;

	return LTR212_NO_ERR;
}

/*************************************************************************************

  n    ,    Address

**************************************************************************************/

INT LTR212_ReadEEPROM(PTLTR212 hnd, INT n, INT Address, BYTE *image)

{
	DWORD command[1024], EEPROM_data[512];
	INT slot_num     =hnd->Channel.cc-1;   
	INT i;
	INT hdrd_cnt;     //  
	INT tail;         // 
	INT cycles_qnt;   //    
	INT err=0;
	INT parity;


	cycles_qnt=(INT) (n/100);
	tail=n%100;


	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 

	if((Address<0)||(Address+n-1)>=512)
		return LTR212_ERR_CANT_READ_EEPROM; 


	for(hdrd_cnt=0;hdrd_cnt<cycles_qnt;hdrd_cnt++) //     
	{
		for(i=0; i<100; i++)
		{
			command[i]=Address+100*hdrd_cnt+i; //    
			command[i]<<=16;
			command[i]|=RD_FLASH|(slot_num<<8);   //    DSP  

			parity=eval_parity(command[i]);
			command[i]|=(parity)<<5;  

		} //  for 

		if((err=(LTR_Send(&(hnd->Channel), command, 100, TIMEOUT_CMD_SEND)))!=100)
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_READ_EEPROM;           


		if((err=(LTR_Recv(&(hnd->Channel), EEPROM_data, NULL, 100, TIMEOUT_CMD_RECIEVE)))!=100)
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_READ_EEPROM;      


		for(i=0; i<100; i++)
		{
			//  

			if(check_parity(EEPROM_data[i]))
				return LTR212_ERR_PARITY_ERROR;   

			if(((EEPROM_data[i])&0xFFDF)==(PARITY_ERR|(slot_num)<<8))
				return LTR212_ERR_PARITY_ERROR; 

			if((EEPROM_data[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))                
				return LTR212_ERR_CANT_READ_EEPROM;      


			EEPROM_data[i]>>=16;
			EEPROM_data[i]&=0xFF;
			*(image+100*hdrd_cnt+i)=EEPROM_data[i];
		} //  for(i=...)
	} //  for(hdrd_cntr...)   

	for(i=0; i<tail; i++)  // ...                                                       
	{                                                                           
		command[i]=Address+100*cycles_qnt+i; //                  
		command[i]<<=16;                                                           
		command[i]|=RD_FLASH|(slot_num<<8);   //    DSP     

		parity=eval_parity(command[i]);
		command[i]|=(parity)<<5;

	} //  for(i=...)                                                                   

	if((err=(LTR_Send(&(hnd->Channel), command, tail, TIMEOUT_CMD_SEND)))!=tail)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_EEPROM;      


	if((err=(LTR_Recv(&(hnd->Channel), EEPROM_data, NULL, tail, TIMEOUT_CMD_RECIEVE)))!=tail) 
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_EEPROM;      


	for(i=0; i<tail; i++)                                                         
	{ 

		if(check_parity(EEPROM_data[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((EEPROM_data[i])&0xFFDF)==(PARITY_ERR|(slot_num)<<8))
			return LTR212_ERR_PARITY_ERROR; 

		if((EEPROM_data[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))                
			return LTR212_ERR_CANT_READ_EEPROM;                                     

		EEPROM_data[i]>>=16;                                                    
		EEPROM_data[i]&=0xFF;                                                   
		*(image+100*cycles_qnt+i)=EEPROM_data[i];                                 
	} //  for(i=...)                                                         


	return LTR212_NO_ERR;
} 


/*******************************************************************************************

   n    ,    Address

********************************************************************************************/

INT LTR212_WriteEEPROM(PTLTR212 hnd, INT n, INT Address, BYTE *image) 
{

	DWORD command[1024], command_ack[15000];
	INT slot_num     =hnd->Channel.cc-1; 
	INT i;
	INT cmd_cnt=0;
	INT tail;         // 
	INT cycles_qnt;   // -   
	INT hdrd_cnt;     //  
	INT err=0;
	INT parity=0;


	cycles_qnt=(INT) (n/100);  // - 
	tail=n%100;				   // 

	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR;


	if((Address<0)||(Address+n-1)>=512)             
		return LTR212_ERR_CANT_WRITE_EEPROM;           



	for(hdrd_cnt=0;hdrd_cnt<cycles_qnt;hdrd_cnt++) //        
	{ 
		for(i=0;i<100;i++)
		{
			command[2*i]=Address+100*hdrd_cnt+i; //   
			command[2*i]<<=16;
			command[2*i]|=WR_FLASH|(slot_num<<8);  //    DSP

			parity=eval_parity(command[2*i]);
			command[2*i]|=(parity)<<5;


			command[2*i+1]=*(image+100*hdrd_cnt+i); //   
			command[2*i+1]<<=16;
			command[2*i+1]|=WR_FLASH|(slot_num<<8);

			parity=eval_parity(command[2*i+1]);
			command[2*i+1]|=(parity)<<5;

			cmd_cnt++;

		} 


		if((err=(LTR_Send(&(hnd->Channel), command, 2*cmd_cnt, TIMEOUT_CMD_SEND)))!=2*cmd_cnt) 
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_WRITE_EEPROM;     


		if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, cmd_cnt, TIMEOUT_CMD_RECIEVE)))!=cmd_cnt)
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_WRITE_EEPROM;     


		for(i=0;i< cmd_cnt;i++)  
		{

			if(check_parity(command_ack[i]))
				return LTR212_ERR_PARITY_ERROR;  


			if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
				return LTR212_ERR_PARITY_ERROR; 


			if((command_ack[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))  
				return LTR212_ERR_CANT_WRITE_EEPROM;       
		}  


		cmd_cnt=0;  
	} //  for(hdrd_cntr...) 


	for(i=0;i<tail;i++)
	{
		command[2*i]=Address+100*cycles_qnt+i; //   
		command[2*i]<<=16;
		command[2*i]|=WR_FLASH|(slot_num<<8);  //    DSP

		parity=eval_parity(command[2*i]);
		command[2*i]|=(parity)<<5;


		command[2*i+1]=*(image+100*cycles_qnt+i); //   
		command[2*i+1]<<=16;
		command[2*i+1]|=WR_FLASH|(slot_num<<8);

		parity=eval_parity(command[2*i+1]);
		command[2*i+1]|=(parity)<<5;

		cmd_cnt++;

	} 

	if((err=(LTR_Send(&(hnd->Channel), command, 2*cmd_cnt, TIMEOUT_CMD_SEND)))!=2*cmd_cnt)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_EEPROM;     


	if((LTR_Recv(&(hnd->Channel), command_ack, NULL, cmd_cnt, TIMEOUT_CMD_RECIEVE))!=cmd_cnt)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_EEPROM;     


	for(i=0;i< cmd_cnt;i++)
	{

		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR;   

		if((command_ack[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))  
			return LTR212_ERR_CANT_WRITE_EEPROM;         

	}  

	return LTR212_NO_ERR;  
}

/************************************************************************************

     -

*************************************************************************************/     

static INT LTR212_LoadIIRFilter(PTLTR212 hnd, SHORT *koeff) // CHAR *fname)
{

	DWORD command[5], command_ack;
	INT slot_num     =hnd->Channel.cc -1; 
	INT i;
	INT err=0;
	INT parity=0;

	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 


	for(i=0;i<5;i++)
	{
		command[i]=koeff[i];    //      -
		command[i]<<=16;
		command[i]|=LOAD_IIR|(slot_num<<8);

		parity=eval_parity(command[i]);
		command[i]|=(parity)<<5;
	}

	if((err=(LTR_Send(&(hnd->Channel), command, 5, TIMEOUT_CMD_SEND)))!=5)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_LOAD_IIR;    


	if((LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE))<=0)
		return LTR212_ERR_CANT_LOAD_IIR; 


	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_LOAD_IIR;        


	return LTR212_NO_ERR;
}  

/************************************************************************************

   DSP   -

*************************************************************************************/ 

static INT LTR212_LoadFIRFilter(PTLTR212 hnd, SHORT *koeff) // CHAR *fname) 
{


	DWORD command[MAXTAPS], command_ack;
	BYTE FIR_order, dec_factor;            //     
	INT slot_num     =hnd->Channel.cc -1; 
	INT i;
	INT parity=0;
	INT err=0;


	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 

	FIR_order=hnd->filter.TAP;
	dec_factor=hnd->filter.Decimation;

	command[0]=dec_factor;  	  //   DSP     
	command[0]<<=24;
	command[0]|=(FIR_order<<16);
	command[0]|=LOAD_FIR|(slot_num<<8);

	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<=0)
		return err;  


	for(i=0;i<FIR_order;i++)		//      -
	{
		command[i]=koeff[i]; 
		command[i]<<=16;
		command[i]|=LOAD_FIR|(slot_num<<8);

		parity=eval_parity(command[i]);
		command[i]|=(parity)<<5;
	}

	if((err=(LTR_Send(&(hnd->Channel), command, FIR_order, TIMEOUT_CMD_SEND)))!=FIR_order) //     DSP 
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_LOAD_FIR;    


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_EEPROM;      

	//   

	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 


	if((command_ack&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_LOAD_FIR;       


	return LTR212_NO_ERR;
}    


/*************************************************************************************

   

**************************************************************************************/

LTR212API_DllExport(INT) LTR212_CreateLChannel(INT PhysChannel, INT Scale)
{
	INT VChannelWord;

	VChannelWord=PhysChannel;  // 16     
	VChannelWord<<=16;
	VChannelWord|=Scale;		  // 16  -  

	return(VChannelWord);
} 


/*************************************************************************************

         

**************************************************************************************/
LTR212API_DllExport(INT) LTR212_SetADC(PTLTR212 hnd)
{
	DWORD command[1], command_ack[8];
	DWORD channel_command[8], dac_command[8];
	DWORD filter_mode; // ,     ,     
	DWORD L_SKIP, L_CHOP, L_FAST, L_AC, L_DEL, L_UB, L_REF; // 
	INT reg_name;
	INT Phys_Channel, Phys_Channel_Prev;// ,        
	INT Channel_Scale;
	INT Channel_Group;
	INT i;
	INT cmd_cnt=0, dac_cnt=0;
	INT Is_IIR_On, Is_FIR_On;
	INT slot_num     =hnd->Channel.cc -1; 
	WORD Channel_Mode;
	INT err=0;
	ltr212filter iirFlt, firFlt;
	double fsBase;
	INT parity=0;

	INT CHOP[3]={0,1,1};
	INT SKIP[3]={1,0,0};
	INT FAST[3]={0,0,0};   
	INT Fdivider[3]={40,682,682};

	/***       ***
	(       : 1,3,5,7,2,4,6,8)
	 -   ,       */


	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 

	if(hnd->LChQnt==0||hnd->LChQnt>LTR212_MAX_LChQnt)
		return LTR212_ERR_INVALID_SLOT_NUM;


	for(i=0;i<hnd->LChQnt;i++)                               
	{
		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;                                              
		Phys_Channel=(hnd->LChTbl[i])>>16;     

		if((Phys_Channel<1)||(Phys_Channel>8))    
			return LTR212_ERR_WRONG_VCH_SETTINGS;     

		if((Channel_Scale<0)||(Channel_Scale>=8))                  
			return LTR212_ERR_WRONG_VCH_SETTINGS;     

		if(i==0) 
			continue;

		Phys_Channel_Prev=(hnd->LChTbl[i-1])>>16;  

		if(Phys_Channel<=Phys_Channel_Prev)                  
			return LTR212_ERR_WRONG_VCH_SETTINGS;               
	}                                                


	if(hnd->UseFabricClb)
		if((!hnd->AcqMode)||(!hnd->REF))  //    .     . . 
			return LTR212_ERR_CANT_USE_CALIBR_MODE;

	err=LTR212_ResetAll_AD7730(hnd); 
	if(err)
		return(err);


	//   ,  ,  . ,      

	for(i=0;i<hnd->LChQnt;i++)
	{
		Phys_Channel=(hnd->LChTbl[i])>>16;


		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;
		Channel_Mode=0;

		Phys_Channel-=1;

		if(Phys_Channel<4)
			Channel_Group=0;
		else
			Channel_Group=1; 

		if(Channel_Scale<4)
			Channel_Mode=Channel_Scale;
		else
			Channel_Mode=Channel_Scale-4;

		Channel_Mode<<=4;

		if(Channel_Scale>3)   // ,         
		{
			L_UB=1;
			L_UB<<=12;
			Channel_Mode|=L_UB;
		} 

		L_REF=hnd->REF;
		L_REF<<=7;

		Channel_Mode|=L_REF;    

		Channel_Mode|=(Phys_Channel<<13);
		Channel_Mode|=Channel_Group;


		//  24- !!!!!
		//***************************

		if(!((hnd->filter.IIR)||(hnd->filter.FIR)))
			Channel_Mode|=0x0100;
		//****************************


		channel_command[cmd_cnt]=Channel_Mode;
		channel_command[cmd_cnt]<<=16;
		channel_command[cmd_cnt]|=LOAD_CHANNEL|(slot_num<<8);

		parity=eval_parity(channel_command[cmd_cnt]);
		channel_command[cmd_cnt]|=(parity)<<5;

		cmd_cnt++;


		if(!hnd->UseClb) //      .  ,    . -
		{

			dac_command[dac_cnt]=Phys_Channel;
			dac_command[dac_cnt]<<=24;

			dac_command[dac_cnt]|=(0x20)<<16;
			dac_command[dac_cnt]|=LOAD_DAC|(slot_num<<8); //       .    DSP

			parity=eval_parity(dac_command[dac_cnt]);
			dac_command[dac_cnt]|=(parity)<<5;

			dac_cnt++;	   
		} //   else

	}  //   for i  


	//     

	if((err=(LTR_Send(&(hnd->Channel), channel_command, cmd_cnt, TIMEOUT_CMD_SEND)))!=cmd_cnt) //                  
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SET_ADC;   



	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, cmd_cnt, TIMEOUT_CMD_RECIEVE)))!=cmd_cnt) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SET_ADC;   



	for(i=0;i<cmd_cnt;i++) 
	{
		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR; 

		if((command_ack[i]&0x0000FFDF)!=(channel_command[i]&0x0000FFDF))  
			return LTR212_ERR_CANT_SET_ADC;
	}    

	//     


	if(hnd->UseClb==1)  //  .. -,     
	{
		err=LTR212_LoadClbCoeffs(hnd);
		if(err)
			return(err); 
	}	      
	else      
	{   //  ,        (0x20)

		if((err=(LTR_Send(&(hnd->Channel), dac_command, dac_cnt, TIMEOUT_CMD_SEND)))!=dac_cnt) 
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_SET_ADC;   



		if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, dac_cnt, TIMEOUT_CMD_RECIEVE)))!=cmd_cnt) //   
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_SET_ADC;


		for(i=0;i<dac_cnt;i++)  
		{

			if(check_parity(command_ack[i]))
				return LTR212_ERR_PARITY_ERROR;  

			if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
				return LTR212_ERR_PARITY_ERROR; 


			if((command_ack[i]&0x0000FFDF)!=(dac_command[i]&0x0000FFDF))  
				return LTR212_ERR_CANT_SET_ADC; 

		}
	}   

	if(hnd->UseFabricClb)
	{
		err=LTR212_LoadFabricClbCoeffs(hnd);
		if(err) return(err);
	}  

	L_REF=hnd->REF;

	command[0]=L_REF;
	command[0]<<=16;
	command[0]|=SET_REF|(slot_num<<8);

	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;


	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<=0) //    
		return LTR212_ERR_CANT_SET_ADC;   


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<=0) //   
		return LTR212_ERR_CANT_SET_ADC;


	if(check_parity(command_ack[0]))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_SET_ADC; 	   


	if(CHOP[hnd->AcqMode]==0)					//  Fdivider   
		if(SKIP[hnd->AcqMode]==0)
		{
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<150))
				return LTR212_ERR_WRONG_ADC_SETTINGS;
		}
		else
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<40))
				return LTR212_ERR_WRONG_ADC_SETTINGS;

	if(CHOP[hnd->AcqMode]==1)
		if(SKIP[hnd->AcqMode]==0)
		{
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<75))
				return LTR212_ERR_WRONG_ADC_SETTINGS;
		}
		else
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<20))
				return LTR212_ERR_WRONG_ADC_SETTINGS;


	filter_mode=Fdivider[hnd->AcqMode];
	filter_mode<<=12;  //   12  ,      

	L_SKIP=SKIP[hnd->AcqMode];
	L_SKIP<<=9;		   //   9   -    SKIP
	filter_mode|=L_SKIP;

	L_FAST=FAST[hnd->AcqMode];
	L_FAST<<=8;			//   8   -    FAST 
	filter_mode|=L_FAST;

	L_AC=hnd->AC;
	L_AC<<=5;			//   5   -    AC
	filter_mode|=L_AC;

	L_CHOP=CHOP[hnd->AcqMode];
	L_CHOP<<=4;			//   4   -    CHOP
	filter_mode|=L_CHOP; 

	L_DEL=0;//hnd->codec.Delay;
	filter_mode|=L_DEL;  //  DL  , ..      


	reg_name=FILTER_REG; 


	for(i=0; i<4; i++) //        
	{
		err=LTR212_SelectCodec(hnd, i);
		if(err=LTR212_Write_24bitReg(hnd, reg_name, filter_mode))
			return err;
	} //  for i   


	if(hnd->AcqMode) 
	{
		if(hnd->filter.IIR || hnd->filter.FIR) 
			return LTR212_ERR_CANT_MANAGE_FILTERS; 
	}

	else 
	{
		hnd->Fs= eval_LChRate(Fdivider[hnd->AcqMode], CHOP[hnd->AcqMode], 0); //   __  

		if(hnd->filter.IIR) 
		{
			if(LTR212_ReadFilter(hnd->filter.IIR_Name,  &iirFlt)) return LTR212_ERR_CANT_MANAGE_FILTERS; // ??? !!! tmp
			if(hnd->Fs!= iirFlt.fs) return LTR212_ERR_CANT_MANAGE_FILTERS;
			if(iirFlt.taps!= 5) return LTR212_ERR_CANT_MANAGE_FILTERS;
			if((err= LTR212_LoadIIRFilter(hnd, iirFlt.koeff)) ) return err;
		};

		if(hnd->filter.FIR) 
		{
			if(LTR212_ReadFilter(hnd->filter.FIR_Name,  &firFlt))
				return LTR212_ERR_CANT_MANAGE_FILTERS; // ??? !!! tmp      
			hnd->filter.TAP= firFlt.taps;
			hnd->filter.Decimation= firFlt.decimation;      
			if((err= LTR212_LoadFIRFilter(hnd, firFlt.koeff)) ) return err;         
		};
	};
	//         ;-))
	err=LTR212_CalcFS(hnd, &fsBase, &(hnd->Fs));
	if(err) return(err);

	Is_IIR_On=(hnd->filter.IIR)<<24;
	Is_FIR_On=(hnd->filter.FIR)<<16;

	command[0]=Is_IIR_On|Is_FIR_On;
	command[0]|=ENA_DIS_FILTERS|(slot_num<<8);

	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<=0) //     
		return err;

	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<=0) //   
		return err; 


	//   
	if(check_parity(command_ack[0]))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_MANAGE_FILTERS;   


	return LTR212_NO_ERR;  
}


/*************************************************************************************

         

**************************************************************************************/   


INT LTR212_CalibrStages(PTLTR212 hnd, BYTE *LChannel_Mask, INT mode, INT reset)
{

#define INTERNAL_CALIBR_BASE_ADDR 100;


	DWORD command[8], command_ack[8]; 
	DWORD dac_command[8];
	INT Phys_Channel, Channel_Scale, Codec, Calibr_Mode;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err;
	INT reg;
	INT dac_cntr=0;
	WORD ModeReg_Val; 
	DWORD OffsetReg_Val=0, GainReg_Val=0;
	INT EEPROM_Addr;
	BYTE EEPROM_Data[8];
	INT UseClb_buf;
	BYTE DAC_Shift[8]={0,0,0,0,0,0,0,0};
	BYTE LChannel_Mask_tmp=0;

	INT Internal_Calibr_Addr;
	INT i;
	WORD Flash_CRC;
	INT parity;


	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 

	UseClb_buf=hnd->UseClb;
	hnd->UseClb=0;
	hnd->UseFabricClb=0; 

	if((reset<0)||(reset>1))
		return LTR212_ERR_CANT_CALIBRATE;  


	if(reset)

	{
		err=LTR212_ResetAll_AD7730(hnd);  //  	  
		if(err) return(err);   


		if(mode!=2) //    ,   
		{  
			for(i=0;i<hnd->LChQnt;i++)                  

			{                                         

				if(!((*LChannel_Mask>>i)&0x1))           
					continue;                               

				Phys_Channel=(hnd->LChTbl[i]>>16)-1;     


				dac_command[dac_cntr]=Phys_Channel;                        
				dac_command[dac_cntr]<<=24;                                

				dac_command[dac_cntr]|=(0x20<<16);                         
				dac_command[dac_cntr]|=LOAD_DAC|(slot_num<<8);    

				parity=eval_parity(dac_command[dac_cntr]);
				dac_command[dac_cntr]|=(parity)<<5;

				dac_cntr++;

				//      ,         (0x20)
				if(mode!=0)
				{
					EEPROM_Addr=Phys_Channel*7+6;
					EEPROM_Data[0]=0x20; //    

					err=LTR212_WriteEEPROM(hnd, 1, EEPROM_Addr, EEPROM_Data);                                                  	 
					if(err) return(err); 
				} 

			} //  for


			if((err=(LTR_Send(&(hnd->Channel), dac_command, dac_cntr, TIMEOUT_CMD_SEND)))!=dac_cntr)
				if(err<0)
					return err;
				else 
					return LTR212_ERR_CANT_CALIBRATE;   


			if((LTR_Recv(&(hnd->Channel), command_ack, NULL, dac_cntr, TIMEOUT_CMD_RECIEVE))!=dac_cntr) //     
				if(err<0)
					return err;
				else 
					return LTR212_ERR_CANT_CALIBRATE;   



			for(i=0;i<dac_cntr;i++)  
			{

				if(check_parity(command_ack[i]))
					return LTR212_ERR_PARITY_ERROR;  


				if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
					return LTR212_ERR_PARITY_ERROR; 


				if((command_ack[i]&0x0000FFDF)!=(dac_command[i]&0x0000FFDF))  
					return LTR212_ERR_CANT_CALIBRATE;

			}   

		} //  if(mode!=2)

	} //   if reset       


	if(mode==0)
	{

		for(i=0;i<hnd->LChQnt;i++)                
		{                                       
			if(!((*LChannel_Mask>>i)&0x1))         
				continue;                             

			Phys_Channel=(hnd->LChTbl[i]>>16)-1; 
			Channel_Scale=(hnd->LChTbl[i])&0x000000FF;

			//                
			if(!hnd->AC)
			{
				Internal_Calibr_Addr=100+Channel_Scale*48+Phys_Channel*6; //  


				err=LTR212_ReadEEPROM(hnd, 3, Internal_Calibr_Addr, EEPROM_Data);
				if(err) 
					return(err);  

				OffsetReg_Val=EEPROM_Data[2];
				OffsetReg_Val<<=8;
				OffsetReg_Val|=EEPROM_Data[1];
				OffsetReg_Val<<=8; 
				OffsetReg_Val|=EEPROM_Data[0];

			} //   if !AC...
			else 
				OffsetReg_Val=0x800000; //     -   

			//  . -     

			if((Phys_Channel==0)||(Phys_Channel==4))                                                               
				Codec=0;                                                                                               	 

			if((Phys_Channel==1)||(Phys_Channel==5))                                                                 	 
				Codec=1;                                                                                               	 

			if((Phys_Channel==2)||(Phys_Channel==6))                                                                 	 
				Codec=2;                                                                                               	 

			if((Phys_Channel==3)||(Phys_Channel==7))                                                                 	 
				Codec=3;                                                                                               	 


			err=LTR212_SelectCodec(hnd, Codec);                                                                      	 
			if(err) return (err);                                                                                  	 

			reg=MODE_REG;  

			err=LTR212_Read_16bitReg(hnd, reg, &ModeReg_Val);                                                       	 
			if(err) return(err);							 /****   !!! *****/                  	 

			if(Phys_Channel>=4) //  .  ,   AIN2  .                 	 
				ModeReg_Val|=0x0001;                                                                               	 
			else                                                                                                 	 
				ModeReg_Val&=0xFFFE; //  .  ,   AIN1  .                 	 

			err=LTR212_Write_16bitReg(hnd, reg, ModeReg_Val);                                                       	 
			if(err) return(err);                                                                                  	 



			reg=OFFSET_REG;                                                                                          	 
			err=LTR212_Write_24bitReg(hnd, reg, OffsetReg_Val);                                                        	 
			if(err) return(err);                                                                                    	 

			reg=GAIN_REG;                                                                                            	 
			err=LTR212_Read_24bitReg(hnd, reg, &GainReg_Val);                                                          	 
			if(err) return(err);                                                                                    	 

			EEPROM_Data[0]=OffsetReg_Val;                                                                            	 
			EEPROM_Data[1]=OffsetReg_Val>>8;                                                                         	 
			EEPROM_Data[2]=OffsetReg_Val>>16;                                                                        	 

			EEPROM_Data[3]=GainReg_Val;                                                                              	 
			EEPROM_Data[4]=GainReg_Val>>8;                                                                           	 
			EEPROM_Data[5]=GainReg_Val>>16;

			EEPROM_Data[6]=0x20; //       

			EEPROM_Addr=Phys_Channel*7;                                                                              	 

			err=LTR212_WriteEEPROM(hnd, 7, EEPROM_Addr, EEPROM_Data);                                                  	 
			if(err) return(err);                                                                                    	 

		}               


		goto End_Calibr;
	}



	if(mode==1)                                                                                                          
	{                                                                                                                   

		for(i=0;i<hnd->LChQnt;i++)                                                                                         

		{                                                                                                                

			if(!((*LChannel_Mask>>i)&0x1))                                                                                  
				continue;                                                                                                      

			Phys_Channel=(hnd->LChTbl[i]>>16)-1;                                                                            
			Channel_Scale=(hnd->LChTbl[i])&0x000000FF;                                                                      


			Internal_Calibr_Addr=100+Channel_Scale*48+Phys_Channel*6+3; //     - .                                   


			err=LTR212_ReadEEPROM(hnd, 3, Internal_Calibr_Addr, EEPROM_Data);  
			if(err) return(err);                                           



			GainReg_Val=EEPROM_Data[2];           
			GainReg_Val<<=8;                      
			GainReg_Val|=EEPROM_Data[1];          
			GainReg_Val<<=8;                      
			GainReg_Val|=EEPROM_Data[0];          



			if((Phys_Channel==0)||(Phys_Channel==4))                                                               	                                                                                                                  
				Codec=0;                                                                                               	                                                                                                                  

			if((Phys_Channel==1)||(Phys_Channel==5))                                                                 	                                                                                                                  
				Codec=1;                                                                                               	                                                                                                                  

			if((Phys_Channel==2)||(Phys_Channel==6))                                                                 	                                                                                                                  
				Codec=2;                                                                                               	                                                                                                                  

			if((Phys_Channel==3)||(Phys_Channel==7))                                                                 	                                                                                                                  
				Codec=3;                                                                                               	                                                                                                                  


			err=LTR212_SelectCodec(hnd, Codec);                                                                      	                                                                                                                  
			if(err) return (err);                                                                                  	                                                                                                                  

			reg=MODE_REG;                                                                                         	                                                                                                                  
			err=LTR212_Read_16bitReg(hnd, reg, &ModeReg_Val);                                                       	                                                                                                                  
			if(err) return(err);							


			if(Phys_Channel>=4) //  .  ,   AIN2  .                 	                                                                                                                  
				ModeReg_Val|=0x0001;                                                                               	                                                                                                                  
			else                                                                                                 	                                                                                                                  
				ModeReg_Val&=0xFFFE; //  .  ,   AIN1  .                 	                                                                                                                  

			err=LTR212_Write_16bitReg(hnd, reg, ModeReg_Val);                                                       	                                                                                                                  
			if(err) return(err);                                                                                  	                                                                                                                  

			reg=OFFSET_REG;                                                                                          	                                                                                                                  
			err=LTR212_Read_24bitReg(hnd, reg, &OffsetReg_Val);                                                        	                                                                                                                  
			if(err) return(err);                                                                                    	                                                                                                                  

			reg=GAIN_REG;                                                                                            	                                                                                                                  
			err=LTR212_Write_24bitReg(hnd, reg, GainReg_Val);                                                          	                                                                                                                  
			if(err) return(err);                                                                                    	                                                                                                                  

			EEPROM_Data[0]=OffsetReg_Val;                                                                            	                                                                                                                  
			EEPROM_Data[1]=OffsetReg_Val>>8;                                                                         	                                                                                                                  
			EEPROM_Data[2]=OffsetReg_Val>>16;                                                                        	                                                                                                                  

			EEPROM_Data[3]=GainReg_Val;                                                                              	                                                                                                                  
			EEPROM_Data[4]=GainReg_Val>>8;                                                                           	                                                                                                                  
			EEPROM_Data[5]=GainReg_Val>>16;

			EEPROM_Addr=Phys_Channel*7;                                                                              	                                                                                                                  

			err=LTR212_WriteEEPROM(hnd, 6, EEPROM_Addr, EEPROM_Data);                                                  	                                                                                                                  
			if(err) return(err);                                                                                    	                                                                                                                  

		}     

		goto End_Calibr;                                                                                                   
	}                                                                                                                  

	err=LTR212_SetADCcalibr(hnd);
	if(err) return(err);


	if(mode==2)
	{

		LChannel_Mask_tmp=*LChannel_Mask;
		err=LTR212_EvaluateDACValue(hnd, LChannel_Mask, DAC_Shift);     
		if(err) 
			return (err); 

		*LChannel_Mask= LChannel_Mask_tmp;

		for(i=0;i<hnd->LChQnt;i++)
		{
			if(!((*LChannel_Mask>>i)&0x1))
				continue;

			Phys_Channel=(hnd->LChTbl[i]>>16)-1; 

			command[0]=Phys_Channel;                                                                                                 
			command[0]<<=24;                                                                                                         
			command[0]|=(DAC_Shift[Phys_Channel]<<16);                                                                                              
			command[0]|=LOAD_DAC|(slot_num<<8); //       .    DSP 

			parity=eval_parity(command[0]);
			command[0]|=(parity)<<5;

			if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<1)
				if(err<0)
					return err;
				else 
					return LTR212_ERR_CANT_CALIBRATE;   


			if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //                                         
				if(err<0)
					return err;
				else 
					return LTR212_ERR_CANT_CALIBRATE;   


			//  

			if(check_parity(command_ack[0]))
				return LTR212_ERR_PARITY_ERROR;  


			if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
				return LTR212_ERR_PARITY_ERROR; 


			if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
				return LTR212_ERR_CANT_CALIBRATE;


			EEPROM_Data[0]=DAC_Shift[Phys_Channel];
			EEPROM_Addr=Phys_Channel*7+6;

			err=LTR212_WriteEEPROM(hnd, 1, EEPROM_Addr, EEPROM_Data); 
			if(err) 
				return(err);

		} //   for

	} 	 //   if    */

	Phys_Channel=0; // 

	command[0]=Phys_Channel;	  //        
	command[0]<<=24;			  //   -   

	Calibr_Mode=mode+4;		  //    ,    

	Calibr_Mode<<=16;
	command[0]|=Calibr_Mode;


	if((hnd->AcqMode)<2)
		command[0]|=CALIBR_4CH |(slot_num<<8);
	else
		command[0]|=CALIBR_8CH|(slot_num<<8);


	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;


	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<1) //     ""
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_CALIBRATE;   


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_CALIBRATE;   

	//    

	if(check_parity(command_ack[0]))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_CALIBRATE;

	//           

	for(i=0;i<hnd->LChQnt;i++)

	{

		if(!((*LChannel_Mask>>i)&0x1))
			continue;

		Phys_Channel=(hnd->LChTbl[i]>>16)-1; 

		if((Phys_Channel==0)||(Phys_Channel==4))
			Codec=0;

		if((Phys_Channel==1)||(Phys_Channel==5))
			Codec=1;

		if((Phys_Channel==2)||(Phys_Channel==6))
			Codec=2;

		if((Phys_Channel==3)||(Phys_Channel==7))
			Codec=3; 


		err=LTR212_SelectCodec(hnd, Codec);
		if(err) return (err);

		reg=MODE_REG;
		err=LTR212_Read_16bitReg(hnd, reg, &ModeReg_Val);

		if(err)
			return(err);							 


		if(Phys_Channel>=4) //  .  ,   AIN2  .    
			ModeReg_Val|=0x0001;

		else
			ModeReg_Val&=0xFFFE; //  .  ,   AIN1  . 

		err=LTR212_Write_16bitReg(hnd, reg, ModeReg_Val);
		if(err) return(err);


		reg=OFFSET_REG;
		err=LTR212_Read_24bitReg(hnd, reg, &OffsetReg_Val);
		if(err) 
			return(err);


		reg=GAIN_REG;
		err=LTR212_Read_24bitReg(hnd, reg, &GainReg_Val);
		if(err) 
			return(err);


		EEPROM_Data[0]=OffsetReg_Val;
		EEPROM_Data[1]=OffsetReg_Val>>8;
		EEPROM_Data[2]=OffsetReg_Val>>16;

		EEPROM_Data[3]=GainReg_Val;
		EEPROM_Data[4]=GainReg_Val>>8;
		EEPROM_Data[5]=GainReg_Val>>16;

		EEPROM_Addr=Phys_Channel*7;

		err=LTR212_WriteEEPROM(hnd, 6, EEPROM_Addr, EEPROM_Data); 
		if(err) return(err);

	}    

End_Calibr:

	hnd->UseClb=UseClb_buf;

	Flash_CRC=0;

	err=LTR212_EvaluateFlashCRC(hnd, &Flash_CRC);//      .
	if(err) return(err);


	err=LTR212_WriteFlashCRC(hnd, Flash_CRC); //    .    
	if(err) return(err);



	return LTR212_NO_ERR; 
}



/*************************************************************************************

    

**************************************************************************************/   



LTR212API_DllExport (INT) LTR212_Calibrate(PTLTR212 hnd, BYTE *LChannel_Mask, INT Calibr_Mode, INT reset)
{
	INT err=0;

	switch (Calibr_Mode)
	{
	case 0: //   

		if((!hnd->AcqMode)||(!hnd->REF))  //    .     . . 
			return LTR212_ERR_CANT_USE_CALIBR_MODE;

		err=LTR212_CalibrStages(hnd, LChannel_Mask, 0, reset);
		if(err) return err;  
		break;

	case 1: //     
		if(!hnd->REF)
			return LTR212_ERR_CANT_USE_CALIBR_MODE;

		err=LTR212_CalibrStages(hnd, LChannel_Mask, 1, reset); 
		if(err) return err;  
		break; 

	case 2: //     
		if((!hnd->AcqMode)||(!hnd->REF))
			return LTR212_ERR_CANT_USE_CALIBR_MODE;

		err=LTR212_CalibrStages(hnd, LChannel_Mask, 0, 1); // 1-  
		if(err) return err;
		err=LTR212_CalibrStages(hnd, LChannel_Mask, 1, 0);  // 2-  
		if(err) return err;
		break; 

	case 3: //              
		err=LTR212_CalibrStages(hnd, LChannel_Mask, 2, reset); 
		if(err) return err;  
		break; 

	case 4: //                       
		err=LTR212_CalibrStages(hnd, LChannel_Mask, 3, reset);
		if(err) return err;  
		break;                                              

	case 5: //   +  0                         
		err=LTR212_CalibrStages(hnd, LChannel_Mask, 1, 1); 
		if(err) return err;
		err=LTR212_CalibrStages(hnd, LChannel_Mask, 2, 0);    
		if(err) return err;                          
		break;                                                      

	case 6: //    (        )!!!                     
		err=LTR212_CalibrStages(hnd, LChannel_Mask, 3, 0); 
		if(err) return err;  
		break; 

	} //   switch!!!                                                              

	return LTR212_NO_ERR;

}


/*************************************************************************************

   

**************************************************************************************/


LTR212API_DllExport(INT) LTR212_Start(PTLTR212 hnd)
{
	BYTE Phys_Chan_Mask; //   
	BYTE Tmp_Ch_Mask;    //  
	INT Phys_Channel;
	INT Mode_4or8Ch;
	DWORD command[1], command_ack[1];
	INT slot_num     =hnd->Channel.cc -1;   
	INT i;
	INT parity;
	INT err=0;

	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR;  

	Phys_Chan_Mask=0;

	for(i=0;i<hnd->LChQnt;i++)	//    ,    DSP
	{
		Phys_Channel=(hnd->LChTbl[i])>>16;
		if(hnd->AcqMode!=2)
			if(Phys_Channel>4)
				return LTR212_ERR_INVALID_ACQ_MODE;

		Tmp_Ch_Mask=1;
		Tmp_Ch_Mask<<=(Phys_Channel-1);

		Phys_Chan_Mask|=Tmp_Ch_Mask;
	}

	if(hnd->AcqMode==2)
		Mode_4or8Ch=1;
	else 
		Mode_4or8Ch=0;

	//Mode_4or8Ch=hnd->Mode; // ,   : 4-  8- 
	Mode_4or8Ch<<=24;
	command[0]=Phys_Chan_Mask; //      ("0"- 4-,"1"- 8-)
	command[0]<<=16;
	command[0]|=Mode_4or8Ch;

	//   !!!!!


	command[0]|=START_ACQ|slot_num<<8;//CONT_READ;

	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<1) //     "  "
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_START_ADC;   


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)  //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_START_ADC;   


	//  
	if(check_parity(command_ack[0]))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_START_ADC; 

	return LTR212_NO_ERR;
}  


/*************************************************************************************

   

**************************************************************************************/ 

LTR212API_DllExport(INT) LTR212_Stop(PTLTR212 hnd)
{
	DWORD command[1], *stop_buf;
	INT read_cntr;
	DWORD tick;   //          
	INT parity;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;

	command[0]=STOP_ACQ|(slot_num<<8); 

	stop_buf=(DWORD *) calloc(15000, sizeof(DWORD));

	if(stop_buf==NULL)
		return LTR_ERROR_MEMORY_ALLOC;


	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	if((read_cntr=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<1) //     "  "
		if(read_cntr<0)
		{
			err=read_cntr;
			goto exit;
		}
		else 
		{
			err=LTR212_ERR_CANT_STOP; 
			goto exit;
		} 


		tick=GetTickCount();

		while(1)
		{
			read_cntr=LTR_Recv(&(hnd->Channel), stop_buf, NULL, 15000, 100); //  ,   FIFO

			if(read_cntr!=0)
				if((stop_buf[read_cntr-1]&0xFFDF)==(STOP_ACQ|(slot_num<<8)))
					break;



			if(CalkTickInterval(tick, GetTickCount())>=12000/*5000*/) //    5    
			{
				err=LTR212_ERR_CANT_STOP; 
				goto exit;
			}

		} 

		if(check_parity(stop_buf[read_cntr-1]))
		{
			err=LTR212_ERR_CANT_STOP; 
			goto exit;
		} 



exit:

		if(stop_buf!=NULL)
			free(stop_buf);

		return err;     

} 



/***************************************************************************************************************

     

****************************************************************************************************************/ 


LTR212API_DllExport (INT) LTR212_Recv(PTLTR212 hnd, DWORD *data, DWORD *tmark, DWORD size, DWORD timeout)
{
	INT res=LTR_Recv(&(hnd->Channel), data, tmark, size, timeout);


	if(res>0)
		if(hnd->Channel.flags&FLAG_RBUF_OVF)
			res=LTR212_ERR_ERROR_OVERFLOW; 

	return res;

}


/***************************************************************************************************************

       ,    

****************************************************************************************************************/ 


LTR212API_DllExport (INT) LTR212_ProcessDataTest(PTLTR212 hnd, DWORD *src, double *dest, DWORD *size, BOOL volt,DWORD *bad_num)
{
	SHORT One_Sample;
	INT Phys_Channel;
	INT Phys_Channel_Rcv;
	INT Frame_Begin;
	INT i,j,k;
	INT err_out;
	INT output_size;
	INT ds           =0;
	INT slot_num     =hnd->Channel.cc -1;
	UINT32 sample_cntr;


	err_out=LTR212_NO_ERR; 

	if(hnd->LChQnt==0||hnd->LChQnt>LTR212_MAX_LChQnt)
		return LTR212_ERR_INVALID_SLOT_NUM;

	Frame_Begin=src[0]&0x00000007;//((hnd->LChTbl[0])>>16)-1;    //    
	//j=0;	   

	for(k=0;k<hnd->LChQnt;k++)
		if(((hnd->LChTbl[k]>>16)-1)==Frame_Begin)
		{
			j=k;
			break;
		} 

		output_size=(INT) *size; //   
		ds=0; //       

		sample_cntr=((*src)>>4)&0x0000000F; // 4-    

		for(i=0;i<*size;i++)
		{
			if(j>=hnd->LChQnt)
				j=0;	  //j-     


			if(((src[i]>>8&0x8F)!=slot_num)||((sample_cntr+i)&0x0000000F)!=((src[i]>>4)&0x0000000F))
			{
				err_out=LTR212_ERR_INV_ADC_DATA; //    , DSP      
				*bad_num=i-1;                     //  
				return(err_out);
			}								  //   ,          


			Phys_Channel=((hnd->LChTbl[j])>>16)-1;  //   ,     
			Phys_Channel_Rcv=src[i]&0x00000007;   //   ,  DSP     
			if(Phys_Channel!=Phys_Channel_Rcv)	   // .   

			{
				err_out=LTR212_ERR_INV_ADC_DATA;
				*bad_num=i;
				ds=ds+j+1; 	 //          
				j=0;
				output_size--;

				continue;
			}

			One_Sample=src[i]>>16;


			dest[i-ds]=(double) One_Sample;

			j++;    
		}  //   for  

		output_size=*size-ds;
		*size=(DWORD) output_size;

		return(err_out);  
} 

/*************************************************************************************

    

**************************************************************************************/
// !!! tmp ---     8-   !!!
//    
static double eval_LChRate(INT divider, INT Is_CHOP_Ena, INT Delay)
{
	if(Is_CHOP_Ena==0)
		return(4915200/(16*divider));
	else
		return(4915200/(Delay+3*16*divider));
}   


/*****************************************************************

   

******************************************************************/ 



INT LTR212_ResetAll_AD7730(PTLTR212 hnd)
{
	DWORD command, command_ack;
	INT slot_num     =hnd->Channel.cc-1; 
	INT err=0;
	INT parity;


	command=RESET_CODECS|(slot_num<<8);

	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_RESET_CODECS;    


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_RESET_CODECS;    

	//     

	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 


	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_RESET_CODECS;      


	return LTR212_NO_ERR;   

}

/*****************************************************************

    (0-3)

******************************************************************/ 

INT LTR212_SelectCodec(PTLTR212 hnd, INT CodecNum)
{
	DWORD command, command_ack; 
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;
	INT parity;

	command=CodecNum;
	command<<=16;
	command|=SEL_CODEC|(slot_num<<8); 

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SELECT_CODEC;    


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SELECT_CODEC;  



	//    
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_SELECT_CODEC;   


	return LTR212_NO_ERR;
}


/*****************************************************************

    8-   

******************************************************************/

INT LTR212_Write_8bitReg(PTLTR212 hnd, INT RegCode, BYTE value)  
{
	DWORD command, command_ack;
	INT parity;
	INT slot_num     =hnd->Channel.cc -1;
	INT err=0;

	command=COMM_REG_WR | RegCode; //       
	command<<=16;				  //   
	command|=WRITE_8REG|(slot_num<<8);	 

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;    

	//  
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;  


	command=value;
	command<<=16;
	command|=WRITE_8REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)  //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;


	//   
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;   


	return LTR212_NO_ERR;

}


/*****************************************************************

    8-   

******************************************************************/

INT LTR212_Read_8bitReg(PTLTR212 hnd, INT RegCode, BYTE *value)
{
	DWORD command, command_ack, reg_data[1];
	INT parity;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;

	command=COMM_REG_RD | RegCode; //       
	command<<=16;
	command|=WRITE_8REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG; 


	//   
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;     

	//      

	command=READ_8REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    

	if((err=(LTR_Recv(&(hnd->Channel), reg_data, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;   

	//  
	if(check_parity(reg_data[0]))
		return LTR212_ERR_PARITY_ERROR;  

	if(((reg_data[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((reg_data[0]&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_READ_REG;    

	reg_data[0]>>=16;
	reg_data[0]&=0x00FF;
	*value=reg_data[0];

	return LTR212_NO_ERR;

}

/*****************************************************************

    16-   

******************************************************************/

INT LTR212_Write_16bitReg(PTLTR212 hnd, INT RegCode, WORD value)
{
	DWORD command, command_ack;
	INT parity;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;

	command=COMM_REG_WR | RegCode; //       
	command<<=16;				  //   
	command|=WRITE_8REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;


	//    
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;     

	//      16- 

	command=value;
	command<<=16;
	command|=WRITE_16REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		return err;  

	//   

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;


	//   
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;


	return LTR212_NO_ERR;
} 



/*****************************************************************

    16-   

******************************************************************/


INT LTR212_Read_16bitReg(PTLTR212 hnd, INT RegCode, WORD *value)

{

	DWORD command,command_ack,reg_data;
	INT parity;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;

	command=COMM_REG_RD | RegCode; //       
	command<<=16;
	command|=WRITE_8REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    


	//    
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;        


	//      

	command=READ_16REG|(slot_num<<8);

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;


	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    


	if((err=(LTR_Recv(&(hnd->Channel), &reg_data, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;   


	//  
	if(check_parity(reg_data))
		return LTR212_ERR_PARITY_ERROR;  

	if(((reg_data)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((reg_data&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_READ_REG;         

	reg_data>>=16;
	*value=reg_data;          

	return LTR212_NO_ERR;
} 


/*****************************************************************

    24-   

******************************************************************/ 
INT LTR212_Write_24bitReg(PTLTR212 hnd, INT RegCode, DWORD value)
{
	DWORD command[3], command_ack[3];
	DWORD high_8bit;
	DWORD last_16bit;
	INT parity;
	INT slot_num     =hnd->Channel.cc -1; 
	INT i;
	INT err;


	command[0]=COMM_REG_WR | RegCode; //       
	command[0]<<=16;				  //   
	command[0]|=WRITE_8REG|(slot_num<<8);

	//   
	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	//     8   24- 

	high_8bit=value&0x00FF0000;
	last_16bit=value&0x0000FFFF;

	command[1]=high_8bit;
	command[1]|=WRITE_24REG|(slot_num<<8);

	//   
	parity=eval_parity(command[1]);
	command[1]|=(parity)<<5;

	command[2]=last_16bit;
	command[2]<<=16;
	command[2]|=WRITE_24REG|(slot_num<<8);

	//   
	parity=eval_parity(command[2]);
	command[2]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 3, TIMEOUT_CMD_SEND)))!=3)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;

	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 2, TIMEOUT_CMD_RECIEVE)))!=2)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_REG;

	for(i=0;i<2;i++) 
	{
		//  
		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR; 

		if((command_ack[i]&0x0000FFDF)!=(command[i]&0x0000FFDF))  
			return LTR212_ERR_CANT_WRITE_REG; 
	}

	return LTR212_NO_ERR;
}  


/*****************************************************************

    24-   

******************************************************************/ 

INT LTR212_Read_24bitReg(PTLTR212 hnd, INT RegCode, DWORD *value)

{

	DWORD command,command_ack,reg_data[2];
	INT parity;
	INT slot_num     =hnd->Channel.cc -1; 
	INT i;
	INT err=0;

	command=COMM_REG_RD | RegCode; //       
	command<<=16;
	command|=WRITE_8REG|(slot_num<<8);	  

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    

	//  
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_REG;   

	//       

	command=READ_24REG|(slot_num<<8); 

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;    

	if((LTR_Recv(&(hnd->Channel), reg_data, NULL, 2, TIMEOUT_CMD_RECIEVE))!=2)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;     

	for(i=0;i<2;i++) 
	{
		//  
		if(check_parity(reg_data[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((reg_data[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR; 

		if((reg_data[i]&0x0000FFDF)!=(command&0x0000FFDF))  
			return LTR212_ERR_CANT_WRITE_REG;
	} 
	//     2- 

	reg_data[0]&=0x00FF0000;
	reg_data[1]>>=16;

	*value=reg_data[0]|reg_data[1];

	return LTR212_NO_ERR;

}


#define QFreq 4.9152e6
#define THE8CHANTIME  1.0/50e3  // !!! tmp 

// !!!     VChRate ____      
LTR212API_DllExport(INT) LTR212_CalcFS(PTLTR212 hnd, double *fsBase, double *fs) 
{
	INT d= 1;


	double fs_for_modes[3]={7680.0, 150.15, 150.15 }; 


	if((hnd->AcqMode<0)||(hnd->AcqMode>2))
		return LTR212_ERR_WRONG_ADC_SETTINGS;

	*fsBase=fs_for_modes[hnd->AcqMode];

	if(hnd->filter.Decimation<=0)
		return LTR212_ERR_WRONG_ADC_SETTINGS;

	if(hnd->filter.FIR) d= hnd->filter.Decimation;
	*fs= *fsBase / d;  

	if((hnd->AcqMode)==2)
		*fs=3.4;

	return(0); 

}; 


/********************************************************************************************

            .   

*********************************************************************************************/


LTR212API_DllExport (INT) LTR212_ReadFilter(CHAR *fname, ltr212filter *filter)
{ 
	FILE *f;
	INT   k;
#define NSYMFLT 127
#define fltStr2 "DECIMATION= "
#define fltStr1 "FS= "
	CHAR  line[NSYMFLT+1], tmp[512];


	memset(filter, 0x0, sizeof(ltr212filter));

	if((f= fopen(fname, "r")) == NULL) return 1;
	if(fgets(line, NSYMFLT, f) == NULL)  goto __bad_exit;
	strcpy(tmp, line);
	tmp[strlen(fltStr1)]= 0x0;
	if(stricmp(tmp, fltStr1)) goto __bad_exit;
	if(sscanf(line + strlen(fltStr1), "%lf", &(filter->fs))!=1) goto __bad_exit;

	if(fgets(line, NSYMFLT, f) == NULL)  goto __bad_exit;
	strcpy(tmp, line);
	tmp[strlen(fltStr2)]= 0x0;
	if(stricmp(tmp, fltStr2)) goto __bad_exit;
	if(sscanf(line + strlen(fltStr2), "%d",(INT *) &(filter->decimation))!=1) goto __bad_exit;  

	while(fgets(line, NSYMFLT, f) != NULL) {
		if(sscanf(line, "%X", &k)!=1) continue;

		if(filter->taps < MAXTAPS) {
			filter->koeff[filter->taps]= k;
		}
		// else goto __bad_exit;
		filter->taps++;
	}


	fclose(f);

	if((filter->taps > MAXTAPS) ||( filter->taps < MINTAPS)) return 1;
	return 0;

__bad_exit:
	fclose(f);
	return 1;
};


/*********************************************************************

         60 (0x3C)

**********************************************************************/   


LTR212API_DllExport (INT) LTR212_WriteSerialNumber(PTLTR212 hnd, CHAR *sn, WORD Code)
{
	INT sn_length; //    
	INT err;
	INT slot_num     =hnd->Channel.cc -1; 
	DWORD command, command_ack;
	INT parity;
	INT EEPROM_Addr=60; //      60
	WORD Flash_CRC;
	CHAR Module_Name[7]="LTR212";

	command=Code;
	command<<=16;
	command|=(WRITE_SN_CHECK|(slot_num<<8));

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;



	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_WRITE_SERIAL_NUM;  


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else 
			return  LTR212_ERR_CANT_WRITE_SERIAL_NUM;    

	//    
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_WRITE_SERIAL_NUM;			  

	if((command_ack>>16))
		return LTR212_ERR_CANT_WRITE_SERIAL_NUM;

	sn_length=strlen(sn);

	if(sn_length>(sizeof(hnd->ModuleInfo.Serial)-1)/*-1*//*17*/)
		return LTR212_ERR_CANT_WRITE_SERIAL_NUM;

	err=LTR212_WriteEEPROM(hnd, sn_length+1/*sizeof(hnd->Serial)*/, EEPROM_Addr, (BYTE *) sn); 
	if(err) return(err);

	//     

	EEPROM_Addr=80;

	err=LTR212_WriteEEPROM(hnd, strlen(Module_Name)+1, EEPROM_Addr, (BYTE *) Module_Name); 
	if(err) return(err);

	//       !!! 

	err=LTR212_EvaluateFlashCRC(hnd, &Flash_CRC);
	if(err) return(err);

	err=LTR212_WriteFlashCRC(hnd, Flash_CRC);
	if(err) return(err);

	return LTR212_NO_ERR;  
}

/*********************************************************************

         60 (0x3C)

**********************************************************************/    

INT LTR212_ReadSerialNumber(PTLTR212 hnd, CHAR *sn)   
{
	INT err;
	INT EEPROM_Addr=60;
	INT string_flag=0;
	INT i;


	err=LTR212_ReadEEPROM(hnd, sizeof(hnd->ModuleInfo.Serial), EEPROM_Addr, (BYTE *) sn); 
	if(err)
		return(err);

	for(i=0;i<sizeof(hnd->ModuleInfo.Serial);i++)
		if(sn[i]=='\0')
		{
			string_flag=1; 
			break;
		}

		if(!string_flag)
			sn[0]='\0';


		return LTR212_NO_ERR;  
}


/**********************************************************************************       

       DSP            

***********************************************************************************/    

INT LTR212_LoadDACBuffer(PTLTR212 hnd)

{
	return LTR212_NO_ERR; 
}


/*********************************************************************

   

*********************************************************************/ 

static WORD UpdateCRC16(WORD *crc, BYTE b)
{
	WORD w;
	INT j;
	w = *crc;
	w ^= b << 8;
	for(j=0;j<8;j++)  {
		if(w&0x8000) w = (w<<1) ^ 0x1021;
		else w <<= 1;
	}
	*crc = w;
	return w;
}




INT LTR212_TestBios(PTLTR212 hnd, WORD *CRC_Rcv)
{
	DWORD command, command_ack;
	INT slot_num     =hnd->Channel.cc -1; 
	INT parity;
	WORD CRC_DSP;
	INT err=0;



	command=TEST_BIOS|(slot_num<<8);
	//   
	parity=eval_parity(command);
	command|=(parity)<<5;



	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_TEST_NOT_PASSED;      




	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
	{
		*CRC_Rcv=0; 

		if(err<0)
			return err;
		else 
			return LTR212_ERR_TEST_NOT_PASSED;    
	}		  

	//   
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
	{
		*CRC_Rcv=0; 
		return LTR212_ERR_TEST_NOT_PASSED;
	}		  			  


	CRC_DSP=command_ack>>16; 
	*CRC_Rcv=CRC_DSP;
	if(CRC_DSP!=hnd->CRC_PM)
		return LTR212_ERR_TEST_NOT_PASSED; 



	return LTR212_NO_ERR;  
}  

/********************************************************************************************************

    

********************************************************************************************************/      

LTR212API_DllExport (INT) LTR212_ProcessData(PTLTR212 hnd, DWORD *src, double *dest, DWORD *size, BOOL volt/*,INT *bad_num*/)
{

	DWORD One_Sample_U;
	DWORD High_Byte, M_L_Byte;
	SHORT One_Sample_16;
	INT One_Sample;
	INT Phys_Channel;
	INT Phys_Channel_Rcv;
	INT Channel_Scale;
	INT Frame_Begin;
	INT i,j,k;
	INT bad_frame_flag=0;
	INT next_frame=0;
	INT i_d;
	INT err_out;
	INT output_size;
	INT slot_num     =hnd->Channel.cc -1;
	DWORD sample_cntr;
	INT Range_Koeff;
	INT Correction;

	err_out=LTR212_NO_ERR; 

	if(hnd->LChQnt==0||hnd->LChQnt>LTR212_MAX_LChQnt)
		return LTR212_ERR_INVALID_SLOT_NUM;

	Frame_Begin=((hnd->LChTbl[0])>>16)-1;    //    


	k=0;
	j=0;	   
	output_size=(INT) ((*size)/2); //   
	// ds=0; //       


	sample_cntr=((*src)>>4)&0x0000000F; // 4-    

	for(i=0;i<*size;i++)
	{
		if(j>=hnd->LChQnt)
		{
			j=0;	  //j-     
			next_frame=k; //        
		}


		if(((src[i]>>8&0x8F)!=slot_num)||((sample_cntr+i)&0x0000000F)!=((src[i]>>4)&0x0000000F))
		{ err_out=LTR212_ERR_INV_ADC_DATA; //    , DSP      
		//  
		//   ,          
		}

		Phys_Channel_Rcv=src[i]&0x00000007;   //   ,  DSP         

		if(bad_frame_flag)
		{
			if(!(i%2)&&(Phys_Channel_Rcv==Frame_Begin))
			{
				bad_frame_flag=0;
				j=0;
				k=next_frame;
			}
			else 
				continue;
		} 

		Phys_Channel=((hnd->LChTbl[j])>>16)-1;  //   ,     

		if(Phys_Channel!=Phys_Channel_Rcv)	   // .   
		{
			err_out=LTR212_ERR_INV_ADC_DATA;

			if(i%2)
				j++;
			bad_frame_flag=1;

			continue;
		}

		if((i%2)==0) 
			continue;       

		i_d=(INT) i/2; 

		High_Byte=src[i-1]&0xFFFF0000;   
		M_L_Byte=src[i]>>16;

		if(!((hnd->filter.IIR)||(hnd->filter.FIR)))
		{

			Channel_Scale=(hnd->LChTbl[j])&0x0000000F;
			if(Channel_Scale>=4)
			{
				One_Sample_U= (M_L_Byte|High_Byte);
				One_Sample=One_Sample_U;
			}
			else  
			{
				One_Sample_U=(M_L_Byte|High_Byte)-0x800000;
				One_Sample=(INT) One_Sample_U;
			}

			Range_Koeff=8388608;
			Correction=0x800000;

		} 
		else
		{
			Channel_Scale=(hnd->LChTbl[j])&0x0000000F;
			Range_Koeff=32768;
			Correction=0x8000;


			One_Sample_16=0|(M_L_Byte);//One_Sample_SU;

			if(Channel_Scale>=4)
				One_Sample=One_Sample_16+Correction; 
			else 
				One_Sample=One_Sample_16;
		}

		//     

		if(volt)
		{
			Channel_Scale=(hnd->LChTbl[j])&0x0000000F; //         
			switch(Channel_Scale)
			{
			case 0:

				dest[k]=One_Sample*0.01/Range_Koeff;/*8388608;*/
				break;

			case 1:

				dest[k]=One_Sample*0.02/Range_Koeff;
				break;

			case 2:

				dest[k]=One_Sample*0.04/Range_Koeff;
				break;

			case 3:

				dest[k]=One_Sample*0.08/Range_Koeff; 
				break;

			case 4:

				dest[k]=(One_Sample)*0.01/(Range_Koeff*2); 
				break; 

			case 5:

				dest[k]=(One_Sample)*0.02/(Range_Koeff*2); 
				break; 

			case 6:

				dest[k]=(One_Sample)*0.04/(Range_Koeff*2);  
				break; 

			case 7:

				dest[k]=(One_Sample)*0.08/(Range_Koeff*2);  
				break;    

			} //   switch

		}  //   if
		else
		{ 
			dest[k]=(double) One_Sample;

		} //   else

		j++; 
		k++;
	}  //   for  

	if(k%hnd->LChQnt)
		output_size=next_frame;
	else
		output_size=k;

	*size=(DWORD) output_size;
	return(err_out);  

}


/*****************************************************************************************************************

      (       

*****************************************************************************************************************/

INT LTR212_EvaluateDACValue(PTLTR212 hnd, BYTE *LChannel_Mask, BYTE *DAC_Val)

{
	DWORD calibr_data[1024];
	double calibr_volts[1024];
	INT Channel_Scale;
	INT err;
	INT cntr;
	DWORD samples_qnt;
	INT DAC_Code;
	double DAC_Code_dbl;
	double V_REF[2]={2.5, 5.0};
	double Correct_Vtg;
	INT i, j;
	INT reg;
	double mean_val[8];
	WORD ModeReg_Val_Rd;
	DWORD command[1], command_ack[8], dac_command[8];
	INT slot_num     =hnd->Channel.cc -1; 
	INT cnt[8];
	INT parity;
	INT Phys_Channel;
	INT LChTbl_buf[8]; 																
	INT Bad_Value_Flag=0;
	CHAR DAC_Correct[8];
	double DAC_LSB_REF[2]={0.0013, 0.0026};
	double Vtg_First_Mes[8], Vtg_Sec_Mes[8];
	INT k=0;
	CHAR DAC_Val_Sign;
	BYTE DAC_Val_Prev[8];
	INT Correction_Allow_Flag=0;
	INT dac_cntr=0;
	INT IIR_buf, FIR_buf;

	//{0,0,0,0,0,0,0,0}; //   DAC        
	INT Range;                       


	//   

	for(i=0;i<hnd->LChQnt;i++)                                                                                       

	{                                                                                                              

		if(!((*LChannel_Mask>>i)&0x1))                                                                                    
			continue;                                                                                                        

		Phys_Channel=(hnd->LChTbl[i]>>16)-1;                                                                              


		dac_command[dac_cntr]=Phys_Channel;                                                                            
		dac_command[dac_cntr]<<=24;                                                                                    

		dac_command[dac_cntr]|=(0x20<<16);                                                                             
		dac_command[dac_cntr]|=LOAD_DAC|(slot_num<<8);   

		parity=eval_parity(dac_command[dac_cntr]);
		dac_command[dac_cntr]|=(parity)<<5;

		dac_cntr++;                                                                                                    

	} //  for                                                                                                        


	if((err=(LTR_Send(&(hnd->Channel), dac_command, dac_cntr, TIMEOUT_CMD_SEND)))!=dac_cntr) 
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_CALIBRATE;    


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, dac_cntr, TIMEOUT_CMD_RECIEVE)))!=dac_cntr) //     
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_CALIBRATE;   

	for(i=0;i<dac_cntr;i++)  
	{    //   
		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  		  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR; 


		if((command_ack[i]&0x0000FFDF)!=(dac_command[i]&0x0000FFDF))  
			return LTR212_ERR_CANT_CALIBRATE;
	}   

	for(i=0;i<hnd->LChQnt;i++)                                                                                   
	{  
		if(!((*LChannel_Mask>>i)&0x1))      
			continue;    

		LChTbl_buf[i]=hnd->LChTbl[i]; //   , ..                          
		//hnd->LChTbl[i]=LTR212_CreateVChannel(i+1,0);//      +/-80   
		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF; 


		if(hnd->REF) 
			hnd->LChTbl[i]=(hnd->LChTbl[i]&0xFFFF0000)|0x3;//      +/-80      
		else  
			hnd->LChTbl[i]=(hnd->LChTbl[i]&0xFFFF0000)|0x2;//      +/-40        
	}                                                                                                       


	if(hnd->AcqMode==0)      //      
	{
		IIR_buf=hnd->filter.IIR;
		FIR_buf=hnd->filter.FIR;
		hnd->filter.IIR=0;
		hnd->filter.FIR=0;
	} 


	err=LTR212_SetADCcalibr(hnd);                                                                                        
	if(err) return(err);  

	samples_qnt=(hnd->LChQnt)*64; // -    2   - 

	err=LTR212_Start(hnd);

	//      . !!! 

	cntr=LTR_Recv(&(hnd->Channel), calibr_data, NULL, samples_qnt, 15000); //   32   

	if(cntr!=(int) samples_qnt)
		if(cntr<0)
			return(cntr);
		else  
			return LTR212_ERR_CANT_CALIBRATE;

	err=LTR212_Stop(hnd);
	if(err)
		return(err);

	reg=MODE_REG;
	err=LTR212_Read_16bitReg(hnd, reg, &ModeReg_Val_Rd);
	if(err)
		return(err);

	err=LTR212_ProcessData(hnd, calibr_data, calibr_volts, &samples_qnt, 1);
	if(err)
		return(err);


	if(hnd->AcqMode==0)      //    
	{
		hnd->filter.IIR=IIR_buf;
		hnd->filter.FIR=FIR_buf;
	} 

	for(i=0;i<8;i++)
	{
		mean_val[i]=0.0;
		cnt[i]=0;
	}

	j=0;

	for(i=0; i<2*samples_qnt; i+=2)
	{
		Phys_Channel=(calibr_data[i]&0x00000007);

		mean_val[Phys_Channel]=mean_val[Phys_Channel]+calibr_volts[(INT) i/2];
		cnt[Phys_Channel]++;
	}

	for(i=0; i<8; i++) //   8 ..
	{
		if(!((*LChannel_Mask>>i)&0x1))      
			continue;                          

		Phys_Channel=((hnd->LChTbl[i]&0x000F0000)>>16)-1; 

		if(cnt[Phys_Channel]!=0)	  //      ..
		{
			mean_val[Phys_Channel]=mean_val[Phys_Channel]/cnt[Phys_Channel]; //     


			if(fabs(mean_val[Phys_Channel])>(V_REF[hnd->REF]*31/2000)) // ,         
				return LTR212_ERR_CANT_EVAL_DAC;   


			Vtg_First_Mes[Phys_Channel]=mean_val[Phys_Channel];

			DAC_Code_dbl=fabs(mean_val[Phys_Channel])/DAC_LSB_REF[hnd->REF];///     
			DAC_Code=(INT) (DAC_Code_dbl+0.5); 		   //     

			Correct_Vtg=DAC_Code*V_REF[hnd->REF]/2000; // ,     (  )

			if(DAC_Code==0)
				DAC_Code=0x20;
			else
				if(mean_val[Phys_Channel]>0)	  //    ,        "1".
					DAC_Code|=0x20;

			command[0]=Phys_Channel;
			command[0]<<=24;

			command[0]|=(DAC_Code<<16);
			command[0]|=LOAD_DAC|(slot_num<<8); //       .    DSP

			//   
			parity=eval_parity(command[0]);
			command[0]|=(parity)<<5;

			if((LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))<1)
				if(cntr<0)
					return(cntr);
				else  
					return LTR212_ERR_CANT_CALIBRATE; 


			if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1) //   
				if(err<0)
					return(err);
				else  
					return LTR212_ERR_CANT_CALIBRATE;  

			//    
			if(check_parity(command_ack[0]))
				return LTR212_ERR_PARITY_ERROR;  


			if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
				return LTR212_ERR_PARITY_ERROR; 

			if((command_ack[0]&0x0000FFDF)!=(dac_command[0]&0x0000FFDF))  
				return LTR212_ERR_CANT_CALIBRATE; 


			*(DAC_Val+Phys_Channel)=DAC_Code;
			DAC_Val_Prev[Phys_Channel]=DAC_Val[Phys_Channel];

			DAC_Correct[Phys_Channel]=DAC_Code;	

		}
	}

	//                          		
	for(i=0;i<hnd->LChQnt;i++)                                             		
	{ 
		if(!((*LChannel_Mask>>i)&0x1))      
			continue;

		hnd->LChTbl[i]=LChTbl_buf[i];                                        		
	}                                                                   		
	//***********************************************************************
	// ,        


	if(hnd->AcqMode==0)      //      
	{
		IIR_buf=hnd->filter.IIR;
		FIR_buf=hnd->filter.FIR;
		hnd->filter.IIR=0;
		hnd->filter.FIR=0;
	} 

	err=LTR212_SetADCcalibr(hnd);	
	if(err) return err;

new_attempt: //  !!!!!!!!!!!!!!!!
	k++;

	Bad_Value_Flag=0;

	samples_qnt=(hnd->LChQnt)*64; // -    2   -                                                                                            

	err=LTR212_Start(hnd);
	if(err) return err; 

	cntr=LTR_Recv(&(hnd->Channel), calibr_data, NULL, samples_qnt, 15000); //   32    

	if(cntr!=samples_qnt)                                                                                                                                                           
		if(cntr<0)
			return(cntr);
		else  
			return LTR212_ERR_CANT_CALIBRATE; 


	err=LTR212_Stop(hnd);
	if(err) return(err);


	err=LTR212_ProcessData(hnd, calibr_data, calibr_volts, &samples_qnt, 1/*, &bad_num*/); 
	if(err) return(err); 


	for(i=0;i<8;i++)                                                                                                                                                                
	{                                                                                                                                                                               
		mean_val[i]=0.0;                                                                                                                                                              
		cnt[i]=0;                                                                                                                                                                     
	}                                                                                                                                                                              

	j=0;                                                                                                                                                                            

	for(i=0; i<2*samples_qnt; i+=2)                                                                                                                                                 
	{                                                  
		Phys_Channel=(calibr_data[i]&0x00000007);                                                                                                                                    

		mean_val[Phys_Channel]=mean_val[Phys_Channel]+calibr_volts[(INT) i/2];                                                                                                    
		cnt[Phys_Channel]++;                                                                                                                                                      
	}                                                                                                                                                                           

	for(i=0; i<hnd->LChQnt; i++) //   8 ..                                                                                                                                    
	{  
		if(!((*LChannel_Mask>>i)&0x1))      
			continue;  

		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;

		Phys_Channel=((hnd->LChTbl[i]&0x000F0000)>>16)-1;
		Range=hnd->LChTbl[i]&0x0000000F;

		mean_val[Phys_Channel]=mean_val[Phys_Channel]/cnt[Phys_Channel]; //       

		Vtg_Sec_Mes[Phys_Channel]=mean_val[Phys_Channel];


		if(Channel_Scale>=4) //   
		{
			if((Vtg_Sec_Mes[Phys_Channel]==0)||(Vtg_Sec_Mes[Phys_Channel]==Vtg_First_Mes[Phys_Channel])) //         0. 
			{								                          //  ,    <0,  < 1 .   
				*LChannel_Mask&=(~(1<<i)); 		                          //    ""    .
				continue;
			}
			else
				goto next;
		}

		if(!Correction_Allow_Flag)    
			goto next;                  

		/**************     ******************/

		//    "0"   
		if(((Vtg_Sec_Mes[Phys_Channel]>0)&&(Vtg_First_Mes[Phys_Channel]<0))||((Vtg_Sec_Mes[Phys_Channel]<0)&&(Vtg_First_Mes[Phys_Channel]>0)))
			// ,     
		{
			if(fabs(Vtg_Sec_Mes[Phys_Channel])>=fabs(Vtg_First_Mes[Phys_Channel]))
				DAC_Val[Phys_Channel]=DAC_Val_Prev[Phys_Channel];

			*LChannel_Mask&=(~(1<<i));
			continue;
		}  


next: 
		Vtg_First_Mes[Phys_Channel]=Vtg_Sec_Mes[Phys_Channel];  


		DAC_Val_Prev[Phys_Channel]=DAC_Val[Phys_Channel];   

		if(mean_val[Phys_Channel]>0)
		{
			if(DAC_Val[Phys_Channel]>=0x20)
				DAC_Val[Phys_Channel]++;/*=DAC_Correct[Phys_Channel]*/
			else
			{
				DAC_Val[Phys_Channel]--;/*=DAC_Correct[Phys_Channel];*/


				DAC_Val_Sign=(CHAR) DAC_Val[Phys_Channel];   

				if(DAC_Val_Sign<=0)
				{
					DAC_Val[Phys_Channel]=fabs((double)DAC_Val_Sign);
					DAC_Val[Phys_Channel]=(DAC_Val[Phys_Channel]&0x1F)|0x20;     
				}
			}  //  else


			Bad_Value_Flag=1;
		} //  if


		else 
		{
			if(DAC_Val[Phys_Channel]>=0x20)
			{
				DAC_Val[Phys_Channel]--;/*=DAC_Correct[Phys_Channel];*/


				if(DAC_Val[Phys_Channel]<0x20)
					DAC_Val[Phys_Channel]=0x20-DAC_Val[Phys_Channel];
			} //  if!    
			else                          
				DAC_Val[Phys_Channel]++;/*=DAC_Correct[Phys_Channel]; */

			Bad_Value_Flag=1;    

		} //  else  

	}//   for


	//   ,  ,   

	if(Bad_Value_Flag==1)

	{
		dac_cntr=0;

		for(i=0;i<hnd->LChQnt;i++)                                                                                       

		{                                                                                                              

			if(!((*LChannel_Mask>>i)&0x1))                                                                                
				continue;                                                                                                    

			Phys_Channel=(hnd->LChTbl[i]>>16)-1;                                                                          


			dac_command[dac_cntr]=Phys_Channel;                                                                        
			dac_command[dac_cntr]<<=24;                                                                                

			dac_command[dac_cntr]|=(DAC_Val[Phys_Channel])<<16;                                                                           
			dac_command[dac_cntr]|=LOAD_DAC|(slot_num<<8);  

			parity=eval_parity(dac_command[dac_cntr]);
			dac_command[dac_cntr]|=(parity)<<5;

			dac_cntr++;                                                                                                

		} //  for                                                                                                    


		if((err=(LTR_Send(&(hnd->Channel), dac_command, dac_cntr, TIMEOUT_CMD_SEND)))!=dac_cntr) 
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_CALIBRATE;   


		if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, dac_cntr, TIMEOUT_CMD_RECIEVE)))!=dac_cntr) //                 
			if(err<0)
				return err;
			else 
				return LTR212_ERR_CANT_CALIBRATE;                                                                        


		for(i=0;i<dac_cntr;i++) 

		{

			//    

			if(check_parity(command_ack[i]))
				return LTR212_ERR_PARITY_ERROR;  


			if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
				return LTR212_ERR_PARITY_ERROR; 

			if((command_ack[i]&0x0000FFDF)!=(dac_command[i]&0x0000FFDF))  
				return LTR212_ERR_CANT_CALIBRATE;

		}                                                                                                              


		Correction_Allow_Flag=1;     
		goto new_attempt;

	}

	if(hnd->AcqMode==0)      //    
	{
		hnd->filter.IIR=IIR_buf;
		hnd->filter.FIR=FIR_buf;
	} 

	return LTR212_NO_ERR;

}	


/*********************************************************************************************

     

**********************************************************************************************/ 

INT LTR212_WriteFlashCRC(PTLTR212 hnd, WORD Flash_CRC)
{
	INT err;
	BYTE CRC_HByte, CRC_LByte;
	BYTE CRC_Bytes[2];

	CRC_LByte=Flash_CRC&0x00FF;       //    
	CRC_HByte=(Flash_CRC>>8)&0x00FF;   //   


	CRC_Bytes[0]=CRC_LByte;
	CRC_Bytes[1]=CRC_HByte;

	err=LTR212_WriteEEPROM(hnd, 2, 510, CRC_Bytes); //   . 80   
	if (err) return(err); 


	return LTR212_NO_ERR;   
}


/*******************************************************************************************

    

**********************************************************************************************/  

LTR212API_DllExport (INT) LTR212_TestEEPROM(PTLTR212 hnd)
{
	WORD Flash_CRC;
	INT err;
	BYTE CRC_From_Flash_Bytes[2];
	WORD CRC_From_Flash;


	CRC_From_Flash=0;
	Flash_CRC=0;

	err=LTR212_EvaluateFlashCRC(hnd, &Flash_CRC);
	if (err) return(err);
	err=LTR212_ReadEEPROM(hnd, 2, 510, CRC_From_Flash_Bytes); //   . 510
	if (err) return(err);


	CRC_From_Flash=CRC_From_Flash_Bytes[1];
	CRC_From_Flash<<=8;
	CRC_From_Flash|=CRC_From_Flash_Bytes[0];

	hnd->CRC_Flash_Eval=Flash_CRC;
	hnd->CRC_Flash_Read=CRC_From_Flash;

	if(Flash_CRC!=CRC_From_Flash)
		return LTR212_ERR_WRONG_FLASH_CRC;

	return LTR212_NO_ERR;   
}

/**************************************************************************************

    

**************************************************************************************/  

INT LTR212_EvaluateFlashCRC(PTLTR212 hnd, WORD *Flash_CRC)
{

	INT Flash_Size=510;//510; //      
	BYTE Flash_Byte_CRC;
	BYTE Flash_Content[510];
	INT i;
	INT err;

	Flash_Byte_CRC=0;
	*Flash_CRC=0;

	err=LTR212_ReadEEPROM(hnd, Flash_Size, 0, Flash_Content);
	if (err) return(err); 

	for(i=0;i<Flash_Size;i++)
	{

		Flash_Byte_CRC=Flash_Content[i];
		UpdateCRC16(Flash_CRC, Flash_Byte_CRC);
	} 

	return LTR212_NO_ERR;   
}


/********************************************************************************

     

**********************************************************************************/   

LTR212API_DllExport (INT) LTR212_TestInterfaceStart(PTLTR212 hnd, INT PackDelay)
{

	DWORD command=0;
	DWORD command_ack;
	INT parity;
	INT slot_num     =hnd->Channel.cc -1;     
	INT err;

	command=PackDelay;
	command<<=24;  
	command|=TEST_INTERFACE|slot_num<<8;

	//   
	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)                                            
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_START_INTERFACE_TEST;

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_START_INTERFACE_TEST;

	//    
	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_START_INTERFACE_TEST;  	

	return LTR212_NO_ERR; 

}


static const INT min_range_id = -2000;

const LPCSTR err_str[] = 
{
	"LTR212:     !",
	"LTR212:   !",
	"LTR212:  !",
	"LTR212:  !",
	"LTR212:  !",
	"LTR212:  !",
	"LTR212:  BIOS!",
	"LTR212:  !",
	"LTR212:   !",
	"LTR212:    !",
	"LTR212:  -!",
	"LTR212:  -!",
	"LTR212:   AD7730!",
	"LTR212:  AD7730!",
	"LTR212:     AD7730!",
	"LTR212:     AD7730!",
	"LTR212:  !",
	"LTR212:   !",
	"LTR212:   !",
	"LTR212:  !",
	"LTR212:    !",
	"LTR212:   !",
	"LTR212:  !",
	"LTR212: /  !",
	"LTR212:   !",
	"LTR212:  (   )!",
	"LTR212:    !",
	"LTR212:        !",
	"LTR212:    !",
	"LTR212:  !",
	"LTR212:  (  )!",
	"LTR212:       !",
	"LTR212:    !",
	"LTR212:       !",
	"LTR212:        ",
	"LTR212:     !", 
	"LTR212:   !",
	"LTR212:    !",
	"LTR212:   !",
	"LTR212:    !!",
	"LTR212:   !",
	"LTR212:    . ,      !",
	"LTR212:   -!"   
};

LTR212API_DllExport (LPCSTR) LTR212_GetErrorString(INT Error_Code)
{
	LPCSTR ret_val = NULL;
	INT ret_val_index;
	double error_range;

	error_range=-min_range_id + 1+sizeof err_str / sizeof err_str[0];

	if ((-Error_Code < -min_range_id )|| (Error_Code < -error_range/*-min_range_id + 1+sizeof err_str / sizeof err_str[0]*/))
	{
		ret_val = LTR_GetErrorString(Error_Code);
	}
	else
	{
		ret_val_index=-Error_Code + min_range_id-1;
		ret_val = err_str[ret_val_index];
	}

	return ret_val;
}


/**************************************************************************************************

     ,    

**************************************************************************************************/  

INT LTR212_SetADCcalibr(PTLTR212 hnd)
{
	DWORD command[1], command_ack[8];
	DWORD channel_command[8];// dac_command[8];
	DWORD filter_mode; // ,     ,     
	DWORD L_SKIP, L_CHOP, L_FAST, L_AC, L_DEL, L_UB, L_REF; // 
	INT reg_name;
	INT Phys_Channel, Phys_Channel_Prev;// ,        
	INT Channel_Scale;
	INT Channel_Group;
	INT parity;
	INT i;
	INT cmd_cnt=0; 
	INT Is_IIR_On, Is_FIR_On;
	INT slot_num     =hnd->Channel.cc -1; 
	WORD Channel_Mode;
	INT err=0;
	BYTE tmp_mask;

	INT CHOP[3]={0,1,1};
	INT SKIP[3]={0,0,0};
	INT FAST[3]={0,0,0};   
	INT Fdivider[3]={2048,682,682};


	/***       ***
	(       : 1,3,5,7,2,4,6,8)
	 -   ,       */


	if(hnd==NULL)
		return LTR212_ERR_INVALID_DESCR; 

	if(hnd->LChQnt==0||hnd->LChQnt>LTR212_MAX_LChQnt)
		return LTR212_ERR_INVALID_SLOT_NUM;



	for(i=0;i<hnd->LChQnt;i++)                               
	{
		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;                                              
		Phys_Channel=(hnd->LChTbl[i])>>16;     

		if((Phys_Channel<1)||(Phys_Channel>8))    
			return LTR212_ERR_WRONG_VCH_SETTINGS;     

		if((Channel_Scale<0)||(Channel_Scale>=8))                  
			return LTR212_ERR_WRONG_VCH_SETTINGS;     

		if(i==0) 
			continue;

		Phys_Channel_Prev=(hnd->LChTbl[i-1])>>16;  

		if(Phys_Channel<=Phys_Channel_Prev)                  
			return LTR212_ERR_WRONG_VCH_SETTINGS;               
	}                                                

	//     ,      
	if(hnd->UseFabricClb)                                             
	{                                                              
		if(hnd->UseClb==1)                                              
			return LTR212_ERR_CANT_USE_FABRIC_AND_USER_CALIBR_SYM;       

		tmp_mask=0xFF;                                                              
		err=LTR212_Calibrate(hnd, &tmp_mask, 2,1); ///????????????????????????????????????????????????????????									    
		if(err) return err;                                           
	}   

	//   ,  ,  . ,      

	for(i=0;i<hnd->LChQnt;i++)
	{
		Phys_Channel=(hnd->LChTbl[i])>>16;


		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;
		Channel_Mode=0;

		Phys_Channel-=1;

		if(Phys_Channel<4)
			Channel_Group=0;
		else
			Channel_Group=1; 

		if(Channel_Scale<4)
			Channel_Mode=Channel_Scale;
		else
			Channel_Mode=Channel_Scale-4;

		Channel_Mode<<=4;

		if(Channel_Scale>3)   // ,         
		{
			L_UB=1;
			L_UB<<=12;
			Channel_Mode|=L_UB;
		} 

		L_REF=hnd->REF;
		L_REF<<=7;

		Channel_Mode|=L_REF;    

		Channel_Mode|=(Phys_Channel<<13);
		Channel_Mode|=Channel_Group;

		//  24- !!!!!
		//***************************

		if(!((hnd->filter.IIR)||(hnd->filter.FIR)))
			Channel_Mode|=0x0100;
		//****************************

		channel_command[cmd_cnt]=Channel_Mode;
		channel_command[cmd_cnt]<<=16;
		channel_command[cmd_cnt]|=LOAD_CHANNEL|(slot_num<<8);

		parity=eval_parity(channel_command[cmd_cnt]);
		channel_command[cmd_cnt]|=(parity)<<5;

		cmd_cnt++;

	}  //   for i  


	//     

	if((err=(LTR_Send(&(hnd->Channel), channel_command, cmd_cnt, TIMEOUT_CMD_SEND)))!=cmd_cnt) //                  
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_SET_ADC;   

	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, cmd_cnt, TIMEOUT_CMD_RECIEVE)))!=cmd_cnt) //    
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SET_ADC;

	for(i=0;i<cmd_cnt;i++)  
	{
		//    
		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR; 

		if((command_ack[i]&0x0000FFDF)!=(channel_command[i]&0x0000FFDF))  
			return LTR212_ERR_CANT_SET_ADC; 
	}   


	//     

	L_REF=hnd->REF;

	command[0]=L_REF;
	command[0]<<=16;
	command[0]|=SET_REF|(slot_num<<8);

	//   
	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<1) //    
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SET_ADC;  


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SET_ADC;


	//    
	if(check_parity(command_ack[0]))
		return LTR212_ERR_PARITY_ERROR;  

	if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_MANAGE_FILTERS; 


	if(CHOP[hnd->AcqMode]==0)					//  Fdivider   
		if(SKIP[hnd->AcqMode]==0)
		{
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<150))
				return LTR212_ERR_WRONG_ADC_SETTINGS;
		}
		else
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<40))
				return LTR212_ERR_WRONG_ADC_SETTINGS;

	if(CHOP[hnd->AcqMode]==1)
		if(SKIP[hnd->AcqMode]==0)
		{
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<75))
				return LTR212_ERR_WRONG_ADC_SETTINGS;
		}
		else
			if((Fdivider[hnd->AcqMode]>2048)||(Fdivider[hnd->AcqMode]<20))
				return LTR212_ERR_WRONG_ADC_SETTINGS;


	filter_mode=Fdivider[hnd->AcqMode];
	filter_mode<<=12;  //   12  ,      

	L_SKIP=SKIP[hnd->AcqMode];
	L_SKIP<<=9;		   //   9   -    SKIP
	filter_mode|=L_SKIP;

	L_FAST=FAST[hnd->AcqMode];
	L_FAST<<=8;			//   8   -    FAST 
	filter_mode|=L_FAST;

	L_AC=hnd->AC;
	L_AC<<=5;			//   5   -    AC 
	filter_mode|=L_AC;

	L_CHOP=CHOP[hnd->AcqMode];
	L_CHOP<<=4;			//   4   -    CHOP
	filter_mode|=L_CHOP; 

	L_DEL=0;//hnd->codec.Delay;
	filter_mode|=L_DEL;  //  DL  , ..      


	reg_name=FILTER_REG; 


	for(i=0; i<4; i++) //        
	{
		LTR212_SelectCodec(hnd, i);
		if(err=LTR212_Write_24bitReg(hnd, reg_name, filter_mode))
		{
			return err/*LTR212_ERR_CANT_SET_ADC*/;
		} 
	} 

	//      

	Is_IIR_On=0;
	Is_FIR_On=0;

	command[0]=Is_IIR_On|Is_FIR_On;
	command[0]|=ENA_DIS_FILTERS|(slot_num<<8);

	//   
	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SET_ADC;


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1) //   
		if(err<0)
			return err;
		else
			return LTR212_ERR_CANT_SET_ADC;

	//    
	if(check_parity(command_ack[0]))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack[0])&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack[0]&0x0000FFDF)!=(command[0]&0x0000FFDF))  
		return LTR212_ERR_CANT_MANAGE_FILTERS; 


	return LTR212_NO_ERR;  
}



INT eval_parity(DWORD cmd)
{
	unsigned long index;
	INT           parity;


	parity = 0;
	for (index = 0x01UL; index <= 0x10UL; index <<= 1)
		parity ^= (cmd & index) != 0;  

	//        
	for (index = 0x80000000UL; index >= 0x010000UL; index >>= 1)
		parity ^= (cmd & index) != 0;


	return parity;
}

/***********************************************************************************************

       .

************************************************************************************************/         

INT check_parity(DWORD cmd)
{
	if(((cmd&0x20)>>5)==eval_parity(cmd))
		return(0);
	else
		return(1);
}   


/*********************************************************************************************

    

*********************************************************************************************/

INT LTR212_LoadClbCoeffs(PTLTR212 hnd) 
{
	INT i;
	INT j=0;
	DWORD command[100];
	DWORD command_ack[100]; 
	INT Phys_Channel;
	INT Channel_Group;
	INT slot_num     =hnd->Channel.cc -1;  
	INT parity;
	INT err;
	WORD ModeReg_Val;

	INT Reg_HByte;
	INT Reg_MByte;
	INT Reg_LByte;
	INT EEPROM_Addr;
	BYTE Data[56];

	INT Codec;
	INT d=0;

	EEPROM_Addr=0;

	LTR212_ReadEEPROM(hnd,56,EEPROM_Addr, Data);

	for(i=0;i<hnd->LChQnt;i++)
	{
		Phys_Channel=((hnd->LChTbl[i])>>16)-1;

		if(Phys_Channel<4)
			Channel_Group=0;
		else
			Channel_Group=1;   

		if(!Channel_Group)
			ModeReg_Val=0x1B0;
		else
			ModeReg_Val=0x1B1;



		//  

		if((Phys_Channel==0)||(Phys_Channel==4))                                                               	                                                                                                                  
			Codec=0;                                                                                               	                                                                                                                  

		if((Phys_Channel==1)||(Phys_Channel==5))                                                                 	                                                                                                                  
			Codec=1;                                                                                               	                                                                                                                  

		if((Phys_Channel==2)||(Phys_Channel==6))                                                                 	                                                                                                                  
			Codec=2;                                                                                               	                                                                                                                  

		if((Phys_Channel==3)||(Phys_Channel==7))  
			Codec=3;  




		command[j]=Codec;
		command[j]<<=16;
		command[j]|=SEL_CODEC|(slot_num<<8); 

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;  


		j++;

		//    



		command[j]=COMM_REG_WR | MODE_REG; //       
		command[j]<<=16;
		command[j]|=WRITE_8REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;
		j++;               


		//         
		command[j]=ModeReg_Val;
		command[j]<<=16;
		command[j]|=WRITE_16REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		//        

		//  24-  

		Reg_HByte=Data[7*Phys_Channel+2];
		Reg_MByte=Data[7*Phys_Channel+1];
		Reg_LByte=Data[7*Phys_Channel];


		command[j]=COMM_REG_WR | OFFSET_REG; //       
		command[j]<<=16;				  //   
		command[j]|=WRITE_8REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		//     8   24- 


		/*high_8bit=//value&0x00FF0000;
		last_16bit=value&0x0000FFFF; */

		command[j]=(Reg_HByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		command[j]=(Reg_MByte<<24);
		command[j]|=(Reg_LByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);


		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		//  24-  

		Reg_HByte=Data[7*Phys_Channel+5];
		Reg_MByte=Data[7*Phys_Channel+4];
		Reg_LByte=Data[7*Phys_Channel+3];


		command[j]=COMM_REG_WR | GAIN_REG; //       
		command[j]<<=16;				   //   
		command[j]|=WRITE_8REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		//     8   24- 


		/*high_8bit=//value&0x00FF0000;
		last_16bit=value&0x0000FFFF; */

		command[j]=(Reg_HByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		command[j]=(Reg_MByte<<24);
		command[j]|=(Reg_LByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);


		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		//    .     


		command[j]=Phys_Channel;
		command[j]<<=24;

		command[j]|=(Data[7*Phys_Channel+6]<<16);
		command[j]|=LOAD_DAC|(slot_num<<8); //       .    DSP

		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;   




	} //  for(i...)

	if((err=(LTR_Send(&(hnd->Channel), command, j, TIMEOUT_CMD_SEND)))<j)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;  


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, j-2*hnd->LChQnt, TIMEOUT_CMD_RECIEVE)))<(j-2*hnd->LChQnt))
		if(err<0)
			return err;
		else 							  
			return LTR212_ERR_CANT_READ_REG;  





	for(i=0;i<(j-2*hnd->LChQnt);i++)
	{

		if((command_ack[i]&0xF0DF)==WRITE_24REG)
			d++;

		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR;   

		if((command_ack[i]&0x0000FFDF)!=(command[i+d]&0x0000FFDF))  
			return LTR212_ERR_CANT_WRITE_EEPROM;         

	}               




	return LTR212_NO_ERR;  
}

/*************************************************************************************

     

*************************************************************************************/


INT LTR212_LoadFabricClbCoeffs(PTLTR212 hnd) 
{
	INT i;
	INT j=0;
	DWORD command[100];
	DWORD command_ack[100]; 
	INT Phys_Channel;
	INT Channel_Group;
	INT slot_num     =hnd->Channel.cc -1;  
	INT parity;
	INT err;
	WORD ModeReg_Val;

	INT Reg_HByte;
	INT Reg_MByte;
	INT Reg_LByte;
	INT EEPROM_Addr;
	BYTE Data[384];

	INT Codec;
	INT d=0;
	INT Internal_Calibr_Offset;
	INT Channel_Scale;

	EEPROM_Addr=100;

	LTR212_ReadEEPROM(hnd,384,EEPROM_Addr, Data);

	for(i=0;i<hnd->LChQnt;i++)
	{
		Phys_Channel=((hnd->LChTbl[i])>>16)-1;
		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;    


		Internal_Calibr_Offset=Phys_Channel*6+Channel_Scale*48;

		if(Phys_Channel<4)
			Channel_Group=0;
		else
			Channel_Group=1;   

		if(!Channel_Group)
			ModeReg_Val=0x1B0;
		else
			ModeReg_Val=0x1B1;

		/*continue; */

		//  

		if((Phys_Channel==0)||(Phys_Channel==4))                                                               	                                                                                                                  
			Codec=0;                                                                                               	                                                                                                                  

		if((Phys_Channel==1)||(Phys_Channel==5))                                                                 	                                                                                                                  
			Codec=1;                                                                                               	                                                                                                                  

		if((Phys_Channel==2)||(Phys_Channel==6))                                                                 	                                                                                                                  
			Codec=2;                                                                                               	                                                                                                                  

		if((Phys_Channel==3)||(Phys_Channel==7))  
			Codec=3;  




		command[j]=Codec;
		command[j]<<=16;
		command[j]|=SEL_CODEC|(slot_num<<8); 

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;  

		/* if((err=(LTR_Send(&(hnd->Channel), &command, 1, 2000)))<1)
		if(err<0)
		return err;
		else 
		return LTR212_ERR_CANT_SELECT_CODEC;   */

		j++;

		//    



		command[j]=COMM_REG_WR | MODE_REG; //       
		command[j]<<=16;
		command[j]|=WRITE_8REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;
		j++;               


		//         
		command[j]=ModeReg_Val;
		command[j]<<=16;
		command[j]|=WRITE_16REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		//        

		//  24-  

		if(!hnd->AC)
		{
			Reg_HByte=Data[Internal_Calibr_Offset+2];
			Reg_MByte=Data[Internal_Calibr_Offset+1];
			Reg_LByte=Data[Internal_Calibr_Offset];
		}
		else
		{
			Reg_HByte=0x80;
			Reg_MByte=0x0;
			Reg_LByte=0x0;
		}  




		command[j]=COMM_REG_WR | OFFSET_REG; //       
		command[j]<<=16;				  //   
		command[j]|=WRITE_8REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		//     8   24- 


		/*high_8bit=//value&0x00FF0000;
		last_16bit=value&0x0000FFFF; */

		command[j]=(Reg_HByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		command[j]=(Reg_MByte<<24);
		command[j]|=(Reg_LByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);


		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		//  24-  

		Reg_HByte=Data[Internal_Calibr_Offset+5];
		Reg_MByte=Data[Internal_Calibr_Offset+4];
		Reg_LByte=Data[Internal_Calibr_Offset+3];


		command[j]=COMM_REG_WR | GAIN_REG; //       
		command[j]<<=16;				   //   
		command[j]|=WRITE_8REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		//     8   24- 


		/*high_8bit=//value&0x00FF0000;
		last_16bit=value&0x0000FFFF; */

		command[j]=(Reg_HByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);

		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		command[j]=(Reg_MByte<<24);
		command[j]|=(Reg_LByte<<16);
		command[j]|=WRITE_24REG|(slot_num<<8);


		//   
		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;



	} //  for(i...)

	if((err=(LTR_Send(&(hnd->Channel), command, j, TIMEOUT_CMD_SEND)))<j)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;  


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, j-2*hnd->LChQnt, TIMEOUT_CMD_RECIEVE)))<(j-2*hnd->LChQnt))
		if(err<0)
			return err;
		else 							  
			return LTR212_ERR_CANT_READ_REG;  





	for(i=0;i<(j-2*hnd->LChQnt);i++)
	{
		if((command_ack[i]&0xF0DF)==WRITE_24REG)
		{
			d++;
		}

		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR;   

		if((command_ack[i]&0x0000FFDF)!=(command[i+d]&0x0000FFDF))  
			return LTR212_ERR_CANT_WRITE_EEPROM;         
	}               

	return LTR212_NO_ERR;  
}


INT LTR212_InternalCalibrProcessing(PTLTR212 hnd, BYTE *LChannel_Mask) 
{
	INT i;
	INT j=0;
	DWORD command[100];
	DWORD command_ack[100]; 
	INT Phys_Channel;
	INT slot_num     =hnd->Channel.cc -1;  
	INT parity;
	INT err;
	INT Reg_HByte;
	INT Reg_MByte;
	INT Reg_LByte;
	INT EEPROM_Addr;
	INT EEPROM_Addr_CalibrAria;

	BYTE Data[384];
	INT d=0;
	INT Internal_Calibr_Offset;
	INT Channel_Scale;

	EEPROM_Addr=100;

	LTR212_ReadEEPROM(hnd,384,EEPROM_Addr, Data);

	for(i=0;i<hnd->LChQnt;i++)
	{

		if(!((*LChannel_Mask>>i)&0x1))         
			continue;

		Phys_Channel=((hnd->LChTbl[i])>>16)-1;
		Channel_Scale=(hnd->LChTbl[i])&0x0000FFFF;    


		Internal_Calibr_Offset=Phys_Channel*6+Channel_Scale*48;
		EEPROM_Addr_CalibrAria=Phys_Channel*7;



		//        

		//  .  - 

		if(!hnd->AC)
		{
			Reg_HByte=Data[Internal_Calibr_Offset+2];
			Reg_MByte=Data[Internal_Calibr_Offset+1];
			Reg_LByte=Data[Internal_Calibr_Offset];
		}
		else
		{
			Reg_HByte=0x80;
			Reg_MByte=0x0;
			Reg_LByte=0x0;
		}  



		//         

		//     


		command[j]=Phys_Channel*7+2; //   
		command[j]<<=16;
		command[j]|=WR_FLASH|(slot_num<<8);  //    DSP

		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++; 

		command[j]=Reg_HByte; //   
		command[j]<<=16;
		command[j]|=WR_FLASH|(slot_num<<8);

		parity=eval_parity(command[2*i+1]);
		command[j]|=(parity)<<5;

		j++;

		//     

		command[j]=Phys_Channel*7+1; //   
		command[j]<<=16;
		command[j]|=WR_FLASH|(slot_num<<8);  //    DSP

		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;

		command[j]=Reg_MByte; //   
		command[j]<<=16;
		command[j]|=WR_FLASH|(slot_num<<8);

		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		//     

		command[j]=Phys_Channel*7; //   
		command[j]<<=16;
		command[j]|=WR_FLASH|(slot_num<<8);  //    DSP

		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


		command[j]=Reg_LByte; //   
		command[j]<<=16;
		command[j]|=WR_FLASH|(slot_num<<8);

		parity=eval_parity(command[j]);
		command[j]|=(parity)<<5;

		j++;


	} //  for(i...)

	if((err=(LTR_Send(&(hnd->Channel), command, j, TIMEOUT_CMD_SEND)))<j)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_READ_REG;  


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, j-2*hnd->LChQnt, TIMEOUT_CMD_RECIEVE)))<(j-2*hnd->LChQnt))
		if(err<0)
			return err;
		else 							  
			return LTR212_ERR_CANT_READ_REG;  





	for(i=0;i<(j-2*hnd->LChQnt);i++)
	{

		if((command_ack[i]&0xF0DF)==WRITE_24REG)
		{
			d++;

		}

		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR;   

		if((command_ack[i]&0x0000FFDF)!=(command[i+d]&0x0000FFDF))  
			return LTR212_ERR_CANT_WRITE_EEPROM;         

	}               




	return LTR212_NO_ERR;  
}

/************************************************************************************

   

*************************************************************************************/


INT LTR212_ReadBiosVersion(PTLTR212 hnd, CHAR *version)
{
	BYTE Major_Version, Minor_Version;
	DWORD command, command_ack;
	INT slot_num     =hnd->Channel.cc -1;  
	INT parity;
	INT err;

	command=GET_SW_VER|(slot_num<<8);

	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_GET_VER;  


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))<1)
		if(err<0)
			return err;
		else 							  
			return LTR212_ERR_CANT_GET_VER;  

	if(check_parity(command_ack))
		return LTR212_ERR_PARITY_ERROR;  


	if(((command_ack)&0xFFDF)==(PARITY_ERR|slot_num<<8))
		return LTR212_ERR_PARITY_ERROR; 

	if((command_ack&0x0000FFDF)!=(command&0x0000FFDF))  
		return LTR212_ERR_CANT_GET_VER;

	Minor_Version=(command_ack>>16)&0xFF;
	Major_Version=(command_ack>>24)&0xFF;

	sprintf(version, "%d.%d",Major_Version, Minor_Version);	     

	return LTR212_NO_ERR; 
} 


/*****************************************************************************

    

*******************************************************************************/     

INT LTR212_ReadBiosDate(PTLTR212 hnd, CHAR *date)
{

	BYTE Month, Day;
	WORD Year;
	DWORD command, command_ack[2];
	INT slot_num     =hnd->Channel.cc -1;  
	INT parity;
	INT err;
	INT i;


	command=GET_SW_DATE|(slot_num<<8);

	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))<1)
		if(err<0)
			return err;
		else 
			return LTR212_ERR_CANT_GET_VER;  

	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 2, TIMEOUT_CMD_RECIEVE)))<2)
		if(err<0)
			return err;
		else 							  
			return LTR212_ERR_CANT_GET_DATE;  

	for(i=0;i<2;i++)
	{
		if(check_parity(command_ack[i]))
			return LTR212_ERR_PARITY_ERROR;  

		if(((command_ack[i])&0xFFDF)==(PARITY_ERR|slot_num<<8))
			return LTR212_ERR_PARITY_ERROR; 

		if((command_ack[i]&0x0000FFDF)!=(command&0x0000FFDF))  
			return LTR212_ERR_CANT_GET_DATE;
	}	     

	Year=(command_ack[0]>>16);
	Day=(command_ack[1]>>16)&0xFF;
	Month=(command_ack[1]>>24)&0xFF;

	sprintf(date, "%d.%d.%d",Day, Month, Year);	   

	return LTR212_NO_ERR; 
} 

/********************************************************************************

   

**********************************************************************************/   


INT LTR212_ReadModuleName(PTLTR212 hnd, CHAR ModuleName[7])
{
	INT EEPROM_Addr=80;

	LTR212_ReadEEPROM(hnd, 7, EEPROM_Addr, (BYTE *) ModuleName);  



	return LTR212_NO_ERR; 
}


/**********************************************************************************

        

**********************************************************************************/ 

LTR212API_DllExport (DWORD) LTR212_CalcTimeOut(PTLTR212 hnd, DWORD n)
{

	//  n-    !
	double to;
	double Fs[3]={7680, 150.1, 3.4}; 
	int AcqMode=hnd->AcqMode;
	int div;
	int div1;

	if((hnd->filter.IIR)||(hnd->filter.IIR))
		div=2;
	else
		div=1;


	if(hnd->filter.FIR)
		div1=hnd->filter.Decimation;
	else
		div1=1; 

	//to=1E+3*(n*(1/Fs[AcqMode]))+TIMEOUT_CMD_RECIEVE;

	to=(int) (((1000*div1*n)/(Fs[AcqMode]))+TIMEOUT_CMD_RECIEVE);

	return(to);

}

static DWORD CalkTickInterval(DWORD PrevTick, DWORD ActTick)
{
	DWORD Diff;

	if(ActTick>=PrevTick)
		Diff=ActTick-PrevTick;
	else
		Diff=(0xFFFFFFFF-PrevTick)+ActTick;

	return Diff;

}

#ifdef _MANAGED
#pragma managed(pop)
#endif
