program Project2;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  ltr22api in 'ltr22api.pas';


Procedure TestADCStartStop(module:TLTR22);
var
        Res:Integer;
        Values:array [0..1000] of Double;
        ValuesSource:array [0..1000] of Cardinal;
begin
     Res:=LTR22_StartADC(@module, false);
     if (Res=LTR_OK) then
     begin
        Res:=LTR22_Recv(@module, @ValuesSource,nil,1000,600);
        if (Res=1000) then
        begin
             Res:=LTR22_StopADC(@module);
             if (Res=LTR_OK) then
             begin
                 Res:=LTR22_ClearBuffer(@module, true);
                 if (Res=LTR_OK) then
                 begin
                        Res:=LTR22_ProcessData(@module,@ValuesSource,@Values,1000,false,false,nil);
                        if (Res<>LTR_OK) then
                         Writeln('Error Processing Data ',Res);
                 end
                 else Writeln('Error Clearing Buffers ',Res);

             end
             else Writeln('Error Stopping ADC ',Res);

        end
        else Writeln('Error ADC Data ',Res);
     end
     else Writeln('Error Starting ADC ',Res);

     if Res=LTR_OK then Writeln('Testing ReadWrite Successfull'); 
     
end;


var
        module:TLTR22;
        Handle: Cardinal;
        gg:string;
        Res:Integer;
        Counter:Integer;
        LTR34_InitTest:function(module1:pTLTR22):Integer;
        EEPROMData:array [0..8192] of Byte;
begin
  { TODO -oUser -cConsole Main : Insert code here }

  Handle := LoadLibrary('ltr22api.dll');
  if Handle=0 then Writeln('Error Load Dll');
  @LTR34_InitTest:=GetProcAddress(Handle, 'LTR22_Init');
  if @LTR34_InitTest=nil then Writeln('Error Load LTR22_Init');

  Res:=LTR22_Open(@module,module.Channel.saddr,module.Channel.sport,@module.Channel.csn,5);
  if Res=LTR_WARNING_MODULE_IN_USE then
  begin
        Writeln('Warning Module already opened anywhere');
        Res:=LTR_OK;
  end;

  if Res=LTR_OK then
  begin
        Writeln('Module Open Succesfull');
        module.ADCChannelRange[0]:=3;
        module.ADCChannelRange[1]:=2;
        module.ADCChannelRange[2]:=3;
        module.ADCChannelRange[3]:=0;
        Res:=LTR22_SetConfig(@module);
        if Res=LTR_OK then
        begin
                Res:=LTR22_GetConfig(@module);
                if (Res<>LTR_OK) then Writeln('Error Reading module Configuration ',Res);

                TestADCStartStop(module);

                Res:=LTR22_GetModuleDescription(@module);
                if (Res<>LTR_OK) then Writeln('Error Reading module Description ',Res);

                Res:=LTR22_GetCalibrovka(@module);
                if (Res<>LTR_OK) then Writeln('Error Reading module Calibration ',Res);

                for Counter := 0 to 512 do
                  EEPROMData[Counter]:=Counter;

                Res:=LTR22_WriteAVREEPROM(@module, @EEPROMData,0,512);
                if (Res<>LTR_OK) then Writeln('Error Writing EEPROM ',Res);

                for Counter := 0 to 512 do
                  EEPROMData[Counter]:=0;

                Res:=LTR22_ReadAVREEPROM(@module, @EEPROMData,0,512);
                if (Res<>LTR_OK) then Writeln('Error Reading EEPROM ',Res);
        end
        else Writeln('Error Setting Configuration ',Res);

        Res:=LTR22_Close(@module);
        if (Res<>LTR_OK) then Writeln('Error Close module ',Res);
  end
  else Writeln('Error Open module ',Res);
  
  if Res=LTR_OK then Writeln('All Right ! :-)');

  Writeln('Enter any value to exit from application');
  Read(gg);
end.


