// LTR22api.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "ltr\include\ltr22api.h"

#ifdef _MANAGED
#pragma managed(push, off)
#endif

#define _DEBUG_MY

#define LTR22CMD_Measure_ADC_ZERO_START_STOP			(LTR010CMD_INSTR|1)
#define LTR22CMD_AC_AC_DC_STATE							(LTR010CMD_INSTR|2)
#define LTR22CMD_SET_ADC_RANGE							(LTR010CMD_INSTR|3)

#define LTR22CMD_SET_ADC_MAIN_DIV						(LTR010CMD_INSTR|4)
#define LTR22CMD_SET_ADC_EXTRA_DIV						(LTR010CMD_INSTR|5)

#define LTR22CMD_GET_MODULE_CONFIG						(LTR010CMD_INSTR|6)
#define LTR22CMD_GET_MODULE_CALIBROVKA					(LTR010CMD_INSTR|7)

#define LTR22CMD_GET_MODULE_DESCRIPTION					(LTR010CMD_INSTR|8)

#define LTR22CMD_PREPARE_READ_WRITE_EEPROM_ADDRESS		(LTR010CMD_INSTR|9)
#define LTR22CMD_WRITE_EEPROM							(LTR010CMD_INSTR|10)
#define LTR22CMD_READ_EEPROM							(LTR010CMD_INSTR|11)

#define LTR22CMD_SET_ADC_CHANNEL						(LTR010CMD_INSTR|12)

#define LTR22CMD_SET_ADC1234_REGISTER					(LTR010CMD_INSTR|14)
#define LTR22CMD_SET_ADC_FREQ_REGISTER					(LTR010CMD_INSTR|15)
#define LTR22CMD_SET_ADC_SCOPE_REGISTER					(LTR010CMD_INSTR|16)
#define LTR22CMD_SET_ADC_CH_SYNC_REGISTER				(LTR010CMD_INSTR|17)

#define LTR22CMD_SYNC_PHAZE								(LTR010CMD_INSTR|18)
#define LTR22CMD_SET_SYNC_PRIORITY						(LTR010CMD_INSTR|19)

#define LTR22CMD_START_ADC								(LTR010CMD_INSTR|40)
#define LTR22CMD_STOP_ADC								(LTR010CMD_INSTR|41)

#define LTR22CMD_TEST_RUNNING_UNIT						(LTR010CMD_INSTR|50)
#define LTR22CMD_TEST_RUNNING_ZERO						(LTR010CMD_INSTR|51)
#define LTR22CMD_TEST_ECHO								(LTR010CMD_INSTR|52)

#define LTR22CMD_GET_ECHO								(LTR010CMD_INSTR|63)

#define TIMEOUT_CMD_SEND								2000
#define TIMEOUT_CMD_RECIEVE								4000

	
const LPCSTR               err_str[] =
{
    "  ",
    "  ",
    "  -   LTR22",
    "   ",	
    " ,    ",	
    "     ",
    "  ",
    "     ",
    "        ",
    "   - ",
    "  AVR  ",
    "   AVR",
    "   AVR",
	 "    LTR22"    
};

LTR22API_Export const int LTR22_DISK_FREQ_ARRAY[LTR22_MAX_DISC_FREQ_NUMBER]=
{
	3472,  3720,   4006,  4340,  4734,  5208,  5580,  5787,
	6009,  6510,   7102,  7440,  7812,  8680,  9765,  10416, 
	11160, 13020, 15625,  17361, 19531, 26041, 39062, 52083, 
	78125
};


BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
	switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
		break;
	}
    return TRUE;
}

DWORD ConvertSToModuleFormat (bool Command, byte CommandData, WORD Data)
{
	DWORD	DDD=Data,
			NNN=CommandData,
			BitC=Command;
	return DDD|(CommandData<<16)|(BitC<<24);	
}

bool NormalizeTypeBool(bool Data)
{
	if (((byte)Data)>=1)return true;
	else return false;
}


int ResetModule(TLTR22 *module)
{	
	int res=LTR_OK;
	const int  RBUF_SIZE=1;	
	DWORD rbuf[RBUF_SIZE];			
	DWORD Command=LTR010CMD_RESET;		

	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{			
		if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_SEND)==RBUF_SIZE)
		{	
			if ((rbuf[0]&0xff)!=0x80) res=LTR22_ERROR_MODULE_INTERFACE;
		}
		else res=LTR_ERROR_RECV;
	}
	else res=LTR_ERROR_SEND;

	Sleep(140); //    ,      

	return res;
}

int StopModule(TLTR22 *module)
{
	int res=LTR_OK;
	const int  RBUF_SIZE=1;	
	DWORD Command=LTR010CMD_STOP;	

	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{			
		
	}else res=LTR_ERROR_SEND;

	return res;
}

int ReconnectModule(TLTR22 *module)
{
	int res=LTR_OK;

	res=StopModule(module);
	if (res==LTR_OK)
	{
		res=ResetModule(module);
		if (res=LTR_OK)
		{
			res=StopModule(module);
		}
	}
	return res;
}



int PrepareToWriteMemory(TLTR22 *module)
{
	int res=LTR_OK;
	const int 
		SBUF_SIZE=2,
		RBUF_SIZE=2;
	DWORD sbuf[SBUF_SIZE];
	DWORD rbuf[RBUF_SIZE];	

	sbuf[0]=LTR010CMD_PROGR|(0xAC53<<16);	// Prepare to write
	sbuf[1]=LTR010CMD_PROGR;				// Prepare to write

	res =ReconnectModule(module);
	if (res==LTR_OK)
	{
		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{	
				if ((rbuf[1]>>24)!=0x53) res=LTR22_ERROR_PRERARE_TO_WRITE;
			}else res=LTR_ERROR_RECV;
		}else res=LTR_ERROR_SEND;
	}

	return res;
}

int ChipErase(TLTR22 *module)
{
	int res=LTR_OK;
	const int 
		SBUF_SIZE=2,
		RBUF_SIZE=2;
	DWORD sbuf[SBUF_SIZE];
	DWORD rbuf[RBUF_SIZE];	
	sbuf[0]=LTR010CMD_PROGR|(0xAC80<<16);	// chip erase
	sbuf[1]=LTR010CMD_PROGR;				// chip erase
	

	res=PrepareToWriteMemory(module);

	if (res==LTR_OK)
	{	
		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{				
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{	
				res=StopModule(module);
			}else res=LTR_ERROR_RECV;
		}else res=LTR_ERROR_SEND;	
	}
	return res;
}

int WriteModuleMemory(TLTR22 *module, int BeginPageNumber, byte * Data, DWORD size, bool MadeChipErase)
{
	int res=LTR_OK;
	const int 
		SBUF_SIZE=(4*32)+2,
		RBUF_SIZE=SBUF_SIZE;
	DWORD sbuf[SBUF_SIZE];
	DWORD rbuf[RBUF_SIZE];	
	int NumPages=size/64;	
	int CounterDataWrite=0;
	int CounterDataRead=0;	

	MadeChipErase=NormalizeTypeBool(MadeChipErase);


	sbuf[0]=LTR010CMD_STOP;
	sbuf[1]=LTR010CMD_RESET;
	LTR_Send(&module->Channel,sbuf,2,1000);
	LTR_Recv(&module->Channel,sbuf,NULL,1,1000);
	while (LTR_Recv(&module->Channel,sbuf,NULL,SBUF_SIZE,1000)>0)Sleep(1);
	//         

	if (MadeChipErase) res=ChipErase(module);	
	if (res==LTR_OK)
	{
		res=PrepareToWriteMemory(module);
		if (res==LTR_OK)
		{
			for (int PageCount=BeginPageNumber;(PageCount<BeginPageNumber+NumPages)&&(res==LTR_OK);PageCount++)
			{
				for (int address=0;address<32;address++,CounterDataWrite+=2)
				{
					//  
					sbuf[4*address] = LTR010CMD_PROGR|(0x4000<<16);
					sbuf[4*address+1] = LTR010CMD_PROGR|(((address<<8)|Data[CounterDataWrite])<<16);					

					//  
					sbuf[4*address+2] = LTR010CMD_PROGR|(0x4800<<16);
					sbuf[4*address+3] = LTR010CMD_PROGR|(((address<<8)|Data[CounterDataWrite+1])<<16);;																
				}

				sbuf[SBUF_SIZE-2] = LTR010CMD_PROGR|(((DWORD)(0x4c00|(PageCount>>3)))<<16);
				sbuf[SBUF_SIZE-1] = LTR010CMD_PROGR|(((DWORD)(PageCount<<13))<<16);

				if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
				{
					if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, 10000)==RBUF_SIZE)
					{	
						for (int i=2;i<RBUF_SIZE-1;i+=2,CounterDataRead++)
						{
							if ((rbuf[i]>>24)!=Data[CounterDataRead])
							{
								res=LTR22_ERROR_WRITE_AVR_MEMORY;												
							}
						}
					}
					else 
					{
						res=LTR_ERROR_RECV;
						PageCount=1000;
					};
				}
				else 
				{
					res=LTR_ERROR_SEND;
					PageCount=1000;
				};
			}
		}
	}

	sbuf[0]=LTR010CMD_STOP;
	sbuf[1]=LTR010CMD_RESET;
	sbuf[1]=LTR010CMD_STOP;
	LTR_Send(&module->Channel,sbuf,3,1000);
	LTR_Recv(&module->Channel,sbuf,NULL,1,1000);
	while (LTR_Recv(&module->Channel,sbuf,NULL,SBUF_SIZE,1000)>0)Sleep(1);

	return res;
}

int ReadModuleMemory(TLTR22 *module, int BeginPageNumber, byte * Data, DWORD Pages)
{
	int res=LTR_OK;
	const int 
		SBUF_SIZE=(4*256),
		RBUF_SIZE=SBUF_SIZE;
	DWORD sbuf[SBUF_SIZE];
	DWORD rbuf[RBUF_SIZE];			
	int CounterDataRead=0;	
	
	BeginPageNumber=min(BeginPageNumber,16);
	Pages=min((DWORD)max(16-BeginPageNumber,0),Pages);

	res=PrepareToWriteMemory(module);
	if (res==LTR_OK)
	{
		for (DWORD PageCount=BeginPageNumber;(PageCount<BeginPageNumber+Pages)&&(res==LTR_OK);PageCount++)
		{
			for (int address=0;address<256;address++)
			{
				sbuf[4*address+0] = LTR010CMD_PROGR|((0x2000|PageCount)<<16);
				sbuf[4*address+1] = LTR010CMD_PROGR|((address<<8)<<16);

				sbuf[4*address+2] = LTR010CMD_PROGR|((0x2800|PageCount)<<16);
				sbuf[4*address+3] = LTR010CMD_PROGR|((address<<8)<<16);																		
			}			

			if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
			{
				if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, 15000)==RBUF_SIZE)
				{	
					for (int i=1;i<RBUF_SIZE;i+=2,CounterDataRead++)
					{
						Data[CounterDataRead]=(byte)((rbuf[i]>>16)&0xff);
						if ((rbuf[i]&0xf0ff)!=0x8040)
						{
							res=LTR22_ERROR_READ_AVR_MEMORY;												
						}
					}
				}
				else 
				{
					res=LTR_ERROR_RECV;
					PageCount=1000;
				};
			}
			else 
			{
				res=LTR_ERROR_SEND;
				PageCount=1000;
			};
		}
	}

	return res;
}

/*
   -  
*/
int TestNewFreq(TLTR22 * module, bool adc384,byte Freq_dv)
{	
	float const UpFreq=20840000.0,
				DownFreq=1280000.0;

	adc384=NormalizeTypeBool(adc384);

	float ClkFreq=20000000.0f/Freq_dv;	
	
	if ((ClkFreq<DownFreq)&&(ClkFreq>UpFreq)) return LTR22_ERROR_INVALID_FREQ_DIV;

	int FreqDisc=(int)(ClkFreq/(128.0f*(adc384+2)));

	int i;
	for (i=0;i<LTR22_MAX_DISC_FREQ_NUMBER;i++)
	{
		if (FreqDisc==LTR22_DISK_FREQ_ARRAY[i])
		{
			module->FreqDiscretizationIndex=i;
			return LTR_OK;
		}
	}

	if (i==LTR22_MAX_DISC_FREQ_NUMBER) return LTR22_ERROR_INVALID_FREQ_DIV;

	return LTR_OK;

}


LTR22API_DllExport(INT) LTR22_Init(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;	

	int res=LTR_OK;

	memset(module,0, sizeof(TLTR22));
	
	res=LTR_Init(&module->Channel);
	if(res==LTR_OK) 
	{	
		module->size=sizeof(TLTR22);
		module->MeasureADCZero=true;
		module->AC_DC_State=true;
		module->Fdiv_rg=4;	
		module->FreqDiscretizationIndex=1;

		//     
		for (int i=0;i<LTR22_ADC_NUMBERS;i++)
		{
			module->ChannelEnabled[i]=true;
			module->ADCChannelRange[i]=4;
		}

		//  - 
		module->SyncType=0; 		

		//    ,    
		for (int f=0;f<LTR22_MAX_DISC_FREQ_NUMBER;f++)
		{
			for (int i=0;i<LTR22_ADC_NUMBERS;i++)
			{			

				module->ADCCalibration[i][f].FactoryCalibScale[0]=1;
				module->ADCCalibration[i][f].FactoryCalibScale[1]=1;
				module->ADCCalibration[i][f].FactoryCalibScale[2]=1;
				module->ADCCalibration[i][f].FactoryCalibScale[3]=1;
				module->ADCCalibration[i][f].FactoryCalibScale[4]=1;
				module->ADCCalibration[i][f].FactoryCalibScale[5]=1;			

				module->ADCCalibration[i][f].UserCalibScale[0]=(float)(2/65536.0);			
				module->ADCCalibration[i][f].UserCalibScale[1]=(float)(0.6/65536.0);			
				module->ADCCalibration[i][f].UserCalibScale[2]=(float)(0.2/65536.0);			
				module->ADCCalibration[i][f].UserCalibScale[3]=(float)(0.06/65536.0);			
				module->ADCCalibration[i][f].UserCalibScale[4]=(float)(20/65536.0);			
				module->ADCCalibration[i][f].UserCalibScale[5]=(float)(6/65536.0);			
			}
		}		
	}

	return res;	
}


LTR22API_DllExport(INT) LTR22_Close(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;
	if (module->DataReadingProcessed)LTR22_StopADC(module);
	
	return LTR_Close(&module->Channel);	
}

LTR22API_DllExport(INT) LTR22_Open(TLTR22 *module, DWORD saddr, WORD sport, CHAR *csn, WORD cc)
{
	int res=LTR_OK;
	int WarningRes=LTR_OK;
	if(module==NULL||csn==NULL) return LTR_ERROR_PARAMETRS;

	
	if (LTR22_IsOpened(module)==LTR_OK)
	{
		res=LTR22_Close(module);
	}	

	if (res==LTR_OK)
	{
		res= LTR22_Init(module);
	}

	if(res==LTR_OK) 
	{
		if (saddr!=0)module->Channel.saddr=saddr;
		if (sport!=0)module->Channel.sport=sport;
		if (csn!=NULL) memcpy(module->Channel.csn, csn, SERIAL_NUMBER_SIZE);
		module->Channel.cc=max(cc,1);			

		WarningRes=LTR_Open(&module->Channel);
		if (WarningRes==LTR_OK||WarningRes==LTR_WARNING_MODULE_IN_USE) res=LTR_OK;
		else res = WarningRes;

		if (res==LTR_OK) res=LTR22_ClearBuffer(module,false);		

		if(res==LTR_OK) 
		{
			const	int SBUF_SIZE=4,
					RBUF_SIZE=1;
			DWORD rbuf[RBUF_SIZE], 
				sbuf[SBUF_SIZE] = {LTR010CMD_STOP,LTR010CMD_RESET,LTR010CMD_STOP};			

			if(LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)!=SBUF_SIZE) res=LTR22_ERROR_SEND_DATA;
			else 
			{
				DWORD EndTime=GetTickCount()+TIMEOUT_CMD_RECIEVE+TIMEOUT_CMD_SEND;
				while(res==LTR_OK&&(GetTickCount()<EndTime)) 
				{
					if(LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)!=RBUF_SIZE) 
					{
						res=LTR22_ERROR_RECV_DATA;
					}
					else 
					{
						if((rbuf[0]&0xC0C0)==LTR010CMD_RESET) 
						{
							if((rbuf[0]>>16)!=LTR22_MODULE_CODE) res=LTR22_ERROR_NOT_LTR22;
							else 
							{
								res=LTR_OK;
								break;
							}
						}
					}
				}
			}

			Sleep(250); //    ,      						

			if(res!=LTR_OK)
				LTR_Close(&module->Channel);
			else
			{
				//    
				res=LTR22_GetCalibrovka(module);
				if (res==LTR_OK)
				{
					res=LTR22_GetModuleDescription(module);
					if(res==LTR_OK)
					{
						res=LTR22_GetConfig(module);
					}
				}
			}
		}
	}

	if (WarningRes==LTR_WARNING_MODULE_IN_USE&&res==LTR_OK) res = WarningRes;
	return res;
}

LTR22API_DllExport(INT) LTR22_IsOpened(TLTR22 *module)
{	
	if(module==NULL) return LTR_ERROR_PARAMETRS;	
	int Res=LTR_IsOpened(&module->Channel);
	return Res;
}

/*
-----------------------------------------------------------------------------------
    
*/
LTR22API_DllExport(INT) LTR22_GetConfig(TLTR22 *module)
{	
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR22_IsOpened(module);
	if(res==LTR_OK) 
	{
		const	int RBUF_SIZE=5;
		
		DWORD Command=LTR22CMD_GET_MODULE_CONFIG;		
		if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
		{			
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if (((rbuf[0]>>16)==6)&& //   
					((rbuf[1]&0xff)==31)&& //    
					((rbuf[2]&0xff)==32)&& //    
					((rbuf[3]&0xff)==33)&& //       
					((rbuf[4]&0xff)==34)) //      
				{ //     					
					module->AC_DC_State=(rbuf[1]>>(16+0))&1;
					module->MeasureADCZero=!((rbuf[1]>>(16+1))&1);
					module->SyncMaster=(rbuf[1]>>(16+3))&1;
					module->DataReadingProcessed=((rbuf[1]>>(16+7))&1);
					

					module->Adc384=(rbuf[2]>>(16+7))&1;
					module->Fdiv_rg=(byte)((rbuf[2]>>16)&0xf);					

					for (int i=0;i<4;i++)
					{
						module->ADCChannelRange[i]=(byte)((rbuf[3]>>(16+(i*4)))&0xf);
						module->ChannelEnabled[i]=(byte)((rbuf[4]>>(16+i))&0x1);
					}

					module->SyncType=(byte)((rbuf[4]>>(16+4))&0x3);

				} 
				else 
				{
					res=LTR22_ERROR_MODULE_INTERFACE;
				}
			} 
			else 
			{
				res=LTR_ERROR_RECV;	
			}
		} else res=LTR_ERROR_SEND;
	}
	return res;
}

/*
-----------------------------------------------------------------------------------
      
*/
LTR22API_DllExport(INT) LTR22_SetConfig(TLTR22 *module)
{	
	if(module==NULL) return LTR_ERROR_PARAMETRS;	
	
	int ADC1234_Register=0,
		ADC_Freq_Register=0,
		ADC_Scope_Register=0,
		ADC_Ch_Sync_Register=0;

	int res=TestNewFreq(module, module->Adc384,module->Fdiv_rg);	

	if (res==LTR_OK) res=LTR22_IsOpened(module);

	if(res==LTR_OK) 
	{
		module->DataReadingProcessed=false; // !!!  -    -    

		ADC1234_Register=(((DWORD)module->AC_DC_State))|
			((!module->MeasureADCZero)<<1)|
			((module->SyncMaster)<<3)|
			((module->DataReadingProcessed)<<7);

		ADC_Freq_Register=	(((DWORD)module->Fdiv_rg))|			
			((module->Adc384)<<7);

		for (int i=0;i<LTR22_ADC_CHANNELS;i++)
		{
			ADC_Scope_Register=ADC_Scope_Register|(module->ADCChannelRange[i]<<(i*4));
			ADC_Ch_Sync_Register=ADC_Ch_Sync_Register|(module->ChannelEnabled[i]<<i);
		}
		
		ADC_Ch_Sync_Register=ADC_Ch_Sync_Register|
			(module->SyncType<<4);
		//module->DataReadingProcessed=true; //       		
		
		const	int SBUF_SIZE=4,
					RBUF_SIZE=4;
		DWORD sbuf[SBUF_SIZE];
		sbuf[0]=LTR22CMD_SET_ADC1234_REGISTER|(ADC1234_Register<<16);		
		sbuf[1]=LTR22CMD_SET_ADC_FREQ_REGISTER|(ADC_Freq_Register<<16);		
		sbuf[2]=LTR22CMD_SET_ADC_SCOPE_REGISTER|(ADC_Scope_Register<<16);		
		sbuf[3]=LTR22CMD_SET_ADC_CH_SYNC_REGISTER|(ADC_Ch_Sync_Register<<16);		

		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{
			
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if (((rbuf[0]>>16)==(LTR22CMD_SET_ADC1234_REGISTER&0x3f))&& 
					((rbuf[1]>>16)==(LTR22CMD_SET_ADC_FREQ_REGISTER&0x3f))&& 
					((rbuf[2]>>16)==(LTR22CMD_SET_ADC_SCOPE_REGISTER&0x3f))&& 
					((rbuf[3]>>16)==(LTR22CMD_SET_ADC_CH_SYNC_REGISTER&0x3f)))
				{ 
					//     					
				} else res=LTR22_ERROR_MODULE_INTERFACE;

			} 
			else 
			{
				res=LTR_ERROR_RECV;	
			}
		} else res=LTR_ERROR_SEND;

		
	}	
	else res=LTR_ERROR_SEND;
	
	return res;
}

/*
-----------------------------------------------------------------------------------
   LTR
*/
LTR22API_DllExport(INT) LTR22_ClearBuffer(TLTR22 *module, bool wait_response)
{	
	int Res=LTR_OK;
	const int RBUF_CLEAR_SIZE=262144*2;	

	if(module==NULL) return LTR_ERROR_PARAMETRS;	


	bool DataFinished=false;		
	DWORD begintime=GetTickCount();

	DWORD *rbuf=new DWORD[RBUF_CLEAR_SIZE];	
	if (rbuf!=NULL)
	{
		if (wait_response)
		{ //      -     
			do
			{			
				Res=LTR_Recv(&module->Channel, rbuf, NULL, RBUF_CLEAR_SIZE, 100);				

				for (int i=0;i<Res;i++)
				{
					if ((rbuf[i]&0xffff00ff)==0xf2f300FE)
					{
						DataFinished=true;
						Res=LTR_OK;
						break;
					}
				}
				Sleep(0);
			}while((!DataFinished)&&((GetTickCount()-begintime)<5000));

			if (!DataFinished)Res=LTR22_ERROR_MODULE_INTERFACE;
			else Res=0;
		}
		else
		{
			while ((Res=LTR_Recv(&module->Channel, rbuf, NULL, RBUF_CLEAR_SIZE, 100))>0)
			{
				if ((rbuf[Res-1]&0xffff00ff)==0xf2f300FE)
				{ //      
					DataFinished=true;
					Res=LTR_OK;
					break;
				}
				Sleep(1);
			}
		}

		delete rbuf; 	
	}
	else Res=LTR_ERROR_MEMORY_ALLOC;

	return Res;
}

LTR22API_DllExport(INT) LTR22_SetSyncPriority(TLTR22 *module, bool SyncMaster)
{
	//    
	if(module==	NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;	
	const int	RBUF_SIZE=1;	

	SyncMaster=NormalizeTypeBool(SyncMaster);	

	DWORD Command=LTR22CMD_SET_SYNC_PRIORITY|(((DWORD)SyncMaster)<<16);
	
	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{		
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)!=(LTR22CMD_SET_SYNC_PRIORITY&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;				
			} 
			else res=LTR_ERROR_RECV;
		}
	}else res=LTR_ERROR_SEND;

	if (res==LTR_OK)
	{
		module->SyncMaster=SyncMaster;					
	}

	return res;
}

/*
-----------------------------------------------------------------------------------
   
    
 ,         ,
   .
*/
LTR22API_DllExport(INT) LTR22_SyncPhaze(TLTR22 *module, DWORD timeout)
{
	//    
	if(module==	NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;	
	const int	RBUF_SIZE=1;	 	
	
	DWORD Command=LTR22CMD_SYNC_PHAZE;
	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{		
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)!=(LTR22CMD_SYNC_PHAZE&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
				else
				{
					if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, timeout)==RBUF_SIZE)
					{	
						if ((rbuf[0]>>16)!=(LTR22CMD_SYNC_PHAZE&0x3f))
							res=LTR22_ERROR_MODULE_INTERFACE;
					}else res=LTR_ERROR_RECV;
				};
			} 
			else res=LTR_ERROR_RECV;
		}
	}else res=LTR_ERROR_SEND;

	if (res==LTR_OK)
	{		
		module->SyncType=1;			
	}

	return res;
}

/*
-----------------------------------------------------------------------------------
 -   
*/
LTR22API_DllExport(INT) LTR22_StartADC(TLTR22 *module, bool WaitSync)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;	
	const int	RBUF_SIZE=1;	

	WaitSync=NormalizeTypeBool(WaitSync);	

	if (WaitSync)
	{ //          
		module->SyncType=2; // ,  ,
	}

	DWORD Command=LTR22CMD_START_ADC|(WaitSync<<16);
		
	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{	
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{					
				if ((rbuf[0]>>16)!=(LTR22CMD_START_ADC&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else res=LTR_ERROR_RECV;
		}		
	}
	else res=LTR_ERROR_SEND;		
	
	if (res==LTR_OK)
	{
		module->DataReadingProcessed=true;
	}

	return res;
}

LTR22API_DllExport(INT) LTR22_StopADC(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;	
	const int	RBUF_SIZE=1;

	DWORD Command=LTR22CMD_STOP_ADC;
		
	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{	
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{					
				if ((rbuf[0]>>16)!=(LTR22CMD_STOP_ADC&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else res=LTR_ERROR_RECV;
		}		
	}
	else res=LTR_ERROR_SEND;		
		

	if (res==LTR_OK)
	{
		module->DataReadingProcessed=false;
	}

	return res;
}

/*
-----------------------------------------------------------------------------------
 -     true -  false -  
*/
LTR22API_DllExport(INT) LTR22_SwitchMeasureADCZero(TLTR22 *module, bool SetMeasure)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;	

	int res=LTR_OK;

	SetMeasure=NormalizeTypeBool(SetMeasure);

	if (!module->DataReadingProcessed)
	{
		const int	RBUF_SIZE=1;
		
		DWORD Command=LTR22CMD_Measure_ADC_ZERO_START_STOP|((!SetMeasure)<<16); //    
		
		if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)!=(LTR22CMD_Measure_ADC_ZERO_START_STOP&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
				else module->MeasureADCZero=SetMeasure;
			} 
			else res=LTR_ERROR_RECV;
		}else res=LTR_ERROR_SEND;
	}else res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;

	return res;
}
/*
-----------------------------------------------------------------------------------
        0..16  
true = 3 false =2
  = adc384*FREQ_dv
 Fclk=20*10^6/adc384*FREQ_dv
     1.28-20.84 
*/

LTR22API_DllExport(INT) LTR22_SetFreq(TLTR22 *module, bool adc384, byte Freq_dv)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	float const UpFreq=20840000.0,
				DownFreq=1280000.0;

	adc384=NormalizeTypeBool(adc384);

	res=TestNewFreq(module, adc384, Freq_dv);

	if (res==LTR_OK)
	{		
		const int	SBUF_SIZE=2,
					RBUF_SIZE=2;
		DWORD sbuf[SBUF_SIZE];	

		sbuf[0]=LTR22CMD_SET_ADC_MAIN_DIV|(Freq_dv<<16);
		sbuf[1]=LTR22CMD_SET_ADC_EXTRA_DIV|(adc384<<16);
		
		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{			
			if (!module->DataReadingProcessed)
			{
				DWORD rbuf[2];				
				if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
				{					
					if ((rbuf[0]>>16)!=(LTR22CMD_SET_ADC_MAIN_DIV&0x3f))
						res=LTR22_ERROR_MODULE_INTERFACE;
					if ((rbuf[1]>>16)!=(LTR22CMD_SET_ADC_EXTRA_DIV&0x3f))
						res=LTR22_ERROR_MODULE_INTERFACE;
				} 
				else res=LTR_ERROR_RECV;
			}else res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;
		}
		else res=LTR_ERROR_SEND;

	}else res=LTR22_ERROR_INVALID_FREQ_DIV;

	if (res==LTR_OK)
	{
		module->Adc384=adc384;
		module->Fdiv_rg=Freq_dv;
	}

	return res;
}


/*
-----------------------------------------------------------------------------------
  true =AC+DC false=AC 
*/
LTR22API_DllExport(INT) LTR22_SwitchACDCState(TLTR22 *module, bool ACDCState)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;

	const int	RBUF_SIZE=1;	

	ACDCState=NormalizeTypeBool(ACDCState);

	DWORD Command=LTR22CMD_AC_AC_DC_STATE|(ACDCState<<16);	

	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{		
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)!=(LTR22CMD_AC_AC_DC_STATE&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else res=LTR_ERROR_RECV;
		}
	}
	else res=LTR_ERROR_SEND;

	if (res==LTR_OK)
	{
		module->AC_DC_State=ACDCState;
	}

	return res;
}

/*
-----------------------------------------------------------------------------------
 
 16-   4  -    4 .
 0..6
0 - 1 1 - 0.3 2 - 0.1 3 - 0.03 4 - 10 5 - 3

 - [4]  
*/
LTR22API_DllExport(INT) LTR22_SetADCRange(TLTR22 *module, byte ADCChannel, byte ADCChannelRange)
{
	//    
	if(module==	NULL||ADCChannelRange>5||ADCChannel>3||
				ADCChannel<0||ADCChannelRange<0) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	
	const int	RBUF_SIZE=1;	
			
	DWORD Command=LTR22CMD_SET_ADC_RANGE|
					(((DWORD)ADCChannel)<<24)|
					(((DWORD)ADCChannelRange)<<16);	

	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{		
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)!=(LTR22CMD_SET_ADC_RANGE&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else res=LTR_ERROR_RECV;
		}
	}else res=LTR_ERROR_SEND;

	if (res==LTR_OK)
	{		
		module->ADCChannelRange[ADCChannel]=ADCChannelRange;				
	}

	return res;
}

/*
-----------------------------------------------------------------------------------
   - 
 ,    ,  ,  .
*/
LTR22API_DllExport(INT) LTR22_SetADCChannel(TLTR22 *module, byte ADCChannel, bool EnableADC)
{
	//    
	if(module==	NULL||ADCChannel>3||ADCChannel<0) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	
	const int	RBUF_SIZE=1;
	

	EnableADC=NormalizeTypeBool(EnableADC);

			
	DWORD Command=LTR22CMD_SET_ADC_CHANNEL|
			(((DWORD)ADCChannel)<<24)|
			(((DWORD)EnableADC)<<16);	

	if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
	{		
		if (!module->DataReadingProcessed)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)!=(LTR22CMD_SET_ADC_CHANNEL&0x3f))
					res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else res=LTR_ERROR_RECV;
		}
	}else res=LTR_ERROR_SEND;

	if (res==LTR_OK)
	{		
		module->ChannelEnabled[ADCChannel]=EnableADC;				
	}

	return res;
}

/*
-----------------------------------------------------------------------------------
        
*/
LTR22API_DllExport(INT) LTR22_GetCalibrovka(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	const int ConfigSize=4800;
	int InternalRes;

	if (!module->DataReadingProcessed)
	{
		const int	RBUF_SIZE=ConfigSize+1;
		
		DWORD Command=LTR22CMD_GET_MODULE_CALIBROVKA;	
		if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
		{
			DWORD rbuf[RBUF_SIZE];			
			if ((InternalRes=LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE))==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)==(LTR22CMD_GET_MODULE_CALIBROVKA&0x3f))				
				{

					//      ,   
					//     
					byte TempConfArray[ConfigSize];
					for	(int i=0;i<ConfigSize;i++)
					{
						TempConfArray[i]=(byte)((rbuf[i+1]>>16)&0xff);
						if (((rbuf[i+1]>>24)&0xff)!=(BYTE)i) res=LTR22_ERROR_MODULE_INTERFACE;
					};

					if (res==LTR_OK)
					{
						float *pcfg = (float *)&TempConfArray;
						for (int ADCCount=0;ADCCount<LTR22_ADC_NUMBERS;ADCCount++)
						{	
							for (int FreqCount=0;FreqCount<LTR22_MAX_DISC_FREQ_NUMBER;FreqCount++)
							{
								//     
								for(int RangeCount=0;RangeCount<LTR22_RANGE_NUMBER;RangeCount++)
								{							
									module->ADCCalibration[ADCCount][FreqCount].FactoryCalibOffset[RangeCount]=*pcfg++;		
									module->ADCCalibration[ADCCount][FreqCount].FactoryCalibScale[RangeCount]=*pcfg++;
								};
							}
						};
					}
				}else res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else 
				res=LTR_ERROR_RECV;
		}else res=LTR_ERROR_SEND;
	}else res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;

	return res;
}

/*
-----------------------------------------------------------------------------------
   
*/
LTR22API_DllExport(INT) LTR22_Recv(TLTR22 *module, DWORD *data, DWORD *tstamp, DWORD size, DWORD timeout)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;	

	int res=LTR_Recv(&module->Channel, data, tstamp, size, timeout);
	if(res>0) 
	{
		if (res==size)
		{
			if(!(module->Channel.flags&FLAG_RBUF_OVF)) 
			{
				
			} else res=LTR22_ERROR_OVERFLOW;
		}else res=LTR22_ERROR_RECV_DATA;
	}
	return res;
}


/*
-----------------------------------------------------------------------------------
    flash
*/
LTR22API_DllExport(INT) LTR22_GetModuleDescription(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	const int DescriptionSize=128;

	if (!module->DataReadingProcessed)
	{
		const int	RBUF_SIZE=DescriptionSize+1;

		DWORD Command=LTR22CMD_GET_MODULE_DESCRIPTION;	
		if (LTR_Send(&module->Channel, &Command, 1, TIMEOUT_CMD_SEND)==1)
		{
			DWORD rbuf[RBUF_SIZE];			
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)==(LTR22CMD_GET_MODULE_DESCRIPTION&0x3f))				
				{
					//      ,   
					//     
					byte TempDescArray[DescriptionSize];
					for	(int i=0;i<DescriptionSize;i++)
					{
						TempDescArray[i]=(byte)((rbuf[i+1]>>16)&0xff);
						if (((rbuf[i+1]>>24)&0xff)!=i) res=LTR22_ERROR_MODULE_INTERFACE;
					};

					if (res==LTR_OK)
					{						
						int DescriptionArrayCounter=0;						
						int SizeCopy=0;

						module->ModuleInfo.Description = *(new TDESCRIPTION_MODULE());

						//  
						SizeCopy=sizeof(module->ModuleInfo.Description.CompanyName);
						memcpy(module->ModuleInfo.Description.CompanyName,TempDescArray+DescriptionArrayCounter,SizeCopy);						
						DescriptionArrayCounter+=SizeCopy;
						//  
						SizeCopy=sizeof(module->ModuleInfo.Description.DeviceName);
						memcpy(module->ModuleInfo.Description.DeviceName,TempDescArray+DescriptionArrayCounter,SizeCopy);												
						DescriptionArrayCounter+=SizeCopy;
						//   
						SizeCopy=sizeof(module->ModuleInfo.Description.SerialNumber);
						memcpy(module->ModuleInfo.Description.SerialNumber,TempDescArray+DescriptionArrayCounter,SizeCopy);												
						DescriptionArrayCounter+=SizeCopy;
						//   CPU
						SizeCopy=sizeof(module->ModuleInfo.CPU.Name);
						memcpy(module->ModuleInfo.CPU.Name,TempDescArray+DescriptionArrayCounter,SizeCopy);												
						DescriptionArrayCounter+=SizeCopy;

						// CPU Clock						
						DWORD Clock=0;
						SizeCopy=sizeof(Clock);
						memcpy((byte*)&Clock,TempDescArray+DescriptionArrayCounter,SizeCopy);												
						DescriptionArrayCounter+=SizeCopy;
						module->ModuleInfo.CPU.ClockRate=Clock;
						// FirmwareVersion
						SizeCopy=sizeof(module->ModuleInfo.CPU.FirmwareVersion);
						memcpy((byte*)&module->ModuleInfo.CPU.FirmwareVersion,TempDescArray+DescriptionArrayCounter,SizeCopy);												
						DescriptionArrayCounter+=SizeCopy;

						// DeviceRevision
						SizeCopy=sizeof(module->ModuleInfo.Description.Revision);
						module->ModuleInfo.Description.Revision=TempDescArray[DescriptionArrayCounter];																	
						DescriptionArrayCounter+=SizeCopy;
						
						// 
						SizeCopy=53;
						memcpy(module->ModuleInfo.Description.Comment,TempDescArray+DescriptionArrayCounter,SizeCopy);																													
						DescriptionArrayCounter+=SizeCopy;	

						// CRC
						WORD CRC=0;						
						SizeCopy=sizeof(CRC);
						memcpy((byte*)&CRC,TempDescArray+DescriptionArrayCounter,SizeCopy);																																			

						if (CRC!=0xffff)res=LTR22_ERROR_MODULE_INTERFACE;
					}
				}else res=LTR22_ERROR_MODULE_INTERFACE;
			} else res=LTR_ERROR_RECV;
		}else res=LTR_ERROR_SEND;
	}else res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;

	return res;
}

/********************************************************************
OverflowFlags -   4-     -  
,     1
   -     
  TestDataCounter      
*********************************************************************/
LTR22API_DllExport(INT) LTR22_ProcessData(TLTR22 *module, DWORD *src_data, double *dst_data, 
										 DWORD size, bool calibrMainPset, bool calibrExtraVolts, 
										 byte * OverflowFlags)
{
	int res=LTR_OK;
	int EnabledChannels=0;

	for (int i=0;i<LTR22_ADC_CHANNELS;i++)
	{
		if (module->ChannelEnabled[i]==true)EnabledChannels++;
	}

	if (!EnabledChannels)return LTR22_ERROR_PARAMETERS;

	byte	ADCChannelNumber=0, //   
				ADCChannelRange=0,	//  
				DataCounterThis=0;	//   
		double	ChannelScale=0,		//   - 
				ChannelOffset=0;	//   - 
		int OffsetArray=size/EnabledChannels, //     
			OffsetIndex=0; //     			

	calibrMainPset=NormalizeTypeBool(calibrMainPset);
	calibrExtraVolts=NormalizeTypeBool(calibrExtraVolts);
	
	if(module!=NULL && src_data!=NULL && dst_data!=NULL) 
	{		
		if (OverflowFlags!=NULL)memset(OverflowFlags,0,LTR22_ADC_CHANNELS);

		for (int countData=0,DataRecieveCounter=((src_data[0]>>5)&7), SrcDataCounter=0;
			countData<OffsetArray;
			countData++)
			{				
				for(int ADCCounter=0,ChannelIncrimentNumber=0;ADCCounter<EnabledChannels;ADCCounter++,ChannelIncrimentNumber=0)
				{						
					ADCChannelNumber=(byte)(src_data[SrcDataCounter]&3);
					ADCChannelRange=(byte)((src_data[SrcDataCounter]>>2)&7);
					DataCounterThis=(byte)((src_data[SrcDataCounter]>>5)&7);

					//     -  ,     -  
					for (int i=0;i<ADCChannelNumber;i++)
					{
						if (module->ChannelEnabled[i])ChannelIncrimentNumber++;
					}

					OffsetIndex=(ChannelIncrimentNumber*OffsetArray)+countData;

					//   
					if (DataRecieveCounter!=DataCounterThis)
						res=LTR22_ERROR_INVALID_DATA_COUNTER;

					//       
					//       0  5,      7
					if (ADCChannelRange!=module->ADCChannelRange[ADCChannelNumber])
					{
						if (ADCChannelRange==LTR22_RANGE_OVERFLOW)
						{
							if (OverflowFlags!=NULL)OverflowFlags[ADCChannelNumber]=1;
						}
						else
						{					
							res=LTR22_ERROR_INVALID_DATA_RANGE_FOR_THIS_CHANNEL;	
						}
						ADCChannelRange=module->ADCChannelRange[ADCChannelNumber];
					}				

					ChannelScale=module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].FactoryCalibScale[ADCChannelRange];
					ChannelOffset=module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].FactoryCalibOffset[ADCChannelRange];

					dst_data[OffsetIndex]=(short)((src_data[SrcDataCounter]>>16)&0xffff);

					if (calibrMainPset)
					{	//       
						dst_data[OffsetIndex]=(dst_data[OffsetIndex]*ChannelScale)+ChannelOffset;													
					}			

					if (calibrExtraVolts)
					{	//       	
						dst_data[OffsetIndex]=
							(dst_data[OffsetIndex]*module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].UserCalibScale[ADCChannelRange])
							+module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].UserCalibOffset[ADCChannelRange];	
					}	

					//  ,   ,      ,
					//    
					SrcDataCounter++;
					if (++DataRecieveCounter>6)DataRecieveCounter=0;
				}
			}
	} else res=LTR_ERROR_PARAMETRS;

	return res;
}

/********************************************************************
OverflowFlags -   4-     -  
,     1
   -     
  TestDataCounter      
  -   
*********************************************************************/
LTR22API_DllExport(INT) LTR22_ProcessDataTest(TLTR22 *module, DWORD *src_data, double *dst_data, 
										 DWORD size, bool calibrMainPset, bool calibrExtraVolts, 
										 byte * OverflowFlags, LPCWSTR FilePath)
{
	int res=LTR_OK;
	int EnabledChannels=0;	

	for (int i=0;i<LTR22_ADC_CHANNELS;i++)
	{
		if (module->ChannelEnabled[i]==true)EnabledChannels++;
	}

	if (!EnabledChannels)return LTR22_ERROR_PARAMETERS;

	byte	ADCChannelNumber=0, //   
				ADCChannelRange=0,	//  
				DataCounterThis=0;	//   
		double	ChannelScale=0,		//   - 
				ChannelOffset=0;	//   - 
		int OffsetArray=size/EnabledChannels, //     
			OffsetIndex=0; //     			

	calibrMainPset=NormalizeTypeBool(calibrMainPset);
	calibrExtraVolts=NormalizeTypeBool(calibrExtraVolts);
	
	if(module!=NULL && src_data!=NULL && dst_data!=NULL) 
	{		
		if (OverflowFlags!=NULL)memset(OverflowFlags,0,LTR22_ADC_CHANNELS);

		for (int countData=0,DataRecieveCounter=((src_data[0]>>5)&7), SrcDataCounter=0;
			countData<OffsetArray;
			countData++)
			{				
				for(int ADCCounter=0,ChannelIncrimentNumber=0;ADCCounter<EnabledChannels;ADCCounter++,ChannelIncrimentNumber=0)
				{						
					ADCChannelNumber=(byte)(src_data[SrcDataCounter]&3);
					ADCChannelRange=(byte)((src_data[SrcDataCounter]>>2)&7);
					DataCounterThis=(byte)((src_data[SrcDataCounter]>>5)&7);

					//     -  ,     -  
					for (int i=0;i<ADCChannelNumber;i++)
					{
						if (module->ChannelEnabled[i])ChannelIncrimentNumber++;
					}

					OffsetIndex=(ChannelIncrimentNumber*OffsetArray)+countData;

					//   
					if (DataRecieveCounter!=DataCounterThis)
					{
						res=LTR22_ERROR_INVALID_DATA_COUNTER;
						if (FilePath!=NULL)
						{
							HANDLE FileHandle = CreateFile(FilePath, GENERIC_READ|GENERIC_WRITE, 0, 
										NULL, OPEN_EXISTING, 0, NULL);
							if (FileHandle!=INVALID_HANDLE_VALUE)
							{
								SYSTEMTIME cur_time;
								GetLocalTime(&cur_time);								

								char Message[255];
								sprintf_s(Message, "%02u.%02u.%04u %02u:%02u:%02u \r\n", cur_time.wDay,
								cur_time.wMonth, cur_time.wYear, cur_time.wHour, cur_time.wMinute, cur_time.wSecond);

								memset(Message,0,sizeof(Message));
								sprintf_s(Message," %.255s \r\n", LTR22_GetErrorString(res));
								WriteFile(FileHandle,Message, 255, NULL, NULL);

								memset(Message,0,sizeof(Message));
								sprintf_s(Message,"   %d \r\n", SrcDataCounter);
								WriteFile(FileHandle,Message, 255, NULL, NULL);

								for (int i=0;i<(int)size;i++)
								{
									memset(Message,0,sizeof(Message));
									sprintf_s(Message," %d,  %x0.8 \r\n", src_data[SrcDataCounter]);
									WriteFile(FileHandle,Message, 255, NULL, NULL);
								}
								CloseHandle(FileHandle);
								return res;
							}
						}						
					}

					//       
					//       0  5,      7
					if (ADCChannelRange!=module->ADCChannelRange[ADCChannelNumber])
					{
						if (ADCChannelRange==LTR22_RANGE_OVERFLOW)
						{
							if (OverflowFlags!=NULL)OverflowFlags[ADCChannelNumber]=1;
						}
						else
						{	
							res=LTR22_ERROR_INVALID_DATA_RANGE_FOR_THIS_CHANNEL;								
							if (FilePath!=NULL)
							{
								HANDLE FileHandle = CreateFile(FilePath, GENERIC_READ|GENERIC_WRITE, 0, 
										NULL, OPEN_EXISTING, 0, NULL);
								if (FileHandle!=INVALID_HANDLE_VALUE)
								{
									SYSTEMTIME cur_time;
									GetLocalTime(&cur_time);								

									char Message[255];
									sprintf_s(Message, "%02u.%02u.%04u %02u:%02u:%02u \r\n", cur_time.wDay,
										cur_time.wMonth, cur_time.wYear, cur_time.wHour, cur_time.wMinute, cur_time.wSecond);

									memset(Message,0,sizeof(Message));
									sprintf_s(Message," %.255s \r\n", LTR22_GetErrorString(res));
									WriteFile(FileHandle,Message, 255, NULL, NULL);

									memset(Message,0,sizeof(Message));
									sprintf_s(Message,"   %d \r\n", SrcDataCounter);
									WriteFile(FileHandle,Message, 255, NULL, NULL);

									for (int i=0;i<(int)size;i++)
									{
										memset(Message,0,sizeof(Message));
										sprintf_s(Message," %d,  %x0.8 \r\n", src_data[SrcDataCounter]);
										WriteFile(FileHandle,Message, 255, NULL, NULL);
									}
									CloseHandle(FileHandle);
									return res;
								}
							}
						}
						ADCChannelRange=module->ADCChannelRange[ADCChannelNumber];
					}				

					ChannelScale=module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].FactoryCalibScale[ADCChannelRange];
					ChannelOffset=module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].FactoryCalibOffset[ADCChannelRange];

					dst_data[OffsetIndex]=(short)((src_data[SrcDataCounter]>>16)&0xffff);

					if (calibrMainPset)
					{	//       
						dst_data[OffsetIndex]=(dst_data[OffsetIndex]*ChannelScale)+ChannelOffset;													
					}			

					if (calibrExtraVolts)
					{	//       	
						dst_data[OffsetIndex]=
							(dst_data[OffsetIndex]*module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].UserCalibScale[ADCChannelRange])
							+module->ADCCalibration[ADCChannelNumber][module->FreqDiscretizationIndex].UserCalibOffset[ADCChannelRange];	
					}	

					//  ,   ,      ,
					//    
					SrcDataCounter++;
					if (++DataRecieveCounter>6)DataRecieveCounter=0;
				}
			}
	} else res=LTR_ERROR_PARAMETRS;

	return res;
}

/*
---------------------------------------------------------------------------------------
 EEPROM AVR   
   ,
   
*/
LTR22API_DllExport(INT) LTR22_WriteAVREEPROM(TLTR22 *module, byte *Data, DWORD BeginAddress, DWORD size)
{
	int const EEPROMSize=512;
	int Res=LTR_OK;	
	
	if ((BeginAddress+size)>EEPROMSize||module==NULL) return LTR_ERROR_PARAMETRS;	

	if (!module->DataReadingProcessed)
	{
		const int	SBUF_SIZE=1,
					RBUF_SIZE=1,					
					Internal_AVR_Buffer=100;
					
		DWORD sbuf[Internal_AVR_Buffer];
		DWORD rbuf[Internal_AVR_Buffer];		

		int DataCounter=0,
			BufferDataSend=0;

		//   
		sbuf[0]=LTR22CMD_PREPARE_READ_WRITE_EEPROM_ADDRESS|(BeginAddress<<16);	
		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)==(LTR22CMD_PREPARE_READ_WRITE_EEPROM_ADDRESS&0x3f))										
				{		
					while ((size>0)&&(Res==LTR_OK))
					{
						BufferDataSend=min(size,Internal_AVR_Buffer);							
						for (int i=0;i<BufferDataSend;i++,DataCounter++)
						{			
							sbuf[i]=LTR22CMD_WRITE_EEPROM|(Data[DataCounter]<<16);			
						}

						//  
						if (LTR_Send(&module->Channel, sbuf, BufferDataSend, TIMEOUT_CMD_SEND)==BufferDataSend)
						{
							if (LTR_Recv(&module->Channel, rbuf, NULL, BufferDataSend, 5000)==BufferDataSend)
							{
								for (int i=0;i<BufferDataSend;i++)
								{
									if ((rbuf[i]>>16)==(LTR22CMD_WRITE_EEPROM&0x3f))				
									{	
									}else 
										Res=LTR22_ERROR_MODULE_INTERFACE;	
								}
							}else Res=LTR_ERROR_RECV;
						}else Res=LTR_ERROR_SEND;
						size-=BufferDataSend;
					}
				}else Res=LTR22_ERROR_MODULE_INTERFACE;				
			} else Res=LTR_ERROR_RECV;
		}else Res=LTR_ERROR_SEND;
	}else Res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;
	return Res;
}

/*
---------------------------------------------------------------------------------------
 EEPROM AVR   
*/
LTR22API_DllExport(INT) LTR22_ReadAVREEPROM(TLTR22 *module, byte *Data, DWORD BeginAddress, DWORD size)
{
	int const EEPROMSize=512;
	int Res=LTR_OK;	

	if ((BeginAddress+size)>EEPROMSize||module==NULL) return LTR_ERROR_PARAMETRS;	

	if (!module->DataReadingProcessed)
	{
		const int	SBUF_SIZE=2,
					RBUF_SIZE=size+2;
		DWORD sbuf[SBUF_SIZE];
		DWORD rbuf[520];

		sbuf[0]=LTR22CMD_PREPARE_READ_WRITE_EEPROM_ADDRESS|(BeginAddress<<16);	
		sbuf[1]=LTR22CMD_READ_EEPROM|(size<<16);

		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, 300000)==RBUF_SIZE)
			{				
				if (((rbuf[0]>>16)==(LTR22CMD_PREPARE_READ_WRITE_EEPROM_ADDRESS&0x3f))&&
					((rbuf[1]>>16)==(LTR22CMD_READ_EEPROM&0x3f)))
				{					
					for (DWORD i=0;(i<size);i++)
					{
						if ((rbuf[i+2]>>24)!=(byte)i)Res=LTR22_ERROR_MODULE_INTERFACE;
						Data[i]=(byte)(rbuf[i+2]>>16);
					}					
				}else Res=LTR22_ERROR_MODULE_INTERFACE;
			}else Res=LTR_ERROR_RECV;
		}else Res=LTR_ERROR_SEND;		
	}else Res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;
	return Res;
}

/*
-----------------------------------------------------------------------------------
  
*/
LTR22API_DllExport(LPCSTR) LTR22_GetErrorString(int ErrorCode)
{
 /*
     *      ,    .
     * 
     * 
     *   err -   (  ),     LTR11.
     *  
     *         ,   .
     *   NULL -   .
     */
     
    const int err_qnt = sizeof err_str / sizeof err_str[0];
	const int min_err_id=6000;
    LPCSTR    ret_val = NULL;

    
    if (ErrorCode > -min_err_id || ErrorCode <= -(min_err_id + err_qnt))
    {		
			/*    (     ) */
			/*         */
			ret_val = LTR_GetErrorString(ErrorCode);		
    }
    else
    {
        /*          LTR-21 */
        ret_val = err_str[-ErrorCode - min_err_id];
    }
    return ret_val;
}

/*
-----------------------------------------------------------------------------------
        
 
*/
LTR22API_DllExport(INT) LTR22_WriteBroaching(TLTR22 *module, byte *Data, DWORD size,
											   bool WriteCalibrovkaAndDescription, bool ProgrammAVR)
{	
	int const BroachingSize=8192;
	if (size<BroachingSize||module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;

	WriteCalibrovkaAndDescription=NormalizeTypeBool(WriteCalibrovkaAndDescription);
	ProgrammAVR=NormalizeTypeBool(ProgrammAVR);

#ifdef _DEBUG_MY
	if (!WriteCalibrovkaAndDescription)
	{//     
#endif
		res=LTR22_GetModuleDescription(module);
		res=LTR22_GetCalibrovka(module);
#ifdef _DEBUG_MY
	}
#endif

	if(res==LTR_OK)
	{
		///
		///     
		///	

		int const 
					DescriptionSize=128,
					CalibrovkaSize=4800,
					BeginDescriptionAddress=BroachingSize-DescriptionSize,
					BeginCalibrovkaAddress=BeginDescriptionAddress-CalibrovkaSize;
		byte TempDescArray[DescriptionSize];	
		int DescriptionArrayCounter=0;						
		int SizeCopy=0;

#ifdef _DEBUG_MY

		//  
		SizeCopy=sizeof(module->ModuleInfo.Description.CompanyName);
		memcpy(TempDescArray+DescriptionArrayCounter,module->ModuleInfo.Description.CompanyName,SizeCopy);						
		DescriptionArrayCounter+=SizeCopy;
		//  
		SizeCopy=sizeof(module->ModuleInfo.Description.DeviceName);
		memcpy(TempDescArray+DescriptionArrayCounter,module->ModuleInfo.Description.DeviceName,SizeCopy);												
		DescriptionArrayCounter+=SizeCopy;
		//   
		SizeCopy=sizeof(module->ModuleInfo.Description.SerialNumber);
		memcpy(TempDescArray+DescriptionArrayCounter,module->ModuleInfo.Description.SerialNumber,SizeCopy);												
		DescriptionArrayCounter+=SizeCopy;
		//   CPU
		SizeCopy=sizeof(module->ModuleInfo.CPU.Name);
		memcpy(TempDescArray+DescriptionArrayCounter,module->ModuleInfo.CPU.Name,SizeCopy);												
		DescriptionArrayCounter+=SizeCopy;

		// CPU Clock						
		DWORD Clock=(DWORD)module->ModuleInfo.CPU.ClockRate;
		SizeCopy=sizeof(Clock);
		memcpy(TempDescArray+DescriptionArrayCounter,(byte*)&Clock,SizeCopy);												
		DescriptionArrayCounter+=SizeCopy;
		
		// FirmwareVersion
		SizeCopy=sizeof(module->ModuleInfo.CPU.FirmwareVersion);
		memcpy(TempDescArray+DescriptionArrayCounter,(byte*)&module->ModuleInfo.CPU.FirmwareVersion,SizeCopy);												
		DescriptionArrayCounter+=SizeCopy;

		// DeviceRevision
		SizeCopy=sizeof(module->ModuleInfo.Description.Revision);
		TempDescArray[DescriptionArrayCounter]=module->ModuleInfo.Description.Revision;																	
		DescriptionArrayCounter+=SizeCopy;

		// 
		SizeCopy=53;
		memcpy(TempDescArray+DescriptionArrayCounter,module->ModuleInfo.Description.Comment,SizeCopy);																													
		DescriptionArrayCounter+=SizeCopy;	

		// CRC
		WORD CRC=0xffff;						
		SizeCopy=sizeof(CRC);
		memcpy(TempDescArray+DescriptionArrayCounter,(byte*)&CRC,SizeCopy);	

		//     
		for (int i=0;i<DescriptionSize;i++)
		{
			Data[BeginDescriptionAddress+i]=TempDescArray[i];
		}
#endif
		///
		///   
		///	

		//      ,   
		//     
		byte TempConfArray2[CalibrovkaSize];
		byte *pbyte; //      byte		
		int CalibrovkaArrayCounter=0;		
		
		for (int ADCCount=0;ADCCount<LTR22_ADC_NUMBERS;ADCCount++)
		{	
			for (int FreqCount=0;FreqCount<LTR22_MAX_DISC_FREQ_NUMBER;FreqCount++)
			{
				//     
				for(int RangeCount=0;RangeCount<LTR22_RANGE_NUMBER;RangeCount++)
				{
					pbyte=(byte*)&module->ADCCalibration[ADCCount][FreqCount].FactoryCalibOffset[RangeCount];

					for (int i=0;i<4;i++,CalibrovkaArrayCounter++)
					{
						TempConfArray2[CalibrovkaArrayCounter]=*pbyte++;
					}

					pbyte=(byte*)&module->ADCCalibration[ADCCount][FreqCount].FactoryCalibScale[RangeCount];

					for (int i=0;i<4;i++,CalibrovkaArrayCounter++)
					{
						TempConfArray2[CalibrovkaArrayCounter]=*pbyte++;
					}
				};
			}
		};


		//     
		for (int i=0;i<CalibrovkaSize;i++)
		{
			Data[BeginCalibrovkaAddress+i]=TempConfArray2[i];
		}
		if (ProgrammAVR) res=WriteModuleMemory(module,0, Data, BroachingSize, true);
	}

	if (res==LTR_OK) res=LTR22_Open(module, module->Channel.saddr,module->Channel.sport,module->Channel.csn, module->Channel.cc);
	else LTR22_Open(module, module->Channel.saddr,module->Channel.sport,module->Channel.csn, module->Channel.cc);

	return res;
}

/***************************************************************************************************
 
****************************************************************************************************/
/*
-----------------------------------------------------------------------------------
 
*/
LTR22API_DllExport(INT) LTR22_ReadAVRBroaching(TLTR22 *module, byte *Data, DWORD size, DWORD BeginPage, DWORD PageNumbers)
{
	int const BroachingSize=8192;	
	if (size<BroachingSize||module==NULL) return LTR_ERROR_PARAMETRS;
	
	return ReadModuleMemory(module, BeginPage,Data, PageNumbers);
}

/*
-----------------------------------------------------------------------------------
   -      
*/
LTR22API_DllExport(INT) LTR22_TestHardwareInterface(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;

	if (!module->DataReadingProcessed)
	{
		const int	SBUF_SIZE=1,
					RBUF_SIZE=17;
		DWORD sbuf[SBUF_SIZE];
		DWORD rbuf[RBUF_SIZE];	
		sbuf[0]=LTR22CMD_TEST_RUNNING_UNIT;	
		if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
		{					
			if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
			{				
				if ((rbuf[0]>>16)==(LTR22CMD_TEST_RUNNING_UNIT&0x3f))				
				{
					for (int i=0;i<16;i++)
					{
						if ((rbuf[i+1]>>16)!=(1<<i))
						{
							break;
							res=LTR22_ERROR_INVALID_TEST_HARD_INTERFACE;
						}
					};
				}else res=LTR22_ERROR_MODULE_INTERFACE;
			} 
			else res=LTR_ERROR_RECV;

		}else res=LTR_ERROR_SEND;

		if (res==LTR_OK)
		{
			sbuf[0]=LTR22CMD_TEST_RUNNING_ZERO;
			if (LTR_Send(&module->Channel, sbuf, SBUF_SIZE, TIMEOUT_CMD_SEND)==SBUF_SIZE)
			{					
				if (LTR_Recv(&module->Channel, rbuf, NULL, RBUF_SIZE, TIMEOUT_CMD_RECIEVE)==RBUF_SIZE)
				{				
					if ((rbuf[0]>>16)==(LTR22CMD_TEST_RUNNING_ZERO&0x3f))				
					{
						for (int i=0;i<16;i++)
						{
							if ((rbuf[i+1]>>16)!=((~(1<<i))&0xffff))
							{
								break;
								res=LTR22_ERROR_INVALID_TEST_HARD_INTERFACE;
							}
						};
					}else res=LTR22_ERROR_MODULE_INTERFACE;
				} 
				else res=LTR_ERROR_RECV;

			}else res=LTR_ERROR_SEND;
		}
	}else res=LTR22_ERROR_CANNOT_DO_WHILE_ADC_RUNNING;
	return res;
}

/*
-----------------------------------------------------------------------------------
 
*/
LTR22API_DllExport(INT) LTR22_GetADCData(TLTR22 *module, double * Data, DWORD Size, DWORD time, 
										bool calibrMainPset, bool calibrExtraVolts)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	DWORD * rbuf =new DWORD[Size];

	res=LTR22_StartADC(module,false);
	if (res==LTR_OK)
	{
		if (LTR_Recv(&module->Channel, rbuf, NULL, Size, time)==Size)
		{			
			res=LTR22_ProcessData(module, rbuf, Data, Size,calibrMainPset,calibrExtraVolts,NULL);
		}
		else 
		{
			res=LTR_ERROR_RECV;
		}
	}	
	else
	{
		res=res;
	}

	if (res==LTR_OK)	res=LTR22_StopADC(module);			
	else LTR22_StopADC(module);

	if (res==LTR_OK)res=LTR22_ClearBuffer(module, true);
	else LTR22_ClearBuffer(module, true);

	if (rbuf!=NULL) free(rbuf);
	return res;
}

LTR22API_DllExport(INT) LTR22_ReopenModule(TLTR22 *module)
{
	if(module==NULL) return LTR_ERROR_PARAMETRS;

	int res=LTR_OK;
	
	res=LTR_Close(&module->Channel);
	res=LTR_Open(&module->Channel);
	return res;
}


#ifdef _MANAGED
#pragma managed(pop)
#endif


