unit EXAMPLE_LTR34;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ltrapi, ltrapitypes, ltrapidefine, ltr34api;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button3: TButton;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  LTR:TLTR;
  LTR34:TLTR34;
  CSNLIST:array[0..CRATE_MAX-1,0..SERIAL_NUMBER_SIZE-1]of char;
  LTR34GENERATE:boolean;
implementation

{$R *.dfm}


function TESTERROR(ERROR:integer;MEMO:Tmemo;STR:string):boolean;
begin
  TESTERROR:=false;
  if(memo.lines.Count>10000)then memo.Lines.Clear;
  if(ERROR<LTR_OK)then
  begin
     Memo.Lines.Add( STR+' :  '+ Inttostr(ERROR));
     TESTERROR:=true;
  end
  else
  begin
     Memo.Lines.Add( STR+' :  ');
  end
end;

procedure TForm1.Button1Click(Sender: TObject);
var i:integer;
    err:integer;
    CrateNom   :byte;
    CrateSelect:byte;
    MID:array[0..MODULE_MAX-1]of WORD;
    LIST34:array[0..MODULE_MAX-1]of byte;
    Total34:byte;
    LTR34SELECT:byte;
begin
  Button1.Enabled:=true;
  Button2.Enabled:=false;
  Button3.Enabled:=false;
  //       (LocalHost 127.0.0.1)
  for i:=0 to CRATE_MAX-1 do CSNLIST[i]:='';
  LTR_Init(@LTR);
  err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'  LTR')then exit;
  err:=LTR_GetCrates(@LTR,@CSNLIST[0,0]); if TESTERROR(err,memo1,'    ')then exit;

  //  
  CrateNom:=0;
  CrateSelect:=0;//   LTR 
  For i:=0 to CRATE_MAX-1 do
  if(CSNLIST[i]<>'')then
  begin
     Memo1.Lines.Add( '      LTR :'+CSNLIST[i]);
     CrateNom:=CrateNom+1;
  end;
  err:=LTR_Close(@LTR);                   if TESTERROR(err,memo1,'  LTR')then exit;
  //    
  LTR_Init(@LTR);
  for i:=0 to SERIAL_NUMBER_SIZE-1 do
  LTR.csn[i]:=CSNLIST[CrateSelect][i];

  err:=LTR_Open(@LTR);                    if TESTERROR(err,memo1,'     "'+LTR.csn+ '"')then exit;
  err:=LTR_GetCrateModules(@LTR,@MID[0]); if TESTERROR(err,memo1,'   ')then exit;
  Total34:=0;
  //  
  for i:=0 to MODULE_MAX-1 do
  begin
    if MID[i]<>0 then Memo1.Lines.Add( '       LTR'+inttostr(MID[i] div 256)+'   '+inttostr(i+1));
    if MID[i]=MID_LTR34 then
      begin
        LIST34[Total34]:=i;
        Total34:=Total34+1;
      end;
  end;
  LTR34SELECT:=0;//  LTR34
  //     
  LTR34_Init(@LTR34);
  err:=LTR34_Open(@LTR34,LTR.saddr,LTR.sport,@CSNLIST[CrateSelect][0],LIST34[LTR34SELECT]+1);

  if TESTERROR(err,memo1,'  LTR34   : '+inttostr(LIST34[LTR34SELECT]+1))then
  begin
      Button1.Enabled:=true;
      Button2.Enabled:=false;
      Button3.Enabled:=false;
  end
  else
  begin
      Button1.Enabled:=false;
      Button2.Enabled:=true;
      Button3.Enabled:=true;
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  err:integer;
begin
  err:=LTR34_Close(@LTR34);
  if TESTERROR(err,memo1,'  LTR34')then exit;
  err:=LTR_Close(@LTR);
  if TESTERROR(err,memo1,'   LTR')then exit;
  Button1.Enabled:=true;
  Button2.Enabled:=false;
  Button3.Enabled:=false;
end;

procedure TForm1.Button3Click(Sender: TObject);
var DATA:array[0..499]of DOUBLE;
    WORD_DATA:array[0..499]of integer;
    err:integer;
    i:integer;
begin
  if LTR34GENERATE=false then
  begin
    err:=LTR34_Reset(@LTR34);
    if TESTERROR(err,memo1,'  LTR34 ')then exit;

    LTR34.ChannelQnt:=1;        //   0, 1, 2, 3  (1, 2, 4, 8)
    LTR34.RingMode:=true;          //    true -  , false -  
    LTR34.FrequencyDivisor:=60; //    0..60 (31.25..500 )
    LTR34.UseClb:=true;            //  .
    LTR34.AcknowledgeType:=false;   //   true -    , false-     100 
    LTR34.LChTbl[0]:=LTR34_CreateLChannel(1,0);
    err:=LTR34_Config(@LTR34);
    if TESTERROR(err,memo1,'  LTR34')then exit;
    for i:=0 to 499 do
       DATA[i]:=10*sin(i*(pi/250));

    err:=LTR34_ProcessData(@LTR34,@DATA,@WORD_DATA,500,1);//1-     
    if TESTERROR(err,memo1,'    LTR34')then exit;


    err:=LTR34_Send(@LTR34,@WORD_DATA,500,2000);//1-     
    if TESTERROR(err,memo1,'    LTR34')then exit;
    err:=LTR34_DACStart(@LTR34);
    if TESTERROR(err,memo1,'  LTR34')then
      exit
    else
    begin
      Button1.Enabled:=false;
      Button2.Enabled:=false;
      Button3.Enabled:=true;
      Button3.Caption:='STOP SIN';
      LTR34GENERATE:=true;
    end;
  end else
  begin
      Button1.Enabled:=false;
      Button2.Enabled:=true;
      Button3.Enabled:=true;
      Button3.Caption:='GENERATE SIN';
      err:=LTR34_DACStop(@LTR34);
      LTR34GENERATE:=false;
      if TESTERROR(err,memo1,'  LTR34')then exit;
  end;
end;

end.
