
#include "stdafx.h";
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "ltr\\include\\ltr34api.h";

void main()
{
TLTR34 conf;
int j;
DWORD size;
int SizeSent;
int err=0;
INT SlotNum; //   
CHAR FPGA_Version[255]; //        
CHAR SerialNum[255]; //       
CHAR ModuleName[255]; //      
CHAR ErrorString[255]; //     
CHAR MsgString[255]; //      

/*     .        . */

err=LTR34_Init(&conf);
if(err) 
  {
	strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	LTR34_Close(&conf);
	Sleep(3000);
	return;
   }

//     .       -  

//   - 1;
SlotNum=5;
//       - C://ltr51.ttf
err=LTR34_Open(&conf, SADDR_DEFAULT, SPORT_DEFAULT,"", SlotNum);
if(err) 
  {
	if(err==LTR_WARNING_MODULE_IN_USE)
	 {
		strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	    CharToOem(ErrorString,ErrorString);
	    printf("%s",ErrorString);
	 }
	else
	{
	 strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	 CharToOem(ErrorString,ErrorString);
	 printf("%s",ErrorString);
	 return;
	}
   }
/*    .      */

strcpy(FPGA_Version, conf.ModuleInfo. FPGA_Version);
strcpy(MsgString,"  : ");
strcat(MsgString, FPGA_Version);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 

strcpy(SerialNum, conf.ModuleInfo.Serial);
strcpy(MsgString,"  : ");
strcat(MsgString, SerialNum);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 

strcpy(ModuleName, conf.ModuleInfo.Name);
strcpy(MsgString," : ");
strcat(MsgString, ModuleName);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 

//    .
//       1:1

conf.ChannelQnt=2; //  2 .    1-  3- . 
conf.LChTbl[0]=LTR34_CreateLChannel(1,0);
conf.LChTbl[1]=LTR34_CreateLChannel(3,0);


//       

conf.FrequencyDivisor=40; //   

conf.UseClb=true; //    
conf.AcknowledgeType=false; //   - 
conf.ExternalStart=false;   //   
conf.RingMode=true;        //        

//      

err=LTR34_Reset(&conf);
if(err) 
  {
	strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	LTR34_Close(&conf);
	Sleep(3000);
	return;
   }
//   
err=LTR34_Config(&conf);
if(err) 
  {
	strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	LTR34_Close(&conf);
	Sleep(3000);
	return;
   }

sprintf(MsgString," : %f ", conf.FrequencyDAC);
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 

   double *Code= new double[10000];
   DWORD *ArrayToSend=new DWORD[10000];
   
   j=0;
   size=0;
		//      -   
    for (double i=0.0;i<8.0;i+=0.01)
	 {
	//  .  ""  0  8 .  0.01  
	  Code[j]= i; //   . .   1 
	  j++;
	  
	  Code[j]= i; //   . .   3
	  j++;
	 }
size=j; //  
//    -. ArrayToSend - ,   .
// ,     !
err=LTR34_ProcessData(&conf, Code, ArrayToSend, size, true);
if(err) 
  {
	strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	Sleep(3000);
	goto exit;
   }
//    
SizeSent=LTR34_Send(&conf, ArrayToSend, size, 5000);
if(SizeSent!=(int) size)
{
 if(SizeSent < 0)
 {
  sprintf(MsgString,"%s", "    !");
  CharToOem(MsgString,MsgString);
  printf("%s\n",MsgString); 
  }
 else
 {
  sprintf(MsgString, "!      !");
  CharToOem(MsgString,MsgString);
  printf("%s\n",MsgString); 
  }
  goto exit; 
 }

//  

err=LTR34_DACStart(&conf);
if(err) 
  {
	strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	Sleep(3000);
	goto exit;
   }
//    1  3   ""

 sprintf(MsgString,"%s", "        5 ");
 CharToOem(MsgString,MsgString);
 printf("%s\n",MsgString);

 Sleep(5000);

 //  

 err=LTR34_DACStop(&conf);
if(err) 
  {
	strcpy(ErrorString, (char *) LTR34_GetErrorString(err));
	CharToOem(ErrorString,ErrorString);
	printf("%s",ErrorString);
	Sleep(3000);
	goto exit;
   }

sprintf(MsgString,"%s", " ");
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString);

sprintf(MsgString,"  .     .");
CharToOem(MsgString,MsgString);
printf("%s\n",MsgString); 
getchar();

exit:

if(ArrayToSend!=NULL)
 delete(ArrayToSend);

if(Code!=NULL)
 delete(Code);

LTR34_Close(&conf);

return; 

}

