#include "stdafx.h"
#include "ltr\\include\\ltr41api.h" 



#ifdef _MANAGED
#pragma managed(push, off)
#endif

  //   AVR
#define READ_WORD                                     (0x80C1)
#define CONFIG                                        (0x80C2)  
#define START_SECOND_MARK                             (0x80C3)
#define STOP_SECOND_MARK    						  (0x80C4)
#define MAKE_START_MARK                				  (0x80C5)

#define WRITE_EEPROM                                  (0x80C6) 
#define READ_EEPROM                                   (0x80C7)
#define READ_CONF_RECORD                              (0x80C8) 
#define START_STREAM_READ							  (0x80C9) 
#define STOP_STREAM_READ                              (0x80CA)
#define CONFIG_READ_RATE                              (0x80CB)


#define INIT                						  (0x80CF)

#define DATA_OUTPUT_CONFIRM     					   (0x16)       
#define PARITY_ERROR                                   (0x17)
#define RS485_ERROR_CONFIRM_TIMEOUT					   (0x18)
#define RS485_ERROR_SEND_TIMEOUT					   (0x19)
#define DATA_ERROR                                     (0x1A) 




#define F_OSC  (15000000) //    AVR 
#define CMD_TIMEOUT (2000)
#define MODULE_ID (0x29)

 


int LTR41_ReadConfRecord(PTLTR41 hnd, CHAR *version, CHAR *date, CHAR *name, CHAR *serial);           
                                                               
                                                            
INT eval_parity(DWORD cmd);                                                                                
INT check_parity(DWORD cmd); 
INT eval_scalers(double *Freq, WORD *Prescaler, BYTE *PrescalerCode, BYTE *Scaler);
                                                                                                           
                                                              
static WORD CRC_Calc(BYTE *b, WORD N);                                                                     
static void CRC_Update(WORD *crc, BYTE *b, int c) ;   
static DWORD CalkTickInterval(DWORD PrevTick, DWORD ActTick);


BOOL APIENTRY DllMain( HMODULE hModule,
                       DWORD  ul_reason_for_call,
                       LPVOID lpReserved
					 )
{
    return TRUE;
}  		 
 
int __stdcall DllEntryPoint (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	// Included for compatibility with Borland 

      return 1;
}    



/****************************************************************************************************************
  
                 
  
 ****************************************************************************************************************/


LTR41API_DllExport (INT) LTR41_Init(PTLTR41 hnd)
{
int err;


 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 

//         15 
hnd->StreamReadRate=15000;


//     
hnd->Marks.SecondMark_Mode=0;   //    -  
hnd->Marks.StartMark_Mode=0;    //   ""-


strcpy(hnd->ModuleInfo.FirmwareVersion,"\0");
strcpy(hnd->ModuleInfo.FirmwareDate,"\0");
strcpy(hnd->ModuleInfo.Serial,"\0");
strcpy(hnd->ModuleInfo.Name,"\0");
hnd->size = sizeof(TLTR41);

err=LTR_Init(&(hnd->Channel));		//   
 if(err==LTR_OK)
    return LTR41_NO_ERR;
  else return err;

}

/**********************************************************************************

          LTR41.  RESET 
   
************************************************************************************/


LTR41API_DllExport (INT) LTR41_Open(PTLTR41 hnd, INT net_addr, WORD net_port, CHAR *crate_sn, INT slot_num)
 {

DWORD command[2], stop[1], rbuf[1024]; //       /  
const int max_slot_num = 16;
int read_cntr;
int tick;

int err=0;
int warning=0;
  
    if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 
   


    
//   
 
 hnd->Channel.saddr=net_addr; //  

 if(crate_sn==NULL)
  return LTR41_ERR_INVALID_CRATE_SN; //  
  
 sprintf(hnd->Channel.csn, crate_sn);   
 
 
 if((slot_num<1)||(slot_num)>max_slot_num)
  return LTR41_ERR_INVALID_SLOT_NUM;
 
  hnd->Channel.cc=slot_num;   
 
   //       
 if((err=LTR_Open(&(hnd->Channel)))!=LTR_OK)   
   if(err<0)
    if(err==LTR_WARNING_MODULE_IN_USE)
    {
    warning=err;
    err=LTR_OK;
    }
   else 
    return err;
  else
    return LTR41_ERR_CANT_OPEN;	   
    
    slot_num-=1;
      
 		//  :  : , , 
 		
 	command[0]=LTR010CMD_STOP|(slot_num<<8);
	stop[0]=LTR010CMD_STOP|(slot_num<<8);



 if((err=(LTR_Send(&(hnd->Channel), stop, 1, TIMEOUT_CMD_SEND))) != 1 )  //   "STOP"
  return LTR41_ERR_CANT_SEND_COMMAND;
  

  command[0]=LTR010CMD_RESET|(slot_num<<8);;   
 if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) != 1 )  //  "RESET"
  if(err<0)
    return err;
      else
    return LTR41_ERR_CANT_RESET_MODULE; 
  

    
    
    tick=GetTickCount();
    
 while(1)
     {
      read_cntr=LTR_Recv(&(hnd->Channel), rbuf, NULL, 1024, 100); //  ,   FIFO
      
      if(read_cntr!=0)
       if((rbuf[read_cntr-1]&0xFFFF0000)==(0x29290000)) 
        break;
       
      
	   
	  if(CalkTickInterval(tick, GetTickCount())>=TIMEOUT_CMD_RECIEVE) //    5    
	   return LTR41_ERR_CANT_RESET_MODULE; 
	   
	 } 

    
     
   		
 if((err=(LTR_Send(&(hnd->Channel), stop, 1, TIMEOUT_CMD_SEND))) != 1)  //   "STOP"
   if(err<0)
    return err;
   else
    return LTR41_ERR_CANT_SEND_COMMAND;
  
 
  Sleep(500);  
  command[0]=INIT|(slot_num<<8);
     
 if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) != 1 )  //    INSTR
   if(err<0)
    return err;
   else
    return LTR41_ERR_CANT_SEND_COMMAND;
  
 if((err=(LTR_Recv(&(hnd->Channel), rbuf, NULL, 1, TIMEOUT_CMD_RECIEVE))!=1))   //  
   if(err<0)
    return err;
   else
    return LTR41_ERR_MODULE_NO_RESPONCE;
  
  err=LTR41_ReadConfRecord(hnd, hnd->ModuleInfo.FirmwareVersion, hnd->ModuleInfo.FirmwareDate, hnd->ModuleInfo.Name, hnd->ModuleInfo.Serial); 
   if(err) return err;  
  
  
  if(warning)
   return(warning);
  else 
   return LTR41_NO_ERR;
 }
 

/***************************************************************************************

                :   
               
****************************************************************************************/    

LTR41API_DllExport (INT) LTR41_IsOpened(PTLTR41 hnd)
{
 INT res;
 
 if(hnd!=NULL) {
    res=LTR_IsOpened(&hnd->Channel);
 } else res=LTR_ERROR_PARAMETRS;
 
 return res;
}

/***************************************************************************************

                   
               
****************************************************************************************/               

LTR41API_DllExport (INT) LTR41_Close(PTLTR41 hnd)
 {
 int err=0;
 
  if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 
 
   LTR41_StopSecondMark(hnd);
 
  if ((err=LTR_Close(&(hnd->Channel)))!=LTR_OK) 
   return(err);	
 
  return LTR41_NO_ERR; 
 }


/**************************************************************************************

                   

**************************************************************************************/


LTR41API_DllExport (INT) LTR41_Config(PTLTR41 hnd)

{
 DWORD command[2];
 DWORD command_ack[2];
 DWORD slot_num   =hnd->Channel.cc -1;
 BYTE Output_Groups=0;
 BYTE Marks_Conf;
 WORD Prescaler;
 BYTE PrescalerCode;
 BYTE Scaler;
 int i;
 
 int err=0;

 
  if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR;
 
 
  if((hnd->Marks.StartMark_Mode<0)||(hnd->Marks.StartMark_Mode>2))
   return LTR41_ERR_WRONG_START_MARK_CONF;
   
  if((hnd->Marks.SecondMark_Mode<0)||(hnd->Marks.StartMark_Mode>2))
   return LTR41_ERR_WRONG_SECOND_MARK_CONF;
   
  if((hnd->StreamReadRate<100.0)||(hnd->StreamReadRate>100000.0))
   return LTR41_ERR_WRONG_STREAM_READ_FREQ_SETTINGS;
   
   

 
 
 Marks_Conf=hnd->Marks.StartMark_Mode;
 Marks_Conf<<=4;
 Marks_Conf|=hnd->Marks.SecondMark_Mode;

 
 
 eval_scalers(&(hnd->StreamReadRate), &Prescaler, &PrescalerCode, &Scaler);  

 command[0]=Marks_Conf;
 command[0]<<=16;
 command[0]|=CONFIG;
 command[0]|=(slot_num<<8);

 command[0]|=(eval_parity(command[0]))<<5; 

 
 //         ,   -  .
 command[1]=Scaler;
 command[1]<<=8;
 command[1]|=PrescalerCode;
 command[1]<<=16;
 command[1]|=CONFIG_READ_RATE;
 command[1]|=(slot_num<<8); 

 command[1]|=(eval_parity(command[1]))<<5; 
 



 if((err=(LTR_Send(&(hnd->Channel), command, 2, TIMEOUT_CMD_SEND)))!= 2 )
  if(err<0)
    return err;
      else
    return LTR41_ERR_CANT_SEND_COMMAND;
  
 if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, 2, TIMEOUT_CMD_RECIEVE)))!=2)
  if(err<0)
    return err;
  else
    return LTR41_ERR_MODULE_NO_RESPONCE;
 

  for(i=0;i<2;i++)
  {
      //     
   
  if(check_parity(command_ack[i]))
     return LTR41_ERR_PARITY_FROM_MODULE;
   

   if((command_ack[i]&0x0000001F)==PARITY_ERROR)
    return LTR41_ERR_PARITY_TO_MODULE; 
    

 if((command_ack[i]&0x0000FF1F)!=(command[i]&0x0000FF1F)) //  . ,  ""  
    return LTR41_ERR_CANT_CONFIG;  

   } 
    

   return LTR41_NO_ERR; 
 }  


  
 
/****************************************************************************************

     16-     
   
****************************************************************************************/   
  
  
LTR41API_DllExport (INT) LTR41_ReadPort(PTLTR41 hnd, WORD *InputData)
 {
DWORD command[1];
DWORD data; 
DWORD slot_num   =hnd->Channel.cc -1;
DWORD val;

int SecMark_Index=0;
int SecMarks_LocalQntr=0;
int DataPacks_Qntr=0;
int err=0;


 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 
   

  data=0x0;


command[0]=0;
command[0]|=READ_WORD;
command[0]|=(slot_num<<8);

//     , ..   .    -    

  if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) != 1 ) 
   {
    if(err<0)
     return(err);
    else
     return LTR41_ERR_CANT_SEND_COMMAND; 
   }
  
  if((err=(LTR_Recv(&(hnd->Channel), &data, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)  // 2
    {
     if(err<0)
       return(err);
     else
      return LTR41_ERR_CANT_READ_DATA; 
    }
    
    
   
     if((data&0x8000))
      return LTR41_ERR_CANT_READ_DATA;
     
    
    val=((data&0xFFFF0000)>>16);
    
    *InputData=(WORD)val;
    
   return LTR41_NO_ERR;  
 }




/****************************************************************************************

         
   
****************************************************************************************/   


LTR41API_DllExport (INT) LTR41_StartStreamRead(PTLTR41 hnd)
 {
 
DWORD command;
DWORD command_ack;
DWORD slot_num   =hnd->Channel.cc -1;
int err=0;

 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 
   
command=START_STREAM_READ;
command|=(slot_num<<8);
 
command|=(eval_parity(command))<<5; 

 if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 )  
  if(err<0)
    return err;
  else
    return LTR41_ERR_CANT_SEND_COMMAND;
    
    

 if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1) 
   if(err<0)
    return err;
   else
    return LTR41_ERR_MODULE_NO_RESPONCE; 
    
   
 if(check_parity(command_ack))
   return LTR41_ERR_PARITY_FROM_MODULE;
   
   
 if((command_ack&0x0000001F)==PARITY_ERROR) 
   return LTR41_ERR_PARITY_TO_MODULE; 
    
   
 if((command_ack&0x0000FF1F)!=(command&0x0000FF1F))
   return LTR41_ERR_CANT_START_STREAM_READ;

 
   return LTR41_NO_ERR;  
 
  }
  

  
/****************************************************************************************

           
   
****************************************************************************************/ 
  
 LTR41API_DllExport (INT) LTR41_Recv(PTLTR41 hnd, DWORD *data, DWORD *tmark, DWORD size, DWORD timeout)
{
 INT res=LTR_Recv(&(hnd->Channel), data, tmark, size, timeout);
 
 if(res>0)
     if(hnd->Channel.flags&FLAG_RBUF_OVF)
       res=LTR41_ERR_ERROR_OVERFLOW; 
    
 return res;
 }
  
  
/****************************************************************************************

            16- 
   
****************************************************************************************/ 

LTR41API_DllExport (INT) LTR41_ProcessData(PTLTR41 hnd, DWORD *src, WORD *dest, DWORD *size)
{

 int i=0;
 int j=0;
 
 for (i=0;i<*size;i++)
  {
  if(i!=0)
   if(((src[i]&0xFF)-(src[i-1]&0xFF))!=1)
     if(((src[i-1]&0xFF)!=255)&&((src[i]&0xFF)!=0))
      return LTR41_ERR_WRONG_IO_DATA;   
   
  
   dest[j]=(WORD)(src[i]>>16);
   j++;
   
   *size=j;
   
  } 


return LTR41_NO_ERR;    
}







/****************************************************************************************

         
   
****************************************************************************************/   


LTR41API_DllExport (INT) LTR41_StopStreamRead(PTLTR41 hnd)
 {
  DWORD command;
  DWORD *stop_buf;
  DWORD slot_num   =hnd->Channel.cc -1;
  int read_cntr;
  int tick;
  int err=LTR_OK;

 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 


   stop_buf=(DWORD *) calloc(15000, sizeof(DWORD));
   
   if(stop_buf==NULL)
    return LTR_ERROR_MEMORY_ALLOC;


command=STOP_STREAM_READ;
command|=(slot_num<<8);
 
command|=(eval_parity(command))<<5; 

 if((read_cntr=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 )  
  if(read_cntr<0)
    goto exit;
  else
     {
      err=LTR41_ERR_CANT_SEND_COMMAND;
      goto exit;
     }
    
   
    
    tick=GetTickCount();
    
     while(1)
     {
      read_cntr=LTR_Recv(&(hnd->Channel), stop_buf, NULL, 15000, 100); //  ,   FIFO
      
      if(read_cntr!=0)
       if((stop_buf[read_cntr-1]&0xFFDF)==(STOP_STREAM_READ|(slot_num<<8)))
        break;
       
      
	   
	  if(CalkTickInterval(tick, GetTickCount())>=5000) //    5    
	  {
	   err=LTR41_ERR_CANT_STOP_STREAM_READ; 
	   goto exit;
	  }
	   
	 } 
 
	  
   if(check_parity(stop_buf[read_cntr-1]))
      err=LTR41_ERR_PARITY_FROM_MODULE;    
      
      
  exit:
  
    if(stop_buf!=NULL)
     free(stop_buf);
  
  return err; 
 }



/****************************************************************************************

                    
   
****************************************************************************************/   
 
LTR41API_DllExport (INT) LTR41_StartSecondMark(PTLTR41 hnd)
 {
 
DWORD command;
DWORD command_ack;
DWORD slot_num   =hnd->Channel.cc -1;
int err=0;


//int CommandPacks_Qntr=0;


 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 

command=0x0;
command|=START_SECOND_MARK;
command|=(slot_num<<8);
 
command|=(eval_parity(command))<<5; 
 
 if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 )  
  if(err<0)
    return err;
  else
    return LTR41_ERR_CANT_SEND_COMMAND;
 
 if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1) 
   if(err<0)
    return err;
   else
    return LTR41_ERR_MODULE_NO_RESPONCE; 
    
   
 if(check_parity(command_ack))
   return LTR41_ERR_PARITY_FROM_MODULE;
   
   
 if((command_ack&0x0000001F)==PARITY_ERROR) 
   return LTR41_ERR_PARITY_TO_MODULE; 
    
   
 if((command_ack&0x0000FF1F)!=(command&0x0000FF1F))
   return LTR41_ERR_CANT_LAUNCH_SEC_MARK;
    
  // hnd->Marks.SecondMarks_Qnt=0; 
 
 return LTR41_NO_ERR; 
 }



/****************************************************************************************

                     
   
****************************************************************************************/   


LTR41API_DllExport (INT) LTR41_StopSecondMark(PTLTR41 hnd)
 {
 
DWORD command;
DWORD command_ack;

DWORD slot_num   =hnd->Channel.cc -1;  
int err=0;

      
 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 

 command=0x0;
 command|=STOP_SECOND_MARK;
 command|=(slot_num<<8);

 command|=(eval_parity(command))<<5; 
 
 if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 ) 
   if(err<0)
    return err;
   else
    return LTR41_ERR_CANT_SEND_COMMAND;
   
    
 if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)   
   if(err<0)
    return err;
   else
    return LTR41_ERR_MODULE_NO_RESPONCE; 
 
  
  if(check_parity(command_ack))
     return LTR41_ERR_PARITY_FROM_MODULE;
   
   
  if((command_ack&0x0000001F)==PARITY_ERROR) 
    return LTR41_ERR_PARITY_TO_MODULE;  
   
   
  if((command_ack&0x0000FF1F)!=(command&0x0000FF1F))
    return LTR41_ERR_CANT_STOP_SEC_MARK;
 
  return LTR41_NO_ERR;   
 }


/****************************************************************************************

                   ""
   
****************************************************************************************/   


LTR41API_DllExport (INT) LTR41_MakeStartMark(PTLTR41 hnd)
{

DWORD command;
DWORD command_ack;
DWORD slot_num   =hnd->Channel.cc -1;  
int parity;
int err=0;

 if(hnd==NULL)
   return LTR41_ERR_WRONG_MODULE_DESCR; 
     
command=0;
command|=MAKE_START_MARK;
command|=(slot_num<<8);


parity=eval_parity(command);
command|=(parity)<<5;
 
 if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 ) 
  if(err<0)
    return err;
  else
    return LTR41_ERR_CANT_SEND_COMMAND;
 
 
 if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
   if(err<0)
    return err;
   else
    return LTR41_ERR_MODULE_NO_RESPONCE; 
 
   
 if(check_parity(command_ack))
   return LTR41_ERR_PARITY_FROM_MODULE;
   
   
 if((command_ack&0x0000001F)==PARITY_ERROR) 
   return LTR41_ERR_PARITY_TO_MODULE; 
   
   
 if((command_ack&0x0000FF1F)!=(command&0x0000FF1F)) //  . ,  ""  
   return LTR41_ERR_CANT_LAUNCH_START_MARK;  
   
   
  return LTR41_NO_ERR;   

}



static const int min_range_id = -7000; 
const LPCSTR err_str[] = 
{
	"LTR41:     !",
	"LTR41:  !",
	"LTR41:   !",
	"LTR41:   !",
	"LTR41:  !",
	"LTR41:    !",
	"LTR41:  !",
	"LTR41:   !",
	"LTR41:    !",
	"LTR41:    !",
	"LTR41:   !",
	"LTR41:  ,   !",
	"LTR41:     !",
	"LTR41:      !",	  //,       ! (0,1,2)?
	"LTR41:   !   0, 1  2   Marks.SecondMark_Mode!",
	"LTR41:   !   0, 1  2   Marks.StartMark_Mode!",
	"LTR41:  !",
	"LTR41:     EEPROM!",
	"LTR41:    EEPROM!",
	"LTR41:  EEPROM!",
	"LTR41:   !",
	"LTR41:  !",
	"LTR41:    !",
	"LTR41:    !",
	"LTR41:    -!",
	"LTR41:       !",
	"LTR41:   -!"
};

/*****************************************************************************************************

                   
   
******************************************************************************************************/   

LTR41API_DllExport (LPCSTR) LTR41_GetErrorString(int Error_Code)
{
	LPCSTR ret_val = NULL;
	int ret_val_index;
	double error_range;
	
	error_range=-min_range_id + 1+sizeof err_str / sizeof err_str[0];

	if ((-Error_Code < -min_range_id )|| (Error_Code < -error_range))
	{
		ret_val = LTR_GetErrorString(Error_Code);
	}
	else
	{
		ret_val_index=-Error_Code + min_range_id-1;
		ret_val = err_str[ret_val_index];
	}
	
	return ret_val;
}



 /**********************************************************************************************
 
              
       
 ************************************************************************************************/    

LTR41API_DllExport (INT) LTR41_WriteEEPROM(PTLTR41 hnd, INT Address, BYTE val) 
  {
  
    DWORD command[2], command_ack;
    INT slot_num     =hnd->Channel.cc -1; 
    INT err=0;
    INT parity=0;
    
    if(hnd==NULL)
      return LTR41_ERR_WRONG_MODULE_DESCR;
      
      
    if((Address<0)||(Address)>=512)             
      return LTR41_ERR_WRONG_EEPROM_ADDR;           
   
     command[0]=Address; //   
     command[0]<<=16;
	 command[0]|=WRITE_EEPROM|(slot_num<<8);  //    DSP
	 
	 parity=eval_parity(command[0]);
     command[0]|=(parity)<<5;
    
		         
     command[1]=val; //   
	 command[1]<<=16;
	 command[1]|=WRITE_EEPROM|(slot_num<<8);
	 
	 parity=eval_parity(command[1]);
     command[1]|=(parity)<<5;
	 
   if((err=(LTR_Send(&(hnd->Channel), command, 2, TIMEOUT_CMD_SEND)))!=2) 
    if(err<0)
       return err;
     else 		 
       return LTR41_ERR_CANT_SEND_COMMAND;      
                        
                                                             
   if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
    if(err<0)
       return err;
     else 
       return LTR41_ERR_CANT_WRITE_EEPROM;     
    
  
      //     
   
   if(check_parity(command_ack))
     return LTR41_ERR_PARITY_FROM_MODULE;
   
   
   if((command_ack&0x0000001F)==PARITY_ERROR) 
    return LTR41_ERR_PARITY_TO_MODULE; 
    
   
   if((command_ack&0x0000FF1F)!=(command[0]&0x0000FF1F)) //  . ,  ""  
    return LTR41_ERR_CANT_WRITE_EEPROM;  
   
    return LTR41_NO_ERR;  
     }
  

 /**********************************************************************************************
 
              
       
 ************************************************************************************************/       


LTR41API_DllExport (INT) LTR41_ReadEEPROM(PTLTR41 hnd, INT Address, BYTE *val) 
  {
  
    DWORD command, command_ack;
    INT slot_num     =hnd->Channel.cc -1; 
    INT err=0;
    INT parity=0;
    
    
    if(hnd==NULL)
      return LTR41_ERR_WRONG_MODULE_DESCR;
      
      
    if((Address<0)||(Address)>=512)             
      return LTR41_ERR_CANT_READ_EEPROM;           
   
     command=Address; //   
     command<<=16;
	 command|=READ_EEPROM|(slot_num<<8);  //    DSP
	 
	 parity=eval_parity(command);
     command|=(parity)<<5;
    
    
   if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))!=1) 
    if(err<0)
       return err;
    else 		 
       return LTR41_ERR_CANT_SEND_COMMAND;      
                        
                                                             
   if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
    if(err<0)
       return err;
    else 
       return LTR41_ERR_CANT_READ_EEPROM;     
   
      //     
   
   if(check_parity(command_ack))
    return LTR41_ERR_PARITY_FROM_MODULE;
   
   
   if((command_ack&0x0000001F)==PARITY_ERROR) 
    return LTR41_ERR_PARITY_TO_MODULE; 
    
   
 if((command_ack&0x0000FF1F)!=(command&0x0000FF1F)) //  . ,  ""  
    return LTR41_ERR_CANT_READ_EEPROM;  
   
    *val=(BYTE)((command_ack>>16)&0xFF);
 
    return LTR41_NO_ERR;  
     }
  
/*****************************************************************************************************

                      
   
******************************************************************************************************/ 

int LTR41_ReadConfRecord(PTLTR41 hnd, CHAR *version, CHAR *date, CHAR *name, CHAR *serial)
 {

   #define CR_LENGTH (42)
   #define CRC_LENGTH (2)

    BYTE conf_rec[44]; 
    BYTE ver[2];

    DWORD command, command_ack[50];
    INT slot_num     =hnd->Channel.cc -1; 
    INT err=0;
    INT parity=0;
    WORD CR_CRC;      // .  . ,  
    WORD CR_CRC_RCV;  // .  . ,   Flash
    int i;
    
    
    if(hnd==NULL)
      return LTR41_ERR_WRONG_MODULE_DESCR; 
      
      
     command=0; //   
	 command|=READ_CONF_RECORD|(slot_num<<8);  //    DSP
	 
	 parity=eval_parity(command);
     command|=(parity)<<5;
     
     
    if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))!=1) 
    if(err<0)
       return err;
     else 		 
       return LTR41_ERR_CANT_SEND_COMMAND;      
                        
                                                             
   if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, CR_LENGTH+CRC_LENGTH, TIMEOUT_CMD_RECIEVE)))!=(CR_LENGTH+CRC_LENGTH))
    if(err<0)
       return err;
     else 
       return LTR41_ERR_CANT_READ_CONF_REC;  
       
       
   for(i=0;i<CR_LENGTH;i++)
    {
    
    if((command_ack[i]&0x0000001F)==PARITY_ERROR) 
        return LTR41_ERR_PARITY_TO_MODULE;   
    
      
     //       -      
     //   6    -      
     
      if(check_parity(command_ack[i]))
        return LTR41_ERR_PARITY_FROM_MODULE;  //     
        
      if((command_ack[i]&0x0000FF1F)!=(command&0x0000FF1F))
        return LTR41_ERR_CANT_READ_CONF_REC;  
    }    
       
 
    for(i=0;i<CR_LENGTH;i++)
     conf_rec[i]=(BYTE)((command_ack[i]>>16)&0xFF);
    
    CR_CRC=0;
    
    CR_CRC=CRC_Calc(conf_rec, CR_LENGTH); 
    CR_CRC_RCV=(WORD)(((command_ack[CR_LENGTH]>>16)&0xFFF)|((command_ack[CR_LENGTH+1]>>8)&0xFF00));
    
    
    // !     !
    
    if(CR_CRC!=CR_CRC_RCV)
      return LTR41_ERR_WRONG_CONF_REC; 
     
   
    if(conf_rec[0]!=MODULE_ID)
     return LTR41_ERR_WRONG_CONF_REC; 
    
    
    for(i=0;i<2;i++)
     ver[i]=*(conf_rec+1+i); //  
     
    sprintf(version, "%d.%d",ver[0], ver[1]);    
     
    for(i=0;i<14;i++)
     date[i]=*(conf_rec+3+i); //   
     
    for(i=0;i<8;i++)
     name[i]=*(conf_rec+17+i); //   
     
    for(i=0;i<17;i++)
     serial[i]=*(conf_rec+25+i); //   
     
     
     
    
  return LTR41_NO_ERR;  
 } 



/******************************************************************************************

                             
  
/*****************************************************************************************/
 INT eval_scalers(double *Freq, WORD *Prescaler, BYTE *PrescalerCode, BYTE *Scaler)
 {
 
  if((*Freq>=100.0)&&(*Freq<230.0))
   {
   *Prescaler=1024;
   *PrescalerCode=4;
   }
   
  if((*Freq>=230.0)&&(*Freq<920.0))
  {
   *Prescaler=256;
   *PrescalerCode=3;
   }
  
  if((*Freq>=920.0)&&(*Freq<7325.0))
  {
   *Prescaler=64;
   *PrescalerCode=2;
   }
   
  if((*Freq>=7325.0)&&(*Freq<58595.0))
  {
   *Prescaler=8;
   *PrescalerCode=1;
   }
   
  if((*Freq>=58595.0)&&(*Freq<=100000.0))
  {
   *Prescaler=1;
   *PrescalerCode=0;
   }
   
   
  *Scaler=(BYTE) (((F_OSC/((*Prescaler)*(*Freq)))-1)+0.5); 
  
  *Freq=F_OSC/((*Prescaler)*(*Scaler+1));
   
  return(0); 
  
 }


/*******************************************************************************

                        
  
/*******************************************************************************/

 INT eval_parity(DWORD cmd)
{
	unsigned long index;
	INT           parity;
	
	
	parity = 0;
	for (index = 0x01UL; index <= 0x10UL; index <<= 1)
		parity ^= (cmd & index) != 0;  
	
	//        	
	for (index = 0x80000000UL; index >= 0x00010000UL; index >>= 1)
		parity ^= (cmd & index) != 0;
	
	
	return parity;
}


/*******************************************************************************

                      
  
/*******************************************************************************/

 INT eval_parity_in(DWORD cmd)
{
	unsigned long index;
	INT           parity;
	
	
	parity = 0;
	for (index = 0x01UL; index <= 0x10UL; index <<= 1)
		parity ^= (cmd & index) != 0;  
	
	//        	
	for (index = 0x800000UL; index >= 0x010000UL; index >>= 1)
		parity ^= (cmd & index) != 0;
	
	
	return parity;
}


INT check_parity(DWORD cmd)
 {
   if(((cmd&0x20)>>5)==eval_parity_in(cmd))
     return(0);
   else
     return(1);
  }  



/*******************************************************************************

   16- CRC
  
/*******************************************************************************/


static WORD CRC_Calc(BYTE *b, WORD N)
/*  .
:
  b --  .
  N --  .
:
    .
*/
{
	WORD crc= 0;
	int i, j;

	for(i=0; i<N; i++) {
		crc ^= b[i] << 8;
		for(j=0;j<8;j++) {
			if(crc&0x8000) crc = (crc<<1) ^ 0x1021;
			else crc <<= 1;
		}
	}
	return crc;
}

static void CRC_Update(WORD *crc, BYTE *b, int c)
/*     ,  
    .
:
  crc --      .
  b --  .
  c --  .
:
  crc --      .
*/
{
	unsigned w;
	int i,j;

	w = *crc;
	for(i=0;i<c;i++) {
		w ^= b[i] << 8;
		for(j=0;j<8;j++)  {
			if(w&0x8000) w = (w<<1) ^ 0x1021;
			else w <<= 1;
		}
	}
	*crc = w;
}

static DWORD CalkTickInterval(DWORD PrevTick, DWORD ActTick)
{
 DWORD Diff;

 if(ActTick>=PrevTick)
  Diff=ActTick-PrevTick;
 else
  Diff=(0xFFFFFFFF-PrevTick)+ActTick;
  
  return Diff;

}

#ifdef _MANAGED
#pragma managed(pop)
#endif
