unit ltrapidefine;
interface
uses windows, SysUtils;

const
//  - $
LTR010CMD          =       ($8000);
LTR010CMD_STOP     =       (LTR010CMD or $00);
LTR010CMD_PROGR    =       (LTR010CMD or $40);
LTR010CMD_RESET    =       (LTR010CMD or $80);
LTR010CMD_INSTR    =       (LTR010CMD or $C0);
LTR010_SLOT_MASK   =       ($F shl 8);
//
SIGNAL_RBUF_OVF    =       ($FFFFFFF0);  //   ->  :    
SIGNAL_TSTAMP      =       ($FFFFFFF1);  //   ->  :  
//
SADDR_LOCAL        =       ((127 shl 24)or(0 shl 16)or(0 shl 8)or(1 shl 0));
SADDR_DEFAULT      =       (SADDR_LOCAL);
SPORT_DEFAULT      =       (11111);
//   -
CC_CONTROL         =        0 ;           //    c    0,  
CC_MODULE1         =        1 ;           //    c    1
CC_MODULE2         =        2 ;           //    c    2
CC_MODULE3         =        3 ;           //    c    3
CC_MODULE4         =        4 ;           //    c    4
CC_MODULE5         =        5 ;           //    c    5
CC_MODULE6         =        6 ;           //    c    6
CC_MODULE7         =        7 ;           //    c    7
CC_MODULE8         =        8 ;           //    c    8
CC_MODULE9         =        9 ;           //    c    9
CC_MODULE10        =       10 ;           //    c    10
CC_MODULE11        =       11 ;           //    c    11
CC_MODULE12        =       12 ;           //    c    12
CC_MODULE13        =       13 ;           //    c    13
CC_MODULE14        =       14 ;           //    c    14
CC_MODULE15        =       15 ;           //    c    15
CC_MODULE16        =       16 ;           //    c    16
CC_DEBUG_FLAG      =       $8000 ;       //   -     
                                                //        .
                                                // ..     .
CC_RAW_DATA_FLAG   =       $4000 ;       //   -     
                                            	//    USB    
CRATE_MAX          =       16    ;       //      
MODULE_MAX         =       16    ;       //      
FLAG_RBUF_OVF      =       (1 shl 0) ;       //    
FLAG_SIGNAL_TSTAMP =       (1 shl 8) ;       //    SIGNAL_TSTAMP
//  
MID_EMPTY          =       0      ;       //  
MID_LTR11          =       $0B0B ;       //   LTR11
MID_LTR22          =       $1616 ;       //   LTR22
MID_LTR27          =       $1B1B ;       //   LTR27
MID_LTR34          =       $2222 ;       //   LTR34
MID_LTR41          =       $2929 ;       //   LTR41
MID_LTR42          =       $2A2A ;       //   LTR42
MID_LTR43          =       $2B2B ;       //   LTR43
MID_LTR51          =       $3333 ;       //   LTR51
MID_LTR212         =       $D4D4 ;       //   LTR212

//  -
CONTROL_COMMAND_SIZE                        =8;
CONTROL_COMMAND_START                       =$FFFFFFFF;
CONTROL_COMMAND_INIT_CONNECTION             =$ABCDEF00;
CONTROL_COMMAND_SET_SERVER_PROCESS_PRIORITY =$ABCDEF01;
CONTROL_COMMAND_PUT_ARRAY                   =$ABCDEF80;
CONTROL_COMMAND_GET_ARRAY                   =$ABCDEF81;
CONTROL_COMMAND_GET_DESCRIPTION             =$ABCDEF82;
CONTROL_COMMAND_BOOT_LOADER_GET_DESCRIPTION =$ABCDEF83;
CONTROL_COMMAND_BOOT_LOADER_SET_DESCRIPTION =$ABCDEF84;
CONTROL_COMMAND_GET_CRATES                  =$ABCDEF87;
CONTROL_COMMAND_GET_MODULES                 =$ABCDEF88;
CONTROL_COMMAND_GET_CRATE_RAW_DATA          =$ABCDEF89;
CONTROL_COMMAND_LOAD_FPGA                   =$ABCDEF8B;
CONTROL_COMMAND_BOOT_LOADER_PUT_ARRAY       =$ABCDEFFD;
CONTROL_COMMAND_BOOT_LOADER_GET_ARRAY       =$ABCDEFFE;
CONTROL_COMMAND_CALL_APPLICATION            =$ABCDEFFF;
CONTROL_ACKNOWLEDGE_SIZE                    =4         ;
CONTROL_ACKNOWLEDGE_MODULE_IN_USE           =$ABCDEFDD;
CONTROL_ACKNOWLEDGE_GOOD                    =$ABCDEFEE;
CONTROL_ACKNOWLEDGE_BAD                     =$ABCDEFFF;

//    LTR010
SEL_AVR_DM              =           		$82000000        ;
SEL_AVR_PM              =        		    $83000000        ;
SEL_DMA_TEST_FLAG       =   		        $84000000        ;
SEL_FLASH_BUFFER        =    		        $85000000        ;
SEL_FPGA_DATA           =  		          $86000000        ;
SEL_FPGA_FLAGS          =    	          $87000000        ;
//
LTR010_FIRMWARE_SIZE	    			=($3000)                ;
LTR010_BOOT_LOADER_SIZE					=($1000)                 ;
LTR010_FIRMWARE_VERSION_ADDRESS     =    (SEL_AVR_PM or $2FF0);
LTR010_BOOT_LOADER_VERSION_ADDRESS  =    (SEL_AVR_PM or $3FF0);
LTR010_MODULE_DESCRIPTOR_ADDRESS    =    (SEL_AVR_PM or $3000);
LTR010_FIRMWARE_START_ADDRESS       =    (SEL_AVR_PM or $0000);
LTR010_BOOT_LOADER_START_ADDRESS    =    (SEL_AVR_PM or $3C00);
//
EP1K100_SIZE                         =   (164*1024+100)     ;
EP1K50_SIZE                          =   ( 96*1024+100)     ;
EP1K30_SIZE                          =   ( 58*1024+100)     ;
EP1K10_SIZE                          =   ( 22*1024+100)     ;
FPGA_INFO_SIZE                       =   250                ;
NAME_SIZE                            =   16                 ;
SERIAL_NUMBER_SIZE                   =   16                 ;
implementation
end.
