﻿unit ltr42api;

interface

uses windows, SysUtils;

const
        LTR_OK=0;
        LTR22_ADC_NUMBERS=4;
        LTR22_ADC_CHANNELS=LTR22_ADC_NUMBERS;
        LTR22_RANGE_NUMBER=6;
        LTR22_RANGE_OVERFLOW=7;

type

TLTR = packed record
        saddr:Cardinal;                       // сетевой адрес сервера
        sport:word;                       // сетевой порт сервера
        csn:array [1..16] of char;                     // серийный номер крейта
        cc:word;                          // номер канала крейта
        flags:Cardinal;                       // флаги состояния канала
        tmark:Cardinal;                       // последняя принятая метка времени
        internal:Pointer;                   // указатель на канал
end;


TINFO_LTR42=packed record

Name: array[1..16] of char;
Serial: array[1..24] of char;
FirmwareVersion: array[1..8] of char;
FirmwareDate: array[1..16] of char;

end;

SYNCHRO_MARKS=packed record

SecondMark_Mode: integer;
StartMark_Mode: integer;

end;

// структура, задающая режим работы АЦП для модуля E-440
TLTR42 = packed record
   //**** служебная информация
  ltr:TLTR;							// структура описывающая модуль в крейте - описание в ltrapi.pdf
  size: Integer;
  AckEna: Integer;
    Marks: SYNCHRO_MARKS;
    ModuleInfo: TINFO_LTR42;
end;

pTLTR42 = ^TLTR42;

Function LTR42_Init(module:pTLTR42) : Integer; stdcall;
Function LTR42_Open(module:pTLTR42; saddr:Cardinal; sport:Word;csnArrayByte:Pointer;cc:Word) : Integer; stdcall;
Function LTR42_Close(module:pTLTR42) : Integer; stdcall;
Function LTR42_IsOpened(module:pTLTR42) : Integer; stdcall;
Function LTR42_WritePort(hnd: pTLTR42; OutputData: Word): Integer; stdcall;
Function LTR42_Config(hnd: pTLTR42):Integer; stdcall;
Function LTR42_StartSecondMark(hnd:pTLTR42):Integer; stdcall;
Function LTR42_StopSecondMark(hnd:pTLTR42):Integer; stdcall;
Function LTR42_MakeStartMark(hnd:PTLTR42):Integer; stdcall;
Function LTR42_WriteEEPROM(hnd:PTLTR42;Address:Integer; val: Byte):Integer; stdcall;
Function LTR42_ReadEEPROM(hnd:PTLTR42; Address:Integer; val: Pointer):Integer; stdcall;
Function LTR42_GetErrorString(Index:Integer) : PChar{ string}; stdcall;

implementation
        Function LTR42_Init(module:pTLTR42) : Integer; external 'ltr42api.dll';
        Function LTR42_Open(module:pTLTR42; saddr:Cardinal; sport:Word;csnArrayByte:Pointer;cc:Word) : Integer; external 'ltr42api.dll';

        Function LTR42_Close(module:pTLTR42) :  Integer; external 'ltr42api.dll';
Function LTR42_IsOpened(module:pTLTR42) :  Integer; external 'ltr42api.dll';
Function LTR42_Config(hnd: pTLTR42):Integer; external 'ltr42api.dll';
Function LTR42_WritePort(hnd: pTLTR42; OutputData: Word): Integer; external 'ltr42api.dll';
Function LTR42_StartSecondMark(hnd:PTLTR42): Integer; external 'ltr42api.dll';
Function LTR42_StopSecondMark(hnd:PTLTR42): Integer; external 'ltr42api.dll';
Function LTR42_MakeStartMark(hnd:PTLTR42): Integer; external 'ltr42api.dll';
Function LTR42_WriteEEPROM(hnd:PTLTR42;Address:Integer; val: Byte): Integer; external 'ltr42api.dll';
Function LTR42_ReadEEPROM(hnd:PTLTR42; Address:Integer; val: Pointer): Integer; external 'ltr42api.dll';
Function LTR42_GetErrorString(Index:Integer) : PChar{string}; external 'ltr42api.dll';

end.







     

