program ltr42ex;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  ltr42api in 'ltr42api.pas';

label exit;
var module:TLTR42;
    Handle: Cardinal;
    OutputWord: Word; {      }
    ModuleName:PChar;
    Serial: PChar;
    Version: PChar;
    Date: PChar;
    ErrorString: PChar;

    err:Integer;

begin
  { TODO -oUser -cConsole Main : Insert code here }

 //  
err:=LTR42_Init(@module);

if(err=LTR_OK) then
   Writeln('Module initialization is successfully')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

//   

//*****************************************************
//**** !  ,   
// (   LTR42_Open()  
//   ,    
//   .   !!!
//*****************************************************
err:=LTR42_Open(@module, module.ltr.saddr, module.ltr.sport, @module.ltr.csn, 6);

if(err=LTR_OK) then
   Writeln('Module has opened successfully')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

Writeln;


//  . 
//  PChar  
//   ,  0-
ModuleName:=@module.ModuleInfo.Name;

Write('ModuleName: ');
Writeln(ModuleName);


Serial:=@module.ModuleInfo.Serial;
Write('Serial number: ');
Writeln(Serial);


Version:=@module.ModuleInfo.FirmwareVersion;
Write('Firmware version: ');
Writeln(Version);



Date:=@module.ModuleInfo.FirmwareDate;
Write('Firmware date: ');
Writeln(Date);

Writeln;


//   .   
 module.Marks.SecondMark_Mode:=0;
 module.Marks.StartMark_Mode:=0;

 //  
 module.AckEna:=0;

 //  
 err:=LTR42_Config(@module);

if(err=LTR_OK) then
   Writeln('Module has configured successfully')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;


//*************************************************

 //    5A17 hex
OutputWord:=$5A17; //   
Writeln('Write 5A17 hex to port');

//     
err:=LTR42_WritePort(@module, OutputWord);

if(err=LTR_OK) then
   Writeln('Writing to port was successfully')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

 Writeln;

//    
//   5 .       ,
//     
//   

err:=LTR42_StartSecondMark(@module);

if(err=LTR_OK) then
   Writeln('Second marks generation has started. Please, wait 5 seconds...')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

 Sleep(5000);


err:=LTR42_StopSecondMark(@module);
if(err=LTR_OK) then
   Writeln('Second marks generation has stoped. ')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

Writeln;

//   
err:=LTR42_MakeStartMark(@module);
if(err=LTR_OK) then
   Writeln('START mark was generated. ')
else
 begin
  //     
  ErrorString:=LTR42_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

 //********************************
 //    

exit:

Writeln;
Writeln('Closing module');
LTR42_Close(@module);

Writeln('Press any key to exit from application');
Readln;
end.
