#include "stdafx.h"

#include "ltr\\include\\ltr42api.h" 




#ifdef _MANAGED
#pragma managed(push, off)
#endif

//   AVR

#define CONFIG                                        (0x80C1)  
#define START_SECOND_MARK                             (0x80C2)
#define STOP_SECOND_MARK    						  (0x80C3)
#define MAKE_START_MARK                				  (0x80C4)

#define WRITE_EEPROM                                  (0x80C5) 
#define READ_EEPROM                                   (0x80C6)
#define READ_CONF_RECORD                              (0x80C7) 


#define INIT                						  (0x80CF)

#define DATA_OUTPUT_CONFIRM     					   (0x1D)       
#define PARITY_ERROR                                   (0x1E)
#define DATA_ERROR                                     (0x1F) 


//  

#define F_OSC  (15000000) //    AVR 
#define CMD_TIMEOUT (2000)
#define MODULE_ID (0x2A)

//     
#define TIMEOUT_CMD_SEND							   (2000)
#define TIMEOUT_CMD_RECIEVE							   (4000)



int LTR42_ReadConfRecord(PTLTR42 hnd, CHAR *version, CHAR *date, CHAR *name, CHAR *serial);           


INT eval_parity(DWORD cmd);                                                                                
INT check_parity(DWORD cmd); 
INT eval_scalers(double *Freq, WORD *Prescaler, BYTE *PrescalerCode, BYTE *Scaler);

INT HC_LE41_CONNECT(PTLTR42 hnd);                                                                     
static WORD CRC_Calc(BYTE *b, WORD N);                                                                     
static void CRC_Update(WORD *crc, BYTE *b, int c) ;
static DWORD CalkTickInterval(DWORD PrevTick, DWORD ActTick);    



BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{
	return TRUE;
}

int __stdcall DllEntryPoint (HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
	// Included for compatibility with Borland 

	return 1;
}



/****************************************************************************************************************

           

****************************************************************************************************************/


LTR42API_DllExport(INT) LTR42_Init(PTLTR42 hnd)
{
	int err;

	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 

	hnd->size=sizeof(TLTR42);

	strcpy(hnd->ModuleInfo.FirmwareVersion,"\0");
	strcpy(hnd->ModuleInfo.FirmwareDate,"\0");
	strcpy(hnd->ModuleInfo.Serial,"\0");
	strcpy(hnd->ModuleInfo.Name,"\0");
	
	hnd->AckEna=1; //    

	err=LTR_Init(&hnd->Channel);		//   
	
	return err;
}

/**********************************************************************************

       LTR42.  RESET 

************************************************************************************/


LTR42API_DllExport(INT) LTR42_Open(PTLTR42 hnd, INT net_addr, WORD net_port, CHAR *crate_sn, INT slot_num)
{

	DWORD command[2], stop[1], rbuf[1024]; //       /  
	const int max_slot_num = 16;
	int read_cntr;
	int tick;

	int err=0;
	int warning=0;

	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 




	//   

	hnd->Channel.saddr=net_addr; //  

	if(crate_sn==NULL)
		return LTR42_ERR_INVALID_CRATE_SN; //  

	sprintf(hnd->Channel.csn, crate_sn);   


	if((slot_num<1)||(slot_num)>max_slot_num)
		return LTR42_ERR_INVALID_SLOT_NUM;

	hnd->Channel.cc=slot_num;   

	//       
	if((err=LTR_Open(&(hnd->Channel)))!=LTR_OK)   
		if(err<0)
			if(err==LTR_WARNING_MODULE_IN_USE)
			{
				warning=err;
				err=LTR_OK;
			}
			else 
				return err;
		else
			return LTR42_ERR_CANT_OPEN;	   

	slot_num-=1;   

	//  :  : , , 

	command[0]=LTR010CMD_STOP|(slot_num<<8);
	stop[0]=LTR010CMD_STOP|(slot_num<<8);



	if((err=(LTR_Send(&(hnd->Channel), stop, 1, TIMEOUT_CMD_SEND))) != 1 )  //   "STOP"
		return LTR42_ERR_CANT_SEND_COMMAND;


	command[0]=LTR010CMD_RESET|(slot_num<<8);;   
	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) != 1 )  //  "RESET"
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_RESET_MODULE; 



	tick=GetTickCount();



	while(1)
	{
		read_cntr=LTR_Recv(&(hnd->Channel), rbuf, NULL, 1024, 100); //  ,   FIFO

		if(read_cntr!=0)
			if((rbuf[read_cntr-1]&0xFFFF0000)==(0x2A2A0000)) 
				break;



		if(CalkTickInterval(tick, GetTickCount())>=5000) //    5    
			return LTR42_ERR_CANT_RESET_MODULE; 

	} 



	if((err=(LTR_Send(&(hnd->Channel), stop, 1, TIMEOUT_CMD_SEND))) != 1)  //   "STOP"
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_COMMAND;


	Sleep(200);  
	command[0]=INIT|(slot_num<<8);


	if((err=(LTR_Send(&(hnd->Channel), command, 1, TIMEOUT_CMD_SEND))) != 1 )  //    INSTR
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_COMMAND;

	if((err=(LTR_Recv(&(hnd->Channel), rbuf, NULL, 1, TIMEOUT_CMD_RECIEVE))!=1))   //  
		if(err<0)
			return err;
		else
			return LTR42_ERR_MODULE_NO_RESPONCE;


	err=LTR42_ReadConfRecord(hnd, hnd->ModuleInfo.FirmwareVersion, hnd->ModuleInfo.FirmwareDate, hnd->ModuleInfo.Name, hnd->ModuleInfo.Serial); 
	if(err) return err;   


	if(warning)
		return(warning);
	else 
		return LTR42_NO_ERR;
}


/***************************************************************************************

    

****************************************************************************************/               

LTR42API_DllExport(INT) LTR42_Close(PTLTR42 hnd)
{
	int err=0;

	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 

	LTR42_StopSecondMark(hnd);


	if ((err=LTR_Close(&(hnd->Channel)))!=LTR_OK) 
		return(err);	 

	return LTR42_NO_ERR; 
}



/***************************************************************************************

 :   

****************************************************************************************/               

LTR42API_DllExport(INT) LTR42_IsOpened(PTLTR42 hnd)
{

	INT err;
	if(hnd!=NULL)  err=LTR_IsOpened(&hnd->Channel);   
	else err=LTR_ERROR_PARAMETRS;
	return err;

}


/**************************************************************************************

  

**************************************************************************************/


LTR42API_DllExport(INT) LTR42_Config(PTLTR42 hnd)

{
	DWORD command;
	DWORD command_ack;
	DWORD slot_num   =hnd->Channel.cc -1;
	BYTE Output_Groups=0;
	BYTE Marks_Conf;

	int err=0;


	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR;


	if((hnd->Marks.StartMark_Mode<0)||(hnd->Marks.StartMark_Mode>2))
		return LTR42_ERR_WRONG_START_MARK_CONF;

	if((hnd->Marks.SecondMark_Mode<0)||(hnd->Marks.StartMark_Mode>2))
		return LTR42_ERR_WRONG_SECOND_MARK_CONF;



	Marks_Conf=hnd->Marks.StartMark_Mode;
	Marks_Conf<<=4;
	Marks_Conf|=hnd->Marks.SecondMark_Mode;

	command=Marks_Conf;

	if(hnd->AckEna!=0)
		hnd->AckEna=1;

	command|=((DWORD) (hnd->AckEna))<<8;

	command<<=16;
	command|=CONFIG;
	command|=(slot_num<<8);
	command|=(eval_parity(command))<<5; 



	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))!= 1 )
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_COMMAND;

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
		if(err<0)
			return err;
		else
			return LTR42_ERR_MODULE_NO_RESPONCE;


	//     

	if(check_parity(command_ack))
		return LTR42_ERR_PARITY_FROM_MODULE;


	if((command_ack&0x0000001F)==PARITY_ERROR)
		return LTR42_ERR_PARITY_TO_MODULE; 


	if((command_ack&0x0000FF1F)!=(command&0x0000FF1F)) //  . ,  ""  
		return LTR42_ERR_CANT_CONFIG;  




	return LTR42_NO_ERR; 
}  




/**************************************************************************************

  16-     

**************************************************************************************/    

LTR42API_DllExport(INT) LTR42_WritePort(PTLTR42 hnd, WORD OutputData)
{
	DWORD data[4];
	DWORD command_ack;
	DWORD slot_num   =hnd->Channel.cc -1;  
	int err=0;
	WORD val;


	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 


	val=OutputData;   



	data[0]=((val<<16)|1|(slot_num<<8)); //      
	data[1]=((val<<16)|(slot_num<<8));  	 // 





	if((err=(LTR_Send(&(hnd->Channel), data, 2, TIMEOUT_CMD_SEND))) !=2 ) 
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_DATA; 

	//     
	if(hnd->AckEna) 

	{
		if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1) 
			if(err<0)
				return err;
			else
				return LTR42_ERR_MODULE_NO_RESPONCE;  





		//     

		if(check_parity(command_ack))
			return LTR42_ERR_PARITY_FROM_MODULE;

		//    
		if((command_ack&0x0000001F)==PARITY_ERROR) 
			return LTR42_ERR_PARITY_TO_MODULE; 


		if(((command_ack)&0x1F)==DATA_ERROR) 
			return LTR42_ERR_DATA_TRANSMISSON_ERROR; 



		if(((command_ack)&0xF1F)!=(DATA_OUTPUT_CONFIRM|(slot_num<<8)))
			return LTR42_ERR_CANT_SEND_DATA;

	}										 
	return LTR42_NO_ERR;  
}

/**************************************************************************************

   16-     

**************************************************************************************/    


LTR42API_DllExport(INT) LTR42_WriteArray(PTLTR42 hnd, WORD *OutputArray, int ArraySize)
{
	DWORD data[2];
	int cmd_cntr=0;
	DWORD *command_ack;
	DWORD slot_num   =hnd->Channel.cc -1;  
	int err=0;
	WORD val;
	LARGE_INTEGER Freq, Start, Fin; 
	double R_Time[1000];    

	int i,j=0;


	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 

	err=LTR42_NO_ERR; 

	command_ack=(DWORD *) malloc(ArraySize*sizeof(DWORD)); 


	QueryPerformanceFrequency(&Freq);   

	for(i=0;i<ArraySize;i++)
	{

		QueryPerformanceCounter(&Start); 

		val=OutputArray[i];   

		data[0]=((val<<16)|1|(slot_num<<8)); //      
		data[1]=((val<<16)|(slot_num<<8));  	 // 

		//Sleep(5);

		if((cmd_cntr=(LTR_Send(&(hnd->Channel), data, 2, TIMEOUT_CMD_SEND))) !=2 ) 
			if(cmd_cntr<0)
			{ err=cmd_cntr;
		goto exit;
		} 
			else
			{
				err=LTR42_ERR_CANT_SEND_DATA;
				goto exit;
			} 

			QueryPerformanceCounter(&Fin);      

			R_Time[j] = ((Fin.QuadPart - Start.QuadPart)*1.0)/(Freq.QuadPart*1.0); 
			R_Time[j]*=1000.0;
			j++;			


	}  

	if((cmd_cntr=(LTR_Recv(&(hnd->Channel), command_ack, NULL,ArraySize, TIMEOUT_CMD_RECIEVE)))!=ArraySize) 
		if(cmd_cntr<0)
		{
			err=cmd_cntr; 
			goto exit;
		} 
		else
		{
			err=LTR42_ERR_MODULE_NO_RESPONCE;  
			goto exit;
		} 


		//   .     
		for(i=0;i<ArraySize;i++)   
		{


			//     

			if(check_parity(command_ack[i]))
			{
				err=LTR42_ERR_PARITY_FROM_MODULE;
				goto exit;
			} 

			//    
			if((command_ack[i]&0x0000001F)==PARITY_ERROR) 
			{
				err=LTR42_ERR_PARITY_TO_MODULE; 
				goto exit;
			} 


			if(((command_ack[i])&0x1F)==DATA_ERROR) 
			{
				err=LTR42_ERR_DATA_TRANSMISSON_ERROR; 
				goto exit;
			} 



			if(((command_ack[i])&0xF1F)!=(DATA_OUTPUT_CONFIRM|(slot_num<<8)))
			{
				err=LTR42_ERR_CANT_SEND_DATA;
				goto exit;
			}

		} //  for


exit:

		if(command_ack!=NULL)
			free(command_ack);

		return err;  

}



/****************************************************************************************

    

****************************************************************************************/   

LTR42API_DllExport(INT) LTR42_StartSecondMark(PTLTR42 hnd)
{

	DWORD command;
	DWORD command_ack;
	DWORD slot_num   =hnd->Channel.cc -1;
	int err=0;



	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 

	command=0x0;
	command|=START_SECOND_MARK;
	command|=(slot_num<<8);

	command|=(eval_parity(command))<<5; 

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 )  
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_COMMAND;

	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1) 
		if(err<0)
			return err;
		else
			return LTR42_ERR_MODULE_NO_RESPONCE; 


	if(check_parity(command_ack))
		return LTR42_ERR_PARITY_FROM_MODULE;


	if((command_ack&0x0000001F)==PARITY_ERROR) 
		return LTR42_ERR_PARITY_TO_MODULE; 


	if((command_ack&0x0000FF1F)!=(command&0x0000FF1F))
		return LTR42_ERR_CANT_LAUNCH_SEC_MARK;

	// hnd->Marks.SecondMarks_Qnt=0; 

	return LTR42_NO_ERR; 
}



/****************************************************************************************

     

****************************************************************************************/   




LTR42API_DllExport(INT) LTR42_StopSecondMark(PTLTR42 hnd)
{

	DWORD command;
	DWORD command_ack;
	DWORD slot_num   =hnd->Channel.cc -1;  
	int err=0;


	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 

	command=0x0;
	command|=STOP_SECOND_MARK;
	command|=(slot_num<<8);

	command|=(eval_parity(command))<<5; 

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 ) 
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_COMMAND;


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)   
		if(err<0)
			return err;
		else
			return LTR42_ERR_MODULE_NO_RESPONCE; 


	if(check_parity(command_ack))
		return LTR42_ERR_PARITY_FROM_MODULE;


	if((command_ack&0x0000001F)==PARITY_ERROR) 
		return LTR42_ERR_PARITY_TO_MODULE;  


	if((command_ack&0x0000FF1F)!=(command&0x0000FF1F))
		return LTR42_ERR_CANT_STOP_SEC_MARK;

	return LTR42_NO_ERR;   
}


/****************************************************************************************

   ""

****************************************************************************************/   


LTR42API_DllExport(INT) LTR42_MakeStartMark(PTLTR42 hnd)
{

	DWORD command;
	DWORD command_ack;
	DWORD slot_num   =hnd->Channel.cc -1;  
	int parity;
	int err=0;

	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 

	command=0;
	command|=MAKE_START_MARK;
	command|=(slot_num<<8);


	parity=eval_parity(command);
	command|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND))) != 1 ) 
		if(err<0)
			return err;
		else
			return LTR42_ERR_CANT_SEND_COMMAND;


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
		if(err<0)
			return err;
		else
			return LTR42_ERR_MODULE_NO_RESPONCE; 


	if(check_parity(command_ack))
		return LTR42_ERR_PARITY_FROM_MODULE;


	if((command_ack&0x0000001F)==PARITY_ERROR) 
		return LTR42_ERR_PARITY_TO_MODULE; 


	if((command_ack&0x0000FF1F)!=(command&0x0000FF1F)) //  . ,  ""  
		return LTR42_ERR_CANT_LAUNCH_START_MARK;  


	return LTR42_NO_ERR;   

}



static const int min_range_id = -8000; 
const LPCSTR err_str[] = 
{
	"LTR42:     !",
	"LTR42:  !",
	"LTR42:   !",
	"LTR42:   !",
	"LTR42:  !",
	"LTR42:    !",
	"LTR42:  !",
	"LTR42:     !",
	"LTR42:   !",
	"LTR42:    !",
	"LTR42:    !",
	"LTR42:   !",
	"LTR42:    !", 
	"LTR42:  ,   !",
	"LTR42:     !",
	"LTR42:      !",	  //,       ! (0,1,2)?
	"LTR42:   !   0, 1  2   Marks.SecondMark_Mode!",
	"LTR42:   !   0, 1  2   Marks.StartMark_Mode!",
	"LTR42:  !",
	"LTR42:     EEPROM!",
	"LTR42:    EEPROM!",
	"LTR42:  EEPROM!",
	"LTR42:   !",
	"LTR42:  !",
};

/*****************************************************************************************************

   

******************************************************************************************************/   

LTR42API_DllExport(LPCSTR) LTR42_GetErrorString(int Error_Code)
{
	LPCSTR ret_val = NULL;
	int ret_val_index;
	double error_range;

	error_range=-min_range_id + 1+sizeof err_str / sizeof err_str[0];

	if ((-Error_Code < -min_range_id )|| (Error_Code < -error_range))
	{
		ret_val = LTR_GetErrorString(Error_Code);
	}
	else
	{
		ret_val_index=-Error_Code + min_range_id-1;
		ret_val = err_str[ret_val_index];
	}

	return ret_val;
}



/**********************************************************************************************

      

************************************************************************************************/    

LTR42API_DllExport(INT) LTR42_WriteEEPROM(PTLTR42 hnd, INT Address, BYTE val) 
{

	DWORD command[2], command_ack;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;
	INT parity=0;

	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR;


	if((Address<0)||(Address)>=512)             
		return LTR42_ERR_WRONG_EEPROM_ADDR;           

	command[0]=Address; //   
	command[0]<<=16;
	command[0]|=WRITE_EEPROM|(slot_num<<8);  //    DSP

	parity=eval_parity(command[0]);
	command[0]|=(parity)<<5;


	command[1]=val; //   
	command[1]<<=16;
	command[1]|=WRITE_EEPROM|(slot_num<<8);

	parity=eval_parity(command[1]);
	command[1]|=(parity)<<5;

	if((err=(LTR_Send(&(hnd->Channel), command, 2, TIMEOUT_CMD_SEND)))!=2) 
		if(err<0)
			return err;
		else 		 
			return LTR42_ERR_CANT_SEND_COMMAND;      


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
		if(err<0)
			return err;
		else 
			return LTR42_ERR_CANT_WRITE_EEPROM;     


	//     

	if(check_parity(command_ack))
		return LTR42_ERR_PARITY_FROM_MODULE;


	if((command_ack&0x0000001F)==PARITY_ERROR) 
		return LTR42_ERR_PARITY_TO_MODULE; 


	if((command_ack&0x0000FF1F)!=(command[0]&0x0000FF1F)) //  . ,  ""  
		return LTR42_ERR_CANT_WRITE_EEPROM;  

	return LTR42_NO_ERR;  
}


/**********************************************************************************************

      

************************************************************************************************/       


LTR42API_DllExport(INT) LTR42_ReadEEPROM(PTLTR42 hnd, INT Address, BYTE *val) 
{

	DWORD command, command_ack;
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;
	INT parity=0;


	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR;


	if((Address<0)||(Address)>=512)             
		return LTR42_ERR_CANT_READ_EEPROM;           

	command=Address; //   
	command<<=16;
	command|=READ_EEPROM|(slot_num<<8);  //    DSP

	parity=eval_parity(command);
	command|=(parity)<<5;


	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))!=1) 
		if(err<0)
			return err;
		else 		 
			return LTR42_ERR_CANT_SEND_COMMAND;      


	if((err=(LTR_Recv(&(hnd->Channel), &command_ack, NULL, 1, TIMEOUT_CMD_RECIEVE)))!=1)
		if(err<0)
			return err;
		else 
			return LTR42_ERR_CANT_READ_EEPROM;     

	//     

	if(check_parity(command_ack))
		return LTR42_ERR_PARITY_FROM_MODULE;


	if((command_ack&0x0000001F)==PARITY_ERROR) 
		return LTR42_ERR_PARITY_TO_MODULE; 


	if((command_ack&0x0000FF1F)!=(command&0x0000FF1F)) //  . ,  ""  
		return LTR42_ERR_CANT_READ_EEPROM;  

	*val=(BYTE)(command_ack>>16)&0xFF;

	return LTR42_NO_ERR;  
}

/*****************************************************************************************************

      

******************************************************************************************************/ 

int LTR42_ReadConfRecord(PTLTR42 hnd, CHAR *version, CHAR *date, CHAR *name, CHAR *serial)
{

#define CR_LENGTH (42)
#define CRC_LENGTH (2)

	BYTE conf_rec[44]; 
	BYTE ver[2];

	DWORD command, command_ack[50];
	INT slot_num     =hnd->Channel.cc -1; 
	INT err=0;
	INT parity=0;
	WORD CR_CRC;      // .  . ,  
	WORD CR_CRC_RCV;  // .  . ,   Flash
	int i;


	if(hnd==NULL)
		return LTR42_ERR_WRONG_MODULE_DESCR; 


	command=0; //   
	command|=READ_CONF_RECORD|(slot_num<<8);  //    DSP

	parity=eval_parity(command);
	command|=(parity)<<5;


	if((err=(LTR_Send(&(hnd->Channel), &command, 1, TIMEOUT_CMD_SEND)))!=1) 
		if(err<0)
			return err;
		else 		 
			return LTR42_ERR_CANT_SEND_COMMAND;      


	if((err=(LTR_Recv(&(hnd->Channel), command_ack, NULL, CR_LENGTH+CRC_LENGTH, TIMEOUT_CMD_RECIEVE)))!=(CR_LENGTH+CRC_LENGTH))
		if(err<0)
			return err;
		else 
			return LTR42_ERR_CANT_READ_CONF_REC;  


	for(i=0;i<CR_LENGTH;i++)
	{

		if((command_ack[i]&0x0000001F)==PARITY_ERROR) 
			return LTR42_ERR_PARITY_TO_MODULE;   


		//       -      
		//   6    -      

		if(check_parity(command_ack[i]))
			return LTR42_ERR_PARITY_FROM_MODULE;  //     

		if((command_ack[i]&0x0000FF1F)!=(command&0x0000FF1F))
			return LTR42_ERR_CANT_READ_CONF_REC;  
	}    


	for(i=0;i<CR_LENGTH;i++)
		conf_rec[i]=(BYTE)(command_ack[i]>>16)&0xFF;

	CR_CRC=0;

	CR_CRC=CRC_Calc(conf_rec, CR_LENGTH); 
	CR_CRC_RCV=(WORD)(((command_ack[CR_LENGTH]>>16)&0xFFF)|((command_ack[CR_LENGTH+1]>>8)&0xFF00));


	// !     !

	if(CR_CRC!=CR_CRC_RCV)
		return LTR42_ERR_WRONG_CONF_REC; 


	if(conf_rec[0]!=MODULE_ID)
		return LTR42_ERR_WRONG_CONF_REC; 


	for(i=0;i<2;i++)
		ver[i]=*(conf_rec+1+i); //  

	sprintf(version, "%d.%d",ver[0], ver[1]);    

	for(i=0;i<14;i++)
		date[i]=*(conf_rec+3+i); //   

	for(i=0;i<8;i++)
		name[i]=*(conf_rec+17+i); //   

	for(i=0;i<17;i++)
		serial[i]=*(conf_rec+25+i); //   




	return LTR42_NO_ERR;  
} 




/*******************************************************************************

   

/*******************************************************************************/

INT eval_parity(DWORD cmd)
{
	unsigned long index;
	INT           parity;


	parity = 0;
	for (index = 0x01UL; index <= 0x10UL; index <<= 1)
		parity ^= (cmd & index) != 0;  

	//        	
	for (index = 0x80000000UL; index >= 0x00010000UL; index >>= 1)
		parity ^= (cmd & index) != 0;


	return parity;
}


/*******************************************************************************

   

/*******************************************************************************/

INT eval_parity_in(DWORD cmd)
{
	unsigned long index;
	INT           parity;


	parity = 0;
	for (index = 0x01UL; index <= 0x10UL; index <<= 1)
		parity ^= (cmd & index) != 0;  

	//        	
	for (index = 0x800000UL; index >= 0x010000UL; index >>= 1)
		parity ^= (cmd & index) != 0;


	return parity;
}


INT check_parity(DWORD cmd)
{
	if(((cmd&0x20)>>5)==eval_parity_in(cmd))
		return(0);
	else
		return(1);
}  




/*******************************************************************************

 16- CRC

/*******************************************************************************/


static WORD CRC_Calc(BYTE *b, WORD N)
/*  .
:
b --  .
N --  .
:
  .
*/
{
	WORD crc= 0;
	int i, j;

	for(i=0; i<N; i++) {
		crc ^= b[i] << 8;
		for(j=0;j<8;j++) {
			if(crc&0x8000) crc = (crc<<1) ^ 0x1021;
			else crc <<= 1;
		}
	}
	return crc;
}

static void CRC_Update(WORD *crc, BYTE *b, int c)
/*     ,  
   .
:
crc --      .
b --  .
c --  .
:
crc --      .
*/
{
	unsigned w;
	int i,j;

	w = *crc;
	for(i=0;i<c;i++) {
		w ^= b[i] << 8;
		for(j=0;j<8;j++)  {
			if(w&0x8000) w = (w<<1) ^ 0x1021;
			else w <<= 1;
		}
	}
	*crc = w;
}


/********************************************************************************

  

**********************************************************************************/                          

static DWORD CalkTickInterval(DWORD PrevTick, DWORD ActTick)
{
	DWORD Diff;

	if(ActTick>=PrevTick)
		Diff=ActTick-PrevTick;
	else
		Diff=(0xFFFFFFFF-PrevTick)+ActTick;

	return Diff;

}



#ifdef _MANAGED
#pragma managed(pop)
#endif