// example.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include "stdio.h"
#include "stdlib.h"
#include "conio.h"
#include <windows.h>
#include "ltr\include\ltr43api.h"

TLTR43 hltr43;
char ErrorString[255];
char MsgString[255];

void oem_printf(char *s)
{
 CharToOem(s,s);
 printf("%s",s);
}


int main(int argc, char* argv[])
{
DWORD AcqThreadId;
DWORD ThreadSatus;

DWORD OutputWord;
DWORD InputWord;

DWORD OutputArray[5]=
 {
 0x0076D300,
 0x009A3400,
 0x00127600,
 0x00FF7100,
 0x00CA6B00
 };

INT TotalBlockCntr;

INT err;                 //    


//*          */
 sprintf(MsgString,"  \n");
 oem_printf(MsgString);

 err=LTR43_Init(&hltr43);

 if(err)
 {
 strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
 oem_printf(ErrorString);
 goto End;
  }
 else
 {
  sprintf(MsgString,"LTR43_Init()->OK\n");
  oem_printf(MsgString);
 }

//  .    .      -  
//     ;
//    - 1;

err=LTR43_Open(&hltr43, SADDR_DEFAULT, SPORT_DEFAULT, "", CC_MODULE7);
 if(err)
 {
   if(err==LTR_WARNING_MODULE_IN_USE)
    {
    strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
    oem_printf(ErrorString);
    }
   else
    {
     strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
     oem_printf(ErrorString);
     goto End;
    }
  }
 else
  {
  sprintf(MsgString,"LTR43_Open()->OK\n");
  oem_printf(MsgString);
 }

sprintf(MsgString," : %s\n", hltr43.ModuleInfo.Name);
oem_printf(MsgString);

sprintf(MsgString,"  AVR: %s\n", hltr43.ModuleInfo.FirmwareVersion);
oem_printf(MsgString);

sprintf(MsgString,"   AVR: %s\n", hltr43.ModuleInfo.FirmwareDate);
oem_printf(MsgString);

sprintf(MsgString,"  : %s\n\n", hltr43.ModuleInfo.Serial);
oem_printf(MsgString);

 //        
 //    -

hltr43.IO_Ports.Port1=0;  //        
hltr43.IO_Ports.Port2=1;  //  
hltr43.IO_Ports.Port3=1;  //  
hltr43.IO_Ports.Port4=0;  //  


/*   */
hltr43.Marks.SecondMark_Mode=1;     //    .    
hltr43.Marks.StartMark_Mode=0;      //    



//    
err=LTR43_Config(&hltr43);
if(err)
 {
 strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
 LTR43_Close(&hltr43);
 oem_printf(ErrorString);
 goto End;
  }
 else
  {
  sprintf(MsgString,"LTR43_Config()->OK\n");
  oem_printf(MsgString);
 }


  /*      -.      
  ,    , ..   9-24. */

sprintf(MsgString,"   -  0x00A17400\n");
oem_printf(MsgString);

OutputWord=0x00B17400;

err=LTR43_WritePort(&hltr43, OutputWord);
if(err)
 {
   strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
   LTR43_Close(&hltr43);
   oem_printf(ErrorString);
   goto End;
  }
 else
   {
  sprintf(MsgString,"LTR43_WritePort()->OK\n");
  oem_printf(MsgString);
 }

//      -.

sprintf(MsgString,"     -\n");
oem_printf(MsgString);

err=LTR43_ReadPort(&hltr43, &InputWord);
if(err)
 {
  strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
  LTR43_Close(&hltr43);
  oem_printf(ErrorString);
  goto End;
  }
 else
 {
  sprintf(MsgString,"LTR43_ReadPort()->OK\n");
  oem_printf(MsgString);
 }
  //      
  sprintf(MsgString, " : %x hex\n", InputWord);
  oem_printf(MsgString);

/*     5    - */

err= LTR43_WriteArray(&hltr43,  OutputArray, 5);
if(err)
  {
   strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
   LTR43_Close(&hltr43);
   oem_printf(ErrorString);
   goto End;
  }
else
  {
  sprintf(MsgString,"LTR43_WriteArray->OK\n");
  oem_printf(MsgString);
 }

 //    
sprintf(MsgString,"   \n");
oem_printf(MsgString);

err= LTR43_StartSecondMark(&hltr43);
if(err)
  {
   strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
   LTR43_Close(&hltr43);
   oem_printf(ErrorString);
   goto End;
  }
else
  {
  sprintf(MsgString,"LTR43_StartSecondMarks()->OK\n");
  oem_printf(MsgString);
 }

 //  3 .     ,   3  
 Sleep(3000);

sprintf(MsgString,"   \n");
oem_printf(MsgString);

//    

err= LTR43_StopSecondMark(&hltr43);
if(err)
  {
   strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
   LTR43_Close(&hltr43);
   oem_printf(ErrorString);
   goto End;
  }
else
  {
  sprintf(MsgString,"LTR43_StopSecondMark()->OK\n");
  oem_printf(MsgString);
  }

 //   

  sprintf(MsgString,"  \n");
  oem_printf(MsgString);

err= LTR43_MakeStartMark(&hltr43);
if(err)
  {
   strcpy(ErrorString, (char *) LTR43_GetErrorString(err));
   LTR43_Close(&hltr43);
   oem_printf(ErrorString);
   goto End;
  }
else
 {
  sprintf(MsgString,"LTR43_MakeStartMark()->OK\n");
  oem_printf(MsgString);
 }


End:
sprintf(MsgString,">>     \n");
oem_printf(MsgString);

   while(!kbhit())
        continue;

        return 0;
}

