program ltr51ex;

{$APPTYPE CONSOLE}

uses
  SysUtils,
  Windows,
  ltr51api in 'ltr51api.pas',
  ltrapi in 'ltrapi.pas';

const
      LCh_QNT = 16;
label exit;
var module: TLTR51;                //     
  	err: Integer;                  //     
	  SlotNum: Integer;              //   
	  i,j: Integer;                  //      
	  samples_qnt: LongWord;         //   ,   -
	  samples_qnt_rcv: Integer;      //  ,   -
	  ThresholdRange: Integer;       //   
	  HighThreshold: double;         //   
	  LowThreshold: double;          //   
	  EdgeMode: Integer;             //    
	  ta,g: Integer;                 //     
	  data:array[0..5000]of Word;    // ,    ,   
	  output_array:array[0..5000]of Word;     //    N  M
    Frequency: array[0..LCh_QNT-1] of double;   //      
    Version: PChar;                //      .  AVR
	  FirmwareDate: PChar;           //       .  AVR
	  FPGA_Version: PChar;           //        ALTERA ACEX
	  Serial: PChar;                 //       
	  ModuleName: PChar;             //      
    Fs, Base, AcqTime, TbaseQnt: PChar;
    RunFlag: integer;
	  ErrorString: PChar;            //     

begin

//     .        .
err:=LTR51_Init(@module);

if(err=LTR_OK) then
   Writeln('Module initialization is successfully')
else
 begin
  //     
  ErrorString:=LTR51_GetErrorString(err);
   //     , ..   
  CharToOem(ErrorString,ErrorString);
  //   
  Writeln(ErrorString);

  goto exit;
 end;

//   
SlotNum:= 1;
//      
err:=LTR51_Open(@module, module.Channel.saddr, module.Channel.sport, @module.Channel.csn, SlotNum,'ltr51.ttf');

if(err=LTR_OK) then
   Writeln('Module has opened successfully')
else
 begin
  ErrorString:=LTR51_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  Writeln(ErrorString);
  goto exit;
 end;

//  . 
Writeln;

Version:=@module.ModuleInfo.FirmwareVersion;
Write('Firmware version: ');
Writeln(Version);

FPGA_Version:=@module.ModuleInfo.FPGA_Version;
Write('FPGA_Version: ');
Writeln(FPGA_Version);

FirmwareDate:=@module.ModuleInfo.FirmwareDate;
Write('Firmware date: ');
Writeln(FirmwareDate);

Serial:=@module.ModuleInfo.Serial;
Write('Serial number: ');
Writeln(Serial);

ModuleName:=@module.ModuleInfo.Name;
Write('ModuleName: ');
Writeln(ModuleName);

Writeln;

//     .    
for i:=0 to module.LChQnt-1 do
begin
  module.LChQnt:=  16;         //     16
  ThresholdRange:= 0;         //    +/-1,2 
  HighThreshold:= 0.2;        //    + 0.7 
  LowThreshold:= -0.2;        //     0.3 
  EdgeMode:= 0;               //       
  module.LChTbl[i]:= LTR51_CreateLChannel((i div 2)+1, @HighThreshold, @LowThreshold, ThresholdRange, EdgeMode);
end;

//        
module.SetUserPars:= 1;      //   
module.Fs:= 100000;          //   100 
module.Base:= 32768;            //  Base
module.AcqTime:=5000;



 //  
err:=LTR51_Config(@module);

if(err=LTR_OK) then
   Writeln('Module has configured successfully')
else
 begin
  ErrorString:=LTR51_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  Writeln(ErrorString);
  goto exit;
 end;

//       
Write('Fs= ');
Writeln(module.Fs);


Write('Base= ');
Writeln(module.Base);


Write('AcqTime= ');
Writeln(module.AcqTime, ' mc');


Write('TbaseQnt= ');
Writeln(module.TbaseQnt);

ta:= module.AcqTime+1000; //     ,   

//      
//GetMem(data, 2*module.LChQnt*module.TbaseQnt);
//     
//GetMem(output_array, module.LChQnt*module.TbaseQnt);
//         
//GetMem(Frequency, module.LChQnt);

//***********************************************
//   
err:= LTR51_Start(@module);

if(err=LTR_OK) then
   Writeln('Module has started successfully')
else
 begin
  ErrorString:=LTR51_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  Writeln(ErrorString);
  goto exit;
 end;

j:= 0;  //    
RunFlag:= 1;

while (RunFlag>=1) do
  begin
		// ,       ,     
		samples_qnt:= 64;
    ta:=2000;

		//  
		samples_qnt_rcv:= LTR51_Recv (@module, @data, NIL, samples_qnt, ta);

		if(samples_qnt_rcv <> samples_qnt) then
		  begin
			  if(samples_qnt_rcv < 0) then
          Writeln('Error: It is not possible to obtain the data from crait')
			  else
          Writeln('Error: the quantity received ',samples_qnt_rcv,' sempls is not equal to quantity required ',samples_qnt);
			  break; //       
		  end;

		err:= LTR51_ProcessData(@module, @data, @output_array, @Frequency, @samples_qnt);

		if(err<>LTR_OK) then
      begin
        ErrorString:=LTR51_GetErrorString(err);
        CharToOem(ErrorString,ErrorString);
        Writeln(ErrorString);
        goto exit;
      end;
		j:= j+1;
    Writeln('Received ', j, ' portion of the data');

		//  
		for i:=0 to module.LChQnt-1 do
      Writeln('Value of frequency for ', i, ' the logic channel: ', Frequency[i]);

    Writeln;
		if (j=5) then
			RunFlag:= 0;
	end;

err:= LTR51_Stop(@module);

if(err=LTR_OK) then
   Writeln('Module has stoped successfully')
else
 begin
  ErrorString:=LTR51_GetErrorString(err);
  CharToOem(ErrorString,ErrorString);
  Writeln(ErrorString);
    
    goto exit;
 end;

 //    

exit:

Writeln;
Writeln('Closing module');
LTR51_Close(@module);

//if(data <> NIL) then
	//	FreeMem(data);
//if(output_array <> NIL) then
	//	FreeMem(output_array);

Writeln('Press any key to exit from application');
Readln;
end.
