// ReadData.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "ltr\\include\\ltr51api.h"

void main()
{

	TLTR51 conf; //     
	INT err; //     
	INT SlotNum; //   
	INT i; //      
	INT j; //   
	DWORD samples_qnt; //   ,   -
	INT samples_qnt_rcv; //  ,   -
	INT ThresholdRange; //   
	double HighThreshold; //   
	double LowThreshold; //   
	INT EdgeMode; //    
	int to; //     
	DWORD *data; // ,    ,   
	DWORD *output_array; //    N  M
	double * Frequency; //      
	CHAR FirmwareVersion[255]; //      .  AVR
	CHAR FirmwareDate[255]; //       .  AVR
	CHAR FPGA_Version[255]; //        ALTERA
	// ACEX
	CHAR SerialNum[255]; //       
	CHAR ModuleName[255]; //      
	CHAR ErrorString[255]; //     
	CHAR MsgString[255]; //      
	/*     .        . */



	err=LTR51_Init(&conf);
	if(err) 
	{
		strcpy(ErrorString, (char *) LTR51_GetErrorString(err));
		CharToOem(ErrorString,ErrorString);
		printf("%s",ErrorString);
		return;
	}

	//     .       -  

	//    1;
	SlotNum=1;
	//       - C://ltr51.ttf
	err=LTR51_Open(&conf, SADDR_DEFAULT, SPORT_DEFAULT,"", SlotNum, "ltr51.ttf");
	if(err) 
	{
		strcpy(ErrorString, (char *) LTR51_GetErrorString(err));
		CharToOem(ErrorString,ErrorString);
		printf("%s",ErrorString);
		LTR51_Close(&conf);
		Sleep(3000);
		return;
	}
	/*    .      */
	strcpy(FirmwareVersion, conf.ModuleInfo.FirmwareVersion);
	strcpy(MsgString,"  : ");
	strcat(MsgString, FirmwareVersion);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	strcpy(FPGA_Version, conf.ModuleInfo. FPGA_Version);
	strcpy(MsgString,"  : ");
	strcat(MsgString, FPGA_Version);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	strcpy(FirmwareDate, conf.ModuleInfo.FirmwareDate);
	strcpy(MsgString,"   : ");
	strcat(MsgString, FirmwareDate);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	strcpy(SerialNum, conf.ModuleInfo.Serial);
	strcpy(MsgString,"  : ");
	strcat(MsgString, SerialNum);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	strcpy(ModuleName, conf.ModuleInfo.Name);
	strcpy(MsgString," : ");
	strcat(MsgString, ModuleName);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	/*      */
	/*     */
	conf.LChQnt=16; //     16
	ThresholdRange=1; //    +/-1,2 
	HighThreshold=0.7; //    + 0.7 
	LowThreshold=-0.3; //     0.3 
	EdgeMode=1; //       
	for(i=0; i< conf.LChQnt; i++)
	{
		conf.LChTbl[i]=LTR51_CreateLChannel(i+1, &HighThreshold, &LowThreshold,
			ThresholdRange, EdgeMode);
	}
	/*         */

	conf.SetUserPars=1; //   
	conf.Fs=500000;     //   100 
	conf.Base=70;    //  Base 
	conf.AcqTime=5000;  //   5 . 

	err=LTR51_Config(&conf); //    .
	if(err) 
	{
		strcpy(ErrorString, (char *) LTR51_GetErrorString(err));
		CharToOem(ErrorString,ErrorString);
		printf("%s",ErrorString);
		LTR51_Close;
		Sleep(3000);
		return;
	}

	/*        */
	printf("\n");

	sprintf(MsgString,"   : %.3f ", conf.Fs);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	sprintf(MsgString,"  BASE: %d", conf.Base);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	sprintf(MsgString,"   : %d :", conf.AcqTime) ;
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	sprintf(MsgString,"  : %d", conf. TbaseQnt);
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 

	to=conf.AcqTime+1000; //     ,   

	/*       */
	samples_qnt=2*conf.LChQnt*conf. TbaseQnt;
	data=(DWORD *) malloc(samples_qnt *sizeof(DWORD));
	/*      */
	output_array =(DWORD *) malloc(conf.LChQnt*conf. TbaseQnt *sizeof(DWORD));
	/*          */
	Frequency =(double *) malloc(conf.LChQnt*sizeof(double));

	//   
	err=LTR51_Start(&conf); //   
	if(err) 
	{
		strcpy(ErrorString, (char *) LTR51_GetErrorString(err));
		CharToOem(ErrorString,ErrorString);
		printf("%s",ErrorString);
		goto exit;
	}

	j=0; //    

	printf("\n");
	while(1)
	{
		/* ,       ,     .      , .. - LTR51_ProcessData()    */
		samples_qnt=2*conf.LChQnt*conf. TbaseQnt;
		/*   */
		samples_qnt_rcv=LTR51_Recv (&conf, data, NULL, samples_qnt, to);

		if(samples_qnt_rcv!=(int) samples_qnt)
		{
			if(samples_qnt_rcv < 0)
			{
				sprintf(MsgString,"%s", "     -!");
				CharToOem(MsgString,MsgString);
				printf("%s\n",MsgString); 
			}
			else
			{
				sprintf(MsgString, "!       !");
				CharToOem(MsgString,MsgString);
				printf("%s\n",MsgString); 
			}

			break; //       
		}

		err=LTR51_ProcessData(&conf, data, output_array, Frequency, &samples_qnt);
		if(err) //   ...
		{
			strcpy(ErrorString, (char *) LTR51_GetErrorString(err));
			CharToOem(ErrorString,ErrorString);	
			printf( "%s", ErrorString); //    
			break; //    
		}
		j++;
		sprintf(MsgString," %d-  ",j);
		CharToOem(MsgString,MsgString);
		printf("%s\n",MsgString); 

		//  
		for(i=0;i<conf.LChQnt;i++)
		{
			sprintf(MsgString,"   %d-  : %.3f",i, Frequency[i]);
			CharToOem(MsgString,MsgString);
			printf("%s\n",MsgString); 
		}
		printf("\n");
		if(j==5)
			break;

	}
	//   
	err=LTR51_Stop(&conf); //   

exit:
	LTR51_Close(&conf); //     

	if(data!=NULL)
		free(data);

	if(output_array!=NULL)
		free(output_array);

	if(Frequency!=NULL)
		free(Frequency);

	sprintf(MsgString,"  .     .");
	CharToOem(MsgString,MsgString);
	printf("%s\n",MsgString); 
	getchar();
	return;

}

