#include <vcl.h>
#include "LtrCrate.h"
#include "LtrClient.h"

//-----------------------------------------------------------------------------
__fastcall TControlClientThread::TControlClientThread(TClient *_client, bool CreateSuspended) : TThread(CreateSuspended)
{
    Priority=tpNormal;
    FreeOnTerminate=false;
    client=_client;
    init_complete=CreateEvent(NULL, FALSE, FALSE, NULL);

    wsaovcntrl.hEvent=WSACreateEvent();
    wsaovcntrlwr.hEvent=WSACreateEvent();
}
//-----------------------------------------------------------------------------
__fastcall TControlClientThread::~TControlClientThread(void)
{
    CloseHandle(init_complete);
}
//-----------------------------------------------------------------------------
int __fastcall TControlClientThread::recv(BYTE *buf, DWORD size)
{
    if (size==0||buf==NULL)  return 0;
    DWORD SizeRecieved=0;

    while (SizeRecieved<size&&!Terminated&&client->IsAlive) // win2000    -      
    {
        DWORD sz=0;

        wsabufcntrl.len=size-SizeRecieved;
        wsabufcntrl.buf=buf+SizeRecieved;

        DWORD flag=0;
        int res=WSARecv(client->socket, &wsabufcntrl, 1, &sz, &flag, &wsaovcntrl, NULL);
        if (res==SOCKET_ERROR)
        {
            if (WSAGetLastError()==WSA_IO_PENDING)
            {
                while ((WSAWaitForMultipleEvents(1, &wsaovcntrl.hEvent, TRUE, TIMEOUT_2, FALSE)!=WSA_WAIT_EVENT_0)
                        &&!Terminated&&client->IsAlive);


                DWORD flag1=0;
                if (Terminated||!client->IsAlive)
                {
                    WSAGetOverlappedResult(client->socket, &wsaovcntrl, &sz, FALSE, &flag1);
                    CancelIo((HANDLE)client->socket);
                }
                else
                {

                    if (!WSAGetOverlappedResult(client->socket, &wsaovcntrl, &sz, FALSE, &flag1))
                    {
                        client->IsAlive=false;
                    }
                }
            }
            else client->IsAlive=false;
        }
        else if (res==0&&sz==0) client->IsAlive=false;
        SizeRecieved+=sz;
    }

    return SizeRecieved;
}
//-----------------------------------------------------------------------------
int __fastcall TControlClientThread::send(BYTE *buf, DWORD size)
{
    wsabufcntrlwr.len=size;
    wsabufcntrlwr.buf=buf;

    DWORD sz=0;

    int res=WSASend(client->socket, &wsabufcntrlwr, 1, &sz, 0, &wsaovcntrlwr, NULL);
    if (res==SOCKET_ERROR)
    {
        if (WSAGetLastError()==WSA_IO_PENDING)
        {
            while ((WSAWaitForMultipleEvents(1, &wsaovcntrlwr.hEvent, TRUE, TIMEOUT_2, FALSE)==WSA_WAIT_TIMEOUT)
                    &&!Terminated&&client->IsAlive);


            DWORD flgs=0;
            if (Terminated||!client->IsAlive)
            {
                WSAGetOverlappedResult(client->socket, &wsaovcntrlwr, &sz, FALSE, &flgs);
                CancelIo((HANDLE)client->socket);
            }
            else
            {
                if (!WSAGetOverlappedResult(client->socket, &wsaovcntrlwr, &sz, FALSE, &flgs))
                {
                    client->IsAlive=false;
                }
            }
        }
        else client->IsAlive=false;
    }
    else if (res==0&&sz==0) client->IsAlive=false;

    return sz;
}
//-----------------------------------------------------------------------------
void __fastcall TControlClientThread::ack(bool ack_flag)
{
    DWORD ack_value = ack_flag ? CONTROL_ACKNOWLEDGE_GOOD : CONTROL_ACKNOWLEDGE_BAD;
    send((BYTE*)&ack_value, CONTROL_ACKNOWLEDGE_SIZE);
}
//-----------------------------------------------------------------------------
void __fastcall TControlClientThread::Execute()
{
    TCrate  *crate=client->crate;

    //   
    SetEvent(init_complete);
    while (!Terminated&&client->IsAlive)
    {
        bool ack_flag=false;
        int res=recv((BYTE*)cheader, 8);
        if (res==0) break;

        if (res==8 && cheader[0]==CONTROL_COMMAND_START && (cheader[1]&0xFFFFFF00)==CONTROL_COMMAND_INIT_CONNECTION)
        {
            DWORD CommandCode = cheader[1];
            switch (CommandCode)
            {
            case CONTROL_COMMAND_BOOT_LOADER_PUT_ARRAY :
            case CONTROL_COMMAND_PUT_ARRAY :
                // DWORD addr, size
                res=recv((BYTE *)cheader, 8);
                if (res!=SOCKET_ERROR && res==8)
                {
                    res=recv(ControlBuffer, cheader[1]);
                    if (res!=SOCKET_ERROR && res==(int)cheader[1])
                    {
                        ack_flag = crate->PutArray(
                            (CommandCode == CONTROL_COMMAND_PUT_ARRAY) ? CM_APP : CM_BOOT,
                            cheader[0], ControlBuffer, cheader[1]);
                        ack(ack_flag);
                    }

                }
                break;
            case CONTROL_COMMAND_BOOT_LOADER_GET_ARRAY :
            case CONTROL_COMMAND_GET_ARRAY :
                // DWORD addr, size
                res=recv((BYTE *)cheader, 8);

                if (res!=SOCKET_ERROR && res==8)
                {
                    ack_flag = crate->GetArray(
                        (CommandCode == CONTROL_COMMAND_GET_ARRAY) ? CM_APP : CM_BOOT,
                        cheader[0], ControlBuffer, cheader[1]);
                    ack(ack_flag);
                    if (ack_flag) send(ControlBuffer, cheader[1]);
                }
                break;
            case CONTROL_COMMAND_BOOT_LOADER_GET_DESCRIPTION :
            case CONTROL_COMMAND_GET_DESCRIPTION :
                ack_flag=crate->GetModuleDescription(
                    (CommandCode == CONTROL_COMMAND_GET_DESCRIPTION) ? CM_APP : CM_BOOT,
                    (TDESCRIPTION_LTR010*)ControlBuffer);
                ack(ack_flag);
                if (ack_flag) send(ControlBuffer, sizeof(TDESCRIPTION_LTR010));
                break;
            case CONTROL_COMMAND_BOOT_LOADER_SET_DESCRIPTION :
                res=recv(ControlBuffer, sizeof(TDESCRIPTION_LTR010));
                if (res!=SOCKET_ERROR && res==sizeof(TDESCRIPTION_LTR010))
                {
                    ack_flag=crate->SetModuleDescription(CM_AUTO, (TDESCRIPTION_LTR010*)ControlBuffer);
                    ack(ack_flag);
                }
                break;
                //
            case CONTROL_COMMAND_LOAD_FPGA :
                // BYTE ControlBuffer[EP1K50_SIZE]
                res=recv(ControlBuffer, EP1K50_SIZE+2);
                if (res!=SOCKET_ERROR && res==(EP1K50_SIZE+2))
                {
                    //      
                    if (WaitForSingleObject(crate_list_access, INFINITE)==WAIT_OBJECT_0)
                        {
                        logfile.AddMessage(Format("Reloading crate >> CSN=%.16s", ARRAYOFCONST(((char*)crate->csn))), crate->log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_CONTROL);
                        ack_flag = crate->Startup(ControlBuffer + 2, NULL);

                        if (WaitForSingleObject(client_list_access, INFINITE)==WAIT_OBJECT_0)
                            {
                            if (!ack_flag)
                                {
                                logfile.AddMessage(Format("Can't ReInit Crate %s", ARRAYOFCONST((crate->path))), crate->log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CRATE_INIT);
                                client->IsAlive = false;
                                }
                            ReleaseMutex(client_list_access);
                            }
                        else
                            {
                            logfile.AddMessage("Can't access client list", crate->log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_CONTROL);
                            }
                        ReleaseMutex(crate_list_access);
                        }
                    else
                        {
                        logfile.AddMessage("Can't access crate list", crate->log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_CONTROL);
                        }
                    ack(ack_flag);
                }
                break;
            case CONTROL_COMMAND_CALL_APPLICATION :
                res=recv((BYTE *)cheader, 4);
                if (res!=SOCKET_ERROR && res==4)
                {
                    ack_flag = crate->CallApplication(cheader[0]);
                    ack(ack_flag);
                }
                break;
                //
            case CONTROL_COMMAND_GET_CRATES :
                memset(ControlBuffer, 0, CRATE_MAX*16);
                if (WaitForSingleObject(crate_list_access, INFINITE)==WAIT_OBJECT_0)
                {
                    for (int i=0, j=0; i<CRATE_MAX; i++)
                    {
                        if (crate_list[i]->GetState() == CRATE_ST_ONLINE)
                        {
                            if (crate_list[i]->sflags&CRATE_FLAG_BOOT_LOADER)
                                memset(ControlBuffer+j*NAME_SIZE, 'X', NAME_SIZE);
                            else memcpy(ControlBuffer+j*NAME_SIZE, crate_list[i]->csn, NAME_SIZE);
                            j++;
                        }
                    }
                    ReleaseMutex(crate_list_access);
                    ack_flag=true;
                }
                else ack_flag=false;
                ack(ack_flag);
                if (ack_flag) send(ControlBuffer, CRATE_MAX*16);
                break;
            case CONTROL_COMMAND_GET_MODULES :
                for (int i=0; i<MODULE_MAX; i++)
                    ((WORD*)ControlBuffer)[i]=crate->module[i].mid;
                ack(true);
                send(ControlBuffer, MODULE_MAX*sizeof(WORD));
                break;

                //    -        
                //      
                //  HIGH PRIORITY -   
            case CONTROL_COMMAND_SET_SERVER_PROCESS_PRIORITY:
            {
                ack(true);
                DWORD Process_Priority=0;
                res = recv((BYTE *)&Process_Priority, sizeof(Process_Priority));
                if (res!=SOCKET_ERROR && res==sizeof(Process_Priority))
                    {
                    SetPriorityClass(GetCurrentProcess(), Process_Priority);
                    ack(true);
                    }
                else  ack(false);
            }
            break;
            case CONTROL_COMMAND_GET_CRATE_RAW_DATA_SIZE:
            {
                TCrate::TModule *module=&crate->module[MODULE_MAX];
                __int64 NumDataAlreadyInBuffer = module->count_FIFO_recv-client->count_FIFO_recv;
                if(NumDataAlreadyInBuffer>MODULE_RECV_BUF_SIZE)
                { //  
                    NumDataAlreadyInBuffer-=MODULE_RECV_BUF_SIZE;
                    //   
                    client->buf_ptr_FIFO_recv = (client->buf_ptr_FIFO_recv+NumDataAlreadyInBuffer)%MODULE_RECV_BUF_SIZE;
                    client->count_FIFO_recv+=NumDataAlreadyInBuffer;
                    NumDataAlreadyInBuffer = MODULE_RECV_BUF_SIZE;
                }
                DWORD SendValue = NumDataAlreadyInBuffer;
                send((BYTE*)&SendValue,sizeof(SendValue));
            }
            break;
            case CONTROL_COMMAND_GET_CRATE_RAW_DATA:
            {
                TCrate::TModule *module=&crate->module[MODULE_MAX];
                DWORD rbuf[3];
                res = recv((BYTE *)rbuf, sizeof(rbuf));
                if (res!=SOCKET_ERROR && res==sizeof(rbuf))
                {
                    DWORD NumData = rbuf[0];
                    DWORD timeout = rbuf[1];
                    DWORD beginTime = GetTickCount();
                    DWORD tmark=((crate->start_mark_counter&0xFFFF)<<16)|
                                (crate->second_mark_counter&0xFFFF);
                    DWORD Databufptr = 0;
                    bool  FullRawData = rbuf[2];

                    if(tmark)
                    {
                        RawDataBuffer[Databufptr++]=SIGNAL_TSTAMP;
                        RawDataBuffer[Databufptr++]=tmark;
                    }

                    __int64 NumDataAlreadyInBuffer = module->count_FIFO_recv-client->count_FIFO_recv;
                    if(NumDataAlreadyInBuffer>MODULE_RECV_BUF_SIZE)
                    { //  

                        //   
                        client->buf_ptr_FIFO_recv = (client->buf_ptr_FIFO_recv+NumDataAlreadyInBuffer-NumData)%MODULE_RECV_BUF_SIZE;
                        client->count_FIFO_recv+= (NumDataAlreadyInBuffer-NumData);

                        if(!FullRawData)
                        {
                            RawDataBuffer[Databufptr++]=SIGNAL_RBUF_OVF;
                        }
                    }

                    DWORD NumDataReady=0;
                    while (NumDataReady<NumData&&(GetTickCount()-beginTime)<timeout)
                    {
                        // ,    
                        while ((module->count_FIFO_recv-client->count_FIFO_recv)<(NumData-NumDataReady)&&
                                ((GetTickCount()-beginTime)<timeout)&&
                                client->IsAlive)
                        {
                            Sleep(TIMEOUT_0/2);
                        }

                        NumDataAlreadyInBuffer = module->count_FIFO_recv-client->count_FIFO_recv;

                        DWORD SizeReady = std::min<DWORD>(NumDataAlreadyInBuffer, NumData-NumDataReady);
                        SizeReady = std::min<DWORD>(SizeReady, RC_SIZE-Databufptr);

                        bool LastTstamp=false;
                        for (DWORD i=0;i<SizeReady;i++)
                        {
                            DWORD Data =  module->recv_buf[client->buf_ptr_FIFO_recv++];
                            if (client->buf_ptr_FIFO_recv>=MODULE_RECV_BUF_SIZE)client->buf_ptr_FIFO_recv=0;
                            if (Data==SIGNAL_TSTAMP)LastTstamp=true;
                            else if (LastTstamp) LastTstamp=false;
                            else if ((Data&LTR010CMD)&&!FullRawData) continue; //    
                            else NumDataReady++;
                            RawDataBuffer[Databufptr++]= Data;
                        }

                        send((BYTE*)RawDataBuffer,Databufptr*sizeof(DWORD));
                        Databufptr=0;
                        client->count_FIFO_recv+=NumDataAlreadyInBuffer;
                    }
                }
                else  ack(false);
            }
            break;

            case CONTROL_COMMAND_GET_CRATE_TYPE:
            {
                ack(true);
                _CrateInfoStruct CrateInfo;
                CrateInfo.CrateType=crate->CrateType;
                CrateInfo.CrateConnectionType=crate->GetConnType();
                CrateInfo.CrateStatus=CrateStatusOnline;//crate->CrateStatus;
                send((BYTE *)&CrateInfo, sizeof(_CrateInfoStruct));
            }
            break;
            case CONTROL_COMMAND_START_ALL_CRATE_MODULES:
            {       /*
                BYTE ModuleNumber[MODULE_MAX];
                memset(ModuleNumber,0,sizeof(ModuleNumber));
                TCrate::TModule *module=&crate->module[MODULE_MAX];
                int CounterData=0;

                res = recv((BYTE *)ModuleNumber, sizeof(ModuleNumber));
                if (res!=SOCKET_ERROR && res==sizeof(ModuleNumber))
                {
                    for (int i = 0; i < MODULE_MAX; i++)
                    {
                        if(ModuleNumber[i]&&crate->module[i].ModulePresence&&
                        crate->module[i].mid!=0xFFFF&&crate->module[i].mid!=0)
                        {
                            DWORD  StartWord=0;
                            switch (crate->module[i].mid)
                            {
                                case 0x0B0B:
//                                StartWord=
                                break;
                            default:
                                ;
                            }
//                           module->send_buf[CounterData++]=
                        }
                    }
                    ack(true);
                }
                else ack(false);
                */
            }

            break;


            default:
                ack(false);
                break;
            }
        }
    }
    client->IsAlive=false;

    DWORD size=0,flag=0;
    if (!WSAGetOverlappedResult(client->socket, &wsaovcntrl, &size, FALSE, &flag))
    {
        CancelIo((HANDLE)client->socket);
    }

    if (client->flags&CC_RAW_DATA_FLAG)
    {
        crate->ReadRawData=false;
    }
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
__fastcall TReadClientThread::TReadClientThread(TClient *_client, bool CreateSuspended) : TThread(CreateSuspended)
{
    Priority=tpHigher;//tpNormal;
    FreeOnTerminate=false;
    client=_client;
    init_complete=CreateEvent(NULL, FALSE, FALSE, NULL);
}
//-----------------------------------------------------------------------------
__fastcall TReadClientThread::~TReadClientThread(void)
{
    CloseHandle(init_complete);
}
//-----------------------------------------------------------------------------

struct CLIENT_REQUEST
{
    WSABUF wsabuf;
    WSAOVERLAPPED wsaov;
};
//
void __fastcall TReadClientThread::Execute()
{
    WORD crate_channel=client->crate_channel;
    TCrate *crate  =client->crate;
    TCrate::TModule *module=&crate->module[(crate_channel-1)&0xF];
    //
    CLIENT_REQUEST rreq[CLIENT_RR_N];

    memset(rreq, 0, sizeof(rreq));
    for (int i=0; i<CLIENT_RR_N; i++)
    {
        rreq[i].wsabuf.buf=(BYTE*)&ReadBuffer[i][0];
        rreq[i].wsaov.hEvent=WSACreateEvent();
        WSASetEvent(rreq[i].wsaov.hEvent);
    }
    int index=0;

    client->buf_ptr_FIFO_recv=module->recv_buf_ptr;
    client->count_FIFO_recv=module->count_FIFO_recv;

    if (!crate->ThreadsRunning)
        client->IsAlive=false;

    //   
    SetEvent(init_complete);
    while (client->IsAlive&&module->ModulePresence)
    {
        while ((WSAWaitForMultipleEvents(1, &rreq[index].wsaov.hEvent, TRUE, TIMEOUT_2, FALSE)==WSA_WAIT_TIMEOUT)
                &&client->IsAlive);

        while (client->IsAlive)
        {
            //  ,    ,      waitforsingleobject

            while ((module->count_FIFO_recv==client->count_FIFO_recv)&&client->IsAlive)
            {
                Sleep(TIMEOUT_0/2);
            }

            DWORD sizeSend=0;
            DWORD *buf=(DWORD*)rreq[index].wsabuf.buf;
            if ((module->count_FIFO_recv-client->count_FIFO_recv)>MODULE_RECV_BUF_SIZE)
            {
                //    
                client->buf_ptr_FIFO_recv=module->recv_buf_ptr;
                client->count_FIFO_recv=module->count_FIFO_recv;

                logfile.AddMessage(Format("RCT.%0.4X RBUF_OVF", ARRAYOFCONST(((int)client->crate_channel))), crate->log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_READ);

                buf[sizeSend++]=SIGNAL_RBUF_OVF;
            }
            else
            {
                sizeSend=std::min<DWORD>((module->count_FIFO_recv-client->count_FIFO_recv),RC_SIZE);

                //     
                if ((client->buf_ptr_FIFO_recv+sizeSend)>=MODULE_RECV_BUF_SIZE)
                {
                    DWORD SizeSend1=MODULE_RECV_BUF_SIZE- client->buf_ptr_FIFO_recv;
                    memcpy(&buf[0], &module->recv_buf[client->buf_ptr_FIFO_recv], SizeSend1*sizeof(DWORD));

                    DWORD SizeSend2=sizeSend-SizeSend1;
                    memcpy(&buf[SizeSend1], module->recv_buf, SizeSend2*sizeof(DWORD));
                    client->buf_ptr_FIFO_recv=SizeSend2;
                }
                else
                {
                    memcpy(&buf[0], &module->recv_buf[client->buf_ptr_FIFO_recv], sizeSend*sizeof(DWORD));
                    client->buf_ptr_FIFO_recv+=sizeSend;
                }

                client->count_FIFO_recv+=sizeSend;
            }

            rreq[index].wsabuf.len=sizeSend*sizeof(DWORD);
            int res=WSASend(client->socket, &rreq[index].wsabuf, 1, &sizeSend, 0, &rreq[index].wsaov, NULL);
            if (res==SOCKET_ERROR)
            {
                if (WSAGetLastError()==WSA_IO_PENDING)
                {
                    //     
                    index=(index+1)%CLIENT_RR_N;
                    break;
                }
                else  client->IsAlive=false;
            }
            else if (res==0&&sizeSend==0)
            {
                client->IsAlive=false;
            };
            //    
        }
    }

    client->IsAlive=false;

    DWORD  sz=0;
    DWORD flag=0;
    if (!WSAGetOverlappedResult(client->socket, &rreq[index].wsaov, &sz, FALSE, &flag))
    {
        CancelIo((HANDLE)client->socket);
    }

    for (int i=0; i<CLIENT_RR_N; i++)
    {
        WSACloseEvent(rreq[i].wsaov.hEvent);
    }
    //
    logfile.AddMessage(Format("RCT.%0.4X EXIT ptr=%8d", ARRAYOFCONST(((int)client->crate_channel, (int)client->buf_ptr_FIFO_recv))), crate->log_flags, LOG_FLAG_DEBUG_LEVEL6|LOG_FLAG_CLIENT_READ);
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
__fastcall TWriteClientThread::TWriteClientThread(TClient *_client, bool CreateSuspended) : TThread(CreateSuspended)
{
    Priority=tpHigher;//tpNormal;
    FreeOnTerminate=false;
    client=_client;
    init_complete=CreateEvent(NULL, FALSE, FALSE, NULL);
}
//-----------------------------------------------------------------------------
__fastcall TWriteClientThread::~TWriteClientThread(void)
{
    CloseHandle(init_complete);
}
//-----------------------------------------------------------------------------
void __fastcall TWriteClientThread::Execute()
{
    DWORD SizeBytes=0;
    TCrate *crate =client->crate;
    WORD crate_channel=client->crate_channel;
    WORD crate_slot=(crate_channel-1)&15;
    TCrate::TModule * module=&crate->module[crate_slot];

    wsabufw.len =MODULE_SEND_BUF_SIZE*sizeof(DWORD);
    wsabufw.buf =(char *)WriteBuf;

    wsaovw.hEvent=WSACreateEvent();
    WSASetEvent(wsaovw.hEvent);

    if (!crate->ThreadsRunning)
        client->IsAlive=false;
    //   
    SetEvent(init_complete);

    while (client->IsAlive&&module->ModulePresence)
    {
        while (WSAWaitForMultipleEvents(1, &wsaovw.hEvent, TRUE, TIMEOUT_2, FALSE)==WSA_WAIT_TIMEOUT
                &&client->IsAlive);

        DWORD flag1=0;
        if (!WSAGetOverlappedResult(client->socket, &wsaovw, &SizeBytes, FALSE, &flag1))
        {
            client->IsAlive=false;
        }

        while (client->IsAlive)
        {
            // ,   recieve -   ,   
            int size=SizeBytes>>2; //   4,     4
            if (size)
            {
                while (client->IsAlive&&module->send_buf_cntr) Sleep(TIMEOUT_0/2);

                //  
                if (!(client->flags&CC_DEBUG_FLAG))
                {
                    //   
                    WORD CrateSlot = crate_slot<<8;
                    for (int i=0; i<size; i++) module->send_buf[i]=(WriteBuf[i]&0xFFFF80FF)|CrateSlot;
                }
                else memcpy(module->send_buf, WriteBuf, size*sizeof(DWORD));

                module->send_buf_cntr=size;
            }

            DWORD flag3=0;
            int res=WSARecv(client->socket, &wsabufw, 1, &SizeBytes, &flag3, &wsaovw, NULL);
            if (res==SOCKET_ERROR)
            {
                if (WSAGetLastError()==WSA_IO_PENDING)
                {
                    SizeBytes=0;
                    break;
                }
                else
                {
                    client->IsAlive=false;
                }
            }
            else if (res==0&&SizeBytes==0)
            {
                client->IsAlive=false;
            };
        }
    }

    client->IsAlive=false;

    DWORD flag=0;
    if (!WSAGetOverlappedResult(client->socket, &wsaovw, &SizeBytes, FALSE, &flag))
    {
        CancelIo((HANDLE)client->socket);
    }

    WSACloseEvent(wsaovw.hEvent);
    logfile.AddMessage(Format("WCT.%0.4X EXIT (total=%8d)", ARRAYOFCONST(((int)client->crate_channel, (int)0))), crate->log_flags, LOG_FLAG_DEBUG_LEVEL6|LOG_FLAG_CLIENT_WRITE);
}
//-----------------------------------------------------------------------------
//

