#ifndef LtrIniFileH
#define LtrIniFileH

#include <inifiles.hpp>

/*================================================================================================*/
class TCSLock
    {
private:
    CRITICAL_SECTION *pcs;
public:
    TCSLock(CRITICAL_SECTION &CriticalSection)
        { pcs = &CriticalSection; EnterCriticalSection(pcs); }
    ~TCSLock(void)
        { LeaveCriticalSection(pcs); }
    };

/*   TIniFile,  , :
 *  -         
 *       , ,
 *  ExtractFilePath(Application->ExeName) + "ltrservice.ini"
 */
class TLtrIniFile
    {
private:
    TIniFile *ini;
    CRITICAL_SECTION cs;
public:
    __fastcall TLtrIniFile(void);
    __fastcall ~TLtrIniFile(void);
    void __fastcall Open(AnsiString FileNameWithoutPath);
    void __fastcall Close(void);
    AnsiString __fastcall
        ReadString(AnsiString Section, AnsiString Ident, AnsiString Default, bool CreateMissing);
    int __fastcall
        ReadInteger(AnsiString Section, AnsiString Ident, int Default, bool CreateMissing);
    int __fastcall
        ReadIntegerHex(AnsiString Section, AnsiString Ident, int Default, bool CreateMissing);
    bool __fastcall
        ReadBool(AnsiString Section, AnsiString Ident, bool Default, bool CreateMissing);
    void __fastcall WriteString(AnsiString Section, AnsiString Ident, AnsiString Value);
    void __fastcall WriteInteger(AnsiString Section, AnsiString Ident, int Value);
    void __fastcall WriteIntegerHex(AnsiString Section, AnsiString Ident, int Value);
    void __fastcall WriteBool(AnsiString Section, AnsiString Ident, bool Value);
    void __fastcall DeleteKey(AnsiString Section, AnsiString Ident);
    void __fastcall ReadSection(AnsiString Section, TStrings *Strings);
    void __fastcall ClearSection(AnsiString Section);
    };
/*================================================================================================*/

#endif
