#include "LtrClient.h"
#include "LtrServiceClients.h"

void __fastcall AcknowledgeCommand(SOCKET socket, DWORD Ackq)
{   
	send(socket, (BYTE*)&Ackq, CONTROL_ACKNOWLEDGE_SIZE, 0);
}

//-----------------------------------------------------------------------------
__fastcall TLTRServiceClient::TLTRServiceClient(bool CreateSuspended) : TThread(CreateSuspended)
{
	Priority=tpNormal;
	FreeOnTerminate=false;
	server=INVALID_SOCKET;
	init_complete=CreateEvent(NULL, FALSE, FALSE, NULL);
}
//-----------------------------------------------------------------------------
__fastcall TLTRServiceClient::~TLTRServiceClient(void)
{
	CloseHandle(init_complete);
}
//-----------------------------------------------------------------------------
void __fastcall TLTRServiceClient::Execute()
{
    logfile.AddMessage("LTRServiceClient thread started.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);

	
		//     
		char str[128];
		gethostname(str, sizeof(str));
		logfile.AddMessage(Format("host_name=%s", ARRAYOFCONST((str))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
		//
		struct addrinfo *ainfo, *ai;
		getaddrinfo(str, NULL, NULL, &ainfo);
		ai=ainfo;
		while(ai!=NULL)
		{
			DWORD ip_addr=((sockaddr_in*)ai->ai_addr)->sin_addr.S_un.S_addr;
			logfile.AddMessage(Format("ip_addr=%d.%d.%d.%d", ARRAYOFCONST(((int)(ip_addr>>0)&0xFF, (int)(ip_addr>>8)&0xFF, (int)(ip_addr>>16)&0xFF, (int)(ip_addr>>24)&0xFF))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
			ai=ai->ai_next;
		}
		freeaddrinfo(ainfo);
		//  
		server=WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED);
		if(server!=INVALID_SOCKET)
		{
			sockaddr_in peer;
			peer.sin_family=AF_INET;
			peer.sin_port  =htons(11111);
			peer.sin_addr.S_un.S_addr=INADDR_ANY;
			if(!bind(server, (sockaddr*)&peer, sizeof(peer)))
			{
				if(!listen(server, 16))
				{
					//   
					SetEvent(init_complete);
					while(!Terminated)
					{
						SOCKET s=WSAAccept(server, NULL, NULL, NULL, NULL);
						if(s!=SOCKET_ERROR&&!Terminated)
						{   
							bool ack_flag=false;
							DWORD Module_Already_Opened = 0;
							// request[] = cmd[8] + csn[16] + cc[2] + tmark[4]
							BYTE request[CONTROL_COMMAND_SIZE+16+2+4];
							DWORD sz=recv(s, request, sizeof(request), 0);
							if(sz==sizeof(request) &&
								*(DWORD*)(request+0)==CONTROL_COMMAND_START &&
								*(DWORD*)(request+4)==CONTROL_COMMAND_INIT_CONNECTION)
							{
                            	WORD Client_flags = (*(WORD*)(request+CONTROL_COMMAND_SIZE+16))&0xFF00;
								WORD Crate_Channel = (*(WORD*)(request+CONTROL_COMMAND_SIZE+16))&0x00FF; //   

								if(WaitForSingleObject(client_list_access, INFINITE)==WAIT_OBJECT_0)
								{
									//   
									//      
                                    int client_index=CLIENT_MAX;
									for(int i=0; i<CLIENT_MAX; i++)
									{
										if(client_list[i]==NULL)
										{
											client_index=i;
										}
										else if(client_list[i]->socket==SOCKET_ERROR||
											!client_list[i]->IsAlive)
										{
											logfile.AddMessage(Format("Connection stopped for client  >> CSN=%.16s  CC=%0.4X", ARRAYOFCONST(((char*)client_list[i]->crate->csn, (int)client_list[i]->crate_channel))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
											delete client_list[i];
											client_list[i]=NULL;
											client_index=i;
										}
										else if (Crate_Channel!=CC_CONTROL&&
                                                    client_list[i]->crate_channel==Crate_Channel&&
        											!memcmp(request+CONTROL_COMMAND_SIZE, client_list[i]->crate->csn, 16))
										{ //         ,    
											Module_Already_Opened++;
										}
									}
									//   
									if(client_index<CLIENT_MAX)
									{
										if(WaitForSingleObject(crate_list_access, INFINITE)==WAIT_OBJECT_0)
										{
                                            int crate_index;
											for(crate_index=0; crate_index<CRATE_MAX; crate_index++)
											{
												if ((crate_list[crate_index]->GetState() == CRATE_ST_ONLINE) &&
													//         
													(request[CONTROL_COMMAND_SIZE]==0 || !memcmp(request+CONTROL_COMMAND_SIZE, crate_list[crate_index]->csn, 16)))
												{
                                                    if(Crate_Channel!=CC_CONTROL)
                                                    {
                                                        //     
                                                        if (crate_list[crate_index]->module[Crate_Channel-1].ModulePresence) break;
                                                    }
                                                    else break;
												}
											}

											if(crate_index<CRATE_MAX &&
                                                   ((!(crate_list[crate_index]->sflags&CRATE_FLAG_BOOT_LOADER))||Crate_Channel==CC_CONTROL))
											{
												TCrate *crate=crate_list[crate_index];
												//    
												memcpy(request+CONTROL_COMMAND_SIZE, crate->csn, 16);
												//    
												DWORD tmark=((crate->start_mark_counter&0xFFFF)<<16)|
													(crate->second_mark_counter&0xFFFF);
												*(DWORD*)(request+CONTROL_COMMAND_SIZE+16+2)=tmark;

                                                //          -  
                                                //   
                                                if (!Module_Already_Opened) AcknowledgeCommand(s, CONTROL_ACKNOWLEDGE_GOOD);
                                                else
                                                {   //   
                                                    AcknowledgeCommand(s, CONTROL_ACKNOWLEDGE_MODULE_IN_USE);
                                                    logfile.AddMessage(Format("Warning ! Module in slot %d already being opened and don't closed %d times !!!", ARRAYOFCONST(((int)Crate_Channel, (int)Module_Already_Opened))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
                                                }

                                                send(s, request, sizeof(request), 0)!=sizeof(request);

												client_list[client_index]=new TClient(s, crate_list[crate_index], Crate_Channel, Client_flags);
												logfile.AddMessage(Format("Connection started for client >> CSN=%.16s  CC=%0.4X", ARRAYOFCONST(((char*)(request+CONTROL_COMMAND_SIZE), (int)(*(WORD*)(request+CONTROL_COMMAND_SIZE+16))))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
												ack_flag=true;
											}
                                            else
                                            {
                                                logfile.AddMessage(Format("Connection refused for client >> CSN=%.16s  CC=%0.4X", ARRAYOFCONST(((char*)(request+CONTROL_COMMAND_SIZE), (int)(*(WORD*)(request+CONTROL_COMMAND_SIZE+16))))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
                                            }
											//
											ReleaseMutex(crate_list_access);
										} else logfile.AddMessage("Connection refused for client >> Can't access crate list.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
									} else logfile.AddMessage("Connection refused for client >> There's no empty resource for client.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
									//
									ReleaseMutex(client_list_access);
								} else logfile.AddMessage("Connection refused for client >> Can't access clien list.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
							} else logfile.AddMessage("Client request connection >> refused. Error in request format.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);

							if(!ack_flag)
							{
                                AcknowledgeCommand(s, CONTROL_ACKNOWLEDGE_BAD);
								shutdown(s,SD_BOTH);
								closesocket(s);
							}
						} else logfile.AddMessage(Format("accept() >> error(%d)", ARRAYOFCONST(((int)WSAGetLastError()))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
					}
				} else logfile.AddMessage(Format("listen() >> error(%d)", ARRAYOFCONST(((int)WSAGetLastError()))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
			} else logfile.AddMessage(Format("bind() >> error(%d)", ARRAYOFCONST(((int)WSAGetLastError()))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
			//
			closesocket(server);
		} else logfile.AddMessage(Format("socket() >> error(%d)", ARRAYOFCONST(((int)WSAGetLastError()))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);

	logfile.AddMessage("LTRServiceClient thread begin stopping.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);

	//   
	if(WaitForSingleObject(client_list_access, INFINITE)==WAIT_OBJECT_0)
	{    
		for(int i=0; i<CLIENT_MAX; i++)
		{
			if(client_list[i]!=NULL)
			{
				client_list[i]->IsAlive=false;
			};
		};

		for(int i=0; i<CLIENT_MAX; i++)
		{
			if(client_list[i]!=NULL)
			{
				logfile.AddMessage(Format("Connection stopped for client  >> CSN=%.16s  CC=%0.4X", ARRAYOFCONST(((char*)client_list[i]->crate->csn, (int)client_list[i]->crate_channel))), g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
				delete client_list[i];
				client_list[i]=NULL;
			};
		};
		ReleaseMutex(client_list_access);
	} else logfile.AddMessage("Can't access clien list.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
	logfile.AddMessage("LTRServiceClient thread stopped.", g_Config.log_flags, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_CLIENT_INIT);
	SetEvent(init_complete);
}
//----------------------------------------------------------------------------- 
