#ifndef LtrServiceCratesH
#define LtrServiceCratesH
#include "common.h"
#include "addrlist.h"

#define PING_IN_SERVICE 0

//---------------------------------------------------------------------------
class TLTRServiceCrate : public TThread
{
 private:
    SOCKET UDP_Socket;  //  ,  
    WSABUF UDP_WSA_Recv_Buf;
    BYTE   UDP_RecvBuf[16];
    WSAOVERLAPPED UDP_Recv_Over;

    void __fastcall StopServiceForDeadCrates(void);
    void ScanUSBCrates(void);
    void StartScanEthernetCrates(void);
    void ConnectCrateByIP(DWORD dwIP);
    void DisconnectCrateByIP(DWORD dwIP);
    void ConnectEthernetCratesByType(int IPListType);
    void DisconnectEthernetCratesByType(int IPListType);
    void ProceedNewEthernetCrate(void);
#if PING_IN_SERVICE
    void CheckForIdleCrates(void);
#endif
 protected:
    void __fastcall Execute();
 public:
    T_MessageQueue * MessageQueueIn;
    T_MessageQueue * MessageQueueDisplay;
    HANDLE init_complete;
    void __fastcall SuspendCrates();
    void __fastcall ResumeCrates();
    __fastcall TLTRServiceCrate(bool CreateSuspended);
    __fastcall ~TLTRServiceCrate(void);
};
//---------------------------------------------------------------------------
#endif
