﻿//$$---- Form CPP ----
//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "Unit1.h"
#include "DialogAddIP.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMAIN *FormMAIN;

/* Строковые константы для отображения в StringGridEthernetCrates */
#define STR_STAT_OFFLINE        "offline"
#define STR_STAT_CONNECTING     "connecting"
#define STR_STAT_ONLINE         "online"
#define STR_STAT_ERROR          "error"
#define STR_TYPE_STATIC         "static"
#define STR_TYPE_DYNAMIC        "dynamic"
#define STR_AUTO_ON             "a" /* Галочка в шрифте Marlett */
#define STR_AUTO_OFF            ""

/* Назначения колонок StringGridEthernetCrates */
enum
    {
    EGRID_COL_NUMBER = 0,
    EGRID_COL_IPAUTO,
    EGRID_COL_IPTYPE,
    EGRID_COL_IPADDR,
    EGRID_COL_STATUS,
    EGRID_COL_SERIAL
    };

/* Имена секций и ключей в INI-файле */
const char INI_SEC_CONFIG[]         = "LTR_SERVER_CONFIG";
const char INI_SEC_LTR_DEFAULT[]    = "LTR010_DEFAULT";
const char INI_SEC_ETHERNET_IP[]    = "LTR_ETHERNET_IP";
const char INI_KEY_PRIORITY[]       = "server_priority";
const char INI_KEY_MINIMIZE2TRAY[]  = "minimize_to_tray";
const char INI_KEY_STARTMINIMIZED[] = "start_minimized";
const char INI_KEY_AUTOCONNECT[]    = "autoconnect_dynamic";
const char INI_KEY_FPGA_TTF[]       = "fpga_ttf";
const char INI_KEY_LOG_FLAGS[]      = "log_flags";
const char INI_KEY_ACTIVE_TAB[]     = "active_tab";

//---------------------------------------------------------------------------
__fastcall TFormMAIN::TFormMAIN(TComponent* Owner): TForm(Owner)
    {
    log_list->Clear();
    Statistic->Clear();
    MenuCaption.Connect = PopupConnectCrate->Caption;
    MenuCaption.Disconnect = PopupDisconnectCrate->Caption;
    MenuCaption.Delete = PopupDeleteCrateIP->Caption;
    MenuCaption.AutoConnect = PopupAutoConnectIPToggle->Caption;
    StringGridEthernetCrates->RowCount = 2;
    StringGridEthernetCrates->Cols[EGRID_COL_NUMBER]->SetText("№");
    StringGridEthernetCrates->Cols[EGRID_COL_IPTYPE]->SetText("Тип");
    StringGridEthernetCrates->Cols[EGRID_COL_IPAUTO]->SetText("Авто");
    StringGridEthernetCrates->Cols[EGRID_COL_IPADDR]->SetText("IP");
    StringGridEthernetCrates->Cols[EGRID_COL_STATUS]->SetText("Статус");
    StringGridEthernetCrates->Cols[EGRID_COL_SERIAL]->SetText("Серийный №");
    StringGridEthernetCrates->Rows[1]->Clear();
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::StringGridEthernetCratesDrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
    {
    TStringGrid *Grid = static_cast<TStringGrid*>(Sender);
    AnsiString Value = Grid->Cells[ACol][ARow];
    RECT TextRect = static_cast<RECT>(Rect);
    unsigned int align = DT_LEFT;

    switch (ACol)
        {
        case EGRID_COL_NUMBER:
            align = DT_CENTER;
            break;
        case EGRID_COL_IPAUTO:
            align = DT_CENTER;
            if (ARow > 0)
                {
                Grid->Canvas->Font->Name = "Marlett";
                Grid->Canvas->Font->Height *= 2;
                }
            break;
        }
    Grid->Canvas->FillRect(Rect);
    InflateRect(&TextRect, -2, -2);
    DrawText(Grid->Canvas->Handle, Value.c_str(), Value.Length(), &TextRect,
        DT_SINGLELINE | DT_VCENTER | align);
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::Dispatch(void *_msg)
{
    TMessage *msg=(TMessage*)_msg;
    switch (msg->Msg)
    {
    case WM_DEVICECHANGE :
        if (ltrservicecrate!=NULL)
            ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_device_changed);
        break;
    case WM_SYSCOMMAND :
        switch (msg->WParam)
        {
        case SC_MINIMIZE :
            Application->Minimize();
            if (CheckBoxMinimizeToTray->Checked)
                ShowWindow(Application->Handle, SW_HIDE);
            break;
        }
        break;
    case WM_POWERBROADCAST :
        if (ltrservicecrate!=NULL)
        {
            switch (msg->WParam)
            {
            case PBT_APMSUSPEND:
            case PBT_APMQUERYSUSPEND:
                ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_suspend);
                break;

            case PBT_APMRESUMEAUTOMATIC:
            case PBT_APMRESUMECRITICAL:
            case PBT_APMRESUMESUSPEND:
                ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_resume_suspend);
                break;
            default:
                break;
                ;
            }
        }
        break;
    }
    TForm::Dispatch(_msg);
}

//---------------------------------------------------------------------------
__fastcall TUpdateInfoThread::TUpdateInfoThread(void * ThisParentInstance):TThread(false)
{
    ParentInstance = ThisParentInstance;
    memset(statistic_csn, 0, sizeof(statistic_csn));
    statistic_slot=0;
    statistic_reset=true;
}

__fastcall TUpdateInfoThread::~TUpdateInfoThread(void)
{

}

void __fastcall TUpdateInfoThread::Execute(void)
{
    TFormMAIN * MainForm = (TFormMAIN *)ParentInstance;
    DWORD ProcessID=0;
    GetWindowThreadProcessId(Application->Handle, &ProcessID);
    HANDLE hProcess = OpenProcess(PROCESS_ALL_ACCESS, false, ProcessID);
    T_Message CurrMessage;

    while (!Terminated)
        {
        if (MainForm->MessageQueueDisplay->PopMessage(&CurrMessage, 500))
            {
                // обновление дерева крейтов
            if (CurrMessage.dwMessage == LTR_DISP_crate_list_updated)
                {
                if (WaitForSingleObject(crate_list_access, 500)==WAIT_OBJECT_0)
                    {
                    int k=0, l=0;
                    MainForm->CrateTree->Items->BeginUpdate();
                    MainForm->CrateTree->Items->Clear();
                    for (int i=0; i<CRATE_MAX; i++)
                        {
                        if (crate_list[i]->GetState() != CRATE_ST_ONLINE)
                            continue;

                        TCrate *crate=crate_list[i];
                        TTreeNode *node;
                        if (crate->sflags&CRATE_FLAG_BOOT_LOADER)
                            {
                            node=MainForm->CrateTree->Items->Add(NULL, Format("CSN <%.16s> - boot loader", ARRAYOFCONST((crate->csn))));
                            }
                        else
                            {
                            if (crate->sflags&CRATE_FLAG_HW_ERROR)
                                {
                                node=MainForm->CrateTree->Items->Add(NULL, Format("CSN <%.16s> - state error", ARRAYOFCONST((crate->csn))));
                                }
                            else node=MainForm->CrateTree->Items->Add(NULL, Format("CSN <%.16s> - state ok", ARRAYOFCONST((crate->csn))));

                            for (int j=0; j<16; j++)
                                {
                                WORD mid=crate->module[j].mid;
                                AnsiString astr=Format("<slot%0.2d%s> - ", ARRAYOFCONST((j+1, (crate->baud_rate&(1<<j)) ? "+" : " ")));

                                if (mid==NULL)
                                    {
                                    astr+="empty";
                                    }
                                else if (mid==0xFFFF)
                                    {
                                    astr+="Initialization";
                                    }
                                else
                                    {
                                    if ((mid&0xFF)!=((mid>>8)&0xFF)) astr+="BAD Module Name";
                                    else astr+=Format("mid = %d ", ARRAYOFCONST(((int)mid&0xFF)));
                                    }
                                MainForm->CrateTree->Items->AddChild(node, astr);
                                }
                            }
                        node->Expand(true);

                        if (crate->sflags&CRATE_FLAG_HW_ERROR) k++;
                        l++;
                        } /* for i */
                    MainForm->CrateTree->Items->EndUpdate();
                    MainForm->TrayIcon1->IconIndex=(l ? (k ? 1 : 0) : 2);
                    ReleaseMutex(crate_list_access);
                    } /* if WaitForSingleObject */
                } /* if CurrMessage */
            else if (MainForm->ltrservicecrate
                 && (CurrMessage.dwMessage == LTR_DISP_ethernet_list_updated))
                {
                /* Заполняем Grid списком статических и динамических IP-крейтов */
                const int ListType[] = { IPLIST_STATIC, IPLIST_DYNAMIC };
                const char *const ListName[] = { STR_TYPE_STATIC, STR_TYPE_DYNAMIC };
                int num_rows = 0;
                for (int type = 0; type < sizeof(ListType) / sizeof(ListType[0]); type++)
                    {
                    TAddrList *IPList =
                        IPCrateList.ExportList(ListType[type]);
                    if (!IPList) continue;
                    TAddrListNode *addr = IPList->GetFirstNode();
                    while (addr)
                        {
                        num_rows++;
                        TStrings *Row = MainForm->StringGridEthernetCrates->Rows[num_rows];
                        AnsiString CrateStatus;
                        switch (addr->iStatus)
                            {
                            case IP_STATUS_OFFLINE:
                                CrateStatus = STR_STAT_OFFLINE;
                                break;
                            case IP_STATUS_CONNECTING:
                                CrateStatus = STR_STAT_CONNECTING;
                                break;
                            case IP_STATUS_ONLINE:
                                CrateStatus = STR_STAT_ONLINE;
                                break;
                            default:
                                CrateStatus = STR_STAT_ERROR;
                                break;
                            }
                        Row->BeginUpdate();
                        Row->Strings[EGRID_COL_NUMBER] = AnsiString(num_rows);
                        Row->Strings[EGRID_COL_IPTYPE] = ListName[type];
                        Row->Strings[EGRID_COL_IPAUTO] = (addr->bAutoConnect) ?
                            STR_AUTO_ON : STR_AUTO_OFF;
                        Row->Strings[EGRID_COL_IPADDR] = IPToStr(addr->dwIP);
                        Row->Strings[EGRID_COL_STATUS] = CrateStatus;
                        Row->Strings[EGRID_COL_SERIAL] = addr->szSerial;
                        Row->EndUpdate();
                        addr = addr->next;
                        }
                    delete IPList;
                    } /* for type */
                /* Если список пуст, добавить одну пустую строку, чтобы не испортить grid */
                if (num_rows == 0)
                    MainForm->StringGridEthernetCrates->Rows[++num_rows]->Clear();
                MainForm->StringGridEthernetCrates->RowCount = 1 + num_rows;
                }  /* if CurrMessage */
            } /* if PopMessage */

        if (WaitForSingleObject(crate_list_access, 500)==WAIT_OBJECT_0)
        {

            // выбор крейта для вывода статистики
            MainForm->Statistic->Lines->BeginUpdate();
            MainForm->Statistic->Clear();

            if (MainForm->CrateTree->Selected!=NULL)
            {
                if (WaitForSingleObject(client_list_access,500)==WAIT_OBJECT_0)
                {
                    int i, j;
                    TTreeNode *node=MainForm->CrateTree->Selected;
                    if (node->Level)
                    {
                        i=node->Text.AnsiPos("<");
                        j=node->Text.AnsiPos(">");
                        statistic_slot=node->Text.SubString(i+5, j-i-6).ToInt();
                        node=node->Parent;
                    }
                    else
                    {
                        statistic_slot=0;
                    }
                    i=node->Text.AnsiPos("<");
                    j=node->Text.AnsiPos(">");
                    if (strcmp(statistic_csn, node->Text.SubString(i+1, j-i-1).c_str()))
                    {
                        strcpy(statistic_csn, node->Text.SubString(i+1, j-i-1).c_str());
                        statistic_reset=true;
                    }

                    // статистика по выбранному крейту
                    for (int i=0; i<CRATE_MAX; i++)
                    {
                        TCrate *crate=crate_list[i];

                        if (crate==NULL||strncmp(crate->csn, statistic_csn, SERIAL_NUMBER_SIZE)) continue;

                        AnsiString CrateType = "";
                        AnsiString CrateConnectionInfo="";
                        switch (crate->CrateType)
                        {
                        case CrateType_LTR010:
                            CrateType = "LTR-U-8/LTR-U-16";
                            break;
                        case CrateType_LTR021:
                            CrateType = "LTR-U-1";
                            break;
                        case CrateType_LTR030:
                            CrateType = "LTR-E-8/LTR-E-16";
                            break;
                        case CrateType_LTR031:
                            CrateType = "LTR-E-2";
                            break;
                        default:
                            CrateType="UnknownCrate";
                            break;
                        }

                        switch (crate->GetConnType())
                        {
                        case CrateCon_Ethernet:
                            CrateConnectionInfo = "Ethernet, IP = " + AnsiString(crate->path);
                            break;
                        case CrateCon_USB:
                            CrateConnectionInfo = "USB";
                            break;
                        default:
                            CrateConnectionInfo = "неизвестный интерфейс";
                            break;
                        }
                        MainForm->Statistic->Lines->Add("------ Статистика по крейту "+CrateType+" ------");
                        MainForm->Statistic->Lines->Add(Format("Серийный номер крейта : %.16s", ARRAYOFCONST((statistic_csn))));
                        MainForm->Statistic->Lines->Add("Интерфейс: " + CrateConnectionInfo);
                        MainForm->Statistic->Lines->Add(Format("Подключен : %.2d:%0.2d:%0.2d %2d.%0.2d.%0.4d", ARRAYOFCONST((
                                                                   (int)crate->start_time.wHour, (int)crate->start_time.wMinute, (int)crate->start_time.wSecond,
                                                                   (int)crate->start_time.wDay,  (int)crate->start_time.wMonth,  (int)crate->start_time.wYear))));
                        int a=crate->total_count_recv/1000000000l;
                        int b=crate->total_count_recv%1000000000l;
                        if (a) MainForm->Statistic->Lines->Add(Format("Общее число принятых слов   : %d%0.9d", ARRAYOFCONST((a, b))));
                        else  MainForm->Statistic->Lines->Add(Format("Общее число принятых слов   : %d", ARRAYOFCONST((b))));
                        int c=crate->total_count_send/1000000000l;
                        int d=crate->total_count_send%1000000000l;
                        if (c) MainForm->Statistic->Lines->Add(Format("Общее число переданных слов : %d%0.9d", ARRAYOFCONST((c, d))));
                        else  MainForm->Statistic->Lines->Add(Format("Общее число переданных слов : %d", ARRAYOFCONST((d))));
                        if (!statistic_reset)
                        {
                            DWORD tick_count=GetTickCount()-statistic_tick_count;
                            double current_speed_recv=1000.0*(crate->total_count_recv-statistic_count_recv)/(tick_count ? tick_count : 1);
                            double current_speed_send=1000.0*(crate->total_count_send-statistic_count_send)/(tick_count ? tick_count : 1);
                            MainForm->Statistic->Lines->Add(Format("Скорость приема данных      : %.1f", ARRAYOFCONST((current_speed_recv))));
                            MainForm->Statistic->Lines->Add(Format("Скорость передачи данных    : %.1f", ARRAYOFCONST((current_speed_send))));
                        }
                        else statistic_reset=false;
                        statistic_count_recv=crate->total_count_recv;
                        statistic_count_send=crate->total_count_send;
                        //
                        MainForm->Statistic->Lines->Add(Format("Принято меток <СТАРТ>       : %d", ARRAYOFCONST(((int)crate->start_mark_counter))));
                        MainForm->Statistic->Lines->Add(Format("Принято меток <СЕКУНДА>     : %d", ARRAYOFCONST(((int)crate->second_mark_counter))));
                        if (statistic_slot)
                        {
                            MainForm->Statistic->Lines->Add("");
                            WORD statistic_mid=crate->module[statistic_slot-1].mid;
                            MainForm->Statistic->Lines->Add(Format("----- Статистика по слоту %0.2d -----", ARRAYOFCONST((statistic_slot))));
                            AnsiString astr="Состояние  : ";
                            if (!statistic_mid)
                            {
                                astr+="Модуль отсутствует.";
                                MainForm->Statistic->Lines->Add(astr);
                            }
                            else if (statistic_mid==0xFFFF || (statistic_mid&0xFF)!=((statistic_mid>>8)&0xFF))
                            {
                                astr+="Модуль идентифицируется.";
                                MainForm->Statistic->Lines->Add(astr);
                            }
                            else
                            {
                                astr+=Format("Установлен модуль LTR%d ", ARRAYOFCONST(((int)statistic_mid&0xFF)));
                                MainForm->Statistic->Lines->Add(astr);

                                MainForm->Statistic->Lines->Add(Format("Число принятых слов   : %0.0f", ARRAYOFCONST(((double)crate->module[statistic_slot-1].count_recv))));
                                MainForm->Statistic->Lines->Add(Format("Число переданных слов : %0.0f", ARRAYOFCONST(((double)crate->module[statistic_slot-1].count_send))));

                                MainForm->Statistic->Lines->Add("");
                                __int64 NumDataClient=0;
                                int ClientNumber=0;
                                for (int i1=0;i1<CLIENT_MAX;i1++)
                                {
                                    if ( client_list[i1]!=NULL&&
                                            client_list[i1]->crate==crate&&
                                            client_list[i1]->crate_channel==statistic_slot&&
                                            client_list[i1]->IsAlive)
                                    {
                                        NumDataClient= std::max(client_list[i1]->count_FIFO_recv,NumDataClient);
                                        ClientNumber++;
                                    }
                                }

                                double NumData=crate->module[statistic_slot-1].count_FIFO_recv-NumDataClient;
                                double Percent =0;
                                if (NumData>0&&ClientNumber)
                                {
                                    Percent =std::min(NumData*100.0/MODULE_RECV_BUF_SIZE, 100.0);
                                }
                                MainForm->Statistic->Lines->Add(Format("Заполнение буфера в сервере : %0.2f", ARRAYOFCONST(((double)Percent)))+" %");

                                MainForm->Statistic->Lines->Add(Format("Подключенных клиентов : %d", ARRAYOFCONST((ClientNumber))));

                                if (statistic_mid==0x2222)
                                {
                                    MainForm->Statistic->Lines->Add("");
                                    MainForm->Statistic->Lines->Add(Format("Hardware FIFO size : %0.6X", ARRAYOFCONST(((int)crate->module[statistic_slot-1].fifo_size))));
                                }
                            }
                        }
                        else
                        {
                            int ClientNumber=0;
                            for (int i1=0;i1<CLIENT_MAX;i1++)
                            {
                                if ( client_list[i1]!=NULL&&
                                        client_list[i1]->crate==crate&&
                                        client_list[i1]->IsAlive)
                                {
                                    ClientNumber++;
                                }
                            }

                            MainForm->Statistic->Lines->Add("");
                            MainForm->Statistic->Lines->Add(Format("Подключенных клиентов : %d", ARRAYOFCONST((ClientNumber))));
                        }

                        break;
                    }
                    statistic_tick_count=GetTickCount();
                    ReleaseMutex(client_list_access);
                }
            }
            MainForm->Statistic->Lines->EndUpdate();
            ReleaseMutex(crate_list_access);

            // вывод сообщений в лог
            int lines_count_new=logfile.GetCount();
            if (lines_count_new)
            {
                MainForm->log_list->Lines->BeginUpdate();
                int lines_count=MainForm->log_list->Lines->Count;
                int lines_count_delete=lines_count+lines_count_new-SCREEN_LOG_SIZE;
                while (lines_count-- && lines_count_delete-->0) MainForm->log_list->Lines->Delete(0);
                while (lines_count_new--) MainForm->log_list->Lines->Add(logfile.GetMessage());
                MainForm->log_list->Lines->EndUpdate();
            }

            bool prio_ishigh = (GetPriorityClass(hProcess) == HIGH_PRIORITY_CLASS);
            MainForm->PopupServerPriorityHigh->Checked = prio_ishigh;
            MainForm->PopupServerPriorityNormal->Checked = !prio_ishigh;
        }
    }

    CloseHandle(hProcess);
}
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::FormCreate(TObject *Sender)
{
    PageControl1Resize(PageControl1);

    crate_list_access =CreateMutex(NULL, FALSE, NULL);
    client_list_access=CreateMutex(NULL, FALSE, NULL);

    /*
    ZeroMemory(client_list, sizeof(client_list));
    ZeroMemory(crate_list, sizeof(crate_list));
    */

    g_INI.Open(LTRINIFILENAME);

    /* Загрузка конфигурации из INI-файла */
    int active_tab =
        g_INI.ReadInteger(INI_SEC_CONFIG, INI_KEY_ACTIVE_TAB, 0, false);
    if ((active_tab >= 0) && (active_tab < PageControl1->PageCount))
        PageControl1->ActivePageIndex = active_tab;

    g_Config.ServerPriority =
        g_INI.ReadInteger(INI_SEC_CONFIG, INI_KEY_PRIORITY, NORMAL_PRIORITY_CLASS, true);
    g_Config.MinimizeToTray =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_MINIMIZE2TRAY, true, true);
    g_Config.StartMinimized =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_STARTMINIMIZED, false, true);
    g_Config.AutoConnectDynamic =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_AUTOCONNECT, true, true);
    g_Config.default_ttf =
        g_INI.ReadString(INI_SEC_LTR_DEFAULT, INI_KEY_FPGA_TTF, "ltr010.ttf", true);
    g_Config.log_flags =
        g_INI.ReadIntegerHex(INI_SEC_LTR_DEFAULT, INI_KEY_LOG_FLAGS, 0x3FF, true);

    /* Загрузка сохраненных статических IP (IPaddr = auto|manual) */
    IPCrateList.Clear();
    if (TStrings* KeyList = new TStringList)
        {
        AnsiString mode;
        g_INI.ReadSection(INI_SEC_ETHERNET_IP, KeyList);
        for (int i = 0; i < KeyList->Count; i++)
            {
            mode = g_INI.ReadString(INI_SEC_ETHERNET_IP, KeyList->Strings[i], "", false);
            IPCrateList.AddUnique(IPLIST_STATIC, StrToIP(KeyList->Strings[i]),
                (mode.LowerCase() == "auto"));
            }
        delete KeyList;
        }

    /* Инициализация меню из g_Config */
    bool prio_ishigh = (g_Config.ServerPriority == HIGH_PRIORITY_CLASS);
    PopupServerPriorityHigh->Checked = prio_ishigh;
    PopupServerPriorityNormal->Checked = !prio_ishigh;

    CheckBoxMinimizeToTray->Checked = g_Config.MinimizeToTray;
    CheckBoxStartMinimized->Checked = g_Config.StartMinimized;
    CheckBoxAutoConnectDynamic->Checked = g_Config.AutoConnectDynamic;

    if (g_Config.StartMinimized)
        {
        if (g_Config.MinimizeToTray)
            {
            ShowWindow(Application->Handle, SW_HIDE);
            Application->ShowMainForm = false;
            }
        else
            {
            Application->Minimize();
            }
        }

    logfile.Open();

    MessageQueueDisplay = new T_MessageQueue(100,100);
    // version info
    DWORD n=GetFileVersionInfoSize(Application->ExeName.c_str(), NULL);
    if (n)
    {
        AnsiString info[3]={"FileDescription", "FileVersion", "CompanyName"};
        char *buf=new char[n];
        GetFileVersionInfo(Application->ExeName.c_str(), 0, n, buf);
        for (int i=0; i<3; i++)
        {
            AnsiString astr="\\StringFileInfo\\041904E3\\"+info[i];
            void *val;
            UINT len;
            if (VerQueryValue(buf, astr.c_str(), &val, &len)) info[i]=(char*)val;
        }
        delete[] buf;
        //
        logfile.AddMessage(info[0]+" v"+info[1]+" ("+info[2]+")", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);
        Caption=info[0]+" v"+info[1];
    }

    TrayIcon1->IconIndex=0;

    WSADATA wsaData;
    if (!WSAStartup(MAKEWORD( 2, 2 ), &wsaData))
    {
        if (LOBYTE(wsaData.wVersion) != 2 ||
                HIBYTE( wsaData.wVersion ) != 2 )
        {
            // Tell the user that we could not find a usable
            // WinSock DLL.                                  */
            WSACleanup( );
            logfile.AddMessage("Invalid version of winsock dll, required 2.2", LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_SCREEN|LOG_FLAG_FILE, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_SCREEN|LOG_FLAG_FILE);
            Close();
            return;
        }
    }
    else
    {
        logfile.AddMessage(Format("WSAStartup() >> error(%d)", ARRAYOFCONST(((int)WSAGetLastError()))), LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_SCREEN|LOG_FLAG_FILE, LOG_FLAG_DEBUG_LEVEL1|LOG_FLAG_SCREEN|LOG_FLAG_FILE);
    }

    //
    bool init_complete=false;
    ltrservicecrate=new TLTRServiceCrate(true);
    if (ltrservicecrate!=NULL)
    {
        ltrservicecrate->MessageQueueDisplay = MessageQueueDisplay;
        ltrservicecrate->Resume();
        if (WaitForSingleObject(ltrservicecrate->init_complete, 5000)==WAIT_OBJECT_0)
        {
            ltrserviceclient=new TLTRServiceClient(true);
            //ltrserviceclient->MessageQueueDisplay = MessageQueueDisplay;
            ltrserviceclient->Resume();
            if (ltrserviceclient!=NULL)
            {
                if (WaitForSingleObject(ltrserviceclient->init_complete, INFINITE)==WAIT_OBJECT_0)
                {
                    UpdateInformationThread = new TUpdateInfoThread(this);
                    init_complete=true;
                }
                else logfile.AddMessage("Can't init LTRServiceClient thread.", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);
            }
            else logfile.AddMessage("Can't create LTRServiceListen thread", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);
        }
        else logfile.AddMessage("Can't init LTRServiceCrate thread.", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);
    }
    else logfile.AddMessage("Can't create LTRServiceCrate thread.", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);
    //
    if (!init_complete) Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormMAIN::FormClose(TObject *Sender, TCloseAction &Action)
{
    logfile.AddMessage("Begin Closing MainForm ...", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);

    if (UpdateInformationThread!=NULL)
    {
        UpdateInformationThread->Terminate();
        UpdateInformationThread->WaitFor();
    }

    if (ltrserviceclient!=NULL)
    {
        ltrserviceclient->Terminate();

        if (ltrserviceclient->server!=SOCKET_ERROR)
        {
            shutdown(ltrserviceclient->server, SD_BOTH);
            closesocket(ltrserviceclient->server);
            ltrserviceclient->server=SOCKET_ERROR;
        }

        ltrserviceclient->WaitFor();
        delete ltrserviceclient;
        ltrserviceclient=NULL;
    }

    if (ltrservicecrate!=NULL)
    {
        ltrservicecrate->Terminate();
        ltrservicecrate->WaitFor();
        delete ltrservicecrate;
        ltrservicecrate=NULL;
    }

    if (MessageQueueDisplay!=NULL)
    {
        delete MessageQueueDisplay;
        MessageQueueDisplay = NULL;
    }

    CloseHandle(crate_list_access);
    CloseHandle(client_list_access);
#if false
    /* Сохраняем список статических крейтов и конфигурацию в INI */
    /* ЭТОТ КОД СЛОМАН И НЕ НУЖЕН, ОТ МЕШАЕТ РЕДАКТИРОВАТЬ INI ПРИ ЗАПУЩЕННОМ СЕРВЕРЕ */
    /* СЕЙЧАС СДЕЛАНО, ЧТО АДРЕСА СОХРАНЯЮТСЯ ПО ОДНОМУ ПРЯМО ПРИ РЕДАКТИРОВАНИИ GRID'А */
    /*
    TAddrList *IPList = IPCrateList.ExportList(IPLIST_STATIC);
    if (IPList)
        {
        g_INI.ClearSection(INI_SEC_ETHERNET_IP);
        TAddrListNode *addr = IPList->GetFirstNode();
        while (addr)
            {
            g_INI.WriteString(INI_SEC_ETHERNET_IP, AnsiString(addr->szIP),
                (addr->bAutoConnect) ? "auto" : "manual");
            addr = addr->next;
            }
        delete IPList;
        }
    */
#endif

    g_INI.WriteInteger(INI_SEC_CONFIG, INI_KEY_ACTIVE_TAB, PageControl1->ActivePageIndex);

    g_INI.Close();
    WSACleanup();
}
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::TrayIcon1Click(TObject *Sender)
{
    Application->Restore();
    Application->MainForm->Visible = true;
    Application->ShowMainForm = true;
    ShowWindow(Application->Handle, SW_RESTORE);
    SetForegroundWindow(Application->Handle);
}
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupQuitClick(TObject *Sender)
{
    FormMAIN->Close();
}
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupRestartServerClick(TObject *Sender)
{
    logfile.AddMessage("LTRSERVER resetting, please wait ...", LOG_FLAG_SCREEN_FILE, LOG_FLAG_SCREEN_FILE);
    TCloseAction xx ;
    FormClose(FormMAIN, xx);
    FormCreate(FormMAIN);

}
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupServerPriorityHighClick(TObject *Sender)
    {
    g_Config.ServerPriority = HIGH_PRIORITY_CLASS;
    g_INI.WriteInteger(INI_SEC_CONFIG, INI_KEY_PRIORITY, g_Config.ServerPriority);
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_server_priority_changed);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupServerPriorityNormalClick(TObject *Sender)
    {
    g_Config.ServerPriority = NORMAL_PRIORITY_CLASS;
    g_INI.WriteInteger(INI_SEC_CONFIG, INI_KEY_PRIORITY, g_Config.ServerPriority);
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_server_priority_changed);
    }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::FormContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled)
    {
    TPoint PopupPos;
    TGridCoord cell;
    bool cell_found = false;
    TStringGrid *Grid = StringGridEthernetCrates;

    PopupDeleteCrateIP->Visible = false;
    PopupAddCrateIP->Visible = false;
    PopupAutoConnectIPToggle->Visible = false;
    PopupClearLog->Visible = false;
    PopupConnectCrate->Visible = false;
    PopupDisconnectCrate->Visible = false;
    PopupConnectAllIP->Visible = false;
    PopupDisconnectAllIP->Visible = false;

    if ((MousePos.x >= 0) && (MousePos.y >= 0))
        { /* Popup вызван мышью, MousePos = координаты клика относительно формы */
        PopupPos = ClientToScreen(MousePos); /* меню рисуем на позиции клика */
        HWND hClickWnd = WindowFromPoint(PopupPos); /* хендл кликнутого окна */
        if (hClickWnd == Grid->Handle)
            { /* Клик в таблице IPшников */
            PopupAddCrateIP->Visible =  true; /* Включаем пункт "добавить" */
            PopupConnectAllIP->Visible =  true; /* Включаем пункт "вкл все" */
            PopupDisconnectAllIP->Visible =  true; /* Включаем пункт "откл все" */
            TPoint GridPos = Grid->ScreenToClient(PopupPos);
            cell = Grid->MouseCoord(GridPos.x, GridPos.y); /* преобразуем пикселы в адрес ячейки */
            if ((cell.X >= Grid->FixedCols) && (cell.Y >= Grid->FixedRows))
                cell_found = true;
            }
        else if (hClickWnd == log_list->Handle)
            { /* Клик в окне журнала */
            PopupClearLog -> Visible = true; /* Включаем пункт "очистить" */
            }
        }
    else
        { /* Popup вызван клавиатурой ([Menu] или [Shift-F10]) */
        if (Grid->Focused())
            { /* Клавиатурный popup на таблице IPшников */
            PopupAddCrateIP->Visible =  true; /* Включаем пункт "добавить" */
            PopupConnectAllIP->Visible =  true; /* Включаем пункт "вкл все" */
            PopupDisconnectAllIP->Visible =  true; /* Включаем пункт "откл все" */
            cell.X = Grid->Col; /* Для клавиатурного popup'а привязка */
            cell.Y = Grid->Row; /* берется к ячейке, имеющей фокус */
            if ((cell.X >= Grid->FixedCols) && (cell.Y >= Grid->FixedRows))
                cell_found = true;
            TRect rect = Grid->CellRect(cell.X, cell.Y);
            /* меню рисуем в верхнем левом углу активной ячейки */
            PopupPos = Grid->ClientToScreen(TPoint(rect.left, rect.top));
            }
        else if (log_list->Focused())
            { /* Клавиатурный popup для окна журнала */
            PopupPos = log_list->ClientToScreen(TPoint(0, 0)); /* меню рисуем в верхнем левом углу */
            PopupClearLog -> Visible = true; /* Включаем пункт "очистить" */
            }
        else
            {
            /* Клавиатурный popup в прочих частях формы */
            PopupPos = ClientToScreen(TPoint(0, 0)); /* меню рисуем в верхнем левом углу формы */
            }
        }

    if (cell_found)
        { /* Вызов контекстного меню ассоциирован с определенной ячейкой таблицы.
             Координаты ячейки сохранены в переменной cell. */
        AnsiString IPString = Grid->Cells[EGRID_COL_IPADDR][cell.Y];
        DWORD IP = StrToIP(IPString);
        bool is_static = (Grid->Cells[EGRID_COL_IPTYPE][cell.Y] != STR_TYPE_DYNAMIC);
        AnsiString status = Grid->Cells[EGRID_COL_STATUS][cell.Y];
        if (status == STR_STAT_OFFLINE)
            { /* OFFLINE => можно подключить или (если статический IP) удалить */
            PopupConnectCrate->Caption =
                AnsiReplaceStr(MenuCaption.Connect, "#IP#", IPString);
            PopupConnectCrate->Tag = IP;
            PopupConnectCrate->Visible = true;
            /* Если IP статический, его можно удалять */
            PopupDeleteCrateIP->Caption =
                AnsiReplaceStr(MenuCaption.Delete, "#IP#", IPString);
            PopupDeleteCrateIP->Tag = IP;
            PopupDeleteCrateIP->Visible = is_static;
            }
        else if ((status == STR_STAT_ONLINE)
              || (status == STR_STAT_CONNECTING))
            { /* ONLINE, CONNECTING => можно отключить. Удалить нельзя. */
            PopupDisconnectCrate->Caption =
                AnsiReplaceStr(MenuCaption.Disconnect, "#IP#", IPString);
            PopupDisconnectCrate->Tag = IP;
            PopupDisconnectCrate->Visible = true;
            }
        /* Для статического IP также включаем toggle autoconnect */
        if (is_static)
            {
            PopupAutoConnectIPToggle->Checked =
                (Grid->Cells[EGRID_COL_IPAUTO][cell.Y] == STR_AUTO_ON);
            PopupAutoConnectIPToggle->Caption =
                AnsiReplaceStr(MenuCaption.AutoConnect, "#IP#", IPString);
            PopupAutoConnectIPToggle->Tag = IP;
            PopupAutoConnectIPToggle->Visible = true;
            }
        }

    PopupMenu1->Popup(PopupPos.x, PopupPos.y);
    Handled = true;
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::TrayIcon1MouseDown(TObject *Sender, TMouseButton Button,
      TShiftState Shift, int X, int Y)
    {
    if (Button == mbRight)
        {
        PopupDeleteCrateIP->Visible = false;
        PopupAddCrateIP->Visible = false;
        PopupAutoConnectIPToggle->Visible = false;
        PopupClearLog->Visible = false;
        PopupConnectCrate->Visible = false;
        PopupDisconnectCrate->Visible = false;
        PopupConnectAllIP->Visible = false;
        PopupDisconnectAllIP->Visible = false;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupAddCrateIPClick(TObject *Sender)
    {
    if (!IsPositiveResult(FormAddIPDialog->ShowModal()))
        return;
    DWORD ip = FormAddIPDialog->IP_Addr;
    bool connect_now = FormAddIPDialog->CheckBoxConnectNow->Checked;
    bool autoconnect = FormAddIPDialog->CheckBoxAutoConnect->Checked;

    if (IPCrateList.AddUnique(IPLIST_STATIC, ip, autoconnect))
        {
        MessageQueueDisplay->PostMessage(LTR_DISP_ethernet_list_updated);
        g_INI.WriteString(INI_SEC_ETHERNET_IP, IPToStr(ip), (autoconnect) ? "auto" : "manual");
        if (connect_now && ltrservicecrate)
            ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, ip);
        }
    else
        {
        Application->MessageBox("Адрес неверен или уже есть в списке", "Ошибка",
            MB_OK | MB_ICONERROR);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDeleteCrateIPClick(TObject *Sender)
    {
    DWORD ip = static_cast<TMenuItem*>(Sender)->Tag;
    if ((ip == INADDR_NONE) && (ip == INADDR_ANY))
        return;
    if (Application->MessageBox(("Удалить из списка адрес " + IPToStr(ip) + " ?").c_str(),
        "Вы уверены?", MB_YESNO | MB_ICONQUESTION) == IDYES)
        {
        if (IPCrateList.Delete(IPLIST_STATIC, ip))
            {
            MessageQueueDisplay->PostMessage(LTR_DISP_ethernet_list_updated);
            g_INI.DeleteKey(INI_SEC_ETHERNET_IP, IPToStr(ip));
            }
        else
            {
            Application->MessageBox("Адрес не найден в списке", "Ошибка",
               MB_OK | MB_ICONERROR);
            }
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupClearLogClick(TObject *Sender)
    {
    log_list->Clear();
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupConnectCrateClick(TObject *Sender)
    {
    DWORD ip = static_cast<TMenuItem*>(Sender)->Tag;
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, ip);

    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDisconnectCrateClick(TObject *Sender)
    {
    DWORD ip = static_cast<TMenuItem*>(Sender)->Tag;
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_crate, ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupConnectAllIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_autoconnect_ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDisconnectAllIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_all_ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupRescanIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_rescan_ethernet_crates);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridEthernetCratesDblClick(TObject *Sender)
    {
    TStringGrid *Grid = StringGridEthernetCrates;
    AnsiString IPString = Grid->Cells[EGRID_COL_IPADDR][Grid->Row];
    DWORD ip = StrToIP(IPString);
    if ((Grid->Row < Grid->FixedRows) || !ip)
        return;
    switch (Grid->Col)
        {
        case EGRID_COL_IPAUTO:
            /* Doubleclick на колонке "Авто": вкл/выкл autoconnect */
            if (Grid->Cells[EGRID_COL_IPTYPE][Grid->Row] != STR_TYPE_DYNAMIC)
                { /* только для статических крейтов */
                bool NewAuto = (Grid->Cells[EGRID_COL_IPAUTO][Grid->Row] != STR_AUTO_ON);
                if (IPCrateList.SetAutoConnect(ip, NewAuto))
                    {
                    g_INI.WriteString(INI_SEC_ETHERNET_IP, IPString, (NewAuto) ? "auto" : "manual");
                    MessageQueueDisplay->PostMessage(LTR_DISP_ethernet_list_updated);
                    }
                }
            break;
        case EGRID_COL_STATUS:
            /* Doubleclick на колонке "Статус": подключить/отключить */
            if (ltrservicecrate)
                {
                AnsiString status = Grid->Cells[EGRID_COL_STATUS][Grid->Row];
                if (status == STR_STAT_OFFLINE)
                    {
                    ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, ip);
                    }
                else if ((status == STR_STAT_ONLINE)
                      || (status == STR_STAT_CONNECTING))
                    {
                    ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_crate, ip);
                    }
                }
            break;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupAutoConnectIPToggleClick(TObject *Sender)
    {
    DWORD ip = PopupDeleteCrateIP->Tag;
    bool NewAuto = static_cast<TMenuItem*>(Sender)->Checked;
    if (IPCrateList.SetAutoConnect(ip, NewAuto))
        {
        g_INI.WriteString(INI_SEC_ETHERNET_IP, IPToStr(ip), (NewAuto) ? "auto" : "manual");
        MessageQueueDisplay->PostMessage(LTR_DISP_ethernet_list_updated);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PageControl1Resize(TObject *Sender)
    {
    const int CW[] = {30, 30, 50, 110, 60};
    GroupBoxEthernetSettings->Width = PageControl1->Width - 190;
    /* Колонки грида из расчета (30, 30, 60, 110, 60, *) при ширине 438 */
    int w = StringGridEthernetCrates->Width;
    int glw = StringGridEthernetCrates->GridLineWidth;
    int sum = 4;
    double K = w / 438.0;
    for (int i = 0; i < sizeof(CW)/sizeof(CW[0]); i++)
        {
        int cw = K * CW[i];
        StringGridEthernetCrates->ColWidths[i] = cw;
        sum += (cw + glw);
        }
    StringGridEthernetCrates->ColWidths[sizeof(CW)/sizeof(CW[0])] = w - sum;
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::CheckBoxAutoConnectDynamicClick(TObject *Sender)
    {
    g_Config.AutoConnectDynamic = static_cast<TCheckBox*>(Sender)->Checked;
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_AUTOCONNECT, g_Config.AutoConnectDynamic);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::CheckBoxStartMinimizedClick(TObject *Sender)
    {
    g_Config.StartMinimized = static_cast<TCheckBox*>(Sender)->Checked;
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_STARTMINIMIZED, g_Config.StartMinimized);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::CheckBoxMinimizeToTrayClick(TObject *Sender)
    {
    g_Config.MinimizeToTray = static_cast<TCheckBox*>(Sender)->Checked;
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_MINIMIZE2TRAY, g_Config.MinimizeToTray);
    }
//---------------------------------------------------------------------------

