//$$---- Form HDR ----
//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <ToolWin.hpp>
#include <DBGrids.hpp>
#include <DBCtrls.hpp>
#include <DB.hpp>
#include <DBClient.hpp>
#include <Mask.hpp>
#include <DBTables.hpp>
//---------------------------------------------------------------------------
#include "LtrCrate.h"
#include "LtrServiceCrates.h"
#include "LtrClient.h"
#include "ltrServiceClients.h"
#include "MessageQueue.h"
//---------------------------------------------------------------------------
class TUpdateInfoThread : public TThread
{
 private:
    void * ParentInstance;
    bool statistic_reset;
    char statistic_csn[SERIAL_NUMBER_SIZE+1];
    int statistic_slot;
    int statistic_tick_count;
    __int64 statistic_count_recv;
    __int64 statistic_count_send;

 protected:
    void __fastcall Execute(void);
 public:
    __fastcall TUpdateInfoThread(void * ParentInstance);
    __fastcall ~TUpdateInfoThread(void);
};



//----------------------------------------------------------------
class TFormMAIN : public TForm
{
__published:    // IDE-managed Components
    TPageControl *PageControl1;
    TTabSheet *TabSheetCrateList;
    TTabSheet *TabSheetConfig;
    TImageList *ImageList1;
    TTrayIcon *TrayIcon1;
    TPopupMenu *PopupMenu1;
    TMenuItem *PopupQuit;
    TMenuItem *PopupRestartServer;
    TMenuItem *PopupServerPriority;
    TMenuItem *PopupServerPriorityHigh;
    TMenuItem *PopupServerPriorityNormal;
    TTabSheet *TabSheetLog;
    TGroupBox *GroupBoxOveralSettings;
    TSplitter *Splitter1;
    TRichEdit *log_list;
    TGroupBox *GroupBoxEthernetSettings;
    TStatusBar *StatusBar1;
    TStringGrid *StringGridEthernetCrates;
    TGroupBox *GroupBox1;
    TMemo *Statistic;
    TGroupBox *GroupBox2;
    TTreeView *CrateTree;
    TSplitter *Splitter2;
    TMenuItem *Separator1;
    TMenuItem *PopupDeleteCrateIP;
    TMenuItem *PopupClearLog;
    TMenuItem *PopupAddCrateIP;
    TMenuItem *PopupConnectCrate;
    TMenuItem *PopupDisconnectCrate;
    TMenuItem *PopupConnectAllIP;
    TMenuItem *PopupDisconnectAllIP;
    TMenuItem *PopupRescanIP;
    TMenuItem *PopupAutoConnectIPToggle;
    TCheckBox *CheckBoxAutoConnectDynamic;
    TCheckBox *CheckBoxStartMinimized;
    TCheckBox *CheckBoxMinimizeToTray;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall TrayIcon1Click(TObject *Sender);
    void __fastcall PopupQuitClick(TObject *Sender);
    void __fastcall PopupRestartServerClick(TObject *Sender);
    void __fastcall PopupServerPriorityHighClick(TObject *Sender);
    void __fastcall PopupServerPriorityNormalClick(TObject *Sender);
    void __fastcall PopupClearLogClick(TObject *Sender);
    void __fastcall FormContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled);
    void __fastcall TrayIcon1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift,
          int X, int Y);
    void __fastcall PopupAddCrateIPClick(TObject *Sender);
    void __fastcall PopupDeleteCrateIPClick(TObject *Sender);
    void __fastcall PopupConnectCrateClick(TObject *Sender);
    void __fastcall PopupDisconnectCrateClick(TObject *Sender);
    void __fastcall PopupConnectAllIPClick(TObject *Sender);
    void __fastcall PopupDisconnectAllIPClick(TObject *Sender);
    void __fastcall PopupRescanIPClick(TObject *Sender);
    void __fastcall StringGridEthernetCratesDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall StringGridEthernetCratesDblClick(TObject *Sender);
    void __fastcall PopupAutoConnectIPToggleClick(TObject *Sender);
    void __fastcall PageControl1Resize(TObject *Sender);
    void __fastcall CheckBoxAutoConnectDynamicClick(TObject *Sender);
    void __fastcall CheckBoxStartMinimizedClick(TObject *Sender);
    void __fastcall CheckBoxMinimizeToTrayClick(TObject *Sender);
private:    // User declarations

    TLTRServiceClient *ltrserviceclient;
    TUpdateInfoThread * UpdateInformationThread;
    struct
        {
        AnsiString Connect;
        AnsiString Disconnect;
        AnsiString AutoConnect;
        AnsiString Delete;
        }
        MenuCaption;

public:     // User declarations
    T_MessageQueue * MessageQueueDisplay;
    TLTRServiceCrate  *ltrservicecrate;

    __fastcall TFormMAIN(TComponent* Owner);
     virtual void __fastcall Dispatch(void *_msg);
};

class TProxyGrid : public TStringGrid
{
    public:
        using TStringGrid::DeleteRow;
        using TStringGrid::DeleteColumn;
};

//---------------------------------------------------------------------------
extern PACKAGE TFormMAIN *FormMAIN;
//---------------------------------------------------------------------------
#endif
