#ifndef COMMONH
#define COMMONH
#define FD_SETSIZE (1)
#include <winsock2.h>
#include <ws2tcpip.h>
#include <windows.h>
#include <stdio.h>
#include <classes.hpp>
#include <inifiles.hpp>
#include <algorithm>
#include "ltr\\include\\ltrapi_ll.h"
#include "MessageQueue.h"
#include "addrlist.h"
#include "LtrIniFile.h"
//
#define DBG
//---------------------------------------------------------------------------
#define LTRLOGFILENAME "ltrserver.log"
#define LTRINIFILENAME "ltrserver.ini"
//---------------------------------------------------------------------------
#define TIMEOUT_0     10
#define TIMEOUT_1     20
#define TIMEOUT_2    200
#define TIMEOUT_4   2000
#define TIMEOUT_8   5000
#define TIMEOUT_C  10000
#define TIMEOUT_G  20000

#define TIMEOUT_ETH_SHORTER 10      /*     data connection (  ) */
#define TIMEOUT_ETH_LONGER  200     /*    data connection,    */
#define TIMEOUT_ETH_CONNECT 60000   /*    (tcp connect) */
#define TIMEOUT_ETH_IDLE    5000    /*      NOP */
#define TIMEOUT_ETH_RETRY   2000    /*     data connection */

#define LTR_CRATE_PING_ATTEMPTS     3   /* -     NOP */
#define LTR_CRATE_DATACONN_ATTEMPTS 10  /* -      */

#define IP_LIST_MAX         256

//---------------------------------------------------------------------------
#define CRATE_RR_N                  32                //       

//     
#define CRATE_RR_SIZE_MAX_DWORD     (128*1024l)
#define CRATE_RR_SIZE_MAX_BYTE      (CRATE_RR_SIZE_MAX_DWORD*4)

#define MODULE_RECV_BUF_SIZE        (1*1024*1024l)   //     (DWORD[MODULE_RECV_BUF_SIZE])
//
#define CRATE_WR_N                  1                //       
#define CRATE_WR_SIZE_MAX_DWORD     (   128*1024l)   //      (DWORD[CRATE_WR_SIZE_MAX])
#define MODULE_SEND_BUF_SIZE        (   128*1024l)   //     (DWORD[MODULE_SEND_BUF_SIZE])

//   Ethernet  (  socket)
#define CRATE_ETH_RECV_BUF_SIZE     (256 * 1024)   //      ( recv)
#define CRATE_ETH_RECV_TCPBUF_SIZE  (CRATE_ETH_RECV_BUF_SIZE * 2) //  ,  TCP 
#define CRATE_ETH_SEND_BUF_SIZE     (256 * 1024)   //      ( send)
#define CRATE_ETH_SEND_TCPBUF_SIZE  (CRATE_ETH_SEND_BUF_SIZE * 2) //  ,  TCP 

//     (bootrom, application, auto)
#define CM_AUTO                 0       // (application_active) ? application : bootloader
#define CM_APP                  1       // application access
#define CM_BOOT                 2       // bootloader access

//
#define CRATE_FLAG_BOOT_LOADER  (1<< 0)
#define CRATE_FLAG_HW_ERROR     (1<< 1)
#define CRATE_FLAG_USB_HI_SPEED (1<< 2)
//   
#define LOG_FLAG_FILE           (1<< 0)
#define LOG_FLAG_SCREEN         (1<< 1)
#define LOG_FLAG_CRATE_INIT     (1<< 2)
#define LOG_FLAG_CRATE_READ     (1<< 3)
#define LOG_FLAG_CRATE_WRITE    (1<< 4)
#define LOG_FLAG_CLIENT_INIT    (1<< 5)
#define LOG_FLAG_CLIENT_CONTROL (1<< 6)
#define LOG_FLAG_CLIENT_READ    (1<< 7)
#define LOG_FLAG_CLIENT_WRITE   (1<< 8)
#define LOG_FLAG_DEBUG_LEVEL1   (1<< 9)
#define LOG_FLAG_DEBUG_LEVEL2   (1<<10)
#define LOG_FLAG_DEBUG_LEVEL3   (1<<11)
#define LOG_FLAG_DEBUG_LEVEL4   (1<<12)
#define LOG_FLAG_DEBUG_LEVEL5   (1<<13)
#define LOG_FLAG_DEBUG_LEVEL6   (1<<14)
#define LOG_FLAG_DEBUG_LEVEL7   (1<<15)
#define LOG_FLAG_DEBUG_LEVEL8   (1<<16)
#define LOG_FLAG_ANY_LEVEL  \
    (LOG_FLAG_DEBUG_LEVEL1 | LOG_FLAG_DEBUG_LEVEL2 | LOG_FLAG_DEBUG_LEVEL3 | LOG_FLAG_DEBUG_LEVEL4 \
    |LOG_FLAG_DEBUG_LEVEL5 | LOG_FLAG_DEBUG_LEVEL6 | LOG_FLAG_DEBUG_LEVEL7 | LOG_FLAG_DEBUG_LEVEL8)
#define LOG_FLAG_SCREEN_FILE    (LOG_FLAG_SCREEN|LOG_FLAG_FILE)
//
#define SCREEN_LOG_SIZE         (16*1000)

//-----------------------------------------------------------------------------
//------------------------ Messages for LTRCrateServiceThread -----------------
//-----------------------------------------------------------------------------

/*   CrateServiceThread */
enum t_CrateServiceThreadMsg
    {
    LTR_SRV_device_changed = 0x1000,
    LTR_SRV_rescan_ethernet_crates,
    LTR_SRV_autoconnect_ip,
    LTR_SRV_disconnect_all_ip,
    LTR_SRV_server_priority_changed,
    LTR_SRV_suspend,
    LTR_SRV_resume_suspend,
    LTR_SRV_send_crate_abort,               /*   (  : ) */
    LTR_SRV_bury_the_dead,                  /*  ,    */
    LTR_SRV_connect_crate,
    LTR_SRV_disconnect_crate,
    };

/*       */
enum t_DisplayThreadMsg
    {
    LTR_DISP_crate_list_updated = 0x2000,
    LTR_DISP_ethernet_list_updated,
    };

/*    */
enum t_CrateState
    {
    CRATE_ST_NULL,          /*  CRATE_STATE()    */
    CRATE_ST_UNINIT,        /*        */
    CRATE_ST_CONNECTING,    /*     */
    CRATE_ST_ONLINE,        /*     */
    CRATE_ST_DEAD,          /*       */
    };

//-----------------------------------------------------------------------------
//------------------------------- Functions Prototypes For Data Exchange-------
//-----------------------------------------------------------------------------

typedef BOOL (WINAPI * T_ReadFile) (HANDLE hFile,
  LPVOID lpBuffer,
  DWORD nNumberOfBytesToRead,
  LPDWORD lpNumberOfBytesRead,
  LPOVERLAPPED lpOverlapped);

typedef BOOL (WINAPI * T_WriteFile) (HANDLE hFile,
  LPCVOID lpBuffer,
  DWORD nNumberOfBytesToRead,
  LPDWORD lpNumberOfBytesRead,
  LPOVERLAPPED lpOverlapped);

typedef DWORD (WINAPI * T_WaitForSingleObject) (HANDLE hHandle,
  DWORD dwMilliseconds);

typedef BOOL (WINAPI * T_GetOverlappedResult) (HANDLE hFile,
  LPOVERLAPPED lpOverlapped,
  LPDWORD lpNumberOfBytesTransferred,
  BOOL bWait);

typedef BOOL (WINAPI * T_DeviceIoControl) (HANDLE hDevice,
  DWORD dwIoControlCode,
  LPVOID lpInBuffer,
  DWORD nInBufferSize,
  LPVOID lpOutBuffer,
  DWORD nOutBufferSize,
  LPDWORD lpBytesReturned,
  LPOVERLAPPED lpOverlapped);

typedef DWORD (WINAPI * T_GetLastError) (void);

//---------------------------------------------------------------------------
class TCrate
{
protected:
    volatile bool Suspended;
    HANDLE ThreadTerminationInUse;              // mutex
    BYTE AllowLowSpeedModule[MODULE_MAX];
    DWORD ei;
    volatile t_CrateState CurState;
    T_MessageQueue *MessageQueueControl;
    T_MessageQueue *MessageQueueDisplay;

    virtual bool StartServiceThreads(void) = 0;
    virtual void StopServiceThreads(void) = 0;

public:
    _CrateType CrateType;
    char path[1024];                            // (USB)    
                                                // (TCP) IP-   
    DWORD ip_addr;                              // (TCP) IP-
    char pid[32];                               //    
    char csn[16];                               //   
    volatile int  sflags;                       //   
    WORD baud_rate;                             //   
    //                                          //
    DWORD second_mark_counter;                  //     LTR43
    DWORD start_mark_counter;                   //     LTR43
    //                                          //
    SYSTEMTIME start_time;                      //
    volatile __int64 total_count_recv;          //      
    volatile __int64 total_count_send;          //      

    bool ReadRawData;                           //       17

    int  log_flags;                             //   
    volatile LONG mconfig;                      //   
    struct TModule
    {
        volatile bool ModulePresence;
        //
        WORD mid;                               // id 
        //                                      //
        volatile DWORD recv_buf_ptr;            //   
        DWORD *recv_buf;                        //  
        DWORD *send_buf;                        //  
        volatile DWORD send_buf_cntr;           //   
        volatile DWORD send_buf_cntr_sended;    //   
        HANDLE send_buf_In_Use;                 //    
        HANDLE recv_buf_is;                     //      readFIFO
        //   34                    //
        volatile __int64 count_recv;            //      
        volatile __int64 count_send;            //      
        volatile __int64 count_FIFO_recv;       //     FIFO (    count_FIFO_Client)
        DWORD fifo_size;                        //   FIFO  

        bool CreateModule(void);
        void DeleteModule(void);
    } module[MODULE_MAX+1];                     // +1 -  RawData

    volatile bool ThreadsRunning;               //        

    TCrate(T_MessageQueue *mqControl, T_MessageQueue *mqDisplay);
    virtual ~TCrate(void);

    /* Callback-      
           .     . */
    bool ParseDataFromCrate(LPDWORD lpBuffer, DWORD NumDWords);
    DWORD PrepareDataForCrate(LPDWORD lpBuffer, DWORD MaxDWords, DWORD &NumDataFast);
    bool ProcessCrateError(DWORD Data);

    /*        */
    inline t_CrateState GetState(void)
        { return (this != NULL) ? CurState : CRATE_ST_NULL; }
    virtual void SetState(t_CrateState new_state, bool NotifyThreads = true) = 0;

    /*    */
    virtual _CrateConnectionType GetConnType(void) = 0;
    virtual bool Startup(BYTE * FPGAData, char *default_ttf) = 0;
    virtual void SuspendCrate(void) = 0;
    virtual void ResumeCrate(void) = 0;

    /*      */
    virtual void CancelIO(void) = 0;
    virtual bool CallApplication(DWORD address) = 0;
    virtual bool GetArray(DWORD mode, DWORD address, BYTE *data, DWORD size) = 0;
    virtual bool PutArray(DWORD mode, DWORD address, BYTE *data, DWORD size) = 0;
    virtual bool GetModuleDescription(DWORD mode, TDESCRIPTION_LTR010 *description) = 0;
    virtual bool SetModuleDescription(DWORD mode, TDESCRIPTION_LTR010 *description) = 0;
    virtual int PingAndGetFailCount(void) = 0;

    /*   (  ) */
    virtual void RestartIdleTimer(void)     {}
    virtual void StopIdleTimer(void)        {}
    virtual HANDLE GetIdleTimerHandle(void) { return NULL; }
};

//---------------------------------------------------------------------------
class TCrateUSB : public TCrate
    {
private:
    TThread *recv_buf_thread;
    TThread *send_buf_thread;
    HANDLE DeviceHANDLE;
    TLTRUSB *ltr_USB;

    bool InitCrate(BYTE * FPGAData, char * default_ttf);
    virtual bool StartServiceThreads(void);
    virtual void StopServiceThreads(void);
public:
    TCrateUSB(T_MessageQueue *mqControl, T_MessageQueue *mqDisplay);
    virtual ~TCrateUSB(void);
    virtual void SetState(t_CrateState new_state, bool NotifyThreads = true);
    virtual _CrateConnectionType GetConnType(void);
    virtual bool Startup(BYTE * FPGAData, char *default_ttf);
    virtual void SuspendCrate(void);
    virtual void ResumeCrate(void);

    virtual void CancelIO(void);
    virtual bool CallApplication(DWORD address);
    virtual bool GetArray(DWORD mode, DWORD address, BYTE *data, DWORD size);
    virtual bool PutArray(DWORD mode, DWORD address, BYTE *data, DWORD size);
    virtual bool GetModuleDescription(DWORD mode, TDESCRIPTION_LTR010 *description);
    virtual bool SetModuleDescription(DWORD mode, TDESCRIPTION_LTR010 *description);
    virtual int PingAndGetFailCount(void);

friend
    class TReadUSBCrateThread;
friend
    class TWriteUSBCrateThread;
    };

//---------------------------------------------------------------------------
class TCrateEther : public TCrate
    {
private:
    int ping_fail_count;
    TThread *data_thread;
    TLTREther *ltr_Ether;
    WSAEVENT hAbortEvent;

    bool InitCrate(void);
    virtual bool StartServiceThreads(void);
    virtual void StopServiceThreads(void);
public:
    TCrateEther(T_MessageQueue *mqControl, T_MessageQueue *mqDisplay, DWORD IdleTimeout);
    virtual ~TCrateEther(void);
    virtual void SetState(t_CrateState new_state, bool NotifyThreads = true);
    virtual _CrateConnectionType GetConnType(void);
    virtual bool Startup(BYTE * FPGAData, char *default_ttf);
    virtual void SuspendCrate(void);
    virtual void ResumeCrate(void);

    virtual void CancelIO(void);
    virtual bool CallApplication(DWORD address);
    virtual bool GetArray(DWORD mode, DWORD address, BYTE *data, DWORD size);
    virtual bool PutArray(DWORD mode, DWORD address, BYTE *data, DWORD size);
    virtual bool GetModuleDescription(DWORD mode, TDESCRIPTION_LTR010 *description);
    virtual bool SetModuleDescription(DWORD mode, TDESCRIPTION_LTR010 *description);
    virtual int PingAndGetFailCount(void);

    /*   */
    virtual void RestartIdleTimer(void)     { ltr_Ether->RestartIdleTimer(); }
    virtual void StopIdleTimer(void)        { ltr_Ether->StopIdleTimer(); }
    virtual HANDLE GetIdleTimerHandle(void) { return ltr_Ether->GetIdleTimerHandle(); }

friend
    class TEthCrateDataThread;
    };

//---------------------------------------------------------------------------
#define CLIENT_RBUF_SIZE (128*1024)
#define CLIENT_WBUF_SIZE (128*1024)
#define CLIENT_MAX  256
//---------------------------------------------------------------------------
class TClient {
 public :
    SOCKET socket;
    TCrate *crate;
    WORD crate_channel;
    WORD flags;
    volatile bool IsAlive;

    __int64 count_FIFO_recv;
    DWORD buf_ptr_FIFO_recv;
    //
    TThread *control_thread;
    TThread *recv_buf_thread;
    TThread *send_buf_thread;

    bool CheckSocket(void);
    TClient(SOCKET _socket, TCrate *_crate, WORD _crate_channel, WORD client_flags);
    ~TClient(void);
};
//---------------------------------------------------------------------------
class TLog
{
 private :
    HANDLE access;
    FILE  *file;
    TStringList *slist;
 public :
    TLog(void);
    TLog(AnsiString fname);
    ~TLog(void);
    //
    bool Open(AnsiString fname=LTRLOGFILENAME);
    bool Close(void);
    //
    bool AddMessage(AnsiString msg, int log_flag, int log_mask);
    AnsiString GetMessage(void);
    int GetCount(void);
};

//---------------------------------------------------------------------------
struct t_GlobalConfig
    {
    DWORD ServerPriority;
    bool MinimizeToTray;
    bool StartMinimized;
    bool AutoConnectDynamic;
    AnsiString default_ttf;
    int log_flags;
    };
extern struct t_GlobalConfig g_Config;

extern HANDLE crate_list_access;
extern HANDLE client_list_access;
extern TCrate  *crate_list[CRATE_MAX];
extern TClient *client_list[CLIENT_MAX];
extern TUniqueAddrMultiList IPCrateList;
//
extern TLog logfile;
extern TLtrIniFile g_INI;
//---------------------------------------------------------------------------
DWORD StrToIP(AnsiString ip_str);
AnsiString IPToStr(DWORD ip);
//---------------------------------------------------------------------------

#endif
