//---------------------------------------------------------------------------

#include <windows.h>
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------

#include "channel.h"
#include "ltr\\include\\ltrapi.h"
LPCSTR ErrorStrings[]={
	"  .",
	" .",
	"  .",
	"   .",
	"     .",
	"  .",
	".      .",
	"  .",
	"  .",
	"   -.",
    " !        "
};

#define SEND_RECIEVE_TIMEOUT 10000
//-----------------------------------------------------------------------------
//              ltr-
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_Init(TLTR *ltr)
{
	INT res=LTR_OK;
	if(ltr!=NULL)
	{
		ltr->saddr=SADDR_DEFAULT;
		ltr->sport=SPORT_DEFAULT;
		ltr->csn[0]=0;
		ltr->cc=CC_CONTROL;
		ltr->flags=0;
		ltr->tmark=-1;
		ltr->internal=NULL;
	} else res=LTR_ERROR_PARAMETRS;
	return res;
}

//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_Open(TLTR *ltr)
{
	int res=LTR_OK;
	if(ltr!=NULL&&ltr->internal!=NULL) res=LTR_Close(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=new TChannel;
		ltr->internal= (LPVOID)channel;
		if(channel!=NULL)
		{
			if(channel->Open(ltr->saddr, ltr->sport))
			{
                //      
                for (int i = 0; i <16; i++) if (ltr->csn[i]==0) memset(&ltr->csn[i],0,16-i);

				DWORD ack=0;
				BYTE sbuf[CONTROL_COMMAND_SIZE+16+2+4], rbuf[CONTROL_COMMAND_SIZE+16+2+4];
				*(DWORD*)(sbuf+0)=CONTROL_COMMAND_START;
				*(DWORD*)(sbuf+4)=CONTROL_COMMAND_INIT_CONNECTION;
				memcpy(sbuf+ 8, ltr->csn, 16);
				memcpy(sbuf+24, &ltr->cc, 2);
				//    
				if(channel->Send(sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT)==sizeof(sbuf) &&
					channel->Recv((BYTE*)&ack, sizeof(ack), SEND_RECIEVE_TIMEOUT)==sizeof(ack) &&
					ack!=CONTROL_ACKNOWLEDGE_BAD&&
					channel->Recv(rbuf, sizeof(rbuf), SEND_RECIEVE_TIMEOUT)==sizeof(rbuf))
				{
					ltr->tmark=*(DWORD*)(rbuf+26);
					if(!ltr->csn[0]) memcpy(ltr->csn, rbuf+CONTROL_COMMAND_SIZE, 16);
					else if(memcmp(ltr->csn, rbuf+8, 16))
                    {   
                        res=LTR_ERROR_OPEN_CHANNEL;
                    }
                    else if (ack==CONTROL_ACKNOWLEDGE_MODULE_IN_USE) res = LTR_WARNING_MODULE_IN_USE;
				} else res=LTR_ERROR_OPEN_SOCKET;
			} else res=LTR_ERROR_OPEN_SOCKET;
			//
			if(res!=LTR_OK&&res!=LTR_WARNING_MODULE_IN_USE) LTR_Close(ltr);
		} else res=LTR_ERROR_MEMORY_ALLOC;
	}
	return res;
}
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_Close(TLTR *ltr)
{
	INT res=LTR_OK;
	if(ltr!=NULL)
	{
		if (ltr->internal!=NULL)
		{
			TChannel *channel=(TChannel*)ltr->internal;
			channel->Close();
			delete (TChannel*)ltr->internal;
			ltr->internal=NULL;
		}
	}else res==LTR_ERROR_PARAMETRS;
	return res;
}
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_IsOpened(TLTR *ltr)
{
	INT res=LTR_OK;
	if(ltr!=NULL)
	{
		if(ltr->internal==NULL) res=LTR_ERROR_CHANNEL_CLOSED;
	} else res=LTR_ERROR_PARAMETRS;
	return res;
}
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_Recv(TLTR *ltr, DWORD *data, DWORD *tmark, DWORD size, DWORD timeout)
{
	if (ltr==NULL||data==NULL||size==0)  return LTR_ERROR_PARAMETRS;

	int res=LTR_IsOpened(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
		ltr->flags&=~FLAG_RBUF_OVF;

		if((ltr->cc&(~CC_DEBUG_FLAG))!=CC_CONTROL)
		{
            DWORD SizeRecieved=0;
            DWORD tbegin = GetTickCount();
            while (size&&((GetTickCount()-tbegin)<timeout))
            {   //                   
                int _sz_=channel->Recv((BYTE*)&data[SizeRecieved], size*sizeof(DWORD), timeout)/sizeof(DWORD);
                if (channel->LastError!=0) return LTR_ERROR_CHANNEL_CLOSED;

                int sz=0;
                for(int i=0; i<_sz_; i++)
                {
                    DWORD CurrentData = data[SizeRecieved+i];
                    if(!(ltr->flags&FLAG_SIGNAL_TSTAMP))
                    {
                        if(CurrentData==SIGNAL_RBUF_OVF)
                        {//   						
                            ltr->flags|=FLAG_RBUF_OVF;
                        }
                        else if(CurrentData==SIGNAL_TSTAMP)
                        {//    SIGNAL_TSTAMP.						
                            ltr->flags|=FLAG_SIGNAL_TSTAMP;
                        }
                        else
                        {
                            if(tmark!=NULL) tmark[SizeRecieved+sz]=ltr->tmark;
                            data[SizeRecieved+sz]=CurrentData;
                            sz++;
                        }
                    }
                    else
                    {  //  
                        ltr->tmark=CurrentData;
                        ltr->flags&=~FLAG_SIGNAL_TSTAMP;
                    }
                }
                SizeRecieved+=sz;
                size-=sz;
            }
			res=SizeRecieved;
		}
        else
        {
            res=channel->Recv((BYTE*)data, size*sizeof(DWORD), timeout)/sizeof(DWORD);
            if (channel->LastError!=0) return LTR_ERROR_CHANNEL_CLOSED;
        }
	}
	return res;
}
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_Send(TLTR *ltr, DWORD *data, DWORD size, DWORD timeout)
{
	if (ltr==NULL||data==NULL||size==0)  return LTR_ERROR_PARAMETRS;

	int res=LTR_IsOpened(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
		res=channel->Send((BYTE*)data, size*sizeof(DWORD), timeout)/sizeof(DWORD);
		if (channel->LastError) return LTR_ERROR_CHANNEL_CLOSED;                  
	}
	return res;
}
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_GetCrates(TLTR *ltr, BYTE *csn)
{
	INT res=LTR_IsOpened(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
		DWORD ack=0;
		DWORD sbuf[2]={CONTROL_COMMAND_START, CONTROL_COMMAND_GET_CRATES};
		INT ssz=channel->Send((BYTE*)sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT);
		INT rsz=channel->Recv((BYTE*)&ack, sizeof(ack), SEND_RECIEVE_TIMEOUT);
		if(ssz!=sizeof(sbuf)) res=LTR_ERROR_SEND;
		else if(rsz!=sizeof(ack)) res=LTR_ERROR_RECV;
		else if(ack!=CONTROL_ACKNOWLEDGE_GOOD) res=LTR_ERROR_EXECUTE;
		else if(channel->Recv((BYTE*)csn, CRATE_MAX*16, SEND_RECIEVE_TIMEOUT)!=(CRATE_MAX*16)) res=LTR_ERROR_RECV;
	}
	return res;
}

//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_SetServerProcessPriority(TLTR *ltr, DWORD Priority)
{
	INT res=LTR_IsOpened(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
		DWORD ack=0;
		DWORD sbuf[2]={CONTROL_COMMAND_START, CONTROL_COMMAND_SET_SERVER_PROCESS_PRIORITY};
		INT ssz=channel->Send((BYTE*)sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT);
		INT rsz=channel->Recv((BYTE*)&ack, sizeof(ack), SEND_RECIEVE_TIMEOUT);

		if(ssz!=sizeof(sbuf))
		{
			res=LTR_ERROR_SEND;
		}
		else
		{
			if(rsz!=sizeof(ack))
			{
				res=LTR_ERROR_RECV;
			}
			else
			{
				if(ack!=CONTROL_ACKNOWLEDGE_GOOD)
				{
					res=LTR_ERROR_EXECUTE;
				}
				else
				{
					if (channel->Send((BYTE*)&Priority, sizeof(Priority), SEND_RECIEVE_TIMEOUT)!=sizeof(Priority)) res=LTR_ERROR_SEND;

					rsz=channel->Recv((BYTE*)&ack, sizeof(ack), SEND_RECIEVE_TIMEOUT);
					if(rsz!=sizeof(ack))
					{
						res=LTR_ERROR_RECV;
					}
					else
					{
						if(ack!=CONTROL_ACKNOWLEDGE_GOOD)
						{
							res=LTR_ERROR_EXECUTE;
						}
					}
				}
			};
		};
	}
	return res;
}

//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_GetCrateModules(TLTR *ltr, WORD *mid)
{
	INT res=LTR_IsOpened(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
		DWORD ack=0;
		DWORD sbuf[2]={CONTROL_COMMAND_START, CONTROL_COMMAND_GET_MODULES};
		INT ssz=channel->Send((BYTE*)sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT);
		INT rsz=channel->Recv((BYTE*)&ack, sizeof(ack), SEND_RECIEVE_TIMEOUT);
		if(ssz!=sizeof(sbuf)) res=LTR_ERROR_SEND;
		else if(rsz!=sizeof(ack)) res=LTR_ERROR_RECV;
		else if(ack!=CONTROL_ACKNOWLEDGE_GOOD) res=LTR_ERROR_EXECUTE;
		else if(channel->Recv((BYTE*)mid, MODULE_MAX*2, SEND_RECIEVE_TIMEOUT)!=(MODULE_MAX*2)) res=LTR_ERROR_RECV;
	}
	return res;
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(LPCSTR) LTR_GetErrorString(INT error)
{
	if(error<1 && error>-((int)(sizeof(ErrorStrings)/sizeof(LPCSTR))))
	{
		return ErrorStrings[abs(error)];
	}
	else
	{
		return ErrorStrings[1];
	}
}
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_GetCrateRawData(TLTR *ltr, DWORD * data, DWORD * tmark, DWORD size, DWORD timeout)
{
	INT res=LTR_IsOpened(ltr);

	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
        if(size)
        {
            DWORD sbuf[5]={CONTROL_COMMAND_START, CONTROL_COMMAND_GET_CRATE_RAW_DATA, size, timeout, ltr->flags&FLAG_RFULL_DATA};
            int ssz=channel->Send((BYTE*)sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT);
            if(ssz!=sizeof(sbuf))
            {
                res=LTR_ERROR_SEND;
            }
            else
            {
                res=LTR_Recv(ltr, data, tmark, size, timeout);
            }
        }
        else
        {
            DWORD sbuf[2]={CONTROL_COMMAND_START, CONTROL_COMMAND_GET_CRATE_RAW_DATA_SIZE};
            int ssz=channel->Send((BYTE*)sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT);
            if(ssz!=sizeof(sbuf))
            {
                res=LTR_ERROR_SEND;
            }
            else
            {
                DWORD SizeRecv =0;
                res=channel->Recv((PBYTE)&SizeRecv, sizeof(SizeRecv), SEND_RECIEVE_TIMEOUT);
                if(res!=sizeof(SizeRecv))
                {
                    res=LTR_ERROR_SEND;
                }
                else res = SizeRecv;
            }
        }
	}
	return res;
}
//-----------------------------------------------------------------------------
LTRAPIWIN_DllExport(INT) LTR_GetCrateInfo(TLTR *ltr, BYTE * CrateInfo)
{
	INT res=LTR_IsOpened(ltr);
	if(res==LTR_OK)
	{
		TChannel *channel=(TChannel*)ltr->internal;
		DWORD ack=0;
		DWORD sbuf[2]={CONTROL_COMMAND_START, CONTROL_COMMAND_GET_CRATE_TYPE};
		INT ssz=channel->Send((BYTE*)sbuf, sizeof(sbuf), SEND_RECIEVE_TIMEOUT);
		INT rsz=channel->Recv((BYTE*)&ack, sizeof(ack), SEND_RECIEVE_TIMEOUT);
		if(ssz!=sizeof(sbuf)) res=LTR_ERROR_SEND;
		else if(rsz!=sizeof(ack)) res=LTR_ERROR_RECV;
		else if(ack!=CONTROL_ACKNOWLEDGE_GOOD) res=LTR_ERROR_EXECUTE;
		else if(channel->Recv(CrateInfo, sizeof(_CrateInfoStruct), SEND_RECIEVE_TIMEOUT)!=sizeof(_CrateInfoStruct)) res=LTR_ERROR_RECV;
	}
	return res;
}
//-----------------------------------------------------------------------------
#pragma argsused
BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{

	WORD wVersionRequested;
	WSADATA wsaData;
	int err ;

	switch(ul_reason_for_call)
	{

		//case DLL_THREAD_ATTACH:
	case DLL_PROCESS_ATTACH :

		wVersionRequested = MAKEWORD( 2, 2 );

		err= WSAStartup( wVersionRequested, &wsaData );
		if ( err != 0 )
		{
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			return false;
		}

		/* Confirm that the WinSock DLL supports 2.2.*/
		/* Note that if the DLL supports versions greater    */
		/* than 2.2 in addition to 2.2, it will still return */
		/* 2.2 in wVersion since that is the version we      */
		/* requested.                                        */

		if ( LOBYTE( wsaData.wVersion ) != 2 ||
			HIBYTE( wsaData.wVersion ) != 2 )
		{
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			WSACleanup( );
			return false;
		}
		break;
		//case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		WSACleanup();
		break;

	}
	return true;
}
//-----------------------------------------------------------------------------

