#include "boot.h"
#include <algorithm>
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
TLUSB_BOOT_LOADER::TLUSB_BOOT_LOADER() : TLUSB_COMMON()
{
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_BOOT_LOADER::PutArray(DWORD address, BYTE *data, DWORD size)
{
 LastErrorNumber=LUSB_RESULT_OK;
 if(data!=NULL && size!=0)
 {
	DWORD i=0;
    while(i<size && LastErrorNumber>=LUSB_RESULT_OK)
    {
        DWORD sz=std::min<int>(4096, size-i);
     	WORD InBuf[4]={0x0000, V_PUT_ARRAY, address, (address)>>16};
        if(!ControlLDevice(DIOC_SEND_COMMAND, &InBuf, sizeof(InBuf), data+i, sz))
        {
            if(LastErrorNumber==1006) LastErrorNumber=1101;
        }
        //
        address+=sz;
        i+=sz;
    }
 } else LastErrorNumber=1000;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_BOOT_LOADER::GetArray(DWORD address, BYTE *data, DWORD size)
{
 LastErrorNumber=LUSB_RESULT_OK;
 if(data!=NULL && size!=0)
 {  
	DWORD i=0;
    while(i<size && LastErrorNumber>=LUSB_RESULT_OK)
    {
        DWORD sz=std::min<int>(4096, size-i);
     	WORD InBuf[4]={0x0001, V_GET_ARRAY, address, (address)>>16};
        if(!ControlLDevice(DIOC_SEND_COMMAND, &InBuf, sizeof(InBuf), data+i, sz))
        {
            if(LastErrorNumber==1006) LastErrorNumber=1102;
        }
        //
        address+=sz;
        i+=sz;
    }
 } else LastErrorNumber=1000;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_BOOT_LOADER::CallApplication(DWORD address)
{
 WORD InBuf[4]={0, V_CALL_APPLICATION, address, (address)>>16};
 if(!ControlLDevice(DIOC_SEND_COMMAND, InBuf, sizeof(InBuf), NULL, 0))
 {
    if(LastErrorNumber==1006) LastErrorNumber=1103;
 }
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}


