#include "common.h"
#include <algorithm>
//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
TLUSB_COMMON::TLUSB_COMMON()
{
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_COMMON::PutArray(DWORD address, BYTE *data, DWORD size)
{
 LastErrorNumber=LUSB_RESULT_OK;
 if(data!=NULL && size!=0)
 {
	DWORD i=0;
    while(i<size && LastErrorNumber>=LUSB_RESULT_OK)
    {
        DWORD sz=std::min<int>(4096, size-i);
     	WORD InBuf[4]={0x0000, V_PUT_ARRAY, address, (address)>>16};
        if(!ControlLDevice(DIOC_SEND_COMMAND, &InBuf, sizeof(InBuf), data+i, sz))
        {
            if(LastErrorNumber==1006) LastErrorNumber=1101;
        }
        address+=sz;
        i+=sz;
    }
 } else LastErrorNumber=1000;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_COMMON::GetArray(DWORD address, BYTE *data, DWORD size)
{
 LastErrorNumber=LUSB_RESULT_OK;
 if(data!=NULL && size!=0) {
	DWORD i=0;
    while(i<size && LastErrorNumber>=LUSB_RESULT_OK)
    {
        DWORD sz=std::min<int>(4096, size-i);
     	WORD InBuf[4]={0x0001, V_GET_ARRAY, address, (address)>>16};
        if(!ControlLDevice(DIOC_SEND_COMMAND, &InBuf, sizeof(InBuf), data+i, sz))
        {
            if(LastErrorNumber==1006) LastErrorNumber=1102;
        }
        address+=sz;
        i+=sz;
    }
 } else LastErrorNumber=1000;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_COMMON::ReadData(LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToRead, LPDWORD lpNumberOfBytesRead, LPOVERLAPPED lpOverlapped)
{
 LastErrorNumber=LUSB_RESULT_OK;
 if(lpNumberOfBytesToRead!=NULL)
 {
    if(hDevice!=INVALID_HANDLE_VALUE)
    {
    	if(*lpNumberOfBytesToRead>(1*1024*1024)) *lpNumberOfBytesToRead=1*1024*1024;
        if(!ReadFile(hDevice, lpBuffer, *lpNumberOfBytesToRead, lpNumberOfBytesRead, lpOverlapped))
        {
           if (GetLastError()!=ERROR_IO_PENDING) LastErrorNumber=1211;
        }
    } else LastErrorNumber=1004;
 } else LastErrorNumber=1000;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_COMMON::WriteData(LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToWrite, LPDWORD lpNumberOfBytesWrite, LPOVERLAPPED lpOverlapped)
{
 LastErrorNumber=LUSB_RESULT_OK;
 if(lpNumberOfBytesToWrite!=NULL)
 {
    if(hDevice!=INVALID_HANDLE_VALUE)
    {
    	if(*lpNumberOfBytesToWrite>(1*1024*1024)) *lpNumberOfBytesToWrite=1*1024*1024;
	    if(!WriteFile(hDevice, lpBuffer, *lpNumberOfBytesToWrite, lpNumberOfBytesWrite, lpOverlapped) &&
           GetLastError()!=ERROR_IO_PENDING) LastErrorNumber=1212;
    } else LastErrorNumber=1004;
 } else LastErrorNumber=1000;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_COMMON::SyncReadData(LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToRead, DWORD TimeOut)
{
 OVERLAPPED overlapped;
 memset(&overlapped, 0, sizeof(overlapped));
 overlapped.hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
 if(overlapped.hEvent!=NULL)
 {
    DWORD size;
    if(ReadData(lpBuffer, lpNumberOfBytesToRead, &size, &overlapped))
    {
        if(WaitForSingleObject(overlapped.hEvent, TimeOut)==WAIT_OBJECT_0)
        {
            GetOverlappedResult(hDevice, &overlapped, lpNumberOfBytesToRead, FALSE);
        }
        else
        {
            CancelIo();
        }
    }
    CloseHandle(overlapped.hEvent);
 } else LastErrorNumber=11111;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}
//-----------------------------------------------------------------------------
//     
//-----------------------------------------------------------------------------
bool WINAPI TLUSB_COMMON::SyncWriteData(LPBYTE lpBuffer, LPDWORD lpNumberOfBytesToWrite, DWORD TimeOut)
{
 OVERLAPPED overlapped;
 memset(&overlapped, 0, sizeof(overlapped));
 overlapped.hEvent=CreateEvent(NULL, FALSE, FALSE, NULL);
 if(overlapped.hEvent!=NULL)
 {
    DWORD size;
    if(WriteData(lpBuffer, lpNumberOfBytesToWrite, &size, &overlapped))
    {
        if(WaitForSingleObject(overlapped.hEvent, TimeOut)==WAIT_OBJECT_0)
        {
            GetOverlappedResult(hDevice, &overlapped, lpNumberOfBytesToWrite, FALSE);
        }
        else
        {
            CancelIo();
        }
    }
    CloseHandle(overlapped.hEvent);
 } else LastErrorNumber=11111;
 return LastErrorNumber<LUSB_RESULT_OK ? false : true;
}

