//---------------------------------------------------------------------------

#include <windows.h>
//---------------------------------------------------------------------------
//   Important note about DLL memory management when your DLL uses the
//   static version of the RunTime Library:
//
//   If your DLL exports any functions that pass String objects (or structs/
//   classes containing nested Strings) as parameter or function results,
//   you will need to add the library MEMMGR.LIB to both the DLL project and
//   any other projects that use the DLL.  You will also need to use MEMMGR.LIB
//   if any other projects which use the DLL will be performing new or delete
//   operations on any non-TObject-derived classes which are exported from the
//   DLL. Adding MEMMGR.LIB to your project will change the DLL and its calling
//   EXE's to use the BORLNDMM.DLL as their memory manager.  In these cases,
//   the file BORLNDMM.DLL should be deployed along with your DLL.
//
//   To avoid using BORLNDMM.DLL, pass string information using "char *" or
//   ShortString parameters.
//
//   If your DLL uses the dynamic version of the RTL, you do not need to
//   explicitly add MEMMGR.LIB as this will be done implicitly for you
//---------------------------------------------------------------------------


#include "LTR\\include\\ltrapi_ll.h"
#include "LIB\\DEV_STD\\USB_defs.h"
#include "LIB\\DEV_STD\\LUSB.h"

//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------

//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
__declspec(dllexport) DWORD WINAPI LTRAPI_LL_GetDLLVersion(void)
{
	return LC_CURRENT_VERSION;
}
//------------------------------------------------------------------------
//    
//------------------------------------------------------------------------
//extern "C" __declspec(dllexport) LPVOID WINAPI CreateInstance(char *DeviceName)
//extern "C"
__declspec(dllexport) TLTRUSB * WINAPI CreateInstanceUSB()
{
    TLTRUSB * NewClass = new TLTRUSB();
 return NewClass;
}

__declspec(dllexport) void WINAPI DeleteInstanceUSB(TLTRUSB * NewClass)
{
    delete NewClass;
}

__declspec(dllexport) TLTREther * WINAPI CreateInstanceEther(WSAEVENT AbortEvent, DWORD IdleTimeout)
{
    TLTREther * NewClass = new TLTREther(AbortEvent, IdleTimeout);
    return NewClass;
}

__declspec(dllexport) void WINAPI DeleteInstanceEther(TLTREther * NewClass)
{
    delete NewClass;
}

// Maybe defined in your compiler headers. If so, please, comment this
/*
typedef struct _OSVERSIONINFOEX {
  DWORD dwOSVersionInfoSize;
  DWORD dwMajorVersion;
  DWORD dwMinorVersion;
  DWORD dwBuildNumber;
  DWORD dwPlatformId;
  TCHAR szCSDVersion[128];
  WORD wServicePackMajor;
  WORD wServicePackMinor;
  WORD wSuiteMask;
  BYTE wProductType;
  BYTE wReserved;
} OSVERSIONINFOEX, *POSVERSIONINFOEX, *LPOSVERSIONINFOEX;
*/
//------------------------------------------------------------------------
//
//------------------------------------------------------------------------
DWORD GetSystemVersionMy(void)
{
   OSVERSIONINFOEX osvi;
   ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
   osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
   if(!GetVersionEx((OSVERSIONINFO *)&osvi))
   {
      osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
      if(!GetVersionEx((OSVERSIONINFO *)&osvi)) return 0;
   }
   switch (osvi.dwPlatformId)
   {
      case VER_PLATFORM_WIN32_NT:
         if ( osvi.dwMajorVersion <= 4 ) return 0x00000003; // WinNT
         if ( osvi.dwMajorVersion == 5 ) return 0x00010003; // Win2000  WinXP
      case VER_PLATFORM_WIN32_WINDOWS:
         if((osvi.dwMajorVersion>4)||((osvi.dwMajorVersion==4)&&(osvi.dwMinorVersion>0))) return 0x00020001; // Win98
         else return 0x00010001; // Win95
      case VER_PLATFORM_WIN32s: return 0x00010000; // Win32s
   }
   return 0;
}


//-------------------------------------------------------
TLTRUSB::TLTRUSB()
{
    MainDeviceClass = new TLUSB_BASE();
    Application = new TLTR010();
    Bootloader = new TLTR010_BOOT_LOADER();

    Application->SetUSBDevice(MainDeviceClass);
    Bootloader->SetUSBDevice(MainDeviceClass);
}

TLTRUSB::~TLTRUSB()
{
    delete Bootloader;
    delete Application;
    if(MainDeviceClass!=NULL)
    {
        delete (TLUSB_BASE*)MainDeviceClass;
    }
}

bool WINAPI TLTRUSB::OpenLDeviceByName(LPTSTR DeviceName)
{
    TLUSB_BASE * MainDevice = (TLUSB_BASE *)MainDeviceClass;
    if (MainDevice->OpenLDeviceByName(DeviceName))
    {
        char mname[16];
        if(MainDevice->GetModuleName(mname,16))
        {
            if(strstr(mname, "LTR010")
                        || strstr(mname, "LTR021")
                        ||strstr(mname, "LTR030")
                        ||strstr(mname, "LTR031")
                        )
            {
                if(strstr(mname, "LTR021")
                    ||strstr(mname, "LTR030")
                    ||strstr(mname, "LTR031")) Application->NoRealLoadFPGAGlag= true;
                else Application->NoRealLoadFPGAGlag= false;
                //
                SwitchBootloader(true);
            } else return false;
        } else return false;
    } else return false;
    return true;
}

bool WINAPI TLTRUSB::CloseLDevice(void)
{
    TLUSB_BASE * MainDevice = (TLUSB_BASE *)MainDeviceClass;
    if(MainDevice!=NULL)
    {
        return MainDevice->CloseLDevice();
    }
    return false;
}

bool WINAPI TLTRUSB::SwitchBootloader(bool Bootloader)
{
    DWORD Address;
    bool LastApplicationActive = application_active;
    if (Bootloader)
    {
        application_active=false;
        Address =LTR010_BOOT_LOADER_START_ADDRESS;
    }
    else
    {
        application_active=true;
        Address=LTR010_FIRMWARE_START_ADDRESS;
    }

    if (!this->Bootloader->CallApplication(Address))
    {
        application_active = LastApplicationActive;
        return false;
    }                
    return true;
}

HANDLE WINAPI TLTRUSB::GetUSBDeviceHandle(void)
{
    TLUSB_BASE * MainDevice = (TLUSB_BASE *)MainDeviceClass;
    return MainDevice->GetUSBDeviceHandle();
}

void WINAPI TLTRUSB::CancelIO(void)
{
    TLUSB_BASE * MainDevice = (TLUSB_BASE *)MainDeviceClass;
    MainDevice->CancelIo();
}

bool WINAPI TLTRUSB::GetModuleName(char mname[], DWORD Length)
{
    TLUSB_BASE * MainDevice = (TLUSB_BASE *)MainDeviceClass;
    return MainDevice->GetModuleName(mname, Length);
}


//-----------------------------------------------------------------------------
//
//-----------------------------------------------------------------------------
#pragma argsused
BOOL APIENTRY DllMain( HMODULE hModule,
					  DWORD  ul_reason_for_call,
					  LPVOID lpReserved
					  )
{

	WORD wVersionRequested;
	WSADATA wsaData;
	int err ;

	switch(ul_reason_for_call)
	{

		//case DLL_THREAD_ATTACH:
	case DLL_PROCESS_ATTACH :

		wVersionRequested = MAKEWORD( 2, 2 );

		err= WSAStartup( wVersionRequested, &wsaData );
		if ( err != 0 )
		{
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			return false;
		}

		/* Confirm that the WinSock DLL supports 2.2.*/
		/* Note that if the DLL supports versions greater    */
		/* than 2.2 in addition to 2.2, it will still return */
		/* 2.2 in wVersion since that is the version we      */
		/* requested.                                        */

		if ( LOBYTE( wsaData.wVersion ) != 2 ||
			HIBYTE( wsaData.wVersion ) != 2 )
		{
			/* Tell the user that we could not find a usable */
			/* WinSock DLL.                                  */
			WSACleanup( );
			return false;
		}
		break;
		//case DLL_THREAD_DETACH:
	case DLL_PROCESS_DETACH:
		WSACleanup();
		break;

	}
	return true;
}
//-----------------------------------------------------------------------------
//---------------------------------------------------------------------------

