//-----------------------------------------------------------------------------
// crate controller LTR021
//-----------------------------------------------------------------------------
#ifndef __LTR021api__
#define __LTR021api__
#include "ltr\\include\\ltrapi.h"
#ifdef __cplusplus
extern "C" {
#endif
//  
#define LTR021_OK                     (LTR_OK)    /*  .*/
#define LTR021_ERROR_GET_ARRAY        (-200l)     /*   GET_ARRAY.*/
#define LTR021_ERROR_PUT_ARRAY        (-201l)     /*   PUT_ARRAY.*/
#define LTR021_ERROR_GET_MODULE_NAME  (-202l)     /*   GET_MODULE_NAME.*/
#define LTR021_ERROR_GET_MODULE_GESCR (-203l)     /*   GET_MODULE_DESCRIPTOR.*/
#define LTR021_ERROR_CRATE_TYPE       (-204l)     /*  .*/
//-----------------------------------------------------------------------------
typedef struct
{
    TDESCRIPTION_MODULE     Module;
    TDESCRIPTION_CPU        Cpu;
    TDESCRIPTION_FPGA       Fpga;
    TDESCRIPTION_INTERFACE  Interface;
} TDESCRIPTION_LTR021;
/*
  LTR021
*/
typedef enum 
{
  LTR021_No_Sync=0,
  LTR021_Rising_Start,
  LTR021_Falling_Start,
  LTR021_Rising_Sync,
  LTR021_Falling_Sync
}_LTR021_Sync_Type;

#pragma pack(4)
//
typedef struct
{
    TLTR ltr;
} TLTR021;
#pragma pack()
//-----------------------------------------------------------------------------
EXPORTCALL(INT) LTR021_Init(TLTR021 *module);
EXPORTCALL(INT) LTR021_Open(TLTR021 *module, DWORD saddr, WORD sport, CHAR *csn);
EXPORTCALL(INT) LTR021_Close(TLTR021 *module);
EXPORTCALL(INT) LTR021_GetArray(TLTR021 *module, BYTE *buf, DWORD size, DWORD address);
EXPORTCALL(INT) LTR021_PutArray(TLTR021 *module, BYTE *buf, DWORD size, DWORD address);
EXPORTCALL(INT) LTR021_GetDescription(TLTR021 *module, TDESCRIPTION_LTR021 *description);
EXPORTCALL(INT) LTR021_SetCrateSyncType(TLTR021 *module, DWORD SyncType);
//
EXPORTCALL(LPCSTR) LTR021_GetErrorString(INT error);
#ifdef __cplusplus
}
#endif
#endif

