//---------------------------------------------------------------------------

#ifndef LTRS511API
#define LTRS511API

#ifdef LTRS511API_EXPORTS
#define LTRS511API_DllExport(type)   __declspec(dllexport) type APIENTRY  
#else
#define LTRS511API_DllExport(type)   __declspec(dllimport) type APIENTRY
#endif


#include <d:\\prj\\ltr\\include\\ltrapi.h>
#include <d:\\prj\\ltr\\include\\ltrapitypes.h>
#include <d:\\prj\\ltr\\include\\ltrapidefine.h>


#define TIMEOUT_CMD_SEND   				    (2000)
#define TIMEOUT_CMD_RECIEVE                 (4000)

#define LTR511CMD_KEY1          0x00818000
#define LTR511CMD_KEY2          0x00828000
#define LTR511CMD_RELAY         0x00848000
#define LTR511CMD_READ          0x00038000
#define LTR511_KEYNOM           16

#define LTR511CMD_PERMITWRITEEEPROM	(LTR010CMD_INSTR|0x66)
#define LTR511CMD_BLOCKWRITEEEPROM	(LTR010CMD_INSTR|0x60)
#define LTR511CMD_WRITEEEPROM		(LTR010CMD_INSTR|0x68)
#define LTR511CMD_READEEPROM		(LTR010CMD_INSTR|0x70)
#define LTR511CMD_CLEAREEPROM		(LTR010CMD_INSTR|0x78)
#define LTR511CMD_IO_ROM                 (LTR010CMD|0x60)

#define LTR511_EEPROM_SIZE			2048

//    EEPROM
#define ADR_LTR511_SERIAL                       0
#define ADR_LTR511_SERIAL_FLOOR                 24
#define ADR_LTR511_MODULE_NAME                  48
#define ADR_LTR511_REVISION                     64
#define ADR_LTR511_RELISE                       68
#define ADR_LTR511_FPGA_VER                     70
#define ADR_LTR511_OFFSET                       74
#define ADR_LTR511_AMPL1                        78
#define ADR_LTR511_AMPL2                        82
#define ADR_LTR511_R1                           86
#define ADR_LTR511_R2                           90
#define ADR_LTR511_C                            94
#define ADR_CRC                                 2022 //  34-.
#define WORKING_FLASH_SIZE                      2000 //     CRC


#define MODE1                   1// 
#define MODE2                   6//   
#define MODE3                   7// 
#define MODE4                   2//   600 
#define MODE5                   3//     
#define MODE6                   0//     


#define MID_LTR_NALADKA               0x0101 //    ,        (       )

int MODE_LIST[6]={MODE1,MODE2,MODE3,MODE4,MODE5,MODE6};

#ifndef __cplusplus
#define true 1
#define false 0
	typedef byte bool;
#endif	
#pragma pack(4)

typedef struct{
                char Serial[24];//
      			char SerialFloor[24];//  
				char Name[16];//
                BYTE Rev;//
                BYTE Rel;//
				char FPGA_Version[8];
                float Const_Offset;
                float Ampl1;
                float Ampl2;
                float TestR1;
                float TestR2;
                float OneChannelC[32];
}TLTR511Info;

typedef struct{
        TLTR Channel;
        BYTE KEYS[LTR511_KEYNOM];// .
        BYTE RELAY1;    //       
                        //   .
                        //   
                        //   
                        //"-1,  
        BYTE RELAY2;    //-   
                        //  .
        BYTE RELAY3;    //     
        BYTE RELAY4;    //   2 : 1
        BYTE OVERFLOW1; //     X
        BYTE OVERFLOW2; //     Y
        DWORD REGOUT1;
        DWORD REGOUT2;
        TLTR511Info Info;
}TLTR511, *pTLTR511;
#pragma pack()

#ifdef __cplusplus
extern "C" {
#endif

LTRS511API_DllExport (int) LTR511_CMDSEND(pTLTR511 module,DWORD CMD);
LTRS511API_DllExport (int) LTR511_CMDRECV(pTLTR511 module,DWORD *CMD);
LTRS511API_DllExport (int) LTR511_SETCONFIG(pTLTR511 module);
LTRS511API_DllExport (int) LTR511_GETCONFIG(pTLTR511 module);
LTRS511API_DllExport (int) LTR511_Open(pTLTR511 module, DWORD net_addr, WORD net_port, CHAR *crate_sn,INT slot_num);
LTRS511API_DllExport (int) LTR511_Close(pTLTR511 module);


/****************************************************************************
 
*****************************************************************************/
LTRS511API_DllExport (void)  LTR511_FlashReadRecover(DWORD *FlashCommand, BYTE *ReadBytes);
LTRS511API_DllExport (void)  LTR511_MakeReadFlashCmd(WORD Address, DWORD *FlashCommand);
LTRS511API_DllExport (int)   LTR511_ReadFlash(pTLTR511 module, BYTE *data, WORD size, WORD Address);

LTRS511API_DllExport (void)  LTR511_MakeWriteFlashCmd(WORD Address, BYTE ByteToWrite, DWORD *FlashCommand);
LTRS511API_DllExport (void)  LTR511_MakeEwenFlashCmd(DWORD *FlashCommand);
LTRS511API_DllExport (int)   LTR511_WriteFlash(TLTR511 *module, BYTE *data, WORD size, WORD Address);
LTRS511API_DllExport (int)   LTR511_ReadInfo(pTLTR511 module);
LTRS511API_DllExport (int)   LTR511_WriteInfo(pTLTR511 module);
LTRS511API_DllExport (int)   LTR511_TestEEPROM(TLTR511 *module);
LTRS511API_DllExport (int)   LTR511_DEFInfo(pTLTR511 module);
//---------------------------------------------------------------------------
#ifdef __cplusplus
}
#endif

#endif
