#ifndef __ltrapidefine__
#define __ltrapidefine__
#if defined _MSC_VER
#define EXPORTCALL(type) type  __declspec(dllexport) WINAPI
#else
#if defined __cplusplus
#define EXPORTCALL(type) type WINAPI __declspec(dllexport)
#else
#define EXPORTCALL(type) type WINAPI __declspec(dllexport)
#endif
#endif

//  -
#define LTR010DATA                (0x0000l)
#define LTR010USERDATA            (0x4000l)
#define LTR010CMD                 (0x8000l)
#define LTR010CRATE_CMD           (0xC000l)
#define LTR010_CMD_DATA_MASK      (0xC000l)

#define LTR010CMD_STOP            (LTR010CMD|0x00)
#define LTR010CMD_PROGR           (LTR010CMD|0x40)
#define LTR010CMD_RESET           (LTR010CMD|0x80)
#define LTR010CMD_INSTR           (LTR010CMD|0xC0)
#define LTR010_SLOT_MASK          (0xFl<<8)
//
#define SIGNAL_RBUF_OVF           (0xFFFFFFF0)  //   ->  :    
#define SIGNAL_TSTAMP             (0xFFFFFFF1)  //   ->  :  
//
#define SADDR_LOCAL               ((127l<<24)|(0l<<16)|(0l<<8)|(1l<<0))
#define SADDR_DEFAULT             (SADDR_LOCAL)
#define SPORT_DEFAULT             (11111)
//   -
#define CC_CONTROL                 0            //    c    0,  
#define CC_MODULE1                 1            //    c    1
#define CC_MODULE2                 2            //    c    2
#define CC_MODULE3                 3            //    c    3
#define CC_MODULE4                 4            //    c    4
#define CC_MODULE5                 5            //    c    5
#define CC_MODULE6                 6            //    c    6
#define CC_MODULE7                 7            //    c    7
#define CC_MODULE8                 8            //    c    8
#define CC_MODULE9                 9            //    c    9
#define CC_MODULE10               10            //    c    10
#define CC_MODULE11               11            //    c    11
#define CC_MODULE12               12            //    c    12
#define CC_MODULE13               13            //    c    13
#define CC_MODULE14               14            //    c    14
#define CC_MODULE15               15            //    c    15
#define CC_MODULE16               16            //    c    16
#define CC_USERDATA               18            //        
#define CC_DEBUG_FLAG             0x8000        //   -     
                                                //        .
                                                // ..     .
#define CC_RAW_DATA_FLAG          0x4000        //   -     
                                            	//    USB    
#define CRATE_MAX                 16l           //      
#define MODULE_MAX                16l           //      

#define FLAG_RBUF_OVF             (1<<0)        //    
#define FLAG_RFULL_DATA           (1<<1)        //         LTR_GetCrateRawData
#define FLAG_SIGNAL_TSTAMP        (1<<8)        //    SIGNAL_TSTAMP
//  
#define MID_EMPTY                 0             //  
#define MID_LTR11                 0x0B0B        //   LTR11
#define MID_LTR22                 0x1616        //   LTR22
#define MID_LTR27                 0x1B1B        //   LTR27
#define MID_LTR34                 0x2222        //   LTR34
#define MID_LTR41                 0x2929        //   LTR41
#define MID_LTR42                 0x2A2A        //   LTR42
#define MID_LTR43                 0x2B2B        //   LTR43
#define MID_LTR51                 0x3333        //   LTR51
#define MID_LTR212                0xD4D4        //   LTR212

//  -
#define CONTROL_CRATE_INFO_SIZE                     (3*4)
#define CONTROL_COMMAND_SIZE                        8
#define CONTROL_COMMAND_START                       0xFFFFFFFF
#define CONTROL_COMMAND_INIT_CONNECTION             0xABCDEF00
#define CONTROL_COMMAND_SET_SERVER_PROCESS_PRIORITY 0xABCDEF01
#define CONTROL_COMMAND_GET_CRATE_TYPE              0xABCDEF02
#define CONTROL_COMMAND_PUT_ARRAY                   0xABCDEF80
#define CONTROL_COMMAND_GET_ARRAY                   0xABCDEF81
#define CONTROL_COMMAND_GET_DESCRIPTION             0xABCDEF82
#define CONTROL_COMMAND_BOOT_LOADER_GET_DESCRIPTION 0xABCDEF83
#define CONTROL_COMMAND_BOOT_LOADER_SET_DESCRIPTION 0xABCDEF84
#define CONTROL_COMMAND_GET_CRATES                  0xABCDEF87
#define CONTROL_COMMAND_GET_MODULES                 0xABCDEF88
#define CONTROL_COMMAND_GET_CRATE_RAW_DATA          0xABCDEF89
#define CONTROL_COMMAND_GET_CRATE_RAW_DATA_SIZE     0xABCDEF8A
#define CONTROL_COMMAND_LOAD_FPGA                   0xABCDEF8B

#define CONTROL_COMMAND_START_ALL_CRATE_MODULES     0xABCDEF90

#define CONTROL_COMMAND_BOOT_LOADER_PUT_ARRAY       0xABCDEFFD
#define CONTROL_COMMAND_BOOT_LOADER_GET_ARRAY       0xABCDEFFE
#define CONTROL_COMMAND_CALL_APPLICATION            0xABCDEFFF
#define CONTROL_ACKNOWLEDGE_SIZE                    4
#define CONTROL_ACKNOWLEDGE_MODULE_IN_USE           0xABCDEFDD
#define CONTROL_ACKNOWLEDGE_GOOD                    0xABCDEFEE
#define CONTROL_ACKNOWLEDGE_BAD                     0xABCDEFFF

//    LTR010
#define SEL_AVR_DM                         		0x82000000
#define SEL_AVR_PM                      		0x83000000
#define SEL_DMA_TEST_FLAG          		        0x84000000
#define SEL_FLASH_BUFFER            		    	0x85000000
#define SEL_FPGA_DATA             		        0x86000000
#define SEL_FPGA_FLAGS              	        	0x87000000
#define SEL_FLASH_DSP              	        	0x88000000
#define SEL_FLASH_STATUS              	        	0x89000000
#define SEL_SDRAM	              	        	0x8A000000
#define SEL_SRAM	              	        	0x8B000000
#define SEL_DSP              	        		0x90000000
#define SEL_DSP_SPI              	        	0x91000000
#define SEL_DSP_SPI_BOOT              	        	0x92000000
#define SEL_DSP_MEM              	        	0x93000000



//
#define LTR010_FIRMWARE_SIZE	    			(0x3000)
#define LTR010_BOOT_LOADER_SIZE				(0x1000)
#define LTR010_FIRMWARE_VERSION_ADDRESS         (SEL_AVR_PM|0x2FF0)
#define LTR010_BOOT_LOADER_VERSION_ADDRESS      (SEL_AVR_PM|0x3FF0)
#define LTR010_MODULE_DESCRIPTOR_ADDRESS        (SEL_AVR_PM|0x3000)
#define LTR010_FIRMWARE_START_ADDRESS           (SEL_AVR_PM|0x0000)
#define LTR010_BOOT_LOADER_START_ADDRESS        (SEL_AVR_PM|0x3C00)
//
#define EP1K100_SIZE                            (164*1024+100)
#define EP1K50_SIZE                             ( 96*1024+100)
#define EP1K30_SIZE                             ( 58*1024+100)
#define EP1K10_SIZE                             ( 22*1024+100)
#define FPGA_INFO_SIZE                          250
#define NAME_SIZE                               16
#define SERIAL_NUMBER_SIZE                      16
#endif
