// Example LTR.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "ltr\\include\\ltrapi.h"
#include "ltr\\include\\ltrapidefine.h"


void ModuleOpenAndWork(void * Args)
{	
	INT res = LTR_OK;
	//      ltr-   

	TLTR ltr=*(TLTR *)Args;	
	//         
	//    
	ltr.cc=CC_CONTROL;
	//  
	res=LTR_Open(&ltr);
	int ThreadNumber=(int)ltr.internal;
	if(res==LTR_OK) 
	{
		WORD mid[MODULE_MAX];
		//    
		res=LTR_GetCrateModules(&ltr, mid);
		if(res==LTR_OK) 
		{
			printf(">> NumberInstalled Modules for threadNumber %d :\n", ThreadNumber);
			for(int i=0; i<MODULE_MAX; i++)
				printf(">> slot%0.2d  mid=%d  >> threadNumber %d \n", i+1, mid[i]&0xFF, ThreadNumber);
		}
		//   
		LTR_Close(&ltr);
	} 

	if(res!=LTR_OK) printf("Module Number %d , invoke error %s\n", ThreadNumber, LTR_GetErrorString(res));
}

int _tmain(int argc, _TCHAR* argv[])
{
	const int NUM_MODULE=3;

	INT res;
	TLTR ltr[NUM_MODULE];
	HANDLE ThreadHandle[NUM_MODULE];

	//       
	for (int i=0;i<NUM_MODULE;i++)
	{
		res=LTR_Init(&ltr[i]);		
		if(res==LTR_OK) 
		{
			ThreadHandle[i] = CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)ModuleOpenAndWork,&ltr[i],0,NULL);			
		}
	}

	for (int i=0;i<NUM_MODULE;i++)
	{
		while (WaitForSingleObject(ThreadHandle[i],100)==WAIT_TIMEOUT);		
		CloseHandle(ThreadHandle[i]);
	}


	//    
	if(res!=LTR_OK) printf(">> %s\n", LTR_GetErrorString(res));

	while (true) Sleep(100);
	return 0;
}

