/*
 * crate controller LTR030/LTR031
 */
#ifndef LTR030API_H_
#define LTR030API_H_

#include "ltr/include/ltrapi.h"

#ifdef __cplusplus
extern "C" {
#endif


/*================================================================================================*/
/*   */
#define LTR030_OK                     (LTR_OK)   /*   . */
#define LTR030_ERROR_GET_ARRAY        (-30000L)  /*    GET_ARRAY. */
#define LTR030_ERROR_PUT_ARRAY        (-30001L)  /*    PUT_ARRAY. */
#define LTR030_ERROR_GET_MODULE_NAME  (-30002L)  /*    GET_MODULE_NAME. */
#define LTR030_ERROR_GET_MODULE_GESCR (-30003L)  /*   
                                                  * GET_MODULE_DESCRIPTOR.
                                                  */
#define LTR030_ERROR_CRATE_TYPE       (-30004L)  /*   . */


#ifdef LTR030API_EXPORTS
  #define LTR030API_DllExport(type) __declspec(dllexport) type APIENTRY
#else
  #define LTR030API_DllExport(type) __declspec(dllimport) type APIENTRY
#endif
/*================================================================================================*/

/*================================================================================================*/
typedef struct
    {
    TDESCRIPTION_MODULE Module;
    TDESCRIPTION_CPU Cpu;
    TDESCRIPTION_FPGA Fpga;
    TDESCRIPTION_INTERFACE Interface;
    } TDESCRIPTION_LTR030, *PTDESCRIPTION_LTR030;
/*   LTR030 */
typedef enum 
    {
    e_LTR030Sync_No = 0,
    e_LTR030Sync_Rising_Start,
    e_LTR030Sync_Falling_Start,
    e_LTR030Sync_Rising,
    e_LTR030Sync_Falling
    } t_LTR021_Sync_Type;

#pragma pack(4)

typedef struct
    {
    TLTR ltr;
    } TLTR030, *PTLTR030;
#pragma pack()
/*================================================================================================*/

/*================================================================================================*/
LTR030API_DllExport( INT ) LTR030_Init(PTLTR030 module);
LTR030API_DllExport( INT ) LTR030_Open(PTLTR030 module, DWORD saddr, WORD sport, CHAR *csn);
LTR030API_DllExport( INT ) LTR030_Close(PTLTR030 module);
LTR030API_DllExport( INT ) LTR030_PutArray(PTLTR030 module, BYTE *buf, DWORD size, DWORD address);
LTR030API_DllExport( INT ) LTR030_GetDescription(PTLTR030 module, PTDESCRIPTION_LTR030 description);
LTR030API_DllExport( LPCSTR ) LTR030_GetErrorString(INT error);
/*================================================================================================*/

#ifdef __cplusplus
}
#endif
#endif /*#ifndef LTR030API_H_*/

