#ifndef __LTR27API__
#define __LTR27API__
// 
#define LTR27_ERROR_SEND_DATA      (-3000)
#define LTR27_ERROR_RECV_DATA      (-3001)
#define LTR27_ERROR_RESET_MODULE   (-3002)
#define LTR27_ERROR_NOT_LTR27      (-3003)
#define LTR27_ERROR_PARITY         (-3004)
#define LTR27_ERROR_OVERFLOW       (-3005)
#define LTR27_ERROR_INDEX          (-3006)
//
#define LTR27_ERROR                (-3007)
#define LTR27_ERROR_EXCHANGE       (-3008)
#define LTR27_ERROR_FORMAT         (-3008)
#define LTR27_ERROR_CRC            (-3010)
//
#ifdef __cplusplus
extern "C" {
#endif
#pragma pack(4)
//
typedef LPVOID TLTR_HANDLE;
//  
typedef struct
{
 BYTE  Name[16];              // "LTR27"
 BYTE  SerialNumber[16];      // "1L123456"
 BYTE  Revision;              // 'C'
 BYTE  FirmwareVersion[16];   // "v1.0.1.0"
 //
 DOUBLE InputDataRateMax;     //    ( )
 DOUBLE InputDataRateMin;     //
 DOUBLE OutputDataRateMax;    //
 DOUBLE OutputDataRateMin;    //
} TLTR_MODULE_INFO;
//
typedef struct
{
 DOUBLE InputDataRate;        //    ( )
 DOUBLE OutputDataRate;       //
 DWORD  InputDataSize;        //    
 DWORD  OutputDataSize;       //
} TLTR_TEST_MODE;
#pragma pack()
// 
INT LTR27Test_Open         (TLTR_HANDLE *hnd, UINT32 net_addr, UINT16 net_port, CHAR *crate_serial, UINT channel_mode);
INT LTR27Test_Close        (TLTR_HANDLE *hnd);
INT LTR27Test_GetModuleInfo(TLTR_HANDLE hnd, TLTR_MODULE_INFO *info);
//
INT LTR27Test_Start        (TLTR_HANDLE hnd, TLTR_TEST_MODE *mode);
INT LTR27Test_Stop         (TLTR_HANDLE hnd);
INT LTR27Test_Execute      (TLTR_HANDLE hnd, UINT32 *data_in, UINT32 *data_out);
//   
LPCSTR LTR27Test_GetErrorString(INT error);
//
#ifdef __cplusplus
}
#endif
#endif


