#ifndef __ltrapitypes__
#define __ltrapitypes__
#include <windows.h>
#ifdef __cplusplus
extern "C" {
#endif
//
#ifndef COMMENT_LENGTH
#define COMMENT_LENGTH 256
#endif
#ifndef ADC_CALIBRATION_NUMBER
#define ADC_CALIBRATION_NUMBER 256
#endif
#ifndef DAC_CALIBRATION_NUMBER
#define DAC_CALIBRATION_NUMBER 256
#endif
//
#pragma pack(4)

//  
#define CRATE_TYPE_UNKNOWN       0
#define CRATE_TYPE_LTR010       10
#define CRATE_TYPE_LTR021       21
#define CRATE_TYPE_LTR030       30
#define CRATE_TYPE_LTR031       31
#define CRATE_TYPE_BOOTLOADER   99

#define CRATE_IFACE_UNKNOWN     0
#define CRATE_IFACE_USB         1
#define CRATE_IFACE_TCPIP       2

typedef struct
{
 BYTE CrateType;                                           //  
 BYTE CrateInterface;                                      //   
} TCRATE_INFO;

//  
typedef struct _DESCRIPTION_MODULE_                        //
{                                                          //
  BYTE   CompanyName[16];                                  //
  BYTE   DeviceName[16];                                   //  
  BYTE   SerialNumber[16];                                 //   
  BYTE   Revision;                                         //  
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_MODULE;                                     //
//     
typedef struct _DESCRIPTION_CPU_                           //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         // 
  double ClockRate;                                        //
  DWORD  FirmwareVersion;                                  //
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_CPU;                                        //
//  
typedef struct _DESCRIPTION_FPGA_                          //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         // 
  double ClockRate;                                        //
  DWORD  FirmwareVersion;                                  //
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_FPGA;                                       //
//  
typedef struct _DESCRIPTION_ADC_                           //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         // 
  double Calibration[ADC_CALIBRATION_NUMBER];              //  
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_ADC;                                        //
//  
typedef struct _DESCRIPTION_DAC_                           //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         // 
  double Calibration[DAC_CALIBRATION_NUMBER];              //  
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_DAC;                                        //
//  h-
typedef struct _DESCRIPTION_MEZZANINE_                     //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         //  
  BYTE   SerialNumber[16];                                 //   
  BYTE   Revision;                                         //  
  double Calibration[4];                                   //  
  BYTE   Comment[COMMENT_LENGTH];                          // 
} TDESCRIPTION_MEZZANINE;                                   //
//   
typedef struct _DESCRIPTION_DIGITAL_IO_                    //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         //  ???????
  WORD   InChannels;                                       //  
  WORD   OutChannels;                                      //  
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_DIGITAL_IO;                                 //
//   
typedef struct _DESCRIPTION_INTERFACE_                     //
{                                                          //
  BYTE   Active;                                           //     
  BYTE   Name[16];                                         // 
  BYTE   Comment[COMMENT_LENGTH];                          //
} TDESCRIPTION_INTERFACE;                                  //
#pragma pack()
//
#ifdef __cplusplus
}
#endif
#endif
