#include "LtrClient.h"
#include "LtrServiceClients.h"

void __fastcall AcknowledgeCommand(SOCKET socket, DWORD Ackq)
    {
    send(socket, (BYTE*)&Ackq, CONTROL_ACKNOWLEDGE_SIZE, 0);
    }

//-----------------------------------------------------------------------------
__fastcall TLTRServiceClient::TLTRServiceClient(bool CreateSuspended) : TThread(CreateSuspended)
    {
    Priority=tpNormal;
    FreeOnTerminate=false;
    server=INVALID_SOCKET;
    init_complete=CreateEvent(NULL, FALSE, FALSE, NULL);
    }
//-----------------------------------------------------------------------------
__fastcall TLTRServiceClient::~TLTRServiceClient(void)
    {
    CloseHandle(init_complete);
    }
//-----------------------------------------------------------------------------
void __fastcall TLTRServiceClient::Execute()
    {
    g_Log.Write("LTRServiceClient thread started.", LOGTASK_CLIENT_CTL, LOGL_VERBOSE);

    //     
    char hostname[128];
    if (!gethostname(hostname, sizeof(hostname)))
        {
        AnsiString str = hostname;
        struct addrinfo *ai_list, hint;
        ZeroMemory(&hint, sizeof(hint));
        hint.ai_family = AF_INET;
        if (!getaddrinfo(hostname, NULL, &hint, &ai_list))
            {
            for (struct addrinfo *iter = ai_list; iter; iter = iter->ai_next)
                {
                if (iter->ai_addr->sa_family == AF_INET)
                    {
                    if (((sockaddr_in*)iter->ai_addr)->sin_addr.s_addr != 0x0100007F)
                        str += Format(" [%u.%u.%u.%u]", ARRAYOFCONST((
                            ((sockaddr_in*)iter->ai_addr)->sin_addr.S_un.S_un_b.s_b1,
                            ((sockaddr_in*)iter->ai_addr)->sin_addr.S_un.S_un_b.s_b2,
                            ((sockaddr_in*)iter->ai_addr)->sin_addr.S_un.S_un_b.s_b3,
                            ((sockaddr_in*)iter->ai_addr)->sin_addr.S_un.S_un_b.s_b4
                            )));
                    }
                }
            freeaddrinfo(ai_list);
            }
        g_Log.Write("Server: " + str, LOGTASK_CLIENT_INIT, LOGL_VERBOSE);
        }

    //  
    server = WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0, WSA_FLAG_OVERLAPPED);
    if (server != INVALID_SOCKET)
        {
        sockaddr_in server_addr;
        sockaddr peer_addr;
        server_addr.sin_family = AF_INET;
        server_addr.sin_port = htons(LTR_CLIENT_PORT);
        server_addr.sin_addr.s_addr = INADDR_ANY;
        peer_addr.sa_family = AF_INET;
        int peer_addr_len = sizeof(peer_addr);
        if (!bind(server, (sockaddr*)&server_addr, sizeof(server_addr)))
            {
            if (!listen(server, 16))
                {
                //   
                SetEvent(init_complete);
                while (!Terminated)
                    {
                    SOCKET s = WSAAccept(server, &peer_addr, &peer_addr_len, NULL, NULL);
                    if ((s != SOCKET_ERROR) && (!Terminated))
                        {
                        DWORD peer_ip = (peer_addr.sa_family == AF_INET) ?
                            ((sockaddr_in*)&peer_addr)->sin_addr.s_addr : INADDR_NONE;
                        AnsiString peer_str = IPToStr(peer_ip);

                        bool ack_flag = false;
                        DWORD Module_Already_Opened = 0;
                        // request[] = cmd[8] + csn[16] + cc[2] + tmark[4]
                        BYTE request[CONTROL_COMMAND_SIZE+16+2+4];
                        DWORD sz=recv(s, request, sizeof(request), 0);
                        if (sz==sizeof(request) &&
                            *(DWORD*)(request+0)==CONTROL_COMMAND_START &&
                            *(DWORD*)(request+4)==CONTROL_COMMAND_INIT_CONNECTION)
                            {
                            WORD Client_flags = (*(WORD*)(request+CONTROL_COMMAND_SIZE+16))&0xFF00;
                            WORD Crate_Channel = (*(WORD*)(request+CONTROL_COMMAND_SIZE+16))&0x00FF; //   

                            if ((Crate_Channel == CC_CONTROL) || (Crate_Channel == 1 + MODULE_INDEX_USER)
                                || ((Crate_Channel > 0) && (Crate_Channel <= MODULE_MAX)))
                                {
                                if (WaitForSingleObject(client_list_access, INFINITE)==WAIT_OBJECT_0)
                                    {
                                    //   
                                    //      
                                    int client_index = CLIENT_MAX;
                                    for (int i = 0; i < CLIENT_MAX; i++)
                                        {
                                        if (client_list[i] == NULL)
                                            {
                                            client_index = i;
                                            }
                                        else if ((client_list[i]->socket == SOCKET_ERROR) ||
                                            (!client_list[i]->IsAlive))
                                            {
                                            g_Log.Write(Format("Connection stopped for client " +
                                                client_list[i]->peer_addr_str + ": CSN=%.16s  CC=%0.4X",
                                                ARRAYOFCONST(((char*)client_list[i]->crate->csn, (int)client_list[i]->crate_channel))),
                                                LOGTASK_CLIENT_CTL, LOGL_INFO);
                                            delete client_list[i];
                                            client_list[i]=NULL;
                                            client_index=i;
                                            }
                                        else if ((Crate_Channel != CC_CONTROL) &&
                                                    (client_list[i]->crate_channel == Crate_Channel) &&
                                                    (!memcmp(request+CONTROL_COMMAND_SIZE, client_list[i]->crate->csn, 16)))
                                            { //         ,    
                                            Module_Already_Opened++;
                                            }
                                        }
                                    //   
                                    if (client_index < CLIENT_MAX)
                                        {
                                        if (WaitForSingleObject(crate_list_access, INFINITE) == WAIT_OBJECT_0)
                                            {
                                            int crate_index;
                                            for (crate_index = 0; crate_index < CRATE_MAX; crate_index++)
                                                {
                                                if ((crate_list[crate_index]->GetState() == CRATE_ST_ONLINE) &&
                                                    //         
                                                    (request[CONTROL_COMMAND_SIZE]==0 || !memcmp(request+CONTROL_COMMAND_SIZE, crate_list[crate_index]->csn, 16)))
                                                    {
                                                    if (Crate_Channel != CC_CONTROL)
                                                        {
                                                        //     
                                                        if (crate_list[crate_index]->module[Crate_Channel-1].ModulePresence) break;
                                                        }
                                                    else break;
                                                    }
                                                }

                                            if ((crate_index<CRATE_MAX) &&
                                                (
                                                (!(crate_list[crate_index]->sflags & CRATE_FLAG_BOOT_LOADER))
                                                ||
                                                (Crate_Channel == CC_CONTROL)
                                                ))
                                                {
                                                TCrate *crate = crate_list[crate_index];
                                                //    
                                                memcpy(request + CONTROL_COMMAND_SIZE, crate->csn, 16);
                                                //    
                                                DWORD tmark = ((crate->start_mark_counter & 0xFFFF) << 16)|
                                                    (crate->second_mark_counter & 0xFFFF);
                                                *(DWORD*)(request+CONTROL_COMMAND_SIZE + 16 + 2) = tmark;

                                                //          -  
                                                //   
                                                if (!Module_Already_Opened)
                                                    {
                                                    AcknowledgeCommand(s, CONTROL_ACKNOWLEDGE_GOOD);
                                                    }
                                                else
                                                    {//   
                                                    AcknowledgeCommand(s, CONTROL_ACKNOWLEDGE_MODULE_IN_USE);
                                                    g_Log.Write(Format("Warning ! Module in slot %d already opened %d times",
                                                        ARRAYOFCONST(((int)Crate_Channel, (int)Module_Already_Opened))),
                                                        LOGTASK_CLIENT_INIT, LOGL_WARNING);
                                                    }

                                                send(s, request, sizeof(request), 0); // != sizeof(request);

                                                client_list[client_index] = new TClient(s, peer_ip, crate_list[crate_index], Crate_Channel, Client_flags);
                                                g_Log.Write(Format("Connection started for client " + peer_str + ": CSN=%.16s  CC=%0.4X",
                                                    ARRAYOFCONST(((char*)(request + CONTROL_COMMAND_SIZE),
                                                                  (int)(*(WORD*)(request + CONTROL_COMMAND_SIZE + 16))))),
                                                    LOGTASK_CLIENT_INIT, LOGL_INFO);
                                                ack_flag = true;
                                                }
                                            else
                                                {
                                                g_Log.Write(Format("Connection refused for client " + peer_str + ": CSN=%.16s  CC=%0.4X",
                                                    ARRAYOFCONST(((char*)(request + CONTROL_COMMAND_SIZE),
                                                                  (int)(*(WORD*)(request + CONTROL_COMMAND_SIZE + 16))))),
                                                    LOGTASK_CLIENT_INIT, LOGL_ERROR);
                                                }
                                            ReleaseMutex(crate_list_access);
                                            }
                                        else g_Log.Write("Connection refused for client " + peer_str + ": cannot access crate list.",
                                            LOGTASK_CLIENT_INIT, LOGL_ERROR);
                                        } /* if (client_index < CLIENT_MAX) */
                                    else g_Log.Write("Connection refused for client " + peer_str + ": no empty slot for client.",
                                        LOGTASK_CLIENT_INIT, LOGL_ERROR);
                                    ReleaseMutex(client_list_access);
                                    } /* mutex */
                                else g_Log.Write("Connection refused for client " + peer_str + ": cannot access client list.",
                                    LOGTASK_CLIENT_INIT, LOGL_ERROR);
                                } /* channel */
                            else g_Log.Write("Connection refused for client " + peer_str + ": invalid channel number.",
                                LOGTASK_CLIENT_INIT, LOGL_ERROR);
                            } /* request valid */
                        else g_Log.Write("Connection refused for client " + peer_str + ": error in request format.",
                            LOGTASK_CLIENT_INIT, LOGL_ERROR);

                        if (!ack_flag)
                            {
                            AcknowledgeCommand(s, CONTROL_ACKNOWLEDGE_BAD);
                            shutdown(s,SD_BOTH);
                            closesocket(s);
                            }
                        }
                    else
                        {
                        int error = WSAGetLastError();
                         /*   , accept()   WSAEINTR,   */
                        if (error != WSAEINTR)
                            g_Log.Write(Format("accept() returned error %d", ARRAYOFCONST((error))),
                                LOGTASK_CLIENT_INIT, LOGL_ERROR);
                        }
                    } /* while (!Terminated) */
                }
            else g_Log.Write(Format("Cannot listen for clients (%d)", ARRAYOFCONST(((int)WSAGetLastError()))),
                 LOGTASK_CLIENT_INIT, LOGL_ERROR);
            }
        else g_Log.Write(Format("Cannot bind server socket (%d)", ARRAYOFCONST(((int)WSAGetLastError()))),
             LOGTASK_CLIENT_INIT, LOGL_ERROR);
        closesocket(server);
        }
    else g_Log.Write(Format("Cannot create server socket (%d)", ARRAYOFCONST(((int)WSAGetLastError()))),
         LOGTASK_CLIENT_INIT, LOGL_ERROR);

    g_Log.Write("LTRServiceClient thread begin stopping.", LOGTASK_CLIENT_CTL, LOGL_DEBUG1);

    //   
    if(WaitForSingleObject(client_list_access, INFINITE)==WAIT_OBJECT_0)
    {
        for(int i=0; i<CLIENT_MAX; i++)
        {
            if(client_list[i]!=NULL)
            {
                client_list[i]->IsAlive=false;
            };
        };

        for(int i=0; i<CLIENT_MAX; i++)
        {
            if (client_list[i]!=NULL)
            {
                g_Log.Write(Format("Connection stopped for client " +
                    client_list[i]->peer_addr_str + ": CSN=%.16s  CC=%0.4X",
                    ARRAYOFCONST(((char*)client_list[i]->crate->csn, (int)client_list[i]->crate_channel))),
                    LOGTASK_CLIENT_CTL, LOGL_INFO);
                delete client_list[i];
                client_list[i]=NULL;
            };
        };
        ReleaseMutex(client_list_access);
    } else g_Log.Write("Cannot access client list.", LOGTASK_CLIENT_CTL, LOGL_ERROR);
    g_Log.Write("LTRServiceClient thread stopped.", LOGTASK_CLIENT_CTL, LOGL_VERBOSE);
    SetEvent(init_complete);
}
//-----------------------------------------------------------------------------
