#ifndef LtrServiceCratesH
#define LtrServiceCratesH
#include "common.h"
#include "addrlist.h"

//---------------------------------------------------------------------------
class TLTRAutoDiscovery
    {
    private:
        bool working;
        SOCKET udp_socket;
        UCHAR signature[16];
        UCHAR recv_buf[16];
        struct bufctl
            {
            unsigned int failcount;
            DWORD flags;
            WSABUF buf;
            WSAOVERLAPPED overlap;
            }
            request, reply;
        struct timerctl
            {
            HANDLE handle;
            LARGE_INTEGER interval;
            }
            send_timer;
        sockaddr_in bcast_addr;
        sockaddr peer_addr;
        int peer_addr_size;

        void do_Send();
        void do_Receive();
    public:
        TLTRAutoDiscovery();
        ~TLTRAutoDiscovery();
        void Start();
        void Stop();
        bool Worker(DWORD *pPeerIP);
    };
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TLTRServiceCrate : public TThread
{
 private:
    TLTRAutoDiscovery AutoDiscovery;

    void __fastcall StopServiceForDeadCrates(void);
    void __fastcall ScanUSBCrates(void);
    void __fastcall ConnectCrateByIP(DWORD dwIP);
    void __fastcall DisconnectCrateByIP(DWORD dwIP);
    void __fastcall ConnectAllIPCratesByType(int IPListType);
    void __fastcall DisconnectAllIPCratesByType(int IPListType);
 protected:
    void __fastcall Execute();
 public:
    T_MessageQueue * MessageQueueIn;
    T_MessageQueue * MessageQueueDisplay;
    HANDLE init_complete;
    void __fastcall SuspendCrates();
    void __fastcall ResumeCrates();
    __fastcall TLTRServiceCrate(bool CreateSuspended);
    __fastcall ~TLTRServiceCrate(void);
};
//---------------------------------------------------------------------------
#endif
