//$$---- Form CPP ----
//---------------------------------------------------------------------------

#include <vcl.h>
#include <stdio.h>
#pragma hdrstop
#include "Unit1.h"
#include "DialogAddIP.h"
#include "CenterMsgBox.h"
#include "stringres.h"
#include <dbt.h>
#include <devguid.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFormMAIN *FormMAIN;

/*   StringGridIPCrates */
enum
    {
    EGRID_COL_NUMBER = 0,
    EGRID_COL_IPAUTO,
    EGRID_COL_IPTYPE,
    EGRID_COL_IPADDR,
    EGRID_COL_STATUS,
    EGRID_COL_SERIAL
    };

/*  */
static const struct
    {
    LCID lcid;
    const char *ConfigStr;      /*    ini- */
    }
    LanguageInfo[] =
    {
    { 0, "auto" },
    { MAKELCID(MAKELANGID(LANG_ENGLISH, SUBLANG_ENGLISH_US), SORT_DEFAULT), "en" },
    { MAKELCID(MAKELANGID(LANG_RUSSIAN, SUBLANG_DEFAULT), SORT_DEFAULT), "ru" }
    };

/*      INI- */
const char INI_SEC_CONFIG[]         = "LTR_SERVER_CONFIG";
const char INI_SEC_LTR_DEFAULT[]    = "LTR010_DEFAULT";
const char INI_SEC_IP_CRATES[]      = "LTR_IP_CRATES";
const char INI_SEC_LOG[]            = "LOG_SETTINGS";
const char INI_SEC_VISUAL[]         = "WINDOW_STATE";

const char INI_KEY_PRIORITY[]       = "server_priority";
const char INI_KEY_MINIMIZE2TRAY[]  = "minimize_to_tray";
const char INI_KEY_STARTMINIMIZED[] = "start_minimized";
const char INI_KEY_AUTOCONNECT[]    = "autoconnect_dynamic";
const char INI_KEY_AUTODISCOVER[]   = "enable_discovery";
const char INI_KEY_FPGA_TTF[]       = "fpga_ttf";
const char INI_KEY_LOGNAME[]        = "logfile";
const char INI_KEY_LOGLEVEL[]       = "loglevel";
const char INI_KEY_LANG[]           = "language";
const char INI_KEY_ACTIVE_TAB[]     = "active_tab";
const char INI_KEY_MAXIMIZED[]      = "maximized";
const char INI_KEY_PLACEMENT[]      = "placement";

/*      StringGridIPCrates */
AnsiString SC_STAT_OFFLINE;
AnsiString SC_STAT_CONNECTING;
AnsiString SC_STAT_ONLINE;
AnsiString SC_STAT_ERROR;
AnsiString SC_TYPE_STATIC;
AnsiString SC_TYPE_DYNAMIC;
AnsiString SC_Tooltip_Auto;
AnsiString SC_Tooltip_Status;
AnsiString SC_Tooltip_Type[2];
const AnsiString SC_AUTO_ON = "a"; /*    Marlett */
const AnsiString SC_AUTO_OFF = "";

//---------------------------------------------------------------------------
#define SENDER(var, type)   \
    type* var = dynamic_cast<type*>(Sender); \
    if (!var) return;
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
__fastcall TFormMAIN::TFormMAIN(TComponent* Owner): TForm(Owner)
    {
    log_list->Clear();
    Statistic->Clear();
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::StringGridIPCratesDrawCell(TObject *Sender, int ACol, int ARow,
      TRect &Rect, TGridDrawState State)
    {
    SENDER(Grid, TStringGrid);
    AnsiString Value = Grid->Cells[ACol][ARow];
    RECT TextRect = static_cast<RECT>(Rect);
    unsigned int align = DT_LEFT;

    switch (ACol)
        {
        case EGRID_COL_NUMBER:
            align = DT_CENTER;
            break;
        case EGRID_COL_IPAUTO:
            align = DT_CENTER;
            if (ARow > 0)
                {
                Grid->Canvas->Font->Name = "Marlett";
                Grid->Canvas->Font->Height *= 2;
                }
            break;
        }
    Grid->Canvas->FillRect(Rect);
    InflateRect(&TextRect, -2, -2);
    DrawText(Grid->Canvas->Handle, Value.c_str(), Value.Length(), &TextRect,
        DT_SINGLELINE | DT_VCENTER | align);
    }

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::Dispatch(void *_msg)
    {
    TMessage *msg = (TMessage*)_msg;
    switch (msg->Msg)
        {
        case WM_DEVICECHANGE:
            /*     USB  */
            switch (msg->WParam)
                {
                /*        
                    DBT_DEVNODES_CHANGED    
                   (DBT_DEVICEARRIVAL  DBT_DEVICEREMOVECOMPLETE).    .
                         - .
                 */
                case DBT_DEVNODES_CHANGED:
                case DBT_DEVICEARRIVAL:
                case DBT_DEVICEREMOVECOMPLETE:
                    if (ltrservicecrate)
                        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_device_changed);
                    break;
                }
            break;
        case WM_SYSCOMMAND :
            switch (msg->WParam)
                {
                case SC_MINIMIZE :
                    Application->Minimize();
                    if (MenuSettingsMinimizeToTray->Checked)
                        ShowWindow(Application->Handle, SW_HIDE);
                    break;
                }
            break;
        case WM_POWERBROADCAST :
            if (ltrservicecrate)
                {
                switch (msg->WParam)
                    {
                    case PBT_APMSUSPEND:
                    case PBT_APMQUERYSUSPEND:
                        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_suspend);
                        break;
                    case PBT_APMRESUMEAUTOMATIC:
                    case PBT_APMRESUMECRITICAL:
                    case PBT_APMRESUMESUSPEND:
                        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_resume_suspend);
                        break;
                    }
                }
            break;
        }
    TForm::Dispatch(_msg);
    }

//---------------------------------------------------------------------------
__fastcall TUpdateInfoThread::TUpdateInfoThread(void * ThisParentInstance):TThread(false)
    {
    ParentInstance = ThisParentInstance;
    memset(statistic_csn, 0, sizeof(statistic_csn));
    statistic_slot = 0;
    statistic_reset = true;
    }

__fastcall TUpdateInfoThread::~TUpdateInfoThread(void)
    {

    }

void __fastcall TUpdateInfoThread::Execute(void)
    {
    TFormMAIN * MainForm = (TFormMAIN *)ParentInstance;
    T_Message CurrMessage;
    TFormatSettings LocaleFormatSettings;

    AnsiString SC_CRATE_TITLE_FORMAT = "CSN <%.16s> - %s";
    AnsiString SC_empty = LoadStr(IDS_empty);
    AnsiString SC_Initialization = LoadStr(IDS_Initialization);
    AnsiString SC_unknown_interface = LoadStr(IDS_unknown_interface);
    AnsiString SC_Unknown_Crate = LoadStr(IDS_Unknown_Crate);
    AnsiString SC_boot_loader = LoadStr(IDS_boot_loader);
    AnsiString SC_state_error = LoadStr(IDS_state_error);
    AnsiString SC_state_ok = LoadStr(IDS_state_ok);
    AnsiString SC_Bad_Module_Name = LoadStr(IDS_Bad_Module_Name);

    AnsiString SC_Crate_statistics_for = LoadStr(IDS_Crate_statistics_for);
    AnsiString SC_Crate_serial_number = LoadStr(IDS_Crate_serial_number);
    AnsiString SC_Interface = LoadStr(IDS_Interface);
    AnsiString SC_Connected = LoadStr(IDS_Connected);
    AnsiString SC_Total_sent_words = LoadStr(IDS_Total_sent_words);
    AnsiString SC_Total_recv_words = LoadStr(IDS_Total_recv_words);
    AnsiString SC_Data_input_speed = LoadStr(IDS_Data_input_speed);
    AnsiString SC_Data_output_speed = LoadStr(IDS_Data_output_speed);
    AnsiString SC_words_per_second = LoadStr(IDS_words_per_second);
    AnsiString SC_Start_marks_received = LoadStr(IDS_Start_marks_received);
    AnsiString SC_Second_marks_received = LoadStr(IDS_Second_marks_received);
    AnsiString SC_Statistics_for_slot = LoadStr(IDS_Statistics_for_slot);
    AnsiString SC_Status = LoadStr(IDS_Status);
    AnsiString SC_No_module = LoadStr(IDS_No_module);
    AnsiString SC_Identifying_module = LoadStr(IDS_Identifying_module);
    AnsiString SC_Contains_module = LoadStr(IDS_Contains_module);
    AnsiString SC_Num_sent_words = LoadStr(IDS_Num_sent_words);
    AnsiString SC_Num_recv_words = LoadStr(IDS_Num_recv_words);
    AnsiString SC_Server_buffer_util = LoadStr(IDS_Server_buffer_util);
    AnsiString SC_Connected_clients = LoadStr(IDS_Connected_clients);
    AnsiString SC_Hardware_FIFO_state = LoadStr(IDS_Hardware_FIFO_state);
//    AnsiString SC_ = LoadStr(IDS_);
//    AnsiString SC_ = LoadStr(IDS_);

    /*   /,      */
    LCID lcid = GetThreadLocale();
    GetLocaleFormatSettings(lcid, LocaleFormatSettings);
    switch (PRIMARYLANGID(LANGIDFROMLCID(lcid)))
        {
        case LANG_RUSSIAN:
            LocaleFormatSettings.ShortDateFormat = "dd.MM.yyyy";
            break;
        case LANG_ENGLISH:
            LocaleFormatSettings.ShortDateFormat = "MMM dd, yyyy";
            break;
        }
    /*    -, AM/PM -   */
    LocaleFormatSettings.LongTimeFormat = "hh:mm:ss";

    /*   */
    while (!Terminated)
        {
        if (MainForm->MessageQueueDisplay->PopMessage(&CurrMessage, 500))
            {
                //   
            if (CurrMessage.dwMessage == LTR_DISP_crate_list_updated)
                {
                if (WaitForSingleObject(crate_list_access, 500)==WAIT_OBJECT_0)
                    {
                    int k=0, l=0;
                    MainForm->CrateTree->Items->BeginUpdate();
                    MainForm->CrateTree->Items->Clear();
                    for (int i = 0; i < CRATE_MAX; i++)
                        {
                        if (crate_list[i]->GetState() != CRATE_ST_ONLINE)
                            continue;

                        TCrate *crate=crate_list[i];
                        TTreeNode *node;
                        if (crate->sflags&CRATE_FLAG_BOOT_LOADER)
                            {
                            node=MainForm->CrateTree->Items->Add(NULL,
                                Format(SC_CRATE_TITLE_FORMAT, ARRAYOFCONST((crate->csn, SC_boot_loader))));
                            }
                        else
                            {
                            if (crate->sflags&CRATE_FLAG_HW_ERROR)
                                {
                                node=MainForm->CrateTree->Items->Add(NULL,
                                    Format(SC_CRATE_TITLE_FORMAT, ARRAYOFCONST((crate->csn, SC_state_error))));
                                }
                            else node=MainForm->CrateTree->Items->Add(NULL,
                                Format(SC_CRATE_TITLE_FORMAT, ARRAYOFCONST((crate->csn, SC_state_ok))));

                            for (int j = 0; j < MODULE_MAX; j++)
                                {
                                WORD mid=crate->module[j].mid;
                                AnsiString astr=Format("<slot%0.2d%s> - ", ARRAYOFCONST((j+1, (crate->baud_rate&(1<<j)) ? "+" : " ")));

                                if (mid == NULL)
                                    {
                                    astr += SC_empty;
                                    }
                                else if (mid == 0xFFFF)
                                    {
                                    astr += SC_Initialization;
                                    }
                                else
                                    {
                                    if ((mid & 0xFF) != ((mid >> 8) & 0xFF))
                                        astr += SC_Bad_Module_Name;
                                    else
                                        astr += Format("mid = %d ", ARRAYOFCONST(((int)mid & 0xFF)));
                                    }
                                MainForm->CrateTree->Items->AddChild(node, astr);
                                }
                            }
                        node->Expand(true);

                        if (crate->sflags & CRATE_FLAG_HW_ERROR)
                            k++;
                        l++;
                        } /* for i */
                    MainForm->CrateTree->Items->EndUpdate();
                    MainForm->TrayIcon1->IconIndex = (l ? (k ? 1 : 0) : 2);
                    ReleaseMutex(crate_list_access);
                    } /* if WaitForSingleObject */
                } /* if CurrMessage */
            else if (MainForm->ltrservicecrate
                 && (CurrMessage.dwMessage == LTR_DISP_ip_list_updated))
                {
                /*  Grid     IP- */
                const int ListType[] = { IPLIST_STATIC, IPLIST_DYNAMIC };
                const AnsiString *const ListName[] = { &SC_TYPE_STATIC, &SC_TYPE_DYNAMIC };
                int num_rows = 0;
                for (int type = 0; type < sizeof(ListType) / sizeof(ListType[0]); type++)
                    {
                    TAddrList *IPList =
                        IPCrateList.ExportList(ListType[type]);
                    if (!IPList) continue;
                    TAddrListNode *addr = IPList->GetFirstNode();
                    while (addr)
                        {
                        num_rows++;
                        TStrings *Row = MainForm->StringGridIPCrates->Rows[num_rows];
                        AnsiString CrateStatus;
                        switch (addr->iStatus)
                            {
                            case IP_STATUS_OFFLINE:
                                CrateStatus = SC_STAT_OFFLINE;
                                break;
                            case IP_STATUS_CONNECTING:
                                CrateStatus = SC_STAT_CONNECTING;
                                break;
                            case IP_STATUS_ONLINE:
                                CrateStatus = SC_STAT_ONLINE;
                                break;
                            default:
                                CrateStatus = SC_STAT_ERROR;
                                break;
                            }
                        Row->BeginUpdate();
                        Row->Strings[EGRID_COL_NUMBER] = AnsiString(num_rows);
                        Row->Strings[EGRID_COL_IPTYPE] = *ListName[type];
                        Row->Strings[EGRID_COL_IPAUTO] = (addr->bAutoConnect) ?
                            SC_AUTO_ON : SC_AUTO_OFF;
                        Row->Strings[EGRID_COL_IPADDR] = IPToStr(addr->dwIP);
                        Row->Strings[EGRID_COL_STATUS] = CrateStatus;
                        Row->Strings[EGRID_COL_SERIAL] = addr->szSerial;
                        Row->EndUpdate();
                        addr = addr->next;
                        }
                    delete IPList;
                    } /* for type */
                /*   ,    ,    grid */
                if (num_rows == 0)
                    MainForm->StringGridIPCrates->Rows[++num_rows]->Clear();
                MainForm->StringGridIPCrates->RowCount = 1 + num_rows;
                }  /* if CurrMessage */
            } /* if PopMessage */

        if (WaitForSingleObject(crate_list_access, 500) == WAIT_OBJECT_0)
            {
            //     
            MainForm->Statistic->Lines->BeginUpdate();
            MainForm->Statistic->Clear();

            if (MainForm->CrateTree->Selected!=NULL)
                {
                if (WaitForSingleObject(client_list_access, 500)==WAIT_OBJECT_0)
                    {
                    int i, j;
                    TTreeNode *node = MainForm->CrateTree->Selected;
                    if (node->Level)
                        {
                        i=node->Text.AnsiPos("<");
                        j=node->Text.AnsiPos(">");
                        statistic_slot=node->Text.SubString(i+5, j-i-6).ToInt();
                        node=node->Parent;
                        }
                    else
                        {
                        statistic_slot = 0;
                        }
                    i=node->Text.AnsiPos("<");
                    j=node->Text.AnsiPos(">");
                    if (strcmp(statistic_csn, node->Text.SubString(i+1, j-i-1).c_str()))
                        {
                        strcpy(statistic_csn, node->Text.SubString(i+1, j-i-1).c_str());
                        statistic_reset=true;
                        }

                    //    
                    for (int i=0; i < CRATE_MAX; i++)
                        {
                        TCrate *crate=crate_list[i];

                        if (!crate || strncmp(crate->csn, statistic_csn, SERIAL_NUMBER_SIZE))
                            continue;

                        AnsiString CrateType = "";
                        AnsiString CrateConnectionInfo = "";
                        switch (crate->CrateType)
                            {
                            case CRATE_TYPE_LTR010:
                                CrateType = "LTR-U-8/LTR-U-16";
                                break;
                            case CRATE_TYPE_LTR021:
                                CrateType = "LTR-U-1";
                                break;
                            case CRATE_TYPE_LTR030:
                                CrateType = "LTR-E-8/LTR-E-16";
                                break;
                            case CRATE_TYPE_LTR031:
                                CrateType = "LTR-E-2";
                                break;
                            default:
                                CrateType = SC_Unknown_Crate;
                                break;
                            }

                        switch (crate->GetConnType())
                            {
                            case CRATE_IFACE_TCPIP:
                                CrateConnectionInfo = "TCP/IP, " + AnsiString(crate->path);
                                break;
                            case CRATE_IFACE_USB:
                                CrateConnectionInfo = "USB";
                                break;
                            default:
                                CrateConnectionInfo = SC_unknown_interface;
                                break;
                            }
                        MainForm->Statistic->Lines->Add("------ " + SC_Crate_statistics_for + " " + CrateType + " ------");
                        MainForm->Statistic->Lines->Add(Format(SC_Crate_serial_number + " : %.16s", ARRAYOFCONST((statistic_csn))));
                        MainForm->Statistic->Lines->Add(SC_Interface + ": " + CrateConnectionInfo);
                        MainForm->Statistic->Lines->Add(SC_Connected + ": " + DateTimeToStr(SystemTimeToDateTime(crate->start_time), LocaleFormatSettings));
                        MainForm->Statistic->Lines->Add(SC_Total_recv_words + ": " + IntToStr(crate->total_count_recv));
                        MainForm->Statistic->Lines->Add(SC_Total_sent_words + ": " + IntToStr(crate->total_count_send));
                        if (!statistic_reset)
                            {
                            DWORD tick_count = GetTickCount() - statistic_tick_count;
                            if (tick_count == 0)
                                tick_count = 1;
                            double current_speed_recv = 1000.0 * (crate->total_count_recv - statistic_count_recv) / tick_count;
                            double current_speed_send = 1000.0 * (crate->total_count_send - statistic_count_send) / tick_count;
                            MainForm->Statistic->Lines->Add(SC_Data_input_speed + Format(": %.1f ", ARRAYOFCONST((current_speed_recv))) + SC_words_per_second);
                            MainForm->Statistic->Lines->Add(SC_Data_output_speed + Format(": %.1f ", ARRAYOFCONST((current_speed_send))) + SC_words_per_second);
                            }
                        else
                            {
                            statistic_reset = false;
                            }
                        statistic_count_recv = crate->total_count_recv;
                        statistic_count_send = crate->total_count_send;

                        MainForm->Statistic->Lines->Add(SC_Start_marks_received + Format(": %d", ARRAYOFCONST(((int)crate->start_mark_counter))));
                        MainForm->Statistic->Lines->Add(SC_Second_marks_received + Format(": %d", ARRAYOFCONST(((int)crate->second_mark_counter))));
                        if (statistic_slot)
                            {
                            MainForm->Statistic->Lines->Add("");
                            WORD statistic_mid = crate->module[statistic_slot - 1].mid;
                            MainForm->Statistic->Lines->Add(Format("----- " + SC_Statistics_for_slot + " %0.2d -----", ARRAYOFCONST((statistic_slot))));
                            AnsiString astr = SC_Status + "  : ";
                            if (!statistic_mid)
                                {
                                astr += SC_No_module;
                                MainForm->Statistic->Lines->Add(astr);
                                }
                            else if ((statistic_mid == 0xFFFF) || (statistic_mid & 0xFF) != ((statistic_mid >> 8) & 0xFF))
                                {
                                astr += SC_Identifying_module;
                                MainForm->Statistic->Lines->Add(astr);
                                }
                            else
                                {
                                astr += SC_Contains_module + Format(" LTR%d ", ARRAYOFCONST(((int)statistic_mid & 0xFF)));
                                MainForm->Statistic->Lines->Add(astr);
                                MainForm->Statistic->Lines->Add(SC_Num_recv_words + ": " + IntToStr(crate->module[statistic_slot - 1].count_recv));
                                MainForm->Statistic->Lines->Add(SC_Num_sent_words + ": " + IntToStr(crate->module[statistic_slot - 1].count_send));
                                MainForm->Statistic->Lines->Add("");
                                __int64 NumDataClient = 0;
                                int ClientCount = 0;
                                for (int client = 0; client < CLIENT_MAX; client++)
                                    {
                                    if (client_list[client] && (client_list[client]->crate == crate)
                                       && (client_list[client]->crate_channel == statistic_slot)
                                       && (client_list[client]->IsAlive))
                                        {
                                        NumDataClient = std::max(client_list[client]->count_FIFO_recv, NumDataClient);
                                        ClientCount++;
                                        }
                                    }

                                double NumData = crate->module[statistic_slot-1].count_FIFO_recv - NumDataClient;
                                double Percent = 0;
                                if ((NumData > 0) && (ClientCount > 0))
                                    {
                                    Percent = std::min(NumData * 100.0 / MODULE_RECV_BUF_SIZE, 100.0);
                                    }
                                MainForm->Statistic->Lines->Add(SC_Server_buffer_util + Format(" : %0.2f", ARRAYOFCONST(((double)Percent)))+" %");
                                MainForm->Statistic->Lines->Add(SC_Connected_clients + " : " + IntToStr(ClientCount));

                                if (statistic_mid == 0x2222)
                                    {
                                    MainForm->Statistic->Lines->Add("");
                                    MainForm->Statistic->Lines->Add(SC_Hardware_FIFO_state + Format(": %0.6X", ARRAYOFCONST(((int)crate->module[statistic_slot - 1].fifo_size))));
                                    }
                                }
                            }
                        else /* !statistic_slot */
                            {
                            int ClientCount = 0;
                            for (int client = 0; client < CLIENT_MAX; client++)
                                {
                                if (client_list[client] && (client_list[client]->crate == crate)
                                   && (client_list[client]->IsAlive))
                                    {
                                    ClientCount++;
                                    }
                                }
                            MainForm->Statistic->Lines->Add("");
                            MainForm->Statistic->Lines->Add(SC_Connected_clients + " : " + IntToStr(ClientCount));
                            }

                        break;
                        }
                    statistic_tick_count = GetTickCount();
                    ReleaseMutex(client_list_access);
                    }
                }
            MainForm->Statistic->Lines->EndUpdate();
            ReleaseMutex(crate_list_access);
            }

        /*   */
        g_Log.Flush(MainForm->log_list->Lines, SCREEN_LOG_SIZE);

        bool prio_ishigh = (GetPriorityClass(GetCurrentProcess()) == HIGH_PRIORITY_CLASS);
        MainForm->TrayPopupHighPriority->Checked = prio_ishigh;
        MainForm->MenuSettingsHighPriority->Checked = prio_ishigh;
        } /* while (!Terminated) */

    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::AppMinimize(TObject *Sender)
    {
    TrayPopupRestore->Visible = true;
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::AppRestore(TObject *Sender)
    {
    TrayPopupRestore->Visible = false;
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::FormCreate(TObject *Sender)
    {
    crate_list_access = CreateMutex(NULL, FALSE, NULL);
    client_list_access = CreateMutex(NULL, FALSE, NULL);
    // ZeroMemory(client_list, sizeof(client_list));
    // ZeroMemory(crate_list, sizeof(crate_list));

    g_INI.Open(LTRINIFILENAME);

    /*   */
    LCID lcid;
    int LangSel = 0;
    AnsiString lang = AnsiLowerCase(g_INI.ReadString(INI_SEC_CONFIG, INI_KEY_LANG,
        LanguageInfo[0].ConfigStr, true));
    for (int i = 0; i < sizeof(LanguageInfo)/sizeof(LanguageInfo[0]); i++)
        {
        if (lang == LanguageInfo[i].ConfigStr)
            {
            LangSel = i;
            break;
            }
        }
    lcid = LanguageInfo[LangSel].lcid;
    if (lcid == 0)
        lcid = GetUserDefaultLCID();

    /*   ,      LoadStr() */
    SetThreadLocale(lcid);

    Application->OnMinimize = AppMinimize;
    Application->OnRestore = AppRestore;

    /*       */
    SC_STAT_OFFLINE = LoadStr(IDS_CSTAT_OFFLINE);
    SC_STAT_CONNECTING = LoadStr(IDS_CSTAT_CONNECTING);
    SC_STAT_ONLINE = LoadStr(IDS_CSTAT_ONLINE);
    SC_STAT_ERROR = LoadStr(IDS_CSTAT_ERROR);
    SC_TYPE_STATIC = LoadStr(IDS_CTYPE_STATIC);
    SC_TYPE_DYNAMIC = LoadStr(IDS_CTYPE_DYNAMIC);

    SC_Tooltip_Auto = LoadStr(IDS_tt_Auto);
    SC_Tooltip_Status = LoadStr(IDS_tt_Status);
    SC_Tooltip_Type[0] = LoadStr(IDS_tt_TypeStatic);
    SC_Tooltip_Type[1] = LoadStr(IDS_tt_TypeDynamic);

    TabSheetCrateList->Caption = LoadStr(IDS_tabcap_Crates);
    GroupBoxStat->Caption = " " + LoadStr(IDS_grpcap_Statistics) + " ";
    GroupBoxTree->Caption = " " + LoadStr(IDS_grpcap_CrateList) + " ";
    TabSheetIPCrates->Caption = LoadStr(IDS_tabcap_IPCrateCtl);
    TabSheetLog->Caption = LoadStr(IDS_tabcap_Log);

    MenuFile->Caption = LoadStr(IDS_menu_File);
    MenuFileRestart->Caption = LoadStr(IDS_mi_RestartServer);
    MenuFileExit->Caption = LoadStr(IDS_mi_Shutdown);

    MenuSettings->Caption = LoadStr(IDS_menu_Settings);
    MenuSettingsLang->Caption = LoadStr(IDS_subm_SettingsLanguage);
    MenuSettingsLang_auto->Caption = LoadStr(IDS_mi_SettingsLanguageAuto);
    MenuSettingsLang_en->Caption = LoadStr(IDS_mi_SettingsLanguageEN);
    MenuSettingsLang_ru->Caption = LoadStr(IDS_mi_SettingsLanguageRU);
    MenuSettingsHighPriority->Caption = LoadStr(IDS_mi_SettingsHighPriority);
    MenuSettingsStartMinimized->Caption = LoadStr(IDS_mi_SettingsStartMin);
    MenuSettingsMinimizeToTray->Caption = LoadStr(IDS_mi_SettingsMinToTray);
    MenuSettingsAD_enable->Caption = LoadStr(IDS_mi_SettingsADEnable);
    MenuSettingsAD_autoconnect->Caption = LoadStr(IDS_mi_SettingsADAutoConn);

    MenuLogLevel->Caption = LoadStr(IDS_subm_LogLevel);
    MenuLogLevel_0->Caption = LoadStr(IDS_mi_LogLevel0);
    MenuLogLevel_1->Caption = LoadStr(IDS_mi_LogLevel1);
    MenuLogLevel_2->Caption = LoadStr(IDS_mi_LogLevel2);
    MenuLogLevel_3->Caption = LoadStr(IDS_mi_LogLevel3);
    MenuLogLevel_4->Caption = LoadStr(IDS_mi_LogLevel4);
    MenuLogLevel_5->Caption = LoadStr(IDS_mi_LogLevel5);
    MenuLogLevel_6->Caption = LoadStr(IDS_mi_LogLevel6);
    MenuLogLevel_7->Caption = LoadStr(IDS_mi_LogLevel7);

    PopupConnectCrate->Caption = LoadStr(IDS_mi_ConnectIP);
    PopupDisconnectCrate->Caption = LoadStr(IDS_mi_DisconnectIP);
    PopupDeleteCrateIP->Caption = LoadStr(IDS_mi_DeleteAddressIP);
    PopupAutoConnectIPToggle->Caption = LoadStr(IDS_mi_ConnectIPAtStart);
    PopupConnectAllIP->Caption = LoadStr(IDS_mi_ConnectAllAuto);
    PopupDisconnectAllIP->Caption = LoadStr(IDS_mi_DisconnectAllCrates);
    PopupAddCrateIP->Caption = LoadStr(IDS_mi_AddIPAddress);
    LogPopupClear->Caption = LoadStr(IDS_mi_ClearLog);
    TrayPopupRestore->Caption = LoadStr(IDS_mi_Restore);
    TrayPopupRestart->Caption = LoadStr(IDS_mi_RestartServer);
    TrayPopupHighPriority->Caption = LoadStr(IDS_mi_SettingsHighPriority);
    TrayPopupShutdown->Caption = LoadStr(IDS_mi_Shutdown);

    /*    */
    MenuCaption.Connect = PopupConnectCrate->Caption;
    MenuCaption.Disconnect = PopupDisconnectCrate->Caption;
    MenuCaption.Delete = PopupDeleteCrateIP->Caption;
    MenuCaption.AutoConnect = PopupAutoConnectIPToggle->Caption;

    LogLevelMenuItemList[0] = MenuLogLevel_0;
    LogLevelMenuItemList[1] = MenuLogLevel_1;
    LogLevelMenuItemList[2] = MenuLogLevel_2;
    LogLevelMenuItemList[3] = MenuLogLevel_3;
    LogLevelMenuItemList[4] = MenuLogLevel_4;
    LogLevelMenuItemList[5] = MenuLogLevel_5;
    LogLevelMenuItemList[6] = MenuLogLevel_6;
    LogLevelMenuItemList[7] = MenuLogLevel_7;

    LangMenuItemList[0] = MenuSettingsLang_auto;
    LangMenuItemList[1] = MenuSettingsLang_en;
    LangMenuItemList[2] = MenuSettingsLang_ru;

    /*   IP  */
    StringGridIPCrates->RowCount = 2;
    StringGridIPCrates->Cells[EGRID_COL_NUMBER][0] = LoadStr(IDS_NUMBER_SIGN);
    StringGridIPCrates->Cells[EGRID_COL_IPTYPE][0] = LoadStr(IDS_Type);
    StringGridIPCrates->Cells[EGRID_COL_IPAUTO][0] = LoadStr(IDS_Auto);
    StringGridIPCrates->Cells[EGRID_COL_IPADDR][0] = LoadStr(IDS_IP);
    StringGridIPCrates->Cells[EGRID_COL_STATUS][0] = LoadStr(IDS_Status);
    StringGridIPCrates->Cells[EGRID_COL_SERIAL][0] = LoadStr(IDS_Serial_N);
    StringGridIPCrates->Rows[1]->Clear();
    IPGridColWidth[0] = 68;
    IPGridColWidth[1] = 68;
    IPGridColWidth[2] = 114;
    IPGridColWidth[3] = 228;
    IPGridColWidth[4] = 183;
    IPGridColWidth[5] = 0;
    {
    AnsiString GridParamStr = LoadStr(IDS_GRIDPARAMS) + ",";
    int i = 0;
    while (1)
        {
        int elem;
        int commapos = GridParamStr.AnsiPos(",");
        if (!commapos)
            break;
        if (!TryStrToInt(GridParamStr.SubString(1, commapos - 1).Trim(), elem))
            elem = 0;
        if (elem > 1000)
            elem = 0;
        GridParamStr.Delete(1, commapos);
        IPGridColWidth[i++] = elem;
        if (elem == 0)
            break;
        if (i >= sizeof(IPGridColWidth)/sizeof(IPGridColWidth[0]))
            break;
        }
    }
    PageControl1Resize(PageControl1); /*    */

    /*    INI- */

    /*   */
    g_Config.LogName =
        g_INI.ReadString(INI_SEC_LOG, INI_KEY_LOGNAME, LTRLOGFILENAME, true);
    g_Config.LogLevel =
        g_INI.ReadInteger(INI_SEC_LOG, AnsiString(INI_KEY_LOGLEVEL), LOGL_INFO, true);

    /*   */
    g_Config.ServerPriority =
        g_INI.ReadInteger(INI_SEC_CONFIG, INI_KEY_PRIORITY, NORMAL_PRIORITY_CLASS, true);
    g_Config.MinimizeToTray =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_MINIMIZE2TRAY, true, true);
    g_Config.StartMinimized =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_STARTMINIMIZED, false, true);
    g_Config.EnableAutoDiscovery =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_AUTODISCOVER, true, true);
    g_Config.AutoConnectDynamic =
        g_INI.ReadBool(INI_SEC_CONFIG, INI_KEY_AUTOCONNECT, true, true);
    g_Config.default_ttf =
        g_INI.ReadString(INI_SEC_LTR_DEFAULT, INI_KEY_FPGA_TTF, "ltr010.ttf", true);

    /*   */
    {
    WINDOWPLACEMENT wp;
    wp.length = sizeof(wp);
    GetWindowPlacement(Handle, &wp);
    RECT rc;
    AnsiString pos_str = g_INI.ReadString(INI_SEC_VISUAL, INI_KEY_PLACEMENT, "", false);
    if (sscanf(pos_str.c_str(), "%ld,%ld,%ld,%ld",
        &rc.left, &rc.top, &rc.right, &rc.bottom) == 4)
        {
        wp.rcNormalPosition = rc;
        }

    TrayPopupRestore->Visible = g_Config.StartMinimized;
    if (g_Config.StartMinimized)
        {
        if (g_Config.MinimizeToTray)
            {
            //ShowWindow(Application->Handle, SW_HIDE);
            wp.showCmd = SW_HIDE;
            Application->ShowMainForm = false;
            }
        else
            {
            wp.showCmd = SW_SHOWMINIMIZED;
            //Application->Minimize();
            }
        }
    else if (g_INI.ReadBool(INI_SEC_VISUAL, INI_KEY_MAXIMIZED, false, false))
        {
        wp.showCmd = SW_SHOWMAXIMIZED;
        }
    SetWindowPlacement(Handle, &wp);

    /*   */
    int active_tab =
        g_INI.ReadInteger(INI_SEC_VISUAL, INI_KEY_ACTIVE_TAB, 0, false);
    if ((active_tab >= 0) && (active_tab < PageControl1->PageCount))
        PageControl1->ActivePageIndex = active_tab;
    }

    /*    IP (IPaddr = auto|manual) */
    IPCrateList.Clear();
    if (TStrings* KeyList = new TStringList)
        {
        AnsiString mode;
        g_INI.ReadSection(INI_SEC_IP_CRATES, KeyList);
        for (int i = 0; i < KeyList->Count; i++)
            {
            mode = g_INI.ReadString(INI_SEC_IP_CRATES, KeyList->Strings[i], "", false);
            IPCrateList.AddUnique(IPLIST_STATIC, StrToIP(KeyList->Strings[i]),
                (mode.LowerCase() == "auto"));
            }
        delete KeyList;
        }

    /*    g_Config */
    bool prio_ishigh = (g_Config.ServerPriority == HIGH_PRIORITY_CLASS);
    TrayPopupHighPriority->Checked = prio_ishigh;
    MenuSettingsHighPriority->Checked = prio_ishigh;

    MenuSettingsMinimizeToTray->Checked = g_Config.MinimizeToTray;
    MenuSettingsStartMinimized->Checked = g_Config.StartMinimized;
    MenuSettingsAD_autoconnect->Checked = g_Config.AutoConnectDynamic;
    MenuSettingsAD_enable->Checked = g_Config.EnableAutoDiscovery;

    if (g_Config.LogLevel < 0)
        g_Config.LogLevel = 0;
    if (g_Config.LogLevel >= sizeof(LogLevelMenuItemList)/sizeof(LogLevelMenuItemList[0]))
        g_Config.LogLevel = sizeof(LogLevelMenuItemList)/sizeof(LogLevelMenuItemList[0]);
    LogLevelMenuItemList[g_Config.LogLevel]->Checked = true;

    if (LangSel < sizeof(LangMenuItemList)/sizeof(LangMenuItemList[0]))
        LangMenuItemList[LangSel]->Checked = true;

    g_Log.OpenFile(g_Config.LogName);
    g_Log.SetLevel(g_Config.LogLevel);

    MessageQueueDisplay = new T_MessageQueue(100,100);

    /*  file version info     caption */
    DWORD n = GetFileVersionInfoSize(Application->ExeName.c_str(), NULL);
    if (n)
        {
        AnsiString info[3] = {"FileDescription", "FileVersion", "CompanyName"};
        char *buf = new char[n];
        if (buf)
            {
            LPVOID val;
            UINT len;
            GetFileVersionInfo(Application->ExeName.c_str(), 0, n, buf);
            if (VerQueryValue(buf, "\\VarFileInfo\\Translation", &val, &len) && (len >= sizeof(DWORD)))
                {
                DWORD bestpage = MAKELONG(HIWORD(((LPDWORD)val)[0]), LOWORD(((LPDWORD)val)[0]));
                for (unsigned int i = 1; i < len / sizeof(DWORD); i++)
                    {
                    DWORD page = MAKELONG(HIWORD(((LPDWORD)val)[i]), LOWORD(((LPDWORD)val)[i]));
                    if (HIWORD(page) == LANGIDFROMLCID(lcid))
                        {
                        bestpage = page;
                        break;
                        }
                    }
                AnsiString Prefix = "\\StringFileInfo\\" + IntToHex((int)bestpage, 8) + "\\";
                for (int i = 0; i < 3; i++)
                    {
                    if (VerQueryValue(buf, (Prefix + info[i]).c_str(), &val, &len))
                        info[i] = (LPTSTR)val;
                    }
                }
            delete[] buf;
            g_Log.Write("Starting up " + info[0] + " v" + info[1] + " (" + info[2] + ")",
                 LOGTASK_GLOBAL, LOGL_CRITICAL);
            Caption = info[0] + " v" + info[1];
            }
        }

    TrayIcon1->IconIndex = 0;

    WSADATA wsaData;
    if (!WSAStartup(MAKEWORD( 2, 2 ), &wsaData))
        {
        if (LOBYTE(wsaData.wVersion) != 2 ||
                HIBYTE( wsaData.wVersion ) != 2 )
            {
            // Tell the user that we could not find a usable
            // WinSock DLL.                                  */
            WSACleanup( );
            g_Log.Write("Invalid version of winsock dll, required 2.2",
                LOGTASK_GLOBAL, LOGL_CRITICAL);
            Close();
            Application->Terminate();
            return;
            }
        }
    else
        {
        g_Log.Write(Format("WSAStartup() error (%d)", ARRAYOFCONST(((int)WSAGetLastError()))),
            LOGTASK_GLOBAL, LOGL_CRITICAL);
        Close();
        Application->Terminate();
        return;
        }

#if 0
    DEV_BROADCAST_DEVICEINTERFACE NotifyFilter;
    ZeroMemory(&NotifyFilter, sizeof(NotifyFilter));
    NotifyFilter.dbcc_size = sizeof(NotifyFilter);
    NotifyFilter.dbcc_devicetype = DBT_DEVTYP_DEVICEINTERFACE;
    NotifyFilter.dbcc_classguid = USB_DEVICE_CLSID;
    hDevNotify =
        RegisterDeviceNotification(Application->Handle, &NotifyFilter, DEVICE_NOTIFY_WINDOW_HANDLE);
#endif

    bool init_complete=false;
    ltrservicecrate=new TLTRServiceCrate(true);
    if (ltrservicecrate!=NULL)
        {
        ltrservicecrate->MessageQueueDisplay = MessageQueueDisplay;
        ltrservicecrate->Resume();
        if (WaitForSingleObject(ltrservicecrate->init_complete, 5000)==WAIT_OBJECT_0)
            {
            ltrserviceclient=new TLTRServiceClient(true);
            //ltrserviceclient->MessageQueueDisplay = MessageQueueDisplay;
            ltrserviceclient->Resume();
            if (ltrserviceclient!=NULL)
                {
                if (WaitForSingleObject(ltrserviceclient->init_complete, INFINITE)==WAIT_OBJECT_0)
                    {
                    UpdateInformationThread = new TUpdateInfoThread(this);
                    init_complete=true;
                    }
                else
                    {
                    g_Log.Write("Cannot init LTRServiceClient thread.", LOGTASK_GLOBAL, LOGL_CRITICAL);
                    TerminateThread((HANDLE)ltrserviceclient->Handle, 0);
                    }
                }
            else g_Log.Write("Cannot create LTRServiceListen thread", LOGTASK_GLOBAL, LOGL_CRITICAL);
            }
        else
            {
            g_Log.Write("Cannot init LTRServiceCrate thread.", LOGTASK_GLOBAL, LOGL_CRITICAL);
            TerminateThread((HANDLE)ltrservicecrate->Handle, 0);
            }
        }
    else g_Log.Write("Cannot create LTRServiceCrate thread.", LOGTASK_GLOBAL, LOGL_CRITICAL);

    if (!init_complete)
        {
        Close();
        Application->Terminate();
        }
    }
//---------------------------------------------------------------------------
void __fastcall TFormMAIN::FormClose(TObject *Sender, TCloseAction &Action)
    {
    g_Log.Write("Server shutting down", LOGTASK_GLOBAL, LOGL_CRITICAL);

    EndThread(UpdateInformationThread);

    if (ltrserviceclient)
        {
        ltrserviceclient->Terminate();
        if (ltrserviceclient->server != SOCKET_ERROR)
            { /*  ,  accept() */
            shutdown(ltrserviceclient->server, SD_BOTH);
            closesocket(ltrserviceclient->server);
            ltrserviceclient->server = SOCKET_ERROR;
            }
        EndThread(ltrserviceclient);
        }

    EndThread(ltrservicecrate);

    if (MessageQueueDisplay)
        {
        delete MessageQueueDisplay;
        MessageQueueDisplay = NULL;
        }

    CloseHandle(crate_list_access);
    CloseHandle(client_list_access);

    /*       */
    {
    WINDOWPLACEMENT wp;
    wp.length = sizeof(wp);
    GetWindowPlacement(Handle, &wp);
    g_INI.WriteString(INI_SEC_VISUAL, INI_KEY_PLACEMENT, Format("%d,%d,%d,%d", ARRAYOFCONST((
        wp.rcNormalPosition.left,
        wp.rcNormalPosition.top,
        wp.rcNormalPosition.right,
        wp.rcNormalPosition.bottom
        ))));
    g_INI.WriteBool(INI_SEC_VISUAL, INI_KEY_MAXIMIZED, (SW_SHOWMAXIMIZED == wp.showCmd));
    g_INI.WriteInteger(INI_SEC_VISUAL, INI_KEY_ACTIVE_TAB, PageControl1->ActivePageIndex);
    }

    /*      */
    g_Log.Flush(log_list->Lines, SCREEN_LOG_SIZE);
    g_Log.CloseFile();

    g_INI.Close();

#if 0
    UnregisterDeviceNotification(hDevNotify);
#endif
    WSACleanup();

    Application->OnMinimize = NULL;
    Application->OnRestore = NULL;

    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::TrayIcon1Click(TObject *Sender)
    {
    if (Application && Application->MainForm)
        {
        Application->Restore();
        Application->MainForm->Visible = true;
        Application->ShowMainForm = true;
        ShowWindow(Application->Handle, SW_RESTORE);
        SetForegroundWindow(Application->Handle);
        }
    }
//---------------------------------------------------------------------------

bool __fastcall TFormMAIN::ValidCell(int X, int Y)
    {
    TStringGrid *Grid = StringGridIPCrates;
    return (
           (X >= Grid->FixedCols)
        && (Y >= Grid->FixedRows)
        && (X < Grid->ColCount)
        && (Y < Grid->RowCount)
        && (Grid->Cells[EGRID_COL_IPADDR][Y] != "")
        );
    }
//---------------------------------------------------------------------------


//---------------------------------------------------------------------------
void __fastcall TFormMAIN::GridContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled)
    {
    TPoint PopupPos;
    TGridCoord cell;
    TStringGrid *Grid = StringGridIPCrates;

    PopupDeleteCrateIP->Visible = false;
    PopupConnectCrate->Visible = false;
    PopupDisconnectCrate->Visible = false;
    PopupAutoConnectIPToggle->Visible = false;
    //PopupAddCrateIP->Visible = false;
    //PopupConnectAllIP->Visible = false;
    //PopupDisconnectAllIP->Visible = false;

    if ((MousePos.x >= 0) && (MousePos.y >= 0))
        { /* Popup  , MousePos =     */
        PopupPos = Grid->ClientToScreen(MousePos); /*      */
        cell = Grid->MouseCoord(MousePos.x, MousePos.y); /*      */
        //   
        if (ValidCell(cell.X, cell.Y))
            {
            Grid->Col = cell.X;
            Grid->Row = cell.Y;
            }
        }
    else
        { /* Popup   ([Menu]  [Shift-F10]) */
        cell.X = Grid->Col; /*   popup'  */
        cell.Y = Grid->Row; /*   ,   */
        TRect rect = Grid->CellRect(cell.X, cell.Y);
        /*         */
        PopupPos = Grid->ClientToScreen(TPoint(rect.left, rect.top));
        }

    if (ValidCell(cell.X, cell.Y))
        { /*        .
                  cell. */
        AnsiString IPString = Grid->Cells[EGRID_COL_IPADDR][cell.Y];
        AnsiString status = Grid->Cells[EGRID_COL_STATUS][cell.Y];
        if (status == SC_STAT_OFFLINE)
            { /* OFFLINE =>     */
            PopupConnectCrate->Caption =
                AnsiReplaceStr(MenuCaption.Connect, "#IP#", IPString);
            PopupConnectCrate->Visible = true;

            PopupDeleteCrateIP->Caption =
                AnsiReplaceStr(MenuCaption.Delete, "#IP#", IPString);
            PopupDeleteCrateIP->Visible = true;
            }
        else if ((status == SC_STAT_ONLINE)
              || (status == SC_STAT_CONNECTING))
            { /* ONLINE, CONNECTING =>  .  . */
            PopupDisconnectCrate->Caption =
                AnsiReplaceStr(MenuCaption.Disconnect, "#IP#", IPString);
            PopupDisconnectCrate->Visible = true;
            }
        /*  toggle autoconnect */
        PopupAutoConnectIPToggle->Checked =
            (Grid->Cells[EGRID_COL_IPAUTO][cell.Y] == SC_AUTO_ON);
        PopupAutoConnectIPToggle->Caption =
            AnsiReplaceStr(MenuCaption.AutoConnect, "#IP#", IPString);
        PopupAutoConnectIPToggle->Visible = true;
        }

    GridPopupMenu->Popup(PopupPos.x, PopupPos.y);
    Handled = true;
    }
//---------------------------------------------------------------------------

int __fastcall TFormMAIN::GetPopupNode(TAddrListNode *pNode)
    {
    /*  PopupNode;    (IPLIST_...)  -1 */
    TGridCoord cell;
    TStringGrid *Grid = StringGridIPCrates;
    cell.X = Grid->Col; /*    */
    cell.Y = Grid->Row;
    if (!ValidCell(cell.X, cell.Y))
        return -1;
    /*  IP-  ,   PopupNode */
    return IPCrateList.Find(StrToIP(Grid->Cells[EGRID_COL_IPADDR][cell.Y]), pNode);
    }
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
void __fastcall TFormMAIN::PopupAddCrateIPClick(TObject *Sender)
    {
    if (!IsPositiveResult(FormAddIPDialog->ShowModal()))
        return;
    DWORD ip = FormAddIPDialog->IP_Addr;
    bool connect_now = FormAddIPDialog->CheckBoxConnectNow->Checked;
    bool autoconnect = FormAddIPDialog->CheckBoxAutoConnect->Checked;

    if (IPCrateList.AddUnique(IPLIST_STATIC, ip, autoconnect))
        {
        MessageQueueDisplay->PostMessage(LTR_DISP_ip_list_updated);
        g_INI.WriteString(INI_SEC_IP_CRATES, IPToStr(ip), (autoconnect) ? "auto" : "manual");
        if (connect_now && ltrservicecrate)
            ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, ip);
        }
    else
        {
        MessageBoxCtr(FormMAIN->Handle, LoadStr(IDS_Bad_or_dup_address), LoadStr(IDS_Error),
            MB_OK | MB_ICONERROR);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDeleteCrateIPClick(TObject *Sender)
    {
    TAddrListNode node;

    int list_idx = GetPopupNode(&node);
    if (list_idx < 0) return;

    //     
    if (node.iStatus != IP_STATUS_OFFLINE)
        return;

    AnsiString ip_str = IPToStr(node.dwIP);
    switch (list_idx)
        {
        case IPLIST_STATIC:
            if (MessageBoxCtr(FormMAIN->Handle,
                LoadStr(IDS_Delete_address_) + ip_str + " ?",
                LoadStr(IDS_Are_you_sure), MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
                {
                if (IPCrateList.Delete(IPLIST_STATIC, node.dwIP))
                    {
                    MessageQueueDisplay->PostMessage(LTR_DISP_ip_list_updated);
                    g_INI.DeleteKey(INI_SEC_IP_CRATES, ip_str);
                    }
                else
                    {
                    MessageBoxCtr(FormMAIN->Handle, LoadStr(IDS_Address_not_in_list),
                        LoadStr(IDS_Error), MB_OK | MB_ICONERROR);
                    }
                }
            break;
        case IPLIST_DYNAMIC:
            //         .ini   
            if (IPCrateList.Delete(IPLIST_DYNAMIC, node.dwIP))
                MessageQueueDisplay->PostMessage(LTR_DISP_ip_list_updated);
            break;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupConnectCrateClick(TObject *Sender)
    {
    TAddrListNode node;
    if (GetPopupNode(&node) < 0) return;
    //     
    if (node.iStatus != IP_STATUS_OFFLINE)
        return;
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, node.dwIP);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDisconnectCrateClick(TObject *Sender)
    {
    TAddrListNode node;
    if (GetPopupNode(&node) < 0) return;
    //      online  connecting
    if ((node.iStatus != IP_STATUS_ONLINE) && (node.iStatus != IP_STATUS_CONNECTING))
        return;
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_crate, node.dwIP);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupConnectAllIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_autoconnect_ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupDisconnectAllIPClick(TObject *Sender)
    {
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_all_ip);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridIPCratesDblClick(TObject *Sender)
    {
    TStringGrid *Grid = StringGridIPCrates;
    if (!ValidCell(Grid->Col, Grid->Row))
        return;
    AnsiString IPString = Grid->Cells[EGRID_COL_IPADDR][Grid->Row];
    DWORD ip = StrToIP(IPString);
    if (!ip) return;
    switch (Grid->Col)
        {
        case EGRID_COL_IPAUTO:
            /* Doubleclick   "": / autoconnect */
            {
            bool is_static = (Grid->Cells[EGRID_COL_IPTYPE][Grid->Row] != SC_TYPE_DYNAMIC);
            bool NewAuto = (Grid->Cells[EGRID_COL_IPAUTO][Grid->Row] != SC_AUTO_ON);
            if (IPCrateList.SetAutoConnect(ip, NewAuto))
                {
                if (is_static)
                    g_INI.WriteString(INI_SEC_IP_CRATES, IPString, (NewAuto) ? "auto" : "manual");
                MessageQueueDisplay->PostMessage(LTR_DISP_ip_list_updated);
                }
            }
            break;
        case EGRID_COL_STATUS:
            /* Doubleclick   "": / */
            if (ltrservicecrate)
                {
                AnsiString status = Grid->Cells[EGRID_COL_STATUS][Grid->Row];
                if (status == SC_STAT_OFFLINE)
                    {
                    ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, ip);
                    }
                else if ((status == SC_STAT_ONLINE)
                      || (status == SC_STAT_CONNECTING))
                    {
                    ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_crate, ip);
                    }
                }
            break;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridIPCratesMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
    {
    static int lastrow = -1, lastcol = -1;
    int row, col;

    /*  tooltip' */
    TStringGrid *Grid = StringGridIPCrates;
    Grid->MouseToCell(X, Y, col, row);
    if ((col != lastcol) || (row != lastrow))
        {
        lastcol = col;
        lastrow = row;
        AnsiString hint = "";
        if (ValidCell(col, row))
            {
            switch (col)
                {
                case EGRID_COL_IPAUTO:
                    hint = SC_Tooltip_Auto;
                    break;
                case EGRID_COL_IPTYPE:
                    hint = SC_Tooltip_Type[(Grid->Cells[col][row] == SC_TYPE_DYNAMIC)];
                    break;
                case EGRID_COL_STATUS:
                    hint = SC_Tooltip_Status;
                    break;
                }
            }
        Application->CancelHint();
        Grid->Hint = hint;
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PopupAutoConnectIPToggleClick(TObject *Sender)
    {
    TAddrListNode node;
    int list_idx = GetPopupNode(&node);
    if (list_idx < 0) return;
    node.bAutoConnect = !node.bAutoConnect;
    if (IPCrateList.SetAutoConnect(node.dwIP, node.bAutoConnect))
        {
        if (list_idx == IPLIST_STATIC)
            g_INI.WriteString(INI_SEC_IP_CRATES, IPToStr(node.dwIP),
                (node.bAutoConnect) ? "auto" : "manual");
        MessageQueueDisplay->PostMessage(LTR_DISP_ip_list_updated);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::PageControl1Resize(TObject *Sender)
    {
    /*     IPGridColWidth    1000 */
    /*  0  " " */

    int NumCols = std::min<int>(StringGridIPCrates->ColCount,
        sizeof(IPGridColWidth)/sizeof(IPGridColWidth[0]));
    int Space = StringGridIPCrates->Width;
    int Sep = StringGridIPCrates->GridLineWidth + 1;
    double K = Space / 1000.0;
    for (int i = 0; i < NumCols; i++)
        {
        if (IPGridColWidth[i] == 0)
            {
            StringGridIPCrates->ColWidths[i] = Space;
            break;
            }
        int cw = K * IPGridColWidth[i];
        StringGridIPCrates->ColWidths[i] = cw;
        Space -= (cw + Sep);
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuFileRestartClick(TObject *Sender)
    {
    TCloseAction xx;
    FormClose(FormMAIN, xx);
    FormCreate(FormMAIN);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuFileExitClick(TObject *Sender)
    {
    FormMAIN->Close();
    }
//---------------------------------------------------------------------------


void __fastcall TFormMAIN::MenuLogLevelClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    self->Checked = true;
    for (int i = 0; i < sizeof(LogLevelMenuItemList)/sizeof(LogLevelMenuItemList[0]); i++)
        {
        if (LogLevelMenuItemList[i] == self)
            {
            g_Config.LogLevel = i;
            g_Log.SetLevel(g_Config.LogLevel);
            g_INI.WriteInteger(INI_SEC_LOG, INI_KEY_LOGLEVEL, g_Config.LogLevel);
            break;
            }
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsLangClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    //    ,   
    if (self->Checked) return;

    self->Checked = true;
    for (int i = 0; i < sizeof(LangMenuItemList)/sizeof(LangMenuItemList[0]); i++)
        {
        if (LangMenuItemList[i] == self)
            {
            if (i < sizeof(LanguageInfo)/sizeof(LanguageInfo[0]))
                {
                g_INI.WriteString(INI_SEC_CONFIG, INI_KEY_LANG, LanguageInfo[i].ConfigStr);
                //   ,  messagebox    
                LCID lcid = LanguageInfo[i].lcid;
                if (lcid == 0)
                    lcid = GetUserDefaultLCID();
                SetThreadLocale(lcid);
                if (MessageBoxCtr(FormMAIN->Handle,
                    LoadStr(IDS_RestartToApply), LoadStr(IDS_LangChange),
                    MB_OKCANCEL | MB_ICONQUESTION) == IDOK)
                    {
                    // restart
                    TCloseAction xx;
                    FormClose(FormMAIN, xx);
                    FormCreate(FormMAIN);
                    }
                }
            break;
            }
        }
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsHighPriorityClick(TObject *Sender)
    {
    g_Config.ServerPriority =
        (g_Config.ServerPriority == HIGH_PRIORITY_CLASS)
            ? NORMAL_PRIORITY_CLASS
            : HIGH_PRIORITY_CLASS;
    bool set_high = (g_Config.ServerPriority == HIGH_PRIORITY_CLASS);
    //    ,    callback
    MenuSettingsHighPriority->Checked = set_high;
    TrayPopupHighPriority->Checked = set_high;
    g_INI.WriteInteger(INI_SEC_CONFIG, INI_KEY_PRIORITY, g_Config.ServerPriority);
    if (ltrservicecrate)
        ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_server_priority_changed);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsStartMinimizedClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    g_Config.StartMinimized = self->Checked;
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_STARTMINIMIZED, g_Config.StartMinimized);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsMinimizeToTrayClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    g_Config.MinimizeToTray = self->Checked;
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_MINIMIZE2TRAY, g_Config.MinimizeToTray);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsAD_autoconnectClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    g_Config.AutoConnectDynamic = self->Checked;
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_AUTOCONNECT, g_Config.AutoConnectDynamic);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::MenuSettingsAD_enableClick(TObject *Sender)
    {
    SENDER(self, TMenuItem);
    if (g_Config.EnableAutoDiscovery != self->Checked)
        {
        g_Config.EnableAutoDiscovery = self->Checked;
        if (ltrservicecrate)
            ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_autodiscovery_changed);
        }
    g_INI.WriteBool(INI_SEC_CONFIG, INI_KEY_AUTODISCOVER, g_Config.EnableAutoDiscovery);
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::LogPopupClearClick(TObject *Sender)
    {
    log_list->Clear();
    }
//---------------------------------------------------------------------------

void __fastcall TFormMAIN::StringGridIPCratesKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
    {
    /* /   [Ctrl-Enter] */
    if ((Shift == (TShiftState() << ssCtrl)) && (Key == VK_RETURN) && ltrservicecrate)
        {
        TAddrListNode node;
        if (GetPopupNode(&node) < 0) return;
        switch (node.iStatus)
            {
            case IP_STATUS_OFFLINE:
                ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_connect_crate, node.dwIP);
                break;
            case IP_STATUS_ONLINE:
            case IP_STATUS_CONNECTING:
                ltrservicecrate->MessageQueueIn->PostMessage(LTR_SRV_disconnect_crate, node.dwIP);
                break;
            }
        }
    }
//---------------------------------------------------------------------------

