//$$---- Form HDR ----
//---------------------------------------------------------------------------

#ifndef FormMainH
#define FormMainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <ExtCtrls.hpp>
#include <ImgList.hpp>
#include <Menus.hpp>
#include <Grids.hpp>
#include <ValEdit.hpp>
#include <ToolWin.hpp>
#include <DBGrids.hpp>
#include <DBCtrls.hpp>
#include <DB.hpp>
#include <DBClient.hpp>
#include <Mask.hpp>
#include <DBTables.hpp>
//---------------------------------------------------------------------------
#include "LtrCrate.h"
#include "LtrServiceCrates.h"
#include "LtrClient.h"
#include "ltrServiceClients.h"
#include "MessageQueue.h"
//---------------------------------------------------------------------------
class TUpdateInfoThread : public TThread
{
 private:
    void * ParentInstance;
    bool statistic_reset;
    char statistic_csn[SERIAL_NUMBER_SIZE+1];
    int statistic_slot;
    int statistic_tick_count;
    __int64 statistic_count_recv;
    __int64 statistic_count_send;

 protected:
    void __fastcall Execute(void);
 public:
    __fastcall TUpdateInfoThread(void * ParentInstance);
    __fastcall ~TUpdateInfoThread(void);
};



//----------------------------------------------------------------
class TFormMAIN : public TForm
{
__published:    // IDE-managed Components
    TPageControl *PageControl1;
    TTabSheet *TabSheetCrateList;
    TTabSheet *TabSheetIPCrates;
    TImageList *ImageList1;
    TTrayIcon *TrayIcon1;
    TPopupMenu *GridPopupMenu;
    TTabSheet *TabSheetLog;
    TRichEdit *log_list;
    TStatusBar *StatusBar1;
    TGroupBox *GroupBoxStat;
    TMemo *Statistic;
    TGroupBox *GroupBoxTree;
    TTreeView *CrateTree;
    TSplitter *Splitter2;
    TMenuItem *PopupDeleteCrateIP;
    TMenuItem *PopupAddCrateIP;
    TMenuItem *PopupConnectCrate;
    TMenuItem *PopupDisconnectCrate;
    TMenuItem *PopupConnectAllIP;
    TMenuItem *PopupDisconnectAllIP;
    TMenuItem *PopupAutoConnectIPToggle;
    TMainMenu *MainMenu1;
    TMenuItem *MenuFile;
    TMenuItem *MenuFileRestart;
    TMenuItem *MenuFileExit;
    TMenuItem *MenuSettings;
    TMenuItem *MenuSettingsAD_enable;
    TMenuItem *MenuSettingsAD_autoconnect;
    TMenuItem *MenuSettingsHighPriority;
    TMenuItem *MenuSettingsStartMinimized;
    TMenuItem *MenuSettingsMinimizeToTray;
    TMenuItem *MenuSettingsLang;
    TMenuItem *MenuSettingsLang_auto;
    TMenuItem *MenuSettingsLang_en;
    TMenuItem *MenuSettingsLang_ru;
    TMenuItem *MenuLogLevel;
    TMenuItem *MenuLogLevel_0;
    TMenuItem *MenuLogLevel_1;
    TMenuItem *MenuLogLevel_2;
    TMenuItem *MenuLogLevel_3;
    TMenuItem *MenuLogLevel_4;
    TMenuItem *MenuLogLevel_5;
    TMenuItem *MenuLogLevel_6;
    TMenuItem *MenuLogLevel_7;
    TStringGrid *StringGridIPCrates;
    TPopupMenu *TrayPopupMenu;
    TMenuItem *TrayPopupRestart;
    TMenuItem *TrayPopupHighPriority;
    TMenuItem *TrayPopupShutdown;
    TMenuItem *TrayPopupRestore;
    TPopupMenu *LogPopupMenu;
    TMenuItem *LogPopupClear;
    void __fastcall FormCreate(TObject *Sender);
    void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
    void __fastcall TrayIcon1Click(TObject *Sender);
    void __fastcall GridContextPopup(TObject *Sender, TPoint &MousePos, bool &Handled);
    void __fastcall PopupAddCrateIPClick(TObject *Sender);
    void __fastcall PopupDeleteCrateIPClick(TObject *Sender);
    void __fastcall PopupConnectCrateClick(TObject *Sender);
    void __fastcall PopupDisconnectCrateClick(TObject *Sender);
    void __fastcall PopupConnectAllIPClick(TObject *Sender);
    void __fastcall PopupDisconnectAllIPClick(TObject *Sender);
    void __fastcall StringGridIPCratesDrawCell(TObject *Sender, int ACol, int ARow,
          TRect &Rect, TGridDrawState State);
    void __fastcall StringGridIPCratesDblClick(TObject *Sender);
    void __fastcall PopupAutoConnectIPToggleClick(TObject *Sender);
    void __fastcall PageControl1Resize(TObject *Sender);
    void __fastcall MenuFileRestartClick(TObject *Sender);
    void __fastcall MenuFileExitClick(TObject *Sender);
    void __fastcall MenuLogLevelClick(TObject *Sender);
    void __fastcall MenuSettingsLangClick(TObject *Sender);
    void __fastcall MenuSettingsHighPriorityClick(TObject *Sender);
    void __fastcall MenuSettingsStartMinimizedClick(TObject *Sender);
    void __fastcall MenuSettingsMinimizeToTrayClick(TObject *Sender);
    void __fastcall MenuSettingsAD_autoconnectClick(TObject *Sender);
    void __fastcall MenuSettingsAD_enableClick(TObject *Sender);
    void __fastcall StringGridIPCratesMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
    void __fastcall AppMinimize(TObject *Sender);
    void __fastcall AppRestore(TObject *Sender);
    void __fastcall LogPopupClearClick(TObject *Sender);
    void __fastcall StringGridIPCratesKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);
private:    // User declarations

    TLTRServiceClient *ltrserviceclient;
    TUpdateInfoThread * UpdateInformationThread;
    struct
        {
        AnsiString Connect;
        AnsiString Disconnect;
        AnsiString AutoConnect;
        AnsiString Delete;
        }
        MenuCaption;
    TMenuItem *LogLevelMenuItemList[8];
    TMenuItem *LangMenuItemList[3];
    WORD IPGridColWidth[8]; //      1000px
#if 0
    HDEVNOTIFY hDevNotify;
#endif
    int __fastcall GetPopupNode(TAddrListNode *pNode);
    bool __fastcall ValidCell(int X, int Y);

public:     // User declarations
    T_MessageQueue * MessageQueueDisplay;
    TLTRServiceCrate  *ltrservicecrate;

    __fastcall TFormMAIN(TComponent* Owner);
     virtual void __fastcall Dispatch(void *_msg);
};

/*
class TProxyGrid : public TStringGrid
{
    public:
        using TStringGrid::DeleteRow;
        using TStringGrid::DeleteColumn;
};
*/

//---------------------------------------------------------------------------
extern PACKAGE TFormMAIN *FormMAIN;
//---------------------------------------------------------------------------
#endif
