#include "common.h"
#include "LtrClient.h"
#include "unit1.h"
#include <shellapi.h>
//---------------------------------------------------------------------------
/*   */
HANDLE crate_list_access=NULL;
HANDLE client_list_access=NULL;
TCrate  *crate_list[CRATE_MAX];
TClient *client_list[CLIENT_MAX];
TUniqueAddrMultiList IPCrateList;
TLogfile g_Log;
TLtrIniFile g_INI;
struct t_GlobalConfig g_Config;

//---------------------------------------------------------------------------

/*------------------------------------------------------------------------------------------------*/
DWORD StrToIP(AnsiString ip_str)
    {
    int len, n;
    unsigned int q1, q2, q3, q4;

    len = ip_str.Length();
    if ((len < 7) || (len > 15))
        return 0;
    if ((sscanf(ip_str.c_str(), "%3u.%3u.%3u.%3u%n", &q1, &q2, &q3, &q4, &n) >= 4)
        && (n == len)
        && ((q1 | q2 | q3 | q4) <= 255) /*   <= 255 */
        && ((q1 | q2 | q3 | q4) > 0)    /*     0 */
        && ((q1 & q2 & q3 & q4) < 255)  /*     255 */
        )
        {
        return ((DWORD)q4 << 24) | ((DWORD)q3 << 16) | (q2 << 8) | q1;
        }
    else
        {
        return 0;
        }
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
AnsiString IPToStr(DWORD ip)
    {
    return Format("%u.%u.%u.%u",
        ARRAYOFCONST((ip & 0xFF, (ip >> 8) & 0xFF, (ip >> 16) & 0xFF, (ip >> 24) & 0xFF)));
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
TClient::TClient(SOCKET _socket, DWORD peer_ip, TCrate *_crate, WORD _crate_channel, WORD _client_flags)
    {
    socket=_socket;
    peer_addr_str = IPToStr(peer_ip);
    crate=_crate;
    crate_channel=_crate_channel;
    buf_ptr_FIFO_recv=0;
    count_FIFO_recv=0;
    control_thread=recv_buf_thread=send_buf_thread=NULL;
    IsAlive=true;
    flags=_client_flags;

    if(flags&CC_RAW_DATA_FLAG)
        {
        count_FIFO_recv=crate->module[MODULE_INDEX_RAW].count_FIFO_recv;
        buf_ptr_FIFO_recv = crate->module[MODULE_INDEX_RAW].recv_buf_ptr;
        crate->ReadRawData=true;
        }

    if (_crate_channel==CC_CONTROL)
        {
        control_thread=new TControlClientThread(this, false);
        }
    else
        {
        recv_buf_thread=new TReadClientThread(this, false);
        send_buf_thread=new TWriteClientThread(this, false);
        }
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
TClient::~TClient(void)
    {
    IsAlive = false;
    if (socket != SOCKET_ERROR)
        {
        shutdown(socket, SD_BOTH);
        closesocket(socket);
        socket = SOCKET_ERROR;
        }
    EndThread(control_thread);
    EndThread(recv_buf_thread);
    EndThread(send_buf_thread);
    }
/*------------------------------------------------------------------------------------------------*/

/*------------------------------------------------------------------------------------------------*/
bool TClient::CheckSocket(void)
    {
    fd_set fdset={1, {socket}};
    timeval tval={0, 0};
    int res=select(0, &fdset, NULL, NULL, &tval);
    return res==1 ? true : false;
    }
/*------------------------------------------------------------------------------------------------*/

